--
-- PostgreSQL database dump
--

-- Dumped from database version 15.6 (Debian 15.6-0+deb12u1)
-- Dumped by pg_dump version 15.6 (Debian 15.6-0+deb12u1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: gnumed_v22; Type: DATABASE; Schema: -; Owner: gm-dbo
--

CREATE DATABASE gnumed_v22 WITH TEMPLATE = template0 ENCODING = 'UTF8' LOCALE_PROVIDER = libc LOCALE = 'en_US.UTF-8';


ALTER DATABASE gnumed_v22 OWNER TO "gm-dbo";

\connect gnumed_v22

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: gnumed_v22; Type: DATABASE PROPERTIES; Schema: -; Owner: gm-dbo
--

ALTER DATABASE gnumed_v22 SET lc_messages TO 'C';
ALTER DATABASE gnumed_v22 SET default_transaction_read_only TO 'on';
ALTER DATABASE gnumed_v22 SET check_function_bodies TO 'on';
ALTER DATABASE gnumed_v22 SET ignore_checksum_failure TO 'off';


\connect gnumed_v22

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: au; Type: SCHEMA; Schema: -; Owner: gm-dbo
--

CREATE SCHEMA au;


ALTER SCHEMA au OWNER TO "gm-dbo";

--
-- Name: audit; Type: SCHEMA; Schema: -; Owner: gm-dbo
--

CREATE SCHEMA audit;


ALTER SCHEMA audit OWNER TO "gm-dbo";

--
-- Name: bill; Type: SCHEMA; Schema: -; Owner: gm-dbo
--

CREATE SCHEMA bill;


ALTER SCHEMA bill OWNER TO "gm-dbo";

--
-- Name: SCHEMA bill; Type: COMMENT; Schema: -; Owner: gm-dbo
--

COMMENT ON SCHEMA bill IS 'Holds everything related to billing.';


--
-- Name: blobs; Type: SCHEMA; Schema: -; Owner: gm-dbo
--

CREATE SCHEMA blobs;


ALTER SCHEMA blobs OWNER TO "gm-dbo";

--
-- Name: cfg; Type: SCHEMA; Schema: -; Owner: gm-dbo
--

CREATE SCHEMA cfg;


ALTER SCHEMA cfg OWNER TO "gm-dbo";

--
-- Name: SCHEMA cfg; Type: COMMENT; Schema: -; Owner: gm-dbo
--

COMMENT ON SCHEMA cfg IS 'This schema holds all the configuration data.';


--
-- Name: clin; Type: SCHEMA; Schema: -; Owner: gm-dbo
--

CREATE SCHEMA clin;


ALTER SCHEMA clin OWNER TO "gm-dbo";

--
-- Name: de_de; Type: SCHEMA; Schema: -; Owner: gm-dbo
--

CREATE SCHEMA de_de;


ALTER SCHEMA de_de OWNER TO "gm-dbo";

--
-- Name: dem; Type: SCHEMA; Schema: -; Owner: gm-dbo
--

CREATE SCHEMA dem;


ALTER SCHEMA dem OWNER TO "gm-dbo";

--
-- Name: gm; Type: SCHEMA; Schema: -; Owner: gm-dbo
--

CREATE SCHEMA gm;


ALTER SCHEMA gm OWNER TO "gm-dbo";

--
-- Name: i18n; Type: SCHEMA; Schema: -; Owner: gm-dbo
--

CREATE SCHEMA i18n;


ALTER SCHEMA i18n OWNER TO "gm-dbo";

--
-- Name: pgtrgm; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA pgtrgm;


ALTER SCHEMA pgtrgm OWNER TO postgres;

--
-- Name: ref; Type: SCHEMA; Schema: -; Owner: gm-dbo
--

CREATE SCHEMA ref;


ALTER SCHEMA ref OWNER TO "gm-dbo";

--
-- Name: SCHEMA ref; Type: COMMENT; Schema: -; Owner: gm-dbo
--

COMMENT ON SCHEMA ref IS 'This schema holds data that is "reference material" which comes
	 pre-installed with a GNUmed database. Examples are:
	 - document types
	 - ICD codes
	 - form templates';


--
-- Name: staging; Type: SCHEMA; Schema: -; Owner: gm-dbo
--

CREATE SCHEMA staging;


ALTER SCHEMA staging OWNER TO "gm-dbo";

--
-- Name: SCHEMA staging; Type: COMMENT; Schema: -; Owner: gm-dbo
--

COMMENT ON SCHEMA staging IS 'A schema used for staging data imports.';


--
-- Name: pg_trgm; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS pg_trgm WITH SCHEMA pgtrgm;


--
-- Name: EXTENSION pg_trgm; Type: COMMENT; Schema: -; Owner: 
--

COMMENT ON EXTENSION pg_trgm IS 'text similarity measurement and index searching based on trigrams';


--
-- Name: add_table_for_audit(name); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.add_table_for_audit(name) RETURNS boolean
    LANGUAGE sql SECURITY DEFINER
    AS $_$
select audit.add_table_for_audit('public', $1);$_$;


ALTER FUNCTION audit.add_table_for_audit(name) OWNER TO "gm-dbo";

--
-- Name: FUNCTION add_table_for_audit(name); Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON FUNCTION audit.add_table_for_audit(name) IS 'sanity-checking convenience function for marking tables
	 for auditing, schema is always "public"';


--
-- Name: add_table_for_audit(name, name); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.add_table_for_audit(name, name) RETURNS boolean
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
	_relnamespace alias for $1;
	_relname ALIAS FOR $2;
	dummy RECORD;
	tmp text;
BEGIN
	-- does table exist ?
	select relname into dummy from pg_class where
		relname = _relname and
		relnamespace = (select oid from pg_namespace where nspname = _relnamespace)
	;
	if not found then
		tmp := _relnamespace || '.' || _relname;
		raise exception 'audit.add_table_for_audit: Table [%] does not exist.', tmp;
		return false;
	end if;
	-- already queued for auditing ?
	select 1 into dummy from audit.audited_tables where table_name = _relname and schema = _relnamespace;
	if found then
		return true;
	end if;
	-- add definition
	insert into audit.audited_tables (
		schema, table_name
	) values (
		_relnamespace, _relname
	);
	return true;
END;$_$;


ALTER FUNCTION audit.add_table_for_audit(name, name) OWNER TO "gm-dbo";

--
-- Name: FUNCTION add_table_for_audit(name, name); Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON FUNCTION audit.add_table_for_audit(name, name) IS 'sanity-checking convenience function for marking tables for auditing';


--
-- Name: ft_del_access_log(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_access_log() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_access_log (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, user_action
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.user_action
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_access_log() OWNER TO "gm-dbo";

--
-- Name: ft_del_active_substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_active_substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	INSERT INTO audit.log_active_substance (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, description, atc_code
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.description, OLD.atc_code
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_active_substance() OWNER TO "gm-dbo";

--
-- Name: ft_del_address(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_address() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_address (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, id_street, aux_street, number, subunit, addendum, lat_lon
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.id_street, OLD.aux_street, OLD.number, OLD.subunit, OLD.addendum, OLD.lat_lon
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_address() OWNER TO "gm-dbo";

--
-- Name: ft_del_allergy(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_allergy() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_allergy (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, substance, substance_code, generics, allergene, atc_code, fk_type, generic_specific, definite
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.substance, OLD.substance_code, OLD.generics, OLD.allergene, OLD.atc_code, OLD.fk_type, OLD.generic_specific, OLD.definite
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_allergy() OWNER TO "gm-dbo";

--
-- Name: ft_del_allergy_state(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_allergy_state() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_allergy_state (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, has_allergy, comment, last_confirmed, fk_encounter
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.has_allergy, OLD.comment, OLD.last_confirmed, OLD.fk_encounter
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_allergy_state() OWNER TO "gm-dbo";

--
-- Name: ft_del_atc_group(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_atc_group() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	INSERT INTO audit.log_atc_group (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, code, description
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.code, OLD.description
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_atc_group() OWNER TO "gm-dbo";

--
-- Name: ft_del_atc_substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_atc_substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	INSERT INTO audit.log_atc_substance (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, code, name, ddd_amount, fk_ddd_unit, route, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.code, OLD.name, OLD.ddd_amount, OLD.fk_ddd_unit, OLD.route, OLD.comment
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_atc_substance() OWNER TO "gm-dbo";

--
-- Name: ft_del_auto_hint(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_auto_hint() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_auto_hint (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, query, title, hint, url, is_active, source, lang, recommendation_query, popup_type, highlight_as_priority
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.query, OLD.title, OLD.hint, OLD.url, OLD.is_active, OLD.source, OLD.lang, OLD.recommendation_query, OLD.popup_type, OLD.highlight_as_priority
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_auto_hint() OWNER TO "gm-dbo";

--
-- Name: ft_del_beh_fall_typ(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_beh_fall_typ() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_beh_fall_typ (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, code, kurzform, name
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.code, OLD.kurzform, OLD.name
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_beh_fall_typ() OWNER TO "gm-dbo";

--
-- Name: ft_del_behandlungsfall(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_behandlungsfall() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	INSERT INTO audit.log_behandlungsfall (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_patient, fk_falltyp, started, must_pay_prax_geb
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_patient, OLD.fk_falltyp, OLD.started, OLD.must_pay_prax_geb
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_behandlungsfall() OWNER TO "gm-dbo";

--
-- Name: ft_del_bill(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_bill() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_bill (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, invoice_id, close_date, apply_vat, fk_receiver_identity, fk_receiver_address, fk_doc, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.invoice_id, OLD.close_date, OLD.apply_vat, OLD.fk_receiver_identity, OLD.fk_receiver_address, OLD.fk_doc, OLD.comment
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_bill() OWNER TO "gm-dbo";

--
-- Name: ft_del_bill_item(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_bill_item() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_bill_item (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_provider, fk_encounter, date_to_bill, description, net_amount_per_unit, currency, status, fk_billable, fk_bill, unit_count, amount_multiplier
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_provider, OLD.fk_encounter, OLD.date_to_bill, OLD.description, OLD.net_amount_per_unit, OLD.currency, OLD.status, OLD.fk_billable, OLD.fk_bill, OLD.unit_count, OLD.amount_multiplier
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_bill_item() OWNER TO "gm-dbo";

--
-- Name: ft_del_clin_aux_note(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_clin_aux_note() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_clin_aux_note (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_clin_aux_note() OWNER TO "gm-dbo";

--
-- Name: ft_del_clin_diag(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_clin_diag() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_clin_diag (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_narrative, laterality, is_chronic, is_active, is_definite, clinically_relevant
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_narrative, OLD.laterality, OLD.is_chronic, OLD.is_active, OLD.is_definite, OLD.clinically_relevant
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_clin_diag() OWNER TO "gm-dbo";

--
-- Name: ft_del_clin_item_type(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_clin_item_type() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_clin_item_type (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, type, code
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.type, OLD.code
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_clin_item_type() OWNER TO "gm-dbo";

--
-- Name: ft_del_clin_medication(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_clin_medication() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	INSERT INTO audit.log_clin_medication (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, last_prescribed, fk_last_script, discontinued, brandname, generic, adjuvant, dosage_form, ufk_drug, drug_db, atc_code, is_cr, dosage, period, dosage_unit, directions, is_prn
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.last_prescribed, OLD.fk_last_script, OLD.discontinued, OLD.brandname, OLD.generic, OLD.adjuvant, OLD.dosage_form, OLD.ufk_drug, OLD.drug_db, OLD.atc_code, OLD.is_cr, OLD.dosage, OLD.period, OLD.dosage_unit, OLD.directions, OLD.is_prn
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_clin_medication() OWNER TO "gm-dbo";

--
-- Name: ft_del_clin_narrative(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_clin_narrative() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_clin_narrative (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_clin_narrative() OWNER TO "gm-dbo";

--
-- Name: ft_del_coded_phrase(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_coded_phrase() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	INSERT INTO audit.log_coded_phrase (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, term, code, xfk_coding_system
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.term, OLD.code, OLD.xfk_coding_system
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_coded_phrase() OWNER TO "gm-dbo";

--
-- Name: ft_del_consumable_substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_consumable_substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_consumable_substance (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, atc_code, amount, unit
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.atc_code, OLD.amount, OLD.unit
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_consumable_substance() OWNER TO "gm-dbo";

--
-- Name: ft_del_consumed_substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_consumed_substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	INSERT INTO audit.log_consumed_substance (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, description, atc_code
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.description, OLD.atc_code
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_consumed_substance() OWNER TO "gm-dbo";

--
-- Name: ft_del_data_source(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_data_source() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_data_source (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, name_long, name_short, version, description, source, lang
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.name_long, OLD.name_short, OLD.version, OLD.description, OLD.source, OLD.lang
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_data_source() OWNER TO "gm-dbo";

--
-- Name: ft_del_doc_desc(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_doc_desc() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_doc_desc (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_doc, text
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_doc, OLD.text
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_doc_desc() OWNER TO "gm-dbo";

--
-- Name: ft_del_doc_med(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_doc_med() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_doc_med (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_encounter, fk_episode, fk_type, comment, clin_when, ext_ref, fk_org_unit, unit_is_receiver, fk_hospital_stay
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_encounter, OLD.fk_episode, OLD.fk_type, OLD.comment, OLD.clin_when, OLD.ext_ref, OLD.fk_org_unit, OLD.unit_is_receiver, OLD.fk_hospital_stay
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_doc_med() OWNER TO "gm-dbo";

--
-- Name: ft_del_dose(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_dose() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_dose (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_substance, amount, unit, dose_unit
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_substance, OLD.amount, OLD.unit, OLD.dose_unit
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_dose() OWNER TO "gm-dbo";

--
-- Name: ft_del_drug_product(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_drug_product() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_drug_product (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, preparation, atc_code, is_fake, fk_data_source, external_code, external_code_type
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.preparation, OLD.atc_code, OLD.is_fake, OLD.fk_data_source, OLD.external_code, OLD.external_code_type
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_drug_product() OWNER TO "gm-dbo";

--
-- Name: ft_del_encounter(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_encounter() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_encounter (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_patient, fk_type, fk_location, source_time_zone, reason_for_encounter, assessment_of_encounter, started, last_affirmed
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_patient, OLD.fk_type, OLD.fk_location, OLD.source_time_zone, OLD.reason_for_encounter, OLD.assessment_of_encounter, OLD.started, OLD.last_affirmed
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_encounter() OWNER TO "gm-dbo";

--
-- Name: ft_del_episode(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_episode() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_episode (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_health_issue, description, is_open, fk_encounter, diagnostic_certainty_classification, summary
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_health_issue, OLD.description, OLD.is_open, OLD.fk_encounter, OLD.diagnostic_certainty_classification, OLD.summary
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_episode() OWNER TO "gm-dbo";

--
-- Name: ft_del_external_care(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_external_care() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_external_care (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_encounter, fk_health_issue, issue, fk_org_unit, provider, comment, inactive
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_encounter, OLD.fk_health_issue, OLD.issue, OLD.fk_org_unit, OLD.provider, OLD.comment, OLD.inactive
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_external_care() OWNER TO "gm-dbo";

--
-- Name: ft_del_family_history(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_family_history() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_family_history (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, fk_relation_type, age_noted, age_of_death, contributed_to_death, name_relative, dob_relative, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.fk_relation_type, OLD.age_noted, OLD.age_of_death, OLD.contributed_to_death, OLD.name_relative, OLD.dob_relative, OLD.comment
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_family_history() OWNER TO "gm-dbo";

--
-- Name: ft_del_fhx_relation_type(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_fhx_relation_type() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_fhx_relation_type (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, is_genetic
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.is_genetic
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_fhx_relation_type() OWNER TO "gm-dbo";

--
-- Name: ft_del_form_data(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_form_data() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_form_data (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_instance, fk_form_field, value
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_instance, OLD.fk_form_field, OLD.value
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_form_data() OWNER TO "gm-dbo";

--
-- Name: ft_del_form_defs(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_form_defs() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	INSERT INTO audit.log_form_defs (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, fk_type, country, locale, soap_cat, name_short, name_long, revision, template, engine, in_use, url, is_user
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.fk_type, OLD.country, OLD.locale, OLD.soap_cat, OLD.name_short, OLD.name_long, OLD.revision, OLD.template, OLD.engine, OLD.in_use, OLD.url, OLD.is_user
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_form_defs() OWNER TO "gm-dbo";

--
-- Name: ft_del_form_instances(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_form_instances() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_form_instances (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, fk_form_def, form_name
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.fk_form_def, OLD.form_name
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_form_instances() OWNER TO "gm-dbo";

--
-- Name: ft_del_gender_label(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_gender_label() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_gender_label (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, tag, label, sort_weight, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.tag, OLD.label, OLD.sort_weight, OLD.comment
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_gender_label() OWNER TO "gm-dbo";

--
-- Name: ft_del_health_issue(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_health_issue() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_health_issue (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, laterality, age_noted, is_active, clinically_relevant, is_confidential, is_cause_of_death, fk_encounter, grouping, diagnostic_certainty_classification, summary
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.laterality, OLD.age_noted, OLD.is_active, OLD.clinically_relevant, OLD.is_confidential, OLD.is_cause_of_death, OLD.fk_encounter, OLD.grouping, OLD.diagnostic_certainty_classification, OLD.summary
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_health_issue() OWNER TO "gm-dbo";

--
-- Name: ft_del_hospital_stay(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_hospital_stay() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_hospital_stay (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, discharge, fk_org_unit
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.discharge, OLD.fk_org_unit
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_hospital_stay() OWNER TO "gm-dbo";

--
-- Name: ft_del_hx_family_item(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_hx_family_item() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	INSERT INTO audit.log_hx_family_item (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, fk_narrative_condition, fk_relative, name_relative, dob_relative, condition, age_noted, age_of_death, is_cause_of_death
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.fk_narrative_condition, OLD.fk_relative, OLD.name_relative, OLD.dob_relative, OLD.condition, OLD.age_noted, OLD.age_of_death, OLD.is_cause_of_death
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_hx_family_item() OWNER TO "gm-dbo";

--
-- Name: ft_del_identity(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_identity() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_identity (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, deleted, gender, dob, fk_marital_status, cob, deceased, title, tob, emergency_contact, fk_emergency_contact, comment, fk_primary_provider, dob_is_estimated
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.deleted, OLD.gender, OLD.dob, OLD.fk_marital_status, OLD.cob, OLD.deceased, OLD.title, OLD.tob, OLD.emergency_contact, OLD.fk_emergency_contact, OLD.comment, OLD.fk_primary_provider, OLD.dob_is_estimated
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_identity() OWNER TO "gm-dbo";

--
-- Name: ft_del_identity_tag(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_identity_tag() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_identity_tag (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_identity, fk_tag, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_identity, OLD.fk_tag, OLD.comment
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_identity_tag() OWNER TO "gm-dbo";

--
-- Name: ft_del_inbox_item_category(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_inbox_item_category() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_inbox_item_category (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, is_user
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.is_user
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_inbox_item_category() OWNER TO "gm-dbo";

--
-- Name: ft_del_inbox_item_type(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_inbox_item_type() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_inbox_item_type (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_inbox_item_category, description, is_user
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_inbox_item_category, OLD.description, OLD.is_user
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_inbox_item_type() OWNER TO "gm-dbo";

--
-- Name: ft_del_incoming_data_unmatchable(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_incoming_data_unmatchable() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_incoming_data_unmatchable (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_patient_candidates, request_id, firstnames, lastnames, dob, postcode, other_info, type, data, gender, requestor, external_data_id, fk_identity_disambiguated
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_patient_candidates, OLD.request_id, OLD.firstnames, OLD.lastnames, OLD.dob, OLD.postcode, OLD.other_info, OLD.type, OLD.data, OLD.gender, OLD.requestor, OLD.external_data_id, OLD.fk_identity_disambiguated
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_incoming_data_unmatchable() OWNER TO "gm-dbo";

--
-- Name: ft_del_incoming_data_unmatched(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_incoming_data_unmatched() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_incoming_data_unmatched (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_patient_candidates, request_id, firstnames, lastnames, dob, postcode, other_info, type, data, gender, requestor, external_data_id, fk_identity_disambiguated, comment, fk_provider_disambiguated
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_patient_candidates, OLD.request_id, OLD.firstnames, OLD.lastnames, OLD.dob, OLD.postcode, OLD.other_info, OLD.type, OLD.data, OLD.gender, OLD.requestor, OLD.external_data_id, OLD.fk_identity_disambiguated, OLD.comment, OLD.fk_provider_disambiguated
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_incoming_data_unmatched() OWNER TO "gm-dbo";

--
-- Name: ft_del_lab_request(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lab_request() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lab_request (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, fk_test_org, request_id, fk_requestor, lab_request_id, lab_rxd_when, results_reported_when, request_status, is_pending, diagnostic_service_section, ordered_service, note_test_org
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.fk_test_org, OLD.request_id, OLD.fk_requestor, OLD.lab_request_id, OLD.lab_rxd_when, OLD.results_reported_when, OLD.request_status, OLD.is_pending, OLD.diagnostic_service_section, OLD.ordered_service, OLD.note_test_org
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lab_request() OWNER TO "gm-dbo";

--
-- Name: ft_del_lab_test_gnr(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lab_test_gnr() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lab_test_gnr (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, id_test
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.id_test
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lab_test_gnr() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_code2aoe(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_code2aoe() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_code2aoe (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_lnk_code2item, fk_generic_code, fk_item, code_modifier, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_lnk_code2item, OLD.fk_generic_code, OLD.fk_item, OLD.code_modifier, OLD.pk
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_code2aoe() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_code2episode(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_code2episode() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_code2episode (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_lnk_code2item, fk_generic_code, fk_item, code_modifier, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_lnk_code2item, OLD.fk_generic_code, OLD.fk_item, OLD.code_modifier, OLD.pk
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_code2episode() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_code2fhx(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_code2fhx() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_code2fhx (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_lnk_code2item, fk_generic_code, fk_item, code_modifier, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_lnk_code2item, OLD.fk_generic_code, OLD.fk_item, OLD.code_modifier, OLD.pk
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_code2fhx() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_code2h_issue(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_code2h_issue() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_code2h_issue (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_lnk_code2item, fk_generic_code, fk_item, code_modifier, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_lnk_code2item, OLD.fk_generic_code, OLD.fk_item, OLD.code_modifier, OLD.pk
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_code2h_issue() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_code2narrative(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_code2narrative() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_code2narrative (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_lnk_code2item, fk_generic_code, fk_item, code_modifier, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_lnk_code2item, OLD.fk_generic_code, OLD.fk_item, OLD.code_modifier, OLD.pk
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_code2narrative() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_code2procedure(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_code2procedure() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_code2procedure (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_lnk_code2item, fk_generic_code, fk_item, code_modifier, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_lnk_code2item, OLD.fk_generic_code, OLD.fk_item, OLD.code_modifier, OLD.pk
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_code2procedure() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_code2rfe(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_code2rfe() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_code2rfe (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_lnk_code2item, fk_generic_code, fk_item, code_modifier, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_lnk_code2item, OLD.fk_generic_code, OLD.fk_item, OLD.code_modifier, OLD.pk
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_code2rfe() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_code2tst_pnl(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_code2tst_pnl() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_code2tst_pnl (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_lnk_code2item, fk_generic_code, fk_item, code_modifier, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_lnk_code2item, OLD.fk_generic_code, OLD.fk_item, OLD.code_modifier, OLD.pk
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_code2tst_pnl() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_constraint2vacc_course(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_constraint2vacc_course() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_constraint2vacc_course (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_vaccination_course, fk_constraint
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_vaccination_course, OLD.fk_constraint
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_constraint2vacc_course() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_dose2drug(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_dose2drug() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_dose2drug (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_drug_product, fk_dose
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_drug_product, OLD.fk_dose
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_dose2drug() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_identity2ext_id(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_identity2ext_id() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_identity2ext_id (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, id_identity, external_id, fk_origin, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.id_identity, OLD.external_id, OLD.fk_origin, OLD.comment
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_identity2ext_id() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_identity2primary_doc(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_identity2primary_doc() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	INSERT INTO audit.log_lnk_identity2primary_doc (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_identity, fk_primary_doc
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_identity, OLD.fk_primary_doc
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_identity2primary_doc() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_job2person(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_job2person() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_job2person (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_identity, fk_occupation, activities
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_identity, OLD.fk_occupation, OLD.activities
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_job2person() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_loinc2substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_loinc2substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_loinc2substance (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_substance, loinc, max_age, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_substance, OLD.loinc, OLD.max_age, OLD.comment
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_loinc2substance() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_loinc2test_panel(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_loinc2test_panel() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_loinc2test_panel (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_test_panel, loinc
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_test_panel, OLD.loinc
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_loinc2test_panel() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_org_unit2comm(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_org_unit2comm() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_org_unit2comm (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_org_unit, url, fk_type, is_confidential, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_org_unit, OLD.url, OLD.fk_type, OLD.is_confidential, OLD.comment
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_org_unit2comm() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_org_unit2ext_id(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_org_unit2ext_id() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_org_unit2ext_id (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_org_unit, external_id, fk_type, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_org_unit, OLD.external_id, OLD.fk_type, OLD.comment
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_org_unit2ext_id() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_pat2vaccination_course(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_pat2vaccination_course() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_pat2vaccination_course (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_patient, fk_course
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_patient, OLD.fk_course
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_pat2vaccination_course() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_person2relative(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_person2relative() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_person2relative (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, id_identity, id_relative, id_relation_type, started, ended
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.id_identity, OLD.id_relative, OLD.id_relation_type, OLD.started, OLD.ended
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_person2relative() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_substance2brand(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_substance2brand() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_substance2brand (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_brand, fk_substance
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_brand, OLD.fk_substance
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_substance2brand() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_tst2norm(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_tst2norm() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_tst2norm (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, id_test, id_norm
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.id_test, OLD.id_norm
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_tst2norm() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_type2item(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_type2item() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_type2item (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_type, fk_item
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_type, OLD.fk_item
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_type2item() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_vaccination_course2schedule(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_vaccination_course2schedule() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_vaccination_course2schedule (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_course, fk_schedule
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_course, OLD.fk_schedule
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_vaccination_course2schedule() OWNER TO "gm-dbo";

--
-- Name: ft_del_lnk_vaccine2inds(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_lnk_vaccine2inds() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_lnk_vaccine2inds (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, fk_vaccine, fk_indication
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.fk_vaccine, OLD.fk_indication
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_lnk_vaccine2inds() OWNER TO "gm-dbo";

--
-- Name: ft_del_message_inbox(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_message_inbox() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_message_inbox (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_staff, fk_inbox_item_type, comment, data, importance, fk_patient, ufk_context, due_date, expiry_date
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_staff, OLD.fk_inbox_item_type, OLD.comment, OLD.data, OLD.importance, OLD.fk_patient, OLD.ufk_context, OLD.due_date, OLD.expiry_date
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_message_inbox() OWNER TO "gm-dbo";

--
-- Name: ft_del_occupation(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_occupation() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_occupation (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, name
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.name
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_occupation() OWNER TO "gm-dbo";

--
-- Name: ft_del_operation(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_operation() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	INSERT INTO audit.log_operation (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, fk_health_issue, fk_encounter, clin_where, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.fk_health_issue, OLD.fk_encounter, OLD.clin_where, OLD.comment
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_operation() OWNER TO "gm-dbo";

--
-- Name: ft_del_org(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_org() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_org (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, fk_category, fk_data_source
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.fk_category, OLD.fk_data_source
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_org() OWNER TO "gm-dbo";

--
-- Name: ft_del_org_unit(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_org_unit() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_org_unit (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, fk_org, fk_address, fk_category
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.fk_org, OLD.fk_address, OLD.fk_category
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_org_unit() OWNER TO "gm-dbo";

--
-- Name: ft_del_paperwork_templates(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_paperwork_templates() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_paperwork_templates (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_template_type, instance_type, name_short, name_long, external_version, gnumed_revision, engine, in_use, filename, data, edit_after_substitution
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_template_type, OLD.instance_type, OLD.name_short, OLD.name_long, OLD.external_version, OLD.gnumed_revision, OLD.engine, OLD.in_use, OLD.filename, OLD.data, OLD.edit_after_substitution
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_paperwork_templates() OWNER TO "gm-dbo";

--
-- Name: ft_del_patient(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_patient() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_patient (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_identity, edc
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_identity, OLD.edc
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_patient() OWNER TO "gm-dbo";

--
-- Name: ft_del_prax_geb_paid(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_prax_geb_paid() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_prax_geb_paid (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_fall, paid_amount, paid_when, paid_with
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_fall, OLD.paid_amount, OLD.paid_when, OLD.paid_with
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_prax_geb_paid() OWNER TO "gm-dbo";

--
-- Name: ft_del_praxis_branch(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_praxis_branch() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_praxis_branch (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_org_unit
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_org_unit
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_praxis_branch() OWNER TO "gm-dbo";

--
-- Name: ft_del_procedure(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_procedure() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_procedure (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, fk_hospital_stay, clin_end, is_ongoing, fk_org_unit, fk_doc, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.fk_hospital_stay, OLD.clin_end, OLD.is_ongoing, OLD.fk_org_unit, OLD.fk_doc, OLD.comment
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_procedure() OWNER TO "gm-dbo";

--
-- Name: ft_del_ref_source(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_ref_source() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	INSERT INTO audit.log_ref_source (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, name_short, name_long, version, description, source
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.name_short, OLD.name_long, OLD.version, OLD.description, OLD.source
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_ref_source() OWNER TO "gm-dbo";

--
-- Name: ft_del_referral(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_referral() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_referral (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, id, fk_referee, fk_form
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.id, OLD.fk_referee, OLD.fk_form
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_referral() OWNER TO "gm-dbo";

--
-- Name: ft_del_region(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_region() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_region (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, code, country, name
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.code, OLD.country, OLD.name
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_region() OWNER TO "gm-dbo";

--
-- Name: ft_del_relation_types(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_relation_types() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_relation_types (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, inverse, biological, biol_verified, description
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.inverse, OLD.biological, OLD.biol_verified, OLD.description
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_relation_types() OWNER TO "gm-dbo";

--
-- Name: ft_del_report_query(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_report_query() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_report_query (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, label, cmd
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.label, OLD.cmd
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_report_query() OWNER TO "gm-dbo";

--
-- Name: ft_del_staff(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_staff() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_staff (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_identity, db_user, short_alias, comment, is_active
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_identity, OLD.db_user, OLD.short_alias, OLD.comment, OLD.is_active
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_staff() OWNER TO "gm-dbo";

--
-- Name: ft_del_staff_role(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_staff_role() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	INSERT INTO audit.log_staff_role (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, name, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.name, OLD.comment
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_staff_role() OWNER TO "gm-dbo";

--
-- Name: ft_del_street(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_street() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_street (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, id_urb, name, postcode, suburb, lat_lon
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.id_urb, OLD.name, OLD.postcode, OLD.suburb, OLD.lat_lon
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_street() OWNER TO "gm-dbo";

--
-- Name: ft_del_substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_substance (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, atc, intake_instructions
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.atc, OLD.intake_instructions
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_substance() OWNER TO "gm-dbo";

--
-- Name: ft_del_substance_in_brand(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_substance_in_brand() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	INSERT INTO audit.log_substance_in_brand (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, fk_brand, description, atc_code
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.fk_brand, OLD.description, OLD.atc_code
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_substance_in_brand() OWNER TO "gm-dbo";

--
-- Name: ft_del_substance_intake(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_substance_intake() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_substance_intake (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, schedule, aim, duration, intake_is_approved_of, is_long_term, discontinued, discontinue_reason, fk_drug_component, comment_on_start, harmful_use_type
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.schedule, OLD.aim, OLD.duration, OLD.intake_is_approved_of, OLD.is_long_term, OLD.discontinued, OLD.discontinue_reason, OLD.fk_drug_component, OLD.comment_on_start, OLD.harmful_use_type
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_substance_intake() OWNER TO "gm-dbo";

--
-- Name: ft_del_suppressed_hint(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_suppressed_hint() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_suppressed_hint (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_encounter, fk_hint, suppressed_by, suppressed_when, rationale, md5_sum
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_encounter, OLD.fk_hint, OLD.suppressed_by, OLD.suppressed_when, OLD.rationale, OLD.md5_sum
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_suppressed_hint() OWNER TO "gm-dbo";

--
-- Name: ft_del_tag_image(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_tag_image() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_tag_image (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, filename, image
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.filename, OLD.image
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_tag_image() OWNER TO "gm-dbo";

--
-- Name: ft_del_test_org(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_test_org() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_test_org (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_org_unit, fk_adm_contact, fk_med_contact, comment, contact
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_org_unit, OLD.fk_adm_contact, OLD.fk_med_contact, OLD.comment, OLD.contact
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_test_org() OWNER TO "gm-dbo";

--
-- Name: ft_del_test_panel(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_test_panel() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_test_panel (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.comment
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_test_panel() OWNER TO "gm-dbo";

--
-- Name: ft_del_test_result(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_test_result() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_test_result (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, fk_type, val_num, val_alpha, val_unit, val_normal_min, val_normal_max, val_normal_range, val_target_min, val_target_max, val_target_range, abnormality_indicator, norm_ref_group, note_test_org, material, material_detail, fk_intended_reviewer, fk_request, status, source_data, val_grouping
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.fk_type, OLD.val_num, OLD.val_alpha, OLD.val_unit, OLD.val_normal_min, OLD.val_normal_max, OLD.val_normal_range, OLD.val_target_min, OLD.val_target_max, OLD.val_target_range, OLD.abnormality_indicator, OLD.norm_ref_group, OLD.note_test_org, OLD.material, OLD.material_detail, OLD.fk_intended_reviewer, OLD.fk_request, OLD.status, OLD.source_data, OLD.val_grouping
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_test_result() OWNER TO "gm-dbo";

--
-- Name: ft_del_test_type(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_test_type() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_test_type (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_test_org, name, comment, reference_unit, loinc, abbrev, fk_meta_test_type
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_test_org, OLD.name, OLD.comment, OLD.reference_unit, OLD.loinc, OLD.abbrev, OLD.fk_meta_test_type
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_test_type() OWNER TO "gm-dbo";

--
-- Name: ft_del_urb(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_urb() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_urb (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, fk_region, postcode, lat_lon, name
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.fk_region, OLD.postcode, OLD.lat_lon, OLD.name
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_urb() OWNER TO "gm-dbo";

--
-- Name: ft_del_vacc_indication(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_vacc_indication() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_vacc_indication (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, description, atcs_single_indication, atcs_combi_indication
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.description, OLD.atcs_single_indication, OLD.atcs_combi_indication
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_vacc_indication() OWNER TO "gm-dbo";

--
-- Name: ft_del_vacc_route(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_vacc_route() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_vacc_route (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, abbreviation, description
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.abbreviation, OLD.description
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_vacc_route() OWNER TO "gm-dbo";

--
-- Name: ft_del_vaccination(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_vaccination() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_vaccination (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, fk_provider, fk_vaccine, site, batch_no, reaction
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.fk_provider, OLD.fk_vaccine, OLD.site, OLD.batch_no, OLD.reaction
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_vaccination() OWNER TO "gm-dbo";

--
-- Name: ft_del_vaccination_course(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_vaccination_course() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_vaccination_course (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_recommended_by, fk_indication, is_active, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_recommended_by, OLD.fk_indication, OLD.is_active, OLD.comment
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_vaccination_course() OWNER TO "gm-dbo";

--
-- Name: ft_del_vaccination_course_constraint(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_vaccination_course_constraint() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_vaccination_course_constraint (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_vaccination_course_constraint() OWNER TO "gm-dbo";

--
-- Name: ft_del_vaccination_definition(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_vaccination_definition() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_vaccination_definition (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, fk_course, is_booster, seq_no, min_age_due, max_age_due, min_interval, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.fk_course, OLD.is_booster, OLD.seq_no, OLD.min_age_due, OLD.max_age_due, OLD.min_interval, OLD.comment
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_vaccination_definition() OWNER TO "gm-dbo";

--
-- Name: ft_del_vaccination_schedule(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_vaccination_schedule() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_vaccination_schedule (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, name, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.name, OLD.comment
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_vaccination_schedule() OWNER TO "gm-dbo";

--
-- Name: ft_del_vaccine(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_vaccine() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_vaccine (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, id_route, is_live, min_age, max_age, comment, fk_drug_product
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.id_route, OLD.is_live, OLD.min_age, OLD.max_age, OLD.comment, OLD.fk_drug_product
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_vaccine() OWNER TO "gm-dbo";

--
-- Name: ft_del_vaccine_batches(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_vaccine_batches() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_vaccine_batches (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_vaccine, batch_no
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_vaccine, OLD.batch_no
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_vaccine_batches() OWNER TO "gm-dbo";

--
-- Name: ft_del_waiting_list(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_waiting_list() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_deleter boolean;
BEGIN
	-- is the session user allowed to delete data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_deleter;
	IF _is_allowed_deleter IS FALSE THEN
		RAISE EXCEPTION
			'DELETE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return OLD;
	END IF;
	INSERT INTO audit.log_waiting_list (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_patient, registered, urgency, list_position, comment, area
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_patient, OLD.registered, OLD.urgency, OLD.list_position, OLD.comment, OLD.area
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_waiting_list() OWNER TO "gm-dbo";

--
-- Name: ft_del_xlnk_identity(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_del_xlnk_identity() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	INSERT INTO audit.log_xlnk_identity (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, xfk_identity, pupic, data
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.xfk_identity, OLD.pupic, OLD.data
	);
	return OLD;
END;$$;


ALTER FUNCTION audit.ft_del_xlnk_identity() OWNER TO "gm-dbo";

--
-- Name: ft_ins_access_log(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_access_log() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_access_log() OWNER TO "gm-dbo";

--
-- Name: ft_ins_active_substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_active_substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_active_substance() OWNER TO "gm-dbo";

--
-- Name: ft_ins_address(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_address() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_address() OWNER TO "gm-dbo";

--
-- Name: ft_ins_allergy(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_allergy() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_allergy() OWNER TO "gm-dbo";

--
-- Name: ft_ins_allergy_state(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_allergy_state() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_allergy_state() OWNER TO "gm-dbo";

--
-- Name: ft_ins_atc_group(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_atc_group() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_atc_group() OWNER TO "gm-dbo";

--
-- Name: ft_ins_atc_substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_atc_substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_atc_substance() OWNER TO "gm-dbo";

--
-- Name: ft_ins_auto_hint(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_auto_hint() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_auto_hint() OWNER TO "gm-dbo";

--
-- Name: ft_ins_beh_fall_typ(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_beh_fall_typ() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_beh_fall_typ() OWNER TO "gm-dbo";

--
-- Name: ft_ins_behandlungsfall(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_behandlungsfall() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_behandlungsfall() OWNER TO "gm-dbo";

--
-- Name: ft_ins_bill(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_bill() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_bill() OWNER TO "gm-dbo";

--
-- Name: ft_ins_bill_item(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_bill_item() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_bill_item() OWNER TO "gm-dbo";

--
-- Name: ft_ins_clin_aux_note(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_clin_aux_note() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_clin_aux_note() OWNER TO "gm-dbo";

--
-- Name: ft_ins_clin_diag(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_clin_diag() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_clin_diag() OWNER TO "gm-dbo";

--
-- Name: ft_ins_clin_item_type(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_clin_item_type() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_clin_item_type() OWNER TO "gm-dbo";

--
-- Name: ft_ins_clin_medication(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_clin_medication() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_clin_medication() OWNER TO "gm-dbo";

--
-- Name: ft_ins_clin_narrative(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_clin_narrative() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_clin_narrative() OWNER TO "gm-dbo";

--
-- Name: ft_ins_coded_phrase(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_coded_phrase() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_coded_phrase() OWNER TO "gm-dbo";

--
-- Name: ft_ins_consumable_substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_consumable_substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_consumable_substance() OWNER TO "gm-dbo";

--
-- Name: ft_ins_consumed_substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_consumed_substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_consumed_substance() OWNER TO "gm-dbo";

--
-- Name: ft_ins_data_source(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_data_source() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_data_source() OWNER TO "gm-dbo";

--
-- Name: ft_ins_doc_desc(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_doc_desc() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_doc_desc() OWNER TO "gm-dbo";

--
-- Name: ft_ins_doc_med(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_doc_med() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_doc_med() OWNER TO "gm-dbo";

--
-- Name: ft_ins_dose(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_dose() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_dose() OWNER TO "gm-dbo";

--
-- Name: ft_ins_drug_product(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_drug_product() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_drug_product() OWNER TO "gm-dbo";

--
-- Name: ft_ins_encounter(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_encounter() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_encounter() OWNER TO "gm-dbo";

--
-- Name: ft_ins_episode(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_episode() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_episode() OWNER TO "gm-dbo";

--
-- Name: ft_ins_external_care(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_external_care() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_external_care() OWNER TO "gm-dbo";

--
-- Name: ft_ins_family_history(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_family_history() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_family_history() OWNER TO "gm-dbo";

--
-- Name: ft_ins_fhx_relation_type(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_fhx_relation_type() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_fhx_relation_type() OWNER TO "gm-dbo";

--
-- Name: ft_ins_form_data(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_form_data() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_form_data() OWNER TO "gm-dbo";

--
-- Name: ft_ins_form_defs(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_form_defs() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_form_defs() OWNER TO "gm-dbo";

--
-- Name: ft_ins_form_instances(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_form_instances() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_form_instances() OWNER TO "gm-dbo";

--
-- Name: ft_ins_gender_label(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_gender_label() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_gender_label() OWNER TO "gm-dbo";

--
-- Name: ft_ins_health_issue(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_health_issue() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_health_issue() OWNER TO "gm-dbo";

--
-- Name: ft_ins_hospital_stay(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_hospital_stay() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_hospital_stay() OWNER TO "gm-dbo";

--
-- Name: ft_ins_hx_family_item(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_hx_family_item() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_hx_family_item() OWNER TO "gm-dbo";

--
-- Name: ft_ins_identity(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_identity() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_identity() OWNER TO "gm-dbo";

--
-- Name: ft_ins_identity_tag(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_identity_tag() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_identity_tag() OWNER TO "gm-dbo";

--
-- Name: ft_ins_inbox_item_category(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_inbox_item_category() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_inbox_item_category() OWNER TO "gm-dbo";

--
-- Name: ft_ins_inbox_item_type(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_inbox_item_type() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_inbox_item_type() OWNER TO "gm-dbo";

--
-- Name: ft_ins_incoming_data_unmatchable(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_incoming_data_unmatchable() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_incoming_data_unmatchable() OWNER TO "gm-dbo";

--
-- Name: ft_ins_incoming_data_unmatched(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_incoming_data_unmatched() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_incoming_data_unmatched() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lab_request(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lab_request() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lab_request() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lab_test_gnr(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lab_test_gnr() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lab_test_gnr() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_code2aoe(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_code2aoe() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_code2aoe() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_code2episode(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_code2episode() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_code2episode() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_code2fhx(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_code2fhx() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_code2fhx() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_code2h_issue(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_code2h_issue() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_code2h_issue() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_code2narrative(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_code2narrative() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_code2narrative() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_code2procedure(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_code2procedure() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_code2procedure() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_code2rfe(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_code2rfe() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_code2rfe() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_code2tst_pnl(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_code2tst_pnl() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_code2tst_pnl() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_constraint2vacc_course(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_constraint2vacc_course() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_constraint2vacc_course() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_dose2drug(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_dose2drug() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_dose2drug() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_identity2ext_id(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_identity2ext_id() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_identity2ext_id() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_identity2primary_doc(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_identity2primary_doc() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_identity2primary_doc() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_job2person(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_job2person() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_job2person() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_loinc2substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_loinc2substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_loinc2substance() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_loinc2test_panel(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_loinc2test_panel() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_loinc2test_panel() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_org_unit2comm(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_org_unit2comm() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_org_unit2comm() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_org_unit2ext_id(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_org_unit2ext_id() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_org_unit2ext_id() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_pat2vaccination_course(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_pat2vaccination_course() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_pat2vaccination_course() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_person2relative(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_person2relative() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_person2relative() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_substance2brand(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_substance2brand() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_substance2brand() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_tst2norm(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_tst2norm() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_tst2norm() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_type2item(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_type2item() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_type2item() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_vaccination_course2schedule(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_vaccination_course2schedule() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_vaccination_course2schedule() OWNER TO "gm-dbo";

--
-- Name: ft_ins_lnk_vaccine2inds(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_lnk_vaccine2inds() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_lnk_vaccine2inds() OWNER TO "gm-dbo";

--
-- Name: ft_ins_message_inbox(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_message_inbox() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_message_inbox() OWNER TO "gm-dbo";

--
-- Name: ft_ins_occupation(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_occupation() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_occupation() OWNER TO "gm-dbo";

--
-- Name: ft_ins_operation(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_operation() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_operation() OWNER TO "gm-dbo";

--
-- Name: ft_ins_org(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_org() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_org() OWNER TO "gm-dbo";

--
-- Name: ft_ins_org_unit(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_org_unit() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_org_unit() OWNER TO "gm-dbo";

--
-- Name: ft_ins_paperwork_templates(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_paperwork_templates() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_paperwork_templates() OWNER TO "gm-dbo";

--
-- Name: ft_ins_patient(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_patient() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_patient() OWNER TO "gm-dbo";

--
-- Name: ft_ins_prax_geb_paid(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_prax_geb_paid() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_prax_geb_paid() OWNER TO "gm-dbo";

--
-- Name: ft_ins_praxis_branch(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_praxis_branch() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_praxis_branch() OWNER TO "gm-dbo";

--
-- Name: ft_ins_procedure(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_procedure() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_procedure() OWNER TO "gm-dbo";

--
-- Name: ft_ins_ref_source(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_ref_source() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_ref_source() OWNER TO "gm-dbo";

--
-- Name: ft_ins_referral(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_referral() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_referral() OWNER TO "gm-dbo";

--
-- Name: ft_ins_region(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_region() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_region() OWNER TO "gm-dbo";

--
-- Name: ft_ins_relation_types(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_relation_types() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_relation_types() OWNER TO "gm-dbo";

--
-- Name: ft_ins_report_query(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_report_query() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_report_query() OWNER TO "gm-dbo";

--
-- Name: ft_ins_staff(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_staff() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_staff() OWNER TO "gm-dbo";

--
-- Name: ft_ins_staff_role(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_staff_role() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_staff_role() OWNER TO "gm-dbo";

--
-- Name: ft_ins_street(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_street() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_street() OWNER TO "gm-dbo";

--
-- Name: ft_ins_substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_substance() OWNER TO "gm-dbo";

--
-- Name: ft_ins_substance_in_brand(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_substance_in_brand() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_substance_in_brand() OWNER TO "gm-dbo";

--
-- Name: ft_ins_substance_intake(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_substance_intake() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_substance_intake() OWNER TO "gm-dbo";

--
-- Name: ft_ins_suppressed_hint(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_suppressed_hint() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_suppressed_hint() OWNER TO "gm-dbo";

--
-- Name: ft_ins_tag_image(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_tag_image() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_tag_image() OWNER TO "gm-dbo";

--
-- Name: ft_ins_test_org(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_test_org() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_test_org() OWNER TO "gm-dbo";

--
-- Name: ft_ins_test_panel(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_test_panel() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_test_panel() OWNER TO "gm-dbo";

--
-- Name: ft_ins_test_result(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_test_result() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_test_result() OWNER TO "gm-dbo";

--
-- Name: ft_ins_test_type(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_test_type() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_test_type() OWNER TO "gm-dbo";

--
-- Name: ft_ins_urb(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_urb() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_urb() OWNER TO "gm-dbo";

--
-- Name: ft_ins_vacc_indication(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_vacc_indication() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_vacc_indication() OWNER TO "gm-dbo";

--
-- Name: ft_ins_vacc_route(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_vacc_route() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_vacc_route() OWNER TO "gm-dbo";

--
-- Name: ft_ins_vaccination(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_vaccination() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_vaccination() OWNER TO "gm-dbo";

--
-- Name: ft_ins_vaccination_course(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_vaccination_course() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_vaccination_course() OWNER TO "gm-dbo";

--
-- Name: ft_ins_vaccination_course_constraint(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_vaccination_course_constraint() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_vaccination_course_constraint() OWNER TO "gm-dbo";

--
-- Name: ft_ins_vaccination_definition(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_vaccination_definition() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_vaccination_definition() OWNER TO "gm-dbo";

--
-- Name: ft_ins_vaccination_schedule(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_vaccination_schedule() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_vaccination_schedule() OWNER TO "gm-dbo";

--
-- Name: ft_ins_vaccine(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_vaccine() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_vaccine() OWNER TO "gm-dbo";

--
-- Name: ft_ins_vaccine_batches(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_vaccine_batches() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_vaccine_batches() OWNER TO "gm-dbo";

--
-- Name: ft_ins_waiting_list(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_waiting_list() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_inserter boolean;
BEGIN
	-- is the session user allowed to insert data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_inserter;
	IF _is_allowed_inserter IS FALSE THEN
		RAISE EXCEPTION
			'INSERT: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_waiting_list() OWNER TO "gm-dbo";

--
-- Name: ft_ins_xlnk_identity(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_ins_xlnk_identity() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := 0;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_ins_xlnk_identity() OWNER TO "gm-dbo";

--
-- Name: ft_upd_access_log(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_access_log() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_access_log (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, user_action
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.user_action
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_access_log() OWNER TO "gm-dbo";

--
-- Name: ft_upd_active_substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_active_substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_active_substance (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, description, atc_code
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.description, OLD.atc_code
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_active_substance() OWNER TO "gm-dbo";

--
-- Name: ft_upd_address(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_address() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_address (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, id_street, aux_street, number, subunit, addendum, lat_lon
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.id_street, OLD.aux_street, OLD.number, OLD.subunit, OLD.addendum, OLD.lat_lon
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_address() OWNER TO "gm-dbo";

--
-- Name: ft_upd_allergy(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_allergy() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_allergy (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, substance, substance_code, generics, allergene, atc_code, fk_type, generic_specific, definite
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.substance, OLD.substance_code, OLD.generics, OLD.allergene, OLD.atc_code, OLD.fk_type, OLD.generic_specific, OLD.definite
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_allergy() OWNER TO "gm-dbo";

--
-- Name: ft_upd_allergy_state(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_allergy_state() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_allergy_state (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, has_allergy, comment, last_confirmed, fk_encounter
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.has_allergy, OLD.comment, OLD.last_confirmed, OLD.fk_encounter
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_allergy_state() OWNER TO "gm-dbo";

--
-- Name: ft_upd_atc_group(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_atc_group() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_atc_group (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, code, description
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.code, OLD.description
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_atc_group() OWNER TO "gm-dbo";

--
-- Name: ft_upd_atc_substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_atc_substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_atc_substance (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, code, name, ddd_amount, fk_ddd_unit, route, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.code, OLD.name, OLD.ddd_amount, OLD.fk_ddd_unit, OLD.route, OLD.comment
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_atc_substance() OWNER TO "gm-dbo";

--
-- Name: ft_upd_auto_hint(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_auto_hint() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_auto_hint (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, query, title, hint, url, is_active, source, lang, recommendation_query, popup_type, highlight_as_priority
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.query, OLD.title, OLD.hint, OLD.url, OLD.is_active, OLD.source, OLD.lang, OLD.recommendation_query, OLD.popup_type, OLD.highlight_as_priority
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_auto_hint() OWNER TO "gm-dbo";

--
-- Name: ft_upd_beh_fall_typ(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_beh_fall_typ() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_beh_fall_typ (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, code, kurzform, name
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.code, OLD.kurzform, OLD.name
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_beh_fall_typ() OWNER TO "gm-dbo";

--
-- Name: ft_upd_behandlungsfall(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_behandlungsfall() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_behandlungsfall (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_patient, fk_falltyp, started, must_pay_prax_geb
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_patient, OLD.fk_falltyp, OLD.started, OLD.must_pay_prax_geb
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_behandlungsfall() OWNER TO "gm-dbo";

--
-- Name: ft_upd_bill(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_bill() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_bill (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, invoice_id, close_date, apply_vat, fk_receiver_identity, fk_receiver_address, fk_doc, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.invoice_id, OLD.close_date, OLD.apply_vat, OLD.fk_receiver_identity, OLD.fk_receiver_address, OLD.fk_doc, OLD.comment
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_bill() OWNER TO "gm-dbo";

--
-- Name: ft_upd_bill_item(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_bill_item() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_bill_item (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_provider, fk_encounter, date_to_bill, description, net_amount_per_unit, currency, status, fk_billable, fk_bill, unit_count, amount_multiplier
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_provider, OLD.fk_encounter, OLD.date_to_bill, OLD.description, OLD.net_amount_per_unit, OLD.currency, OLD.status, OLD.fk_billable, OLD.fk_bill, OLD.unit_count, OLD.amount_multiplier
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_bill_item() OWNER TO "gm-dbo";

--
-- Name: ft_upd_clin_aux_note(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_clin_aux_note() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_clin_aux_note (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_clin_aux_note() OWNER TO "gm-dbo";

--
-- Name: ft_upd_clin_diag(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_clin_diag() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_clin_diag (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_narrative, laterality, is_chronic, is_active, is_definite, clinically_relevant
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_narrative, OLD.laterality, OLD.is_chronic, OLD.is_active, OLD.is_definite, OLD.clinically_relevant
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_clin_diag() OWNER TO "gm-dbo";

--
-- Name: ft_upd_clin_item_type(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_clin_item_type() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_clin_item_type (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, type, code
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.type, OLD.code
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_clin_item_type() OWNER TO "gm-dbo";

--
-- Name: ft_upd_clin_medication(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_clin_medication() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_clin_medication (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, last_prescribed, fk_last_script, discontinued, brandname, generic, adjuvant, dosage_form, ufk_drug, drug_db, atc_code, is_cr, dosage, period, dosage_unit, directions, is_prn
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.last_prescribed, OLD.fk_last_script, OLD.discontinued, OLD.brandname, OLD.generic, OLD.adjuvant, OLD.dosage_form, OLD.ufk_drug, OLD.drug_db, OLD.atc_code, OLD.is_cr, OLD.dosage, OLD.period, OLD.dosage_unit, OLD.directions, OLD.is_prn
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_clin_medication() OWNER TO "gm-dbo";

--
-- Name: ft_upd_clin_narrative(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_clin_narrative() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_clin_narrative (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_clin_narrative() OWNER TO "gm-dbo";

--
-- Name: ft_upd_coded_phrase(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_coded_phrase() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_coded_phrase (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, term, code, xfk_coding_system
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.term, OLD.code, OLD.xfk_coding_system
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_coded_phrase() OWNER TO "gm-dbo";

--
-- Name: ft_upd_consumable_substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_consumable_substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_consumable_substance (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, atc_code, amount, unit
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.atc_code, OLD.amount, OLD.unit
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_consumable_substance() OWNER TO "gm-dbo";

--
-- Name: ft_upd_consumed_substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_consumed_substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_consumed_substance (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, description, atc_code
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.description, OLD.atc_code
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_consumed_substance() OWNER TO "gm-dbo";

--
-- Name: ft_upd_data_source(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_data_source() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_data_source (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, name_long, name_short, version, description, source, lang
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.name_long, OLD.name_short, OLD.version, OLD.description, OLD.source, OLD.lang
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_data_source() OWNER TO "gm-dbo";

--
-- Name: ft_upd_doc_desc(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_doc_desc() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_doc_desc (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_doc, text
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_doc, OLD.text
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_doc_desc() OWNER TO "gm-dbo";

--
-- Name: ft_upd_doc_med(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_doc_med() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_doc_med (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_encounter, fk_episode, fk_type, comment, clin_when, ext_ref, fk_org_unit, unit_is_receiver, fk_hospital_stay
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_encounter, OLD.fk_episode, OLD.fk_type, OLD.comment, OLD.clin_when, OLD.ext_ref, OLD.fk_org_unit, OLD.unit_is_receiver, OLD.fk_hospital_stay
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_doc_med() OWNER TO "gm-dbo";

--
-- Name: ft_upd_dose(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_dose() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_dose (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_substance, amount, unit, dose_unit
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_substance, OLD.amount, OLD.unit, OLD.dose_unit
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_dose() OWNER TO "gm-dbo";

--
-- Name: ft_upd_drug_product(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_drug_product() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_drug_product (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, preparation, atc_code, is_fake, fk_data_source, external_code, external_code_type
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.preparation, OLD.atc_code, OLD.is_fake, OLD.fk_data_source, OLD.external_code, OLD.external_code_type
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_drug_product() OWNER TO "gm-dbo";

--
-- Name: ft_upd_encounter(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_encounter() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_encounter (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_patient, fk_type, fk_location, source_time_zone, reason_for_encounter, assessment_of_encounter, started, last_affirmed
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_patient, OLD.fk_type, OLD.fk_location, OLD.source_time_zone, OLD.reason_for_encounter, OLD.assessment_of_encounter, OLD.started, OLD.last_affirmed
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_encounter() OWNER TO "gm-dbo";

--
-- Name: ft_upd_episode(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_episode() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_episode (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_health_issue, description, is_open, fk_encounter, diagnostic_certainty_classification, summary
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_health_issue, OLD.description, OLD.is_open, OLD.fk_encounter, OLD.diagnostic_certainty_classification, OLD.summary
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_episode() OWNER TO "gm-dbo";

--
-- Name: ft_upd_external_care(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_external_care() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_external_care (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_encounter, fk_health_issue, issue, fk_org_unit, provider, comment, inactive
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_encounter, OLD.fk_health_issue, OLD.issue, OLD.fk_org_unit, OLD.provider, OLD.comment, OLD.inactive
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_external_care() OWNER TO "gm-dbo";

--
-- Name: ft_upd_family_history(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_family_history() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_family_history (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, fk_relation_type, age_noted, age_of_death, contributed_to_death, name_relative, dob_relative, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.fk_relation_type, OLD.age_noted, OLD.age_of_death, OLD.contributed_to_death, OLD.name_relative, OLD.dob_relative, OLD.comment
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_family_history() OWNER TO "gm-dbo";

--
-- Name: ft_upd_fhx_relation_type(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_fhx_relation_type() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_fhx_relation_type (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, is_genetic
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.is_genetic
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_fhx_relation_type() OWNER TO "gm-dbo";

--
-- Name: ft_upd_form_data(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_form_data() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_form_data (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_instance, fk_form_field, value
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_instance, OLD.fk_form_field, OLD.value
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_form_data() OWNER TO "gm-dbo";

--
-- Name: ft_upd_form_defs(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_form_defs() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_form_defs (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, fk_type, country, locale, soap_cat, name_short, name_long, revision, template, engine, in_use, url, is_user
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.fk_type, OLD.country, OLD.locale, OLD.soap_cat, OLD.name_short, OLD.name_long, OLD.revision, OLD.template, OLD.engine, OLD.in_use, OLD.url, OLD.is_user
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_form_defs() OWNER TO "gm-dbo";

--
-- Name: ft_upd_form_instances(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_form_instances() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_form_instances (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, fk_form_def, form_name
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.fk_form_def, OLD.form_name
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_form_instances() OWNER TO "gm-dbo";

--
-- Name: ft_upd_gender_label(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_gender_label() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_gender_label (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, tag, label, sort_weight, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.tag, OLD.label, OLD.sort_weight, OLD.comment
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_gender_label() OWNER TO "gm-dbo";

--
-- Name: ft_upd_health_issue(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_health_issue() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_health_issue (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, laterality, age_noted, is_active, clinically_relevant, is_confidential, is_cause_of_death, fk_encounter, grouping, diagnostic_certainty_classification, summary
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.laterality, OLD.age_noted, OLD.is_active, OLD.clinically_relevant, OLD.is_confidential, OLD.is_cause_of_death, OLD.fk_encounter, OLD.grouping, OLD.diagnostic_certainty_classification, OLD.summary
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_health_issue() OWNER TO "gm-dbo";

--
-- Name: ft_upd_hospital_stay(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_hospital_stay() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_hospital_stay (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, discharge, fk_org_unit
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.discharge, OLD.fk_org_unit
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_hospital_stay() OWNER TO "gm-dbo";

--
-- Name: ft_upd_hx_family_item(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_hx_family_item() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_hx_family_item (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, fk_narrative_condition, fk_relative, name_relative, dob_relative, condition, age_noted, age_of_death, is_cause_of_death
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.fk_narrative_condition, OLD.fk_relative, OLD.name_relative, OLD.dob_relative, OLD.condition, OLD.age_noted, OLD.age_of_death, OLD.is_cause_of_death
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_hx_family_item() OWNER TO "gm-dbo";

--
-- Name: ft_upd_identity(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_identity() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_identity (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, deleted, gender, dob, fk_marital_status, cob, deceased, title, tob, emergency_contact, fk_emergency_contact, comment, fk_primary_provider, dob_is_estimated
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.deleted, OLD.gender, OLD.dob, OLD.fk_marital_status, OLD.cob, OLD.deceased, OLD.title, OLD.tob, OLD.emergency_contact, OLD.fk_emergency_contact, OLD.comment, OLD.fk_primary_provider, OLD.dob_is_estimated
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_identity() OWNER TO "gm-dbo";

--
-- Name: ft_upd_identity_tag(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_identity_tag() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_identity_tag (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_identity, fk_tag, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_identity, OLD.fk_tag, OLD.comment
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_identity_tag() OWNER TO "gm-dbo";

--
-- Name: ft_upd_inbox_item_category(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_inbox_item_category() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_inbox_item_category (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, is_user
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.is_user
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_inbox_item_category() OWNER TO "gm-dbo";

--
-- Name: ft_upd_inbox_item_type(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_inbox_item_type() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_inbox_item_type (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_inbox_item_category, description, is_user
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_inbox_item_category, OLD.description, OLD.is_user
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_inbox_item_type() OWNER TO "gm-dbo";

--
-- Name: ft_upd_incoming_data_unmatchable(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_incoming_data_unmatchable() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_incoming_data_unmatchable (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_patient_candidates, request_id, firstnames, lastnames, dob, postcode, other_info, type, data, gender, requestor, external_data_id, fk_identity_disambiguated
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_patient_candidates, OLD.request_id, OLD.firstnames, OLD.lastnames, OLD.dob, OLD.postcode, OLD.other_info, OLD.type, OLD.data, OLD.gender, OLD.requestor, OLD.external_data_id, OLD.fk_identity_disambiguated
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_incoming_data_unmatchable() OWNER TO "gm-dbo";

--
-- Name: ft_upd_incoming_data_unmatched(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_incoming_data_unmatched() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_incoming_data_unmatched (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_patient_candidates, request_id, firstnames, lastnames, dob, postcode, other_info, type, data, gender, requestor, external_data_id, fk_identity_disambiguated, comment, fk_provider_disambiguated
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_patient_candidates, OLD.request_id, OLD.firstnames, OLD.lastnames, OLD.dob, OLD.postcode, OLD.other_info, OLD.type, OLD.data, OLD.gender, OLD.requestor, OLD.external_data_id, OLD.fk_identity_disambiguated, OLD.comment, OLD.fk_provider_disambiguated
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_incoming_data_unmatched() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lab_request(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lab_request() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lab_request (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, fk_test_org, request_id, fk_requestor, lab_request_id, lab_rxd_when, results_reported_when, request_status, is_pending, diagnostic_service_section, ordered_service, note_test_org
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.fk_test_org, OLD.request_id, OLD.fk_requestor, OLD.lab_request_id, OLD.lab_rxd_when, OLD.results_reported_when, OLD.request_status, OLD.is_pending, OLD.diagnostic_service_section, OLD.ordered_service, OLD.note_test_org
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lab_request() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lab_test_gnr(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lab_test_gnr() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lab_test_gnr (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, id_test
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.id_test
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lab_test_gnr() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_code2aoe(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_code2aoe() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_code2aoe (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_lnk_code2item, fk_generic_code, fk_item, code_modifier, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_lnk_code2item, OLD.fk_generic_code, OLD.fk_item, OLD.code_modifier, OLD.pk
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_code2aoe() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_code2episode(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_code2episode() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_code2episode (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_lnk_code2item, fk_generic_code, fk_item, code_modifier, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_lnk_code2item, OLD.fk_generic_code, OLD.fk_item, OLD.code_modifier, OLD.pk
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_code2episode() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_code2fhx(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_code2fhx() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_code2fhx (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_lnk_code2item, fk_generic_code, fk_item, code_modifier, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_lnk_code2item, OLD.fk_generic_code, OLD.fk_item, OLD.code_modifier, OLD.pk
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_code2fhx() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_code2h_issue(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_code2h_issue() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_code2h_issue (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_lnk_code2item, fk_generic_code, fk_item, code_modifier, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_lnk_code2item, OLD.fk_generic_code, OLD.fk_item, OLD.code_modifier, OLD.pk
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_code2h_issue() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_code2narrative(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_code2narrative() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_code2narrative (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_lnk_code2item, fk_generic_code, fk_item, code_modifier, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_lnk_code2item, OLD.fk_generic_code, OLD.fk_item, OLD.code_modifier, OLD.pk
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_code2narrative() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_code2procedure(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_code2procedure() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_code2procedure (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_lnk_code2item, fk_generic_code, fk_item, code_modifier, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_lnk_code2item, OLD.fk_generic_code, OLD.fk_item, OLD.code_modifier, OLD.pk
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_code2procedure() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_code2rfe(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_code2rfe() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_code2rfe (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_lnk_code2item, fk_generic_code, fk_item, code_modifier, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_lnk_code2item, OLD.fk_generic_code, OLD.fk_item, OLD.code_modifier, OLD.pk
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_code2rfe() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_code2tst_pnl(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_code2tst_pnl() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_code2tst_pnl (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_lnk_code2item, fk_generic_code, fk_item, code_modifier, pk
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_lnk_code2item, OLD.fk_generic_code, OLD.fk_item, OLD.code_modifier, OLD.pk
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_code2tst_pnl() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_constraint2vacc_course(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_constraint2vacc_course() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_constraint2vacc_course (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_vaccination_course, fk_constraint
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_vaccination_course, OLD.fk_constraint
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_constraint2vacc_course() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_dose2drug(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_dose2drug() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_dose2drug (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_drug_product, fk_dose
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_drug_product, OLD.fk_dose
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_dose2drug() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_identity2ext_id(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_identity2ext_id() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_identity2ext_id (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, id_identity, external_id, fk_origin, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.id_identity, OLD.external_id, OLD.fk_origin, OLD.comment
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_identity2ext_id() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_identity2primary_doc(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_identity2primary_doc() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_identity2primary_doc (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_identity, fk_primary_doc
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_identity, OLD.fk_primary_doc
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_identity2primary_doc() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_job2person(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_job2person() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_job2person (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_identity, fk_occupation, activities
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_identity, OLD.fk_occupation, OLD.activities
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_job2person() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_loinc2substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_loinc2substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_loinc2substance (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_substance, loinc, max_age, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_substance, OLD.loinc, OLD.max_age, OLD.comment
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_loinc2substance() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_loinc2test_panel(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_loinc2test_panel() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_loinc2test_panel (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_test_panel, loinc
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_test_panel, OLD.loinc
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_loinc2test_panel() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_org_unit2comm(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_org_unit2comm() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_org_unit2comm (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_org_unit, url, fk_type, is_confidential, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_org_unit, OLD.url, OLD.fk_type, OLD.is_confidential, OLD.comment
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_org_unit2comm() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_org_unit2ext_id(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_org_unit2ext_id() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_org_unit2ext_id (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_org_unit, external_id, fk_type, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_org_unit, OLD.external_id, OLD.fk_type, OLD.comment
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_org_unit2ext_id() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_pat2vaccination_course(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_pat2vaccination_course() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_pat2vaccination_course (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_patient, fk_course
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_patient, OLD.fk_course
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_pat2vaccination_course() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_person2relative(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_person2relative() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_person2relative (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, id_identity, id_relative, id_relation_type, started, ended
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.id_identity, OLD.id_relative, OLD.id_relation_type, OLD.started, OLD.ended
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_person2relative() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_substance2brand(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_substance2brand() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_substance2brand (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_brand, fk_substance
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_brand, OLD.fk_substance
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_substance2brand() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_tst2norm(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_tst2norm() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_tst2norm (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, id_test, id_norm
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.id_test, OLD.id_norm
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_tst2norm() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_type2item(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_type2item() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_type2item (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_type, fk_item
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_type, OLD.fk_item
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_type2item() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_vaccination_course2schedule(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_vaccination_course2schedule() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_vaccination_course2schedule (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_course, fk_schedule
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_course, OLD.fk_schedule
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_vaccination_course2schedule() OWNER TO "gm-dbo";

--
-- Name: ft_upd_lnk_vaccine2inds(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_lnk_vaccine2inds() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_lnk_vaccine2inds (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, fk_vaccine, fk_indication
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.fk_vaccine, OLD.fk_indication
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_lnk_vaccine2inds() OWNER TO "gm-dbo";

--
-- Name: ft_upd_message_inbox(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_message_inbox() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_message_inbox (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_staff, fk_inbox_item_type, comment, data, importance, fk_patient, ufk_context, due_date, expiry_date
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_staff, OLD.fk_inbox_item_type, OLD.comment, OLD.data, OLD.importance, OLD.fk_patient, OLD.ufk_context, OLD.due_date, OLD.expiry_date
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_message_inbox() OWNER TO "gm-dbo";

--
-- Name: ft_upd_occupation(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_occupation() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_occupation (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, name
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.name
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_occupation() OWNER TO "gm-dbo";

--
-- Name: ft_upd_operation(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_operation() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_operation (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, fk_health_issue, fk_encounter, clin_where, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.fk_health_issue, OLD.fk_encounter, OLD.clin_where, OLD.comment
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_operation() OWNER TO "gm-dbo";

--
-- Name: ft_upd_org(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_org() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_org (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, fk_category, fk_data_source
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.fk_category, OLD.fk_data_source
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_org() OWNER TO "gm-dbo";

--
-- Name: ft_upd_org_unit(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_org_unit() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_org_unit (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, fk_org, fk_address, fk_category
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.fk_org, OLD.fk_address, OLD.fk_category
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_org_unit() OWNER TO "gm-dbo";

--
-- Name: ft_upd_paperwork_templates(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_paperwork_templates() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_paperwork_templates (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_template_type, instance_type, name_short, name_long, external_version, gnumed_revision, engine, in_use, filename, data, edit_after_substitution
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_template_type, OLD.instance_type, OLD.name_short, OLD.name_long, OLD.external_version, OLD.gnumed_revision, OLD.engine, OLD.in_use, OLD.filename, OLD.data, OLD.edit_after_substitution
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_paperwork_templates() OWNER TO "gm-dbo";

--
-- Name: ft_upd_patient(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_patient() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_patient (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_identity, edc
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_identity, OLD.edc
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_patient() OWNER TO "gm-dbo";

--
-- Name: ft_upd_prax_geb_paid(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_prax_geb_paid() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_prax_geb_paid (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_fall, paid_amount, paid_when, paid_with
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_fall, OLD.paid_amount, OLD.paid_when, OLD.paid_with
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_prax_geb_paid() OWNER TO "gm-dbo";

--
-- Name: ft_upd_praxis_branch(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_praxis_branch() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_praxis_branch (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_org_unit
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_org_unit
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_praxis_branch() OWNER TO "gm-dbo";

--
-- Name: ft_upd_procedure(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_procedure() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_procedure (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, fk_hospital_stay, clin_end, is_ongoing, fk_org_unit, fk_doc, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.fk_hospital_stay, OLD.clin_end, OLD.is_ongoing, OLD.fk_org_unit, OLD.fk_doc, OLD.comment
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_procedure() OWNER TO "gm-dbo";

--
-- Name: ft_upd_ref_source(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_ref_source() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_ref_source (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, name_short, name_long, version, description, source
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.name_short, OLD.name_long, OLD.version, OLD.description, OLD.source
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_ref_source() OWNER TO "gm-dbo";

--
-- Name: ft_upd_referral(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_referral() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_referral (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, id, fk_referee, fk_form
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.id, OLD.fk_referee, OLD.fk_form
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_referral() OWNER TO "gm-dbo";

--
-- Name: ft_upd_region(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_region() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_region (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, code, country, name
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.code, OLD.country, OLD.name
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_region() OWNER TO "gm-dbo";

--
-- Name: ft_upd_relation_types(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_relation_types() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_relation_types (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, inverse, biological, biol_verified, description
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.inverse, OLD.biological, OLD.biol_verified, OLD.description
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_relation_types() OWNER TO "gm-dbo";

--
-- Name: ft_upd_report_query(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_report_query() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_report_query (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, label, cmd
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.label, OLD.cmd
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_report_query() OWNER TO "gm-dbo";

--
-- Name: ft_upd_staff(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_staff() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_staff (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_identity, db_user, short_alias, comment, is_active
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_identity, OLD.db_user, OLD.short_alias, OLD.comment, OLD.is_active
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_staff() OWNER TO "gm-dbo";

--
-- Name: ft_upd_staff_role(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_staff_role() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_staff_role (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, name, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.name, OLD.comment
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_staff_role() OWNER TO "gm-dbo";

--
-- Name: ft_upd_street(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_street() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_street (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, id_urb, name, postcode, suburb, lat_lon
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.id_urb, OLD.name, OLD.postcode, OLD.suburb, OLD.lat_lon
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_street() OWNER TO "gm-dbo";

--
-- Name: ft_upd_substance(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_substance() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_substance (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, atc, intake_instructions
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.atc, OLD.intake_instructions
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_substance() OWNER TO "gm-dbo";

--
-- Name: ft_upd_substance_in_brand(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_substance_in_brand() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_substance_in_brand (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, fk_brand, description, atc_code
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.fk_brand, OLD.description, OLD.atc_code
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_substance_in_brand() OWNER TO "gm-dbo";

--
-- Name: ft_upd_substance_intake(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_substance_intake() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_substance_intake (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, schedule, aim, duration, intake_is_approved_of, is_long_term, discontinued, discontinue_reason, fk_drug_component, comment_on_start, harmful_use_type
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.schedule, OLD.aim, OLD.duration, OLD.intake_is_approved_of, OLD.is_long_term, OLD.discontinued, OLD.discontinue_reason, OLD.fk_drug_component, OLD.comment_on_start, OLD.harmful_use_type
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_substance_intake() OWNER TO "gm-dbo";

--
-- Name: ft_upd_suppressed_hint(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_suppressed_hint() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_suppressed_hint (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_encounter, fk_hint, suppressed_by, suppressed_when, rationale, md5_sum
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_encounter, OLD.fk_hint, OLD.suppressed_by, OLD.suppressed_when, OLD.rationale, OLD.md5_sum
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_suppressed_hint() OWNER TO "gm-dbo";

--
-- Name: ft_upd_tag_image(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_tag_image() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_tag_image (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, filename, image
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.filename, OLD.image
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_tag_image() OWNER TO "gm-dbo";

--
-- Name: ft_upd_test_org(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_test_org() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_test_org (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_org_unit, fk_adm_contact, fk_med_contact, comment, contact
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_org_unit, OLD.fk_adm_contact, OLD.fk_med_contact, OLD.comment, OLD.contact
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_test_org() OWNER TO "gm-dbo";

--
-- Name: ft_upd_test_panel(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_test_panel() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_test_panel (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description, OLD.comment
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_test_panel() OWNER TO "gm-dbo";

--
-- Name: ft_upd_test_result(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_test_result() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_test_result (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, fk_type, val_num, val_alpha, val_unit, val_normal_min, val_normal_max, val_normal_range, val_target_min, val_target_max, val_target_range, abnormality_indicator, norm_ref_group, note_test_org, material, material_detail, fk_intended_reviewer, fk_request, status, source_data, val_grouping
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.fk_type, OLD.val_num, OLD.val_alpha, OLD.val_unit, OLD.val_normal_min, OLD.val_normal_max, OLD.val_normal_range, OLD.val_target_min, OLD.val_target_max, OLD.val_target_range, OLD.abnormality_indicator, OLD.norm_ref_group, OLD.note_test_org, OLD.material, OLD.material_detail, OLD.fk_intended_reviewer, OLD.fk_request, OLD.status, OLD.source_data, OLD.val_grouping
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_test_result() OWNER TO "gm-dbo";

--
-- Name: ft_upd_test_type(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_test_type() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_test_type (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_test_org, name, comment, reference_unit, loinc, abbrev, fk_meta_test_type
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_test_org, OLD.name, OLD.comment, OLD.reference_unit, OLD.loinc, OLD.abbrev, OLD.fk_meta_test_type
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_test_type() OWNER TO "gm-dbo";

--
-- Name: ft_upd_urb(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_urb() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_urb (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, fk_region, postcode, lat_lon, name
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.fk_region, OLD.postcode, OLD.lat_lon, OLD.name
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_urb() OWNER TO "gm-dbo";

--
-- Name: ft_upd_vacc_indication(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_vacc_indication() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_vacc_indication (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, description, atcs_single_indication, atcs_combi_indication
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.description, OLD.atcs_single_indication, OLD.atcs_combi_indication
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_vacc_indication() OWNER TO "gm-dbo";

--
-- Name: ft_upd_vacc_route(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_vacc_route() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_vacc_route (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, abbreviation, description
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.abbreviation, OLD.description
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_vacc_route() OWNER TO "gm-dbo";

--
-- Name: ft_upd_vaccination(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_vaccination() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_vaccination (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_item, clin_when, fk_encounter, fk_episode, narrative, soap_cat, pk, fk_provider, fk_vaccine, site, batch_no, reaction
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_item, OLD.clin_when, OLD.fk_encounter, OLD.fk_episode, OLD.narrative, OLD.soap_cat, OLD.pk, OLD.fk_provider, OLD.fk_vaccine, OLD.site, OLD.batch_no, OLD.reaction
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_vaccination() OWNER TO "gm-dbo";

--
-- Name: ft_upd_vaccination_course(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_vaccination_course() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_vaccination_course (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_recommended_by, fk_indication, is_active, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_recommended_by, OLD.fk_indication, OLD.is_active, OLD.comment
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_vaccination_course() OWNER TO "gm-dbo";

--
-- Name: ft_upd_vaccination_course_constraint(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_vaccination_course_constraint() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_vaccination_course_constraint (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, description
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.description
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_vaccination_course_constraint() OWNER TO "gm-dbo";

--
-- Name: ft_upd_vaccination_definition(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_vaccination_definition() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_vaccination_definition (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		id, fk_course, is_booster, seq_no, min_age_due, max_age_due, min_interval, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.id, OLD.fk_course, OLD.is_booster, OLD.seq_no, OLD.min_age_due, OLD.max_age_due, OLD.min_interval, OLD.comment
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_vaccination_definition() OWNER TO "gm-dbo";

--
-- Name: ft_upd_vaccination_schedule(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_vaccination_schedule() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_vaccination_schedule (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, name, comment
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.name, OLD.comment
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_vaccination_schedule() OWNER TO "gm-dbo";

--
-- Name: ft_upd_vaccine(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_vaccine() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_vaccine (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, id_route, is_live, min_age, max_age, comment, fk_drug_product
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.id_route, OLD.is_live, OLD.min_age, OLD.max_age, OLD.comment, OLD.fk_drug_product
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_vaccine() OWNER TO "gm-dbo";

--
-- Name: ft_upd_vaccine_batches(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_vaccine_batches() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_vaccine_batches (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_vaccine, batch_no
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_vaccine, OLD.batch_no
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_vaccine_batches() OWNER TO "gm-dbo";

--
-- Name: ft_upd_waiting_list(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_waiting_list() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	_is_allowed_updater boolean;
BEGIN
	-- is the session user allowed to update data ?
	SELECT gm.account_is_dbowner_or_staff(SESSION_USER) INTO STRICT _is_allowed_updater;
	IF _is_allowed_updater IS FALSE THEN
		RAISE EXCEPTION
			'UPDATE: gm.account_is_dbowner_or_staff(NAME): <%> is neither database owner, nor <postgres>, nor on staff', SESSION_USER
			USING ERRCODE = 'integrity_constraint_violation'
		;
		return NEW;
	END IF;
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_waiting_list (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk, fk_patient, registered, urgency, list_position, comment, area
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk, OLD.fk_patient, OLD.registered, OLD.urgency, OLD.list_position, OLD.comment, OLD.area
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_waiting_list() OWNER TO "gm-dbo";

--
-- Name: ft_upd_xlnk_identity(); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.ft_upd_xlnk_identity() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	NEW.row_version := OLD.row_version + 1;
	NEW.modified_when := CURRENT_TIMESTAMP;
	NEW.modified_by := SESSION_USER;
	INSERT INTO audit.log_xlnk_identity (
		orig_version, orig_when, orig_by, orig_tableoid, audit_action,
		pk_audit, row_version, modified_when, modified_by, pk, xfk_identity, pupic, data
	) VALUES (
		OLD.row_version, OLD.modified_when, OLD.modified_by, TG_RELID, TG_OP,
		OLD.pk_audit, OLD.row_version, OLD.modified_when, OLD.modified_by, OLD.pk, OLD.xfk_identity, OLD.pupic, OLD.data
	);
	return NEW;
END;$$;


ALTER FUNCTION audit.ft_upd_xlnk_identity() OWNER TO "gm-dbo";

--
-- Name: register_table_for_auditing(name, name); Type: FUNCTION; Schema: audit; Owner: gm-dbo
--

CREATE FUNCTION audit.register_table_for_auditing(name, name) RETURNS boolean
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
	_schema alias for $1;
	_table alias for $2;
BEGIN
	-- does table exist ?
	perform 1 from pg_class where
		relname = _table
			and
		relnamespace = (select oid from pg_namespace where nspname = _schema)
	;
	if not found then
		raise exception 'audit.register_table_for_auditing(): table [%.%] does not exist', _schema, _table;
		return false;
	end if;
	-- already queued for auditing ?
	perform 1 from audit.audited_tables where
		table_name = _table
			and
		schema = _schema;
	if found then
		return true;
	end if;
	-- add definition
	insert into audit.audited_tables (
		schema, table_name
	) values (
		_schema, _table
	);
	return true;
END;$_$;


ALTER FUNCTION audit.register_table_for_auditing(name, name) OWNER TO "gm-dbo";

--
-- Name: FUNCTION register_table_for_auditing(name, name); Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON FUNCTION audit.register_table_for_auditing(name, name) IS 'sanity-checking convenience function for registering a table for auditing';


--
-- Name: get_bill_receiver_identity(integer); Type: FUNCTION; Schema: bill; Owner: gm-dbo
--

CREATE FUNCTION bill.get_bill_receiver_identity(integer) RETURNS integer
    LANGUAGE sql
    AS $_$
select
	value
from (
	select
		id.pk_id,
		id.value::integer
	from
		dem.v_external_ids4identity id
			join dem.identity d_i on (id.value = d_i.pk::text)
	where
		id.pk_type = (select pk from dem.enum_ext_id_types where name = 'bill receiver' and issuer = 'GNUmed')
			and
		id.pk_identity = $1
	union all
	select
		0,
		$1
) me
limit 1;$_$;


ALTER FUNCTION bill.get_bill_receiver_identity(integer) OWNER TO "gm-dbo";

--
-- Name: trf_prevent_empty_bills(); Type: FUNCTION; Schema: bill; Owner: gm-dbo
--

CREATE FUNCTION bill.trf_prevent_empty_bills() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_item_count integer;
	_msg text;
BEGIN
	if TG_OP = 'UPDATE' then
		if OLD.fk_bill IS NULL then
			return NULL;
		end if;
		if OLD.fk_bill IS NOT DISTINCT FROM NEW.fk_bill then
			return NULL;
		end if;
	else
		if OLD.fk_bill is NULL then
			return NULL;
		end if;
	end if;
	-- we now either:
	--	DELETE with .fk_bill NOT NULL
	-- or:
	--	UPDATE with an .fk_bill change (including towards fk_bill = NULL)
	-- let us check whether the (previous) bill still exists
	-- at all or whether we are deleting the bill (and thereby
	-- setting our .fk_bill to NULL)
	-- only works at or below REPEATABLE READ after deletion of bill
	perform 1 from bill.bill where pk = OLD.fk_bill;
	if FOUND is FALSE then
		return NULL;
	end if;
	select count(1) into _item_count
	from bill.bill_item
	where
		fk_bill = OLD.fk_bill
			and
		pk != OLD.pk;
	if _item_count > 0 then
		return NULL;
	end if;
	_msg := '[bill.trf_prevent_empty_bills]: cannot remove (by '
			|| '<' || TG_OP || '>'
			||') the only item (bill.bill_item.pk='
			|| coalesce(OLD.pk::text, '<NULL>'::text)
			|| ') from bill (bill.bill_item.fk_bill=bill.bill.pk='
			|| coalesce(OLD.fk_bill::text, '<NULL>'::text)
			|| ') ';
	raise exception unique_violation using message = _msg;
	return NULL;
END;$$;


ALTER FUNCTION bill.trf_prevent_empty_bills() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_prevent_empty_bills(); Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON FUNCTION bill.trf_prevent_empty_bills() IS 'Prevent bills to become void of items due to deletions/updates of bill items.';


--
-- Name: trf_prevent_mislinked_bills(); Type: FUNCTION; Schema: bill; Owner: gm-dbo
--

CREATE FUNCTION bill.trf_prevent_mislinked_bills() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_doc_patient integer;
	_bill_patient integer;
	_msg text;
BEGIN
	if NEW.fk_doc IS NULL then
		return NEW;
	end if;
	if TG_OP = 'UPDATE' then
		if OLD.fk_doc IS NOT DISTINCT FROM NEW.fk_doc then
			return NEW;
		end if;
	end if;
	-- we now either:
	--	INSERT with .fk_doc NOT NULL
	-- or:
	--	UPDATE with an .fk_bill change to a NON-NULL value
	select pk_patient into _doc_patient
	from blobs.v_doc_med
	where
		pk_doc = NEW.fk_doc;
	select pk_patient into _bill_patient
	from bill.v_bills
	where
		pk_bill = NEW.pk;
	if _doc_patient = _bill_patient then
		return NEW;
	end if;
	_msg := '[bill.trf_prevent_mislinked_bills]: patient mismatch between '
		|| 'bill (pk=' || NEW.pk || ', patient=' || _bill_patient || ') '
		|| 'and invoice (pk=' || NEW.fk_doc || ', patient=' || _doc_patient || ')';
	raise exception integrity_constraint_violation using message = _msg;
	return NULL;
END;$$;


ALTER FUNCTION bill.trf_prevent_mislinked_bills() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_prevent_mislinked_bills(); Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON FUNCTION bill.trf_prevent_mislinked_bills() IS 'Prevent bills to link to invoices of another patient.';


--
-- Name: delete_document(integer, integer); Type: FUNCTION; Schema: blobs; Owner: gm-dbo
--

CREATE FUNCTION blobs.delete_document(integer, integer) RETURNS boolean
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
	_pk_doc alias for $1;
	_pk_encounter alias for $2;
	_del_note text;
	_doc_row record;
	_obj_row record;
	tmp text;
BEGIN
	select * into _doc_row from blobs.doc_med where pk = _pk_doc;
	_del_note := _('Deletion of document') || E':
'
		|| ' '
			|| to_char(_doc_row.clin_when, 'YYYY-MM-DD HH24:MI')
			|| ' "' || (select _(dt.name) from blobs.doc_type dt where pk = _doc_row.fk_type) || '"'
			|| coalesce(' (' || _doc_row.ext_ref || ')', '')
		|| coalesce(E'
 ' || _doc_row.comment, '')
	;
	FOR _obj_row IN select * from blobs.doc_obj where fk_doc = _pk_doc order by seq_idx LOOP
		_del_note := _del_note || E'
'
			|| ' #' || coalesce(_obj_row.seq_idx, '-1') || ': "' || coalesce(_obj_row.comment, '') || E'"
'
			|| ' ' || coalesce(_obj_row.filename, '') || E'
';
	end LOOP;
	insert into clin.clin_narrative
		(fk_encounter, fk_episode, narrative, soap_cat)
	values (
		_pk_encounter,
		_doc_row.fk_episode,
		_del_note,
		NULL
	);
	-- should auto-cascade:
	--delete from blobs.doc_obj where fk_doc = _pk_doc;
	-- should auto-NULL:
	--bill.bill.fk_doc
	delete from blobs.doc_med where pk = _pk_doc;
	return True;
END;$_$;


ALTER FUNCTION blobs.delete_document(integer, integer) OWNER TO "gm-dbo";

--
-- Name: delete_document_part(integer, integer); Type: FUNCTION; Schema: blobs; Owner: gm-dbo
--

CREATE FUNCTION blobs.delete_document_part(integer, integer) RETURNS boolean
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
	_pk_doc_part alias for $1;
	_pk_encounter alias for $2;
	_del_note text;
	_doc_row record;
	_obj_row record;
	tmp text;
BEGIN
	select * into _obj_row from blobs.doc_obj where pk = _pk_doc_part;
	select * into _doc_row from blobs.doc_med where pk = _obj_row.fk_doc;
	_del_note := _('Deletion of part from document') || E':
'
		|| ' '
			|| to_char(_doc_row.clin_when, 'YYYY-MM-DD HH24:MI')
			|| ' "' || (select _(dt.name) from blobs.doc_type dt where pk = _doc_row.fk_type) || '"'
			|| coalesce(' (' || _doc_row.ext_ref || ')', '')
		|| coalesce(E'
 ' || _doc_row.comment, '')
		|| E'
'
		|| ' #' || coalesce(_obj_row.seq_idx, '-1') || ': "' || coalesce(_obj_row.comment, '') || E'"
'
		|| ' ' || coalesce(_obj_row.filename, '') || E'
'
	;
	insert into clin.clin_narrative
		(fk_encounter, fk_episode, narrative, soap_cat)
	values (
		_pk_encounter,
		_doc_row.fk_episode,
		_del_note,
		NULL
	);
	delete from blobs.doc_obj where pk = _pk_doc_part;
	return True;
END;$_$;


ALTER FUNCTION blobs.delete_document_part(integer, integer) OWNER TO "gm-dbo";

--
-- Name: trf_do_not_duplicate_primary_episode_in_link_table(); Type: FUNCTION; Schema: blobs; Owner: gm-dbo
--

CREATE FUNCTION blobs.trf_do_not_duplicate_primary_episode_in_link_table() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
	-- if already in doc_med
	perform 1 from blobs.doc_med dm where dm.fk_episode = NEW.fk_episode and dm.pk = NEW.fk_doc_med;
	if FOUND then
		-- skip the insert/update
		return null;
	end if;
	return NEW;
END;$$;


ALTER FUNCTION blobs.trf_do_not_duplicate_primary_episode_in_link_table() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_do_not_duplicate_primary_episode_in_link_table(); Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON FUNCTION blobs.trf_do_not_duplicate_primary_episode_in_link_table() IS 'This trigger function is called before a lnk_doc_med2episode
	 row is inserted or updated. It makes sure the episode does
	 not duplicate the primary episode for this document listed
	 in doc_med. If it does the insert/update is skipped.';


--
-- Name: trf_mark_unreviewed_on_doc_obj_update(); Type: FUNCTION; Schema: blobs; Owner: gm-dbo
--

CREATE FUNCTION blobs.trf_mark_unreviewed_on_doc_obj_update() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
	if (NEW.data != OLD.data) or ((NEW.data != OLD.data) is NULL) then
		delete from blobs.reviewed_doc_objs where fk_reviewed_row = OLD.pk;
	end if;
	return NEW;
END;$$;


ALTER FUNCTION blobs.trf_mark_unreviewed_on_doc_obj_update() OWNER TO "gm-dbo";

--
-- Name: trf_remove_primary_episode_from_link_table(); Type: FUNCTION; Schema: blobs; Owner: gm-dbo
--

CREATE FUNCTION blobs.trf_remove_primary_episode_from_link_table() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
	-- if update
	if TG_OP = 'UPDATE' then
		-- and no change
		if NEW.fk_episode = OLD.fk_episode then
			-- then do nothing
			return NEW;
		end if;
	end if;
	-- if already in link table
	perform 1 from blobs.lnk_doc_med2episode ldm2e where ldm2e.fk_episode = NEW.fk_episode and ldm2e.fk_doc_med = NEW.pk;
	if FOUND then
		-- delete from link table
		delete from blobs.lnk_doc_med2episode where fk_episode = NEW.fk_episode and fk_doc_med = NEW.pk;
	end if;
	return NEW;
END;$$;


ALTER FUNCTION blobs.trf_remove_primary_episode_from_link_table() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_remove_primary_episode_from_link_table(); Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON FUNCTION blobs.trf_remove_primary_episode_from_link_table() IS 'This trigger function is called when a doc_med row
	 is inserted or updated. It makes sure the primary
	 episode listed in doc_med is not duplicated in
	 lnk_doc_med2episode for the same document. If it
	 exists in the latter it is removed from there.';


--
-- Name: trf_set_intended_reviewer(); Type: FUNCTION; Schema: blobs; Owner: gm-dbo
--

CREATE FUNCTION blobs.trf_set_intended_reviewer() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_pk_patient integer;
	_pk_provider integer;
BEGIN
	-- explicitely set ?
	if NEW.fk_intended_reviewer is not NULL then
		return NEW;
	end if;
	-- find patient via document
	select
		fk_patient into _pk_patient
	from
		clin.encounter
	where
		clin.encounter.pk = (
			select fk_encounter from blobs.doc_med where pk = NEW.fk_doc
		);
	-- does patient have primary provider ?
	select
		fk_primary_provider into _pk_provider
	from
		dem.identity
	where
		dem.identity.pk = _pk_patient;
	if _pk_provider is not NULL then
		NEW.fk_intended_reviewer := _pk_provider;
		return NEW;
	end if;
	-- else use CURRENT_USER
	select
		pk into _pk_provider
	from
		dem.staff
	where
		dem.staff.db_user = current_user;
	NEW.fk_intended_reviewer := _pk_provider;
	return NEW;
END;$$;


ALTER FUNCTION blobs.trf_set_intended_reviewer() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_set_intended_reviewer(); Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON FUNCTION blobs.trf_set_intended_reviewer() IS 'Set the default on blobs.doc_obj.fk_intended_reviewer.';


--
-- Name: trf_verify_page_number(); Type: FUNCTION; Schema: blobs; Owner: gm-dbo
--

CREATE FUNCTION blobs.trf_verify_page_number() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
declare
	msg text;
begin
	if NEW.seq_idx is NULL then
		return NEW;
	end if;
	perform 1 from blobs.doc_obj where pk <> NEW.pk and fk_doc = NEW.fk_doc and seq_idx = NEW.seq_idx;
	if FOUND then
		msg := '[blobs.trf_verify_page_number]: uniqueness violation: seq_idx [' || NEW.seq_idx || '] already exists for fk_doc [' || NEW.fk_doc || ']';
		raise exception '%', msg;
	end if;
	return NEW;
end;$$;


ALTER FUNCTION blobs.trf_verify_page_number() OWNER TO "gm-dbo";

--
-- Name: create_cfg_item(text, text, text, text, text); Type: FUNCTION; Schema: cfg; Owner: gm-dbo
--

CREATE FUNCTION cfg.create_cfg_item(text, text, text, text, text) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
declare
	_option alias for $1;
	_val_type alias for $2;
	_workplace alias for $3;
	_cookie alias for $4;
	_owner alias for $5;
	real_owner text;
	pk_template integer;
	pk_item integer;
begin
	-- check template
	select into pk_template pk from cfg.cfg_template where name = _option and type = _val_type;
	if not FOUND then
		insert into cfg.cfg_template (name, type) values (_option, _val_type);
		select into pk_template currval('cfg.cfg_template_pk_seq');
	end if;
	if _owner is null then
		select into real_owner CURRENT_USER;
	else
		real_owner := _owner;
	end if;
	-- check item
	if _cookie is NULL then
		select into pk_item pk from cfg.cfg_item where
			fk_template = pk_template and
			owner = real_owner and
			workplace = _workplace and
			cookie is null;
	else
		select into pk_item pk from cfg.cfg_item where
			fk_template = pk_template and
			owner = real_owner and
			workplace = _workplace and
			cookie = _cookie;
	end if;
	if FOUND then
		return pk_item;
	end if;
	insert into cfg.cfg_item (
		fk_template, workplace, cookie, owner
	) values (
		pk_template,
		_workplace,
		_cookie,
		real_owner
	);
	select into pk_item currval('cfg.cfg_item_pk_seq');
	return pk_item;
end;$_$;


ALTER FUNCTION cfg.create_cfg_item(text, text, text, text, text) OWNER TO "gm-dbo";

--
-- Name: set_option(text, anyelement, text, text, text); Type: FUNCTION; Schema: cfg; Owner: gm-dbo
--

CREATE FUNCTION cfg.set_option(text, anyelement, text, text, text) RETURNS boolean
    LANGUAGE plpgsql
    AS $_$
declare
	_option alias for $1;
	_value alias for $2;
	_workplace alias for $3;
	_cookie alias for $4;
	_owner alias for $5;
	val_type text;
	pk_item integer;
	rows integer;
	cmd text;
begin
	-- determine data type
	if _value is of (text, char, varchar, name) then
		val_type := 'string';
	elsif _value is of (smallint, integer, bigint, numeric, boolean) then
		val_type := 'numeric';
	elsif _value is of (bytea) then
		val_type := 'data';
	elsif _value is of (text[]) then
		val_type := 'str_array';
	else
		raise exception 'cfg.set_option(text, any, text, text, text): invalid type of value';
	end if;
	-- create template/item if need be
	select into pk_item cfg.create_cfg_item(_option, val_type, _workplace, _cookie, _owner);
	-- set item value
	cmd := 'select 1 from cfg.cfg_' || val_type || ' where fk_item=' || pk_item || ';';
	execute cmd;
	get diagnostics rows = row_count;
	found := rows <> 0;
	if FOUND then
		if val_type = 'str_array' then
			cmd := 'update cfg.cfg_str_array set value=''{"' || array_to_string(_value, '","') || '"}'' where fk_item=' || pk_item || ';';
		elsif val_type = 'data' then
			cmd := 'update cfg.cfg_data set value=''' || encode(_value, 'escape') || ''' where fk_item=' || pk_item || ';';
		else
			cmd := 'update cfg.cfg_' || val_type || ' set value=' || quote_literal(_value) || ' where fk_item=' || pk_item || ';';
		end if;
		execute cmd;
		return True;
	end if;
	if val_type = 'str_array' then
		cmd := 'insert into cfg.cfg_str_array(fk_item, value) values (' || pk_item || ', ''{"' || array_to_string(_value, '","') || '"}'');';
	elsif val_type = 'data' then
		cmd := 'insert into cfg.cfg_data(fk_item, value) values (' || pk_item || ', ''' || encode(_value, 'escape') || ''');';
	else
		cmd := 'insert into cfg.cfg_' || val_type || ' (fk_item, value) values (' || pk_item || ', ' || quote_literal(_value) || ');';
	end if;
	execute cmd;
	return True;
end;$_$;


ALTER FUNCTION cfg.set_option(text, anyelement, text, text, text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION set_option(text, anyelement, text, text, text); Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON FUNCTION cfg.set_option(text, anyelement, text, text, text) IS 'set option, owner = NULL means CURRENT_USER';


--
-- Name: _get_recommendation_for_patient_hint(text, integer); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin._get_recommendation_for_patient_hint(text, integer) RETURNS text
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_raw_query ALIAS FOR $1;
	_pk_identity ALIAS FOR $2;
	_query text;
	_recommendation text;
BEGIN
	IF _raw_query IS NULL THEN
		RETURN NULL::text;
	END IF;
	_query := replace(_raw_query, 'ID_ACTIVE_PATIENT', _pk_identity::text);
	BEGIN
		EXECUTE _query INTO STRICT _recommendation;
	EXCEPTION
		--WHEN insufficient_privilege THEN RAISE WARNING 'auto hint recommendation query failed: %', _query;
		WHEN others THEN
			RAISE WARNING 'auto hint recommendation query failed: %', _query;
			-- only available starting with PG 9.2:
			--GET STACKED DIAGNOSTICS
			--	_exc_state = RETURNED_SQLSTATE,
			--	_exc_msg = MESSAGE_TEXT,
			--	_exc_detail = PG_EXCEPTION_DETAIL,
			--	_exc_hint = PG_EXCEPTION_HINT,
			--	_exc_context = PG_EXCEPTION_CONTEXT;
			--RAISE WARNING 'SQL STATE: %', _exc_state;
			--RAISE WARNING 'MESSAGE: %', _exc_msg;
			--RAISE WARNING 'DETAIL: %', _exc_detail;
			--RAISE WARNING 'HINT: %', _exc_hint;
			--RAISE WARNING 'CONTEXT: %', _exc_context;
			-- workaround for 9.1:
			RAISE WARNING 'SQL STATE: %', SQLSTATE;
			RAISE WARNING 'MESSAGE: %', SQLERRM;
			_recommendation := 'ERROR running hint recommendation query [' || _query || ']';
	END;
	RETURN _recommendation;
END;$_$;


ALTER FUNCTION clin._get_recommendation_for_patient_hint(text, integer) OWNER TO "gm-dbo";

--
-- Name: add_coded_phrase(text, text, text); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.add_coded_phrase(text, text, text) RETURNS boolean
    LANGUAGE plpgsql
    AS $_$
declare
	_term alias for $1;
	_code alias for $2;
	_system alias for $3;
	_tmp text;
begin
	select into _tmp 1 from clin.coded_phrase where
		term = _term
		and code = _code
		and xfk_coding_system = _system;
	if found then
		return True;
	end if;
	insert into clin.coded_phrase (term, code, xfk_coding_system)
		values (_term, _code, _system);
	return True;
end;$_$;


ALTER FUNCTION clin.add_coded_phrase(text, text, text) OWNER TO "gm-dbo";

--
-- Name: f_del_booster_must_have_base_immunity(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.f_del_booster_must_have_base_immunity() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	msg text;
BEGIN
	-- do not worry about booster deletes
	if OLD.is_booster then
		return null;
	end if;
	-- any non-booster rows left ?
	perform 1 from clin.vaccination_definition where fk_course = OLD.fk_course and seq_no is not null;
	if FOUND then
		return null;
	end if;
	-- *any* rows left ?
	perform 1 from clin.vaccination_definition where fk_course = OLD.fk_course;
	if not FOUND then
		-- no problem
		return null;
	end if;
	-- any remaining rows can only be booster rows - which is a problem
	msg := 'Cannot delete last non-booster vacc def [' || OLD.pk || '] from course [' || OLD.fk_course || ']. There would be only booster definitions left.';
	raise exception '%', msg;
	return null;
END;$$;


ALTER FUNCTION clin.f_del_booster_must_have_base_immunity() OWNER TO "gm-dbo";

--
-- Name: f_fk_reviewer_default(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.f_fk_reviewer_default() RETURNS integer
    LANGUAGE plpgsql
    AS $$
declare
	_pk_staff integer;
begin
	select pk into _pk_staff from dem.staff where db_user = current_user;
	return _pk_staff;
end;$$;


ALTER FUNCTION clin.f_fk_reviewer_default() OWNER TO "gm-dbo";

--
-- Name: f_ins_booster_must_have_base_immunity(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.f_ins_booster_must_have_base_immunity() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
	-- do not worry about non-booster inserts
	if NEW.is_booster is false then
		return NEW;
	end if;
	-- only insert booster def if non-booster def exists
	perform 1 from clin.vaccination_definition where fk_course = NEW.fk_course and seq_no is not null;
	if FOUND then
		return NEW;
	end if;
	raise exception 'Cannot define booster shot for course [%]. There is no base immunization definition.', NEW.fk_course;
	return null;
END;
$$;


ALTER FUNCTION clin.f_ins_booster_must_have_base_immunity() OWNER TO "gm-dbo";

--
-- Name: f_protect_clin_root_item(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.f_protect_clin_root_item() RETURNS boolean
    LANGUAGE plpgsql
    AS $$
begin
	raise exception 'INSERT/DELETE on <clin_root_item> not allowed.';
	return False;
end;
$$;


ALTER FUNCTION clin.f_protect_clin_root_item() OWNER TO "gm-dbo";

--
-- Name: FUNCTION f_protect_clin_root_item(); Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON FUNCTION clin.f_protect_clin_root_item() IS 'protect from direct inserts/deletes which the 
	 inheritance system cannot handle properly';


--
-- Name: f_upd_booster_must_have_base_immunity(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.f_upd_booster_must_have_base_immunity() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	msg text;
BEGIN
	-- do not worry about non-booster updates
	if NEW.is_booster is false then
		return null;
	end if;
	-- after update to booster still non-booster def available ?
	perform 1 from clin.vaccination_definition where fk_course = NEW.fk_course and seq_no is not null;
	if FOUND then
		return null;
	end if;
	msg := 'Cannot set vacc def [' || NEW.pk || '] to booster for course [' || NEW.fk_course || ']. There would be no base immunization definition left.';
	raise exception '%', msg;
	return null;
END;$$;


ALTER FUNCTION clin.f_upd_booster_must_have_base_immunity() OWNER TO "gm-dbo";

--
-- Name: get_dob(integer); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.get_dob(integer) RETURNS timestamp with time zone
    LANGUAGE sql
    AS $_$
		select date_trunc('day'::text, d_i.dob) + COALESCE(d_i.tob, d_i.dob::time without time zone)::interval AS dob
		from dem.identity d_i
		where d_i.pk = $1;
	$_$;


ALTER FUNCTION clin.get_dob(integer) OWNER TO "gm-dbo";

--
-- Name: get_dod(integer); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.get_dod(integer) RETURNS timestamp with time zone
    LANGUAGE sql
    AS $_$select deceased from dem.identity d_i where d_i.pk = $1;$_$;


ALTER FUNCTION clin.get_dod(integer) OWNER TO "gm-dbo";

--
-- Name: is_null_or_blank_string(text); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.is_null_or_blank_string(text) RETURNS boolean
    LANGUAGE sql
    AS $_$select (coalesce(trim($1), '') = '');$_$;


ALTER FUNCTION gm.is_null_or_blank_string(text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION is_null_or_blank_string(text); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.is_null_or_blank_string(text) IS 'input is either NULL or empty string -> True; 
input is not NULL and not empty -> FALSE';


--
-- Name: is_null_or_non_empty_string(text); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.is_null_or_non_empty_string(text) RETURNS boolean
    LANGUAGE sql
    AS $_$select (coalesce(trim($1), 'NULL') != '');$_$;


ALTER FUNCTION gm.is_null_or_non_empty_string(text) OWNER TO "gm-dbo";

SET default_tablespace = '';

SET default_table_access_method = heap;

--
-- Name: audit_fields; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.audit_fields (
    pk_audit integer NOT NULL,
    row_version integer DEFAULT 0 NOT NULL,
    modified_when timestamp with time zone DEFAULT now() NOT NULL,
    modified_by name DEFAULT "current_user"() NOT NULL,
    CONSTRAINT audit_audit_fields_sane_modified_when CHECK (((modified_when <= clock_timestamp()) IS TRUE))
);


ALTER TABLE audit.audit_fields OWNER TO "gm-dbo";

--
-- Name: TABLE audit_fields; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON TABLE audit.audit_fields IS 'this table holds all the fields needed for auditing';


--
-- Name: COLUMN audit_fields.row_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.audit_fields.row_version IS 'the version of the row; mainly just a count';


--
-- Name: COLUMN audit_fields.modified_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.audit_fields.modified_when IS 'when has this row been committed (created/modified)';


--
-- Name: COLUMN audit_fields.modified_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.audit_fields.modified_by IS 'by whom has this row been committed (created/modified)';


--
-- Name: auto_hint; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.auto_hint (
    pk integer NOT NULL,
    query text,
    title text,
    hint text,
    url text,
    is_active boolean DEFAULT true NOT NULL,
    source text,
    lang text,
    recommendation_query text,
    popup_type integer DEFAULT 1 NOT NULL,
    highlight_as_priority boolean DEFAULT true NOT NULL,
    CONSTRAINT ref_auto_hint_sane_hint CHECK ((gm.is_null_or_blank_string(hint) IS FALSE)),
    CONSTRAINT ref_auto_hint_sane_lang CHECK ((gm.is_null_or_blank_string(lang) IS FALSE)),
    CONSTRAINT ref_auto_hint_sane_popup_type CHECK (((popup_type > '-1'::integer) AND (popup_type < 3))),
    CONSTRAINT ref_auto_hint_sane_query CHECK ((gm.is_null_or_blank_string(query) IS FALSE)),
    CONSTRAINT ref_auto_hint_sane_rec_query CHECK (gm.is_null_or_non_empty_string(recommendation_query)),
    CONSTRAINT ref_auto_hint_sane_source CHECK ((gm.is_null_or_blank_string(source) IS FALSE)),
    CONSTRAINT ref_auto_hint_sane_title CHECK ((gm.is_null_or_blank_string(title) IS FALSE)),
    CONSTRAINT ref_auto_hint_sane_url CHECK (gm.is_null_or_non_empty_string(url))
)
INHERITS (audit.audit_fields);


ALTER TABLE ref.auto_hint OWNER TO "gm-dbo";

--
-- Name: TABLE auto_hint; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.auto_hint IS 'This table stores SQL queries and the associated hints. If the query returns TRUE the client should display the hint.';


--
-- Name: COLUMN auto_hint.query; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.auto_hint.query IS 'This query is run against the database.';


--
-- Name: COLUMN auto_hint.title; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.auto_hint.title IS 'A short title to summarize and identify the hint.';


--
-- Name: COLUMN auto_hint.hint; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.auto_hint.hint IS 'When the query returns true this is the hint that should be displayed.';


--
-- Name: COLUMN auto_hint.url; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.auto_hint.url IS 'An URL relevant to the hint.';


--
-- Name: COLUMN auto_hint.is_active; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.auto_hint.is_active IS 'Whether or not this query/hint is active.';


--
-- Name: COLUMN auto_hint.source; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.auto_hint.source IS 'Who provided query and hint.';


--
-- Name: COLUMN auto_hint.lang; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.auto_hint.lang IS 'The language the hint is written in.';


--
-- Name: COLUMN auto_hint.popup_type; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.auto_hint.popup_type IS '0: do not include in any popups (= 0 popups); 1: show an individual popup for this hint (= 1 hint per popup), 2: include in list popups only (= 2 or more hints in popup)';


--
-- Name: COLUMN auto_hint.highlight_as_priority; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.auto_hint.highlight_as_priority IS 'Whether or not user wants this hint highlighted (possibly among a list of displayed hints), the way of highlighting is up to the application.';


--
-- Name: v_auto_hints; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_auto_hints AS
 SELECT auto_hint.pk AS pk_auto_hint,
    auto_hint.query,
    auto_hint.recommendation_query,
    auto_hint.title,
    auto_hint.hint,
    auto_hint.url,
    auto_hint.is_active,
    auto_hint.source,
    auto_hint.lang,
    auto_hint.popup_type,
    auto_hint.highlight_as_priority,
    NULL::text AS rationale4suppression,
    NULL::text AS recommendation,
    md5(((((COALESCE(auto_hint.query, ''::text) || COALESCE(auto_hint.recommendation_query, ''::text)) || COALESCE(auto_hint.title, ''::text)) || COALESCE(auto_hint.hint, ''::text)) || COALESCE(auto_hint.url, ''::text))) AS md5_sum,
    auto_hint.xmin AS xmin_auto_hint
   FROM ref.auto_hint;


ALTER TABLE ref.v_auto_hints OWNER TO "gm-dbo";

--
-- Name: get_hints_for_patient(integer); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.get_hints_for_patient(_pk_identity integer) RETURNS SETOF ref.v_auto_hints
    LANGUAGE plpgsql
    AS $$
DECLARE
	_hint ref.v_auto_hints%rowtype;
	_query text;
	_suppression_exists boolean;		-- does not mean that the suppression applies
	_md5_at_suppression text;
	_old_rationale4suppression text;
	_hint_currently_applies boolean;	-- regardless of whether suppressed or not
	_hint_recommendation text;
	_title text;
--	_exc_state text;
--	_exc_msg text;
--	_exc_detail text;
--	_exc_hint text;
--	_exc_context text;
BEGIN
	-- loop over all defined hints
	FOR _hint IN SELECT * FROM ref.v_auto_hints WHERE is_active LOOP
		--raise NOTICE 'checking hint for patient %: %', _pk_identity, _hint.title;
		-- is the hint suppressed ?
		SELECT (clin.hint_suppression_exists(_pk_identity, _hint.pk_auto_hint)).*
			INTO STRICT _suppression_exists, _md5_at_suppression, _old_rationale4suppression;
		-- does the hint currently apply ? (regardless of whether it is suppressed)
		_query := replace(_hint.query, 'ID_ACTIVE_PATIENT', _pk_identity::text);
		_query := replace(_query, 'clin.v_emr_journal', 'clin._view_emr_journal_without_suppressed_hints');
		SELECT (clin.run_hint_query(_hint.title, _query)).*
			INTO STRICT _hint_currently_applies, _title;
		-- error ?
		IF _hint_currently_applies IS NULL THEN
			--raise NOTICE ' error -> return';
			_hint.title := _title;
			_hint.hint := _query;
			RETURN NEXT _hint;
			-- process next hint
			CONTINUE;
		END IF;
		-- hint does not apply
		IF _hint_currently_applies IS FALSE THEN
			-- does a (previously stored) suppression exist ?
			IF _suppression_exists IS FALSE THEN
				-- no, so skip this hint
				--raise NOTICE ' does not apply -> skip';
				CONTINUE;
			END IF;
			--raise NOTICE ' does not apply but suppression invalid -> return for invalidation';
			-- hint suppressed but does NOT apply:
			-- skip hint but invalidate suppression, because:
			-- * previously the hint must have applied and the user suppressed it,
			-- * then patient data (or hint definition) changed such that
			--   the hint does not apply anymore (but the suppression is
			--   still valid),
			-- * when patient data changes again, the hint might apply again
			-- * HOWEVER - since the suppression would still be valid - the
			--   hint would magically get suppressed again (which is
			--   medically unsafe) ...
			-- after invalidation, the hint will no longer be suppressed,
			-- however - since it does not currently apply - it will
			-- still not be returned and shown until it applies again ...
			--
			-- -----------------------------------------------------------------------
			-- UNFORTUNATELY, the following is currently not _possible_ because
			-- we are running inside a READONLY transaction (due to inherent
			-- security risks when running arbitrary user queries [IOW the hint
			-- SQL] against the database) and we cannot execute a
			-- sub-transaction as READWRITE :-/
			--
			--UPDATE clin.suppressed_hint
			--SET md5_sum = 'invalidated'::text		-- will not ever match any md5 sum
			--WHERE
			--	fk_encounter IN (
			--		SELECT pk FROM clin.encounter WHERE fk_patient = _pk_identity
			--	)
			--		AND
			--	fk_hint = _hint.pk_auto_hint;
			-- -----------------------------------------------------------------------
			--
			-- hence our our workaround is to, indeed, return the hint but
			-- tag it with a magic rationale, by means of which the client
			-- can detect it to be in need of invalidation:
			_hint.title := 'HINT DOES NOT APPLY BUT NEEDS INVALIDATION OF EXISTING SUPPRESSION [' || _hint.title || '].';
			_hint.rationale4suppression := 'magic_tag::does_not_apply::suppression_needs_invalidation';
			RETURN NEXT _hint;
			CONTINUE;
		END IF;
		--raise NOTICE ' applies';
		-- but is there a suppression ?
		IF _suppression_exists IS FALSE THEN
			--raise NOTICE ' return';
			-- no: retrieve recommendation
			SELECT clin._get_recommendation_for_patient_hint(_hint.recommendation_query, _pk_identity) INTO STRICT _hint_recommendation;
			_hint.recommendation := _hint_recommendation;
			-- return hint
			RETURN NEXT _hint;
			CONTINUE;
		END IF;
		-- yes, is suppressed
		--raise NOTICE ' is suppressed';
		-- is the suppression still valid ?
		-- -> yes, suppression valid
		IF _md5_at_suppression = _hint.md5_sum THEN
			--raise NOTICE '-> suppression valid, ignoring hint';
			-- hint applies, suppressed, suppression valid: skip this hint
			CONTINUE;
		END IF;
		-- -> no, suppression not valid
		-- hint definition must have changed so ignore the suppression but
		-- provide previous rationale for suppression to the user
		_hint.rationale4suppression := _old_rationale4suppression;
		-- retrieve recommendation
		SELECT clin._get_recommendation_for_patient_hint(_hint.recommendation_query, _pk_identity) INTO STRICT _hint_recommendation;
		_hint.recommendation := _hint_recommendation;
		RETURN NEXT _hint;
		CONTINUE;
	END LOOP;
	RETURN;
END;$$;


ALTER FUNCTION clin.get_hints_for_patient(_pk_identity integer) OWNER TO "gm-dbo";

--
-- Name: hint_suppression_exists(integer, integer); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.hint_suppression_exists(_pk_identity integer, _pk_hint integer, OUT _o_exists boolean, OUT _o_md5 text, OUT _o_rationale text) RETURNS record
    LANGUAGE plpgsql
    AS $$
--DECLARE
--	_md5_suppressed text;
--	_old_rationale4suppression text;
BEGIN
	SELECT
		md5_sum,
		rationale
			INTO
		_o_md5,
		_o_rationale
	FROM clin.suppressed_hint WHERE
		fk_hint = _pk_hint
			AND
		fk_encounter IN (
			SELECT pk FROM clin.encounter WHERE fk_patient = _pk_identity
		);
	IF FOUND THEN
		_o_exists := TRUE;
	ELSE
		_o_exists := FALSE;
	END IF;
END;$$;


ALTER FUNCTION clin.hint_suppression_exists(_pk_identity integer, _pk_hint integer, OUT _o_exists boolean, OUT _o_md5 text, OUT _o_rationale text) OWNER TO "gm-dbo";

--
-- Name: move_waiting_list_entry(integer, integer); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.move_waiting_list_entry(_wl_pos_src integer, _wl_pos_dest integer) RETURNS boolean
    LANGUAGE plpgsql
    AS $$
DECLARE
	_tmp_pos integer;
	_curr_max_pos integer;
BEGIN
	if _wl_pos_src = _wl_pos_dest then
		return true;
	end if;
	if _wl_pos_dest < 1 then
		raise notice 'clin.move_waiting_list_entry(): Will not move entry [%] before start of list [%].', _wl_pos_src, _wl_pos_dest;
		return False;
	end if;
	select max(list_position) into _curr_max_pos from clin.waiting_list;
	-- do not move last entry further down
	if _wl_pos_src = _curr_max_pos then
		if _wl_pos_dest > _wl_pos_src then
			raise notice 'clin.move_waiting_list_entry(): Will not move last entry [%] beyond end of list to [%].', _wl_pos_src, _wl_pos_dest;
			return False;
		end if;
	end if;
	-- does the source row exist ?
	perform 1 from clin.waiting_list where list_position = _wl_pos_src;
	if not found then
		raise notice 'clin.move_waiting_list_entry(): Cannot move entry [%] to [%]. Entry does not exist.', _wl_pos_src, _wl_pos_dest ;
		return false;
	end if;
	-- load destination row
	perform 1 from clin.waiting_list where list_position = _wl_pos_dest;
	-- does not exist
	if not found then
		-- do not move entry beyond end of list more than necessary
		if _wl_pos_dest > (_curr_max_pos + 1) then
			_tmp_pos := _curr_max_pos + 1;
		else
			_tmp_pos := _wl_pos_dest;
		end if;
		-- so update row to move and be done with it
		update clin.waiting_list
			set list_position = _tmp_pos
			where list_position = _wl_pos_src;
		return true;
	end if;
	-- move existing row out of the way
	select (max(list_position) + _wl_pos_dest + _wl_pos_src) into _tmp_pos from clin.waiting_list;
	update clin.waiting_list
		set list_position = _tmp_pos
		where list_position = _wl_pos_dest;
	-- move row to move
	update clin.waiting_list
		set list_position = _wl_pos_dest
		where list_position = _wl_pos_src;
	-- move back existing row
	update clin.waiting_list
		set list_position = _wl_pos_src
		where list_position = _tmp_pos;
	return true;
END;$$;


ALTER FUNCTION clin.move_waiting_list_entry(_wl_pos_src integer, _wl_pos_dest integer) OWNER TO "gm-dbo";

--
-- Name: FUNCTION move_waiting_list_entry(_wl_pos_src integer, _wl_pos_dest integer); Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON FUNCTION clin.move_waiting_list_entry(_wl_pos_src integer, _wl_pos_dest integer) IS 'Move row with logical position $1 into logical position $2. If another row
 exists with position $2 it will be moved to position $1 in the process.
 Fails if there is no row with position $1.';


--
-- Name: remove_old_empty_encounters(integer); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.remove_old_empty_encounters(integer) RETURNS boolean
    LANGUAGE sql
    AS $_$select clin.remove_old_empty_encounters($1, '1 week'::interval);$_$;


ALTER FUNCTION clin.remove_old_empty_encounters(integer) OWNER TO "gm-dbo";

--
-- Name: FUNCTION remove_old_empty_encounters(integer); Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON FUNCTION clin.remove_old_empty_encounters(integer) IS 'Remove empty encounters older than 1 week from a patient.';


--
-- Name: remove_old_empty_encounters(integer, interval); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.remove_old_empty_encounters(integer, interval) RETURNS boolean
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
	_pk_identity alias for $1;
	_defined_minimum_encounter_age alias for $2;
	_usable_minimum_encounter_age interval;
	_no_of_encounters integer;
BEGIN
	-- does person exist ?
	perform 1 from dem.identity where pk = _pk_identity;
	if not found then
		raise exception 'clin.remove_old_empty_encounters(person=%, min_age=%): person [%] does not exist', _pk_identity, _defined_minimum_encounter_age, _pk_identity;
		return false;
	end if;
	SELECT count(1) INTO STRICT _no_of_encounters
	FROM clin.encounter	WHERE fk_patient = _pk_identity;
	IF _no_of_encounters < 2 THEN
		raise notice 'clin.remove_old_empty_encounters(person=%, min_age=%): there are less than 2 encounters for this patient', _pk_identity, _defined_minimum_encounter_age;
		return false;
	END IF;
	if _defined_minimum_encounter_age < '3 days'::interval then
		_usable_minimum_encounter_age := '3 days'::interval;
	else
		_usable_minimum_encounter_age := _defined_minimum_encounter_age;
	end if;
	DELETE FROM clin.encounter WHERE
		clin.encounter.fk_patient = _pk_identity
			AND
		-- is this the active encounter somewhere ?
		(SELECT pg_try_advisory_lock('clin.encounter'::regclass::oid::int, clin.encounter.pk))
			AND
		age(clin.encounter.last_affirmed) > _usable_minimum_encounter_age
			AND
		NOT EXISTS (SELECT 1 FROM clin.clin_root_item WHERE fk_encounter = clin.encounter.pk)
			AND
		NOT EXISTS (SELECT 1 FROM blobs.doc_med WHERE fk_encounter = clin.encounter.pk)
			AND
		NOT EXISTS (SELECT 1 FROM clin.episode WHERE fk_encounter = clin.encounter.pk)
			AND
		NOT EXISTS (SELECT 1 FROM clin.health_issue WHERE fk_encounter = clin.encounter.pk)
			AND
		NOT EXISTS (SELECT 1 FROM clin.allergy_state WHERE fk_encounter = clin.encounter.pk)
			AND
		NOT EXISTS (SELECT 1 FROM bill.bill_item WHERE fk_encounter = clin.encounter.pk)
			AND
		NOT EXISTS (SELECT 1 FROM clin.external_care WHERE fk_encounter = clin.encounter.pk)
			AND
		NOT EXISTS (SELECT 1 FROM clin.suppressed_hint WHERE fk_encounter = clin.encounter.pk)
	;
	RETURN TRUE;
END;$_$;


ALTER FUNCTION clin.remove_old_empty_encounters(integer, interval) OWNER TO "gm-dbo";

--
-- Name: FUNCTION remove_old_empty_encounters(integer, interval); Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON FUNCTION clin.remove_old_empty_encounters(integer, interval) IS 'Remove empty encounters older than a definable minimum age from a patient.';


--
-- Name: run_hint_query(text, text); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.run_hint_query(_title text, _query text, OUT _o_applies boolean, OUT _o_title text) RETURNS record
    LANGUAGE plpgsql
    AS $$
BEGIN
	BEGIN
		EXECUTE _query INTO STRICT _o_applies;
	EXCEPTION
		--WHEN insufficient_privilege THEN RAISE WARNING 'auto hint query failed: %', _query;
		WHEN others THEN
			RAISE WARNING 'auto hint query failed: %', _query;
			-- only available starting with PG 9.2:
			--GET STACKED DIAGNOSTICS
			--	_exc_state = RETURNED_SQLSTATE,
			--	_exc_msg = MESSAGE_TEXT,
			--	_exc_detail = PG_EXCEPTION_DETAIL,
			--	_exc_hint = PG_EXCEPTION_HINT,
			--	_exc_context = PG_EXCEPTION_CONTEXT;
			--RAISE WARNING 'SQL STATE: %', _exc_state;
			--RAISE WARNING 'MESSAGE: %', _exc_msg;
			--RAISE WARNING 'DETAIL: %', _exc_detail;
			--RAISE WARNING 'HINT: %', _exc_hint;
			--RAISE WARNING 'CONTEXT: %', _exc_context;
			-- workaround for 9.1:
			RAISE WARNING 'SQL STATE: %', SQLSTATE;
			RAISE WARNING 'MESSAGE: %', SQLERRM;
			_o_applies := NULL;
			_o_title := ('ERROR checking for [' || _title || '] !')::TEXT;
			RETURN;
	END;
	_o_title := _title;
END;$$;


ALTER FUNCTION clin.run_hint_query(_title text, _query text, OUT _o_applies boolean, OUT _o_title text) OWNER TO "gm-dbo";

--
-- Name: transfer_all_encounter_data(integer, integer); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.transfer_all_encounter_data(_pk_source_encounter integer, _pk_target_encounter integer) RETURNS boolean
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
	_fk_row record;
	_success boolean;
BEGIN
	-- same patient on both encounters ?
	SELECT (
		coalesce((select fk_patient from clin.encounter where pk = _pk_source_encounter), -1)
			=
		coalesce((select fk_patient from clin.encounter where pk = _pk_target_encounter), -2)
	) INTO strict _success;
	IF _success IS FALSE THEN
		RAISE NOTICE 'source encounter (%) belongs to a patient different from target encounter (%), aborting', _pk_source_encounter, _pk_target_encounter;
		RETURN FALSE;
	END IF;
	-- loop over foreign keys in non-clin.* tables
	FOR _fk_row IN
		SELECT
			conrelid::pg_catalog.regclass
				as referencing_table,
			(select attname from pg_attribute where attnum = pg_c.conkey[1] and attrelid = pg_c.conrelid) as referencing_column
		FROM
			pg_catalog.pg_constraint pg_c
		WHERE
			pg_c.confrelid = 'clin.encounter'::pg_catalog.regclass
				AND
			pg_c.contype = 'f'
				AND
			position('clin.'::text in pg_c.conrelid::pg_catalog.regclass::text) = 0
	LOOP
		EXECUTE format (
			'UPDATE %1$s SET %2$I = %3$L WHERE %2$I = %4$L',
				_fk_row.referencing_table,
				_fk_row.referencing_column,
				_pk_target_encounter,
				_pk_source_encounter
		);
	END LOOP;
	-- update clin.clin_root_item children in one go
	UPDATE clin.clin_root_item SET fk_encounter = _pk_target_encounter WHERE fk_encounter = _pk_source_encounter;
	return TRUE;
END;$_$;


ALTER FUNCTION clin.transfer_all_encounter_data(_pk_source_encounter integer, _pk_target_encounter integer) OWNER TO "gm-dbo";

--
-- Name: FUNCTION transfer_all_encounter_data(_pk_source_encounter integer, _pk_target_encounter integer); Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON FUNCTION clin.transfer_all_encounter_data(_pk_source_encounter integer, _pk_target_encounter integer) IS 'transfers all data linked to _pk_source_encounter into _pk_target_encounter';


--
-- Name: trf_activate_issue_on_opening_episode(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_activate_issue_on_opening_episode() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
begin
	if TG_OP = 'UPDATE' then
		if OLD.is_open is TRUE then
			return NEW;
		end if;
	end if;
	update clin.health_issue
	set is_active = TRUE
	where
		pk = NEW.fk_health_issue
			AND
		is_active is FALSE
	;
	return NEW;
end;$$;


ALTER FUNCTION clin.trf_activate_issue_on_opening_episode() OWNER TO "gm-dbo";

--
-- Name: trf_announce_active_substance_mod_no_pk(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_announce_active_substance_mod_no_pk() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
begin
	execute 'notify "active_substance_mod_db:"';
	return NULL;
end;
$$;


ALTER FUNCTION clin.trf_announce_active_substance_mod_no_pk() OWNER TO "gm-dbo";

--
-- Name: trf_announce_consumed_substance_mod_no_pk(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_announce_consumed_substance_mod_no_pk() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
begin
	execute 'notify "consumed_substance_mod_db:"';
	return NULL;
end;
$$;


ALTER FUNCTION clin.trf_announce_consumed_substance_mod_no_pk() OWNER TO "gm-dbo";

--
-- Name: trf_check_ext_care_uniq_issue_per_enc_and_unit_ins_upd(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_check_ext_care_uniq_issue_per_enc_and_unit_ins_upd() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_issue_count integer;
BEGIN
	SELECT COUNT(1) INTO STRICT _issue_count
	FROM clin.external_care
	WHERE
		issue = NEW.issue
			AND
		fk_org_unit = NEW.fk_org_unit
			AND
		fk_encounter IN (
			SELECT pk FROM clin.encounter WHERE fk_patient = (
				SELECT fk_patient FROM clin.encounter WHERE pk = NEW.fk_encounter
			)
		)
	;
	IF _issue_count > 1 THEN
		RAISE EXCEPTION '% into clin.external_care: Sanity check failed. Cannot insert issue [%] more than once for patient of encounter [%] at org unit [%].',
			TG_OP,
			NEW.issue,
			NEW.fk_encounter,
			NEW.fk_org_unit
			USING ERRCODE = 'check_violation';
		return NULL;
	END IF;
	RETURN NEW;
END;
$$;


ALTER FUNCTION clin.trf_check_ext_care_uniq_issue_per_enc_and_unit_ins_upd() OWNER TO "gm-dbo";

--
-- Name: trf_del_intake_document_deleted(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_del_intake_document_deleted() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_row record;
	_pk_episode integer;
BEGIN
	select
		* into _row
	from
		clin.v_substance_intake_journal
	where
		src_pk = OLD.pk;
	_pk_episode := _row.pk_episode;
	-- create episode if needed
	if _pk_episode is null then
		select pk into _pk_episode
		from clin.episode
		where
			description = _('Medication history')
				and
			fk_encounter in (
				select pk from clin.encounter where fk_patient = _row.pk_patient
			);
		if not found then
			insert into clin.episode (
				description,
				is_open,
				fk_encounter
			) values (
				_('Medication history'),
				FALSE,
				OLD.fk_encounter
			) returning pk into _pk_episode;
		end if;
	end if;
	insert into clin.clin_narrative (
		fk_encounter,
		fk_episode,
		soap_cat,
		narrative
	) values (
		_row.pk_encounter,
		_pk_episode,
		NULL,
		_('Deletion of') || ' ' || _row.narrative
	);
	return OLD;
END;$$;


ALTER FUNCTION clin.trf_del_intake_document_deleted() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_del_intake_document_deleted(); Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON FUNCTION clin.trf_del_intake_document_deleted() IS 'Document the deletion of a substance intake.';


--
-- Name: trf_del_intake_must_unlink_all_drug_components(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_del_intake_must_unlink_all_drug_components() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_pk_drug_product integer;
	_component_count integer;
	_pk_patient integer;
	_intake_count integer;
	_msg text;
BEGIN
	-- which drug ?
	select fk_drug_product into _pk_drug_product
	from ref.lnk_dose2drug
	where pk = OLD.fk_drug_component;
	-- how many components therein ?
	select count(1) into _component_count
	from ref.lnk_dose2drug
	where fk_drug_product = _pk_drug_product;
	-- only one component anyways ?
	if _component_count = 1 then
		return NULL;
	end if;
	-- retrieve patient
	select fk_patient into _pk_patient
	from clin.encounter
	where pk = OLD.fk_encounter;
	-- how many intakes of this drug are linked to this patient
	select count(1) into _intake_count
	from clin.substance_intake
	where
		fk_drug_component in (
			select pk from ref.lnk_dose2drug where fk_drug_product = _pk_drug_product
		)
			and
		fk_encounter in (
			select pk from clin.encounter where fk_patient = _pk_patient
		);
	-- intake count must be 0
	if _intake_count = 0 then
		return NULL;
	end if;
	_msg := '[clin.trf_del_intake_must_unlink_all_drug_components]: deleting a multi-component intake ['
		|| OLD.pk || '] must unlink all components of the drug product ['
		|| _pk_drug_product || '] '
		|| '(unlinked component [' || OLD.fk_drug_component || '])';
	raise exception check_violation using message = _msg;
	return NULL;
END;$$;


ALTER FUNCTION clin.trf_del_intake_must_unlink_all_drug_components() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_del_intake_must_unlink_all_drug_components(); Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON FUNCTION clin.trf_del_intake_must_unlink_all_drug_components() IS 'If a multi-component drug intake is deleted from a patient ALL components thereof must be unlinked.';


--
-- Name: trf_ensure_one_allergy_state_per_patient(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_ensure_one_allergy_state_per_patient() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
declare
	_new_pk_patient integer;
	_old_pk_patient integer;
begin
	-- find patient from encounter
	select into _new_pk_patient fk_patient
		from clin.encounter
		where pk = NEW.fk_encounter;
	if not FOUND then
		raise exception 'Encounter % does not exist !?', NEW.fk_encounter;
		return NEW;
	end if;
	-- new row
	if TG_OP = 'INSERT' then
		-- patient already there ?
		perform 1 from clin.allergy_state
		where
			fk_encounter in (select pk from clin.encounter where fk_patient = _new_pk_patient);
		if FOUND then
			raise exception 'Cannot insert second allergy state for patient % via encounter %.', _new_pk_patient, NEW.fk_encounter;
			return NEW;
		end if;
		return NEW;
	end if;
	if TG_OP = 'UPDATE' then
		if NEW.fk_encounter = OLD.fk_encounter then
			return NEW;
		end if;
		select into _old_pk_patient fk_patient
			from clin.encounter
			where pk = OLD.fk_encounter;
		if _new_pk_patient = _old_pk_patient then
			return NEW;
		end if;
		raise exception 'Invalid fk_encounter update (% -> %): it would change the associated patient (% -> %).', OLD.fk_encounter, NEW.fk_encounter, _old_pk_patient, _new_pk_patient;
		return NEW;
	end if;
	return NEW;
end;$$;


ALTER FUNCTION clin.trf_ensure_one_allergy_state_per_patient() OWNER TO "gm-dbo";

--
-- Name: trf_ins_intake_prevent_duplicate_component_links(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_ins_intake_prevent_duplicate_component_links() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_pk_patient integer;
	_pk_intake integer;
	_msg text;
BEGIN
	-- which patient ?
	select fk_patient into _pk_patient
	from clin.encounter
	where pk = NEW.fk_encounter;
	-- already exists ?
	select pk into _pk_intake
	from clin.substance_intake
	where
		fk_encounter in (
			select pk from clin.encounter where fk_patient = _pk_patient
		)
			and
		fk_drug_component = NEW.fk_drug_component
	;
	if FOUND then
		_msg := '[clin.trf_ins_intake_prevent_duplicate_component_links]: drug component ref.lnk_dose2drug.pk=(' || NEW.fk_drug_component || ') '
			|| 'already linked to patient=(' || _pk_patient || ') '
			|| 'as clin.substance_intake.pk=(' || _pk_intake || ')';
		raise exception unique_violation using message = _msg;
	end if;
	return NEW;
END;$$;


ALTER FUNCTION clin.trf_ins_intake_prevent_duplicate_component_links() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_ins_intake_prevent_duplicate_component_links(); Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON FUNCTION clin.trf_ins_intake_prevent_duplicate_component_links() IS 'Prevent patient from being put on a particular component twice.';


--
-- Name: trf_ins_lc2sth_fk_generic_code(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_ins_lc2sth_fk_generic_code() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_msg text;
BEGIN
	perform 1 from ref.coding_system_root where pk_coding_system = NEW.fk_generic_code;
	if FOUND then
		return NEW;
	end if;
	_msg := 'clin.trf_ins_lc2sth_fk_generic_code(): INSERT into '
		|| TG_TABLE_SCHEMA || '.' || TG_TABLE_NAME || ': '
		|| 'fk_generic_code=(' || NEW.fk_generic_code || ') '
		|| 'does not exist in ref.coding_system_root.pk_coding_system';
	raise foreign_key_violation using message = _msg;
	return NEW;
END;$$;


ALTER FUNCTION clin.trf_ins_lc2sth_fk_generic_code() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_ins_lc2sth_fk_generic_code(); Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON FUNCTION clin.trf_ins_lc2sth_fk_generic_code() IS 'Check foreign key integrity on insert to *.fk_generic_code -> ref.coding_system_root.pk_coding_system.';


--
-- Name: trf_ins_upd_export_item_normalize_fk_identity(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_ins_upd_export_item_normalize_fk_identity() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
	SELECT fk_patient INTO STRICT NEW.fk_identity
	FROM clin.encounter
	WHERE
		pk = (
			SELECT fk_encounter FROM blobs.doc_med WHERE pk = (
				SELECT fk_doc FROM blobs.doc_obj WHERE pk = NEW.fk_doc_obj
			)
		)
	;
	RETURN NEW;
END;$$;


ALTER FUNCTION clin.trf_ins_upd_export_item_normalize_fk_identity() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_ins_upd_export_item_normalize_fk_identity(); Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON FUNCTION clin.trf_ins_upd_export_item_normalize_fk_identity() IS 'Set .fk_identity from .fk_doc if .fk_doc is NOT NULL';


--
-- Name: trf_insert_intake_links_all_drug_components(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_insert_intake_links_all_drug_components() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_component_count integer;
	_pk_patient integer;
	_pk_drug_product integer;
	_pk_component integer;
BEGIN
	-- get the product we are linking to
	select fk_drug_product into _pk_drug_product
	from ref.lnk_dose2drug
	where pk = NEW.fk_drug_component;
	-- how many components therein ?
	select count(1) into _component_count
	from ref.lnk_dose2drug
	where fk_drug_product = _pk_drug_product;
	-- only one component ?
	if _component_count = 1 then
		return NEW;
	end if;
	-- which patient ?
	select fk_patient into _pk_patient
	from clin.encounter
	where pk = NEW.fk_encounter;
	-- INSERT all components
	for _pk_component in
		select pk from ref.lnk_dose2drug where fk_drug_product = _pk_drug_product
	loop
		-- already there ?
		perform 1 from clin.substance_intake where
			fk_encounter in (
				select pk from clin.encounter where fk_patient = _pk_patient
			)
				and
			fk_drug_component = _pk_component
		;
		if FOUND then
			continue;
		end if;
		-- insert
		insert into clin.substance_intake (
			fk_drug_component,				-- differentiate
			clin_when,						-- harmonize (started)
			fk_encounter,					-- harmonize
			fk_episode,						-- required
			soap_cat,						-- harmonize
			schedule,						-- harmonize
			duration,						-- harmonize
			intake_is_approved_of,			-- harmonize
			is_long_term,					-- harmonize
			discontinued,					-- harmonize
			narrative,
			aim,
			discontinue_reason,
			comment_on_start,
			harmful_use_type
		) values (
			_pk_component,
			NEW.clin_when,
			NEW.fk_encounter,
			NEW.fk_episode,
			NEW.soap_cat,
			NEW.schedule,
			NEW.duration,
			NEW.intake_is_approved_of,
			NEW.is_long_term,
			NEW.discontinued,
			NEW.narrative,
			NEW.aim,
			NEW.discontinue_reason,
			NEW.comment_on_start,
			NEW.harmful_use_type
		);
	end loop;
	return NEW;
END;$$;


ALTER FUNCTION clin.trf_insert_intake_links_all_drug_components() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_insert_intake_links_all_drug_components(); Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON FUNCTION clin.trf_insert_intake_links_all_drug_components() IS 'If a patient is put on a multi-component drug they must be put on ALL components thereof.';


--
-- Name: trf_invalidate_review_on_result_change(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_invalidate_review_on_result_change() RETURNS trigger
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
DECLARE
	is_modified bool;
BEGIN
	is_modified := False;
	-- change of test type
	if NEW.fk_type != OLD.fk_type then
		is_modified := True;
	end if;
	-- change of numeric value
	if NEW.val_num != OLD.val_num then
		is_modified := True;
	end if;
	-- change of alpha value
	if NEW.val_alpha != OLD.val_alpha then
		is_modified := True;
	end if;
	-- change of unit
	if NEW.val_unit != OLD.val_unit then
		is_modified := True;
	end if;
	if is_modified is True then
		delete from clin.reviewed_test_results where fk_reviewed_row = OLD.pk;
	end if;
	return NEW;
END;$$;


ALTER FUNCTION clin.trf_invalidate_review_on_result_change() OWNER TO "gm-dbo";

--
-- Name: trf_normalize_proc_is_ongoing(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_normalize_proc_is_ongoing() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
	if NEW.clin_end > clock_timestamp() then
		NEW.is_ongoing := TRUE;
	else
		NEW.is_ongoing := FALSE;
	end if;
	return NEW;
END;$$;


ALTER FUNCTION clin.trf_normalize_proc_is_ongoing() OWNER TO "gm-dbo";

--
-- Name: trf_notify_reviewer_of_review_change(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_notify_reviewer_of_review_change() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
declare
	_pk_patient integer;
	_pk_type integer;
begin
	-- disallow change of referenced row
	-- for cleanliness this really *should* be in another trigger
	if NEW.fk_reviewed_row <> OLD.fk_reviewed_row then
		raise exception 'Attaching an existing review to another test result is not allowed (fk_reviewed_row change).';
		return NEW;
	end if;
	-- change of last reviewer ?
	if NEW.fk_reviewer = OLD.fk_reviewer then
		return NEW;
	end if;
	-- review change ?
	if (NEW.is_technically_abnormal <> OLD.is_technically_abnormal) or
	   (NEW.clinically_relevant <> OLD.clinically_relevant) then
		-- find patient for test result
		select pk_patient into _pk_patient
			from clin.v_test_results
			where pk_test_result = OLD.fk_reviewed_row;
		-- find inbox item type
		select pk_type into _pk_type
			from dem.v_inbox_item_type where
			type = 'results review change';
		-- create it if necessary
		if not found then
			insert into dem.inbox_item_type (
				fk_inbox_item_category,
				description
			) values (
				(select pk from dem.inbox_item_category where description = 'clinical'),
				'results review change'
			);
			select pk_type into _pk_type
				from dem.v_inbox_item_type where
				type = 'results review change';
		end if;
		-- already notified ?
		perform 1 from dem.message_inbox where
			fk_staff = OLD.fk_reviewer
			and fk_inbox_item_type = _pk_type
			and ufk_context = ARRAY[_pk_patient];
		-- nope, so notify now
		if not found then
			insert into dem.message_inbox (
				fk_staff, fk_inbox_item_type, comment, ufk_context
			) values (
				OLD.fk_reviewer,
				_pk_type,
				(select
					_('results review changed for patient') || ' [' || vpb.lastnames || ', ' || vbp.firstnames || ']'
					from dem.v_basic_person vbp
					where vpb.pk_identity = _pk_patient
				),
				ARRAY[_pk_patient]
			);
		end if;
	end if;
	return NEW;
end;$$;


ALTER FUNCTION clin.trf_notify_reviewer_of_review_change() OWNER TO "gm-dbo";

--
-- Name: trf_sanity_check_enc_epi_ins_upd(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_sanity_check_enc_epi_ins_upd() RETURNS trigger
    LANGUAGE plpgsql
    AS $_$
declare
	_fk_encounter_col text;
	_enc_pk integer;
	_fk_episode_col text;
	_epi_pk integer;
	_identity_from_encounter integer;
	_identity_from_episode integer;
	_cmd text;
begin
	_fk_encounter_col := TG_ARGV[0];
	_fk_episode_col := TG_ARGV[1];
	_cmd := 'select $1.' || _fk_encounter_col;
	EXECUTE _cmd INTO STRICT _enc_pk USING NEW;
	select fk_patient into _identity_from_encounter from clin.encounter where pk = _enc_pk;
--	raise notice '%: % -> %', _cmd, _enc_pk, _identity_from_encounter;
	_cmd := 'select $1.' || _fk_episode_col;
	EXECUTE _cmd INTO STRICT _epi_pk USING NEW;
	select fk_patient into _identity_from_episode from clin.encounter where pk = (select fk_encounter from clin.episode where pk = _epi_pk);
--	raise notice '%: % -> %', _cmd, _epi_pk, _identity_from_episode;
	if _identity_from_encounter <> _identity_from_episode then
		raise exception '% into %.%: Sanity check failed. %=% -> patient=%. %=% -> patient=%.',
			TG_OP,
			TG_TABLE_SCHEMA,
			TG_TABLE_NAME,
			_fk_encounter_col,
			_enc_pk,
			_identity_from_encounter,
			_fk_episode_col,
			_epi_pk,
			_identity_from_episode
		;
		return NULL;
	end if;
	return NEW;
end;
$_$;


ALTER FUNCTION clin.trf_sanity_check_enc_epi_ins_upd() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_sanity_check_enc_epi_ins_upd(); Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON FUNCTION clin.trf_sanity_check_enc_epi_ins_upd() IS 'this function is used in triggers and checks whether foreign keys to clin.episode.pk and clin.encounter.pk on a single table ultimately point to the same patient';


--
-- Name: trf_sanity_check_enc_issue_ins_upd(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_sanity_check_enc_issue_ins_upd() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
declare
	_enc_pk integer;
	_epi_pk integer;
	_identity_from_encounter integer;
	_identity_from_issue integer;
	_cmd text;
begin
	select fk_patient into _identity_from_encounter from clin.encounter where pk = NEW.fk_encounter;
--	raise notice '%: % -> %', _cmd, _enc_pk, _identity_from_encounter;
	select fk_patient into _identity_from_issue
	from clin.encounter where pk = (
		select fk_encounter from clin.health_issue where pk = NEW.fk_health_issue
	);
	IF _identity_from_encounter <> _identity_from_issue THEN
		RAISE EXCEPTION '% into clin.external_care: Sanity check failed. fk_encounter=% -> patient=%. fk_health_issue=% -> patient=%.',
			TG_OP,
			NEW.fk_encounter,
			_identity_from_encounter,
			NEW.fk_health_issue,
			_identity_from_issue
			USING ERRCODE = 'check_violation'
		;
		return NULL;
	END IF;
	return NEW;
end;
$$;


ALTER FUNCTION clin.trf_sanity_check_enc_issue_ins_upd() OWNER TO "gm-dbo";

--
-- Name: trf_sanity_check_enc_vs_issue_on_epi(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_sanity_check_enc_vs_issue_on_epi() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
declare
	_identity_from_encounter integer;
	_identity_from_issue integer;
begin
	-- if issue is NULL, do not worry about mismatch
	if NEW.fk_health_issue is NULL then
		return NEW;
	end if;
	-- .fk_episode must belong to the same patient as .fk_encounter
	select fk_patient into _identity_from_encounter from clin.encounter where pk = NEW.fk_encounter;
	select fk_patient into _identity_from_issue     from clin.encounter where pk = (
		select fk_encounter from clin.health_issue where pk = NEW.fk_health_issue
	);
	if _identity_from_encounter <> _identity_from_issue then
		raise exception 'INSERT/UPDATE into %.%: Sanity check failed. Encounter % patient = %. Issue % patient = %.',
			TG_TABLE_SCHEMA,
			TG_TABLE_NAME,
			NEW.fk_encounter,
			_identity_from_encounter,
			NEW.fk_health_issue,
			_identity_from_issue
		;
		return NULL;
	end if;
	return NEW;
end;$$;


ALTER FUNCTION clin.trf_sanity_check_enc_vs_issue_on_epi() OWNER TO "gm-dbo";

--
-- Name: trf_sanity_check_procedure_episode(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_sanity_check_procedure_episode() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_hospital_stay_episode_pk integer;
BEGIN
	if NEW.fk_hospital_stay is null then
		return NEW;
	end if;
	select into _hospital_stay_episode_pk fk_episode
		from clin.hospital_stay
		where pk = NEW.fk_hospital_stay;
	if NEW.fk_episode = _hospital_stay_episode_pk then
		return NEW;
	end if;
	raise exception '[clin.procedure]: INSERT/UPDATE failed: fk_episode (%) does not match fk_episode (%) behind fk_hospital_stay (%)', NEW.fk_episode, _hospital_stay_episode_pk, NEW.fk_hospital_stay;
	return NEW;
END;$$;


ALTER FUNCTION clin.trf_sanity_check_procedure_episode() OWNER TO "gm-dbo";

--
-- Name: trf_sanity_check_uniq_hint_per_pat_ins_upd(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_sanity_check_uniq_hint_per_pat_ins_upd() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_suppression_count integer;
BEGIN
	-- the count of suppressions for this hint in this patient
	SELECT COUNT(1) INTO STRICT _suppression_count
	FROM clin.suppressed_hint
	WHERE
		fk_hint = NEW.fk_hint
			AND
		fk_encounter IN (
			SELECT pk FROM clin.encounter WHERE fk_patient = (
				SELECT fk_patient FROM clin.encounter WHERE pk = NEW.fk_encounter
			)
		)
	;
	IF _suppression_count > 1 THEN
		RAISE EXCEPTION '% into clin.suppressed_hint: Sanity check failed. Hint [%] suppressed more than once for patient of encounter [%].',
			TG_OP,
			NEW.pk,
			NEW.fk_encounter
			USING ERRCODE = 'check_violation';
		return NULL;
	END IF;
	return NEW;
END;
$$;


ALTER FUNCTION clin.trf_sanity_check_uniq_hint_per_pat_ins_upd() OWNER TO "gm-dbo";

--
-- Name: trf_sync_allergic_state_on_allergies_modified(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_sync_allergic_state_on_allergies_modified() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_fk_patient integer;
	_fk_encounter integer;
	_state integer;
	_no_of_allergies integer;
BEGIN
	if TG_OP = 'INSERT' then
		select into _fk_patient fk_patient from clin.encounter where pk = NEW.fk_encounter;
		_fk_encounter := NEW.fk_encounter;
		_state := 1;
	end if;
	if TG_OP = 'DELETE' then
		-- only run this trigger if deleting last allergy
		select into _fk_patient fk_patient from clin.encounter where pk = OLD.fk_encounter;
		select into _no_of_allergies count(1) from clin.allergy where fk_encounter in (
			select pk from clin.encounter where fk_patient = _fk_patient
		);
		if _no_of_allergies > 1 then
			return OLD;		-- still allergies left
		end if;
		_fk_encounter := OLD.fk_encounter;
		_state := 0;
	end if;
	update clin.allergy_state
		set
			has_allergy = _state,
			last_confirmed = coalesce(last_confirmed, now())
		where fk_encounter in (
			select pk from clin.encounter where fk_patient = _fk_patient
		);
	if not FOUND then
		insert into clin.allergy_state
			(fk_encounter, has_allergy, last_confirmed)
		values
			(_fk_encounter, _state, now());
	end if;
	return NEW;
END;$$;


ALTER FUNCTION clin.trf_sync_allergic_state_on_allergies_modified() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_sync_allergic_state_on_allergies_modified(); Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON FUNCTION clin.trf_sync_allergic_state_on_allergies_modified() IS 'trigger function to sync the allergy state on insert/delete';


--
-- Name: trf_undiscontinue_unsets_reason(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_undiscontinue_unsets_reason() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
declare
	_identity_from_encounter integer;
	_identity_from_issue integer;
begin
	if NEW.discontinued is NULL then
		NEW.discontinue_reason := NULL;
	end if;
	return NEW;
end;$$;


ALTER FUNCTION clin.trf_undiscontinue_unsets_reason() OWNER TO "gm-dbo";

--
-- Name: trf_unique_indication_in_schedule(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_unique_indication_in_schedule() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_msg text;
BEGIN
	-- is the indication already linked ?
	perform 1 from clin.v_vaccination_courses_in_schedule where
		pk_vaccination_schedule = NEW.fk_schedule and
		pk_indication = (select fk_indication from clin.vaccination_course where pk=NEW.fk_course);
	if FOUND then
		_msg := 'Cannot link course [' || NEW.fk_course || '] into schedule [' || NEW.fk_schedule || ']. The indication is already linked.';
		raise exception '%', _msg;
		return null;
	end if;
	return null;
END;$$;


ALTER FUNCTION clin.trf_unique_indication_in_schedule() OWNER TO "gm-dbo";

--
-- Name: trf_upd_intake_must_link_all_drug_components(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_upd_intake_must_link_all_drug_components() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_intake_count integer;
	_component_count integer;
	_pk_patient integer;
	_pk_drug_product integer;
	_msg text;
BEGIN
	select fk_patient into _pk_patient
	from clin.encounter
	where pk = NEW.fk_encounter;
	-- get the drug product we were linking to
	select fk_drug_product into _pk_drug_product
	from ref.lnk_dose2drug
	where pk = OLD.fk_drug_component;
	-- How many substance intake links for this drug have we got ?
	select count(1) into _intake_count
	from clin.substance_intake
	where
		fk_drug_component in (
			select pk from ref.lnk_dose2drug where fk_drug_product = _pk_drug_product
		)
			and
		fk_encounter in (
			select pk from clin.encounter where fk_patient = _pk_patient
		);
	-- unlinking completely would be fine but else:
	if _intake_count != 0 then
		-- How many components *are* there in the drug in question ?
		select count(1) into _component_count
		from ref.lnk_dose2drug
		where fk_drug_product = _pk_drug_product;
		-- substance intake link count and number of components must match
		if _component_count != _intake_count then
			_msg := '[clin.trf_upd_intake_must_link_all_drug_components]: re-linking drug product must unlink all components of old drug product [' || _pk_drug_product || '] '
				|| '(component [' || OLD.fk_drug_component || ' -> ' || NEW.fk_drug_component || '])';
			raise exception check_violation using message = _msg;
		end if;
	end if;
	-- check the NEW drug product
	-- get the drug product we are linking to
	select fk_drug_product into _pk_drug_product
	from ref.lnk_dose2drug
	where fk_substance = NEW.fk_drug_component;
	-- How many substance intake links for this drug have we got ?
	select count(1) into _intake_count
	from clin.substance_intake
	where
		fk_drug_component in (
			select pk from ref.lnk_dose2drug where fk_drug_product = _pk_drug_product
		)
			and
		fk_encounter in (
			select pk from clin.encounter where fk_patient = _pk_patient
		);
	-- linking all is fine but else:
	if _intake_count != 0 then
		-- How many components *are* there in the drug in question ?
		select count(1) into _component_count
		from ref.lnk_dose2drug
		where fk_drug_product = _pk_drug_product;
		-- substance intake link count and number of components must match
		if _component_count != _intake_count then
			_msg := '[clin.trf_upd_intake_must_link_all_drug_components]: re-linking drug product must link all components of new drug product [' || _pk_drug_product || '] '
				|| '(component [' || OLD.fk_drug_component || ' -> ' || NEW.fk_drug_component || '])';
			raise exception check_violation using message = _msg;
		end if;
	end if;
	return NEW;
END;$$;


ALTER FUNCTION clin.trf_upd_intake_must_link_all_drug_components() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_upd_intake_must_link_all_drug_components(); Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON FUNCTION clin.trf_upd_intake_must_link_all_drug_components() IS 'If a patient is put on a different multi-component drug ALL components thereof must be updated.';


--
-- Name: trf_upd_intake_prevent_duplicate_component_links(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_upd_intake_prevent_duplicate_component_links() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_pk_patient integer;
	_intake_count integer;
	_msg text;
BEGIN
	-- which patient ?
	select fk_patient into _pk_patient
	from clin.encounter
	where pk = NEW.fk_encounter;
	-- already exists ?
	select count(1) into strict _intake_count
	from clin.substance_intake
	where
		fk_encounter in (
			select pk from clin.encounter where fk_patient = _pk_patient
		)
			and
		fk_drug_component = NEW.fk_drug_component
	;
	if _intake_count > 1 then
		_msg := '[clin.trf_upd_intake_prevent_duplicate_component_links]: drug component ref.lnk_dose2drug.pk=(' || NEW.fk_drug_component || ') '
			|| 'already linked to patient=(' || _pk_patient || ') as clin.substance_intake';
		raise exception unique_violation using message = _msg;
	end if;
	return NEW;
END;$$;


ALTER FUNCTION clin.trf_upd_intake_prevent_duplicate_component_links() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_upd_intake_prevent_duplicate_component_links(); Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON FUNCTION clin.trf_upd_intake_prevent_duplicate_component_links() IS 'Prevent patient from being put on a particular component twice.';


--
-- Name: trf_upd_intake_updates_all_drug_components(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_upd_intake_updates_all_drug_components() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_pk_drug_product integer;
	_component_count integer;
	_pk_patient integer;
BEGIN
	-- which drug ?
	select fk_drug_product into _pk_drug_product
	from ref.lnk_dose2drug
	where pk = NEW.fk_drug_component;
	-- how many components therein ?
	select count(1) into _component_count
	from ref.lnk_dose2drug
	where fk_drug_product = _pk_drug_product;
	-- only one component ?
	if _component_count = 1 then
		return NEW;
	end if;
	-- which patient ?
	select fk_patient into _pk_patient
	from clin.encounter
	where pk = NEW.fk_encounter;
	-- update all substance instake fields shared by drug components ...
	update clin.substance_intake set
		clin_when = NEW.clin_when,				-- started
		fk_encounter = NEW.fk_encounter,
		soap_cat = NEW.soap_cat,
		schedule = NEW.schedule,
		duration = NEW.duration,
		intake_is_approved_of = NEW.intake_is_approved_of,
		is_long_term = NEW.is_long_term,
		discontinued = NEW.discontinued,
		discontinue_reason = NEW.discontinue_reason,
		comment_on_start = NEW.comment_on_start,
		harmful_use_type = NEW.harmful_use_type
	where
		-- ... which belong to this drug ...
		fk_drug_component in (
			select pk from ref.lnk_dose2drug where fk_drug_product = _pk_drug_product
		)
			AND
		-- ... but are not THIS component ...
		fk_drug_component != NEW.fk_drug_component
			AND
		-- ... this patient ...
		fk_encounter in (
			select pk from clin.encounter where fk_patient = _pk_patient
		)
			AND
		-- ... are different in value (this will stop recursion as soon as all are equal)
		(
			clin_when is distinct from NEW.clin_when
				OR
			fk_encounter is distinct from NEW.fk_encounter
				OR
			soap_cat is distinct from NEW.soap_cat
				OR
			schedule is distinct from NEW.schedule
				OR
			duration is distinct from NEW.duration
				OR
			intake_is_approved_of is distinct from NEW.intake_is_approved_of
				OR
			is_long_term is distinct from NEW.is_long_term
				OR
			discontinued is distinct from NEW.discontinued
				OR
			discontinue_reason is distinct from NEW.discontinue_reason
				OR
			comment_on_start is distinct from NEW.comment_on_start
				OR
			harmful_use_type is distinct from NEW.harmful_use_type
		)
	;
	return NEW;
END;$$;


ALTER FUNCTION clin.trf_upd_intake_updates_all_drug_components() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_upd_intake_updates_all_drug_components(); Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON FUNCTION clin.trf_upd_intake_updates_all_drug_components() IS 'If a drug component substance intake is updated all sibling components must receive some values thereof.';


--
-- Name: trf_upd_lc2sth_fk_generic_code(); Type: FUNCTION; Schema: clin; Owner: gm-dbo
--

CREATE FUNCTION clin.trf_upd_lc2sth_fk_generic_code() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_msg text;
BEGIN
	perform 1 from ref.coding_system_root where pk_coding_system = NEW.fk_generic_code;
	if FOUND then
		return NEW;
	end if;
	_msg := 'clin.trf_upd_lc2sth_fk_generic_code(): UPDATE of '
		|| TG_TABLE_SCHEMA || '.' || TG_TABLE_NAME || ': '
		|| 'fk_generic_code=(' || NEW.fk_generic_code || ') '
		|| 'does not exist in ref.coding_system_root.pk_coding_system, '
		|| 'old fk_generic_code=(' || OLD.fk_generic_code || ')';
	raise foreign_key_violation using message = _msg;
	return OLD;
END;$$;


ALTER FUNCTION clin.trf_upd_lc2sth_fk_generic_code() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_upd_lc2sth_fk_generic_code(); Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON FUNCTION clin.trf_upd_lc2sth_fk_generic_code() IS 'Check foreign key integrity on update of *.fk_generic_code -> ref.coding_system_root.pk_coding_system.';


--
-- Name: add_external_id_type(text, text); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.add_external_id_type(text, text) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
declare
	_name alias for $1;
	_issuer alias for $2;
	_pk int;
begin
	select pk into _pk from dem.enum_ext_id_types where name = _name and issuer = _issuer;
	if FOUND then
		return _pk;
	end if;
	insert into dem.enum_ext_id_types(name, issuer) values (_name, _issuer);
	select currval(pg_get_serial_sequence('dem.enum_ext_id_types', 'pk')) into _pk;
	return _pk;
end;$_$;


ALTER FUNCTION dem.add_external_id_type(text, text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION add_external_id_type(text, text); Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON FUNCTION dem.add_external_id_type(text, text) IS 'Add an external ID type if it does not exist yet.
	 This implementation is prone to concurrency issues.';


--
-- Name: add_name(integer, text, text, boolean); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.add_name(integer, text, text, boolean) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_id_identity alias for $1;
	_first alias for $2;
	_last alias for $3;
	_active alias for $4;
	_id integer;
BEGIN
    -- deactivate all the existing names if this name is to become active
	if _active then
		update dem.names set active = false where id_identity = _id_identity;
	end if;
	-- name already there for this identity ?
	select into _id id from dem.names where id_identity = _id_identity and firstnames = _first and lastnames = _last;
	if FOUND then
		update dem.names set active = _active where id = _id;
		return _id;
	end if;
	-- no, insert new name
	insert into dem.names (id_identity, firstnames, lastnames, active) values (_id_identity, _first, _last, _active);
	if FOUND then
		return currval('dem.names_id_seq');
	end if;
	return NULL;
END;$_$;


ALTER FUNCTION dem.add_name(integer, text, text, boolean) OWNER TO "gm-dbo";

--
-- Name: address_exists(text, text, text, text, text, text, text); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.address_exists(text, text, text, text, text, text, text) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_code_country alias for $1;
	_code_region alias for $2;
	_urb alias for $3;
	_postcode alias for $4;
	_street alias for $5;
	_number alias for $6;
	_subunit alias for $7;
	__subunit text;
	_pk_address integer;
	msg text;
BEGIN
	if (_code_country || _code_region || _urb || _postcode || _street || _number) is NULL then
		msg := '[dem.address_exists]: insufficient or invalid address definition: '
			|| 'country code <' || coalesce(_code_country, 'NULL') || '>, '
			|| 'region code <' || coalesce(_code_region, 'NULL') || '>, '
			|| 'urb <' || coalesce(_urb, 'NULL') || '>, '
			|| 'zip <' || coalesce(_postcode, 'NULL') || '>, '
			|| 'street <' || coalesce(_street, 'NULL') || '>, '
			|| 'number <' || coalesce(_number, 'NULL') || '>'
		;
		raise exception '%', msg;
	end if;
	__subunit := nullif(trim(_subunit), '');
	if __subunit is null then
		select
			pk_address into _pk_address
		from
			dem.v_address
		where
			code_country = trim(_code_country)
				and
			code_region = trim(_code_region)
				and
			urb = trim(_urb)
				and
			postcode = trim(_postcode)
				and
			street = trim(_street)
				and
			number = trim(_number)
				and
			subunit is null;
	else
		select
			pk_address into _pk_address
		from
			dem.v_address
		where
			code_country = trim(_code_country)
				and
			code_region = trim(_code_region)
				and
			urb = trim(_urb)
				and
			postcode = trim(_postcode)
				and
			street = trim(_street)
				and
			number = trim(_number)
				and
			subunit = __subunit;
	end if;
	return _pk_address;
END;$_$;


ALTER FUNCTION dem.address_exists(text, text, text, text, text, text, text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION address_exists(text, text, text, text, text, text, text); Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON FUNCTION dem.address_exists(text, text, text, text, text, text, text) IS 'This function checks whether a given address exists in
the database and returns the primary key if found.
It takes the following parameters:
	country code,
	region code,
	urb (location),
	postcode,
	street,
	number,
	subunit (can be NULL)
';


--
-- Name: assert_unique_named_identity(); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.assert_unique_named_identity() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_identity_row record;
	_names_row record;
	_other_identities integer[];
BEGIN
	-- working on dem.identity
	if TG_TABLE_NAME = 'identity' then
		_identity_row := NEW;
		select * into _names_row from dem.names where id_identity = NEW.pk;
	-- working on dem.names
	else
		select * into _identity_row from dem.identity where pk = NEW.id_identity;
		_names_row := NEW;
	end if;
	-- there cannot be any combination of identical
	-- (dob, firstname, lastname, identity.comment)
	-- so, look for clashing rows
	SELECT array_agg(pk_identity) INTO _other_identities FROM
		dem.v_person_names d_vpn
			join dem.identity d_i on (d_i.pk = d_vpn.pk_identity)
	WHERE
		-- same firstname
		d_vpn.firstnames = _names_row.firstnames
			AND
		-- same lastname
		d_vpn.lastnames = _names_row.lastnames
			AND
		-- same gender
		d_i.gender is not distinct from _identity_row.gender
			AND
		-- same dob (day)
		date_trunc('day', d_i.dob) is not distinct from date_trunc('day', _identity_row.dob)
			AND
		-- same discriminator
		d_i.comment is not distinct from _identity_row.comment
			AND
		-- but not the currently updated or inserted row
		d_i.pk != _identity_row.pk
	;
	if coalesce(array_length(_other_identities, 1), 0) > 0 then
		RAISE EXCEPTION
			'[dem.assert_unique_named_identity] % on %.%: More than one person with (firstnames=%), (lastnames=%), (dob=%), (comment=%): % & %',
				TG_OP,
				TG_TABLE_SCHEMA,
				TG_TABLE_NAME,
				_names_row.firstnames,
				_names_row.lastnames,
				_identity_row.dob,
				_identity_row.comment,
				_identity_row.pk,
				_other_identities
			USING ERRCODE = 'unique_violation'
		;
		RETURN NULL;
	end if;
	return NEW;
END;$$;


ALTER FUNCTION dem.assert_unique_named_identity() OWNER TO "gm-dbo";

--
-- Name: FUNCTION assert_unique_named_identity(); Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON FUNCTION dem.assert_unique_named_identity() IS 'Ensures unique(identity.dob, names.firstnames, names.lastnames, identity.comment)';


--
-- Name: create_address(text, text, text, text, text, text, text); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.create_address(text, text, text, text, text, text, text) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_number ALIAS FOR $1;
	_street ALIAS FOR $2;
	_postcode ALIAS FOR $3;
	_urb ALIAS FOR $4;
	_region_code ALIAS FOR $5;
	_country_code ALIAS FOR $6;
	_subunit alias for $7;
	_street_id integer;
	_pk_address integer;
	__subunit text;
	msg text;
BEGIN
	select into _pk_address dem.address_exists (
		_country_code,
		_region_code,
		_urb,
		_postcode,
		_street,
		_number,
		_subunit
	);
	if _pk_address is not null then
		return _pk_address;
	end if;
	-- this either creates dem.street and possible dem.urb rows or
	-- or else it fails (because region and/or country do not exist)
	select into _street_id dem.create_street(_street, _postcode, _urb, _region_code, _country_code);
	-- create address
	__subunit := nullif(trim(_subunit), '');
	insert into dem.address (
		number,
		id_street,
		subunit
	) values (
		_number,
		_street_id,
		__subunit
	)
	returning id
	into _pk_address;
	return _pk_address;
END;$_$;


ALTER FUNCTION dem.create_address(text, text, text, text, text, text, text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION create_address(text, text, text, text, text, text, text); Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON FUNCTION dem.create_address(text, text, text, text, text, text, text) IS 'This function creates an address. It first
checks whether the address already exists.
It takes the following parameters:
	number,
	street,
	postcode,
	urb (location),
	region code,
	country code,
	subunit (can be NULL)
If the country or the region do not exist
in the database, the function fails.
';


--
-- Name: create_comm_type(text); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.create_comm_type(text) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_description alias for $1;
	_pk_type integer;
BEGIN
	select pk into _pk_type from dem.enum_comm_types where _(description) = _description;
	if FOUND then
		return _pk_type;
	end if;
	select pk into _pk_type from dem.enum_comm_types where description = _description;
	if FOUND then
		return _pk_type;
	end if;
	insert into dem.enum_comm_types(description) values (_description);
	select currval(pg_get_serial_sequence('dem.enum_comm_types', 'pk')) into _pk_type;
	return _pk_type;
END;$_$;


ALTER FUNCTION dem.create_comm_type(text) OWNER TO "gm-dbo";

--
-- Name: create_occupation(text); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.create_occupation(text) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_job alias for $1;
	_id integer;
BEGIN
	select into _id id from dem.occupation where name = _job;
	if FOUND then
		return _id;
	end if;
	insert into dem.occupation (name) values (_job);
	return currval('dem.occupation_id_seq');
END;$_$;


ALTER FUNCTION dem.create_occupation(text) OWNER TO "gm-dbo";

--
-- Name: create_street(text, text, text, text, text); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.create_street(text, text, text, text, text) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_street ALIAS FOR $1;
	_postcode ALIAS FOR $2;
	_urb ALIAS FOR $3;
	_state_code ALIAS FOR $4;
	_country_code ALIAS FOR $5;
	_urb_id integer;
	_street_id integer;
	msg text;
BEGIN
	-- create/get urb
	SELECT INTO _urb_id dem.create_urb(_urb, _postcode, _state_code, _country_code);
	-- create/get and return street
	SELECT INTO _street_id s.id from dem.street s WHERE s.name ILIKE _street AND s.id_urb = _urb_id AND postcode ILIKE _postcode;
	IF FOUND THEN
		RETURN _street_id;
	END IF;
	INSERT INTO dem.street (name, postcode, id_urb) VALUES (_street, _postcode, _urb_id);
	RETURN currval('dem.street_id_seq');
END;$_$;


ALTER FUNCTION dem.create_street(text, text, text, text, text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION create_street(text, text, text, text, text); Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON FUNCTION dem.create_street(text, text, text, text, text) IS 'This function takes a parameters the name of the street,

	the postal code, the name of the urb,

	the postcode of the urb, the code of the state and the

	code of the country.

	If the country or the state does not exists in the tables,

	the function fails.

	At first, both the urb and street are tried to be retrieved according to the

	supplied information. If the fields do not match exactly an

	existing row, a new urb is created or a new street is created and returned.';


--
-- Name: create_urb(text, text, text, text); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.create_urb(text, text, text, text) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_urb ALIAS FOR $1;
	_urb_postcode ALIAS FOR $2;	
	_region_code ALIAS FOR $3;
	_country_code ALIAS FOR $4;
 	_region_pk integer;
	_urb_id integer;
	msg text;
BEGIN
 	-- get region
 	SELECT INTO _region_pk d_r.pk from dem.region d_r WHERE d_r.code = _region_code and d_r.country = _country_code;
 	IF NOT FOUND THEN
		msg := 'combination of region + country not registered ['
			||   'country:' || coalesce(_country_code, 'NULL')
			||  ', region:' || coalesce(_region_code, 'NULL')
			||     ', urb:' || coalesce(_urb, 'NULL')
			|| ', urb_zip:' || coalesce(_urb_postcode, 'NULL')
			|| ']';
		RAISE EXCEPTION '=> %', msg;
 	END IF;
	-- get/create and return urb
	SELECT INTO _urb_id u.id from dem.urb u WHERE u.name ILIKE _urb AND u.fk_region = _region_pk;
	IF FOUND THEN
		RETURN _urb_id;
	END IF;
	INSERT INTO dem.urb (name, postcode, fk_region) VALUES (_urb, _urb_postcode, _region_pk);
	RETURN currval('dem.urb_id_seq');
END;$_$;


ALTER FUNCTION dem.create_urb(text, text, text, text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION create_urb(text, text, text, text); Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON FUNCTION dem.create_urb(text, text, text, text) IS 'This function takes a parameters the name of the urb,\n
	the postcode of the urb, the name of the region and the\n
	name of the country.\n
	If the country or the region does not exists in the tables,\n
	the function fails.\n
	At first, the urb is tried to be retrieved according to the\n
	supplied information. If the fields do not match exactly an\n
	existing row, a new urb is created and returned.';


--
-- Name: date_trunc_utc(text, timestamp with time zone); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.date_trunc_utc(text, timestamp with time zone) RETURNS timestamp without time zone
    LANGUAGE sql IMMUTABLE
    AS $_$select date_trunc($1, $2 at time zone 'UTC');$_$;


ALTER FUNCTION dem.date_trunc_utc(text, timestamp with time zone) OWNER TO "gm-dbo";

--
-- Name: FUNCTION date_trunc_utc(text, timestamp with time zone); Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON FUNCTION dem.date_trunc_utc(text, timestamp with time zone) IS 'date_trunc() is not immutable because it depends on the timezone
	 setting, hence need to use this in index creation, but also need
	 to use it in queries which want to use that index, so make it
	 generally available as a function';


--
-- Name: dob_is_in_range(timestamp with time zone, interval, interval); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.dob_is_in_range(timestamp with time zone, interval, interval) RETURNS boolean
    LANGUAGE sql
    AS $_$
select
	($1 - (extract(year from $1) * '1 year'::interval)) -
	(now() - (extract(year from now()) * '1 year'::interval))
	between (-1 * $2) and $3$_$;


ALTER FUNCTION dem.dob_is_in_range(timestamp with time zone, interval, interval) OWNER TO "gm-dbo";

--
-- Name: f_always_active_name(); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.f_always_active_name() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
	if NEW.active = false then
		raise exception 'Cannot delete/disable active name. Another name must be activated first.';
		return OLD;
	end if;
	return NEW;
END;
$$;


ALTER FUNCTION dem.f_always_active_name() OWNER TO "gm-dbo";

--
-- Name: f_delete_names(); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.f_delete_names() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
BEGIN
	DELETE from dem.names WHERE id_identity=OLD.id;
	RETURN OLD;
END;$$;


ALTER FUNCTION dem.f_delete_names() OWNER TO "gm-dbo";

--
-- Name: f_uniq_active_name(); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.f_uniq_active_name() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
--	tmp text;
BEGIN
--	tmp := 'identity:' || NEW.id_identity || ',id:' || NEW.id || ',name:' || NEW.firstnames || ' ' || NEW.lastnames;
--	raise notice 'uniq_active_name: [%]', tmp;
	if NEW.active = true then
		update dem.names set active = false
		where
			id_identity = NEW.id_identity
				and
			active = true;
	end if;
	return NEW;
END;$$;


ALTER FUNCTION dem.f_uniq_active_name() OWNER TO "gm-dbo";

--
-- Name: gm_upd_default_regions(); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.gm_upd_default_regions() RETURNS boolean
    LANGUAGE plpgsql
    AS $$
declare
	_region_code text;
	_region_name text;
	_country_row record;
begin
	_region_code := '??';
	_region_name := 'state/territory/province/region not available';
	-- add default region to countries needing one
	for _country_row in
		select distinct code from dem.country
		where code not in (
			select country from dem.region where code = _region_code
		)
	loop
		raise notice 'adding default region for [%]', _country_row.code;
		execute 'insert into dem.region (code, country, name) values ('
				|| quote_literal(_region_code) || ', '
				|| quote_literal(_country_row.code) || ', '
				|| quote_literal(_region_name) || ');';
	end loop;
	return true;
end;
$$;


ALTER FUNCTION dem.gm_upd_default_regions() OWNER TO "gm-dbo";

--
-- Name: remove_person(integer); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.remove_person(integer) RETURNS boolean
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_pk_identity alias for $1;
BEGIN
	-- does person exist ?
	perform 1 from dem.identity where pk = _pk_identity;
	if not FOUND then
		raise notice 'dem.remove_person(): dem.identity.pk=(%) does not exist, not removing', _pk_identity;
		return false;
	end if;
	-- we cannot just get the child tables of clin.clin_root_item and
	-- delete from them since they are inter-dependent and may require
	-- a particular order of deletion, so let us do that explicitely:
	DELETE FROM clin.clin_hx_family WHERE fk_encounter IN (
		select pk from clin.encounter where fk_patient = _pk_identity
	);
	DELETE FROM clin.vaccination WHERE fk_encounter IN (
		select pk from clin.encounter where fk_patient = _pk_identity
	);
	DELETE FROM clin.allergy WHERE fk_encounter IN (
		select pk from clin.encounter where fk_patient = _pk_identity
	);
	DELETE FROM clin.allergy_state WHERE fk_encounter IN (
		select pk from clin.encounter where fk_patient = _pk_identity
	);
	DELETE FROM clin.clin_diag WHERE fk_narrative IN (
		SELECT pk FROM clin.clin_narrative WHERE fk_encounter IN (
			select pk from clin.encounter where fk_patient = _pk_identity
		)
	);
	DELETE FROM clin.test_result WHERE fk_encounter IN (
		select pk from clin.encounter where fk_patient = _pk_identity
	);
	DELETE FROM clin.lab_request WHERE fk_encounter in (
		select pk from clin.encounter where fk_patient = _pk_identity
	);
	DELETE FROM clin.substance_intake WHERE fk_encounter IN (
		select pk from clin.encounter where fk_patient = _pk_identity
	);
	DELETE FROM clin.procedure WHERE fk_encounter IN (
		select pk from clin.encounter where fk_patient = _pk_identity
	);
	DELETE FROM clin.clin_narrative WHERE fk_encounter IN (
		select pk from clin.encounter where fk_patient = _pk_identity
	);
	DELETE FROM blobs.doc_med WHERE fk_encounter IN (
		select pk from clin.encounter where fk_patient = _pk_identity
	);
	-- now that we have deleted all the clinical data let us
	-- delete the EMR structural items as well:
	DELETE FROM clin.episode WHERE fk_encounter IN (
	    select pk from clin.encounter where fk_patient = _pk_identity
	);
	DELETE FROM clin.health_issue WHERE fk_encounter IN (
	    select pk from clin.encounter where fk_patient = _pk_identity
	);
	DELETE FROM clin.encounter WHERE fk_patient = _pk_identity;
	-- delete demographics details:
	DELETE FROM dem.identity_tag where fk_identity = _pk_identity;
	DELETE FROM dem.names WHERE id_identity = _pk_identity;
	-- eventually delete the identity itself which does
	-- not go down without some twisting of arms:
	ALTER TABLE dem.identity disable rule r_del_identity;
	DELETE FROM dem.identity WHERE pk = _pk_identity;
	ALTER TABLE dem.identity enable rule r_del_identity;
	return true;
END;$_$;


ALTER FUNCTION dem.remove_person(integer) OWNER TO "gm-dbo";

--
-- Name: FUNCTION remove_person(integer); Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON FUNCTION dem.remove_person(integer) IS 'Fully remove a person from the system - except
 everything is still in the audit tables ;-)';


--
-- Name: set_nickname(integer, text); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.set_nickname(integer, text) RETURNS integer
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_id_identity alias for $1;
	_nick alias for $2;
	_names_row record;
	msg text;
BEGIN
	-- 0.1: Just always set the nickname inside the active name
	-- post 0.1: openEHR-like (name: pk, fk_identity, name, fk_type, comment, is_legal, is_active ...)
	-- does name exist ?
	select into _names_row * from dem.names where id_identity = _id_identity and active = true;
	if not found then
		msg := 'Cannot set nickname [' || _nick || ']. No active <names> row with id_identity [' || _id_identity || '] found.';
		raise exception '%', msg;
	end if;
	update dem.names set preferred = _nick where id = _names_row.id;
	return _names_row.id;
END;$_$;


ALTER FUNCTION dem.set_nickname(integer, text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION set_nickname(integer, text); Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON FUNCTION dem.set_nickname(integer, text) IS 'Setting the nickname only makes sense for the currently active

	 name. However, we also want to keep track of previous nicknames.

	 Hence we would set the nickname right in the active name if

	 it is NULL. It it contains a previous nickname (eg IS NOT NULL)

	 we will inactivate the currently active name and copy it into

	 a new active name but with the nickname set to the new one.

	 Unsetting works the same (IOW *setting* to NULL).';


--
-- Name: trf_normalize_time_in_dob(); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.trf_normalize_time_in_dob() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
	if NEW.dob is NULL then
		return NEW;
	end if;
	NEW.dob = date_trunc('day', NEW.dob) + '11 hours 11 minutes 11 seconds 111 milliseconds'::interval;
	return NEW;
END;$$;


ALTER FUNCTION dem.trf_normalize_time_in_dob() OWNER TO "gm-dbo";

--
-- Name: trf_null_empty_title(); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.trf_null_empty_title() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
begin
	if (NEW.title is null) then
		return NEW;
	end if;
	if trim(NEW.title) <> '' then
		return NEW;
	end if;
	NEW.title := NULL;
	return NEW;
end;$$;


ALTER FUNCTION dem.trf_null_empty_title() OWNER TO "gm-dbo";

--
-- Name: trf_prevent_deletion_of_in_use_staff(); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.trf_prevent_deletion_of_in_use_staff() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
	-- does any audited table contain the dem.staff.db_user we are about to delete ?
	PERFORM 1 FROM audit.audit_fields WHERE modified_by = OLD.db_user LIMIT 1;
	IF FOUND THEN
		RAISE EXCEPTION
			'DELETE from dem.staff: Sanity check failed. User <%> is referenced from <.modified_by> of at least one audited table.', OLD.db_user
			USING ERRCODE = 'foreign_key_violation'
		;
		RETURN NULL;
	END IF;
	-- does any audit table contain the dem.staff.db_user we are about to delete ?
	PERFORM 1 FROM audit.audit_trail WHERE orig_by = OLD.db_user OR audit_by = OLD.db_user LIMIT 1;
	IF FOUND THEN
		RAISE EXCEPTION
			'DELETE from dem.staff: Sanity check failed. User <%> is referenced from <.orig_by> or <.audit_by> of at least one audit table.', OLD.db_user
			USING ERRCODE = 'foreign_key_violation'
		;
		RETURN NULL;
	END IF;
	RETURN OLD;
END;
$$;


ALTER FUNCTION dem.trf_prevent_deletion_of_in_use_staff() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_prevent_deletion_of_in_use_staff(); Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON FUNCTION dem.trf_prevent_deletion_of_in_use_staff() IS 'this function is used to prevent DELETEs of staff members which had been used to store data';


--
-- Name: trf_prevent_multiple_praxi(); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.trf_prevent_multiple_praxi() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_branch_count integer;
	_pk_org_existing integer;
	_pk_org_prospective integer;
	_msg text;
BEGIN
	select count(1) into _branch_count from dem.praxis_branch;
	if TG_OP = 'INSERT' then
		-- first branch ever
		if _branch_count = 0 then
			return NEW;
		end if;
	end if;
	if TG_OP = 'UPDATE' then
		-- only one branch (which is being updated)
		if _branch_count = 1 then
			return NEW;
		end if;
	end if;
	-- now we have either got an INSERT with at least
	-- one praxis_branch already existing or we are
	-- UPDATEing one of several existing branches
	SELECT fk_org INTO _pk_org_existing FROM dem.org_unit
	WHERE pk = (SELECT fk_org_unit FROM dem.praxis_branch LIMIT 1);
	SELECT fk_org INTO _pk_org_prospective
	FROM dem.org_unit WHERE pk = NEW.fk_org_unit;
	if _pk_org_prospective = _pk_org_existing then
		return NEW;
	end if;
	_msg := '[dem.trf_prevent_multiple_praxi] '
			|| TG_OP || ': '
			|| 'Existing praxis branches (dem.praxis_branch.fk_org->dem.org_unit.pk->dem.org_unit.fk_org) belong to an org with dem.org.pk='
			|| _pk_org_existing
			|| '. Cannot link praxis branch (dem.praxis_branch.fk_org=dem.org_unit.pk='
			|| NEW.fk_org_unit
			||') to a different org (dem.org.pk='
			|| _pk_org_prospective
			||'). There can only be one praxis (=dem.org) per database.';
	raise exception unique_violation using message = _msg;
	return NULL;
END;$$;


ALTER FUNCTION dem.trf_prevent_multiple_praxi() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_prevent_multiple_praxi(); Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON FUNCTION dem.trf_prevent_multiple_praxi() IS 'Prevent praxis branches to be defined for more than one dem.org.';


--
-- Name: trf_protect_active_name_of_person(); Type: FUNCTION; Schema: dem; Owner: gm-dbo
--

CREATE FUNCTION dem.trf_protect_active_name_of_person() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_name_count integer;
	_msg text;
BEGIN
	-- how many names are there for the identity at the end of the Tx ?
	select count(1) into _name_count
	from dem.names
	where
		id_identity = OLD.id_identity
			and
		active is true
	;
	-- less than one name ?
	if _name_count < 1 then
		_msg := 'person ' || OLD.id_identity || ' must have at least one, active, name entry';
		raise exception check_violation using message = _msg;
		return OLD;
	end if;
	return OLD;
END;$$;


ALTER FUNCTION dem.trf_protect_active_name_of_person() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_protect_active_name_of_person(); Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON FUNCTION dem.trf_protect_active_name_of_person() IS 'A person must have at least one, active, name record.';


--
-- Name: account_is_dbowner_or_staff(name); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.account_is_dbowner_or_staff(_account name) RETURNS boolean
    LANGUAGE plpgsql
    AS $$
DECLARE
	_is_owner boolean;
BEGIN
	-- is _account member of current db group ?
--	PERFORM 1 FROM pg_auth_members
--	WHERE
--		roleid = (SELECT oid FROM pg_roles WHERE rolname = current_database())
--			AND
--		member = (SELECT oid FROM pg_roles WHERE rolname = _account)
--	;
--	IF FOUND THEN
--		-- should catch people on staff, gm-dbo, and postgres
--		RETURN TRUE;
--	END IF;
	-- postgres
	IF _account = 'postgres' THEN
		RETURN TRUE;
	END IF;
	-- on staff list
	PERFORM 1 FROM dem.staff WHERE db_user = _account;
	IF FOUND THEN
		RETURN TRUE;
	END IF;
	-- owner
	SELECT pg_catalog.pg_get_userbyid(datdba) = _account INTO STRICT _is_owner FROM pg_catalog.pg_database WHERE datname = current_database();
	IF _is_owner IS TRUE THEN
		RETURN TRUE;
	END IF;
	RETURN FALSE;
END;$$;


ALTER FUNCTION gm.account_is_dbowner_or_staff(_account name) OWNER TO "gm-dbo";

--
-- Name: add_missing_array_bits(); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.add_missing_array_bits() RETURNS boolean
    LANGUAGE plpgsql
    AS $_$
DECLARE
BEGIN
	-- array_agg
	perform 1 from pg_catalog.pg_aggregate where aggfnoid::oid = (select oid from pg_catalog.pg_proc where proname = 'array_agg'::name limit 1);
	if FOUND then
		raise NOTICE '[gm.add_missing_array_bits]: aggregate <array_agg> already exists';
	else
		raise NOTICE '[gm.add_missing_array_bits]: aggregate <array_agg> does not exist (probably PostgreSQL <8.4), creating';
		CREATE AGGREGATE array_agg(anyelement) (
			SFUNC = array_append,
			STYPE = anyarray,
			INITCOND = '{}'
		);
		comment on aggregate array_agg(anyelement) is
			'Missing on PG 8.3, needed for vaccination handling starting with conversion from gnumed_v13 to gnumed_v14.';
	end if;
	-- unnest()
	perform 1 from pg_catalog.pg_proc where
		proname = 'array_unnest'::name
			and
		pronamespace = (select oid from pg_namespace where nspname = 'gm'::name)
	;
	if FOUND then
		raise NOTICE '[gm.add_missing_array_bits]: function "gm.array_unnest()" already exists';
	else
		raise NOTICE '[gm.add_missing_array_bits]: function "gm.array_unnest()" does not exist, creating';
		CREATE OR REPLACE FUNCTION gm.array_unnest(anyarray)
			RETURNS SETOF anyelement
			AS '
		SELECT $1[i] FROM
			generate_series (
				array_lower($1,1),
				array_upper($1,1)
			) i
		;'
			LANGUAGE 'sql'
			IMMUTABLE
		;
		comment on function gm.array_unnest(anyarray) is
			'Missing on PG 8.3, needed for vaccination handling starting with conversion from gnumed_v13 to gnumed_v14.';
	end if;
	perform 1 from pg_catalog.pg_proc where
		proname = 'unnest'::name
			and
		pronamespace = (select oid from pg_namespace where nspname = 'pg_catalog'::name)
	;
	if FOUND then
		raise NOTICE '[gm.add_missing_array_bits]: function "pg_catalog.unnest()" exists';
		-- also exists in public ?
		perform 1 from pg_catalog.pg_proc where
			proname = 'unnest'::name
				and
			pronamespace = (select oid from pg_namespace where nspname = 'public'::name)
		;
		if FOUND then
			raise NOTICE '[gm.add_missing_array_bits]: function "unnest()" also exists in schema "public", removing';
			drop function public.unnest(anyarray) cascade;
		end if;
	else
		raise NOTICE '[gm.add_missing_array_bits]: function "pg_catalog.unnest()" does not exist (probably PostgreSQL <8.4)';
		-- exists in public ?
		perform 1 from pg_catalog.pg_proc where
			proname = 'unnest'::name
				and
			pronamespace = (select oid from pg_namespace where nspname = 'public'::name)
		;
		if FOUND then
			raise NOTICE '[gm.add_missing_array_bits]: function "public.unnest()" already exists';
		else
			raise NOTICE '[gm.add_missing_array_bits]: function "public.unnest()" does not exist either, creating';
			CREATE OR REPLACE FUNCTION public.unnest(anyarray)
				RETURNS SETOF anyelement
				AS 'SELECT gm.array_unnest($1);'
				LANGUAGE 'sql'
				IMMUTABLE
			;
			comment on function public.unnest(anyarray) is
				'Missing on PG 8.3, needed for vaccination handling starting with conversion from gnumed_v13 to gnumed_v14.';
		end if;
	end if;
	return TRUE;
END;$_$;


ALTER FUNCTION gm.add_missing_array_bits() OWNER TO "gm-dbo";

--
-- Name: FUNCTION add_missing_array_bits(); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.add_missing_array_bits() IS 'Add array aggregate and array unnesting to PostgreSQL versions lacking this functionality (IOW < 8.4).';


--
-- Name: add_table_for_notifies(name, name); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.add_table_for_notifies(name, name) RETURNS boolean
    LANGUAGE sql
    AS $_$select gm.register_notifying_table($1, $2);$_$;


ALTER FUNCTION gm.add_table_for_notifies(name, name) OWNER TO "gm-dbo";

--
-- Name: FUNCTION add_table_for_notifies(name, name); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.add_table_for_notifies(name, name) IS 'Mark given table for notification trigger generator.
	 Parameters are: (schema, table).
	 Defaults signal to table name.';


--
-- Name: add_user_to_permission_group(name, name); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.add_user_to_permission_group(name, name) RETURNS boolean
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_username alias for $1;
	_target_group alias for $2;
	_valid_groups name[];
	_group name;
	_query text;
BEGIN
	-- verify user
	perform 1 from pg_user where usename = _username;
	if not FOUND then
		raise warning '[gm.add_user_to_permission_group]: user [%] does not exist', _username;
		return False;
	end if;
	-- verify logical group validity
	-- no "gm-nurse", "gm-admin" just yet
	_valid_groups := ARRAY[quote_ident('gm-public'), quote_ident('gm-staff'), quote_ident('gm-doctors')];
	if quote_ident(_target_group) <> all(_valid_groups) then
		raise warning '[gm.add_user_to_permission_group]: invalid group [%]', _target_group;
		return False;
	end if;
	-- verify group existance
	perform 1 from pg_group where groname = _target_group;
	if not FOUND then
		raise warning '[gm.add_user_to_permission_group]: group [%] does not exist', _target_group;
		return False;
	end if;
	-- drop user from all groups
	--FOREACH _group IN ARRAY _valid_groups LOOP
	FOR _group IN SELECT unnest(_valid_groups) LOOP
		_query := 'alter group ' || _group || ' drop user ' || quote_ident(_username) || ';';
		execute _query;
	END LOOP;
	-- add user to desired group
	_query := 'alter group ' || quote_ident(_target_group) || ' add user ' || quote_ident(_username) || ';';
	execute _query;
	return True;
END;$_$;


ALTER FUNCTION gm.add_user_to_permission_group(name, name) OWNER TO "gm-dbo";

--
-- Name: FUNCTION add_user_to_permission_group(name, name); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.add_user_to_permission_group(name, name) IS 'Only gm-dbo is GRANTed EXECUTE on this function. This way users need
 to know the gm-dbo (GNUmed admin) password to execute it.';


--
-- Name: array_unnest(anyarray); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.array_unnest(anyarray) RETURNS SETOF anyelement
    LANGUAGE sql IMMUTABLE
    AS $_$
		SELECT $1[i] FROM
			generate_series (
				array_lower($1,1),
				array_upper($1,1)
			) i
		;$_$;


ALTER FUNCTION gm.array_unnest(anyarray) OWNER TO "gm-dbo";

--
-- Name: FUNCTION array_unnest(anyarray); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.array_unnest(anyarray) IS 'Missing on PG 8.3, needed for vaccination handling starting with conversion from gnumed_v13 to gnumed_v14.';


--
-- Name: concat_table_structure(); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.concat_table_structure() RETURNS text
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
declare
	_struct text;
begin
	select into _struct gm.concat_table_structure_v19_and_up();
	return _struct;
end;
$$;


ALTER FUNCTION gm.concat_table_structure() OWNER TO "gm-dbo";

--
-- Name: concat_table_structure(integer); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.concat_table_structure(integer) RETURNS text
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
declare
	_db_ver alias for $1;
	_struct text;
begin
	if _db_ver < 6 then
		select into _struct gm.concat_table_structure_v1();
		return _struct;
	end if;
	if _db_ver < 8 then
		select into _struct gm.concat_table_structure_v2();
		return _struct;
	end if;
	if _db_ver < 16 then
		select into _struct gm.concat_table_structure_v3();
		return _struct;
	end if;
	if _db_ver < 17 then
		select into _struct gm.concat_table_structure_v16_and_up();
		return _struct;
	end if;
	if _db_ver < 18 then
		select into _struct gm.concat_table_structure_v17_and_up();
		return _struct;
	end if;
	if _db_ver < 19 then
		select into _struct gm.concat_table_structure_v18_and_up();
		return _struct;
	end if;
	select into _struct gm.concat_table_structure_v19_and_up();
	return _struct;
end;
$_$;


ALTER FUNCTION gm.concat_table_structure(integer) OWNER TO "gm-dbo";

--
-- Name: concat_table_structure_v1(); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.concat_table_structure_v1() RETURNS text
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
declare
	_row record;
	_total text;
begin
	_total := '';
	-- schema.table.column.data_type
	for _row in
		select * from information_schema.columns cols
			where cols.table_name in (
				select tabs.table_name from information_schema.tables tabs where
					-- those which hold clinical data
					tabs.table_schema in ('public', 'dem', 'clin', 'blobs') and
					tabs.table_type = 'BASE TABLE'
				)
			order by
				md5(cols.table_schema || cols.table_name || cols.column_name || cols.data_type)
	loop
		_total := _total
			|| _row.table_schema || '.'
			|| _row.table_name || '.'
			|| _row.column_name || '::'
			|| _row.udt_name || '
';
	end loop;
	return _total;
end;
$$;


ALTER FUNCTION gm.concat_table_structure_v1() OWNER TO "gm-dbo";

--
-- Name: FUNCTION concat_table_structure_v1(); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.concat_table_structure_v1() IS 'copy of gm_concat_table_structure() until gnumed_v5, works on public, dem, clin, blobs';


--
-- Name: concat_table_structure_v16_and_up(); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.concat_table_structure_v16_and_up() RETURNS text
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
declare
	_row record;
	_total text;
begin
	_total := '';
	-- schema.table.column.data_type
	for _row in
		select *
		from information_schema.columns cols
		where
			cols.table_name in (
				select tabs.table_name from information_schema.tables tabs where
					-- those which hold clinical data
					tabs.table_schema in ('dem', 'clin', 'blobs', 'cfg', 'ref', 'i18n')
						and
					tabs.table_type = 'BASE TABLE'
			) and
			cols.table_schema in ('dem', 'clin', 'blobs', 'cfg', 'ref', 'i18n')
		order by
			decode(md5(cols.table_schema || cols.table_name || cols.column_name || cols.data_type), 'hex')
	loop
		_total := _total
			|| _row.table_schema || '.'
			|| _row.table_name || '.'
			|| _row.column_name || '::'
			|| _row.udt_name || E'
';
	end loop;
	return _total;
end;
$$;


ALTER FUNCTION gm.concat_table_structure_v16_and_up() OWNER TO "gm-dbo";

--
-- Name: FUNCTION concat_table_structure_v16_and_up(); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.concat_table_structure_v16_and_up() IS 'new concat_table_structure() starting with gnumed_v16,
	 works on dem, clin, blobs, cfg, ref, i18n,
	 sorts properly by bytea';


--
-- Name: concat_table_structure_v17_and_up(); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.concat_table_structure_v17_and_up() RETURNS text
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
declare
	_row record;
	_total text;
begin
	_total := '';
	-- schema.table.column.data_type
	for _row in
		select *
		from information_schema.columns cols
		where
			cols.table_name in (
				select tabs.table_name from information_schema.tables tabs where
					tabs.table_schema in ('dem', 'clin', 'blobs', 'cfg', 'ref', 'i18n', 'bill')
						and
					tabs.table_type = 'BASE TABLE'
			) and
			cols.table_schema in ('dem', 'clin', 'blobs', 'cfg', 'ref', 'i18n', 'bill')
		order by
			decode(md5(cols.table_schema || cols.table_name || cols.column_name || cols.data_type), 'hex')
	loop
		_total := _total
			|| _row.table_schema || '.'
			|| _row.table_name || '.'
			|| _row.column_name || '::'
			|| _row.udt_name || E'
';
	end loop;
	return _total;
end;
$$;


ALTER FUNCTION gm.concat_table_structure_v17_and_up() OWNER TO "gm-dbo";

--
-- Name: FUNCTION concat_table_structure_v17_and_up(); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.concat_table_structure_v17_and_up() IS 'new concat_table_structure() starting with gnumed_v17,
	 works on dem, clin, blobs, cfg, ref, i18n, bill,
	 sorts properly by bytea';


--
-- Name: concat_table_structure_v18_and_up(); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.concat_table_structure_v18_and_up() RETURNS text
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
declare
	_table_desc record;
	_pk_desc record;
	_column_desc record;
	_total text;
begin
	_total := '';
	-- find relevant tables
	for _table_desc in
		select * from information_schema.tables tabs where
			tabs.table_schema in ('dem', 'clin', 'blobs', 'cfg', 'ref', 'i18n', 'bill')
				and
			tabs.table_type = 'BASE TABLE'
		order by
			decode(md5(tabs.table_schema || tabs.table_name), 'hex')
	-- loop over tables
	loop
		-- where are we at ?
		_total := _total || 'TABLE:' || _table_desc.table_schema || '.' || _table_desc.table_name || E'
';
		-- find PKs of that table
		for _pk_desc in
			select * from (
				select
					pg_class.oid::regclass || '.' || pg_attribute.attname || '::' || format_type(pg_attribute.atttypid, pg_attribute.atttypmod) AS primary_key_column
				from
					pg_index, pg_class, pg_attribute
				where
					--pg_class.oid = 'TABLENAME'::regclass
					pg_class.oid = (_table_desc.table_schema || '.' || _table_desc.table_name)::regclass
						AND 
					indrelid = pg_class.oid
						AND
					pg_attribute.attrelid = pg_class.oid
						AND
					pg_attribute.attnum = any(pg_index.indkey)
						AND
					indisprimary
				) AS PKs
			order by
				decode(md5(PKs.primary_key_column), 'hex')
		-- and loop over those PK columns
		loop
			_total := _total || 'PK:' || _pk_desc.primary_key_column	|| E'
';
		end loop;
		-- find columns of that table
		for _column_desc in
			select *
			from information_schema.columns cols
			where
				cols.table_name = _table_desc.table_name
					and
				cols.table_schema = _table_desc.table_schema
			order by
				decode(md5(cols.column_name || cols.data_type), 'hex')
		-- and loop over those columns
		loop
			-- add columns in the format "schema.table.column::data_type"
			_total := _total || 'COL:'
				|| _column_desc.table_schema || '.'
				|| _column_desc.table_name || '.'
				|| _column_desc.column_name || '::'
				|| _column_desc.udt_name || E'
';
		end loop;
	end loop;
	return _total;
end;
$$;


ALTER FUNCTION gm.concat_table_structure_v18_and_up() OWNER TO "gm-dbo";

--
-- Name: FUNCTION concat_table_structure_v18_and_up(); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.concat_table_structure_v18_and_up() IS 'new concat_table_structure() starting with gnumed_v18,
	 works on dem, clin, blobs, cfg, ref, i18n, bill,
	 includes primary keys,
	 sorts properly by bytea';


--
-- Name: concat_table_structure_v19_and_up(); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.concat_table_structure_v19_and_up() RETURNS text
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
declare
	_table_desc record;
	_pk_desc record;
	_column_desc record;
	_constraint_def record;
	_total text;
begin
	_total := '';
	-- find relevant tables
	for _table_desc in
		select * from information_schema.tables tabs where
			tabs.table_schema in ('dem', 'clin', 'blobs', 'cfg', 'ref', 'i18n', 'bill')
				and
			tabs.table_type = 'BASE TABLE'
		order by
			decode(md5(tabs.table_schema || tabs.table_name), 'hex')
	-- loop over tables
	loop
		-- where are we at ?
		_total := _total || 'TABLE:' || _table_desc.table_schema || '.' || _table_desc.table_name || E'\n';
		-- find PKs of that table
		for _pk_desc in
			select * from (
				select
					pg_class.oid::regclass || '.' || pg_attribute.attname || '::' || format_type(pg_attribute.atttypid, pg_attribute.atttypmod) AS primary_key_column
				from
					pg_index, pg_class, pg_attribute
				where
					--pg_class.oid = 'TABLENAME'::regclass
					pg_class.oid = (_table_desc.table_schema || '.' || _table_desc.table_name)::regclass
						AND 
					indrelid = pg_class.oid
						AND
					pg_attribute.attrelid = pg_class.oid
						AND
					pg_attribute.attnum = any(pg_index.indkey)
						AND
					indisprimary
				) AS PKs
			order by
				decode(md5(PKs.primary_key_column), 'hex')
		-- and loop over those PK columns
		loop
			_total := _total || 'PK:' || _pk_desc.primary_key_column	|| E'\n';
		end loop;
		-- find columns of that table
		for _column_desc in
			select *
			from information_schema.columns cols
			where
				cols.table_name = _table_desc.table_name
					and
				cols.table_schema = _table_desc.table_schema
			order by
				decode(md5(cols.column_name || cols.data_type), 'hex')
		-- and loop over those columns
		loop
			-- add columns in the format "schema.table.column::data_type"
			_total := _total || 'COL:'
				|| _column_desc.table_schema || '.'
				|| _column_desc.table_name || '.'
				|| _column_desc.column_name || '::'
				|| _column_desc.udt_name || E'\n';
		end loop;
		-- find and loop over CONSTRAINTs of that table
		for _constraint_def in
			select * from
				(select
					tbl.contype,
					'CONSTRAINT:type='
						|| tbl.contype::TEXT || ':'
						|| replace(pg_catalog.pg_get_constraintdef(tbl.oid, true), ' ', '_')
						|| '::active='
						|| tbl.convalidated::TEXT
					 as condef
				from pg_catalog.pg_constraint tbl
				where
					tbl.conrelid = (_table_desc.table_schema || '.' || _table_desc.table_name)::regclass
					-- include FKs only because we may have to add/remove
					-- other (say, check) constraints in a minor release
					-- for valid reasons which we do not want to affect
					-- the hash, if however we need to modify a foreign
					-- key that would, indeed, warrant a hash change
						AND
					tbl.contype = 'f'
				) as CONSTRAINTs
			order by
				CONSTRAINTs.contype,
				decode(md5(CONSTRAINTs.condef), 'hex')
		loop
			_total := _total || _constraint_def.condef || E'\n';
		end loop;
	end loop;		-- over tables
	return _total;
end;
$$;


ALTER FUNCTION gm.concat_table_structure_v19_and_up() OWNER TO "gm-dbo";

--
-- Name: FUNCTION concat_table_structure_v19_and_up(); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.concat_table_structure_v19_and_up() IS 'new concat_table_structure() starting with gnumed_v19,
	 works on dem, clin, blobs, cfg, ref, i18n, bill,
	 includes primary keys and constraints,
	 sorts properly by bytea';


--
-- Name: concat_table_structure_v2(); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.concat_table_structure_v2() RETURNS text
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
declare
	_row record;
	_total text;
begin
	_total := '';
	-- schema.table.column.data_type
	for _row in
		select * from information_schema.columns cols
			where cols.table_name in (
				select tabs.table_name from information_schema.tables tabs where
					-- those which hold clinical data
					tabs.table_schema in ('dem', 'clin', 'blobs', 'cfg', 'ref', 'i18n') and
					tabs.table_type = 'BASE TABLE'
				)
			order by
				md5(cols.table_schema || cols.table_name || cols.column_name || cols.data_type)
	loop
		_total := _total
			|| _row.table_schema || '.'
			|| _row.table_name || '.'
			|| _row.column_name || '::'
			|| _row.udt_name || '
';
	end loop;
	return _total;
end;
$$;


ALTER FUNCTION gm.concat_table_structure_v2() OWNER TO "gm-dbo";

--
-- Name: FUNCTION concat_table_structure_v2(); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.concat_table_structure_v2() IS 'new concat_table_structure() starting with gnumed_v6, works on dem, clin, blobs, cfg, ref, i18n';


--
-- Name: concat_table_structure_v3(); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.concat_table_structure_v3() RETURNS text
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
declare
	_row record;
	_total text;
begin
	_total := '';
	-- schema.table.column.data_type
	for _row in
		select * from information_schema.columns cols
			where cols.table_name in (
				select tabs.table_name from information_schema.tables tabs where
					-- those which hold clinical data
					tabs.table_schema in ('dem', 'clin', 'blobs', 'cfg', 'ref', 'i18n') and
					tabs.table_type = 'BASE TABLE'
				)
			order by
				decode(md5(cols.table_schema || cols.table_name || cols.column_name || cols.data_type), 'hex')
	loop
		_total := _total
			|| _row.table_schema || '.'
			|| _row.table_name || '.'
			|| _row.column_name || '::'
			|| _row.udt_name || '
';
	end loop;
	return _total;
end;
$$;


ALTER FUNCTION gm.concat_table_structure_v3() OWNER TO "gm-dbo";

--
-- Name: FUNCTION concat_table_structure_v3(); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.concat_table_structure_v3() IS 'new concat_table_structure() starting with gnumed_v8,
	 works on dem, clin, blobs, cfg, ref, i18n,
	 sorts properly by bytea';


--
-- Name: create_all_enc_epi_sanity_check_triggers(); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.create_all_enc_epi_sanity_check_triggers() RETURNS boolean
    LANGUAGE plpgsql
    AS $$
DECLARE
	_schema name;
	_table name;
	_qualified_table2check name;
	_fk_encounter_col name;
	_fk_episode_col name;
	_total_success boolean;
BEGIN
	raise notice 'gm.create_all_enc_epi_sanity_check_triggers()';
	_total_success := True;
	-- loop over tables with encounter AND episode FKs
	-- (assumes there is only one of each)
	for _schema, _table in
		select
			(select pg_n.nspname from pg_catalog.pg_namespace pg_n where pg_n.oid = pg_c.relnamespace),
			pg_c.relname
		from pg_class pg_c
		where pg_c.oid in (
			select distinct fk_tbl.conrelid
			from pg_catalog.pg_constraint fk_tbl
			where
				exists (
					select 1 from pg_catalog.pg_constraint fk_tbl1
					where
						fk_tbl1.contype = 'f'
							and
						fk_tbl1.conrelid = fk_tbl.conrelid
							and
						fk_tbl1.confrelid = 'clin.encounter'::regclass
							and
						fk_tbl1.confkey[1] = (
							select attnum from pg_catalog.pg_attribute col_tbl
							where
								col_tbl.attname = 'pk'
									AND
								col_tbl.attrelid = 'clin.encounter'::regclass
						)
				)
					and
				exists (
					select 1 from pg_catalog.pg_constraint fk_tbl2
					where
						fk_tbl2.contype = 'f'
							and
						fk_tbl2.conrelid = fk_tbl.conrelid
							and
						fk_tbl2.confrelid = 'clin.episode'::regclass
							and
						fk_tbl2.confkey[1] = (
							select attnum from pg_catalog.pg_attribute col_tbl
							where
								col_tbl.attname = 'pk'
									AND
								col_tbl.attrelid = 'clin.episode'::regclass
						)
				)
		)
	loop
		_qualified_table2check := _schema || '.' || _table;
		raise notice 'gm.create_all_enc_epi_sanity_check_triggers(): processing %', _qualified_table2check;
		-- find encounter FK column name
		select col_tbl.attname into _fk_encounter_col
		from pg_catalog.pg_attribute col_tbl
		where
			col_tbl.attrelid = _qualified_table2check::regclass
				and
			col_tbl.attnum = (
				select fk_tbl.conkey[1]
				from pg_catalog.pg_constraint fk_tbl
				where
					fk_tbl.contype = 'f'
						and
					fk_tbl.conrelid = _qualified_table2check::regclass
						and
					fk_tbl.confrelid = 'clin.encounter'::regclass
						and
					fk_tbl.confkey[1] = (
						select col_tbl1.attnum
						from pg_catalog.pg_attribute col_tbl1
						where
							col_tbl1.attname = 'pk'
								AND
							col_tbl1.attrelid = 'clin.encounter'::regclass
					)
				)
			;
		-- find episode FK column name
		select col_tbl.attname into _fk_episode_col
		from pg_catalog.pg_attribute col_tbl
		where
			col_tbl.attrelid = _qualified_table2check::regclass
				and
			col_tbl.attnum = (
				select fk_tbl.conkey[1]
				from pg_catalog.pg_constraint fk_tbl
				where
					fk_tbl.contype = 'f'
						and
					fk_tbl.conrelid = _qualified_table2check::regclass
						and
					fk_tbl.confrelid = 'clin.episode'::regclass
						and
					fk_tbl.confkey[1] = (
						select col_tbl1.attnum
						from pg_catalog.pg_attribute col_tbl1
						where
							col_tbl1.attname = 'pk'
								AND
							col_tbl1.attrelid = 'clin.episode'::regclass
					)
				)
			;
		-- now create the trigger
		BEGIN
			PERFORM gm.create_enc_epi_sanity_check_trigger(_schema, _table, _fk_encounter_col, _fk_episode_col);
		EXCEPTION
			WHEN undefined_table OR invalid_foreign_key THEN
				raise warning 'gm.create_all_enc_epi_sanity_check_triggers(): error processing <%.%>, skipping', _schema, _table;
				_total_success := False;
		END;
	end loop;
	return _total_success;
END;
$$;


ALTER FUNCTION gm.create_all_enc_epi_sanity_check_triggers() OWNER TO "gm-dbo";

--
-- Name: FUNCTION create_all_enc_epi_sanity_check_triggers(); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.create_all_enc_epi_sanity_check_triggers() IS '(Re)create sanity check triggers for all tables which have both fk_encounter and fk_episode.';


--
-- Name: create_all_table_mod_triggers(boolean); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.create_all_table_mod_triggers(_drop_old_triggers boolean) RETURNS boolean
    LANGUAGE plpgsql
    AS $$
DECLARE
	_notify_table record;
	_cmd text;
	_total_success boolean;
BEGIN
	_total_success := True;
	-- loop over registered tables
	for _notify_table in select * from gm.notifying_tables loop
		BEGIN
			PERFORM gm.create_table_mod_triggers(_notify_table.schema_name, _notify_table.table_name);
		EXCEPTION
			WHEN undefined_table OR undefined_column THEN
				raise warning 'gm.create_all_table_mod_triggers(): error processing <%.%>, skipping', _notify_table.schema_name, _notify_table.table_name;
				_total_success := False;
		END;
	end loop;
	return _total_success;
END;
$$;


ALTER FUNCTION gm.create_all_table_mod_triggers(_drop_old_triggers boolean) OWNER TO "gm-dbo";

--
-- Name: FUNCTION create_all_table_mod_triggers(_drop_old_triggers boolean); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.create_all_table_mod_triggers(_drop_old_triggers boolean) IS '(Re)create all table mod triggers for all registered tables.';


--
-- Name: create_enc_epi_sanity_check_trigger(name, name, name, name); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.create_enc_epi_sanity_check_trigger(_schema_name name, _table_name name, _fk_encounter_col name, _fk_episode_col name) RETURNS boolean
    LANGUAGE plpgsql
    AS $$
DECLARE
	_qualified_table2check text;
	_msg text;
	_cmd text;
BEGIN
	_qualified_table2check := _schema_name || '.' || _table_name;
	raise notice 'gm.create_enc_epi_sanity_check_trigger(): % (.% vs .%)', _qualified_table2check, _fk_encounter_col, _fk_episode_col;
	-- verify table exists
	if not exists(select 1 from information_schema.tables where table_schema = _schema_name and table_name = _table_name) then
		raise warning 'gm.create_enc_epi_sanity_check_trigger(): table <%> does not exist', _qualified_table2check;
		raise exception undefined_table;
		return false;
	end if;
	-- verify that it points to clin.encounter.pk
	if not exists (
		select 1
		from
			pg_catalog.pg_constraint fk_tbl
		where
			fk_tbl.contype = 'f'
				AND
			fk_tbl.confrelid = 'clin.encounter'::regclass
				AND
			fk_tbl.conrelid = _qualified_table2check::regclass
				AND
			fk_tbl.confkey[1] = (
				select attnum from pg_catalog.pg_attribute col_tbl
				where
					col_tbl.attname = 'pk'
						AND
					col_tbl.attrelid = 'clin.encounter'::regclass
			)
				AND
			fk_tbl.conkey[1] = (
				select attnum from pg_catalog.pg_attribute col_tbl
				where
					col_tbl.attname = _fk_encounter_col
						AND
					col_tbl.attrelid = _qualified_table2check::regclass
			)
	) then
		raise exception
			'gm.create_enc_epi_sanity_check_trigger(): <%.%> does not point to clin.encounter.pk', _qualified_table2check, _fk_encounter_col
			USING ERRCODE = 'invalid_foreign_key'
		;
		return false;
	end if;
	-- verify that it points to clin.episode.pk
	if not exists (
		select 1
		from
			pg_catalog.pg_constraint fk_tbl
		where
			fk_tbl.contype = 'f'
				AND
			fk_tbl.confrelid = 'clin.episode'::regclass
				AND
			fk_tbl.conrelid = _qualified_table2check::regclass
				AND
			fk_tbl.confkey[1] = (
				select attnum from pg_catalog.pg_attribute col_tbl
				where
					col_tbl.attname = 'pk'
						AND
					col_tbl.attrelid = 'clin.episode'::regclass
			)
				AND
			fk_tbl.conkey[1] = (
				select attnum from pg_catalog.pg_attribute col_tbl
				where
					col_tbl.attname = _fk_episode_col
						AND
					col_tbl.attrelid = _qualified_table2check::regclass
			)
	) then
		raise exception
			'gm.create_enc_epi_sanity_check_trigger(): <%.%> does not point to clin.episode.pk', _qualified_table2check, _fk_episode_col
			USING ERRCODE = 'invalid_foreign_key'
		;
		return false;
	end if;
	-- re-create trigger
	_cmd := 'drop trigger if exists tr_sanity_check_enc_epi_ins_upd on ' || _qualified_table2check || ' cascade';
	execute _cmd;
	_cmd := 'create trigger tr_sanity_check_enc_epi_ins_upd ';
	_cmd := _cmd || 'before insert or update ';
	_cmd := _cmd || 'on ' || _qualified_table2check || ' ';
	_cmd := _cmd || 'for each row when (NEW.fk_episode is not null) ';
	_cmd := _cmd || 'execute procedure clin.trf_sanity_check_enc_epi_ins_upd(''' || _fk_encounter_col || ''', ''' || _fk_episode_col || ''')';
	execute _cmd;
	return True;
END;
$$;


ALTER FUNCTION gm.create_enc_epi_sanity_check_trigger(_schema_name name, _table_name name, _fk_encounter_col name, _fk_episode_col name) OWNER TO "gm-dbo";

--
-- Name: FUNCTION create_enc_epi_sanity_check_trigger(_schema_name name, _table_name name, _fk_encounter_col name, _fk_episode_col name); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.create_enc_epi_sanity_check_trigger(_schema_name name, _table_name name, _fk_encounter_col name, _fk_episode_col name) IS 'This function can be run on any table in order to add enccounter <-> episode sanity check triggers to that table.';


--
-- Name: create_generic_combi_vaccine(text, text[], text, boolean); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.create_generic_combi_vaccine(text, text[], text, boolean) RETURNS boolean
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
	_name alias for $1;
	_indications alias for $2;
	_atc alias for $3;
	_is_live alias for $4;
	_generic_name text;
	_pk_brand integer;
	_pk_vaccine integer;
	_indication text;
BEGIN
	_generic_name := _name || ' - generic vaccine';
	raise notice 're-creating [%] (%)', _generic_name, array_to_string(_indications, '-');
	-- retrieve or create ref.branded_drug entry for indication
	select pk into _pk_brand from ref.branded_drug
	where
		is_fake is true
			and
		description = _generic_name;
	if FOUND is false then
		insert into ref.branded_drug (
			description,
			preparation,
			is_fake,
			atc_code
		) values (
			_generic_name,
			'vaccine',		-- this is rather arbitrary
			True,
			coalesce(_atc, 'J07')
		)
		returning pk
		into _pk_brand;
	end if;
	-- retrieve or create clin.vaccine entry for generic brand
	select pk into _pk_vaccine from clin.vaccine
	where fk_brand = _pk_brand;
	if FOUND is false then
		insert into clin.vaccine (
			is_live,
			fk_brand
		) values (
			_is_live,
			_pk_brand
		)
		returning pk
		into _pk_vaccine;
	end if;
	-- link indications to vaccine
	delete from clin.lnk_vaccine2inds
	where
		fk_vaccine = _pk_vaccine;
	for _indication in select unnest(_indications) loop
		insert into clin.lnk_vaccine2inds (
			fk_vaccine,
			fk_indication
		) values (
			_pk_vaccine,
			(select id from clin.vacc_indication where description = _indication)
		);
	end loop;
	return true;
END;$_$;


ALTER FUNCTION gm.create_generic_combi_vaccine(text, text[], text, boolean) OWNER TO "gm-dbo";

--
-- Name: create_table_mod_triggers(name, name); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.create_table_mod_triggers(_schema_name name, _table_name name) RETURNS boolean
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_qualified_table text;
	_msg text;
	_payload text;
	_PK_col_name text;
	_pk_accessor_SQL text;
	_accessor_col text;
	_col_candidate text;
	_identity_accessor_SQL text;
	_cmd text;
BEGIN
	_qualified_table := _schema_name || '.' || _table_name;
	raise notice 'gm.create_table_mod_triggers(): %', _qualified_table;
	-- verify table exists
	if not exists(select 1 from information_schema.tables where table_schema = _schema_name and table_name = _table_name) then
		raise warning 'gm.create_table_mod_triggers(): table <%> does not exist', _qualified_table;
		raise exception undefined_table;
		return false;
	end if;
	-- find PK column
	select
		pg_attribute.attname into _PK_col_name
	from
		pg_index, pg_class, pg_attribute
	where
		pg_class.oid = _qualified_table::regclass
			AND
		indrelid = pg_class.oid
			AND
		pg_attribute.attrelid = pg_class.oid
			AND
		pg_attribute.attnum = any(pg_index.indkey)
			AND
		indisprimary;
	if _PK_col_name is NULL then
		raise warning 'gm.create_table_mod_triggers(): table <%> lacks a primary key', _qualified_table;
		raise exception undefined_column;
		return false;
	end if;
	_pk_accessor_SQL := 'select $1.' || _PK_col_name;
	-- find identity accessor
	-- special case
	if _qualified_table = 'dem.identity' then
		_identity_accessor_SQL := 'select $1.pk';
	else
		-- look for columns by which to retrieve affected person
		_accessor_col := NULL;
		foreach _col_candidate in array array['fk_identity', 'fk_patient', 'id_identity', 'fk_encounter'] loop
			if exists (
				select 1 from pg_class, pg_attribute where
				pg_class.oid = _qualified_table::regclass
					AND
				pg_attribute.attname = _col_candidate
					AND
				pg_attribute.attrelid = pg_class.oid
			) then
				_accessor_col := _col_candidate;
				exit;
			end if;
		end loop;
		if _accessor_col = 'fk_encounter' then					-- retrieve identity PK via fk_encounter
			_identity_accessor_SQL := 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1';
		elsif _accessor_col = 'fk_identity' then					-- retrieve identity PK via fk_identity
			_identity_accessor_SQL := 'select $1.fk_identity';
		elsif _accessor_col = 'fk_patient' then					-- retrieve identity PK via fk_patient
			_identity_accessor_SQL := 'select $1.fk_patient';
		elsif _accessor_col = 'id_identity' then					-- retrieve identity PK via id_identity
			_identity_accessor_SQL := 'select $1.id_identity';
		else
			_identity_accessor_SQL := '<NULL>';
		end if;
	end if;
	-- drop triggers should they exist
	-- new-name announcement triggers
	_cmd := 'drop trigger if exists zzz_tr_announce_' || _schema_name || '_' || _table_name || '_ins_upd on ' || _qualified_table || ' cascade;';
	execute _cmd;
	_cmd := 'drop trigger if exists zzz_tr_announce_' || _schema_name || '_' || _table_name || '_del on ' || _qualified_table || ' cascade;';
	execute _cmd;
	-- re-create triggers
	-- 1) INSERT/UPDATE
	_payload := 'table=' || _qualified_table || '::PK name=' || _PK_col_name;
	_cmd := 'create constraint trigger zzz_tr_announce_' || _schema_name || '_' || _table_name || '_ins_upd';
	_cmd := _cmd || ' after insert or update';
	_cmd := _cmd || ' on ' || _qualified_table;
	-- needed so a SELECT inside, say, _identity_accessor_SQL running
	-- concurrently to a "lengthy" TX does not create a serialization
	-- failure by being a rw-dependancy pivot
	_cmd := _cmd || ' deferrable initially deferred';
	_cmd := _cmd || ' for each row';
	_cmd := _cmd || ' execute procedure gm.trf_announce_table_ins_upd(''' || _payload || ''', ''' || _pk_accessor_SQL || ''', ''' || _identity_accessor_SQL || ''');';
	execute _cmd;
	-- 2) DELETE
	_payload := 'operation=DELETE::' || _payload;
	_cmd := 'create constraint trigger zzz_tr_announce_' || _schema_name || '_' || _table_name || '_del';
	_cmd := _cmd || ' after delete';
	_cmd := _cmd || ' on ' || _qualified_table;
	-- needed so a SELECT inside, say, _identity_accessor_SQL running
	-- concurrently to a "lengthy" TX does not create a serialization
	-- failure by being a rw-dependancy pivot
	_cmd := _cmd || ' deferrable initially deferred';
	_cmd := _cmd || ' for each row';
	_cmd := _cmd || ' execute procedure gm.trf_announce_table_del(''' || _payload || ''', ''' || _pk_accessor_SQL || ''', ''' || _identity_accessor_SQL || ''');';
	execute _cmd;
	return True;
END;
$_$;


ALTER FUNCTION gm.create_table_mod_triggers(_schema_name name, _table_name name) OWNER TO "gm-dbo";

--
-- Name: FUNCTION create_table_mod_triggers(_schema_name name, _table_name name); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.create_table_mod_triggers(_schema_name name, _table_name name) IS 'This function can be run on any table in order to add notification triggers to that table.';


--
-- Name: create_user(name, text); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.create_user(name, text) RETURNS boolean
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_username alias for $1;
	_password alias for $2;
	_database text;
	_query text;
BEGIN
	perform 1 from pg_user where usename = _username;
	if not FOUND then
		_query := 'create user ' || quote_ident(_username)
					|| ' with password ' || quote_literal(_password)
					|| ';';
		execute _query;
		perform 1 from pg_user where usename = _username;
		if not FOUND then
			raise exception 'cannot create user [%]', _username;
			return false;
		end if;
	end if;
	_query := 'alter group "gm-logins" add user ' || quote_ident(_username) || ';';
	execute _query;
	_query := 'alter group "gm-public" add user ' || quote_ident(_username) || ';';
	execute _query;
	-- satisfy "database = samerole" in pg_hba.conf
	select into _database current_database();
	_query := 'alter group ' || quote_ident(_database) || ' add user ' || quote_ident(_username) || ';';
	execute _query;
	return true;
END;$_$;


ALTER FUNCTION gm.create_user(name, text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION create_user(name, text); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.create_user(name, text) IS 'To create users one needs to have CREATEROLE rights. Only gm-dbo is
 GRANTed EXECUTE. This way users need to know the gm-dbo (GNUmed admin)
 password to execute the function.
 Newly created users belong to group "gm-public" by default.';


--
-- Name: disable_user(name); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.disable_user(name) RETURNS boolean
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_username alias for $1;
	_query text;
BEGIN
	perform 1 from pg_user where usename = _username;
	if not FOUND then
		return true;
	end if;
	_query := 'alter group "gm-logins" drop user ' || quote_ident(_username) || ';';
	execute _query;
	return true;
END;$_$;


ALTER FUNCTION gm.disable_user(name) OWNER TO "gm-dbo";

--
-- Name: FUNCTION disable_user(name); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.disable_user(name) IS 'To disable users one needs to have CREATEROLE rights.
 Only gm-dbo is GRANTed EXECUTE.
 This way users need to know the gm-dbo (GNUmed admin) password
 to execute the function.';


--
-- Name: drop_user(name); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.drop_user(name) RETURNS boolean
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_username alias for $1;
	_query text;
BEGIN
	perform 1 from pg_user where usename = _username;
	if not FOUND then
		return true;
	end if;
	_query := 'drop user ' || quote_ident(_username) || ';';
	execute _query;
	perform 1 from pg_user where usename = _username;
	if FOUND then
		return false;
	end if;
	return true;
END;$_$;


ALTER FUNCTION gm.drop_user(name) OWNER TO "gm-dbo";

--
-- Name: FUNCTION drop_user(name); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.drop_user(name) IS 'To drop users one needs to have CREATEROLE rights.
 Only gm-dbo is GRANTed EXECUTE.
 This way users need to know the gm-dbo (GNUmed admin) password
 to execute the function.';


--
-- Name: get_users(); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.get_users() RETURNS text[]
    LANGUAGE sql
    AS $$select gm.get_users(current_database());$$;


ALTER FUNCTION gm.get_users() OWNER TO "gm-dbo";

--
-- Name: get_users(name); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.get_users(name) RETURNS text[]
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_db alias for $1;
	_gm_users text[];
	_user text;
BEGIN
	-- GNUmed group roles
	_gm_users := ARRAY['gm-logins', 'gm-public', 'gm-doctors', 'gm-staff', _db];
	-- add roles being *members* of groups gm-logins, gm-public, _db
	FOR _user in
		select distinct rolname from pg_roles where oid in (
			select member from pg_auth_members where roleid in (
				select oid from pg_roles where rolname in ('gm-logins', 'gm-public', _db)
			)
		)
	LOOP
		continue when _user = 'postgres';
		continue when _user = any(_gm_users);
		_gm_users := _gm_users || _user;
	END LOOP;
	-- add roles mentioned in any *.modified_by fields
	FOR _user in select distinct modified_by from audit.audit_fields LOOP
		continue when _user = 'postgres';
		continue when _user = any(_gm_users);
		_gm_users := _gm_users || _user;
	END LOOP;
	-- add roles mentioned in dem.staff.db_user
	FOR _user in select distinct db_user from dem.staff LOOP
		continue when _user = 'postgres';
		continue when _user = any(_gm_users);
		_gm_users := _gm_users || _user;
	END LOOP;
	return _gm_users;
END;$_$;


ALTER FUNCTION gm.get_users(name) OWNER TO "gm-dbo";

--
-- Name: FUNCTION get_users(name); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.get_users(name) IS 'Convenience function listing all PostgreSQL accounts (roles) needed for a consistent dump of the database.';


--
-- Name: lo_chunked_md5(oid, integer); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.lo_chunked_md5(oid, integer) RETURNS text
    LANGUAGE plpgsql STABLE STRICT
    AS $_$
DECLARE
	lo_id alias for $1;
	chunk_size alias for $2;
	_lo_fd integer;
	_lo_size integer;
	_chunk_count integer;
	_remainder integer;
	_md5_concat text;
	INV_READ constant integer := x'40000'::integer;
	SEEK_SET constant integer := 0;
	SEEK_END constant integer := 2;
BEGIN
	-- check for existence of lo_id ?
	_lo_fd := lo_open(lo_id, INV_READ);
	-- get size
	_lo_size := lo_lseek(_lo_fd, 0, SEEK_END);
	PERFORM lo_close(_lo_fd);						-- move further down if loread() proves faster
	-- calculate chunks and remainder
	_chunk_count := _lo_size / chunk_size;
	_remainder := _lo_size % chunk_size;
	-- loop over chunks
	_md5_concat := '';
	FOR _chunk_id in 1.._chunk_count LOOP
		_md5_concat := _md5_concat || md5(lo_get(lo_id, (_chunk_id - 1) * chunk_size, chunk_size));
		-- using loread() may be faster (as it directly accesses the
		-- existing lo_fd and thusly does not need to re-open the LO
		-- each round)
	END LOOP;
	-- add remainder
	_md5_concat := _md5_concat || md5(lo_get(lo_id, _chunk_count * chunk_size, _remainder));
	return md5(_md5_concat);
END;$_$;


ALTER FUNCTION gm.lo_chunked_md5(oid, integer) OWNER TO "gm-dbo";

--
-- Name: FUNCTION lo_chunked_md5(oid, integer); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.lo_chunked_md5(oid, integer) IS 'Function to create a chunked md5 sum on arbitrarily large LARGE OBJECTs.';


--
-- Name: load_auto_explain(integer); Type: FUNCTION; Schema: gm; Owner: postgres
--

CREATE FUNCTION gm.load_auto_explain(_min_duration integer) RETURNS boolean
    LANGUAGE plpgsql SECURITY DEFINER
    AS $$
BEGIN
	IF _min_duration < 1500 THEN
		_min_duration := 1500;
	END IF;
	LOAD 'auto_explain';
	PERFORM set_config('auto_explain.log_min_duration'::TEXT, _min_duration::TEXT, false);
	PERFORM set_config('auto_explain.log_analyze'::TEXT, 'ON'::TEXT, false);
	PERFORM set_config('auto_explain.log_verbose'::TEXT, 'ON'::TEXT, false);
	PERFORM set_config('auto_explain.log_timing'::TEXT, 'ON'::TEXT, false);
	PERFORM set_config('auto_explain.log_nested_statements'::TEXT, 'ON'::TEXT, false);
	RETURN TRUE;
END;$$;


ALTER FUNCTION gm.load_auto_explain(_min_duration integer) OWNER TO postgres;

--
-- Name: FUNCTION load_auto_explain(_min_duration integer); Type: COMMENT; Schema: gm; Owner: postgres
--

COMMENT ON FUNCTION gm.load_auto_explain(_min_duration integer) IS 'Load and configure auto_explain.
.
Integer argument = auto_explain.log_min_duration in milliseconds with a lower bound of 1500.';


--
-- Name: log_access2emr(text); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.log_access2emr(text) RETURNS void
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
	_action alias for $1;
BEGIN
	if gm.is_null_or_blank_string(_action) then
		raise exception 'gm.log_access2emr(): action detail cannot be NULL or empty';
	end if;
	insert into gm.access_log (user_action) values ('EMR access: ' || _action);
	return;
END;$_$;


ALTER FUNCTION gm.log_access2emr(text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION log_access2emr(text); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.log_access2emr(text) IS 'This logs access to a patient EMR.';


--
-- Name: log_other_access(text); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.log_other_access(text) RETURNS void
    LANGUAGE sql SECURITY DEFINER
    AS $_$insert into gm.access_log (user_action) values ($1);$_$;


ALTER FUNCTION gm.log_other_access(text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION log_other_access(text); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.log_other_access(text) IS 'This logs access to the database.';


--
-- Name: log_script_insertion(text, text); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.log_script_insertion(text, text) RETURNS text
    LANGUAGE plpgsql
    AS $_$
declare
	_filename alias for $1;
	_version alias for $2;
	_hash text;
begin
	delete from gm.schema_revision where filename = _filename;
	insert into gm.schema_revision (filename, version) values (
		_filename,
		_version
	);
	perform gm.log_other_access (
		'database change script inserted: ' || _filename || ' (' || _version || ')'
	);
	select into _hash md5(gm.concat_table_structure());
	return _hash;
end;$_$;


ALTER FUNCTION gm.log_script_insertion(text, text) OWNER TO "gm-dbo";

--
-- Name: nullify_empty_string(text); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.nullify_empty_string(text) RETURNS text
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_input alias for $1;
BEGIN
	if _input is null then
		return null;
	end if;
	if trim(_input) = '' then
		return null;
	end if;
	return _input;
END;$_$;


ALTER FUNCTION gm.nullify_empty_string(text) OWNER TO "gm-dbo";

--
-- Name: register_notifying_table(name, name); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.register_notifying_table(name, name) RETURNS boolean
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_namespace alias for $1;
	_table alias for $2;
	dummy RECORD;
BEGIN
	-- does table exist ?
	select relname into dummy from pg_class where
		relname = _table and
		relnamespace = (select oid from pg_namespace where nspname = _namespace)
	;
	if not found then
		raise exception 'register_notifying_table(): Table [%.%] does not exist.', _namespace, _table;
	end if;
	-- make sure we can insert
	delete from gm.notifying_tables where
		table_name = _table
		and schema_name = _namespace;
	insert into gm.notifying_tables (
		schema_name,
		table_name
	) values (
		_namespace,
		_table
	);
	return true;
END;$_$;


ALTER FUNCTION gm.register_notifying_table(name, name) OWNER TO "gm-dbo";

--
-- Name: FUNCTION register_notifying_table(name, name); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.register_notifying_table(name, name) IS 'Register given table for notification trigger generator. Parameters are: (schema, table)';


--
-- Name: strip_allzeros_fraction(numeric); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.strip_allzeros_fraction(numeric) RETURNS numeric
    LANGUAGE plpgsql STRICT
    AS $_$
DECLARE
	_numeric_value alias for $1;
	_fraction numeric;
	_msg text;
BEGIN
	_fraction := _numeric_value - trunc(_numeric_value);
	if _fraction <> 0 then
		return _numeric_value;
	end if;
	BEGIN
		return _numeric_value::bigint::numeric;
	EXCEPTION
		WHEN numeric_value_out_of_range THEN
			RAISE NOTICE '[gm.strip_allzeros_fraction]: cannot strip from %', _numeric_value;
			RETURN _numeric_value;
	END;
END;$_$;


ALTER FUNCTION gm.strip_allzeros_fraction(numeric) OWNER TO "gm-dbo";

--
-- Name: FUNCTION strip_allzeros_fraction(numeric); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.strip_allzeros_fraction(numeric) IS 'Remove fractions containing only zeros (n.000...) from NUMERICs/DECIMALs.';


--
-- Name: transfer_users(text); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.transfer_users(text) RETURNS boolean
    LANGUAGE sql
    AS $_$select gm.transfer_users($1, current_database());$_$;


ALTER FUNCTION gm.transfer_users(text) OWNER TO "gm-dbo";

--
-- Name: transfer_users(text, text); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.transfer_users(text, text) RETURNS boolean
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_source_group alias for $1;
	_target_group alias for $2;
	member_ids int[];
	member_id int;
	member_name text;
	tmp text;
BEGIN
	-- source group exists ?
	perform 1 from pg_group where groname = _source_group;
	if not FOUND then
		raise exception 'gm_transfer_users(): source group [%] does not exist', _source_group;
		return false;
	end if;
	-- target group exists ?
	perform 1 from pg_group where groname = _target_group;
	if not FOUND then
		raise exception 'gm_transfer_users(): target group [%] does not exist', _target_group;
		return false;
	end if;
	-- loop over group member IDs
	select into member_ids grolist from pg_group where groname = _source_group;
	FOR idx IN coalesce(array_lower(member_ids, 1), 0) .. coalesce(array_upper(member_ids, 1), -1) LOOP
		member_id := member_ids[idx];
		select into member_name usename from pg_user where usesysid = member_id;
		tmp := 'gm_transfer_users(text): transferring "'
				|| member_name || '" ('
				|| member_id || ') from group "'
				|| _source_group || '" to group "'
				|| _target_group || '"';
		raise notice '%', tmp;
		-- satisfy "database = samegroup" in pg_hba.conf
		tmp := 'alter group ' || quote_ident(_target_group) || ' add user ' || quote_ident(member_name) || ';';
		execute tmp;
	end LOOP;
	return true;
END;$_$;


ALTER FUNCTION gm.transfer_users(text, text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION transfer_users(text, text); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.transfer_users(text, text) IS 'This function transfers adds users from the group role given in the
 argument to the group role corresponding to the current database
 name. This enables group membership based authentication as used
 in GNUmed. This operation is typically only run on database upgrade
 and is only available to gm-dbo.';


--
-- Name: trf_announce_table_del(); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.trf_announce_table_del() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
declare
	_payload text;
	_pk_accessor_SQL text;
	_pk_col_val integer;
	_identity_accessor_SQL text;
	_pk_identity integer;
begin
	_pk_accessor_SQL := TG_ARGV[1];
	EXECUTE _pk_accessor_SQL INTO STRICT _pk_col_val USING OLD;
	_payload := TG_ARGV[0] || '::row PK=' || coalesce(_pk_col_val::text, 'NULL');
	_identity_accessor_SQL := TG_ARGV[2];
	if _identity_accessor_SQL <> '<NULL>' then
		--raise notice '%.%: %', TG_TABLE_SCHEMA, TG_TABLE_NAME, _identity_accessor_SQL;
		EXECUTE _identity_accessor_SQL INTO STRICT _pk_identity USING OLD;
		_payload := _payload || '::person PK=' || coalesce(_pk_identity::text, 'NULL');
	end if;
	perform pg_notify('gm_table_mod', _payload);
	return NULL;
end;
$$;


ALTER FUNCTION gm.trf_announce_table_del() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_announce_table_del(); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.trf_announce_table_del() IS 'Trigger function announcing a DELETE on a table.
sends signal: gm_table_mod
payload:
	operation=DELETE,
	table=the table that is updated,
	PK name=the name of the PK column of the table (requires single column PKs),
	row PK=the PK of the affected row,
	person PK=the PK of the affected person,
';


--
-- Name: trf_announce_table_ins_upd(); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.trf_announce_table_ins_upd() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
declare
	_payload text;
	_pk_accessor_SQL text;
	_pk_col_val integer;
	_identity_accessor_SQL text;
	_pk_identity integer;
begin
	_pk_accessor_SQL := TG_ARGV[1];
	EXECUTE _pk_accessor_SQL INTO STRICT _pk_col_val USING NEW;
	_payload := 'operation=' || TG_OP || '::' || TG_ARGV[0] || '::row PK=' || coalesce(_pk_col_val::text, 'NULL');
	_identity_accessor_SQL := TG_ARGV[2];
	if _identity_accessor_SQL <> '<NULL>' then
		EXECUTE _identity_accessor_SQL INTO STRICT _pk_identity USING NEW;
		_payload := _payload || '::person PK=' || coalesce(_pk_identity::text, 'NULL');
	end if;
	perform pg_notify('gm_table_mod', _payload);
	return NULL;
end;
$$;


ALTER FUNCTION gm.trf_announce_table_ins_upd() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_announce_table_ins_upd(); Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON FUNCTION gm.trf_announce_table_ins_upd() IS 'Trigger function announcing an INSERT or UPDATE to a table.
sends signal: gm_table_mod
payload:
	operation=INSERT/UPDATE,
	table=the table that is updated,
	PK name=the name of the PK column of the table (requires single column PKs),
	row PK=the PK of the affected row,
	person PK=the PK of the affected person,
';


--
-- Name: user_exists(name); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.user_exists(name) RETURNS boolean
    LANGUAGE plpgsql
    AS $_$
BEGIN
	perform 1 from pg_user where usename = $1;
	if not FOUND then
		raise notice 'Cannot set database language. User % does not exist.', $1;
		return false;
	end if;
	return true;
END;$_$;


ALTER FUNCTION gm.user_exists(name) OWNER TO "gm-dbo";

--
-- Name: xid2int(xid); Type: FUNCTION; Schema: gm; Owner: gm-dbo
--

CREATE FUNCTION gm.xid2int(xid) RETURNS integer
    LANGUAGE sql
    AS $_$select $1::text::integer;$_$;


ALTER FUNCTION gm.xid2int(xid) OWNER TO "gm-dbo";

--
-- Name: _(text); Type: FUNCTION; Schema: i18n; Owner: gm-dbo
--

CREATE FUNCTION i18n._(text) RETURNS text
    LANGUAGE sql
    AS $_$select i18n._($1, i18n.get_curr_lang())$_$;


ALTER FUNCTION i18n._(text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION _(text); Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON FUNCTION i18n._(text) IS 'will return either the translation into
	 i18n.curr_lang.lang for the current user
	 or the input,
	 created in public schema for easy access';


--
-- Name: _(text, text); Type: FUNCTION; Schema: i18n; Owner: gm-dbo
--

CREATE FUNCTION i18n._(text, text) RETURNS text
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
	_orig alias for $1;
	_lang alias for $2;
	trans_str text;
BEGIN
	select into trans_str trans from i18n.translations where lang = _lang and orig = _orig;
	if not found then
		-- reduce xx_XX@YY to xx
		select into trans_str trans from i18n.translations where lang = regexp_replace(_lang, '_.*$', '') and orig = _orig;
		if not found then
			return _orig;
		end if;
--		if not found then
--			-- check "generic" dummy translation used to work around accentuation problems
--			select into trans_str trans from i18n.translations where lang = 'generic' and orig = _orig;
--
--			if not found then
--				return _orig;
--			end if;
--		end if;
	end if;
	return trans_str;
END;
$_$;


ALTER FUNCTION i18n._(text, text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION _(text, text); Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON FUNCTION i18n._(text, text) IS 'will return either the translation into <lang>::text
 (2nd argument) for the current user or the input,
 created in public schema for easy access,
 will fallback to "xx" if xx_XX does not exist';


--
-- Name: force_curr_lang(text); Type: FUNCTION; Schema: i18n; Owner: gm-dbo
--

CREATE FUNCTION i18n.force_curr_lang(text) RETURNS boolean
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
    _lang ALIAS FOR $1;
BEGIN
    raise notice 'Forcing current language to [%] without checking for translations..', _lang;
    delete from i18n.curr_lang where db_user = SESSION_USER;
	insert into i18n.curr_lang (lang, db_user) values (_lang, SESSION_USER);
    return true;
END;
$_$;


ALTER FUNCTION i18n.force_curr_lang(text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION force_curr_lang(text); Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON FUNCTION i18n.force_curr_lang(text) IS 'force preferred language to some language:
	 - for "current user"';


--
-- Name: get_curr_lang(); Type: FUNCTION; Schema: i18n; Owner: gm-dbo
--

CREATE FUNCTION i18n.get_curr_lang() RETURNS text
    LANGUAGE sql
    AS $$select i18n.get_curr_lang(CURRENT_USER)$$;


ALTER FUNCTION i18n.get_curr_lang() OWNER TO "gm-dbo";

--
-- Name: get_curr_lang(text); Type: FUNCTION; Schema: i18n; Owner: gm-dbo
--

CREATE FUNCTION i18n.get_curr_lang(text) RETURNS text
    LANGUAGE sql
    AS $_$select lang from i18n.curr_lang where db_user = $1$_$;


ALTER FUNCTION i18n.get_curr_lang(text) OWNER TO "gm-dbo";

--
-- Name: i18n(text); Type: FUNCTION; Schema: i18n; Owner: gm-dbo
--

CREATE FUNCTION i18n.i18n(text) RETURNS text
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
	original ALIAS FOR $1;
BEGIN
	if not exists(select pk from i18n.keys where orig = original) then
		insert into i18n.keys (orig) values (original);
	end if;
	return original;
END;
$_$;


ALTER FUNCTION i18n.i18n(text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION i18n(text); Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON FUNCTION i18n.i18n(text) IS 'insert original strings into i18n.keys for later translation';


--
-- Name: set_curr_lang(text); Type: FUNCTION; Schema: i18n; Owner: gm-dbo
--

CREATE FUNCTION i18n.set_curr_lang(text) RETURNS boolean
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
	_lang ALIAS FOR $1;
BEGIN
	if exists(select pk from i18n.translations where lang = _lang) then
		delete from i18n.curr_lang where db_user = SESSION_USER;
		insert into i18n.curr_lang (lang, db_user) values (_lang, SESSION_USER);
		return true;
	end if;
	raise notice 'Cannot set current language to [%]. No translations available.', _lang;
	return false;
END;
$_$;


ALTER FUNCTION i18n.set_curr_lang(text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION set_curr_lang(text); Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON FUNCTION i18n.set_curr_lang(text) IS 'set preferred language:
	 - for "current (session) user"
	 - only if translations for this language are available';


--
-- Name: set_curr_lang(text, name); Type: FUNCTION; Schema: i18n; Owner: gm-dbo
--

CREATE FUNCTION i18n.set_curr_lang(text, name) RETURNS boolean
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
	_lang ALIAS FOR $1;
	_db_user ALIAS FOR $2;
	lang_has_tx boolean;
BEGIN
	select into lang_has_tx exists(select pk from i18n.translations where lang = _lang);
	if lang_has_tx is False then
		raise notice 'Cannot set current language to [%]. No translations available.', _lang;
		return False;
	end if;
	delete from i18n.curr_lang where db_user = _db_user;
	insert into i18n.curr_lang (db_user, lang) values (_db_user, _lang);
	return true;
END;
$_$;


ALTER FUNCTION i18n.set_curr_lang(text, name) OWNER TO "gm-dbo";

--
-- Name: FUNCTION set_curr_lang(text, name); Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON FUNCTION i18n.set_curr_lang(text, name) IS 'set language to first argument for the user named in
	 the second argument if translations are available';


--
-- Name: tx_or_null(text); Type: FUNCTION; Schema: i18n; Owner: gm-dbo
--

CREATE FUNCTION i18n.tx_or_null(text) RETURNS text
    LANGUAGE sql
    AS $_$select i18n.tx_or_null($1, i18n.get_curr_lang())$_$;


ALTER FUNCTION i18n.tx_or_null(text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION tx_or_null(text); Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON FUNCTION i18n.tx_or_null(text) IS 'will return either the translation into i18n.curr_lang.lang for the current user or null';


--
-- Name: tx_or_null(text, text); Type: FUNCTION; Schema: i18n; Owner: gm-dbo
--

CREATE FUNCTION i18n.tx_or_null(text, text) RETURNS text
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
DECLARE
	_orig alias for $1;
	_lang alias for $2;
	trans_str text;
BEGIN
	select into trans_str trans from i18n.translations where lang = _lang and orig = _orig;
	if not found then
		return null;
	end if;
	return trans_str;
END;
$_$;


ALTER FUNCTION i18n.tx_or_null(text, text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION tx_or_null(text, text); Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON FUNCTION i18n.tx_or_null(text, text) IS 'will return either the translation into language <text> (2nd argument) or null';


--
-- Name: unset_curr_lang(); Type: FUNCTION; Schema: i18n; Owner: gm-dbo
--

CREATE FUNCTION i18n.unset_curr_lang() RETURNS void
    LANGUAGE sql
    AS $$select i18n.unset_curr_lang(CURRENT_USER);$$;


ALTER FUNCTION i18n.unset_curr_lang() OWNER TO "gm-dbo";

--
-- Name: FUNCTION unset_curr_lang(); Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON FUNCTION i18n.unset_curr_lang() IS 'unset the db language for the current user';


--
-- Name: unset_curr_lang(name); Type: FUNCTION; Schema: i18n; Owner: gm-dbo
--

CREATE FUNCTION i18n.unset_curr_lang(name) RETURNS void
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
BEGIN
	delete from i18n.curr_lang where db_user = $1;
	return;
END;$_$;


ALTER FUNCTION i18n.unset_curr_lang(name) OWNER TO "gm-dbo";

--
-- Name: FUNCTION unset_curr_lang(name); Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON FUNCTION i18n.unset_curr_lang(name) IS 'unset the db language for a user (thereby reverting to the default English)';


--
-- Name: untranslate(text, text); Type: FUNCTION; Schema: i18n; Owner: gm-dbo
--

CREATE FUNCTION i18n.untranslate(text, text) RETURNS text
    LANGUAGE plpgsql
    AS $_$
DECLARE
	_trans alias for $1;
	_lang alias for $2;
	_orig text;
BEGIN
	select orig into _orig
	from i18n.translations
	where
		trans = _trans
			and
		lang = _lang;
	return _orig;
END;$_$;


ALTER FUNCTION i18n.untranslate(text, text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION untranslate(text, text); Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON FUNCTION i18n.untranslate(text, text) IS 'Return "original" from a "translated" string (1st argument) as per language (2nd argument).';


--
-- Name: upd_tx(text, text); Type: FUNCTION; Schema: i18n; Owner: gm-dbo
--

CREATE FUNCTION i18n.upd_tx(text, text) RETURNS boolean
    LANGUAGE sql
    AS $_$select i18n.upd_tx((select i18n.get_curr_lang()), $1, $2)$_$;


ALTER FUNCTION i18n.upd_tx(text, text) OWNER TO "gm-dbo";

--
-- Name: upd_tx(text, text, text); Type: FUNCTION; Schema: i18n; Owner: gm-dbo
--

CREATE FUNCTION i18n.upd_tx(text, text, text) RETURNS boolean
    LANGUAGE plpgsql SECURITY DEFINER
    AS $_$
declare
	_lang alias for $1;
	_orig alias for $2;
	_trans alias for $3;
	_tmp text;
begin
	if _lang is null then
		raise notice 'i18n.upd_tx(text, text, text): Cannot create translation for language <NULL>.';
		return False;
	end if;
	if _trans = _orig then
		raise notice 'i18n.upd_tx(text, text, text): Original = translation. Skipping.';
		return True;
	end if;
	select into _tmp '1' from i18n.keys where orig = _orig;
	if not found then
		raise notice 'i18n.upd_tx(text, text, text): [%] not found in i18n.keys. Creating entry.', _orig;
		insert into i18n.keys (orig) values (_orig);
	end if;
	delete from i18n.translations where lang = _lang and orig = _orig;
	insert into i18n.translations (lang, orig, trans) values (_lang, _orig, _trans);
	raise notice 'i18n.upd_tx(%: [%] ==> [%])', _lang, _orig, _trans;
	return True;
end;$_$;


ALTER FUNCTION i18n.upd_tx(text, text, text) OWNER TO "gm-dbo";

--
-- Name: _(text); Type: FUNCTION; Schema: public; Owner: gm-dbo
--

CREATE FUNCTION public._(text) RETURNS text
    LANGUAGE sql
    AS $_$select i18n._($1)$_$;


ALTER FUNCTION public._(text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION _(text); Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON FUNCTION public._(text) IS 'will return either the translation into
	 i18n.curr_lang.lang for the current user
	 or the input,
	 created in public schema for easy access';


--
-- Name: _(text, text); Type: FUNCTION; Schema: public; Owner: gm-dbo
--

CREATE FUNCTION public._(text, text) RETURNS text
    LANGUAGE sql
    AS $_$select i18n._($1, $2)$_$;


ALTER FUNCTION public._(text, text) OWNER TO "gm-dbo";

--
-- Name: FUNCTION _(text, text); Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON FUNCTION public._(text, text) IS 'will return either the translation into <text>
	 (2nd argument) for the current user or the input,
	 created in public schema for easy access';


--
-- Name: f_rfi_type2item(); Type: FUNCTION; Schema: public; Owner: gm-dbo
--

CREATE FUNCTION public.f_rfi_type2item() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
declare
	dummy integer;
	msg text;
begin
	-- does fk_item change at all ?
	if TG_OP = 'UPDATE' then
		if NEW.fk_item = OLD.fk_item then
			return NEW;
		end if;
	end if;
	-- check referential integrity
	select into dummy 1 from clin.clin_root_item where pk_item=NEW.fk_item;
	if not found then
		msg := 'referential integrity violation: clin.lnk_type2item.fk_item [' || NEW.fk_item || '] not in <clin_root_item.pk_item>';
		raise exception '%', msg;
		return NULL;
	end if;
	return NEW;
end;
$$;


ALTER FUNCTION public.f_rfi_type2item() OWNER TO "gm-dbo";

--
-- Name: FUNCTION f_rfi_type2item(); Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON FUNCTION public.f_rfi_type2item() IS 'function used to check referential integrity from
	 clin.lnk_type2item to clin.clin_root_item with a custom trigger';


--
-- Name: f_set_encounter_timezone(); Type: FUNCTION; Schema: public; Owner: gm-dbo
--

CREATE FUNCTION public.f_set_encounter_timezone() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
begin
	if TG_OP = 'INSERT' then
		NEW.source_time_zone := (select (extract(timezone from (select now()))::text || 'seconds')::interval);
	else
		NEW.source_time_zone := OLD.source_time_zone;
	end if;
	return NEW;
end;
$$;


ALTER FUNCTION public.f_set_encounter_timezone() OWNER TO "gm-dbo";

--
-- Name: trf_announce_substance_in_brand_mod_no_pk(); Type: FUNCTION; Schema: ref; Owner: gm-dbo
--

CREATE FUNCTION ref.trf_announce_substance_in_brand_mod_no_pk() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
begin
	execute 'notify "substance_in_brand_mod_db:"';
	return NULL;
end;
$$;


ALTER FUNCTION ref.trf_announce_substance_in_brand_mod_no_pk() OWNER TO "gm-dbo";

--
-- Name: trf_assert_product_has_components(); Type: FUNCTION; Schema: ref; Owner: gm-dbo
--

CREATE FUNCTION ref.trf_assert_product_has_components() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_msg text;
BEGIN
	PERFORM 1 FROM ref.lnk_dose2drug WHERE fk_drug_product = NEW.pk LIMIT 1;
	IF FOUND THEN
		RETURN NEW;
	END IF;
	_msg := '[ref.trf_assert_product_has_components()]: '
		|| TG_OP
		|| ' failed: no components (doses) linked to drug product ['
		|| NEW.pk
		|| '].'
	;
	RAISE EXCEPTION integrity_constraint_violation using message = _msg;
	RETURN NEW;
END;$$;


ALTER FUNCTION ref.trf_assert_product_has_components() OWNER TO "gm-dbo";

--
-- Name: trf_assert_product_keeps_components(); Type: FUNCTION; Schema: ref; Owner: gm-dbo
--

CREATE FUNCTION ref.trf_assert_product_keeps_components() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_msg text;
BEGIN
	PERFORM 1 FROM ref.lnk_dose2drug WHERE fk_drug_product = OLD.pk LIMIT 1;
	-- any components left ?
	IF FOUND THEN
		-- does not matter
		RETURN OLD;
	END IF;
	PERFORM 1 FROM ref.drug_product WHERE pk = OLD.fk_drug_product LIMIT 1;
	-- drug AND components deleted ?
	IF NOT FOUND THEN
		-- does not matter
		RETURN OLD;
	END IF;
	_msg := '[ref.trf_assert_product_keeps_components()]: '
		|| TG_OP
		|| ' failed: no components (doses) linked to drug product ['
		|| OLD.pk
		|| '] anymore.'
	;
	RAISE EXCEPTION integrity_constraint_violation using message = _msg;
	-- does not matter
	RETURN OLD;
END;$$;


ALTER FUNCTION ref.trf_assert_product_keeps_components() OWNER TO "gm-dbo";

--
-- Name: trf_consumable_subst_normalize_amount(); Type: FUNCTION; Schema: ref; Owner: gm-dbo
--

CREATE FUNCTION ref.trf_consumable_subst_normalize_amount() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
	NEW.amount := gm.strip_allzeros_fraction(NEW.amount);
	return NEW;
END;$$;


ALTER FUNCTION ref.trf_consumable_subst_normalize_amount() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_consumable_subst_normalize_amount(); Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON FUNCTION ref.trf_consumable_subst_normalize_amount() IS 'On INSERT/UPDATE drop .000 all-zero fractions from amounts.';


--
-- Name: trf_del_ref_code_tbl_check_backlink(); Type: FUNCTION; Schema: ref; Owner: gm-dbo
--

CREATE FUNCTION ref.trf_del_ref_code_tbl_check_backlink() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_msg text;
BEGIN
	perform 1 from clin.lnk_code2item_root where fk_generic_code = NEW.pk_coding_system;
	if not FOUND then
		return OLD;
	end if;
	_msg := 'ref.trf_del_ref_code_tbl_check_backlink(): DELETE from '
		|| TG_TABLE_SCHEMA || '.' || TG_TABLE_NAME || ': '
		|| 'pk_coding_system=(' || NEW.pk_coding_system || ') '
		|| 'in use in clin.lnk_code2item_root.fk_generic_code, '
		|| 'old pk_coding_system=(' || OLD.pk_coding_system || ')';
	raise foreign_key_violation using message = _msg;
	return OLD;
END;$$;


ALTER FUNCTION ref.trf_del_ref_code_tbl_check_backlink() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_del_ref_code_tbl_check_backlink(); Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON FUNCTION ref.trf_del_ref_code_tbl_check_backlink() IS 'When deleting from any child of ref.coding_system_root check whether its row is being used in any clin.lnk_code2item_root child.';


--
-- Name: trf_do_not_update_component_if_taken_by_patient(); Type: FUNCTION; Schema: ref; Owner: gm-dbo
--

CREATE FUNCTION ref.trf_do_not_update_component_if_taken_by_patient() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
	if OLD.fk_brand = NEW.fk_brand then
		if OLD.fk_substance = NEW.fk_substance then
			return NEW;
		end if;
	end if;
	perform 1 from clin.substance_intake c_si
	where c_si.fk_drug_component = OLD.pk
	limit 1;
	if NOT FOUND then
		return NEW;
	end if;
	raise exception '[ref.trf_do_not_update_component_if_taken_by_patient]: as long as drug component <%> is taken by a patient you cannot modify it', OLD.pk;
	return NEW;
END;$$;


ALTER FUNCTION ref.trf_do_not_update_component_if_taken_by_patient() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_do_not_update_component_if_taken_by_patient(); Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON FUNCTION ref.trf_do_not_update_component_if_taken_by_patient() IS 'If this drug component is taken by any patient do not modify it (
amount, unit, substance, brand).';


--
-- Name: trf_do_not_update_substance_if_taken_by_patient(); Type: FUNCTION; Schema: ref; Owner: gm-dbo
--

CREATE FUNCTION ref.trf_do_not_update_substance_if_taken_by_patient() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_msg text;
BEGIN
	-- allow for case insensitive non-changes
	if upper(OLD.description) = upper(NEW.description) then
		if OLD.amount = NEW.amount then
			if upper(OLD.unit) = upper(NEW.unit) then
				return NEW;
			end if;
		end if;
	end if;
	_msg := '[ref.trf_do_not_update_substance_if_taken_by_patient]: as long as substance <' || OLD.description || '> is taken by a patient you cannot modify it';
	perform 1 from clin.substance_intake c_si
	where c_si.fk_substance = OLD.pk
	limit 1;
	if FOUND then
		raise exception '%', _msg;
	end if;
	PERFORM 1
	FROM clin.substance_intake c_si
	WHERE c_si.fk_drug_component IN (
		-- get all PKs in component link table which
		-- represent the substance we want to modify
		SELECT
			r_ls2b.pk
		FROM
			ref.lnk_substance2brand r_ls2b
		WHERE
			r_ls2b.fk_substance = OLD.pk
	)
	LIMIT 1;
	if FOUND then
		raise exception '%', _msg;
	end if;
	return NEW;
END;$$;


ALTER FUNCTION ref.trf_do_not_update_substance_if_taken_by_patient() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_do_not_update_substance_if_taken_by_patient(); Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON FUNCTION ref.trf_do_not_update_substance_if_taken_by_patient() IS 'If this substance is taken by any patient do not modify description, amount, or unit (case changes allowed).';


--
-- Name: trf_ins_upd_assert_dose_unit_across_drug_components(); Type: FUNCTION; Schema: ref; Owner: gm-dbo
--

CREATE FUNCTION ref.trf_ins_upd_assert_dose_unit_across_drug_components() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_dose_unit_count integer;
	_msg text;
BEGIN
	SELECT count(1) into strict _dose_unit_count
	FROM (
		SELECT dose_unit
		FROM ref.v_drug_components
		WHERE pk_drug_product = NEW.fk_drug_product
		GROUP BY dose_unit
	) AS dose_unit_count;
	if _dose_unit_count = 1 then
		return NEW;
	end if;
	_msg := '[ref.trf_ins_upd_assert_dose_unit_across_drug_components()]: cannot link substance dose [' || NEW.fk_dose || '] '
		|| 'to drug product [' || NEW.fk_drug_product || '] '
		|| 'because all components must have the same <dose_unit>';
	raise exception check_violation using message = _msg;
	return NEW;
END;$$;


ALTER FUNCTION ref.trf_ins_upd_assert_dose_unit_across_drug_components() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_ins_upd_assert_dose_unit_across_drug_components(); Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON FUNCTION ref.trf_ins_upd_assert_dose_unit_across_drug_components() IS 'Assert that all substance doses linked into a multi-component drug carry the same <dose_unit>';


--
-- Name: trf_protect_template_data(); Type: FUNCTION; Schema: ref; Owner: gm-dbo
--

CREATE FUNCTION ref.trf_protect_template_data() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
	if NEW.data != OLD.data then
		-- look for references in clin.form_instances
		-- if there are any we fail this update no matter what
		perform 1 from clin.form_instances where fk_form_def = NEW.pk;
		if FOUND then
			raise exception 'Updating ref.paperwork_templates.data not allowed because it is referenced from existing forms.';
		end if;
	end if;
	-- otherwise let it happen
	return NEW;
END;$$;


ALTER FUNCTION ref.trf_protect_template_data() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_protect_template_data(); Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON FUNCTION ref.trf_protect_template_data() IS 'Do not allow updates to the template data if
	 any forms already use this template.';


--
-- Name: trf_true_brands_must_have_components(); Type: FUNCTION; Schema: ref; Owner: gm-dbo
--

CREATE FUNCTION ref.trf_true_brands_must_have_components() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_brand_is_deleted boolean;
	_is_fake_brand boolean;
	_has_other_components boolean;
BEGIN
	-- if an UPDATE does NOT move the component to another drug
	-- there WILL be at least one component left
	if TG_OP = 'UPDATE' then
		if NEW.fk_brand = OLD.fk_brand then
			return NEW;
		end if;
	end if;
	-- fake drugs may become devoid of components
	select
		is_fake into _is_fake_brand
	from
		ref.branded_drug
	where
		pk = OLD.fk_brand
	;
	if _is_fake_brand is TRUE then
		return OLD;
	end if;
	-- DELETEs may proceed if the drug has been deleted, too
	if TG_OP = 'DELETE' then
		select not exists (
			select 1 from ref.branded_drug
			where pk = OLD.fk_brand
		) into _brand_is_deleted;
		if _brand_is_deleted is TRUE then
			return OLD;
		end if;
	end if;
	-- if there are other components left after the
	-- UPDATE or DELETE everything is fine
	select exists (
		select 1 from ref.lnk_substance2brand
		where
			fk_brand = OLD.fk_brand
				and
			fk_substance != OLD.fk_substance
		limit 1
	) into _has_other_components;
	if _has_other_components is TRUE then
		return OLD;
	end if;
	raise exception '[ref.trf_true_brands_must_have_components::%] brand must have components (brand <%> component <%>)', TG_OP, OLD.fk_brand, OLD.fk_substance;
	return OLD;
END;$$;


ALTER FUNCTION ref.trf_true_brands_must_have_components() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_true_brands_must_have_components(); Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON FUNCTION ref.trf_true_brands_must_have_components() IS 'There must always be at least one component for any existing non-fake branded drug.';


--
-- Name: trf_upd_assert_dose_unit_in_multi_component_drugs(); Type: FUNCTION; Schema: ref; Owner: gm-dbo
--

CREATE FUNCTION ref.trf_upd_assert_dose_unit_in_multi_component_drugs() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_pk_drug_product integer;
	_component_count integer;
	_dose_unit_count integer;
	_msg text;
BEGIN
	SELECT fk_drug_product into strict _pk_drug_product
	FROM ref.lnk_dose2drug
	WHERE fk_dose = NEW.pk;
	if FOUND IS FALSE then
		return NEW;
	end if;
	SELECT count(1) into strict _component_count
	FROM ref.lnk_dose2drug
	WHERE fk_drug_product = _pk_drug_product;
	if _component_count = 1 then
		return NEW;
	end if;
	SELECT count(1) into strict _dose_unit_count
	FROM (
		SELECT dose_unit
		FROM ref.v_drug_components
		WHERE pk_drug_product = _pk_drug_product
		GROUP BY dose_unit
	) AS dose_unit_count;
	if _dose_unit_count = 1 then
		return NEW;
	end if;
	_msg := '[ref.trf_upd_assert_dose_unit_in_multi_component_drugs()]: cannot change <dose_unit> on dose [' || NEW.pk || '] '
		|| 'from [' || coalesce(OLD.dose_unit, '<NULL>') || '] '
		|| 'to [' || coalesce(NEW.dose_unit, '<NULL>') || '] '
		|| 'because all doses linked to drug product [' || _pk_drug_product || '] '
		|| 'must have the same <dose_unit>';
	raise exception check_violation using message = _msg;
	return NEW;
END;$$;


ALTER FUNCTION ref.trf_upd_assert_dose_unit_in_multi_component_drugs() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_upd_assert_dose_unit_in_multi_component_drugs(); Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON FUNCTION ref.trf_upd_assert_dose_unit_in_multi_component_drugs() IS 'Assert that after updates to ref.dose.dose_unit all substance doses linked into a multi-component drug still carry the same <dose_unit>.';


--
-- Name: trf_upd_ref_code_tbl_check_backlink(); Type: FUNCTION; Schema: ref; Owner: gm-dbo
--

CREATE FUNCTION ref.trf_upd_ref_code_tbl_check_backlink() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
DECLARE
	_msg text;
BEGIN
	if NEW.pk_coding_system = OLD.pk_coding_system then
		return NEW;
	end if;
	perform 1 from clin.lnk_code2item_root where fk_generic_code = NEW.pk_coding_system;
	if not FOUND then
		return NEW;
	end if;
	_msg := 'ref.trf_upd_ref_code_tbl_check_backlink(): UPDATE of '
		|| TG_TABLE_SCHEMA || '.' || TG_TABLE_NAME || ': '
		|| 'pk_coding_system=(' || NEW.pk_coding_system || ') '
		|| 'in use in clin.lnk_code2item_root.fk_generic_code, '
		|| 'old pk_coding_system=(' || OLD.pk_coding_system || ')';
	raise foreign_key_violation using message = _msg;
	return OLD;
END;$$;


ALTER FUNCTION ref.trf_upd_ref_code_tbl_check_backlink() OWNER TO "gm-dbo";

--
-- Name: FUNCTION trf_upd_ref_code_tbl_check_backlink(); Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON FUNCTION ref.trf_upd_ref_code_tbl_check_backlink() IS 'When updating any child of ref.coding_system_root check whether its row is being used in any clin.lnk_code2item_root child.';


--
-- Name: clin_root_item; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.clin_root_item (
    pk_item integer NOT NULL,
    clin_when timestamp with time zone DEFAULT now() NOT NULL,
    fk_encounter integer NOT NULL,
    fk_episode integer NOT NULL,
    narrative text,
    soap_cat text,
    CONSTRAINT clin_root_item_sane_soap_cat CHECK (((soap_cat IS NULL) OR (soap_cat = ANY (ARRAY['s'::text, 'o'::text, 'a'::text, 'p'::text, 'u'::text]))))
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.clin_root_item OWNER TO "gm-dbo";

--
-- Name: TABLE clin_root_item; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.clin_root_item IS 'ancestor table for clinical items of any kind, basic
	 unit of clinical information, do *not* store data in
	 here directly, use child tables,
	 contains all the clinical narrative aggregated for full
	 text search, ancestor for all tables that want to store
	 clinical free text';


--
-- Name: COLUMN clin_root_item.pk_item; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.clin_root_item.pk_item IS 'the primary key, not named "id" or "pk" as usual since child
	 tables will have "id"/"pk"-named primary keys already and
	 we would get duplicate columns while inheriting from this
	 table';


--
-- Name: COLUMN clin_root_item.clin_when; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.clin_root_item.clin_when IS 'when this clinical item became known, can be different from
	 when it was entered into the system (= audit.audit_fields.modified_when)';


--
-- Name: COLUMN clin_root_item.fk_encounter; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.clin_root_item.fk_encounter IS 'the encounter this item belongs to';


--
-- Name: COLUMN clin_root_item.fk_episode; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.clin_root_item.fk_episode IS 'the episode this item belongs to';


--
-- Name: COLUMN clin_root_item.narrative; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.clin_root_item.narrative IS 'each clinical item by default inherits a free text field for clinical narrative';


--
-- Name: COLUMN clin_root_item.soap_cat; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.clin_root_item.soap_cat IS 'each clinical item must be either one of the S, O, A, P, U
	 categories or NULL to indicate a non-clinical item, U meaning Unspecified-but-clinical';


--
-- Name: referral; Type: TABLE; Schema: au; Owner: gm-dbo
--

CREATE TABLE au.referral (
    id integer NOT NULL,
    fk_referee integer NOT NULL,
    fk_form integer NOT NULL
)
INHERITS (clin.clin_root_item);


ALTER TABLE au.referral OWNER TO "gm-dbo";

--
-- Name: TABLE referral; Type: COMMENT; Schema: au; Owner: gm-dbo
--

COMMENT ON TABLE au.referral IS 'table for referrals to defined individuals';


--
-- Name: COLUMN referral.narrative; Type: COMMENT; Schema: au; Owner: gm-dbo
--

COMMENT ON COLUMN au.referral.narrative IS 'inherited from clin.clin_root_item;
	 stores text of referral letter';


--
-- Name: COLUMN referral.fk_referee; Type: COMMENT; Schema: au; Owner: gm-dbo
--

COMMENT ON COLUMN au.referral.fk_referee IS 'person to whom the referral is directed';


--
-- Name: COLUMN referral.fk_form; Type: COMMENT; Schema: au; Owner: gm-dbo
--

COMMENT ON COLUMN au.referral.fk_form IS 'foreign key to the form instance of
this referral.';


--
-- Name: referral_id_seq; Type: SEQUENCE; Schema: au; Owner: gm-dbo
--

CREATE SEQUENCE au.referral_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE au.referral_id_seq OWNER TO "gm-dbo";

--
-- Name: referral_id_seq; Type: SEQUENCE OWNED BY; Schema: au; Owner: gm-dbo
--

ALTER SEQUENCE au.referral_id_seq OWNED BY au.referral.id;


--
-- Name: audit_fields_pk_audit_seq; Type: SEQUENCE; Schema: audit; Owner: gm-dbo
--

CREATE SEQUENCE audit.audit_fields_pk_audit_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE audit.audit_fields_pk_audit_seq OWNER TO "gm-dbo";

--
-- Name: audit_fields_pk_audit_seq; Type: SEQUENCE OWNED BY; Schema: audit; Owner: gm-dbo
--

ALTER SEQUENCE audit.audit_fields_pk_audit_seq OWNED BY audit.audit_fields.pk_audit;


--
-- Name: audit_trail; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.audit_trail (
    pk_audit integer NOT NULL,
    orig_version integer DEFAULT 0 NOT NULL,
    orig_when timestamp with time zone NOT NULL,
    orig_by name NOT NULL,
    orig_tableoid oid NOT NULL,
    audit_action text NOT NULL,
    audit_when timestamp with time zone DEFAULT now() NOT NULL,
    audit_by name DEFAULT "current_user"() NOT NULL,
    CONSTRAINT audit_audit_trail_orig_before_audit_when CHECK (((orig_when <= audit_when) IS TRUE)),
    CONSTRAINT audit_audit_trail_sane_audit_when CHECK (((audit_when <= clock_timestamp()) IS TRUE)),
    CONSTRAINT audit_audit_trail_sane_orig_when CHECK (((orig_when <= clock_timestamp()) IS TRUE)),
    CONSTRAINT audit_trail_audit_action_check CHECK ((audit_action = ANY (ARRAY['UPDATE'::text, 'DELETE'::text])))
);


ALTER TABLE audit.audit_trail OWNER TO "gm-dbo";

--
-- Name: TABLE audit_trail; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON TABLE audit.audit_trail IS 'Each table that needs standard auditing must have a log table inheriting
	 from this table. Log tables have the same name with a prepended "log_".
	 However, log_* tables shall not have constraints.';


--
-- Name: COLUMN audit_trail.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.audit_trail.orig_version IS 'the version of this row in the original table previous to the modification';


--
-- Name: COLUMN audit_trail.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.audit_trail.orig_when IS 'previous modification date in the original table';


--
-- Name: COLUMN audit_trail.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.audit_trail.orig_by IS 'who committed the row to the original table';


--
-- Name: COLUMN audit_trail.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.audit_trail.orig_tableoid IS 'the table oid of the original table, use this to identify the source table';


--
-- Name: COLUMN audit_trail.audit_action; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.audit_trail.audit_action IS 'either "update" or "delete"';


--
-- Name: COLUMN audit_trail.audit_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.audit_trail.audit_when IS 'when committed to this table for auditing';


--
-- Name: COLUMN audit_trail.audit_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.audit_trail.audit_by IS 'committed to this table for auditing by whom';


--
-- Name: audit_trail_pk_audit_seq; Type: SEQUENCE; Schema: audit; Owner: gm-dbo
--

CREATE SEQUENCE audit.audit_trail_pk_audit_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE audit.audit_trail_pk_audit_seq OWNER TO "gm-dbo";

--
-- Name: audit_trail_pk_audit_seq; Type: SEQUENCE OWNED BY; Schema: audit; Owner: gm-dbo
--

ALTER SEQUENCE audit.audit_trail_pk_audit_seq OWNED BY audit.audit_trail.pk_audit;


--
-- Name: audited_tables; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.audited_tables (
    id integer NOT NULL,
    schema name DEFAULT 'public'::name NOT NULL,
    table_name name NOT NULL
);


ALTER TABLE audit.audited_tables OWNER TO "gm-dbo";

--
-- Name: TABLE audited_tables; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON TABLE audit.audited_tables IS 'All tables that need standard auditing must be
	 recorded in this table. Audit triggers will be
	 generated automatically for all tables recorded
	 here.';


--
-- Name: audited_tables_id_seq; Type: SEQUENCE; Schema: audit; Owner: gm-dbo
--

CREATE SEQUENCE audit.audited_tables_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE audit.audited_tables_id_seq OWNER TO "gm-dbo";

--
-- Name: audited_tables_id_seq; Type: SEQUENCE OWNED BY; Schema: audit; Owner: gm-dbo
--

ALTER SEQUENCE audit.audited_tables_id_seq OWNED BY audit.audited_tables.id;


--
-- Name: log_access_log; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_access_log (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    user_action text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_access_log OWNER TO "gm-dbo";

--
-- Name: COLUMN log_access_log.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_access_log.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_access_log.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_access_log.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_access_log.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_access_log.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_access_log.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_access_log.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_address; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_address (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    id integer,
    id_street integer,
    aux_street text,
    number text,
    subunit text,
    addendum text,
    lat_lon point
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_address OWNER TO "gm-dbo";

--
-- Name: COLUMN log_address.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_address.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_address.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_address.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_address.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_address.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_address.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_address.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_allergy; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_allergy (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_item integer,
    clin_when timestamp with time zone,
    fk_encounter integer,
    fk_episode integer,
    narrative text,
    soap_cat text,
    pk integer,
    substance text,
    substance_code text,
    generics text,
    allergene text,
    atc_code text,
    fk_type integer,
    generic_specific boolean,
    definite boolean
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_allergy OWNER TO "gm-dbo";

--
-- Name: COLUMN log_allergy.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_allergy.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_allergy.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_allergy.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_allergy.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_allergy.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_allergy.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_allergy.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_allergy_state; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_allergy_state (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    has_allergy integer,
    comment text,
    last_confirmed timestamp with time zone,
    fk_encounter integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_allergy_state OWNER TO "gm-dbo";

--
-- Name: COLUMN log_allergy_state.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_allergy_state.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_allergy_state.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_allergy_state.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_allergy_state.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_allergy_state.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_allergy_state.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_allergy_state.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_auto_hint; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_auto_hint (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    query text,
    title text,
    hint text,
    url text,
    is_active boolean,
    source text,
    lang text,
    recommendation_query text,
    popup_type integer,
    highlight_as_priority boolean
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_auto_hint OWNER TO "gm-dbo";

--
-- Name: COLUMN log_auto_hint.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_auto_hint.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_auto_hint.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_auto_hint.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_auto_hint.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_auto_hint.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_auto_hint.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_auto_hint.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_beh_fall_typ; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_beh_fall_typ (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    code text,
    kurzform text,
    name text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_beh_fall_typ OWNER TO "gm-dbo";

--
-- Name: COLUMN log_beh_fall_typ.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_beh_fall_typ.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_beh_fall_typ.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_beh_fall_typ.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_beh_fall_typ.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_beh_fall_typ.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_beh_fall_typ.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_beh_fall_typ.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_bill; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_bill (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    invoice_id text,
    close_date timestamp with time zone,
    apply_vat boolean,
    fk_receiver_identity integer,
    fk_receiver_address integer,
    fk_doc integer,
    comment text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_bill OWNER TO "gm-dbo";

--
-- Name: COLUMN log_bill.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_bill.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_bill.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_bill.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_bill.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_bill.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_bill.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_bill.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_bill_item; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_bill_item (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_provider integer,
    fk_encounter integer,
    date_to_bill date,
    description text,
    net_amount_per_unit numeric,
    currency text,
    status text,
    fk_billable integer,
    fk_bill integer,
    unit_count integer,
    amount_multiplier numeric
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_bill_item OWNER TO "gm-dbo";

--
-- Name: COLUMN log_bill_item.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_bill_item.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_bill_item.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_bill_item.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_bill_item.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_bill_item.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_bill_item.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_bill_item.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_billable; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_billable (
    pk_coding_system integer,
    code text,
    term text,
    fk_data_source integer,
    comment text,
    pk integer,
    amount numeric,
    currency text,
    vat_multiplier numeric,
    active boolean,
    discountable boolean
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_billable OWNER TO "gm-dbo";

--
-- Name: COLUMN log_billable.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_billable.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_billable.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_billable.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_billable.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_billable.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_billable.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_billable.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_clin_aux_note; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_clin_aux_note (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_item integer,
    clin_when timestamp with time zone,
    fk_encounter integer,
    fk_episode integer,
    narrative text,
    soap_cat text,
    pk integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_clin_aux_note OWNER TO "gm-dbo";

--
-- Name: COLUMN log_clin_aux_note.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_clin_aux_note.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_clin_aux_note.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_clin_aux_note.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_clin_aux_note.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_clin_aux_note.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_clin_aux_note.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_clin_aux_note.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_clin_diag; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_clin_diag (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_narrative integer,
    laterality bpchar,
    is_chronic boolean,
    is_active boolean,
    is_definite boolean,
    clinically_relevant boolean
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_clin_diag OWNER TO "gm-dbo";

--
-- Name: COLUMN log_clin_diag.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_clin_diag.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_clin_diag.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_clin_diag.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_clin_diag.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_clin_diag.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_clin_diag.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_clin_diag.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_clin_item_type; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_clin_item_type (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    type text,
    code text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_clin_item_type OWNER TO "gm-dbo";

--
-- Name: COLUMN log_clin_item_type.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_clin_item_type.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_clin_item_type.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_clin_item_type.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_clin_item_type.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_clin_item_type.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_clin_item_type.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_clin_item_type.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_clin_narrative; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_clin_narrative (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_item integer,
    clin_when timestamp with time zone,
    fk_encounter integer,
    fk_episode integer,
    narrative text,
    soap_cat text,
    pk integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_clin_narrative OWNER TO "gm-dbo";

--
-- Name: COLUMN log_clin_narrative.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_clin_narrative.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_clin_narrative.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_clin_narrative.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_clin_narrative.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_clin_narrative.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_clin_narrative.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_clin_narrative.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_consumable_substance; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_consumable_substance (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    description text,
    atc_code text,
    amount numeric,
    unit text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_consumable_substance OWNER TO "gm-dbo";

--
-- Name: COLUMN log_consumable_substance.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_consumable_substance.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_consumable_substance.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_consumable_substance.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_consumable_substance.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_consumable_substance.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_consumable_substance.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_consumable_substance.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_consumed_substance; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_consumed_substance (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    description text,
    atc_code text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_consumed_substance OWNER TO "gm-dbo";

--
-- Name: COLUMN log_consumed_substance.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_consumed_substance.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_consumed_substance.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_consumed_substance.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_consumed_substance.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_consumed_substance.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_consumed_substance.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_consumed_substance.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_data_source; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_data_source (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    name_short text,
    name_long text,
    version text,
    description text,
    source text,
    lang text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_data_source OWNER TO "gm-dbo";

--
-- Name: COLUMN log_data_source.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_data_source.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_data_source.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_data_source.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_data_source.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_data_source.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_data_source.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_data_source.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_doc_desc; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_doc_desc (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_doc integer,
    text text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_doc_desc OWNER TO "gm-dbo";

--
-- Name: COLUMN log_doc_desc.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_doc_desc.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_doc_desc.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_doc_desc.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_doc_desc.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_doc_desc.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_doc_desc.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_doc_desc.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_doc_med; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_doc_med (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_encounter integer,
    fk_episode integer,
    fk_type integer,
    comment text,
    clin_when timestamp with time zone,
    ext_ref text,
    fk_org_unit integer,
    unit_is_receiver boolean,
    fk_hospital_stay integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_doc_med OWNER TO "gm-dbo";

--
-- Name: COLUMN log_doc_med.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_doc_med.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_doc_med.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_doc_med.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_doc_med.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_doc_med.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_doc_med.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_doc_med.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_dose; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_dose (
    pk integer,
    fk_substance integer,
    amount numeric,
    unit text,
    dose_unit text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_dose OWNER TO "gm-dbo";

--
-- Name: COLUMN log_dose.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_dose.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_dose.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_dose.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_dose.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_dose.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_dose.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_dose.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_drug_product; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_drug_product (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    description text,
    preparation text,
    atc_code text,
    is_fake boolean,
    fk_data_source integer,
    external_code text,
    external_code_type text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_drug_product OWNER TO "gm-dbo";

--
-- Name: COLUMN log_drug_product.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_drug_product.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_drug_product.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_drug_product.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_drug_product.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_drug_product.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_drug_product.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_drug_product.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_encounter; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_encounter (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_patient integer,
    fk_type integer,
    fk_location integer,
    source_time_zone interval,
    reason_for_encounter text,
    assessment_of_encounter text,
    started timestamp with time zone,
    last_affirmed timestamp with time zone
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_encounter OWNER TO "gm-dbo";

--
-- Name: COLUMN log_encounter.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_encounter.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_encounter.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_encounter.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_encounter.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_encounter.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_encounter.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_encounter.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_episode; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_episode (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_health_issue integer,
    description text,
    is_open boolean,
    fk_encounter integer,
    diagnostic_certainty_classification text,
    summary text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_episode OWNER TO "gm-dbo";

--
-- Name: COLUMN log_episode.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_episode.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_episode.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_episode.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_episode.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_episode.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_episode.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_episode.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_external_care; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_external_care (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_encounter integer,
    fk_health_issue integer,
    issue text,
    fk_org_unit integer,
    provider text,
    comment text,
    inactive boolean
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_external_care OWNER TO "gm-dbo";

--
-- Name: COLUMN log_external_care.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_external_care.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_external_care.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_external_care.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_external_care.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_external_care.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_external_care.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_external_care.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_family_history; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_family_history (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_item integer,
    clin_when timestamp with time zone,
    fk_encounter integer,
    fk_episode integer,
    narrative text,
    soap_cat text,
    pk integer,
    fk_relation_type integer,
    age_noted text,
    age_of_death interval,
    contributed_to_death boolean,
    name_relative text,
    dob_relative timestamp with time zone,
    comment text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_family_history OWNER TO "gm-dbo";

--
-- Name: COLUMN log_family_history.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_family_history.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_family_history.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_family_history.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_family_history.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_family_history.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_family_history.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_family_history.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_fhx_relation_type; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_fhx_relation_type (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    description text,
    is_genetic boolean
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_fhx_relation_type OWNER TO "gm-dbo";

--
-- Name: COLUMN log_fhx_relation_type.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_fhx_relation_type.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_fhx_relation_type.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_fhx_relation_type.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_fhx_relation_type.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_fhx_relation_type.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_fhx_relation_type.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_fhx_relation_type.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_form_data; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_form_data (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_instance integer,
    fk_form_field integer,
    value text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_form_data OWNER TO "gm-dbo";

--
-- Name: COLUMN log_form_data.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_form_data.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_form_data.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_form_data.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_form_data.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_form_data.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_form_data.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_form_data.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_form_instances; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_form_instances (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_item integer,
    clin_when timestamp with time zone,
    fk_encounter integer,
    fk_episode integer,
    narrative text,
    soap_cat text,
    pk integer,
    fk_form_def integer,
    form_name text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_form_instances OWNER TO "gm-dbo";

--
-- Name: COLUMN log_form_instances.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_form_instances.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_form_instances.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_form_instances.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_form_instances.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_form_instances.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_form_instances.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_form_instances.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_gender_label; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_gender_label (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    tag text,
    label text,
    sort_weight integer,
    comment text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_gender_label OWNER TO "gm-dbo";

--
-- Name: COLUMN log_gender_label.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_gender_label.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_gender_label.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_gender_label.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_gender_label.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_gender_label.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_gender_label.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_gender_label.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_health_issue; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_health_issue (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    description text,
    laterality character varying,
    age_noted interval,
    is_active boolean,
    clinically_relevant boolean,
    is_confidential boolean,
    is_cause_of_death boolean,
    fk_encounter integer,
    "grouping" text,
    diagnostic_certainty_classification text,
    summary text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_health_issue OWNER TO "gm-dbo";

--
-- Name: COLUMN log_health_issue.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_health_issue.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_health_issue.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_health_issue.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_health_issue.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_health_issue.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_health_issue.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_health_issue.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_hospital_stay; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_hospital_stay (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_item integer,
    clin_when timestamp with time zone,
    fk_encounter integer,
    fk_episode integer,
    narrative text,
    soap_cat text,
    pk integer,
    discharge timestamp with time zone,
    fk_org_unit integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_hospital_stay OWNER TO "gm-dbo";

--
-- Name: COLUMN log_hospital_stay.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_hospital_stay.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_hospital_stay.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_hospital_stay.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_hospital_stay.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_hospital_stay.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_hospital_stay.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_hospital_stay.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_hx_family_item; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_hx_family_item (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_narrative_condition integer,
    fk_relative integer,
    name_relative text,
    dob_relative timestamp with time zone,
    condition text,
    age_noted text,
    age_of_death interval,
    is_cause_of_death boolean
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_hx_family_item OWNER TO "gm-dbo";

--
-- Name: COLUMN log_hx_family_item.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_hx_family_item.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_hx_family_item.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_hx_family_item.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_hx_family_item.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_hx_family_item.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_hx_family_item.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_hx_family_item.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_identity; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_identity (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    deleted boolean,
    gender text,
    dob timestamp with time zone,
    fk_marital_status integer,
    cob bpchar,
    deceased timestamp with time zone,
    title text,
    tob time without time zone,
    emergency_contact text,
    fk_emergency_contact integer,
    comment text,
    fk_primary_provider integer,
    dob_is_estimated boolean
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_identity OWNER TO "gm-dbo";

--
-- Name: COLUMN log_identity.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_identity.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_identity.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_identity.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_identity.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_identity.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_identity.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_identity.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_identity_tag; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_identity_tag (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_identity integer,
    fk_tag integer,
    comment text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_identity_tag OWNER TO "gm-dbo";

--
-- Name: COLUMN log_identity_tag.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_identity_tag.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_identity_tag.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_identity_tag.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_identity_tag.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_identity_tag.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_identity_tag.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_identity_tag.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_inbox_item_category; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_inbox_item_category (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    description text,
    is_user boolean
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_inbox_item_category OWNER TO "gm-dbo";

--
-- Name: COLUMN log_inbox_item_category.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_inbox_item_category.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_inbox_item_category.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_inbox_item_category.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_inbox_item_category.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_inbox_item_category.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_inbox_item_category.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_inbox_item_category.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_inbox_item_type; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_inbox_item_type (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_inbox_item_category integer,
    description text,
    is_user boolean
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_inbox_item_type OWNER TO "gm-dbo";

--
-- Name: COLUMN log_inbox_item_type.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_inbox_item_type.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_inbox_item_type.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_inbox_item_type.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_inbox_item_type.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_inbox_item_type.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_inbox_item_type.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_inbox_item_type.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_incoming_data_unmatchable; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_incoming_data_unmatchable (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_patient_candidates integer[],
    request_id text,
    firstnames text,
    lastnames text,
    dob date,
    postcode text,
    other_info text,
    type text,
    data bytea,
    gender text,
    requestor text,
    external_data_id text,
    fk_identity_disambiguated integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_incoming_data_unmatchable OWNER TO "gm-dbo";

--
-- Name: COLUMN log_incoming_data_unmatchable.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_incoming_data_unmatchable.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_incoming_data_unmatchable.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_incoming_data_unmatchable.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_incoming_data_unmatchable.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_incoming_data_unmatchable.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_incoming_data_unmatchable.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_incoming_data_unmatchable.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_incoming_data_unmatched; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_incoming_data_unmatched (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_patient_candidates integer[],
    request_id text,
    firstnames text,
    lastnames text,
    dob date,
    postcode text,
    other_info text,
    type text,
    data bytea,
    gender text,
    requestor text,
    external_data_id text,
    fk_identity_disambiguated integer,
    comment text,
    fk_provider_disambiguated integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_incoming_data_unmatched OWNER TO "gm-dbo";

--
-- Name: COLUMN log_incoming_data_unmatched.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_incoming_data_unmatched.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_incoming_data_unmatched.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_incoming_data_unmatched.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_incoming_data_unmatched.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_incoming_data_unmatched.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_incoming_data_unmatched.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_incoming_data_unmatched.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lab_request; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lab_request (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_item integer,
    clin_when timestamp with time zone,
    fk_encounter integer,
    fk_episode integer,
    narrative text,
    soap_cat text,
    pk integer,
    fk_test_org integer,
    request_id text,
    fk_requestor integer,
    lab_request_id text,
    lab_rxd_when timestamp with time zone,
    results_reported_when timestamp with time zone,
    request_status text,
    is_pending boolean,
    diagnostic_service_section text,
    ordered_service text,
    note_test_org text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lab_request OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lab_request.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lab_request.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lab_request.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lab_request.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lab_request.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lab_request.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lab_request.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lab_request.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lab_test_gnr; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lab_test_gnr (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    id integer,
    id_test integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lab_test_gnr OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lab_test_gnr.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lab_test_gnr.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lab_test_gnr.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lab_test_gnr.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lab_test_gnr.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lab_test_gnr.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lab_test_gnr.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lab_test_gnr.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_code2aoe; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_code2aoe (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_lnk_code2item integer,
    fk_generic_code integer,
    fk_item integer,
    code_modifier text,
    pk integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_code2aoe OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_code2aoe.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2aoe.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_code2aoe.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2aoe.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_code2aoe.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2aoe.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_code2aoe.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2aoe.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_code2episode; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_code2episode (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_lnk_code2item integer,
    fk_generic_code integer,
    fk_item integer,
    code_modifier text,
    pk integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_code2episode OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_code2episode.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2episode.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_code2episode.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2episode.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_code2episode.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2episode.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_code2episode.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2episode.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_code2fhx; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_code2fhx (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_lnk_code2item integer,
    fk_generic_code integer,
    fk_item integer,
    code_modifier text,
    pk integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_code2fhx OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_code2fhx.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2fhx.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_code2fhx.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2fhx.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_code2fhx.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2fhx.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_code2fhx.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2fhx.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_code2h_issue; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_code2h_issue (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_lnk_code2item integer,
    fk_generic_code integer,
    fk_item integer,
    code_modifier text,
    pk integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_code2h_issue OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_code2h_issue.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2h_issue.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_code2h_issue.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2h_issue.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_code2h_issue.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2h_issue.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_code2h_issue.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2h_issue.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_code2narrative; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_code2narrative (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_lnk_code2item integer,
    fk_generic_code integer,
    fk_item integer,
    code_modifier text,
    pk integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_code2narrative OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_code2narrative.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2narrative.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_code2narrative.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2narrative.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_code2narrative.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2narrative.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_code2narrative.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2narrative.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_code2procedure; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_code2procedure (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_lnk_code2item integer,
    fk_generic_code integer,
    fk_item integer,
    code_modifier text,
    pk integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_code2procedure OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_code2procedure.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2procedure.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_code2procedure.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2procedure.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_code2procedure.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2procedure.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_code2procedure.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2procedure.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_code2rfe; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_code2rfe (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_lnk_code2item integer,
    fk_generic_code integer,
    fk_item integer,
    code_modifier text,
    pk integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_code2rfe OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_code2rfe.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2rfe.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_code2rfe.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2rfe.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_code2rfe.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2rfe.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_code2rfe.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2rfe.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_code2tst_pnl; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_code2tst_pnl (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_lnk_code2item integer,
    fk_generic_code integer,
    fk_item integer,
    code_modifier text,
    pk integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_code2tst_pnl OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_code2tst_pnl.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2tst_pnl.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_code2tst_pnl.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2tst_pnl.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_code2tst_pnl.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2tst_pnl.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_code2tst_pnl.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_code2tst_pnl.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_constraint2vacc_course; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_constraint2vacc_course (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_vaccination_course integer,
    fk_constraint integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_constraint2vacc_course OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_constraint2vacc_course.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_constraint2vacc_course.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_constraint2vacc_course.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_constraint2vacc_course.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_constraint2vacc_course.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_constraint2vacc_course.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_constraint2vacc_course.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_constraint2vacc_course.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_dose2drug; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_dose2drug (
    pk integer,
    fk_drug_product integer,
    fk_dose integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_dose2drug OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_dose2drug.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_dose2drug.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_dose2drug.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_dose2drug.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_dose2drug.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_dose2drug.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_dose2drug.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_dose2drug.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_identity2ext_id; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_identity2ext_id (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    id integer,
    id_identity integer,
    external_id text,
    fk_origin integer,
    comment text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_identity2ext_id OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_identity2ext_id.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_identity2ext_id.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_identity2ext_id.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_identity2ext_id.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_identity2ext_id.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_identity2ext_id.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_identity2ext_id.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_identity2ext_id.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_identity2primary_doc; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_identity2primary_doc (
    pk integer,
    fk_identity integer,
    fk_primary_doc integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_identity2primary_doc OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_identity2primary_doc.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_identity2primary_doc.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_identity2primary_doc.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_identity2primary_doc.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_identity2primary_doc.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_identity2primary_doc.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_identity2primary_doc.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_identity2primary_doc.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_job2person; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_job2person (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_identity integer,
    fk_occupation integer,
    activities text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_job2person OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_job2person.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_job2person.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_job2person.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_job2person.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_job2person.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_job2person.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_job2person.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_job2person.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_loinc2substance; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_loinc2substance (
    pk integer,
    fk_substance integer,
    loinc text,
    max_age interval,
    comment text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_loinc2substance OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_loinc2substance.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_loinc2substance.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_loinc2substance.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_loinc2substance.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_loinc2substance.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_loinc2substance.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_loinc2substance.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_loinc2substance.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_loinc2test_panel; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_loinc2test_panel (
    pk integer,
    fk_test_panel integer,
    loinc text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_loinc2test_panel OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_loinc2test_panel.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_loinc2test_panel.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_loinc2test_panel.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_loinc2test_panel.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_loinc2test_panel.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_loinc2test_panel.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_loinc2test_panel.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_loinc2test_panel.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_org_unit2comm; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_org_unit2comm (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_org_unit integer,
    url text,
    fk_type integer,
    is_confidential boolean,
    comment text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_org_unit2comm OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_org_unit2comm.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_org_unit2comm.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_org_unit2comm.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_org_unit2comm.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_org_unit2comm.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_org_unit2comm.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_org_unit2comm.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_org_unit2comm.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_org_unit2ext_id; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_org_unit2ext_id (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_org_unit integer,
    external_id text,
    fk_type integer,
    comment text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_org_unit2ext_id OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_org_unit2ext_id.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_org_unit2ext_id.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_org_unit2ext_id.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_org_unit2ext_id.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_org_unit2ext_id.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_org_unit2ext_id.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_org_unit2ext_id.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_org_unit2ext_id.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_pat2vaccination_course; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_pat2vaccination_course (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_patient integer,
    fk_course integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_pat2vaccination_course OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_pat2vaccination_course.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_pat2vaccination_course.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_pat2vaccination_course.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_pat2vaccination_course.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_pat2vaccination_course.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_pat2vaccination_course.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_pat2vaccination_course.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_pat2vaccination_course.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_person2relative; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_person2relative (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    id integer,
    id_identity integer,
    id_relative integer,
    id_relation_type integer,
    started date,
    ended date
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_person2relative OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_person2relative.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_person2relative.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_person2relative.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_person2relative.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_person2relative.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_person2relative.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_person2relative.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_person2relative.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_substance2brand; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_substance2brand (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_brand integer,
    fk_substance integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_substance2brand OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_substance2brand.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_substance2brand.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_substance2brand.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_substance2brand.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_substance2brand.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_substance2brand.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_substance2brand.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_substance2brand.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_tst2norm; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_tst2norm (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    id integer,
    id_test integer,
    id_norm integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_tst2norm OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_tst2norm.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_tst2norm.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_tst2norm.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_tst2norm.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_tst2norm.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_tst2norm.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_tst2norm.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_tst2norm.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_type2item; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_type2item (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_type integer,
    fk_item integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_type2item OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_type2item.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_type2item.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_type2item.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_type2item.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_type2item.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_type2item.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_type2item.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_type2item.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_vaccination_course2schedule; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_vaccination_course2schedule (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_course integer,
    fk_schedule integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_vaccination_course2schedule OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_vaccination_course2schedule.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_vaccination_course2schedule.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_vaccination_course2schedule.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_vaccination_course2schedule.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_vaccination_course2schedule.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_vaccination_course2schedule.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_vaccination_course2schedule.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_vaccination_course2schedule.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_lnk_vaccine2inds; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_lnk_vaccine2inds (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    id integer,
    fk_vaccine integer,
    fk_indication integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_lnk_vaccine2inds OWNER TO "gm-dbo";

--
-- Name: COLUMN log_lnk_vaccine2inds.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_vaccine2inds.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_lnk_vaccine2inds.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_vaccine2inds.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_lnk_vaccine2inds.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_vaccine2inds.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_lnk_vaccine2inds.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_lnk_vaccine2inds.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_message_inbox; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_message_inbox (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_staff integer,
    fk_inbox_item_type integer,
    comment text,
    data text,
    importance smallint,
    fk_patient integer,
    ufk_context integer[],
    due_date date,
    expiry_date date
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_message_inbox OWNER TO "gm-dbo";

--
-- Name: COLUMN log_message_inbox.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_message_inbox.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_message_inbox.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_message_inbox.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_message_inbox.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_message_inbox.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_message_inbox.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_message_inbox.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_occupation; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_occupation (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    id integer,
    name text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_occupation OWNER TO "gm-dbo";

--
-- Name: COLUMN log_occupation.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_occupation.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_occupation.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_occupation.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_occupation.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_occupation.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_occupation.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_occupation.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_operation; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_operation (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_health_issue integer,
    fk_encounter integer,
    clin_where text,
    comment text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_operation OWNER TO "gm-dbo";

--
-- Name: COLUMN log_operation.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_operation.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_operation.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_operation.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_operation.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_operation.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_operation.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_operation.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_org; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_org (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    description text,
    fk_category integer,
    fk_data_source integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_org OWNER TO "gm-dbo";

--
-- Name: COLUMN log_org.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_org.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_org.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_org.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_org.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_org.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_org.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_org.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_org_unit; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_org_unit (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    description text,
    fk_org integer,
    fk_address integer,
    fk_category integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_org_unit OWNER TO "gm-dbo";

--
-- Name: COLUMN log_org_unit.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_org_unit.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_org_unit.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_org_unit.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_org_unit.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_org_unit.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_org_unit.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_org_unit.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_paperwork_templates; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_paperwork_templates (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_template_type integer,
    instance_type text,
    name_short text,
    name_long text,
    external_version text,
    gnumed_revision double precision,
    engine text,
    in_use boolean,
    filename text,
    data bytea,
    edit_after_substitution boolean
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_paperwork_templates OWNER TO "gm-dbo";

--
-- Name: COLUMN log_paperwork_templates.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_paperwork_templates.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_paperwork_templates.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_paperwork_templates.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_paperwork_templates.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_paperwork_templates.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_paperwork_templates.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_paperwork_templates.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_patient; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_patient (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_identity integer,
    edc date
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_patient OWNER TO "gm-dbo";

--
-- Name: COLUMN log_patient.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_patient.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_patient.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_patient.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_patient.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_patient.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_patient.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_patient.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_prax_geb_paid; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_prax_geb_paid (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_fall integer,
    paid_amount numeric,
    paid_when date,
    paid_with integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_prax_geb_paid OWNER TO "gm-dbo";

--
-- Name: COLUMN log_prax_geb_paid.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_prax_geb_paid.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_prax_geb_paid.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_prax_geb_paid.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_prax_geb_paid.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_prax_geb_paid.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_prax_geb_paid.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_prax_geb_paid.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_praxis_branch; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_praxis_branch (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_org_unit integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_praxis_branch OWNER TO "gm-dbo";

--
-- Name: COLUMN log_praxis_branch.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_praxis_branch.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_praxis_branch.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_praxis_branch.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_praxis_branch.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_praxis_branch.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_praxis_branch.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_praxis_branch.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_procedure; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_procedure (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_item integer,
    clin_when timestamp with time zone,
    fk_encounter integer,
    fk_episode integer,
    narrative text,
    soap_cat text,
    pk integer,
    clin_where text,
    fk_hospital_stay integer,
    clin_end timestamp with time zone,
    is_ongoing boolean,
    fk_org_unit integer,
    fk_doc integer,
    comment text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_procedure OWNER TO "gm-dbo";

--
-- Name: COLUMN log_procedure.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_procedure.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_procedure.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_procedure.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_procedure.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_procedure.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_procedure.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_procedure.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_referral; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_referral (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_item integer,
    clin_when timestamp with time zone,
    fk_encounter integer,
    fk_episode integer,
    narrative text,
    soap_cat text,
    id integer,
    fk_referee integer,
    fk_form integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_referral OWNER TO "gm-dbo";

--
-- Name: COLUMN log_referral.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_referral.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_referral.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_referral.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_referral.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_referral.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_referral.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_referral.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_region; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_region (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    code text,
    country bpchar,
    name text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_region OWNER TO "gm-dbo";

--
-- Name: COLUMN log_region.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_region.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_region.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_region.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_region.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_region.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_region.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_region.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_relation_types; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_relation_types (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    id integer,
    inverse integer,
    biological boolean,
    biol_verified boolean,
    description text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_relation_types OWNER TO "gm-dbo";

--
-- Name: COLUMN log_relation_types.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_relation_types.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_relation_types.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_relation_types.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_relation_types.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_relation_types.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_relation_types.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_relation_types.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_report_query; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_report_query (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    label text,
    cmd text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_report_query OWNER TO "gm-dbo";

--
-- Name: COLUMN log_report_query.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_report_query.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_report_query.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_report_query.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_report_query.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_report_query.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_report_query.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_report_query.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_staff; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_staff (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_identity integer,
    db_user name,
    short_alias text,
    comment text,
    is_active boolean
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_staff OWNER TO "gm-dbo";

--
-- Name: COLUMN log_staff.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_staff.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_staff.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_staff.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_staff.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_staff.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_staff.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_staff.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_street; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_street (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    id integer,
    id_urb integer,
    name text,
    postcode text,
    suburb text,
    lat_lon point
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_street OWNER TO "gm-dbo";

--
-- Name: COLUMN log_street.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_street.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_street.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_street.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_street.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_street.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_street.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_street.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_substance; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_substance (
    pk integer,
    description text,
    atc text,
    intake_instructions text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_substance OWNER TO "gm-dbo";

--
-- Name: COLUMN log_substance.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_substance.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_substance.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_substance.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_substance.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_substance.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_substance.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_substance.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_substance_in_brand; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_substance_in_brand (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_brand integer,
    description text,
    atc_code text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_substance_in_brand OWNER TO "gm-dbo";

--
-- Name: COLUMN log_substance_in_brand.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_substance_in_brand.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_substance_in_brand.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_substance_in_brand.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_substance_in_brand.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_substance_in_brand.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_substance_in_brand.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_substance_in_brand.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_substance_intake; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_substance_intake (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_item integer,
    clin_when timestamp with time zone,
    fk_encounter integer,
    fk_episode integer,
    narrative text,
    soap_cat text,
    pk integer,
    fk_substance integer,
    preparation text,
    schedule text,
    aim text,
    duration interval,
    intake_is_approved_of boolean,
    is_long_term boolean,
    discontinued timestamp with time zone,
    discontinue_reason text,
    fk_drug_component integer,
    comment_on_start text,
    harmful_use_type integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_substance_intake OWNER TO "gm-dbo";

--
-- Name: COLUMN log_substance_intake.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_substance_intake.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_substance_intake.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_substance_intake.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_substance_intake.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_substance_intake.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_substance_intake.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_substance_intake.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_suppressed_hint; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_suppressed_hint (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_encounter integer,
    fk_hint integer,
    suppressed_by name,
    suppressed_when timestamp with time zone,
    rationale text,
    md5_sum text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_suppressed_hint OWNER TO "gm-dbo";

--
-- Name: COLUMN log_suppressed_hint.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_suppressed_hint.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_suppressed_hint.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_suppressed_hint.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_suppressed_hint.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_suppressed_hint.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_suppressed_hint.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_suppressed_hint.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_tag_image; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_tag_image (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    description text,
    filename text,
    image bytea
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_tag_image OWNER TO "gm-dbo";

--
-- Name: COLUMN log_tag_image.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_tag_image.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_tag_image.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_tag_image.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_tag_image.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_tag_image.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_tag_image.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_tag_image.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_test_org; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_test_org (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_org_unit integer,
    fk_adm_contact integer,
    fk_med_contact integer,
    comment text,
    contact text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_test_org OWNER TO "gm-dbo";

--
-- Name: COLUMN log_test_org.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_test_org.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_test_org.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_test_org.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_test_org.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_test_org.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_test_org.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_test_org.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_test_panel; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_test_panel (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    description text,
    comment text,
    fk_test_types integer[]
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_test_panel OWNER TO "gm-dbo";

--
-- Name: COLUMN log_test_panel.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_test_panel.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_test_panel.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_test_panel.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_test_panel.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_test_panel.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_test_panel.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_test_panel.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_test_result; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_test_result (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_item integer,
    clin_when timestamp with time zone,
    fk_encounter integer,
    fk_episode integer,
    narrative text,
    soap_cat text,
    pk integer,
    fk_type integer,
    val_num numeric,
    val_alpha text,
    val_unit text,
    val_normal_min numeric,
    val_normal_max numeric,
    val_normal_range text,
    val_target_min numeric,
    val_target_max numeric,
    val_target_range text,
    abnormality_indicator text,
    norm_ref_group text,
    note_test_org text,
    material text,
    material_detail text,
    fk_intended_reviewer integer,
    fk_request integer,
    status text,
    source_data text,
    val_grouping text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_test_result OWNER TO "gm-dbo";

--
-- Name: COLUMN log_test_result.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_test_result.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_test_result.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_test_result.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_test_result.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_test_result.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_test_result.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_test_result.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_test_type; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_test_type (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_test_org integer,
    name text,
    comment text,
    reference_unit text,
    loinc text,
    abbrev text,
    fk_meta_test_type integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_test_type OWNER TO "gm-dbo";

--
-- Name: COLUMN log_test_type.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_test_type.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_test_type.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_test_type.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_test_type.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_test_type.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_test_type.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_test_type.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_urb; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_urb (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    id integer,
    fk_region integer,
    postcode text,
    lat_lon point,
    name text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_urb OWNER TO "gm-dbo";

--
-- Name: COLUMN log_urb.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_urb.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_urb.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_urb.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_urb.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_urb.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_urb.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_urb.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_vacc_indication; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_vacc_indication (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    id integer,
    description text,
    atcs_single_indication text[],
    atcs_combi_indication text[]
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_vacc_indication OWNER TO "gm-dbo";

--
-- Name: COLUMN log_vacc_indication.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vacc_indication.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_vacc_indication.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vacc_indication.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_vacc_indication.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vacc_indication.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_vacc_indication.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vacc_indication.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_vacc_route; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_vacc_route (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    id integer,
    abbreviation text,
    description text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_vacc_route OWNER TO "gm-dbo";

--
-- Name: COLUMN log_vacc_route.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vacc_route.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_vacc_route.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vacc_route.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_vacc_route.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vacc_route.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_vacc_route.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vacc_route.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_vaccination; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_vaccination (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk_item integer,
    clin_when timestamp with time zone,
    fk_encounter integer,
    fk_episode integer,
    narrative text,
    soap_cat text,
    pk integer,
    fk_patient integer,
    fk_provider integer,
    fk_vaccine integer,
    site text,
    batch_no text,
    reaction text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_vaccination OWNER TO "gm-dbo";

--
-- Name: COLUMN log_vaccination.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_vaccination.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_vaccination.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_vaccination.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_vaccination_course; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_vaccination_course (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_recommended_by integer,
    fk_indication integer,
    is_active boolean,
    comment text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_vaccination_course OWNER TO "gm-dbo";

--
-- Name: COLUMN log_vaccination_course.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination_course.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_vaccination_course.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination_course.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_vaccination_course.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination_course.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_vaccination_course.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination_course.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_vaccination_course_constraint; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_vaccination_course_constraint (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    description text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_vaccination_course_constraint OWNER TO "gm-dbo";

--
-- Name: COLUMN log_vaccination_course_constraint.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination_course_constraint.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_vaccination_course_constraint.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination_course_constraint.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_vaccination_course_constraint.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination_course_constraint.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_vaccination_course_constraint.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination_course_constraint.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_vaccination_definition; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_vaccination_definition (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    id integer,
    fk_course integer,
    is_booster boolean,
    seq_no integer,
    min_age_due interval,
    max_age_due interval,
    min_interval interval,
    comment text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_vaccination_definition OWNER TO "gm-dbo";

--
-- Name: COLUMN log_vaccination_definition.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination_definition.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_vaccination_definition.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination_definition.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_vaccination_definition.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination_definition.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_vaccination_definition.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination_definition.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_vaccination_schedule; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_vaccination_schedule (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    name text,
    comment text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_vaccination_schedule OWNER TO "gm-dbo";

--
-- Name: COLUMN log_vaccination_schedule.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination_schedule.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_vaccination_schedule.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination_schedule.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_vaccination_schedule.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination_schedule.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_vaccination_schedule.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccination_schedule.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_vaccine; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_vaccine (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    id_route integer,
    is_live boolean,
    min_age interval,
    max_age interval,
    comment text,
    fk_drug_product integer
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_vaccine OWNER TO "gm-dbo";

--
-- Name: COLUMN log_vaccine.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccine.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_vaccine.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccine.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_vaccine.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccine.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_vaccine.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccine.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_vaccine_batches; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_vaccine_batches (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_vaccine integer,
    batch_no text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_vaccine_batches OWNER TO "gm-dbo";

--
-- Name: COLUMN log_vaccine_batches.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccine_batches.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_vaccine_batches.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccine_batches.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_vaccine_batches.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccine_batches.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_vaccine_batches.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_vaccine_batches.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_waiting_list; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_waiting_list (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    fk_patient integer,
    registered timestamp with time zone,
    urgency integer,
    list_position integer,
    comment text,
    area text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_waiting_list OWNER TO "gm-dbo";

--
-- Name: COLUMN log_waiting_list.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_waiting_list.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_waiting_list.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_waiting_list.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_waiting_list.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_waiting_list.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_waiting_list.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_waiting_list.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: log_xlnk_identity; Type: TABLE; Schema: audit; Owner: gm-dbo
--

CREATE TABLE audit.log_xlnk_identity (
    pk_audit integer DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass),
    row_version integer,
    modified_when timestamp with time zone,
    modified_by name,
    pk integer,
    xfk_identity integer,
    pupic text,
    data text
)
INHERITS (audit.audit_trail);


ALTER TABLE audit.log_xlnk_identity OWNER TO "gm-dbo";

--
-- Name: COLUMN log_xlnk_identity.orig_version; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_xlnk_identity.orig_version IS 'the .row_version in the original row before the audited action took place, should be equal to .row_version';


--
-- Name: COLUMN log_xlnk_identity.orig_when; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_xlnk_identity.orig_when IS 'the .modified_when in the original row before the audited action took place, should be equal to .modified_when';


--
-- Name: COLUMN log_xlnk_identity.orig_by; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_xlnk_identity.orig_by IS 'the .modified_by in the original row before the audited action took place, should be equal to .modified_by';


--
-- Name: COLUMN log_xlnk_identity.orig_tableoid; Type: COMMENT; Schema: audit; Owner: gm-dbo
--

COMMENT ON COLUMN audit.log_xlnk_identity.orig_tableoid IS 'the TG_RELID when the audit trigger was run';


--
-- Name: staff; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.staff (
    pk integer NOT NULL,
    fk_identity integer NOT NULL,
    db_user name DEFAULT "current_user"() NOT NULL,
    short_alias text NOT NULL,
    comment text,
    is_active boolean DEFAULT true NOT NULL
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.staff OWNER TO "gm-dbo";

--
-- Name: TABLE staff; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.staff IS 'one-to-one mapping of database user accounts
	 (db_user) to staff identities (fk_identity)';


--
-- Name: COLUMN staff.short_alias; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.staff.short_alias IS 'a short signature unique to this staff member
	 to be used in the GUI, actually this is somewhat
	 redundant with ext_person_id...';


--
-- Name: access_log; Type: TABLE; Schema: gm; Owner: gm-dbo
--

CREATE TABLE gm.access_log (
    pk integer NOT NULL,
    user_action text NOT NULL,
    CONSTRAINT non_empty_user_action CHECK ((gm.is_null_or_blank_string(user_action) IS FALSE))
)
INHERITS (audit.audit_fields);


ALTER TABLE gm.access_log OWNER TO "gm-dbo";

--
-- Name: TABLE access_log; Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON TABLE gm.access_log IS 'This logs access to the database and to records.
 Needed for HIPAA compliance among other things.';


--
-- Name: v_audit_trail; Type: VIEW; Schema: audit; Owner: gm-dbo
--

CREATE VIEW audit.v_audit_trail AS
 SELECT to_char(aat.audit_when, 'YYYY-MM-DD HH24:MI'::text) AS event_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = aat.audit_by)), (('<'::text || (aat.audit_by)::text) || '>'::text)) AS event_by,
    (aat.orig_tableoid)::regclass AS event_table,
    aat.orig_version AS row_version_before,
        CASE
            WHEN (aat.audit_action = 'DELETE'::text) THEN NULL::integer
            ELSE (aat.orig_version + 1)
        END AS row_version_after,
    aat.audit_action AS event,
    aat.audit_when AS audit_when_ts,
    aat.pk_audit
   FROM audit.audit_trail aat
UNION ALL
 SELECT to_char(gal.modified_when, 'YYYY-MM-DD HH24:MI'::text) AS event_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = gal.modified_by)), (('<'::text || (gal.modified_by)::text) || '>'::text)) AS event_by,
    'gm.access_log'::regclass AS event_table,
    NULL::integer AS row_version_before,
    0 AS row_version_after,
    gal.user_action AS event,
    gal.modified_when AS audit_when_ts,
    gal.pk_audit
   FROM gm.access_log gal
  WHERE (gal.row_version = 0)
UNION ALL
 SELECT to_char(aaf.modified_when, 'YYYY-MM-DD HH24:MI'::text) AS event_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = aaf.modified_by)), (('<'::text || (aaf.modified_by)::text) || '>'::text)) AS event_by,
    (aaf.tableoid)::regclass AS event_table,
    NULL::integer AS row_version_before,
    0 AS row_version_after,
    'INSERT'::text AS event,
    aaf.modified_when AS audit_when_ts,
    aaf.pk_audit
   FROM audit.audit_fields aaf
  WHERE (aaf.row_version = 0);


ALTER TABLE audit.v_audit_trail OWNER TO "gm-dbo";

--
-- Name: bill; Type: TABLE; Schema: bill; Owner: gm-dbo
--

CREATE TABLE bill.bill (
    pk integer NOT NULL,
    invoice_id text,
    close_date timestamp with time zone,
    apply_vat boolean,
    fk_receiver_identity integer,
    fk_receiver_address integer,
    fk_doc integer,
    comment text,
    CONSTRAINT bill_bill_sane_apply_vat CHECK (((apply_vat IS NOT NULL) OR ((apply_vat IS NULL) AND (fk_doc IS NULL)))),
    CONSTRAINT bill_bill_sane_comment CHECK ((gm.is_null_or_non_empty_string(comment) IS TRUE)),
    CONSTRAINT bill_bill_sane_invoice_id CHECK ((gm.is_null_or_blank_string(invoice_id) IS FALSE)),
    CONSTRAINT bill_bill_sane_recv_adr CHECK (((fk_receiver_address IS NOT NULL) OR (close_date IS NULL)))
)
INHERITS (audit.audit_fields);


ALTER TABLE bill.bill OWNER TO "gm-dbo";

--
-- Name: TABLE bill; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON TABLE bill.bill IS 'actual bills';


--
-- Name: COLUMN bill.invoice_id; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill.invoice_id IS 'the ID of the bill';


--
-- Name: COLUMN bill.close_date; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill.close_date IS 'cannot add further bill_items after this date if not NULL';


--
-- Name: COLUMN bill.apply_vat; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill.apply_vat IS 'whether or not to apply VAT on the invoice';


--
-- Name: COLUMN bill.fk_receiver_identity; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill.fk_receiver_identity IS 'link to the receiver as a GNUmed identity, if known';


--
-- Name: COLUMN bill.fk_receiver_address; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill.fk_receiver_address IS 'links the address of the receiver of the invoice';


--
-- Name: COLUMN bill.fk_doc; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill.fk_doc IS 'links to the document which contains the invoice PDF';


--
-- Name: COLUMN bill.comment; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill.comment IS 'arbitrary comments on bills';


--
-- Name: bill_item; Type: TABLE; Schema: bill; Owner: gm-dbo
--

CREATE TABLE bill.bill_item (
    pk integer NOT NULL,
    fk_provider integer NOT NULL,
    fk_encounter integer NOT NULL,
    date_to_bill date,
    description text,
    net_amount_per_unit numeric DEFAULT 0 NOT NULL,
    currency text NOT NULL,
    status text DEFAULT 'new'::text,
    fk_billable integer NOT NULL,
    fk_bill integer,
    unit_count integer DEFAULT 1 NOT NULL,
    amount_multiplier numeric DEFAULT 1 NOT NULL,
    CONSTRAINT bill_bill_item_sane_count CHECK ((unit_count > '-1'::integer)),
    CONSTRAINT bill_bill_item_sane_currency CHECK ((gm.is_null_or_blank_string(currency) IS FALSE)),
    CONSTRAINT bill_bill_item_sane_desc CHECK ((gm.is_null_or_non_empty_string(description) IS TRUE)),
    CONSTRAINT bill_bill_item_sane_multiplier CHECK ((amount_multiplier > (0)::numeric)),
    CONSTRAINT valid_stati CHECK ((status = ANY (ARRAY['new'::text, 'transferred'::text])))
)
INHERITS (audit.audit_fields);


ALTER TABLE bill.bill_item OWNER TO "gm-dbo";

--
-- Name: TABLE bill_item; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON TABLE bill.bill_item IS 'items patients currently *are* billed for';


--
-- Name: COLUMN bill_item.fk_provider; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill_item.fk_provider IS 'by whom or on whose behalf did the billable activity happen';


--
-- Name: COLUMN bill_item.fk_encounter; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill_item.fk_encounter IS 'the encounter during which the billable action for this item took place';


--
-- Name: COLUMN bill_item.date_to_bill; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill_item.date_to_bill IS 'The date the bill item was caused. If NULL, use .fk_encounter -> .started';


--
-- Name: COLUMN bill_item.description; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill_item.description IS 'Can be used to further explain the bill item over and above .fk_billable.description.';


--
-- Name: COLUMN bill_item.net_amount_per_unit; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill_item.net_amount_per_unit IS 'How much to charge for one unit of this bill item.';


--
-- Name: COLUMN bill_item.currency; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill_item.currency IS 'Which currency to charge in. Must not be NULL if .net_amount_per_unit is not NULL.';


--
-- Name: COLUMN bill_item.status; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill_item.status IS 'the status of this item';


--
-- Name: COLUMN bill_item.fk_billable; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill_item.fk_billable IS 'Links to the billable item this bill item stands for.';


--
-- Name: COLUMN bill_item.fk_bill; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill_item.fk_bill IS 'Links to the bill this bill item is on if any.';


--
-- Name: COLUMN bill_item.unit_count; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill_item.unit_count IS 'The number of times this item is to be billed. 0 can be used for informative items.';


--
-- Name: COLUMN bill_item.amount_multiplier; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.bill_item.amount_multiplier IS 'A multiplier to apply to .net_amount_per_unit. Can be used for discounts, rebates, or increases. Must be > 0.';


--
-- Name: bill_item_pk_seq; Type: SEQUENCE; Schema: bill; Owner: gm-dbo
--

CREATE SEQUENCE bill.bill_item_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE bill.bill_item_pk_seq OWNER TO "gm-dbo";

--
-- Name: bill_item_pk_seq; Type: SEQUENCE OWNED BY; Schema: bill; Owner: gm-dbo
--

ALTER SEQUENCE bill.bill_item_pk_seq OWNED BY bill.bill_item.pk;


--
-- Name: bill_pk_seq; Type: SEQUENCE; Schema: bill; Owner: gm-dbo
--

CREATE SEQUENCE bill.bill_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE bill.bill_pk_seq OWNER TO "gm-dbo";

--
-- Name: bill_pk_seq; Type: SEQUENCE OWNED BY; Schema: bill; Owner: gm-dbo
--

ALTER SEQUENCE bill.bill_pk_seq OWNED BY bill.bill.pk;


--
-- Name: lnk_enc_type2billable; Type: TABLE; Schema: bill; Owner: gm-dbo
--

CREATE TABLE bill.lnk_enc_type2billable (
    pk integer NOT NULL,
    fk_encounter_type integer NOT NULL,
    fk_billable integer NOT NULL
);


ALTER TABLE bill.lnk_enc_type2billable OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_enc_type2billable; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON TABLE bill.lnk_enc_type2billable IS 'actual bills';


--
-- Name: COLUMN lnk_enc_type2billable.fk_encounter_type; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.lnk_enc_type2billable.fk_encounter_type IS 'Links to encounter type this billable is associated with.';


--
-- Name: COLUMN lnk_enc_type2billable.fk_billable; Type: COMMENT; Schema: bill; Owner: gm-dbo
--

COMMENT ON COLUMN bill.lnk_enc_type2billable.fk_billable IS 'Links to the billable item the encounter type is associated with.';


--
-- Name: lnk_enc_type2billable_pk_seq; Type: SEQUENCE; Schema: bill; Owner: gm-dbo
--

CREATE SEQUENCE bill.lnk_enc_type2billable_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE bill.lnk_enc_type2billable_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_enc_type2billable_pk_seq; Type: SEQUENCE OWNED BY; Schema: bill; Owner: gm-dbo
--

ALTER SEQUENCE bill.lnk_enc_type2billable_pk_seq OWNED BY bill.lnk_enc_type2billable.pk;


--
-- Name: encounter; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.encounter (
    pk integer NOT NULL,
    fk_patient integer NOT NULL,
    fk_type integer DEFAULT 1 NOT NULL,
    fk_location integer NOT NULL,
    source_time_zone interval,
    reason_for_encounter text,
    assessment_of_encounter text,
    started timestamp with time zone DEFAULT now() NOT NULL,
    last_affirmed timestamp with time zone DEFAULT now() NOT NULL,
    CONSTRAINT clin_enc_sane_duration CHECK ((last_affirmed >= started)),
    CONSTRAINT encounter_assessment_of_encounter_check CHECK ((btrim(COALESCE(assessment_of_encounter, 'xxxDEFAULTxxx'::text)) <> ''::text)),
    CONSTRAINT encounter_reason_for_encounter_check CHECK ((btrim(COALESCE(reason_for_encounter, 'xxxDEFAULTxxx'::text)) <> ''::text))
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.encounter OWNER TO "gm-dbo";

--
-- Name: TABLE encounter; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.encounter IS 'a clinical encounter between a person and the health care system';


--
-- Name: COLUMN encounter.fk_patient; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.encounter.fk_patient IS 'PK of subject of care, should be PUPIC, actually';


--
-- Name: COLUMN encounter.fk_type; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.encounter.fk_type IS 'PK of type of this encounter';


--
-- Name: COLUMN encounter.fk_location; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.encounter.fk_location IS 'PK of location *of care*, e.g. where the provider is at';


--
-- Name: COLUMN encounter.source_time_zone; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.encounter.source_time_zone IS 'time zone of location, used to approximate source time
	 zone for all timestamps in this encounter';


--
-- Name: COLUMN encounter.reason_for_encounter; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.encounter.reason_for_encounter IS 'the RFE for the encounter as related by either
	 the patient or the provider (say, in a chart
	 review)';


--
-- Name: COLUMN encounter.assessment_of_encounter; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.encounter.assessment_of_encounter IS 'the Assessment of Encounter (eg consultation summary)
	 as determined by the provider, may simply be a
	 concatenation of soAp narrative, this assessment
	 should go across all problems';


--
-- Name: coding_system_root; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.coding_system_root (
    pk_coding_system integer NOT NULL,
    code text NOT NULL,
    term text NOT NULL,
    fk_data_source integer NOT NULL,
    comment text
);


ALTER TABLE ref.coding_system_root OWNER TO "gm-dbo";

--
-- Name: TABLE coding_system_root; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.coding_system_root IS 'Base table for coding system tables providing common fields.';


--
-- Name: COLUMN coding_system_root.fk_data_source; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.coding_system_root.fk_data_source IS 'links to the data source for the external reference data set';


--
-- Name: COLUMN coding_system_root.comment; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.coding_system_root.comment IS 'an arbitrary comment on the code and/or term,
 child tables will use this in different ways';


--
-- Name: billable; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.billable (
    fk_data_source integer,
    pk integer NOT NULL,
    amount numeric DEFAULT 0 NOT NULL,
    currency text DEFAULT 'u20AC'::text,
    vat_multiplier numeric DEFAULT 0 NOT NULL,
    active boolean DEFAULT true NOT NULL,
    discountable boolean DEFAULT false NOT NULL,
    CONSTRAINT ref_billable_sane_amount CHECK ((amount >= (0)::numeric)),
    CONSTRAINT ref_billable_sane_currency CHECK ((gm.is_null_or_blank_string(currency) IS FALSE)),
    CONSTRAINT ref_billable_sane_vat_multiplier CHECK ((vat_multiplier >= (0)::numeric))
)
INHERITS (ref.coding_system_root);


ALTER TABLE ref.billable OWNER TO "gm-dbo";

--
-- Name: TABLE billable; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.billable IS 'items that *can* be billed to patients';


--
-- Name: COLUMN billable.amount; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.billable.amount IS 'How much to bill for this item.';


--
-- Name: COLUMN billable.currency; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.billable.currency IS 'The currency .amount is in.';


--
-- Name: COLUMN billable.vat_multiplier; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.billable.vat_multiplier IS 'Multiplier to apply to .amount to calculate VAT, eg 0.19 = 19%, 0 = no VAT';


--
-- Name: COLUMN billable.active; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.billable.active IS 'Whether this item is currently supposed to be used for billing patients.';


--
-- Name: COLUMN billable.discountable; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.billable.discountable IS 'Whether discounts can be applied to this item.';


--
-- Name: data_source; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.data_source (
    pk integer NOT NULL,
    name_long text NOT NULL,
    name_short text NOT NULL,
    version text NOT NULL,
    description text,
    source text NOT NULL,
    lang text
)
INHERITS (audit.audit_fields);


ALTER TABLE ref.data_source OWNER TO "gm-dbo";

--
-- Name: TABLE data_source; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.data_source IS 'lists the available coding systems, classifications, ontologies and term lists';


--
-- Name: COLUMN data_source.name_long; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.data_source.name_long IS 'long, complete (, ?official) name for this reference entry';


--
-- Name: COLUMN data_source.name_short; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.data_source.name_short IS 'shorthand for referring to this reference entry';


--
-- Name: COLUMN data_source.version; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.data_source.version IS 'the exact and non-ambigous version for this entry';


--
-- Name: COLUMN data_source.description; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.data_source.description IS 'optional arbitrary description, should include external license';


--
-- Name: COLUMN data_source.source; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.data_source.source IS 'non-ambigous description of source; with this info in hand it
 must be possible to locate a copy of the external data set';


--
-- Name: v_bill_items; Type: VIEW; Schema: bill; Owner: gm-dbo
--

CREATE VIEW bill.v_bill_items AS
 SELECT b_bi.pk AS pk_bill_item,
    r_b.code AS billable_code,
    r_b.term AS billable_description,
    b_bi.description AS item_detail,
    COALESCE((b_bi.date_to_bill)::timestamp with time zone, c_enc.started) AS date_to_bill,
    b_bi.net_amount_per_unit,
    b_bi.unit_count,
    b_bi.amount_multiplier,
    (((b_bi.unit_count)::numeric * b_bi.net_amount_per_unit) * b_bi.amount_multiplier) AS total_amount,
    ((((b_bi.unit_count)::numeric * b_bi.net_amount_per_unit) * b_bi.amount_multiplier) * r_b.vat_multiplier) AS vat,
    b_bi.currency,
    b_bi.date_to_bill AS raw_date_to_bill,
    r_b.amount AS billable_amount,
    r_b.vat_multiplier,
    r_b.currency AS billable_currency,
    r_b.comment AS billable_comment,
    r_b.active AS billable_active,
    r_b.discountable AS billable_discountable,
    r_ds.name_long AS catalog_long,
    r_ds.name_short AS catalog_short,
    r_ds.version AS catalog_version,
    r_ds.lang AS catalog_language,
    c_enc.fk_patient AS pk_patient,
    c_enc.fk_type AS pk_encounter_type,
    b_bi.fk_provider AS pk_provider,
    b_bi.fk_encounter AS pk_encounter_to_bill,
    b_bi.fk_bill AS pk_bill,
    r_b.pk AS pk_billable,
    r_b.fk_data_source AS pk_data_source,
    b_bi.xmin AS xmin_bill_item
   FROM (((bill.bill_item b_bi
     JOIN ref.billable r_b ON ((b_bi.fk_billable = r_b.pk)))
     LEFT JOIN ref.data_source r_ds ON ((r_b.fk_data_source = r_ds.pk)))
     LEFT JOIN clin.encounter c_enc ON ((b_bi.fk_encounter = c_enc.pk)));


ALTER TABLE bill.v_bill_items OWNER TO "gm-dbo";

--
-- Name: v_bills; Type: VIEW; Schema: bill; Owner: gm-dbo
--

CREATE VIEW bill.v_bills AS
 SELECT b_b.pk AS pk_bill,
    b_b.invoice_id,
    b_b.fk_receiver_identity AS pk_receiver_identity,
    ( SELECT round(sum(v_bill_items.total_amount), 2) AS round
           FROM bill.v_bill_items
          WHERE (v_bill_items.pk_bill = b_b.pk)) AS total_amount,
    ( SELECT round(sum(v_bill_items.vat), 2) AS round
           FROM bill.v_bill_items
          WHERE (v_bill_items.pk_bill = b_b.pk)) AS total_vat,
    ( SELECT round(sum((v_bill_items.total_amount + v_bill_items.vat)), 2) AS round
           FROM bill.v_bill_items
          WHERE (v_bill_items.pk_bill = b_b.pk)) AS total_amount_with_vat,
    ( SELECT (v_bill_items.vat_multiplier * (100)::numeric)
           FROM bill.v_bill_items
          WHERE (v_bill_items.pk_bill = b_b.pk)
         LIMIT 1) AS percent_vat,
    ( SELECT v_bill_items.currency
           FROM bill.v_bill_items
          WHERE (v_bill_items.pk_bill = b_b.pk)
         LIMIT 1) AS currency,
    b_b.close_date,
    b_b.apply_vat,
    b_b.comment,
    b_b.fk_receiver_address AS pk_receiver_address,
    b_b.fk_doc AS pk_doc,
    ( SELECT encounter.fk_patient
           FROM clin.encounter
          WHERE (encounter.pk = ( SELECT bill_item.fk_encounter
                   FROM bill.bill_item
                  WHERE (bill_item.fk_bill = b_b.pk)
                 LIMIT 1))) AS pk_patient,
    ( SELECT array_agg(sorted_values.pk_bill_item) AS array_agg
           FROM ( SELECT b_vbi.pk_bill_item
                   FROM bill.v_bill_items b_vbi
                  WHERE (b_vbi.pk_bill = b_b.pk)
                  ORDER BY b_vbi.date_to_bill, b_vbi.billable_code) sorted_values) AS pk_bill_items,
    b_b.xmin AS xmin_bill
   FROM bill.bill b_b;


ALTER TABLE bill.v_bills OWNER TO "gm-dbo";

--
-- Name: doc_desc; Type: TABLE; Schema: blobs; Owner: gm-dbo
--

CREATE TABLE blobs.doc_desc (
    pk integer NOT NULL,
    fk_doc integer,
    text text
)
INHERITS (audit.audit_fields);


ALTER TABLE blobs.doc_desc OWNER TO "gm-dbo";

--
-- Name: TABLE doc_desc; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON TABLE blobs.doc_desc IS 'A textual description of the content such
	 as a result summary. Several of these may
	 belong to one document object.';


--
-- Name: doc_desc_pk_seq; Type: SEQUENCE; Schema: blobs; Owner: gm-dbo
--

CREATE SEQUENCE blobs.doc_desc_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE blobs.doc_desc_pk_seq OWNER TO "gm-dbo";

--
-- Name: doc_desc_pk_seq; Type: SEQUENCE OWNED BY; Schema: blobs; Owner: gm-dbo
--

ALTER SEQUENCE blobs.doc_desc_pk_seq OWNED BY blobs.doc_desc.pk;


--
-- Name: doc_med; Type: TABLE; Schema: blobs; Owner: gm-dbo
--

CREATE TABLE blobs.doc_med (
    pk integer NOT NULL,
    fk_encounter integer NOT NULL,
    fk_episode integer NOT NULL,
    fk_type integer NOT NULL,
    comment text,
    clin_when timestamp with time zone DEFAULT now() NOT NULL,
    ext_ref text,
    fk_org_unit integer,
    unit_is_receiver boolean DEFAULT false NOT NULL,
    fk_hospital_stay integer
)
INHERITS (audit.audit_fields);


ALTER TABLE blobs.doc_med OWNER TO "gm-dbo";

--
-- Name: TABLE doc_med; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON TABLE blobs.doc_med IS 'a medical document object possibly containing several
	 data objects such as several pages of a paper document';


--
-- Name: COLUMN doc_med.fk_encounter; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON COLUMN blobs.doc_med.fk_encounter IS 'the encounter in which this document was entered into the system';


--
-- Name: COLUMN doc_med.fk_episode; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON COLUMN blobs.doc_med.fk_episode IS 'the episode this document pertains to, this may not be the only
	 one applicable to the document (think discharge letters), see also
	 lnk_doc_med2episode';


--
-- Name: COLUMN doc_med.fk_type; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON COLUMN blobs.doc_med.fk_type IS 'semantic type of document (not type of file or mime
	 type), such as "referral letter", "discharge summary", etc.';


--
-- Name: COLUMN doc_med.comment; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON COLUMN blobs.doc_med.comment IS 'additional short comment such as "abdominal", "ward 3,
	 Dr. Stein", etc.';


--
-- Name: COLUMN doc_med.clin_when; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON COLUMN blobs.doc_med.clin_when IS 'date of document content creation (such as exam date),
	 NOT date of document creation or date of import; may
	 be imprecise such as "7/99"';


--
-- Name: COLUMN doc_med.ext_ref; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON COLUMN blobs.doc_med.ext_ref IS 'external reference string of physical document,
	 original paper copy can be found with this';


--
-- Name: COLUMN doc_med.fk_org_unit; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON COLUMN blobs.doc_med.fk_org_unit IS 'Optional link to the org unit this document originates from.\n
Note that the document may contain data from several units but\n
there will always be one "sender".';


--
-- Name: COLUMN doc_med.unit_is_receiver; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON COLUMN blobs.doc_med.unit_is_receiver IS 'whether the org unit is the receiver rather than the document source';


--
-- Name: COLUMN doc_med.fk_hospital_stay; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON COLUMN blobs.doc_med.fk_hospital_stay IS 'the hospital stay this document is associated with';


--
-- Name: doc_med_pk_seq; Type: SEQUENCE; Schema: blobs; Owner: gm-dbo
--

CREATE SEQUENCE blobs.doc_med_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE blobs.doc_med_pk_seq OWNER TO "gm-dbo";

--
-- Name: doc_med_pk_seq; Type: SEQUENCE OWNED BY; Schema: blobs; Owner: gm-dbo
--

ALTER SEQUENCE blobs.doc_med_pk_seq OWNED BY blobs.doc_med.pk;


--
-- Name: doc_obj; Type: TABLE; Schema: blobs; Owner: gm-dbo
--

CREATE TABLE blobs.doc_obj (
    pk integer NOT NULL,
    fk_doc integer NOT NULL,
    seq_idx integer,
    comment text,
    fk_intended_reviewer integer NOT NULL,
    data bytea NOT NULL,
    filename text,
    CONSTRAINT doc_obj_filename_check CHECK ((btrim(COALESCE(filename, 'NULL'::text)) <> ''::text))
);


ALTER TABLE blobs.doc_obj OWNER TO "gm-dbo";

--
-- Name: TABLE doc_obj; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON TABLE blobs.doc_obj IS 'possibly several of these form a medical document
	 such as multiple scanned pages/images';


--
-- Name: COLUMN doc_obj.seq_idx; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON COLUMN blobs.doc_obj.seq_idx IS 'index of this object in the sequence
	 of objects for this document';


--
-- Name: COLUMN doc_obj.comment; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON COLUMN blobs.doc_obj.comment IS 'optional tiny comment for this
	 object, such as "page 1"';


--
-- Name: COLUMN doc_obj.fk_intended_reviewer; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON COLUMN blobs.doc_obj.fk_intended_reviewer IS 'who is *supposed* to review this item';


--
-- Name: COLUMN doc_obj.data; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON COLUMN blobs.doc_obj.data IS 'actual binary object data;

	 here is why we use bytea:

== --------------------------------------------------

To: leon@oss.minimetria.com

Cc: pgsql-sql@postgresql.org

Subject: Re: [SQL] Recommendation on bytea or blob for binary data like images 

Date: Fri, 02 Sep 2005 16:33:09 -0400

Message-ID: <17794.1125693189@sss.pgh.pa.us>

From: Tom Lane <tgl@sss.pgh.pa.us>

List-Archive: <http://archives.postgresql.org/pgsql-sql>

List-Help: <mailto:majordomo@postgresql.org?body=help>

List-ID: <pgsql-sql.postgresql.org>



leon@oss.minimetria.com writes:

> Hi, I"d like to know what the official recommendation is on which binary

> datatype to use for common small-binary size use.



If bytea will work for you, it"s definitely the thing to use.  The only

real drawback to bytea is that there"s currently no API to read and

write bytea values in a streaming fashion.  If your objects are small

enough that you can load and store them as units, bytea is fine.



BLOBs, on the other hand, have a number of drawbacks --- hard to dump,

impossible to secure, etc.



			regards, tom lane

== --------------------------------------------------';


--
-- Name: COLUMN doc_obj.filename; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON COLUMN blobs.doc_obj.filename IS 'the filename from when the data was imported - if any, can be NULL,
	 useful for re-export since legacy devices/applications might expect
	 particular file names and not use mime types for file detection';


--
-- Name: doc_obj_pk_seq; Type: SEQUENCE; Schema: blobs; Owner: gm-dbo
--

CREATE SEQUENCE blobs.doc_obj_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE blobs.doc_obj_pk_seq OWNER TO "gm-dbo";

--
-- Name: doc_obj_pk_seq; Type: SEQUENCE OWNED BY; Schema: blobs; Owner: gm-dbo
--

ALTER SEQUENCE blobs.doc_obj_pk_seq OWNED BY blobs.doc_obj.pk;


--
-- Name: doc_type; Type: TABLE; Schema: blobs; Owner: gm-dbo
--

CREATE TABLE blobs.doc_type (
    pk integer NOT NULL,
    name text NOT NULL
);


ALTER TABLE blobs.doc_type OWNER TO "gm-dbo";

--
-- Name: TABLE doc_type; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON TABLE blobs.doc_type IS 'this table enumerates the document types known to the system';


--
-- Name: COLUMN doc_type.name; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON COLUMN blobs.doc_type.name IS 'the name/label of the document type';


--
-- Name: doc_type_pk_seq; Type: SEQUENCE; Schema: blobs; Owner: gm-dbo
--

CREATE SEQUENCE blobs.doc_type_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE blobs.doc_type_pk_seq OWNER TO "gm-dbo";

--
-- Name: doc_type_pk_seq; Type: SEQUENCE OWNED BY; Schema: blobs; Owner: gm-dbo
--

ALTER SEQUENCE blobs.doc_type_pk_seq OWNED BY blobs.doc_type.pk;


--
-- Name: lnk_doc_med2episode; Type: TABLE; Schema: blobs; Owner: gm-dbo
--

CREATE TABLE blobs.lnk_doc_med2episode (
    pk integer NOT NULL,
    fk_episode integer NOT NULL,
    fk_doc_med integer NOT NULL
)
INHERITS (audit.audit_fields);


ALTER TABLE blobs.lnk_doc_med2episode OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_doc_med2episode; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON TABLE blobs.lnk_doc_med2episode IS 'this allows linking documents to episodes,
	 each document can apply to several episodes
	 but only once each';


--
-- Name: lnk_doc_med2episode_pk_seq; Type: SEQUENCE; Schema: blobs; Owner: gm-dbo
--

CREATE SEQUENCE blobs.lnk_doc_med2episode_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE blobs.lnk_doc_med2episode_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_doc_med2episode_pk_seq; Type: SEQUENCE OWNED BY; Schema: blobs; Owner: gm-dbo
--

ALTER SEQUENCE blobs.lnk_doc_med2episode_pk_seq OWNED BY blobs.lnk_doc_med2episode.pk;


--
-- Name: review_root; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.review_root (
    pk integer NOT NULL,
    fk_reviewed_row integer NOT NULL,
    fk_reviewer integer NOT NULL,
    is_technically_abnormal boolean NOT NULL,
    clinically_relevant boolean NOT NULL,
    comment text
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.review_root OWNER TO "gm-dbo";

--
-- Name: TABLE review_root; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.review_root IS 'this table tracks whether a particular clinical item
	 was reviewed by a clinician or not';


--
-- Name: COLUMN review_root.fk_reviewed_row; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.review_root.fk_reviewed_row IS 'the row the review status is for: to be qualified
	 as a proper foreign key in child tables';


--
-- Name: COLUMN review_root.fk_reviewer; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.review_root.fk_reviewer IS 'who has reviewed the item';


--
-- Name: COLUMN review_root.is_technically_abnormal; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.review_root.is_technically_abnormal IS 'whether test provider flagged this result as abnormal,
	 *not* a clinical assessment but rather a technical one
	 LDT: exist(8422)';


--
-- Name: COLUMN review_root.clinically_relevant; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.review_root.clinically_relevant IS 'whether this result is considered relevant clinically,
	 need not correspond to the value of "techically_abnormal"
	 since abnormal values may be irrelevant while normal
	 ones can be of significance';


--
-- Name: reviewed_doc_objs; Type: TABLE; Schema: blobs; Owner: gm-dbo
--

CREATE TABLE blobs.reviewed_doc_objs (
)
INHERITS (clin.review_root);


ALTER TABLE blobs.reviewed_doc_objs OWNER TO "gm-dbo";

--
-- Name: TABLE reviewed_doc_objs; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON TABLE blobs.reviewed_doc_objs IS 'review table for documents (per object such as a page)';


--
-- Name: episode; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.episode (
    pk integer NOT NULL,
    fk_health_issue integer,
    description text NOT NULL,
    is_open boolean DEFAULT true,
    fk_encounter integer NOT NULL,
    diagnostic_certainty_classification text,
    summary text,
    CONSTRAINT episode_sane_summary CHECK (gm.is_null_or_non_empty_string(summary)),
    CONSTRAINT sane_description CHECK ((gm.is_null_or_blank_string(description) IS FALSE)),
    CONSTRAINT valid_diagnostic_certainty_classification CHECK ((diagnostic_certainty_classification = ANY (ARRAY['A'::text, 'B'::text, 'C'::text, 'D'::text, NULL::text])))
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.episode OWNER TO "gm-dbo";

--
-- Name: TABLE episode; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.episode IS 'Clinical episodes such as "Otitis media",
	 "traffic accident 7/99", "Hepatitis B".
	 This covers a range of time in which
	 activity of illness was noted for the
	 problem episode.description.';


--
-- Name: COLUMN episode.fk_health_issue; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.episode.fk_health_issue IS 'health issue this episode belongs to';


--
-- Name: COLUMN episode.description; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.episode.description IS 'description/name of this episode';


--
-- Name: COLUMN episode.is_open; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.episode.is_open IS 'whether the episode is open (eg. there is activity for it),
	 means open in a temporal sense as in "not closed yet";
	 only one episode can be open per health issue';


--
-- Name: COLUMN episode.fk_encounter; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.episode.fk_encounter IS 'The encounter during which this episode was added (begun).';


--
-- Name: COLUMN episode.diagnostic_certainty_classification; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.episode.diagnostic_certainty_classification IS 'The certainty at which this problem is believed to be a diagnosis:
A: sign (Symptom)
B: cluster of signs (Symptomkomplex)
C: syndromic diagnosis (Bild einer Diagnose)
D: proven diagnosis (diagnostisch gesichert)';


--
-- Name: COLUMN episode.summary; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.episode.summary IS 'Used for tracking the summary of this episode.';


--
-- Name: health_issue; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.health_issue (
    pk integer NOT NULL,
    description text NOT NULL,
    laterality character varying(2) DEFAULT NULL::character varying,
    age_noted interval,
    is_active boolean DEFAULT true,
    clinically_relevant boolean DEFAULT true,
    is_confidential boolean DEFAULT false,
    is_cause_of_death boolean DEFAULT false NOT NULL,
    fk_encounter integer NOT NULL,
    "grouping" text,
    diagnostic_certainty_classification text,
    summary text,
    CONSTRAINT health_issue_laterality_check CHECK (((laterality)::text = ANY (ARRAY[(NULL::character varying)::text, ('s'::character varying)::text, ('d'::character varying)::text, ('sd'::character varying)::text, ('na'::character varying)::text]))),
    CONSTRAINT health_issue_sane_summary CHECK (gm.is_null_or_non_empty_string(summary)),
    CONSTRAINT issue_name_not_empty CHECK ((btrim(description) <> ''::text)),
    CONSTRAINT sane_grouping CHECK (gm.is_null_or_non_empty_string("grouping")),
    CONSTRAINT valid_diagnostic_certainty_classification CHECK ((diagnostic_certainty_classification = ANY (ARRAY['A'::text, 'B'::text, 'C'::text, 'D'::text, NULL::text])))
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.health_issue OWNER TO "gm-dbo";

--
-- Name: TABLE health_issue; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.health_issue IS 'This is pretty much what others would call "Past Medical History"
	 or "Foundational illness", eg. longer-ranging, underlying,
	 encompassing issues with one''s health such as "immunodeficiency",
	 "type 2 diabetes". In Belgium it is called "problem".
	 L.L.Weed includes lots of little things into it, we do not.';


--
-- Name: COLUMN health_issue.description; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.health_issue.description IS 'descriptive name of this health issue, may
	 change over time as evidence increases';


--
-- Name: COLUMN health_issue.laterality; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.health_issue.laterality IS 'NULL: don''t know
	 s: sinister - left
	 d: dexter - right
	 sd: sinister and dexter - both sides
	 na: not applicable';


--
-- Name: COLUMN health_issue.age_noted; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.health_issue.age_noted IS 'at what age the patient acquired the condition';


--
-- Name: COLUMN health_issue.is_active; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.health_issue.is_active IS 'whether this health issue (problem) is active';


--
-- Name: COLUMN health_issue.clinically_relevant; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.health_issue.clinically_relevant IS 'whether this health issue (problem) has any clinical relevance';


--
-- Name: COLUMN health_issue.fk_encounter; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.health_issue.fk_encounter IS 'The encounter during which this health issue was added.';


--
-- Name: COLUMN health_issue."grouping"; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.health_issue."grouping" IS 'This can be used to entirely arbitrarily group health
 issues felt to belong to each other.';


--
-- Name: COLUMN health_issue.diagnostic_certainty_classification; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.health_issue.diagnostic_certainty_classification IS 'The certainty at which this issue is believed to be a diagnosis:
A: sign (Symptom)
B: cluster of signs (Symptomkomplex)
C: syndromic diagnosis (Bild einer Diagnose)
D: proven diagnosis (diagnostisch gesichert)';


--
-- Name: COLUMN health_issue.summary; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.health_issue.summary IS 'Used for tracking the summary of this health issue.';


--
-- Name: org; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.org (
    pk integer NOT NULL,
    description text,
    fk_category integer,
    fk_data_source integer,
    CONSTRAINT org_sane_description CHECK ((gm.is_null_or_blank_string(description) IS FALSE))
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.org OWNER TO "gm-dbo";

--
-- Name: TABLE org; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.org IS 'Organizations at a conceptual level.';


--
-- Name: COLUMN org.description; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.org.description IS 'High-level, conceptual description (= name) of organization, such as "University of Manchester".';


--
-- Name: COLUMN org.fk_data_source; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.org.fk_data_source IS 'Source of the organization data.';


--
-- Name: org_unit; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.org_unit (
    pk integer NOT NULL,
    description text,
    fk_org integer NOT NULL,
    fk_address integer,
    fk_category integer,
    CONSTRAINT org_unit_sane_description CHECK ((gm.is_null_or_blank_string(description) IS FALSE))
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.org_unit OWNER TO "gm-dbo";

--
-- Name: TABLE org_unit; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.org_unit IS 'Actual branches/departments/offices/... of organizations.';


--
-- Name: COLUMN org_unit.description; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.org_unit.description IS 'Description (= name) of branch of organization, such as "Elms Street office of Jim Busser Praxis".';


--
-- Name: v_doc_med; Type: VIEW; Schema: blobs; Owner: gm-dbo
--

CREATE VIEW blobs.v_doc_med AS
 SELECT c_enc.fk_patient AS pk_patient,
    b_dm.pk AS pk_doc,
    b_dm.clin_when,
    b_dt.name AS type,
    public._(b_dt.name) AS l10n_type,
    b_dm.ext_ref,
    b_dm.comment,
    c_epi.description AS episode,
    c_hi.description AS health_issue,
    c_epi.is_open AS episode_open,
    d_ou.description AS unit,
    d_o.description AS organization,
    b_dm.unit_is_receiver,
    COALESCE(( SELECT array_agg(b_do.seq_idx) AS array_agg
           FROM blobs.doc_obj b_do
          WHERE (b_do.fk_doc = b_dm.pk)), ARRAY[]::integer[]) AS seq_idx_list,
    b_dm.fk_type AS pk_type,
    b_dm.fk_encounter AS pk_encounter,
    b_dm.fk_episode AS pk_episode,
    c_epi.fk_health_issue AS pk_health_issue,
    d_ou.fk_org AS pk_org,
    b_dm.fk_hospital_stay AS pk_hospital_stay,
    b_dm.fk_org_unit AS pk_org_unit,
    b_dm.modified_when,
    b_dm.modified_by,
    b_dm.xmin AS xmin_doc_med
   FROM ((((((blobs.doc_med b_dm
     JOIN blobs.doc_type b_dt ON ((b_dm.fk_type = b_dt.pk)))
     JOIN clin.encounter c_enc ON ((b_dm.fk_encounter = c_enc.pk)))
     JOIN clin.episode c_epi ON ((b_dm.fk_episode = c_epi.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_hi.pk = c_epi.fk_health_issue)))
     LEFT JOIN dem.org_unit d_ou ON ((b_dm.fk_org_unit = d_ou.pk)))
     LEFT JOIN dem.org d_o ON ((d_ou.fk_org = d_o.pk)));


ALTER TABLE blobs.v_doc_med OWNER TO "gm-dbo";

--
-- Name: v_doc_desc; Type: VIEW; Schema: blobs; Owner: gm-dbo
--

CREATE VIEW blobs.v_doc_desc AS
 SELECT vdm.pk_patient,
    dd.fk_doc AS pk_doc,
    dd.text AS description,
    vdm.pk_encounter,
    vdm.pk_episode,
    vdm.pk_health_issue,
    dd.pk AS pk_doc_desc
   FROM blobs.doc_desc dd,
    blobs.v_doc_med vdm
  WHERE (dd.fk_doc = vdm.pk_doc);


ALTER TABLE blobs.v_doc_desc OWNER TO "gm-dbo";

--
-- Name: VIEW v_doc_desc; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON VIEW blobs.v_doc_desc IS 'aggregates some document data descriptions';


--
-- Name: encounter_type; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.encounter_type (
    pk integer NOT NULL,
    description text NOT NULL
);


ALTER TABLE clin.encounter_type OWNER TO "gm-dbo";

--
-- Name: TABLE encounter_type; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.encounter_type IS 'these are the types of encounter';


--
-- Name: v_doc_med_journal; Type: VIEW; Schema: blobs; Owner: gm-dbo
--

CREATE VIEW blobs.v_doc_med_journal AS
 SELECT c_enc.fk_patient AS pk_patient,
    b_dm.modified_when,
    b_dm.clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = b_dm.modified_by)), (('<'::text || (b_dm.modified_by)::text) || '>'::text)) AS modified_by,
    NULL::text AS soap_cat,
    ('"'::text || ((((((((((((((public._(b_dt.name) || '" '::text) || public._('with'::text)) || ' '::text) || ( SELECT count(1) AS count
           FROM blobs.doc_obj b_do
          WHERE (b_do.fk_doc = b_dm.pk))) || ' '::text) || public._('part(s)'::text)) || '
'::text) || ' '::text) || to_char(b_dm.clin_when, 'YYYY-MM-DD HH24:MI'::text)) || '
'::text) || COALESCE(((' ['::text || b_dm.ext_ref) || ']'::text), ''::text)) ||
        CASE
            WHEN b_dm.unit_is_receiver THEN COALESCE(((((((' '::text || public._('sent to'::text)) || d_ou.description) || ' '::text) || public._('of'::text)) || ' '::text) || d_o.description), ''::text)
            ELSE COALESCE((((((' @ '::text || d_ou.description) || ' '::text) || public._('of'::text)) || ' '::text) || d_o.description), ''::text)
        END) || '
'::text) || COALESCE((' '::text || b_dm.comment), ''::text))) AS narrative,
    b_dm.fk_encounter AS pk_encounter,
    b_dm.fk_episode AS pk_episode,
    c_epi.fk_health_issue AS pk_health_issue,
    b_dm.pk AS src_pk,
    'blobs.doc_med'::text AS src_table,
    b_dm.row_version,
    c_hi.description AS health_issue,
    c_hi.laterality AS issue_laterality,
    c_hi.is_active AS issue_active,
    c_hi.clinically_relevant AS issue_clinically_relevant,
    c_hi.is_confidential AS issue_confidential,
    c_epi.description AS episode,
    c_epi.is_open AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM (((((((blobs.doc_med b_dm
     JOIN clin.encounter c_enc ON ((b_dm.fk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
     JOIN blobs.doc_type b_dt ON ((b_dm.fk_type = b_dt.pk)))
     JOIN clin.episode c_epi ON ((b_dm.fk_episode = c_epi.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_epi.fk_health_issue = c_hi.pk)))
     LEFT JOIN dem.org_unit d_ou ON ((b_dm.fk_org_unit = d_ou.pk)))
     LEFT JOIN dem.org d_o ON ((d_ou.fk_org = d_o.pk)));


ALTER TABLE blobs.v_doc_med_journal OWNER TO "gm-dbo";

--
-- Name: document_type; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.document_type (
    pk integer NOT NULL,
    scope text,
    description text NOT NULL
);


ALTER TABLE ref.document_type OWNER TO "gm-dbo";

--
-- Name: TABLE document_type; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.document_type IS 'pre-installed document types, do not
	 change these as they will be overwritten
	 during database upgrades at the discretion
	 of the GNUmed team';


--
-- Name: COLUMN document_type.scope; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.document_type.scope IS 'can be used to group document types according
	 to applicability, say, per country';


--
-- Name: v_doc_type; Type: VIEW; Schema: blobs; Owner: gm-dbo
--

CREATE VIEW blobs.v_doc_type AS
 SELECT dt.pk AS pk_doc_type,
    dt.name AS type,
    public._(dt.name) AS l10n_type,
    (NOT (EXISTS ( SELECT 1
           FROM ref.document_type
          WHERE (document_type.description = dt.name)))) AS is_user_defined,
    (EXISTS ( SELECT 1
           FROM blobs.doc_med
          WHERE (doc_med.fk_type = dt.pk))) AS is_in_use,
    dt.xmin AS xmin_doc_type
   FROM blobs.doc_type dt;


ALTER TABLE blobs.v_doc_type OWNER TO "gm-dbo";

--
-- Name: VIEW v_doc_type; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON VIEW blobs.v_doc_type IS 'list active document types, those that are activated for use';


--
-- Name: v_obj4doc_no_data; Type: VIEW; Schema: blobs; Owner: gm-dbo
--

CREATE VIEW blobs.v_obj4doc_no_data AS
 SELECT b_vdm.pk_patient,
    b_do.pk AS pk_obj,
    b_do.seq_idx,
    octet_length(COALESCE(b_do.data, '\x'::bytea)) AS size,
    b_vdm.clin_when AS date_generated,
    b_vdm.type,
    b_vdm.l10n_type,
    b_vdm.ext_ref,
    b_vdm.episode,
    b_vdm.comment AS doc_comment,
    b_do.comment AS obj_comment,
    b_do.filename,
    b_do.fk_intended_reviewer AS pk_intended_reviewer,
    (EXISTS ( SELECT 1
           FROM blobs.reviewed_doc_objs
          WHERE (reviewed_doc_objs.fk_reviewed_row = b_do.pk))) AS reviewed,
    (EXISTS ( SELECT 1
           FROM blobs.reviewed_doc_objs
          WHERE ((reviewed_doc_objs.fk_reviewed_row = b_do.pk) AND (reviewed_doc_objs.fk_reviewer = ( SELECT staff.pk
                   FROM dem.staff
                  WHERE (staff.db_user = "current_user"())))))) AS reviewed_by_you,
    (EXISTS ( SELECT 1
           FROM blobs.reviewed_doc_objs
          WHERE ((reviewed_doc_objs.fk_reviewed_row = b_do.pk) AND (reviewed_doc_objs.fk_reviewer = b_do.fk_intended_reviewer)))) AS reviewed_by_intended_reviewer,
    b_vdm.pk_doc,
    b_vdm.pk_type,
    b_vdm.pk_encounter,
    b_vdm.pk_episode,
    b_vdm.pk_health_issue,
    b_vdm.pk_org,
    b_vdm.pk_org_unit,
    b_vdm.pk_hospital_stay,
    b_do.xmin AS xmin_doc_obj
   FROM (blobs.v_doc_med b_vdm
     JOIN blobs.doc_obj b_do ON ((b_do.fk_doc = b_vdm.pk_doc)))
  WHERE (b_vdm.pk_doc = b_do.fk_doc);


ALTER TABLE blobs.v_obj4doc_no_data OWNER TO "gm-dbo";

--
-- Name: VIEW v_obj4doc_no_data; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON VIEW blobs.v_obj4doc_no_data IS 'denormalized metadata for blobs.doc_obj but without the data itself';


--
-- Name: v_latest_mugshot; Type: VIEW; Schema: blobs; Owner: gm-dbo
--

CREATE VIEW blobs.v_latest_mugshot AS
 SELECT b_vo4d.pk_patient,
    b_vo4d.doc_comment,
    b_vo4d.date_generated AS date_taken,
    b_vo4d.ext_ref,
    b_vo4d.seq_idx AS obj_seq_idx,
    b_vo4d.obj_comment,
    b_vo4d.pk_doc,
    b_vo4d.pk_obj,
    b_do.data AS image
   FROM blobs.v_obj4doc_no_data b_vo4d,
    blobs.doc_obj b_do
  WHERE ((b_vo4d.type = 'patient photograph'::text) AND (b_vo4d.seq_idx = ( SELECT max(b_vo4d1.seq_idx) AS max
           FROM blobs.v_obj4doc_no_data b_vo4d1
          WHERE ((b_vo4d1.pk_patient = b_vo4d.pk_patient) AND (b_vo4d1.type = 'patient photograph'::text))
          GROUP BY b_vo4d1.date_generated
          ORDER BY b_vo4d1.date_generated DESC
         LIMIT 1)) AND (b_do.pk = b_vo4d.pk_obj));


ALTER TABLE blobs.v_latest_mugshot OWNER TO "gm-dbo";

--
-- Name: VIEW v_latest_mugshot; Type: COMMENT; Schema: blobs; Owner: gm-dbo
--

COMMENT ON VIEW blobs.v_latest_mugshot IS 'shows the latest picture of the patient, currently the highest
	 seq_idx of the newest document of type "patient photograph"';


--
-- Name: v_reviewed_doc_objects; Type: VIEW; Schema: blobs; Owner: gm-dbo
--

CREATE VIEW blobs.v_reviewed_doc_objects AS
 SELECT b_rdo.fk_reviewed_row AS pk_doc_obj,
    COALESCE(d_s.short_alias, (('<#'::text || b_rdo.fk_reviewer) || '>'::text)) AS reviewer,
    b_rdo.is_technically_abnormal,
    b_rdo.clinically_relevant,
    (b_rdo.fk_reviewer = b_do.fk_intended_reviewer) AS is_review_by_responsible_reviewer,
    (b_rdo.fk_reviewer = ( SELECT staff.pk
           FROM dem.staff
          WHERE (staff.db_user = CURRENT_USER))) AS is_your_review,
    b_rdo.comment,
    b_rdo.modified_when AS reviewed_when,
    b_rdo.modified_by,
    b_rdo.pk AS pk_review_root,
    b_rdo.fk_reviewer AS pk_reviewer,
    c_enc.fk_patient AS pk_patient,
    b_dm.fk_encounter AS pk_encounter,
    b_dm.fk_episode AS pk_episode,
    c_epi.fk_health_issue AS pk_health_issue
   FROM (((((blobs.reviewed_doc_objs b_rdo
     LEFT JOIN dem.staff d_s ON ((d_s.pk = b_rdo.fk_reviewer)))
     LEFT JOIN blobs.doc_obj b_do ON ((b_do.pk = b_rdo.fk_reviewed_row)))
     LEFT JOIN blobs.doc_med b_dm ON ((b_do.fk_doc = b_dm.pk)))
     LEFT JOIN clin.episode c_epi ON ((b_dm.fk_episode = c_epi.pk)))
     LEFT JOIN clin.encounter c_enc ON ((c_epi.fk_encounter = c_enc.pk)));


ALTER TABLE blobs.v_reviewed_doc_objects OWNER TO "gm-dbo";

--
-- Name: v_unreviewed_docs; Type: VIEW; Schema: blobs; Owner: gm-dbo
--

CREATE VIEW blobs.v_unreviewed_docs AS
 SELECT DISTINCT ON (b_do.fk_doc) b_do.fk_doc AS pk_doc,
    min(b_do.fk_intended_reviewer) AS pk_intended_reviewer,
    min(c_e.fk_patient) AS pk_patient
   FROM ((blobs.doc_obj b_do
     JOIN blobs.doc_med b_dm ON ((b_dm.pk = b_do.fk_doc)))
     JOIN clin.encounter c_e ON ((b_dm.fk_encounter = c_e.pk)))
  WHERE (NOT (EXISTS ( SELECT 1
           FROM blobs.reviewed_doc_objs b_rdo
          WHERE (b_rdo.fk_reviewed_row = b_do.pk))))
  GROUP BY b_do.fk_doc;


ALTER TABLE blobs.v_unreviewed_docs OWNER TO "gm-dbo";

--
-- Name: v_unreviewed_docs_summary; Type: VIEW; Schema: blobs; Owner: gm-dbo
--

CREATE VIEW blobs.v_unreviewed_docs_summary AS
 SELECT b_vud.pk_patient,
    count(1) AS no_of_docs
   FROM blobs.v_unreviewed_docs b_vud
  GROUP BY b_vud.pk_patient;


ALTER TABLE blobs.v_unreviewed_docs_summary OWNER TO "gm-dbo";

--
-- Name: inbox_item_category; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.inbox_item_category (
    pk integer NOT NULL,
    description text NOT NULL,
    is_user boolean DEFAULT true NOT NULL,
    CONSTRAINT inbox_item_category_description_check CHECK ((btrim(COALESCE(description, 'xxxDEFAULTxxx'::text)) <> ''::text))
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.inbox_item_category OWNER TO "gm-dbo";

--
-- Name: TABLE inbox_item_category; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.inbox_item_category IS 'Holds the various categories of messages that
	 can show up in the provider inbox.';


--
-- Name: COLUMN inbox_item_category.description; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.inbox_item_category.description IS '
"clinical"

"admin"

"personal"

...';


--
-- Name: COLUMN inbox_item_category.is_user; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.inbox_item_category.is_user IS 'whether this category was added locally,
	 as to be left alone by database upgrades';


--
-- Name: inbox_item_type; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.inbox_item_type (
    pk integer NOT NULL,
    fk_inbox_item_category integer NOT NULL,
    description text NOT NULL,
    is_user boolean DEFAULT true NOT NULL,
    CONSTRAINT inbox_item_type_description_check CHECK ((btrim(COALESCE(description, 'xxxDEFAULTxxx'::text)) <> ''::text))
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.inbox_item_type OWNER TO "gm-dbo";

--
-- Name: TABLE inbox_item_type; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.inbox_item_type IS 'Holds the various types of messages that can
	 show up in the provider inbox.';


--
-- Name: COLUMN inbox_item_type.fk_inbox_item_category; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.inbox_item_type.fk_inbox_item_category IS 'The category of this item type.';


--
-- Name: COLUMN inbox_item_type.description; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.inbox_item_type.description IS 'the various types of inbox items';


--
-- Name: COLUMN inbox_item_type.is_user; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.inbox_item_type.is_user IS 'whether this type was added locally,
	 as to be left alone by database upgrades';


--
-- Name: names; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.names (
    id integer NOT NULL,
    id_identity integer NOT NULL,
    active boolean DEFAULT true,
    lastnames text NOT NULL,
    firstnames text NOT NULL,
    preferred text,
    comment text
);


ALTER TABLE dem.names OWNER TO "gm-dbo";

--
-- Name: TABLE names; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.names IS 'all the names an identity is known under;
	 As opposed to the versioning of all other tables, changed names
	 should not be moved into the audit trail tables. Search functionality
	 must be available at any time for all names a person ever had.';


--
-- Name: COLUMN names.active; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.names.active IS 'true if the name is still in use';


--
-- Name: COLUMN names.lastnames; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.names.lastnames IS 'all last names of an identity in legal order,

	 IOW "major" name, "group identifier", eg. family, village, tribe, ...';


--
-- Name: COLUMN names.firstnames; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.names.firstnames IS 'all first names of an identity in legal order,

	 IOW "minor" name, identifier of this identity within

	 the group defined by <lastnames>';


--
-- Name: COLUMN names.preferred; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.names.preferred IS 'preferred first name, the name a person is usually

	 called (nickname, warrior name)';


--
-- Name: COLUMN names.comment; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.names.comment IS 'a comment regarding this name, useful in things like "this was
	 the name before marriage" etc';


--
-- Name: v_inbox_item_type; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_inbox_item_type AS
 SELECT it.description AS type,
    public._(it.description) AS l10n_type,
    ic.description AS category,
    public._(ic.description) AS l10n_category,
    it.is_user AS is_user_type,
    ic.is_user AS is_user_category,
    it.pk AS pk_type,
    it.fk_inbox_item_category AS pk_category
   FROM dem.inbox_item_type it,
    dem.inbox_item_category ic
  WHERE (it.fk_inbox_item_category = ic.pk);


ALTER TABLE dem.v_inbox_item_type OWNER TO "gm-dbo";

--
-- Name: v_unreviewed_docs_inbox; Type: VIEW; Schema: blobs; Owner: gm-dbo
--

CREATE VIEW blobs.v_unreviewed_docs_inbox AS
 SELECT now() AS received_when,
    '<system>'::text AS modified_by,
    NULL::text AS provider,
    0 AS importance,
    'clinical'::text AS category,
    public._('clinical'::text) AS l10n_category,
    'review docs'::text AS type,
    public._('review docs'::text) AS l10n_type,
    ( SELECT ((((((b_vuds.no_of_docs || ' '::text) || public._('unreviewed documents for patient'::text)) || ' '::text) || d_n.lastnames) || ', '::text) || d_n.firstnames)) AS comment,
    NULL::integer[] AS pk_context,
    NULL::text AS data,
    NULL::integer AS pk_inbox_message,
    ( SELECT staff.pk
           FROM dem.staff
          WHERE (staff.db_user = "current_user"())) AS pk_staff,
    ( SELECT v_inbox_item_type.pk_category
           FROM dem.v_inbox_item_type
          WHERE (v_inbox_item_type.type = 'review docs'::text)) AS pk_category,
    ( SELECT v_inbox_item_type.pk_type
           FROM dem.v_inbox_item_type
          WHERE (v_inbox_item_type.type = 'review docs'::text)) AS pk_type,
    b_vuds.pk_patient,
    true AS is_virtual,
    (now() - '01:00:00'::interval) AS due_date,
    NULL::timestamp with time zone AS expiry_date,
    true AS is_overdue,
    false AS is_expired,
    '01:00:00'::interval AS interval_due,
    NULL::integer AS xmin_message_inbox
   FROM (blobs.v_unreviewed_docs_summary b_vuds
     JOIN dem.names d_n ON ((b_vuds.pk_patient = d_n.id_identity)))
  WHERE (d_n.active IS TRUE);


ALTER TABLE blobs.v_unreviewed_docs_inbox OWNER TO "gm-dbo";

--
-- Name: cfg_data; Type: TABLE; Schema: cfg; Owner: gm-dbo
--

CREATE TABLE cfg.cfg_data (
    fk_item integer NOT NULL,
    value bytea NOT NULL,
    pk integer NOT NULL
);


ALTER TABLE cfg.cfg_data OWNER TO "gm-dbo";

--
-- Name: TABLE cfg_data; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON TABLE cfg.cfg_data IS 'stores opaque configuration data, either text or binary,
	 note that it will be difficult to share such options
	 among different types of clients';


--
-- Name: cfg_data_pk_seq; Type: SEQUENCE; Schema: cfg; Owner: gm-dbo
--

CREATE SEQUENCE cfg.cfg_data_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE cfg.cfg_data_pk_seq OWNER TO "gm-dbo";

--
-- Name: cfg_data_pk_seq; Type: SEQUENCE OWNED BY; Schema: cfg; Owner: gm-dbo
--

ALTER SEQUENCE cfg.cfg_data_pk_seq OWNED BY cfg.cfg_data.pk;


--
-- Name: cfg_item; Type: TABLE; Schema: cfg; Owner: gm-dbo
--

CREATE TABLE cfg.cfg_item (
    pk integer NOT NULL,
    fk_template integer NOT NULL,
    owner name DEFAULT "current_user"() NOT NULL,
    workplace text,
    cookie text
);


ALTER TABLE cfg.cfg_item OWNER TO "gm-dbo";

--
-- Name: TABLE cfg_item; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON TABLE cfg.cfg_item IS 'this table holds all "instances" of cfg.cfg_template';


--
-- Name: COLUMN cfg_item.fk_template; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.cfg_item.fk_template IS 'this points to the class of this option, think of this as a base object, this also defines the data type';


--
-- Name: COLUMN cfg_item.owner; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.cfg_item.owner IS 'the database level user this option belongs to; this
	 is the "role" of the user from the perspective of
	 the database; can be "default" at the application
	 level to indicate that it does not care';


--
-- Name: COLUMN cfg_item.workplace; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.cfg_item.workplace IS '- the logical workplace this option pertains to
	 - can be a hostname but should be a logical rather
	   than a physical identifier as machines get moved,
	   workplaces do not, kind of like a "role" for the
	   machine
	 - associate this with a physical workplace through
	   a local config file or environment variable';


--
-- Name: COLUMN cfg_item.cookie; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.cfg_item.cookie IS 'an arbitrary, opaque entity the client code can use
	 to associate this config item with even finer grained
	 context; could be the pertinent patient ID for patient
	 specific options';


--
-- Name: cfg_item_pk_seq; Type: SEQUENCE; Schema: cfg; Owner: gm-dbo
--

CREATE SEQUENCE cfg.cfg_item_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE cfg.cfg_item_pk_seq OWNER TO "gm-dbo";

--
-- Name: cfg_item_pk_seq; Type: SEQUENCE OWNED BY; Schema: cfg; Owner: gm-dbo
--

ALTER SEQUENCE cfg.cfg_item_pk_seq OWNED BY cfg.cfg_item.pk;


--
-- Name: cfg_numeric; Type: TABLE; Schema: cfg; Owner: gm-dbo
--

CREATE TABLE cfg.cfg_numeric (
    fk_item integer NOT NULL,
    value numeric NOT NULL,
    pk integer NOT NULL
);


ALTER TABLE cfg.cfg_numeric OWNER TO "gm-dbo";

--
-- Name: cfg_numeric_pk_seq; Type: SEQUENCE; Schema: cfg; Owner: gm-dbo
--

CREATE SEQUENCE cfg.cfg_numeric_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE cfg.cfg_numeric_pk_seq OWNER TO "gm-dbo";

--
-- Name: cfg_numeric_pk_seq; Type: SEQUENCE OWNED BY; Schema: cfg; Owner: gm-dbo
--

ALTER SEQUENCE cfg.cfg_numeric_pk_seq OWNED BY cfg.cfg_numeric.pk;


--
-- Name: cfg_str_array; Type: TABLE; Schema: cfg; Owner: gm-dbo
--

CREATE TABLE cfg.cfg_str_array (
    fk_item integer NOT NULL,
    value text[] NOT NULL,
    pk integer NOT NULL
);


ALTER TABLE cfg.cfg_str_array OWNER TO "gm-dbo";

--
-- Name: cfg_str_array_pk_seq; Type: SEQUENCE; Schema: cfg; Owner: gm-dbo
--

CREATE SEQUENCE cfg.cfg_str_array_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE cfg.cfg_str_array_pk_seq OWNER TO "gm-dbo";

--
-- Name: cfg_str_array_pk_seq; Type: SEQUENCE OWNED BY; Schema: cfg; Owner: gm-dbo
--

ALTER SEQUENCE cfg.cfg_str_array_pk_seq OWNED BY cfg.cfg_str_array.pk;


--
-- Name: cfg_string; Type: TABLE; Schema: cfg; Owner: gm-dbo
--

CREATE TABLE cfg.cfg_string (
    fk_item integer NOT NULL,
    value text NOT NULL,
    pk integer NOT NULL
);


ALTER TABLE cfg.cfg_string OWNER TO "gm-dbo";

--
-- Name: cfg_string_pk_seq; Type: SEQUENCE; Schema: cfg; Owner: gm-dbo
--

CREATE SEQUENCE cfg.cfg_string_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE cfg.cfg_string_pk_seq OWNER TO "gm-dbo";

--
-- Name: cfg_string_pk_seq; Type: SEQUENCE OWNED BY; Schema: cfg; Owner: gm-dbo
--

ALTER SEQUENCE cfg.cfg_string_pk_seq OWNED BY cfg.cfg_string.pk;


--
-- Name: cfg_template; Type: TABLE; Schema: cfg; Owner: gm-dbo
--

CREATE TABLE cfg.cfg_template (
    pk integer NOT NULL,
    name text DEFAULT 'must set this !'::text NOT NULL,
    type text NOT NULL,
    cfg_group text DEFAULT 'xxxDEFAULTxxx'::text NOT NULL,
    description text DEFAULT 'programmer is an avid Camel Book Reader'::text NOT NULL
);


ALTER TABLE cfg.cfg_template OWNER TO "gm-dbo";

--
-- Name: TABLE cfg_template; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON TABLE cfg.cfg_template IS 'meta definition of config items';


--
-- Name: COLUMN cfg_template.name; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.cfg_template.name IS 'the name of the option; this MUST be set to something meaningful';


--
-- Name: COLUMN cfg_template.type; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.cfg_template.type IS 'type of the value';


--
-- Name: COLUMN cfg_template.cfg_group; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.cfg_template.cfg_group IS 'just for logical grouping of options according to task sets to facilitate better config management';


--
-- Name: COLUMN cfg_template.description; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.cfg_template.description IS 'arbitrary description (user visible)';


--
-- Name: cfg_template_pk_seq; Type: SEQUENCE; Schema: cfg; Owner: gm-dbo
--

CREATE SEQUENCE cfg.cfg_template_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE cfg.cfg_template_pk_seq OWNER TO "gm-dbo";

--
-- Name: cfg_template_pk_seq; Type: SEQUENCE OWNED BY; Schema: cfg; Owner: gm-dbo
--

ALTER SEQUENCE cfg.cfg_template_pk_seq OWNED BY cfg.cfg_template.pk;


--
-- Name: cfg_type_enum; Type: TABLE; Schema: cfg; Owner: gm-dbo
--

CREATE TABLE cfg.cfg_type_enum (
    name text NOT NULL
);


ALTER TABLE cfg.cfg_type_enum OWNER TO "gm-dbo";

--
-- Name: TABLE cfg_type_enum; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON TABLE cfg.cfg_type_enum IS 'enumeration of config option data types';


--
-- Name: config; Type: TABLE; Schema: cfg; Owner: gm-dbo
--

CREATE TABLE cfg.config (
    id integer NOT NULL,
    profile character(25) DEFAULT 'default'::bpchar,
    username character(25) DEFAULT "current_user"(),
    ddb integer,
    db integer,
    crypt_pwd text,
    crypt_algo text,
    pwd_hash text,
    hash_algo text
);


ALTER TABLE cfg.config OWNER TO "gm-dbo";

--
-- Name: TABLE config; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON TABLE cfg.config IS 'maps a service name to a database location
	 for a particular user, includes user
	 credentials for that database';


--
-- Name: COLUMN config.profile; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.config.profile IS 'allows multiple profiles per user/
	 pseudo user, one user may have different
	 configuration profiles depending on role,
	 need and location';


--
-- Name: COLUMN config.username; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.config.username IS 'user name as used within the GNUmed system';


--
-- Name: COLUMN config.ddb; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.config.ddb IS 'which GNUmed service are we mapping to a database here';


--
-- Name: COLUMN config.db; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.config.db IS 'how to reach the database host for this service';


--
-- Name: COLUMN config.crypt_pwd; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.config.crypt_pwd IS 'password for user and database, encrypted';


--
-- Name: COLUMN config.crypt_algo; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.config.crypt_algo IS 'encryption algorithm used for password encryption';


--
-- Name: COLUMN config.pwd_hash; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.config.pwd_hash IS 'hash of the unencrypted password';


--
-- Name: COLUMN config.hash_algo; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.config.hash_algo IS 'algorithm used for password hashing';


--
-- Name: config_id_seq; Type: SEQUENCE; Schema: cfg; Owner: gm-dbo
--

CREATE SEQUENCE cfg.config_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE cfg.config_id_seq OWNER TO "gm-dbo";

--
-- Name: config_id_seq; Type: SEQUENCE OWNED BY; Schema: cfg; Owner: gm-dbo
--

ALTER SEQUENCE cfg.config_id_seq OWNED BY cfg.config.id;


--
-- Name: db_logon_banner; Type: TABLE; Schema: cfg; Owner: gm-dbo
--

CREATE TABLE cfg.db_logon_banner (
    message text,
    singularizer boolean DEFAULT true,
    CONSTRAINT db_logon_banner_message_check CHECK ((btrim(message) <> ''::text)),
    CONSTRAINT db_logon_banner_singularizer_check CHECK ((singularizer IS TRUE))
);


ALTER TABLE cfg.db_logon_banner OWNER TO "gm-dbo";

--
-- Name: TABLE db_logon_banner; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON TABLE cfg.db_logon_banner IS 'Stores a banner to show when clients log on.';


--
-- Name: COLUMN db_logon_banner.message; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.db_logon_banner.message IS 'The actual message to show.';


--
-- Name: COLUMN db_logon_banner.singularizer; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON COLUMN cfg.db_logon_banner.singularizer IS 'Makes sure there only ever is one such banner at any given time.';


--
-- Name: report_query; Type: TABLE; Schema: cfg; Owner: gm-dbo
--

CREATE TABLE cfg.report_query (
    pk integer NOT NULL,
    label text NOT NULL,
    cmd text NOT NULL,
    CONSTRAINT report_query_cmd_check CHECK ((btrim(COALESCE(cmd, 'NULL'::text)) <> ''::text)),
    CONSTRAINT report_query_label_check CHECK ((btrim(COALESCE(label, 'NULL'::text)) <> ''::text))
)
INHERITS (audit.audit_fields);


ALTER TABLE cfg.report_query OWNER TO "gm-dbo";

--
-- Name: TABLE report_query; Type: COMMENT; Schema: cfg; Owner: gm-dbo
--

COMMENT ON TABLE cfg.report_query IS 'This table stores SQL commands to be used in frontend report style queries.';


--
-- Name: report_query_pk_seq; Type: SEQUENCE; Schema: cfg; Owner: gm-dbo
--

CREATE SEQUENCE cfg.report_query_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE cfg.report_query_pk_seq OWNER TO "gm-dbo";

--
-- Name: report_query_pk_seq; Type: SEQUENCE OWNED BY; Schema: cfg; Owner: gm-dbo
--

ALTER SEQUENCE cfg.report_query_pk_seq OWNED BY cfg.report_query.pk;


--
-- Name: v_cfg_options; Type: VIEW; Schema: cfg; Owner: gm-dbo
--

CREATE VIEW cfg.v_cfg_options AS
 SELECT cfg_t.name AS option,
    cfg_t.description,
    cfg_i.owner,
    cfg_i.workplace,
    cfg_i.cookie,
    cfg_t.type,
    cfg_t.cfg_group AS "group",
    cfg_t.pk AS pk_cfg_template,
    cfg_i.pk AS pk_cfg_item
   FROM cfg.cfg_template cfg_t,
    cfg.cfg_item cfg_i
  WHERE (cfg_i.fk_template = cfg_t.pk);


ALTER TABLE cfg.v_cfg_options OWNER TO "gm-dbo";

--
-- Name: v_cfg_opts_data; Type: VIEW; Schema: cfg; Owner: gm-dbo
--

CREATE VIEW cfg.v_cfg_opts_data AS
 SELECT cfg_t.name AS option,
    cfg_v.value,
    cfg_t.description,
    cfg_i.owner,
    cfg_i.workplace,
    cfg_i.cookie,
    cfg_t.cfg_group AS "group",
    cfg_t.pk AS pk_cfg_template,
    cfg_i.pk AS pk_cfg_item
   FROM cfg.cfg_template cfg_t,
    cfg.cfg_item cfg_i,
    cfg.cfg_data cfg_v
  WHERE ((cfg_i.fk_template = cfg_t.pk) AND (cfg_v.fk_item = cfg_i.pk));


ALTER TABLE cfg.v_cfg_opts_data OWNER TO "gm-dbo";

--
-- Name: v_cfg_opts_numeric; Type: VIEW; Schema: cfg; Owner: gm-dbo
--

CREATE VIEW cfg.v_cfg_opts_numeric AS
 SELECT cfg_t.name AS option,
    cfg_v.value,
    cfg_t.description,
    cfg_i.owner,
    cfg_i.workplace,
    cfg_i.cookie,
    cfg_t.cfg_group AS "group",
    cfg_t.pk AS pk_cfg_template,
    cfg_i.pk AS pk_cfg_item
   FROM cfg.cfg_template cfg_t,
    cfg.cfg_item cfg_i,
    cfg.cfg_numeric cfg_v
  WHERE ((cfg_i.fk_template = cfg_t.pk) AND (cfg_v.fk_item = cfg_i.pk));


ALTER TABLE cfg.v_cfg_opts_numeric OWNER TO "gm-dbo";

--
-- Name: v_cfg_opts_str_array; Type: VIEW; Schema: cfg; Owner: gm-dbo
--

CREATE VIEW cfg.v_cfg_opts_str_array AS
 SELECT cfg_t.name AS option,
    cfg_v.value,
    cfg_t.description,
    cfg_i.owner,
    cfg_i.workplace,
    cfg_i.cookie,
    cfg_t.cfg_group AS "group",
    cfg_t.pk AS pk_cfg_template,
    cfg_i.pk AS pk_cfg_item
   FROM cfg.cfg_template cfg_t,
    cfg.cfg_item cfg_i,
    cfg.cfg_str_array cfg_v
  WHERE ((cfg_i.fk_template = cfg_t.pk) AND (cfg_v.fk_item = cfg_i.pk));


ALTER TABLE cfg.v_cfg_opts_str_array OWNER TO "gm-dbo";

--
-- Name: v_cfg_opts_string; Type: VIEW; Schema: cfg; Owner: gm-dbo
--

CREATE VIEW cfg.v_cfg_opts_string AS
 SELECT cfg_t.name AS option,
    cfg_v.value,
    cfg_t.description,
    cfg_i.owner,
    cfg_i.workplace,
    cfg_i.cookie,
    cfg_t.cfg_group AS "group",
    cfg_t.pk AS pk_cfg_template,
    cfg_i.pk AS pk_cfg_item
   FROM cfg.cfg_template cfg_t,
    cfg.cfg_item cfg_i,
    cfg.cfg_string cfg_v
  WHERE ((cfg_i.fk_template = cfg_t.pk) AND (cfg_v.fk_item = cfg_i.pk));


ALTER TABLE cfg.v_cfg_opts_string OWNER TO "gm-dbo";

--
-- Name: _enum_allergy_type; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin._enum_allergy_type (
    pk integer NOT NULL,
    value text NOT NULL
);


ALTER TABLE clin._enum_allergy_type OWNER TO "gm-dbo";

--
-- Name: _enum_allergy_type_id_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin._enum_allergy_type_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin._enum_allergy_type_id_seq OWNER TO "gm-dbo";

--
-- Name: _enum_allergy_type_id_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin._enum_allergy_type_id_seq OWNED BY clin._enum_allergy_type.pk;


--
-- Name: allergy; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.allergy (
    pk integer NOT NULL,
    substance text NOT NULL,
    substance_code text,
    generics text,
    allergene text,
    atc_code text,
    fk_type integer NOT NULL,
    generic_specific boolean DEFAULT false,
    definite boolean DEFAULT false
)
INHERITS (clin.clin_root_item);


ALTER TABLE clin.allergy OWNER TO "gm-dbo";

--
-- Name: TABLE allergy; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.allergy IS 'patient allergy details';


--
-- Name: COLUMN allergy.narrative; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.allergy.narrative IS 'used as field "reaction"';


--
-- Name: COLUMN allergy.substance; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.allergy.substance IS 'real-world name of substance the patient reacted to, brand name if drug';


--
-- Name: COLUMN allergy.substance_code; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.allergy.substance_code IS 'data source specific opaque product code; must provide a link
	 to a unique product/substance in the database in use; should follow
	 the parseable convention of "<source>::<source version>::<identifier>",
	 e.g. "MIMS::2003-1::190" for Zantac; it is left as an exercise to the
	 application to know what to do with this information';


--
-- Name: COLUMN allergy.generics; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.allergy.generics IS 'names of generic compounds if drug; brand names change/disappear, generic names do not';


--
-- Name: COLUMN allergy.allergene; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.allergy.allergene IS 'name of allergenic ingredient in substance if known';


--
-- Name: COLUMN allergy.atc_code; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.allergy.atc_code IS 'ATC code of allergene or substance if approprate, applicable for penicilline, not so for cat fur';


--
-- Name: COLUMN allergy.fk_type; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.allergy.fk_type IS 'allergy/sensitivity';


--
-- Name: COLUMN allergy.generic_specific; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.allergy.generic_specific IS 'only meaningful for *drug*/*generic* reactions:
	 1) true: applies to one in "generics" forming "substance",
			  if more than one generic listed in "generics" then
			  "allergene" *must* contain the generic in question;
	 2) false: applies to drug class of "substance";';


--
-- Name: COLUMN allergy.definite; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.allergy.definite IS 'true: definite, false: not definite';


--
-- Name: allergy_state; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.allergy_state (
    pk integer NOT NULL,
    has_allergy integer,
    comment text,
    last_confirmed timestamp with time zone,
    fk_encounter integer NOT NULL,
    CONSTRAINT allergy_state_check CHECK (((has_allergy IS NULL) OR ((has_allergy IS NOT NULL) AND (last_confirmed IS NOT NULL)))),
    CONSTRAINT allergy_state_has_allergy_check CHECK ((has_allergy = ANY (ARRAY[NULL::integer, 0, 1])))
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.allergy_state OWNER TO "gm-dbo";

--
-- Name: COLUMN allergy_state.has_allergy; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.allergy_state.has_allergy IS 'patient allergenic state:
	 - null: unknown, not asked, no data available
	 - -1: unknown, asked, no data obtained
	 - 0:  known, asked, has no known allergies
	 - 1:  known, asked, does have allergies
	';


--
-- Name: COLUMN allergy_state.comment; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.allergy_state.comment IS 'A comment on the state, such as "patient says no allergies but I think he is holding back some".';


--
-- Name: COLUMN allergy_state.last_confirmed; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.allergy_state.last_confirmed IS 'When was the state of allergies last confirmed. Must be not NULL if has_allergy is not NULL.';


--
-- Name: clin_narrative; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.clin_narrative (
    pk integer NOT NULL,
    CONSTRAINT narrative_neither_null_nor_empty CHECK ((btrim(COALESCE(narrative, ''::text)) <> ''::text))
)
INHERITS (clin.clin_root_item);


ALTER TABLE clin.clin_narrative OWNER TO "gm-dbo";

--
-- Name: TABLE clin_narrative; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.clin_narrative IS 'Used to store clinical free text *not* associated
	 with any other table. Used to implement a simple
	 SOAP structure. Also other tags can be associated
	 via link tables.';


--
-- Name: COLUMN clin_narrative.clin_when; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.clin_narrative.clin_when IS 'when did the item reach clinical reality';


--
-- Name: external_care; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.external_care (
    pk integer NOT NULL,
    fk_encounter integer NOT NULL,
    fk_health_issue integer,
    issue text,
    fk_org_unit integer NOT NULL,
    provider text,
    comment text,
    inactive boolean DEFAULT false NOT NULL,
    CONSTRAINT clin_ext_care_issue_xor_fk_issue CHECK ((((fk_health_issue IS NULL) AND (issue IS NOT NULL)) OR ((fk_health_issue IS NOT NULL) AND (issue IS NULL)))),
    CONSTRAINT clin_ext_care_sane_comment CHECK ((gm.is_null_or_non_empty_string(comment) IS TRUE)),
    CONSTRAINT clin_ext_care_sane_issue CHECK ((gm.is_null_or_non_empty_string(issue) IS TRUE)),
    CONSTRAINT clin_ext_care_sane_provider CHECK ((gm.is_null_or_non_empty_string(provider) IS TRUE))
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.external_care OWNER TO "gm-dbo";

--
-- Name: TABLE external_care; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.external_care IS 'lists external care situations for patients';


--
-- Name: COLUMN external_care.fk_encounter; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.external_care.fk_encounter IS 'the encounter during which this external care item was first documented';


--
-- Name: COLUMN external_care.fk_health_issue; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.external_care.fk_health_issue IS 'link to a health issue, if any';


--
-- Name: COLUMN external_care.issue; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.external_care.issue IS 'description of the issue of external care';


--
-- Name: COLUMN external_care.fk_org_unit; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.external_care.fk_org_unit IS 'link to the org unit where care is rendered';


--
-- Name: COLUMN external_care.provider; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.external_care.provider IS 'name of actual provider at .fk_org_unit';


--
-- Name: COLUMN external_care.comment; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.external_care.comment IS 'comment on the patient/provider relationship, say role/issues cared for/...';


--
-- Name: family_history; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.family_history (
    pk integer NOT NULL,
    fk_relation_type integer NOT NULL,
    age_noted text,
    age_of_death interval,
    contributed_to_death boolean,
    name_relative text,
    dob_relative timestamp with time zone,
    comment text,
    CONSTRAINT c_family_history_sane_age_noted CHECK ((gm.is_null_or_non_empty_string(age_noted) IS TRUE)),
    CONSTRAINT c_family_history_sane_condition CHECK ((gm.is_null_or_blank_string(narrative) IS FALSE)),
    CONSTRAINT c_family_history_sane_name CHECK ((gm.is_null_or_non_empty_string(name_relative) IS TRUE)),
    CONSTRAINT narrative_neither_null_nor_empty CHECK ((btrim(COALESCE(narrative, ''::text)) <> ''::text))
)
INHERITS (clin.clin_root_item);


ALTER TABLE clin.family_history OWNER TO "gm-dbo";

--
-- Name: TABLE family_history; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.family_history IS 'This table stores family history items on persons not otherwise in the database.';


--
-- Name: COLUMN family_history.clin_when; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.family_history.clin_when IS 'When the family history item became known to the patient (not the afflicted relative).';


--
-- Name: COLUMN family_history.fk_encounter; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.family_history.fk_encounter IS 'encounter during which family history item became known';


--
-- Name: COLUMN family_history.fk_episode; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.family_history.fk_episode IS 'episode to which family history item is of importance';


--
-- Name: COLUMN family_history.narrative; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.family_history.narrative IS 'the condition this relative suffered from';


--
-- Name: COLUMN family_history.fk_relation_type; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.family_history.fk_relation_type IS 'foreign key to the type of relation the patient has to the afflicated relative';


--
-- Name: COLUMN family_history.age_noted; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.family_history.age_noted IS 'age at which the condition was noted in the relative if known';


--
-- Name: COLUMN family_history.age_of_death; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.family_history.age_of_death IS 'age at which the relative died if known';


--
-- Name: COLUMN family_history.contributed_to_death; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.family_history.contributed_to_death IS 'whether the condition contributed to the death of the relative if known';


--
-- Name: COLUMN family_history.name_relative; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.family_history.name_relative IS 'name of the relative suffering the condition';


--
-- Name: COLUMN family_history.dob_relative; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.family_history.dob_relative IS 'date of birth of the relative if known';


--
-- Name: fhx_relation_type; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.fhx_relation_type (
    pk integer NOT NULL,
    description text,
    is_genetic boolean NOT NULL,
    CONSTRAINT c_fhx_relation_type_sane_desc CHECK ((gm.is_null_or_blank_string(description) IS FALSE))
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.fhx_relation_type OWNER TO "gm-dbo";

--
-- Name: TABLE fhx_relation_type; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.fhx_relation_type IS 'Enumerates inter-person relations for family history linking.';


--
-- Name: COLUMN fhx_relation_type.description; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.fhx_relation_type.description IS 'Description of the relation type, specific or unspecific: sister, father, ..., maternal family, ...';


--
-- Name: COLUMN fhx_relation_type.is_genetic; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.fhx_relation_type.is_genetic IS 'Whether or not this type of relation is biologic/genetic or not. Note that non-genetic relations may still pose a risk because of infectious diseases.';


--
-- Name: hospital_stay; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.hospital_stay (
    pk integer NOT NULL,
    discharge timestamp with time zone,
    fk_org_unit integer NOT NULL,
    CONSTRAINT sane_duration CHECK (((discharge IS NULL) OR (discharge > clin_when))),
    CONSTRAINT sane_hospital CHECK (gm.is_null_or_non_empty_string(narrative))
)
INHERITS (clin.clin_root_item);


ALTER TABLE clin.hospital_stay OWNER TO "gm-dbo";

--
-- Name: TABLE hospital_stay; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.hospital_stay IS 'collects data on hospitalisations of patients, reasons are linked via a link table';


--
-- Name: COLUMN hospital_stay.clin_when; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.hospital_stay.clin_when IS 'to be used as when the patient was admitted';


--
-- Name: COLUMN hospital_stay.narrative; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.hospital_stay.narrative IS 'a comment on the hospital stay';


--
-- Name: COLUMN hospital_stay.discharge; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.hospital_stay.discharge IS 'when was the patient discharged';


--
-- Name: COLUMN hospital_stay.fk_org_unit; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.hospital_stay.fk_org_unit IS 'links to the hospital the patient was admitted to';


--
-- Name: lnk_code2item_root; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.lnk_code2item_root (
    pk_lnk_code2item integer NOT NULL,
    fk_generic_code integer,
    fk_item integer,
    code_modifier text
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.lnk_code2item_root OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_code2item_root; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.lnk_code2item_root IS 'The parent table of all tables linking codes to EMR structures.
Coding tables check this table for existence of their PK in
.fk_generic_code in order to prevent cascading DELETEs/UPDATEs
from breaking referential integrity.
EMR structure tables foreign key into children of this table in
order to link structures to codes.
';


--
-- Name: COLUMN lnk_code2item_root.fk_generic_code; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2item_root.fk_generic_code IS 'Custom foreign key to ref.coding_system_root.pk_coding_system.';


--
-- Name: COLUMN lnk_code2item_root.fk_item; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2item_root.fk_item IS 'Foreign key to clin.* tables';


--
-- Name: COLUMN lnk_code2item_root.code_modifier; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2item_root.code_modifier IS 'Usage specific modifier on the base code, say, certainty or laterality of ICD-10 codes.';


--
-- Name: lnk_code2aoe; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.lnk_code2aoe (
    pk integer NOT NULL
)
INHERITS (clin.lnk_code2item_root);
ALTER TABLE ONLY clin.lnk_code2aoe ALTER COLUMN fk_generic_code SET NOT NULL;


ALTER TABLE clin.lnk_code2aoe OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_code2aoe; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.lnk_code2aoe IS 'Links codes to encounter.aoe.';


--
-- Name: COLUMN lnk_code2aoe.fk_generic_code; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2aoe.fk_generic_code IS 'Custom foreign key to ref.coding_system_root.';


--
-- Name: COLUMN lnk_code2aoe.fk_item; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2aoe.fk_item IS 'Foreign key to clin.encounter';


--
-- Name: lnk_code2episode; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.lnk_code2episode (
    pk integer NOT NULL
)
INHERITS (clin.lnk_code2item_root);
ALTER TABLE ONLY clin.lnk_code2episode ALTER COLUMN fk_generic_code SET NOT NULL;


ALTER TABLE clin.lnk_code2episode OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_code2episode; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.lnk_code2episode IS 'Links codes to episodes.';


--
-- Name: COLUMN lnk_code2episode.fk_generic_code; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2episode.fk_generic_code IS 'Custom foreign key to ref.coding_system_root.';


--
-- Name: COLUMN lnk_code2episode.fk_item; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2episode.fk_item IS 'Foreign key to clin.episode';


--
-- Name: lnk_code2fhx; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.lnk_code2fhx (
    pk integer NOT NULL
)
INHERITS (clin.lnk_code2item_root);
ALTER TABLE ONLY clin.lnk_code2fhx ALTER COLUMN fk_generic_code SET NOT NULL;


ALTER TABLE clin.lnk_code2fhx OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_code2fhx; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.lnk_code2fhx IS 'Links codes to family history items.';


--
-- Name: COLUMN lnk_code2fhx.fk_generic_code; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2fhx.fk_generic_code IS 'Custom foreign key to ref.coding_system_root.';


--
-- Name: COLUMN lnk_code2fhx.fk_item; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2fhx.fk_item IS 'Foreign key to clin.family_history';


--
-- Name: lnk_code2h_issue; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.lnk_code2h_issue (
    pk integer NOT NULL
)
INHERITS (clin.lnk_code2item_root);
ALTER TABLE ONLY clin.lnk_code2h_issue ALTER COLUMN fk_generic_code SET NOT NULL;


ALTER TABLE clin.lnk_code2h_issue OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_code2h_issue; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.lnk_code2h_issue IS 'Links codes to health issues.';


--
-- Name: COLUMN lnk_code2h_issue.fk_generic_code; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2h_issue.fk_generic_code IS 'Custom foreign key to ref.coding_system_root.';


--
-- Name: COLUMN lnk_code2h_issue.fk_item; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2h_issue.fk_item IS 'Foreign key to clin.health_issue';


--
-- Name: lnk_code2procedure; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.lnk_code2procedure (
    pk integer NOT NULL
)
INHERITS (clin.lnk_code2item_root);
ALTER TABLE ONLY clin.lnk_code2procedure ALTER COLUMN fk_generic_code SET NOT NULL;


ALTER TABLE clin.lnk_code2procedure OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_code2procedure; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.lnk_code2procedure IS 'Links codes to procedures. OPS comes to mind.';


--
-- Name: COLUMN lnk_code2procedure.fk_generic_code; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2procedure.fk_generic_code IS 'Custom foreign key to ref.coding_system_root.';


--
-- Name: COLUMN lnk_code2procedure.fk_item; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2procedure.fk_item IS 'Foreign key to clin.procedure';


--
-- Name: lnk_code2rfe; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.lnk_code2rfe (
    pk integer NOT NULL
)
INHERITS (clin.lnk_code2item_root);
ALTER TABLE ONLY clin.lnk_code2rfe ALTER COLUMN fk_generic_code SET NOT NULL;


ALTER TABLE clin.lnk_code2rfe OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_code2rfe; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.lnk_code2rfe IS 'Links codes to encounters.';


--
-- Name: COLUMN lnk_code2rfe.fk_generic_code; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2rfe.fk_generic_code IS 'Custom foreign key to ref.coding_system_root.';


--
-- Name: COLUMN lnk_code2rfe.fk_item; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2rfe.fk_item IS 'Foreign key to clin.encounter';


--
-- Name: lnk_loinc2test_panel; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.lnk_loinc2test_panel (
    pk integer NOT NULL,
    fk_test_panel integer NOT NULL,
    loinc text,
    CONSTRAINT clin_ll2tp_sane_loinc CHECK ((gm.is_null_or_blank_string(loinc) IS FALSE))
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.lnk_loinc2test_panel OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_loinc2test_panel; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.lnk_loinc2test_panel IS 'Links LOINC codes to test panels which thusly become part of said panel.';


--
-- Name: COLUMN lnk_loinc2test_panel.fk_test_panel; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_loinc2test_panel.fk_test_panel IS 'FK linking the test panel';


--
-- Name: COLUMN lnk_loinc2test_panel.loinc; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_loinc2test_panel.loinc IS 'LOINC to include in test panel';


--
-- Name: meta_test_type; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.meta_test_type (
    pk integer NOT NULL,
    abbrev text NOT NULL,
    name text NOT NULL,
    loinc text,
    comment text
);


ALTER TABLE clin.meta_test_type OWNER TO "gm-dbo";

--
-- Name: TABLE meta_test_type; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.meta_test_type IS 'this table merges test types from various test orgs
	 which are intended to measure the same value but have
	 differing names into one logical test type,
	 this is not intended to be used for aggregating
	 semantically different test types into "profiles"';


--
-- Name: patient; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.patient (
    pk integer NOT NULL,
    fk_identity integer NOT NULL,
    edc date,
    CONSTRAINT clin_patient_sane_edc CHECK (((edc IS NULL) OR ((clin.get_dod(fk_identity) IS NULL) AND ((clin.get_dob(fk_identity) IS NULL) OR (edc > (clin.get_dob(fk_identity) + '5 years'::interval))))))
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.patient OWNER TO "gm-dbo";

--
-- Name: TABLE patient; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.patient IS 'A table to hold unique-per-identity *clinical* items, such as Expected Due Date.';


--
-- Name: COLUMN patient.fk_identity; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.patient.fk_identity IS 'the dem.identity.pk of this patient';


--
-- Name: procedure; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.procedure (
    pk integer NOT NULL,
    fk_hospital_stay integer,
    clin_end timestamp with time zone,
    is_ongoing boolean DEFAULT false NOT NULL,
    fk_org_unit integer,
    fk_doc integer,
    comment text,
    CONSTRAINT clin_procedure_lnk_org_or_stay CHECK ((((fk_hospital_stay IS NULL) AND (fk_org_unit IS NOT NULL)) OR ((fk_hospital_stay IS NOT NULL) AND (fk_org_unit IS NULL)))),
    CONSTRAINT clin_procedure_sane_comment CHECK ((gm.is_null_or_non_empty_string(comment) IS TRUE)),
    CONSTRAINT procedure_sane_end CHECK (((clin_end IS NULL) OR (clin_end >= clin_when))),
    CONSTRAINT sane_procedure CHECK ((gm.is_null_or_blank_string(narrative) IS FALSE)),
    CONSTRAINT sane_soap_cat CHECK ((soap_cat = ANY (ARRAY['a'::text, 'p'::text])))
)
INHERITS (clin.clin_root_item);


ALTER TABLE clin.procedure OWNER TO "gm-dbo";

--
-- Name: TABLE procedure; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.procedure IS 'This table holds procedure/operations performed on the patient
 both in hospital or in community care.';


--
-- Name: COLUMN procedure.narrative; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.procedure.narrative IS 'Which procedure/operation was performed.';


--
-- Name: COLUMN procedure.fk_hospital_stay; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.procedure.fk_hospital_stay IS 'At which hospital was the procedure performed,
 unless clin_where is not null,
 if null it was an ambulatory procedure.';


--
-- Name: COLUMN procedure.clin_end; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.procedure.clin_end IS 'When did this procedure end/is expected to end.
- NULL if unknown or .clin_when (=start) is sufficient (eg. insignificant duration)';


--
-- Name: COLUMN procedure.is_ongoing; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.procedure.is_ongoing IS 'Whether this procedure is still going on (such as desensibilisation, chemotherapy, etc).';


--
-- Name: COLUMN procedure.fk_org_unit; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.procedure.fk_org_unit IS 'links to the or unit the procedure was performed at';


--
-- Name: COLUMN procedure.fk_doc; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.procedure.fk_doc IS 'links to the document the procedure is documented in';


--
-- Name: COLUMN procedure.comment; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.procedure.comment IS 'a comment on the procedure (say, the outcome)';


--
-- Name: reviewed_test_results; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.reviewed_test_results (
)
INHERITS (clin.review_root);


ALTER TABLE clin.reviewed_test_results OWNER TO "gm-dbo";

--
-- Name: TABLE reviewed_test_results; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.reviewed_test_results IS 'review table for test results';


--
-- Name: substance_intake; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.substance_intake (
    pk integer NOT NULL,
    schedule text,
    aim text,
    duration interval,
    intake_is_approved_of boolean NOT NULL,
    is_long_term boolean,
    discontinued timestamp with time zone,
    discontinue_reason text,
    fk_drug_component integer NOT NULL,
    comment_on_start text,
    harmful_use_type integer,
    CONSTRAINT clin_patient_sane_use_type CHECK (((harmful_use_type IS NULL) OR ((harmful_use_type >= 0) AND (harmful_use_type <= 3)))),
    CONSTRAINT clin_substance_intake_sane_start_comment CHECK (gm.is_null_or_non_empty_string(comment_on_start)),
    CONSTRAINT discontinued_after_started CHECK (((harmful_use_type IS NOT NULL) OR (clin_when IS NULL) OR (discontinued IS NULL) OR ((discontinued >= clin_when) AND (discontinued <= now())))),
    CONSTRAINT medication_is_plan CHECK ((soap_cat = 'p'::text)),
    CONSTRAINT sane_aim CHECK ((gm.is_null_or_non_empty_string(aim) IS TRUE)),
    CONSTRAINT sane_discontinue_reason CHECK ((((discontinued IS NULL) AND (discontinue_reason IS NULL)) OR ((discontinued IS NOT NULL) AND (gm.is_null_or_non_empty_string(discontinue_reason) IS TRUE)))),
    CONSTRAINT sane_schedule CHECK ((gm.is_null_or_non_empty_string(schedule) IS TRUE))
)
INHERITS (clin.clin_root_item);


ALTER TABLE clin.substance_intake OWNER TO "gm-dbo";

--
-- Name: TABLE substance_intake; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.substance_intake IS 'The substances a patient is actually currently taking.';


--
-- Name: COLUMN substance_intake.clin_when; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.substance_intake.clin_when IS 'When was this substance started.';


--
-- Name: COLUMN substance_intake.fk_encounter; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.substance_intake.fk_encounter IS 'The encounter use of this substance was documented under.';


--
-- Name: COLUMN substance_intake.narrative; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.substance_intake.narrative IS 'Any notes on this substance use.';


--
-- Name: COLUMN substance_intake.schedule; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.substance_intake.schedule IS 'The schedule, if any, the substance is to be taken by.
 An XML snippet to be interpreted by the middleware.';


--
-- Name: COLUMN substance_intake.aim; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.substance_intake.aim IS 'The aim of taking this substance.';


--
-- Name: COLUMN substance_intake.duration; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.substance_intake.duration IS 'How long is this substances intended to be taken.';


--
-- Name: COLUMN substance_intake.intake_is_approved_of; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.substance_intake.intake_is_approved_of IS 'Whether or not intake of this substance is recommended/approved of by the provider';


--
-- Name: COLUMN substance_intake.is_long_term; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.substance_intake.is_long_term IS 'whether this is expected to be a regular/ongoing/chronic/long-term/repeat/permament/perpetual/life-long substance intake';


--
-- Name: COLUMN substance_intake.discontinued; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.substance_intake.discontinued IS 'When was this intake discontinued ?';


--
-- Name: COLUMN substance_intake.discontinue_reason; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.substance_intake.discontinue_reason IS 'Why was this intake discontinued ?';


--
-- Name: COLUMN substance_intake.fk_drug_component; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.substance_intake.fk_drug_component IS 'Links to the component of a branded drug taken by a patient.';


--
-- Name: COLUMN substance_intake.comment_on_start; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.substance_intake.comment_on_start IS 'Comment (uncertainty level) on .clin_when = started. "?" = "entirely unknown".';


--
-- Name: COLUMN substance_intake.harmful_use_type; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.substance_intake.harmful_use_type IS 'NULL=not considered=medication, 0=no or not considered harmful, 1=presently harmful use, 2=presently addicted, 3=previously addicted';


--
-- Name: suppressed_hint; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.suppressed_hint (
    pk integer NOT NULL,
    fk_encounter integer NOT NULL,
    fk_hint integer NOT NULL,
    suppressed_by name DEFAULT "current_user"() NOT NULL,
    suppressed_when timestamp with time zone DEFAULT statement_timestamp() NOT NULL,
    rationale text,
    md5_sum text,
    CONSTRAINT clin_suppressed_hint_sane_by CHECK ((length((suppressed_by)::text) > 0)),
    CONSTRAINT clin_suppressed_hint_sane_md5 CHECK ((gm.is_null_or_blank_string(md5_sum) IS FALSE)),
    CONSTRAINT clin_suppressed_hint_sane_rationale CHECK ((gm.is_null_or_blank_string(rationale) IS FALSE))
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.suppressed_hint OWNER TO "gm-dbo";

--
-- Name: TABLE suppressed_hint; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.suppressed_hint IS 'A table to hold hints suppressed per patient';


--
-- Name: COLUMN suppressed_hint.fk_encounter; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.suppressed_hint.fk_encounter IS 'the encounter during which this hint was first suppressed';


--
-- Name: COLUMN suppressed_hint.fk_hint; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.suppressed_hint.fk_hint IS 'the hint that is suppressed';


--
-- Name: COLUMN suppressed_hint.suppressed_by; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.suppressed_hint.suppressed_by IS 'who suppressed this hint';


--
-- Name: COLUMN suppressed_hint.suppressed_when; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.suppressed_hint.suppressed_when IS 'when was this hint suppressed';


--
-- Name: COLUMN suppressed_hint.rationale; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.suppressed_hint.rationale IS 'rationale on why this hint is suppressed in this patient';


--
-- Name: COLUMN suppressed_hint.md5_sum; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.suppressed_hint.md5_sum IS 'md5 of relevant fields of this hint';


--
-- Name: test_org; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.test_org (
    pk integer NOT NULL,
    fk_org_unit integer NOT NULL,
    fk_adm_contact integer,
    fk_med_contact integer,
    comment text,
    contact text,
    CONSTRAINT sane_comment CHECK ((gm.is_null_or_non_empty_string(comment) IS TRUE)),
    CONSTRAINT sane_contact CHECK ((gm.is_null_or_non_empty_string(contact) IS TRUE))
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.test_org OWNER TO "gm-dbo";

--
-- Name: TABLE test_org; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.test_org IS 'organisation providing results';


--
-- Name: COLUMN test_org.fk_org_unit; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_org.fk_org_unit IS 'link to a unit of an organization more closely defining this lab';


--
-- Name: COLUMN test_org.fk_adm_contact; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_org.fk_adm_contact IS 'whom to call for admin questions (modem link, etc.)';


--
-- Name: COLUMN test_org.fk_med_contact; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_org.fk_med_contact IS 'whom to call for medical questions (result verification,
	 additional test requests)';


--
-- Name: COLUMN test_org.comment; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_org.comment IS 'useful for, say, dummy records where you want
	 to mark up stuff like "pharmacy such-and-such"
	 if you don''t have it in your contacts';


--
-- Name: COLUMN test_org.contact; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_org.contact IS 'free-text contact information for this lab';


--
-- Name: test_panel; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.test_panel (
    pk integer NOT NULL,
    description text,
    comment text,
    CONSTRAINT clin_test_panel_sane_cmt CHECK ((gm.is_null_or_non_empty_string(comment) IS TRUE)),
    CONSTRAINT clin_test_panel_sane_desc CHECK ((gm.is_null_or_blank_string(description) IS FALSE))
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.test_panel OWNER TO "gm-dbo";

--
-- Name: TABLE test_panel; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.test_panel IS 'Panels of tests. The same test can appear in several panels.';


--
-- Name: COLUMN test_panel.description; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_panel.description IS 'A description/label for this panel.';


--
-- Name: COLUMN test_panel.comment; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_panel.comment IS 'An arbitrary comment on this panel.';


--
-- Name: test_result; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.test_result (
    pk integer NOT NULL,
    fk_type integer NOT NULL,
    val_num numeric,
    val_alpha text,
    val_unit text,
    val_normal_min numeric,
    val_normal_max numeric,
    val_normal_range text,
    val_target_min numeric,
    val_target_max numeric,
    val_target_range text,
    abnormality_indicator text,
    norm_ref_group text,
    note_test_org text,
    material text,
    material_detail text,
    fk_intended_reviewer integer NOT NULL,
    fk_request integer,
    status text,
    source_data text,
    val_grouping text,
    CONSTRAINT clin_test_result_sane_source_data CHECK (gm.is_null_or_non_empty_string(source_data)),
    CONSTRAINT clin_test_result_sane_status CHECK (gm.is_null_or_non_empty_string(status)),
    CONSTRAINT clin_test_result_sane_val_grouping CHECK (gm.is_null_or_non_empty_string(val_grouping)),
    CONSTRAINT numval_needs_unit CHECK ((((val_num IS NOT NULL) AND (btrim(COALESCE(val_unit, ''::text)) <> ''::text)) OR (val_num IS NULL))),
    CONSTRAINT test_result_check CHECK (((val_num IS NOT NULL) OR (val_alpha IS NOT NULL) OR ((val_num IS NULL) AND (val_alpha <> ''::text) AND (val_alpha IS NOT NULL))))
)
INHERITS (clin.clin_root_item);


ALTER TABLE clin.test_result OWNER TO "gm-dbo";

--
-- Name: TABLE test_result; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.test_result IS 'the results of a single measurement';


--
-- Name: COLUMN test_result.clin_when; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.clin_when IS 'the time when this result was *actually* obtained,
	 if this is a lab result this should be between
	 lab_request.clin_when and lab_request.results_reported_when,
	 HL7: OBR.observation_date_time';


--
-- Name: COLUMN test_result.narrative; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.narrative IS 'clinical comment, progress note';


--
-- Name: COLUMN test_result.fk_type; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.fk_type IS 'the type of test this result is from';


--
-- Name: COLUMN test_result.val_num; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.val_num IS 'numeric value if any,
	 HL7: OBX.observation_results if OBX.value_type == NM';


--
-- Name: COLUMN test_result.val_alpha; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.val_alpha IS 'alphanumeric value if any,
	 HL7: OBX.observation_results if OBX.value_type == FT';


--
-- Name: COLUMN test_result.val_unit; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.val_unit IS 'the unit this result came in
	 HL7: OBX.units';


--
-- Name: COLUMN test_result.val_normal_min; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.val_normal_min IS 'lower bound of normal range if numerical as
	 defined by provider for this result';


--
-- Name: COLUMN test_result.val_normal_max; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.val_normal_max IS 'upper bound of normal range if numerical as
	 defined by provider for this result';


--
-- Name: COLUMN test_result.val_normal_range; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.val_normal_range IS 'range of normal values if alphanumerical
	 as defined by provider for this result, eg.
	 "less than 0.5 but detectable"
	 HL7: OBX.reference_range';


--
-- Name: COLUMN test_result.val_target_min; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.val_target_min IS 'lower bound of target range if numerical as
	 defined by clinician caring this patient';


--
-- Name: COLUMN test_result.val_target_max; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.val_target_max IS 'upper bound of target range if numerical as
	 defined by clinician caring for this patient';


--
-- Name: COLUMN test_result.val_target_range; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.val_target_range IS 'range of target values if alphanumerical
	 as defined by clinician caring for this patient';


--
-- Name: COLUMN test_result.abnormality_indicator; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.abnormality_indicator IS 'how the test provider flagged this result as abnormal,
	 *not* a clinical assessment but rather a technical one
	 LDT: 8422';


--
-- Name: COLUMN test_result.norm_ref_group; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.norm_ref_group IS 'what sample of the population does this normal range
	 applay to, eg what type of patient was assumed when
	 interpreting this result,
	 LDT: 8407';


--
-- Name: COLUMN test_result.note_test_org; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.note_test_org IS 'A comment on the test result provided by the tester or testing entity.';


--
-- Name: COLUMN test_result.material; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.material IS 'the submitted material, eg. smear, serum, urine, etc.,
	 LDT: 8430';


--
-- Name: COLUMN test_result.material_detail; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.material_detail IS 'details re the material, eg. site taken from, etc.
	 LDT: 8431';


--
-- Name: COLUMN test_result.fk_intended_reviewer; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.fk_intended_reviewer IS 'who is *supposed* to review this item';


--
-- Name: COLUMN test_result.fk_request; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.fk_request IS 'The request this result was ordered under if any.';


--
-- Name: COLUMN test_result.status; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.status IS 'The result status (say, HL7 OBX 11 Observ result status (#00579, table 0085).';


--
-- Name: COLUMN test_result.source_data; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.source_data IS 'The source data for this observation (say, HL7 OBX).';


--
-- Name: COLUMN test_result.val_grouping; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_result.val_grouping IS 'A grouping for related values (say, HL7 OBX Obs Sub ID, think antibiogram).';


--
-- Name: test_type; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.test_type (
    pk integer NOT NULL,
    fk_test_org integer NOT NULL,
    name text NOT NULL,
    comment text,
    reference_unit text,
    loinc text,
    abbrev text NOT NULL,
    fk_meta_test_type integer
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.test_type OWNER TO "gm-dbo";

--
-- Name: TABLE test_type; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.test_type IS 'measurement type, like a "method" in a lab';


--
-- Name: COLUMN test_type.fk_test_org; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_type.fk_test_org IS 'organisation carrying out this type of measurement, eg. a particular lab';


--
-- Name: COLUMN test_type.name; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_type.name IS 'descriptive name of this measurement type,
	 HL7: OBX.observation_identifier';


--
-- Name: COLUMN test_type.comment; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_type.comment IS 'arbitrary comment on this type of measurement/test such
	 as "outdated" or "only reliable when ..."';


--
-- Name: COLUMN test_type.reference_unit; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_type.reference_unit IS 'The chosen reference unit for this test type, preferably SI, used for comparing results delivered in differing units. This does not relate to what unit the test provider delivers results in but rather the unit we think those results need to be converted to in order to be comparable to OTHER results.';


--
-- Name: COLUMN test_type.fk_meta_test_type; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.test_type.fk_meta_test_type IS 'Link to the meta test type (if any) this test type is to be aggregated under.';


--
-- Name: v_edc_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_edc_journal AS
 SELECT c_p.fk_identity AS pk_patient,
    c_p.modified_when,
    c_p.modified_when AS clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_p.modified_by)), (('<'::text || (c_p.modified_by)::text) || '>'::text)) AS modified_by,
    's'::text AS soap_cat,
    (public._('EDC'::text) || to_char((c_p.edc)::timestamp with time zone, ': YYYY Mon DD'::text)) AS narrative,
    ( SELECT c_e.pk
           FROM clin.encounter c_e
          WHERE (c_e.fk_patient = c_p.fk_identity)
          ORDER BY c_e.started DESC
         LIMIT 1) AS pk_encounter,
    NULL::integer AS pk_episode,
    NULL::integer AS pk_health_issue,
    c_p.pk AS src_pk,
    'clin.patient'::text AS src_table,
    c_p.row_version,
    NULL::text AS health_issue,
    NULL::text AS issue_laterality,
    NULL::boolean AS issue_active,
    NULL::boolean AS issue_clinically_relevant,
    NULL::boolean AS issue_confidential,
    NULL::text AS episode,
    NULL::boolean AS episode_open,
    NULL::timestamp with time zone AS encounter_started,
    NULL::timestamp with time zone AS encounter_last_affirmed,
    NULL::text AS encounter_type,
    NULL::text AS encounter_l10n_type
   FROM clin.patient c_p
  WHERE (c_p.edc IS NOT NULL);


ALTER TABLE clin.v_edc_journal OWNER TO "gm-dbo";

--
-- Name: v_external_care_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_external_care_journal AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_ec.modified_when,
    c_ec.modified_when AS clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_ec.modified_by)), (('<'::text || (c_ec.modified_by)::text) || '>'::text)) AS modified_by,
    's'::text AS soap_cat,
    ((((((((((((((public._('External care'::text) ||
        CASE
            WHEN c_ec.inactive THEN ((' ('::text || public._('inactive'::text)) || ')'::text)
            ELSE ''::text
        END) || COALESCE((((' '::text || public._('by'::text)) || ' '::text) || c_ec.provider), ''::text)) || ' @ '::text) || d_ou.description) || ' '::text) || public._('of'::text)) || ' '::text) || d_o.description) || '
'::text) || public._('Issue:'::text)) || ' '::text) || COALESCE(c_hi.description, c_ec.issue)) || '
'::text) || COALESCE(((public._('Comment:'::text) || ' '::text) || c_ec.comment), ''::text)) AS narrative,
    c_ec.fk_encounter AS pk_encounter,
    NULL::integer AS pk_episode,
    c_ec.fk_health_issue AS pk_health_issue,
    c_ec.pk AS src_pk,
    'clin.external_care'::text AS src_table,
    c_ec.row_version,
    c_hi.description AS health_issue,
    c_hi.laterality AS issue_laterality,
    c_hi.is_active AS issue_active,
    c_hi.clinically_relevant AS issue_clinically_relevant,
    c_hi.is_confidential AS issue_confidential,
    NULL::text AS episode,
    NULL::boolean AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM (((((clin.external_care c_ec
     JOIN clin.encounter c_enc ON ((c_ec.fk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_ec.fk_health_issue = c_hi.pk)))
     LEFT JOIN dem.org_unit d_ou ON ((c_ec.fk_org_unit = d_ou.pk)))
     LEFT JOIN dem.org d_o ON ((d_ou.fk_org = d_o.pk)));


ALTER TABLE clin.v_external_care_journal OWNER TO "gm-dbo";

--
-- Name: v_family_history_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_family_history_journal AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_fh.modified_when,
    c_fh.clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_fh.modified_by)), (('<'::text || (c_fh.modified_by)::text) || '>'::text)) AS modified_by,
    c_fh.soap_cat,
    ((((((((((((public._(c_fhrt.description) || COALESCE((' @ '::text || c_fh.age_noted), ''::text)) || ': '::text) || c_fh.narrative) || '
'::text) || ' '::text) ||
        CASE
            WHEN (c_fh.contributed_to_death IS TRUE) THEN (public._('contributed to death'::text) || ' '::text)
            ELSE ''::text
        END) || COALESCE(('@ '::text || (justify_interval(c_fh.age_of_death))::text), ''::text)) || '
'::text) || COALESCE(((' '::text || c_fh.name_relative) || ','::text), ''::text)) || COALESCE((' '::text || to_char(c_fh.dob_relative, 'YYYY-MM-DD'::text)), ''::text)) || COALESCE(('
 '::text || c_fh.comment), ''::text)) || COALESCE(((';
'::text || array_to_string(( SELECT array_agg(((((((((r_csr.code || ' ('::text) || r_ds.name_short) || ' - '::text) || r_ds.version) || ' - '::text) || r_ds.lang) || '): '::text) || r_csr.term)) AS array_agg
           FROM ((clin.lnk_code2fhx c_lc2fhx
             JOIN ref.coding_system_root r_csr ON ((c_lc2fhx.fk_generic_code = r_csr.pk_coding_system)))
             JOIN ref.data_source r_ds ON ((r_ds.pk = r_csr.fk_data_source)))
          WHERE (c_lc2fhx.fk_item = c_fh.pk)), '; '::text)) || ';'::text), ''::text)) AS narrative,
    c_fh.fk_encounter AS pk_encounter,
    c_fh.fk_episode AS pk_episode,
    c_epi.fk_health_issue AS pk_health_issue,
    c_fh.pk AS src_pk,
    'clin.family_history'::text AS src_table,
    c_fh.row_version,
    c_hi.description AS health_issue,
    c_hi.laterality AS issue_laterality,
    c_hi.is_active AS issue_active,
    c_hi.clinically_relevant AS issue_clinically_relevant,
    c_hi.is_confidential AS issue_confidential,
    c_epi.description AS episode,
    c_epi.is_open AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM (((((clin.family_history c_fh
     JOIN clin.encounter c_enc ON ((c_fh.fk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
     JOIN clin.episode c_epi ON ((c_fh.fk_episode = c_epi.pk)))
     LEFT JOIN clin.fhx_relation_type c_fhrt ON ((c_fh.fk_relation_type = c_fhrt.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_epi.fk_health_issue = c_hi.pk)));


ALTER TABLE clin.v_family_history_journal OWNER TO "gm-dbo";

--
-- Name: identity; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.identity (
    pk integer NOT NULL,
    deleted boolean DEFAULT false NOT NULL,
    gender text,
    dob timestamp with time zone,
    fk_marital_status integer,
    cob character(2),
    deceased timestamp with time zone,
    title text,
    tob time without time zone,
    emergency_contact text,
    fk_emergency_contact integer,
    comment text,
    fk_primary_provider integer,
    dob_is_estimated boolean DEFAULT false NOT NULL,
    CONSTRAINT dem_identity_sane_dob CHECK (((dob IS NULL) OR (dob <= now()))),
    CONSTRAINT dem_identity_sane_dod CHECK (((deceased IS NULL) OR (dob IS NULL) OR (deceased >= dob))),
    CONSTRAINT identity_title_check CHECK ((btrim(COALESCE(title, 'NULL'::text)) <> ''::text)),
    CONSTRAINT sane_comment CHECK ((gm.is_null_or_non_empty_string(comment) IS TRUE)),
    CONSTRAINT sane_emergency_contact CHECK ((gm.is_null_or_non_empty_string(emergency_contact) IS TRUE))
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.identity OWNER TO "gm-dbo";

--
-- Name: TABLE identity; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.identity IS 'represents the unique identity of a person';


--
-- Name: COLUMN identity.deleted; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.identity.deleted IS 'whether this identity is considered deleted';


--
-- Name: COLUMN identity.gender; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.identity.gender IS 'the gender code';


--
-- Name: COLUMN identity.dob; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.identity.dob IS 'date/time of birth';


--
-- Name: COLUMN identity.cob; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.identity.cob IS 'country of birth as per date of birth, coded as 2 character ISO code';


--
-- Name: COLUMN identity.deceased; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.identity.deceased IS 'date when a person has died';


--
-- Name: COLUMN identity.title; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.identity.title IS 'Yes, a title is an attribute of an identity, not of a name !
	 Also, there are some incredible rants of titles.';


--
-- Name: COLUMN identity.emergency_contact; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.identity.emergency_contact IS 'Free text emergency contact information.';


--
-- Name: COLUMN identity.fk_emergency_contact; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.identity.fk_emergency_contact IS 'Link to another dem.identity to be used as emergency contact.';


--
-- Name: COLUMN identity.comment; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.identity.comment IS 'A free-text comment on this identity.\n
\n
Can be used to to discriminate patients which are otherwise\n
identical regarding name and date of birth.\n
Should be something non-ephemereal and unique to the person\n
itself across time, place and database instance.\n
Good: place of birth\n
Good: maiden name of mother\n
Good: mother of <name>\n
Good: hash of DNA\n
Good (?): hair color of first pet\n
Bad: current address (will change)\n
Bad: primary provider in this praxis (can change, invalid in another GNUmed instance)\n
Bad: nickname (will change, can dupe as well)\n
Bad: favourite food\n
not-quite-so-bad: occupation';


--
-- Name: COLUMN identity.fk_primary_provider; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.identity.fk_primary_provider IS 'Whether the given DOB is estimated or not. The TOB is assumed to be correct if given';


--
-- Name: v_health_issues_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_health_issues_journal AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_hi.modified_when,
    COALESCE(( SELECT (identity.dob + c_hi.age_noted)
           FROM dem.identity
          WHERE (identity.pk = ( SELECT encounter.fk_patient
                   FROM clin.encounter
                  WHERE (encounter.pk = c_hi.fk_encounter)))), c_enc.started) AS clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_hi.modified_by)), (('<'::text || (c_hi.modified_by)::text) || '>'::text)) AS modified_by,
    'a'::text AS soap_cat,
    (((((((((((((public._('Health Issue'::text) || ' ('::text) ||
        CASE
            WHEN c_hi.is_active THEN public._('active'::text)
            ELSE public._('inactive'::text)
        END) || ', '::text) ||
        CASE
            WHEN c_hi.clinically_relevant THEN public._('clinically relevant'::text)
            ELSE public._('clinically not relevant'::text)
        END) || COALESCE((', '::text || c_hi.diagnostic_certainty_classification), ''::text)) || '): '::text) || c_hi.description) || COALESCE(((((';
'::text || public._('noted at age'::text)) || ': '::text) || (c_hi.age_noted)::text) || ';
'::text), ';
'::text)) || COALESCE((((public._('Laterality'::text) || ': '::text) || (c_hi.laterality)::text) || ' / '::text), ''::text)) ||
        CASE
            WHEN c_hi.is_confidential THEN (public._('confidential'::text) || ' / '::text)
            ELSE ''::text
        END) ||
        CASE
            WHEN c_hi.is_cause_of_death THEN public._('cause of death'::text)
            ELSE ''::text
        END) || COALESCE((((';
'::text || public._('Summary'::text)) || ':
'::text) || c_hi.summary), ''::text)) || COALESCE(((';
'::text || array_to_string(( SELECT array_agg(((((((((r_csr.code || ' ('::text) || r_ds.name_short) || ' - '::text) || r_ds.version) || ' - '::text) || r_ds.lang) || '): '::text) || r_csr.term)) AS array_agg
           FROM ((clin.lnk_code2h_issue c_lc2h
             JOIN ref.coding_system_root r_csr ON ((c_lc2h.fk_generic_code = r_csr.pk_coding_system)))
             JOIN ref.data_source r_ds ON ((r_ds.pk = r_csr.fk_data_source)))
          WHERE (c_lc2h.fk_item = c_hi.pk)), '; '::text)) || ';'::text), ''::text)) AS narrative,
    c_hi.fk_encounter AS pk_encounter,
    NULL::integer AS pk_episode,
    c_hi.pk AS pk_health_issue,
    c_hi.pk AS src_pk,
    'clin.health_issue'::text AS src_table,
    c_hi.row_version,
    c_hi.description AS health_issue,
    c_hi.laterality AS issue_laterality,
    c_hi.is_active AS issue_active,
    c_hi.clinically_relevant AS issue_clinically_relevant,
    c_hi.is_confidential AS issue_confidential,
    NULL::text AS episode,
    NULL::boolean AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM ((clin.health_issue c_hi
     JOIN clin.encounter c_enc ON ((c_hi.fk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)));


ALTER TABLE clin.v_health_issues_journal OWNER TO "gm-dbo";

--
-- Name: v_hospital_stays_journal_multi_day_adm; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_hospital_stays_journal_multi_day_adm AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_hs.modified_when,
    c_hs.clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_hs.modified_by)), (('<'::text || (c_hs.modified_by)::text) || '>'::text)) AS modified_by,
    c_hs.soap_cat,
    ((((((((((((((((((((public._('hospital stay'::text) || '
'::text) || ' '::text) || public._('admitted'::text)) || ': '::text) || to_char(c_hs.clin_when, 'YYYY-MM-DD'::text)) || '
'::text) || ' '::text) || public._('discharged'::text)) || ': '::text) || to_char(c_hs.discharge, 'YYYY-MM-DD'::text)) || '
'::text) || ' '::text) || public._('hospital'::text)) || ': "'::text) || d_ou.description) || ' @ '::text) || d_o.description) || '"'::text) || '
'::text) || COALESCE(('
 '::text || c_hs.narrative), ''::text)) AS narrative,
    c_hs.fk_encounter AS pk_encounter,
    c_hs.fk_episode AS pk_episode,
    ( SELECT episode.fk_health_issue
           FROM clin.episode
          WHERE (episode.pk = c_hs.fk_episode)) AS pk_health_issue,
    c_hs.pk AS src_pk,
    'clin.hospital_stay'::text AS src_table,
    c_hs.row_version,
    c_hi.description AS health_issue,
    c_hi.laterality AS issue_laterality,
    c_hi.is_active AS issue_active,
    c_hi.clinically_relevant AS issue_clinically_relevant,
    c_hi.is_confidential AS issue_confidential,
    c_epi.description AS episode,
    c_epi.is_open AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM ((((((clin.hospital_stay c_hs
     JOIN clin.encounter c_enc ON ((c_hs.fk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
     JOIN clin.episode c_epi ON ((c_hs.fk_episode = c_epi.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_epi.fk_health_issue = c_hi.pk)))
     LEFT JOIN dem.org_unit d_ou ON ((d_ou.pk = c_hs.fk_org_unit)))
     LEFT JOIN dem.org d_o ON ((d_o.pk = d_ou.fk_org)))
  WHERE ((c_hs.discharge IS NOT NULL) AND (to_char(c_hs.clin_when, 'YYYYMMDD'::text) <> to_char(c_hs.discharge, 'YYYYMMDD'::text)));


ALTER TABLE clin.v_hospital_stays_journal_multi_day_adm OWNER TO "gm-dbo";

--
-- Name: v_hospital_stays_journal_multi_day_dis; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_hospital_stays_journal_multi_day_dis AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_hs.modified_when,
    c_hs.discharge AS clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_hs.modified_by)), (('<'::text || (c_hs.modified_by)::text) || '>'::text)) AS modified_by,
    c_hs.soap_cat,
    (((((public._('discharged from'::text) || ' "'::text) || d_ou.description) || ' @ '::text) || d_o.description) || '"'::text) AS narrative,
    c_hs.fk_encounter AS pk_encounter,
    c_hs.fk_episode AS pk_episode,
    ( SELECT episode.fk_health_issue
           FROM clin.episode
          WHERE (episode.pk = c_hs.fk_episode)) AS pk_health_issue,
    c_hs.pk AS src_pk,
    'clin.hospital_stay'::text AS src_table,
    c_hs.row_version,
    c_hi.description AS health_issue,
    c_hi.laterality AS issue_laterality,
    c_hi.is_active AS issue_active,
    c_hi.clinically_relevant AS issue_clinically_relevant,
    c_hi.is_confidential AS issue_confidential,
    c_epi.description AS episode,
    c_epi.is_open AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM ((((((clin.hospital_stay c_hs
     JOIN clin.encounter c_enc ON ((c_hs.fk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
     JOIN clin.episode c_epi ON ((c_hs.fk_episode = c_epi.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_epi.fk_health_issue = c_hi.pk)))
     LEFT JOIN dem.org_unit d_ou ON ((d_ou.pk = c_hs.fk_org_unit)))
     LEFT JOIN dem.org d_o ON ((d_o.pk = d_ou.fk_org)))
  WHERE ((c_hs.discharge IS NOT NULL) AND (to_char(c_hs.clin_when, 'YYYYMMDD'::text) <> to_char(c_hs.discharge, 'YYYYMMDD'::text)));


ALTER TABLE clin.v_hospital_stays_journal_multi_day_dis OWNER TO "gm-dbo";

--
-- Name: v_hospital_stays_journal_no_discharge; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_hospital_stays_journal_no_discharge AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_hs.modified_when,
    c_hs.clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_hs.modified_by)), (('<'::text || (c_hs.modified_by)::text) || '>'::text)) AS modified_by,
    c_hs.soap_cat,
    ((((((((((((((public._('hospital stay'::text) || '
'::text) || ' '::text) || public._('admitted'::text)) || ': '::text) || to_char(c_hs.clin_when, 'YYYY-MM-DD'::text)) || '
'::text) || ' '::text) || public._('hospital'::text)) || ': "'::text) || d_ou.description) || ' @ '::text) || d_o.description) || '"'::text) || COALESCE(('
 '::text || c_hs.narrative), ''::text)) AS narrative,
    c_hs.fk_encounter AS pk_encounter,
    c_hs.fk_episode AS pk_episode,
    ( SELECT episode.fk_health_issue
           FROM clin.episode
          WHERE (episode.pk = c_hs.fk_episode)) AS pk_health_issue,
    c_hs.pk AS src_pk,
    'clin.hospital_stay'::text AS src_table,
    c_hs.row_version,
    c_hi.description AS health_issue,
    c_hi.laterality AS issue_laterality,
    c_hi.is_active AS issue_active,
    c_hi.clinically_relevant AS issue_clinically_relevant,
    c_hi.is_confidential AS issue_confidential,
    c_epi.description AS episode,
    c_epi.is_open AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM ((((((clin.hospital_stay c_hs
     JOIN clin.encounter c_enc ON ((c_hs.fk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
     JOIN clin.episode c_epi ON ((c_hs.fk_episode = c_epi.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_epi.fk_health_issue = c_hi.pk)))
     LEFT JOIN dem.org_unit d_ou ON ((d_ou.pk = c_hs.fk_org_unit)))
     LEFT JOIN dem.org d_o ON ((d_o.pk = d_ou.fk_org)))
  WHERE (c_hs.discharge IS NULL);


ALTER TABLE clin.v_hospital_stays_journal_no_discharge OWNER TO "gm-dbo";

--
-- Name: v_hospital_stays_journal_one_day; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_hospital_stays_journal_one_day AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_hs.modified_when,
    c_hs.clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_hs.modified_by)), (('<'::text || (c_hs.modified_by)::text) || '>'::text)) AS modified_by,
    c_hs.soap_cat,
    (((((((((((((((public._('hospital stay'::text) || '
'::text) || ' '::text) || public._('admitted/discharged'::text)) || ': '::text) || to_char(c_hs.clin_when, 'YYYY-MM-DD'::text)) || '
'::text) || ' '::text) || public._('hospital'::text)) || ': "'::text) || d_ou.description) || ' @ '::text) || d_o.description) || '"'::text) || '
'::text) || COALESCE(('
 '::text || c_hs.narrative), ''::text)) AS narrative,
    c_hs.fk_encounter AS pk_encounter,
    c_hs.fk_episode AS pk_episode,
    ( SELECT episode.fk_health_issue
           FROM clin.episode
          WHERE (episode.pk = c_hs.fk_episode)) AS pk_health_issue,
    c_hs.pk AS src_pk,
    'clin.hospital_stay'::text AS src_table,
    c_hs.row_version,
    c_hi.description AS health_issue,
    c_hi.laterality AS issue_laterality,
    c_hi.is_active AS issue_active,
    c_hi.clinically_relevant AS issue_clinically_relevant,
    c_hi.is_confidential AS issue_confidential,
    c_epi.description AS episode,
    c_epi.is_open AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM ((((((clin.hospital_stay c_hs
     JOIN clin.encounter c_enc ON ((c_hs.fk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
     JOIN clin.episode c_epi ON ((c_hs.fk_episode = c_epi.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_epi.fk_health_issue = c_hi.pk)))
     LEFT JOIN dem.org_unit d_ou ON ((d_ou.pk = c_hs.fk_org_unit)))
     LEFT JOIN dem.org d_o ON ((d_o.pk = d_ou.fk_org)))
  WHERE ((c_hs.discharge IS NOT NULL) AND (to_char(c_hs.clin_when, 'YYYYMMDD'::text) = to_char(c_hs.discharge, 'YYYYMMDD'::text)));


ALTER TABLE clin.v_hospital_stays_journal_one_day OWNER TO "gm-dbo";

--
-- Name: v_hospital_stays_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_hospital_stays_journal AS
 SELECT v_hospital_stays_journal_no_discharge.pk_patient,
    v_hospital_stays_journal_no_discharge.modified_when,
    v_hospital_stays_journal_no_discharge.clin_when,
    v_hospital_stays_journal_no_discharge.modified_by,
    v_hospital_stays_journal_no_discharge.soap_cat,
    v_hospital_stays_journal_no_discharge.narrative,
    v_hospital_stays_journal_no_discharge.pk_encounter,
    v_hospital_stays_journal_no_discharge.pk_episode,
    v_hospital_stays_journal_no_discharge.pk_health_issue,
    v_hospital_stays_journal_no_discharge.src_pk,
    v_hospital_stays_journal_no_discharge.src_table,
    v_hospital_stays_journal_no_discharge.row_version,
    v_hospital_stays_journal_no_discharge.health_issue,
    v_hospital_stays_journal_no_discharge.issue_laterality,
    v_hospital_stays_journal_no_discharge.issue_active,
    v_hospital_stays_journal_no_discharge.issue_clinically_relevant,
    v_hospital_stays_journal_no_discharge.issue_confidential,
    v_hospital_stays_journal_no_discharge.episode,
    v_hospital_stays_journal_no_discharge.episode_open,
    v_hospital_stays_journal_no_discharge.encounter_started,
    v_hospital_stays_journal_no_discharge.encounter_last_affirmed,
    v_hospital_stays_journal_no_discharge.encounter_type,
    v_hospital_stays_journal_no_discharge.encounter_l10n_type
   FROM clin.v_hospital_stays_journal_no_discharge
UNION ALL
 SELECT v_hospital_stays_journal_one_day.pk_patient,
    v_hospital_stays_journal_one_day.modified_when,
    v_hospital_stays_journal_one_day.clin_when,
    v_hospital_stays_journal_one_day.modified_by,
    v_hospital_stays_journal_one_day.soap_cat,
    v_hospital_stays_journal_one_day.narrative,
    v_hospital_stays_journal_one_day.pk_encounter,
    v_hospital_stays_journal_one_day.pk_episode,
    v_hospital_stays_journal_one_day.pk_health_issue,
    v_hospital_stays_journal_one_day.src_pk,
    v_hospital_stays_journal_one_day.src_table,
    v_hospital_stays_journal_one_day.row_version,
    v_hospital_stays_journal_one_day.health_issue,
    v_hospital_stays_journal_one_day.issue_laterality,
    v_hospital_stays_journal_one_day.issue_active,
    v_hospital_stays_journal_one_day.issue_clinically_relevant,
    v_hospital_stays_journal_one_day.issue_confidential,
    v_hospital_stays_journal_one_day.episode,
    v_hospital_stays_journal_one_day.episode_open,
    v_hospital_stays_journal_one_day.encounter_started,
    v_hospital_stays_journal_one_day.encounter_last_affirmed,
    v_hospital_stays_journal_one_day.encounter_type,
    v_hospital_stays_journal_one_day.encounter_l10n_type
   FROM clin.v_hospital_stays_journal_one_day
UNION ALL
 SELECT v_hospital_stays_journal_multi_day_adm.pk_patient,
    v_hospital_stays_journal_multi_day_adm.modified_when,
    v_hospital_stays_journal_multi_day_adm.clin_when,
    v_hospital_stays_journal_multi_day_adm.modified_by,
    v_hospital_stays_journal_multi_day_adm.soap_cat,
    v_hospital_stays_journal_multi_day_adm.narrative,
    v_hospital_stays_journal_multi_day_adm.pk_encounter,
    v_hospital_stays_journal_multi_day_adm.pk_episode,
    v_hospital_stays_journal_multi_day_adm.pk_health_issue,
    v_hospital_stays_journal_multi_day_adm.src_pk,
    v_hospital_stays_journal_multi_day_adm.src_table,
    v_hospital_stays_journal_multi_day_adm.row_version,
    v_hospital_stays_journal_multi_day_adm.health_issue,
    v_hospital_stays_journal_multi_day_adm.issue_laterality,
    v_hospital_stays_journal_multi_day_adm.issue_active,
    v_hospital_stays_journal_multi_day_adm.issue_clinically_relevant,
    v_hospital_stays_journal_multi_day_adm.issue_confidential,
    v_hospital_stays_journal_multi_day_adm.episode,
    v_hospital_stays_journal_multi_day_adm.episode_open,
    v_hospital_stays_journal_multi_day_adm.encounter_started,
    v_hospital_stays_journal_multi_day_adm.encounter_last_affirmed,
    v_hospital_stays_journal_multi_day_adm.encounter_type,
    v_hospital_stays_journal_multi_day_adm.encounter_l10n_type
   FROM clin.v_hospital_stays_journal_multi_day_adm
UNION ALL
 SELECT v_hospital_stays_journal_multi_day_dis.pk_patient,
    v_hospital_stays_journal_multi_day_dis.modified_when,
    v_hospital_stays_journal_multi_day_dis.clin_when,
    v_hospital_stays_journal_multi_day_dis.modified_by,
    v_hospital_stays_journal_multi_day_dis.soap_cat,
    v_hospital_stays_journal_multi_day_dis.narrative,
    v_hospital_stays_journal_multi_day_dis.pk_encounter,
    v_hospital_stays_journal_multi_day_dis.pk_episode,
    v_hospital_stays_journal_multi_day_dis.pk_health_issue,
    v_hospital_stays_journal_multi_day_dis.src_pk,
    v_hospital_stays_journal_multi_day_dis.src_table,
    v_hospital_stays_journal_multi_day_dis.row_version,
    v_hospital_stays_journal_multi_day_dis.health_issue,
    v_hospital_stays_journal_multi_day_dis.issue_laterality,
    v_hospital_stays_journal_multi_day_dis.issue_active,
    v_hospital_stays_journal_multi_day_dis.issue_clinically_relevant,
    v_hospital_stays_journal_multi_day_dis.issue_confidential,
    v_hospital_stays_journal_multi_day_dis.episode,
    v_hospital_stays_journal_multi_day_dis.episode_open,
    v_hospital_stays_journal_multi_day_dis.encounter_started,
    v_hospital_stays_journal_multi_day_dis.encounter_last_affirmed,
    v_hospital_stays_journal_multi_day_dis.encounter_type,
    v_hospital_stays_journal_multi_day_dis.encounter_l10n_type
   FROM clin.v_hospital_stays_journal_multi_day_dis;


ALTER TABLE clin.v_hospital_stays_journal OWNER TO "gm-dbo";

--
-- Name: v_pat_allergies_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_pat_allergies_journal AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_all.modified_when,
    c_all.clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_all.modified_by)), (('<'::text || (c_all.modified_by)::text) || '>'::text)) AS modified_by,
    c_all.soap_cat,
    ((((((((((((public._('Allergy'::text) || ' ('::text) || public._(c_at.value)) || '): '::text) || COALESCE(c_all.narrative, ''::text)) || '
'::text) || public._('substance'::text)) || ': '::text) || c_all.substance) || '; '::text) || COALESCE((((public._('allergene'::text) || ': '::text) || c_all.allergene) || '; '::text), ''::text)) || COALESCE((((public._('generic'::text) || ': '::text) || c_all.generics) || '; '::text), ''::text)) || COALESCE((((public._('ATC code'::text) || ': '::text) || c_all.atc_code) || '; '::text), ''::text)) AS narrative,
    c_all.fk_encounter AS pk_encounter,
    c_all.fk_episode AS pk_episode,
    c_epi.fk_health_issue AS pk_health_issue,
    c_all.pk AS src_pk,
    'clin.allergy'::text AS src_table,
    c_all.row_version,
    c_hi.description AS health_issue,
    c_hi.laterality AS issue_laterality,
    c_hi.is_active AS issue_active,
    c_hi.clinically_relevant AS issue_clinically_relevant,
    c_hi.is_confidential AS issue_confidential,
    c_epi.description AS episode,
    c_epi.is_open AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM (((((clin.allergy c_all
     JOIN clin._enum_allergy_type c_at ON ((c_all.fk_type = c_at.pk)))
     JOIN clin.encounter c_enc ON ((c_all.fk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
     JOIN clin.episode c_epi ON ((c_all.fk_episode = c_epi.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_epi.fk_health_issue = c_hi.pk)));


ALTER TABLE clin.v_pat_allergies_journal OWNER TO "gm-dbo";

--
-- Name: v_pat_allergy_state_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_pat_allergy_state_journal AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_ast.modified_when,
    COALESCE(c_ast.last_confirmed, c_ast.modified_when) AS clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_ast.modified_by)), (('<'::text || (c_ast.modified_by)::text) || '>'::text)) AS modified_by,
    'o'::text AS soap_cat,
    ((((public._('Allergy state'::text) || ': '::text) ||
        CASE
            WHEN (c_ast.has_allergy IS NULL) THEN public._('unknown, unasked'::text)
            WHEN (c_ast.has_allergy = 0) THEN public._('no known allergies'::text)
            WHEN (c_ast.has_allergy = 1) THEN public._('does have allergies'::text)
            ELSE NULL::text
        END) || COALESCE((((' ('::text || public._('last confirmed'::text)) || to_char(c_ast.last_confirmed, ' YYYY-MM-DD HH24:MI'::text)) || ')'::text), ''::text)) || COALESCE(('
 '::text || c_ast.comment), ''::text)) AS narrative,
    c_ast.fk_encounter AS pk_encounter,
    NULL::integer AS pk_episode,
    NULL::integer AS pk_health_issue,
    c_ast.pk AS src_pk,
    'clin.allergy_state'::text AS src_table,
    c_ast.row_version,
    NULL::text AS health_issue,
    NULL::text AS issue_laterality,
    NULL::boolean AS issue_active,
    NULL::boolean AS issue_clinically_relevant,
    NULL::boolean AS issue_confidential,
    NULL::text AS episode,
    NULL::boolean AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM ((clin.allergy_state c_ast
     JOIN clin.encounter c_enc ON ((c_ast.fk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
UNION ALL
 SELECT c_enc.fk_patient AS pk_patient,
    now() AS modified_when,
    now() AS clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_ast.modified_by)), (('<'::text || (c_ast.modified_by)::text) || '>'::text)) AS modified_by,
    'o'::text AS soap_cat,
    (((((((((public._('Allergy state'::text) || ' ('::text) || public._('copy'::text)) || '): '::text) ||
        CASE
            WHEN (c_ast.has_allergy IS NULL) THEN public._('unknown, unasked'::text)
            WHEN (c_ast.has_allergy = 0) THEN public._('no known allergies'::text)
            WHEN (c_ast.has_allergy = 1) THEN public._('does have allergies'::text)
            ELSE NULL::text
        END) || COALESCE(('
 '::text || c_ast.comment), ''::text)) || COALESCE((('
 '::text || public._('last confirmed'::text)) || to_char(c_ast.last_confirmed, ' YYYY-MM-DD HH24:MI'::text)), ''::text)) || COALESCE((('
 '::text || public._('entry last modified'::text)) || to_char(c_ast.modified_when, ' YYYY-MM-DD HH24:MI'::text)), ''::text)) || COALESCE((('
 '::text || public._('encounter started'::text)) || to_char(c_enc.started, ' YYYY-MM-DD HH24:MI'::text)), ''::text)) || COALESCE((('
 '::text || public._('encounter last affirmed'::text)) || to_char(c_enc.last_affirmed, ' YYYY-MM-DD HH24:MI'::text)), ''::text)) AS narrative,
    c_ast.fk_encounter AS pk_encounter,
    NULL::integer AS pk_episode,
    NULL::integer AS pk_health_issue,
    c_ast.pk AS src_pk,
    'clin.allergy_state'::text AS src_table,
    c_ast.row_version,
    NULL::text AS health_issue,
    NULL::text AS issue_laterality,
    NULL::boolean AS issue_active,
    NULL::boolean AS issue_clinically_relevant,
    NULL::boolean AS issue_confidential,
    NULL::text AS episode,
    NULL::boolean AS episode_open,
    now() AS encounter_started,
    now() AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM ((clin.allergy_state c_ast
     JOIN clin.encounter c_enc ON ((c_ast.fk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)));


ALTER TABLE clin.v_pat_allergy_state_journal OWNER TO "gm-dbo";

--
-- Name: v_pat_encounters_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_pat_encounters_journal AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_enc.modified_when,
    c_enc.started AS clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_enc.modified_by)), (('<'::text || (c_enc.modified_by)::text) || '>'::text)) AS modified_by,
    NULL::text AS soap_cat,
    (((((((((public._('Encounter'::text) || ': '::text) || ( SELECT public._(encounter_type.description) AS _
           FROM clin.encounter_type
          WHERE (encounter_type.pk = c_enc.fk_type))) || to_char(c_enc.started, ' YYYY-MM-DD HH24:MI'::text)) || to_char(c_enc.last_affirmed, ' - HH24:MI'::text)) || COALESCE((((((((('
 @ '::text || public._('branch'::text)) || ' "'::text) || d_ou.description) || '" '::text) || public._('of'::text)) || ' "'::text) || d_o.description) || '"'::text), ''::text)) || COALESCE(((('
 '::text || public._('RFE'::text)) || ': '::text) || c_enc.reason_for_encounter), ''::text)) || COALESCE((('
'::text || array_to_string(( SELECT array_agg(((((((((r_csr.code || ' ('::text) || r_ds.name_short) || ' - '::text) || r_ds.version) || ' - '::text) || r_ds.lang) || '): '::text) || r_csr.term)) AS array_agg
           FROM ((clin.lnk_code2rfe c_lc2r
             JOIN ref.coding_system_root r_csr ON ((c_lc2r.fk_generic_code = r_csr.pk_coding_system)))
             JOIN ref.data_source r_ds ON ((r_ds.pk = r_csr.fk_data_source)))
          WHERE (c_lc2r.fk_item = c_enc.pk)), '; '::text)) || ';'::text), ''::text)) || COALESCE(((('
 '::text || public._('AOE'::text)) || ': '::text) || c_enc.assessment_of_encounter), ''::text)) || COALESCE((('
'::text || array_to_string(( SELECT array_agg(((((((((r_csr.code || ' ('::text) || r_ds.name_short) || ' - '::text) || r_ds.version) || ' - '::text) || r_ds.lang) || '): '::text) || r_csr.term)) AS array_agg
           FROM ((clin.lnk_code2aoe c_lc2a
             JOIN ref.coding_system_root r_csr ON ((c_lc2a.fk_generic_code = r_csr.pk_coding_system)))
             JOIN ref.data_source r_ds ON ((r_ds.pk = r_csr.fk_data_source)))
          WHERE (c_lc2a.fk_item = c_enc.pk)), '; '::text)) || ';'::text), ''::text)) AS narrative,
    c_enc.pk AS pk_encounter,
    NULL::integer AS pk_episode,
    NULL::integer AS pk_health_issue,
    c_enc.pk AS src_pk,
    'clin.encounter'::text AS src_table,
    c_enc.row_version,
    NULL::text AS health_issue,
    NULL::text AS issue_laterality,
    NULL::boolean AS issue_active,
    NULL::boolean AS issue_clinically_relevant,
    NULL::boolean AS issue_confidential,
    NULL::text AS episode,
    NULL::boolean AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM (((clin.encounter c_enc
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
     LEFT JOIN dem.org_unit d_ou ON ((c_enc.fk_location = d_ou.pk)))
     LEFT JOIN dem.org d_o ON ((d_ou.fk_org = d_o.pk)));


ALTER TABLE clin.v_pat_encounters_journal OWNER TO "gm-dbo";

--
-- Name: v_pat_episodes_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_pat_episodes_journal AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_epi.modified_when,
    c_enc.started AS clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_epi.modified_by)), (('<'::text || (c_epi.modified_by)::text) || '>'::text)) AS modified_by,
    'a'::text AS soap_cat,
    ((((((((public._('Episode'::text) || ' ('::text) ||
        CASE
            WHEN c_epi.is_open THEN public._('open'::text)
            ELSE public._('closed'::text)
        END) || COALESCE((', '::text || c_epi.diagnostic_certainty_classification), ''::text)) || '): '::text) || c_epi.description) || ';'::text) || COALESCE((((('
 '::text || public._('Synopsis'::text)) || ': '::text) || c_epi.summary) || ';'::text), ''::text)) || COALESCE((('
'::text || array_to_string(( SELECT array_agg(((((((((r_csr.code || ' ('::text) || r_ds.name_short) || ' - '::text) || r_ds.version) || ' - '::text) || r_ds.lang) || '): '::text) || r_csr.term)) AS array_agg
           FROM ((clin.lnk_code2episode c_lc2e
             JOIN ref.coding_system_root r_csr ON ((c_lc2e.fk_generic_code = r_csr.pk_coding_system)))
             JOIN ref.data_source r_ds ON ((r_ds.pk = r_csr.fk_data_source)))
          WHERE (c_lc2e.fk_item = c_epi.pk)), '; '::text)) || ';'::text), ''::text)) AS narrative,
    c_epi.fk_encounter AS pk_encounter,
    c_epi.pk AS pk_episode,
    c_epi.fk_health_issue AS pk_health_issue,
    c_epi.pk AS src_pk,
    'clin.episode'::text AS src_table,
    c_epi.row_version,
    c_hi.description AS health_issue,
    c_hi.laterality AS issue_laterality,
    c_hi.is_active AS issue_active,
    c_hi.clinically_relevant AS issue_clinically_relevant,
    c_hi.is_confidential AS issue_confidential,
    c_epi.description AS episode,
    c_epi.is_open AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM (((clin.episode c_epi
     JOIN clin.encounter c_enc ON ((c_epi.fk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_epi.fk_health_issue = c_hi.pk)));


ALTER TABLE clin.v_pat_episodes_journal OWNER TO "gm-dbo";

--
-- Name: v_pat_narrative_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_pat_narrative_journal AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_n.modified_when,
        CASE
            WHEN (c_n.soap_cat = ANY (ARRAY['s'::text, 'o'::text, 'u'::text])) THEN c_enc.started
            WHEN (c_n.soap_cat IS NULL) THEN c_enc.last_affirmed
            WHEN (c_n.soap_cat = ANY (ARRAY['a'::text, 'p'::text])) THEN c_enc.last_affirmed
            ELSE NULL::timestamp with time zone
        END AS clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_n.modified_by)), (('<'::text || (c_n.modified_by)::text) || '>'::text)) AS modified_by,
    c_n.soap_cat,
    c_n.narrative,
    c_n.fk_encounter AS pk_encounter,
    c_n.fk_episode AS pk_episode,
    c_epi.fk_health_issue AS pk_health_issue,
    c_n.pk AS src_pk,
    'clin.clin_narrative'::text AS src_table,
    c_n.row_version,
    c_hi.description AS health_issue,
    c_hi.laterality AS issue_laterality,
    c_hi.is_active AS issue_active,
    c_hi.clinically_relevant AS issue_clinically_relevant,
    c_hi.is_confidential AS issue_confidential,
    c_epi.description AS episode,
    c_epi.is_open AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM ((((clin.clin_narrative c_n
     JOIN clin.encounter c_enc ON ((c_n.fk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
     JOIN clin.episode c_epi ON ((c_n.fk_episode = c_epi.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_epi.fk_health_issue = c_hi.pk)));


ALTER TABLE clin.v_pat_narrative_journal OWNER TO "gm-dbo";

--
-- Name: v_procedures_at_hospital_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_procedures_at_hospital_journal AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_pr.modified_when,
    c_pr.clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_pr.modified_by)), (('<'::text || (c_pr.modified_by)::text) || '>'::text)) AS modified_by,
        CASE
            WHEN (c_pr.is_ongoing IS TRUE) THEN 'p'::text
            ELSE 'o'::text
        END AS soap_cat,
    ((((((((((((public._('Procedure'::text) || ' "'::text) || c_pr.narrative) || '"'::text) || ' ('::text) || d_ou.description) || ' @ '::text) || d_o.description) || COALESCE((((', '::text || public._('until'::text)) || ' '::text) || to_char(c_pr.clin_end, 'YYYY Mon DD'::text)),
        CASE
            WHEN (c_pr.is_ongoing IS TRUE) THEN (', '::text || public._('ongoing'::text))
            ELSE ''::text
        END)) || ')'::text) || COALESCE(('
 '::text || c_pr.comment), ''::text)) || COALESCE((('
 '::text || public._('document #'::text)) || c_pr.fk_doc), ''::text)) || COALESCE((('
'::text || array_to_string(( SELECT array_agg(((((((((r_csr.code || ' ('::text) || r_ds.name_short) || ' - '::text) || r_ds.version) || ' - '::text) || r_ds.lang) || '): '::text) || r_csr.term)) AS array_agg
           FROM ((clin.lnk_code2procedure c_lc2p
             JOIN ref.coding_system_root r_csr ON ((c_lc2p.fk_generic_code = r_csr.pk_coding_system)))
             JOIN ref.data_source r_ds ON ((r_ds.pk = r_csr.fk_data_source)))
          WHERE (c_lc2p.fk_item = c_pr.pk)), '; '::text)) || ';'::text), ''::text)) AS narrative,
    c_pr.fk_encounter AS pk_encounter,
    c_pr.fk_episode AS pk_episode,
    c_epi.fk_health_issue AS pk_health_issue,
    c_pr.pk AS src_pk,
    'clin.procedure'::text AS src_table,
    c_pr.row_version,
    c_hi.description AS health_issue,
    c_hi.laterality AS issue_laterality,
    c_hi.is_active AS issue_active,
    c_hi.clinically_relevant AS issue_clinically_relevant,
    c_hi.is_confidential AS issue_confidential,
    c_epi.description AS episode,
    c_epi.is_open AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM (((((((clin.procedure c_pr
     JOIN clin.encounter c_enc ON ((c_pr.fk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
     JOIN clin.episode c_epi ON ((c_pr.fk_episode = c_epi.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_epi.fk_health_issue = c_hi.pk)))
     LEFT JOIN clin.hospital_stay c_hs ON ((c_pr.fk_hospital_stay = c_hs.pk)))
     LEFT JOIN dem.org_unit d_ou ON ((c_hs.fk_org_unit = d_ou.pk)))
     LEFT JOIN dem.org d_o ON ((d_ou.fk_org = d_o.pk)))
  WHERE (c_pr.fk_hospital_stay IS NOT NULL);


ALTER TABLE clin.v_procedures_at_hospital_journal OWNER TO "gm-dbo";

--
-- Name: v_procedures_not_at_hospital_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_procedures_not_at_hospital_journal AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_pr.modified_when,
    c_pr.clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_pr.modified_by)), (('<'::text || (c_pr.modified_by)::text) || '>'::text)) AS modified_by,
        CASE
            WHEN (c_pr.is_ongoing IS TRUE) THEN 'p'::text
            ELSE 'o'::text
        END AS soap_cat,
    ((((((((((((public._('Procedure'::text) || ' "'::text) || c_pr.narrative) || '"'::text) || ' ('::text) || d_ou.description) || ' @ '::text) || d_o.description) || COALESCE((((', '::text || public._('until'::text)) || ' '::text) || to_char(c_pr.clin_end, 'YYYY Mon DD'::text)),
        CASE
            WHEN (c_pr.is_ongoing IS TRUE) THEN (', '::text || public._('ongoing'::text))
            ELSE ''::text
        END)) || ')'::text) || COALESCE(('
 '::text || c_pr.comment), ''::text)) || COALESCE((('
 '::text || public._('document #'::text)) || c_pr.fk_doc), ''::text)) || COALESCE((('
'::text || array_to_string(( SELECT array_agg(((((((((r_csr.code || ' ('::text) || r_ds.name_short) || ' - '::text) || r_ds.version) || ' - '::text) || r_ds.lang) || '): '::text) || r_csr.term)) AS array_agg
           FROM ((clin.lnk_code2procedure c_lc2p
             JOIN ref.coding_system_root r_csr ON ((c_lc2p.fk_generic_code = r_csr.pk_coding_system)))
             JOIN ref.data_source r_ds ON ((r_ds.pk = r_csr.fk_data_source)))
          WHERE (c_lc2p.fk_item = c_pr.pk)), '; '::text)) || ';'::text), ''::text)) AS narrative,
    c_pr.fk_encounter AS pk_encounter,
    c_pr.fk_episode AS pk_episode,
    c_epi.fk_health_issue AS pk_health_issue,
    c_pr.pk AS src_pk,
    'clin.procedure'::text AS src_table,
    c_pr.row_version,
    c_hi.description AS health_issue,
    c_hi.laterality AS issue_laterality,
    c_hi.is_active AS issue_active,
    c_hi.clinically_relevant AS issue_clinically_relevant,
    c_hi.is_confidential AS issue_confidential,
    c_epi.description AS episode,
    c_epi.is_open AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM ((((((clin.procedure c_pr
     JOIN clin.encounter c_enc ON ((c_pr.fk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
     JOIN clin.episode c_epi ON ((c_pr.fk_episode = c_epi.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_epi.fk_health_issue = c_hi.pk)))
     LEFT JOIN dem.org_unit d_ou ON ((c_pr.fk_org_unit = d_ou.pk)))
     LEFT JOIN dem.org d_o ON ((d_ou.fk_org = d_o.pk)))
  WHERE (c_pr.fk_hospital_stay IS NULL);


ALTER TABLE clin.v_procedures_not_at_hospital_journal OWNER TO "gm-dbo";

--
-- Name: v_procedures_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_procedures_journal AS
 SELECT v_procedures_at_hospital_journal.pk_patient,
    v_procedures_at_hospital_journal.modified_when,
    v_procedures_at_hospital_journal.clin_when,
    v_procedures_at_hospital_journal.modified_by,
    v_procedures_at_hospital_journal.soap_cat,
    v_procedures_at_hospital_journal.narrative,
    v_procedures_at_hospital_journal.pk_encounter,
    v_procedures_at_hospital_journal.pk_episode,
    v_procedures_at_hospital_journal.pk_health_issue,
    v_procedures_at_hospital_journal.src_pk,
    v_procedures_at_hospital_journal.src_table,
    v_procedures_at_hospital_journal.row_version,
    v_procedures_at_hospital_journal.health_issue,
    v_procedures_at_hospital_journal.issue_laterality,
    v_procedures_at_hospital_journal.issue_active,
    v_procedures_at_hospital_journal.issue_clinically_relevant,
    v_procedures_at_hospital_journal.issue_confidential,
    v_procedures_at_hospital_journal.episode,
    v_procedures_at_hospital_journal.episode_open,
    v_procedures_at_hospital_journal.encounter_started,
    v_procedures_at_hospital_journal.encounter_last_affirmed,
    v_procedures_at_hospital_journal.encounter_type,
    v_procedures_at_hospital_journal.encounter_l10n_type
   FROM clin.v_procedures_at_hospital_journal
UNION ALL
 SELECT v_procedures_not_at_hospital_journal.pk_patient,
    v_procedures_not_at_hospital_journal.modified_when,
    v_procedures_not_at_hospital_journal.clin_when,
    v_procedures_not_at_hospital_journal.modified_by,
    v_procedures_not_at_hospital_journal.soap_cat,
    v_procedures_not_at_hospital_journal.narrative,
    v_procedures_not_at_hospital_journal.pk_encounter,
    v_procedures_not_at_hospital_journal.pk_episode,
    v_procedures_not_at_hospital_journal.pk_health_issue,
    v_procedures_not_at_hospital_journal.src_pk,
    v_procedures_not_at_hospital_journal.src_table,
    v_procedures_not_at_hospital_journal.row_version,
    v_procedures_not_at_hospital_journal.health_issue,
    v_procedures_not_at_hospital_journal.issue_laterality,
    v_procedures_not_at_hospital_journal.issue_active,
    v_procedures_not_at_hospital_journal.issue_clinically_relevant,
    v_procedures_not_at_hospital_journal.issue_confidential,
    v_procedures_not_at_hospital_journal.episode,
    v_procedures_not_at_hospital_journal.episode_open,
    v_procedures_not_at_hospital_journal.encounter_started,
    v_procedures_not_at_hospital_journal.encounter_last_affirmed,
    v_procedures_not_at_hospital_journal.encounter_type,
    v_procedures_not_at_hospital_journal.encounter_l10n_type
   FROM clin.v_procedures_not_at_hospital_journal;


ALTER TABLE clin.v_procedures_journal OWNER TO "gm-dbo";

--
-- Name: message_inbox; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.message_inbox (
    pk integer NOT NULL,
    fk_staff integer,
    fk_inbox_item_type integer NOT NULL,
    comment text,
    data text,
    importance smallint DEFAULT 0 NOT NULL,
    fk_patient integer,
    ufk_context integer[],
    due_date date,
    expiry_date date,
    CONSTRAINT dem_inbox_sane_expiry_date CHECK (((expiry_date IS NULL) OR (due_date IS NULL) OR (expiry_date > due_date))),
    CONSTRAINT message_must_have_recipient CHECK ((((fk_staff IS NULL) AND (fk_patient IS NULL)) IS FALSE)),
    CONSTRAINT provider_inbox_comment_check CHECK ((btrim(COALESCE(comment, 'xxxDEFAULTxxx'::text)) <> ''::text)),
    CONSTRAINT provider_inbox_importance_check CHECK (((importance = '-1'::integer) OR (importance = 0) OR (importance = 1)))
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.message_inbox OWNER TO "gm-dbo";

--
-- Name: TABLE message_inbox; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.message_inbox IS 'messages in GNUmed relating to a patient, a provider, and a context';


--
-- Name: COLUMN message_inbox.fk_staff; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.message_inbox.fk_staff IS 'the member of staff this message is addressed to';


--
-- Name: COLUMN message_inbox.fk_inbox_item_type; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.message_inbox.fk_inbox_item_type IS 'the item (message) type';


--
-- Name: COLUMN message_inbox.comment; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.message_inbox.comment IS 'a free-text comment, may be NULL but not empty';


--
-- Name: COLUMN message_inbox.data; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.message_inbox.data IS 'arbitrary data an application might wish to attach to
	 the message, like a cookie, basically';


--
-- Name: COLUMN message_inbox.importance; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.message_inbox.importance IS 'the relative importance of this message:

	 -1: lower than most things already in the inbox ("low")

	  0: same as most things ("standard")

	  1: higher than most things already there ("high")';


--
-- Name: COLUMN message_inbox.ufk_context; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.message_inbox.ufk_context IS 'a nullable array of Unchecked Foreign Keys, it is up to
	 the application to know what this points to, it will
	 have to make sense within the context of the combination
	 of staff ID, item type, and comment';


--
-- Name: COLUMN message_inbox.due_date; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.message_inbox.due_date IS 'The date this message/reminder is due. If NULL then the message is not a reminder.';


--
-- Name: COLUMN message_inbox.expiry_date; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.message_inbox.expiry_date IS 'The date this message/reminder "expires". Must be > .due_date it not NULL.';


--
-- Name: v_reminders_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_reminders_journal AS
 SELECT d_mi.fk_patient AS pk_patient,
    d_mi.modified_when,
    d_mi.due_date AS clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = d_mi.modified_by)), (('<'::text || (d_mi.modified_by)::text) || '>'::text)) AS modified_by,
    NULL::text AS soap_cat,
    ((((((((((((((((public._('Due today'::text) || ' ('::text) || d_vit.l10n_category) || ' - '::text) || d_vit.l10n_type) || ')'::text) || '
'::text) || COALESCE(((' '::text || d_mi.comment) || '
'::text), ''::text)) || COALESCE(((((' '::text || public._('Will expire:'::text)) || ' '::text) || to_char((d_mi.expiry_date)::timestamp with time zone, 'YYYY-MM-DD'::text)) || '
'::text), ''::text)) || ' '::text) || public._('Importance:'::text)) || ' '::text) || d_mi.importance) || '
'::text) || COALESCE(((((' '::text || public._('Context:'::text)) || ' '::text) || array_to_string(d_mi.ufk_context, ','::text, '?'::text)) || '
'::text), ''::text)) || COALESCE(((((' '::text || public._('Data:'::text)) || ' '::text) || d_mi.data) || '
'::text), ''::text)) || COALESCE((((' '::text || public._('Provider:'::text)) || ' '::text) || d_st.short_alias), ''::text)) AS narrative,
    ( SELECT c_e.pk
           FROM clin.encounter c_e
          WHERE (c_e.fk_patient = d_mi.fk_patient)
          ORDER BY c_e.started DESC
         LIMIT 1) AS pk_encounter,
    NULL::integer AS pk_episode,
    NULL::integer AS pk_health_issue,
    d_mi.pk AS src_pk,
    'dem.message_inbox'::text AS src_table,
    d_mi.row_version,
    NULL::text AS health_issue,
    NULL::text AS issue_laterality,
    NULL::boolean AS issue_active,
    NULL::boolean AS issue_clinically_relevant,
    NULL::boolean AS issue_confidential,
    NULL::text AS episode,
    NULL::boolean AS episode_open,
    ( SELECT c_e.started
           FROM clin.encounter c_e
          WHERE (c_e.fk_patient = d_mi.fk_patient)
          ORDER BY c_e.started DESC
         LIMIT 1) AS encounter_started,
    ( SELECT c_e.last_affirmed
           FROM clin.encounter c_e
          WHERE (c_e.fk_patient = d_mi.fk_patient)
          ORDER BY c_e.started DESC
         LIMIT 1) AS encounter_last_affirmed,
    NULL::text AS encounter_type,
    NULL::text AS encounter_l10n_type
   FROM ((dem.message_inbox d_mi
     JOIN dem.v_inbox_item_type d_vit ON ((d_mi.fk_inbox_item_type = d_vit.pk_type)))
     LEFT JOIN dem.staff d_st ON ((d_mi.fk_staff = d_st.pk)))
  WHERE ((d_mi.fk_patient IS NOT NULL) AND (d_vit.category = 'clinical'::text) AND (d_mi.due_date IS NOT NULL))
UNION
 SELECT d_mi.fk_patient AS pk_patient,
    d_mi.modified_when,
    d_mi.expiry_date AS clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = d_mi.modified_by)), (('<'::text || (d_mi.modified_by)::text) || '>'::text)) AS modified_by,
    NULL::text AS soap_cat,
    ((((((((((((((((public._('Epires today'::text) || ' ('::text) || d_vit.l10n_category) || ' - '::text) || d_vit.l10n_type) || ')'::text) || '
'::text) || COALESCE(((' '::text || d_mi.comment) || '
'::text), ''::text)) || COALESCE(((((' '::text || public._('Was due:'::text)) || ' '::text) || to_char((d_mi.due_date)::timestamp with time zone, 'YYYY-MM-DD'::text)) || '
'::text), ''::text)) || ' '::text) || public._('Importance:'::text)) || ' '::text) || d_mi.importance) || '
'::text) || COALESCE(((((' '::text || public._('Context:'::text)) || ' '::text) || array_to_string(d_mi.ufk_context, ','::text, '?'::text)) || '
'::text), ''::text)) || COALESCE(((((' '::text || public._('Data:'::text)) || ' '::text) || d_mi.data) || '
'::text), ''::text)) || COALESCE((((' '::text || public._('Provider:'::text)) || ' '::text) || d_st.short_alias), ''::text)) AS narrative,
    ( SELECT c_e.pk
           FROM clin.encounter c_e
          WHERE (c_e.fk_patient = d_mi.fk_patient)
          ORDER BY c_e.started DESC
         LIMIT 1) AS pk_encounter,
    NULL::integer AS pk_episode,
    NULL::integer AS pk_health_issue,
    d_mi.pk AS src_pk,
    'dem.message_inbox'::text AS src_table,
    d_mi.row_version,
    NULL::text AS health_issue,
    NULL::text AS issue_laterality,
    NULL::boolean AS issue_active,
    NULL::boolean AS issue_clinically_relevant,
    NULL::boolean AS issue_confidential,
    NULL::text AS episode,
    NULL::boolean AS episode_open,
    ( SELECT c_e.started
           FROM clin.encounter c_e
          WHERE (c_e.fk_patient = d_mi.fk_patient)
          ORDER BY c_e.started DESC
         LIMIT 1) AS encounter_started,
    ( SELECT c_e.last_affirmed
           FROM clin.encounter c_e
          WHERE (c_e.fk_patient = d_mi.fk_patient)
          ORDER BY c_e.started DESC
         LIMIT 1) AS encounter_last_affirmed,
    NULL::text AS encounter_type,
    NULL::text AS encounter_l10n_type
   FROM ((dem.message_inbox d_mi
     JOIN dem.v_inbox_item_type d_vit ON ((d_mi.fk_inbox_item_type = d_vit.pk_type)))
     LEFT JOIN dem.staff d_st ON ((d_mi.fk_staff = d_st.pk)))
  WHERE ((d_mi.fk_patient IS NOT NULL) AND (d_vit.category = 'clinical'::text) AND (d_mi.expiry_date IS NOT NULL))
UNION
 SELECT d_mi.fk_patient AS pk_patient,
    d_mi.modified_when,
    d_mi.modified_when AS clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = d_mi.modified_by)), (('<'::text || (d_mi.modified_by)::text) || '>'::text)) AS modified_by,
    NULL::text AS soap_cat,
    (((((((((((((((((public._('Clinical reminder'::text) || ' ('::text) || d_vit.l10n_category) || ' - '::text) || d_vit.l10n_type) || ')'::text) || '
'::text) || COALESCE(((' '::text || d_mi.comment) || '
'::text), ''::text)) || COALESCE(((((' '::text || public._('Due:'::text)) || ' '::text) || to_char((d_mi.due_date)::timestamp with time zone, 'YYYY-MM-DD'::text)) || '
'::text), ''::text)) || COALESCE(((((' '::text || public._('Expires:'::text)) || ' '::text) || to_char((d_mi.expiry_date)::timestamp with time zone, 'YYYY-MM-DD'::text)) || '
'::text), ''::text)) || ' '::text) || public._('Importance:'::text)) || ' '::text) || d_mi.importance) || '
'::text) || COALESCE(((((' '::text || public._('Context:'::text)) || ' '::text) || array_to_string(d_mi.ufk_context, ','::text, '?'::text)) || '
'::text), ''::text)) || COALESCE(((((' '::text || public._('Data:'::text)) || ' '::text) || d_mi.data) || '
'::text), ''::text)) || COALESCE((((' '::text || public._('Provider:'::text)) || ' '::text) || d_st.short_alias), ''::text)) AS narrative,
    ( SELECT c_e.pk
           FROM clin.encounter c_e
          WHERE (c_e.fk_patient = d_mi.fk_patient)
          ORDER BY c_e.started DESC
         LIMIT 1) AS pk_encounter,
    NULL::integer AS pk_episode,
    NULL::integer AS pk_health_issue,
    d_mi.pk AS src_pk,
    'dem.message_inbox'::text AS src_table,
    d_mi.row_version,
    NULL::text AS health_issue,
    NULL::text AS issue_laterality,
    NULL::boolean AS issue_active,
    NULL::boolean AS issue_clinically_relevant,
    NULL::boolean AS issue_confidential,
    NULL::text AS episode,
    NULL::boolean AS episode_open,
    ( SELECT c_e.started
           FROM clin.encounter c_e
          WHERE (c_e.fk_patient = d_mi.fk_patient)
          ORDER BY c_e.started DESC
         LIMIT 1) AS encounter_started,
    ( SELECT c_e.last_affirmed
           FROM clin.encounter c_e
          WHERE (c_e.fk_patient = d_mi.fk_patient)
          ORDER BY c_e.started DESC
         LIMIT 1) AS encounter_last_affirmed,
    NULL::text AS encounter_type,
    NULL::text AS encounter_l10n_type
   FROM ((dem.message_inbox d_mi
     JOIN dem.v_inbox_item_type d_vit ON ((d_mi.fk_inbox_item_type = d_vit.pk_type)))
     LEFT JOIN dem.staff d_st ON ((d_mi.fk_staff = d_st.pk)))
  WHERE ((d_mi.fk_patient IS NOT NULL) AND (d_vit.category = 'clinical'::text) AND ((d_mi.due_date IS NOT NULL) OR (d_mi.expiry_date IS NOT NULL)));


ALTER TABLE clin.v_reminders_journal OWNER TO "gm-dbo";

--
-- Name: dose; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.dose (
    pk integer NOT NULL,
    fk_substance integer NOT NULL,
    amount numeric NOT NULL,
    unit text NOT NULL,
    dose_unit text,
    CONSTRAINT ref_dose_sane_amount CHECK ((amount > (0)::numeric)),
    CONSTRAINT ref_dose_sane_dose_unit CHECK ((gm.is_null_or_non_empty_string(dose_unit) IS TRUE)),
    CONSTRAINT ref_dose_sane_unit CHECK ((gm.is_null_or_blank_string(unit) IS FALSE))
)
INHERITS (audit.audit_fields);


ALTER TABLE ref.dose OWNER TO "gm-dbo";

--
-- Name: TABLE dose; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.dose IS 'Links doses to consumable substances.';


--
-- Name: COLUMN dose.fk_substance; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.dose.fk_substance IS 'FK linking the substance';


--
-- Name: COLUMN dose.amount; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.dose.amount IS 'the amount of substance (the "5" in "5mg/ml")';


--
-- Name: COLUMN dose.unit; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.dose.unit IS 'unit of amount (the "mg" in "5mg/ml")';


--
-- Name: COLUMN dose.dose_unit; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.dose.dose_unit IS 'unit of reference amount,
 IOW the "ml" in "5mg/ml" (the reference amount is always assumed to be 1, as in "5mg/1ml"),
 if NULL the unit is "1 delivery unit (tablet, capsule, suppository, sachet, ...)",
 corresponds to "dose unit" in UCUM or "unit of product usage" in SNOMED';


--
-- Name: drug_product; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.drug_product (
    pk integer NOT NULL,
    description text NOT NULL,
    preparation text NOT NULL,
    atc_code text,
    is_fake boolean DEFAULT false NOT NULL,
    fk_data_source integer,
    external_code text,
    external_code_type text,
    CONSTRAINT desc_not_empty CHECK ((gm.is_null_or_blank_string(description) IS FALSE)),
    CONSTRAINT drug_sane_external_code CHECK ((gm.is_null_or_non_empty_string(external_code) IS TRUE)),
    CONSTRAINT drug_sane_external_code_type CHECK ((((external_code IS NULL) AND (external_code_type IS NULL)) OR ((external_code IS NOT NULL) AND (external_code_type IS NOT NULL)))),
    CONSTRAINT prep_not_empty CHECK ((gm.is_null_or_blank_string(preparation) IS FALSE)),
    CONSTRAINT sane_atc CHECK ((gm.is_null_or_non_empty_string(atc_code) IS TRUE))
)
INHERITS (audit.audit_fields);


ALTER TABLE ref.drug_product OWNER TO "gm-dbo";

--
-- Name: TABLE drug_product; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.drug_product IS 'The medicine chest of this praxis. Stores brands of drugs patients
 have been taking regardless of whether that brand still exists or
 in fact ever existed as such (as in lifestyle thingies).';


--
-- Name: COLUMN drug_product.description; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.drug_product.description IS 'the name of this drug it is marketed under by the manufacturer';


--
-- Name: COLUMN drug_product.preparation; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.drug_product.preparation IS 'the preparation the drug is delivered in, eg liquid, cream, tablet, etc.';


--
-- Name: COLUMN drug_product.atc_code; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.drug_product.atc_code IS 'the Anatomic Therapeutic Chemical code for this drug, used to compute possible substitutes';


--
-- Name: COLUMN drug_product.is_fake; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.drug_product.is_fake IS 'Whether this truly is an actual brand of an actual drug
 rather than a fake brand created for documenting a, say,
 lifestyle nutrient or simply a component as opposed to
 a particular actual brand.';


--
-- Name: COLUMN drug_product.fk_data_source; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.drug_product.fk_data_source IS 'the data source this entry came from';


--
-- Name: COLUMN drug_product.external_code; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.drug_product.external_code IS 'an opaque code from an external data source, such as "PZN" in Germany';


--
-- Name: COLUMN drug_product.external_code_type; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.drug_product.external_code_type IS 'an opaque code type from an external data source, such as "PZN" in Germany';


--
-- Name: lnk_dose2drug; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.lnk_dose2drug (
    pk integer NOT NULL,
    fk_drug_product integer NOT NULL,
    fk_dose integer NOT NULL
)
INHERITS (audit.audit_fields);


ALTER TABLE ref.lnk_dose2drug OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_dose2drug; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.lnk_dose2drug IS 'Links doses to drug products';


--
-- Name: COLUMN lnk_dose2drug.fk_drug_product; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.lnk_dose2drug.fk_drug_product IS 'FK linking the drug product';


--
-- Name: COLUMN lnk_dose2drug.fk_dose; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.lnk_dose2drug.fk_dose IS 'FK linking the dose';


--
-- Name: substance; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.substance (
    pk integer NOT NULL,
    description text,
    atc text,
    intake_instructions text,
    CONSTRAINT ref_substance_sane_desc CHECK ((gm.is_null_or_non_empty_string(description) IS TRUE)),
    CONSTRAINT ref_substance_sane_instructions CHECK ((gm.is_null_or_non_empty_string(intake_instructions) IS TRUE))
)
INHERITS (audit.audit_fields);


ALTER TABLE ref.substance OWNER TO "gm-dbo";

--
-- Name: TABLE substance; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.substance IS 'Holds substances that are consumed by patients for various reasons.';


--
-- Name: COLUMN substance.description; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.substance.description IS 'the name of the substance';


--
-- Name: COLUMN substance.atc; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.substance.atc IS 'the ATC of the substance';


--
-- Name: COLUMN substance.intake_instructions; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.substance.intake_instructions IS 'any intake instructions for the substance';


--
-- Name: v_substance_intake_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_substance_intake_journal AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_si.modified_when,
    c_si.clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_si.modified_by)), (('<'::text || (c_si.modified_by)::text) || '>'::text)) AS modified_by,
    c_si.soap_cat,
    (((((((((((((((((((((((
        CASE
            WHEN (c_si.is_long_term IS TRUE) THEN (public._('long-term'::text) || ' '::text)
            ELSE ''::text
        END || public._('substance intake'::text)) || ' '::text) ||
        CASE
            WHEN (c_si.intake_is_approved_of IS TRUE) THEN public._('(approved of)'::text)
            WHEN (c_si.intake_is_approved_of IS FALSE) THEN public._('(not approved of)'::text)
            ELSE public._('(of unknown approval)'::text)
        END) || ' '::text) ||
        CASE
            WHEN (c_si.harmful_use_type IS NULL) THEN ''::text
            WHEN (c_si.harmful_use_type = 0) THEN public._('no harmful use'::text)
            WHEN (c_si.harmful_use_type = 1) THEN public._('harmful use'::text)
            WHEN (c_si.harmful_use_type = 2) THEN public._('addiction'::text)
            WHEN (c_si.harmful_use_type = 3) THEN public._('previous addiction'::text)
            ELSE NULL::text
        END) || ':
'::text) || ' '::text) || r_s.description) || COALESCE(((' ['::text || r_s.atc) || '] '::text), ' '::text)) || (r_d.amount)::text) || r_d.unit) || ' '::text) || public._(r_dp.preparation)) || COALESCE((' '::text || c_si.schedule), ''::text)) || ', '::text) ||
        CASE
            WHEN (c_si.comment_on_start = '?'::text) THEN '?'::text
            WHEN (c_si.comment_on_start IS NULL) THEN to_char(c_si.clin_when, 'YYYY-MM-DD'::text)
            ELSE (((('~'::text || to_char(c_si.clin_when, 'YYYY-MM-DD'::text)) || ' ('::text) || c_si.comment_on_start) || ')'::text)
        END) || COALESCE((' -> '::text || c_si.duration), ''::text)) || '
'::text) || COALESCE(((((' '::text || public._('Discontinued'::text)) || to_char(c_si.discontinued, ': YYYY-MM-DD'::text)) || COALESCE(((' ('::text || c_si.discontinue_reason) || ')'::text), ''::text)) || '
'::text), ''::text)) || COALESCE(((('
 '::text || public._('Aim'::text)) || ': '::text) || c_si.aim), ''::text)) || COALESCE(((('
 '::text || public._('Notes'::text)) || ': '::text) || c_si.narrative), ''::text)) || COALESCE(((('
 '::text || public._('Instructions'::text)) || ': '::text) || r_s.intake_instructions), ''::text)) || COALESCE(((((' "'::text || r_dp.description) || '"'::text) || COALESCE(((' ['::text || r_dp.atc_code) || ']'::text), ''::text)) || COALESCE(((((' ('::text || r_dp.external_code_type) || ': '::text) || r_dp.external_code) || ')'::text), ''::text)), ''::text)) AS narrative,
    c_si.fk_encounter AS pk_encounter,
    c_si.fk_episode AS pk_episode,
    c_hi.pk AS pk_health_issue,
    c_si.pk AS src_pk,
    'clin.substance_intake'::text AS src_table,
    c_si.row_version,
    c_hi.description AS health_issue,
    c_hi.laterality AS issue_laterality,
    c_hi.is_active AS issue_active,
    c_hi.clinically_relevant AS issue_clinically_relevant,
    c_hi.is_confidential AS issue_confidential,
    c_epi.description AS episode,
    c_epi.is_open AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM ((((((((clin.substance_intake c_si
     JOIN ref.lnk_dose2drug r_ld2d ON ((c_si.fk_drug_component = r_ld2d.pk)))
     JOIN ref.drug_product r_dp ON ((r_ld2d.fk_drug_product = r_dp.pk)))
     JOIN ref.dose r_d ON ((r_ld2d.fk_dose = r_d.pk)))
     JOIN ref.substance r_s ON ((r_d.fk_substance = r_s.pk)))
     JOIN clin.encounter c_enc ON ((c_si.fk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
     JOIN clin.episode c_epi ON ((c_si.fk_episode = c_epi.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_epi.fk_health_issue = c_hi.pk)));


ALTER TABLE clin.v_substance_intake_journal OWNER TO "gm-dbo";

--
-- Name: v_suppressed_hints_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_suppressed_hints_journal AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_sh.modified_when,
    c_sh.suppressed_when AS clin_when,
    c_sh.modified_by,
    'p'::text AS soap_cat,
    ((((((((((((((
        CASE
            WHEN (r_vah.is_active IS TRUE) THEN public._('Active hint'::text)
            ELSE public._('Inactive hint'::text)
        END || ' #'::text) || c_sh.fk_hint) || ' '::text) || public._('suppressed by'::text)) || ' '::text) || (c_sh.suppressed_by)::text) || '
'::text) || COALESCE(((public._('Title: '::text) || r_vah.title) || '
'::text), ''::text)) || COALESCE(((public._('URL: '::text) || r_vah.url) || '
'::text), ''::text)) || COALESCE(((public._('Source: '::text) || r_vah.source) || '
'::text), ''::text)) || COALESCE(((public._('Rationale: '::text) || c_sh.rationale) || '
'::text), ''::text)) ||
        CASE
            WHEN (c_sh.md5_sum <> r_vah.md5_sum) THEN (public._('Hint definition has been modified since suppression. Rationale for suppression may no longer apply.'::text) || '
'::text)
            ELSE ''::text
        END) || COALESCE(((public._('Hint: '::text) || r_vah.hint) || '
'::text), ''::text)) || COALESCE((public._('Recommendation: '::text) || r_vah.recommendation), ''::text)) AS narrative,
    c_sh.fk_encounter,
    NULL::integer AS pk_episode,
    NULL::integer AS pk_health_issue,
    c_sh.pk AS src_pk,
    'clin.suppressed_hint'::text AS src_table,
    c_sh.row_version,
    NULL::text AS health_issue,
    NULL::text AS issue_laterality,
    NULL::boolean AS issue_active,
    NULL::boolean AS issue_clinically_relevant,
    NULL::boolean AS issue_confidential,
    NULL::text AS episode,
    NULL::boolean AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM (((clin.suppressed_hint c_sh
     JOIN clin.encounter c_enc ON ((c_sh.fk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
     JOIN ref.v_auto_hints r_vah ON ((c_sh.fk_hint = r_vah.pk_auto_hint)));


ALTER TABLE clin.v_suppressed_hints_journal OWNER TO "gm-dbo";

--
-- Name: v_test_types4test_panel; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_test_types4test_panel AS
 SELECT c_tp.pk AS pk_test_panel,
    c_tt.pk AS pk_test_type,
    c_tp.description AS test_panel,
    c_tt.name AS test_type,
    c_tt.abbrev AS test_abbrev,
    c_tt.loinc,
    c_tp.comment AS comment_panel,
    c_tt.comment AS comment_test_type,
    c_tt.reference_unit,
    c_tt.fk_meta_test_type AS pk_meta_test_type,
    c_ll2tp.pk AS pk_lnk_loinc2test_panel
   FROM ((clin.test_panel c_tp
     JOIN clin.lnk_loinc2test_panel c_ll2tp ON ((c_ll2tp.fk_test_panel = c_tp.pk)))
     JOIN clin.test_type c_tt ON ((c_tt.loinc = c_ll2tp.loinc)));


ALTER TABLE clin.v_test_types4test_panel OWNER TO "gm-dbo";

--
-- Name: VIEW v_test_types4test_panel; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_test_types4test_panel IS 'Shows test types linked to test panels via their LOINC code.';


--
-- Name: v_test_types; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_test_types AS
 SELECT c_tt.pk AS pk_test_type,
    c_tt.abbrev,
    c_tt.name,
    c_tt.loinc,
    c_tt.reference_unit,
    c_tt.comment AS comment_type,
    d_ou.description AS name_org,
    c_to.comment AS comment_org,
    c_to.contact AS contact_org,
    COALESCE(c_mtt.abbrev, c_tt.abbrev) AS unified_abbrev,
    COALESCE(c_mtt.name, c_tt.name) AS unified_name,
    COALESCE(c_mtt.loinc, c_tt.loinc) AS unified_loinc,
    (c_tt.fk_meta_test_type IS NULL) AS is_fake_meta_type,
    c_mtt.abbrev AS abbrev_meta,
    c_mtt.name AS name_meta,
    c_mtt.loinc AS loinc_meta,
    c_mtt.comment AS comment_meta,
    ( SELECT array_agg(c_vtt4tp.pk_test_panel) AS array_agg
           FROM clin.v_test_types4test_panel c_vtt4tp
          WHERE (c_vtt4tp.pk_test_type = c_tt.pk)) AS pk_test_panels,
    c_tt.fk_test_org AS pk_test_org,
    c_tt.fk_meta_test_type AS pk_meta_test_type,
    c_to.fk_org_unit AS pk_org_unit,
    c_to.fk_adm_contact AS pk_adm_contact_org,
    c_to.fk_med_contact AS pk_med_contact_org,
    c_tt.xmin AS xmin_test_type
   FROM (((clin.test_type c_tt
     LEFT JOIN clin.test_org c_to ON ((c_to.pk = c_tt.fk_test_org)))
     LEFT JOIN dem.org_unit d_ou ON ((c_to.fk_org_unit = d_ou.pk)))
     LEFT JOIN clin.meta_test_type c_mtt ON ((c_tt.fk_meta_test_type = c_mtt.pk)));


ALTER TABLE clin.v_test_types OWNER TO "gm-dbo";

--
-- Name: VIEW v_test_types; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_test_types IS 'denormalizes test types with test orgs and meta types';


--
-- Name: v_test_results; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_test_results AS
 SELECT cenc.fk_patient AS pk_patient,
    tr.pk AS pk_test_result,
    tr.clin_when,
    c_vtt.unified_abbrev,
    c_vtt.unified_name,
    c_vtt.unified_loinc,
        CASE
            WHEN (COALESCE(btrim(tr.val_alpha), ''::text) = ''::text) THEN (tr.val_num)::text
            ELSE
            CASE
                WHEN (tr.val_num IS NULL) THEN tr.val_alpha
                ELSE ((((tr.val_num)::text || ' ('::text) || tr.val_alpha) || ')'::text)
            END
        END AS unified_val,
    COALESCE(tr.val_target_min, tr.val_normal_min) AS unified_target_min,
    COALESCE(tr.val_target_max, tr.val_normal_max) AS unified_target_max,
    COALESCE(tr.val_target_range, tr.val_normal_range) AS unified_target_range,
    tr.status,
    tr.soap_cat,
    tr.narrative AS comment,
    tr.val_num,
    tr.val_alpha,
    tr.val_unit,
    c_vtt.reference_unit,
    tr.val_normal_min,
    tr.val_normal_max,
    tr.val_normal_range,
    tr.val_target_min,
    tr.val_target_max,
    tr.val_target_range,
    tr.abnormality_indicator,
    tr.norm_ref_group,
    tr.note_test_org,
    tr.material,
    tr.material_detail,
    c_vtt.abbrev AS abbrev_tt,
    c_vtt.name AS name_tt,
    c_vtt.loinc AS loinc_tt,
    c_vtt.comment_type AS comment_tt,
    c_vtt.name_org AS name_test_org,
    c_vtt.contact_org AS contact_test_org,
    c_vtt.comment_org AS comment_test_org,
    c_vtt.is_fake_meta_type,
    c_vtt.abbrev_meta,
    c_vtt.name_meta,
    c_vtt.loinc_meta,
    c_vtt.comment_meta,
    epi.description AS episode,
    chi.description AS health_issue,
    (COALESCE(rtr.fk_reviewed_row, 0))::boolean AS reviewed,
    rtr.is_technically_abnormal,
    rtr.clinically_relevant AS is_clinically_relevant,
    rtr.comment AS review_comment,
    ( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.pk = rtr.fk_reviewer)) AS last_reviewer,
    rtr.modified_when AS last_reviewed,
    COALESCE((rtr.fk_reviewer = ( SELECT staff.pk
           FROM dem.staff
          WHERE (staff.db_user = "current_user"()))), false) AS review_by_you,
    COALESCE((tr.fk_intended_reviewer = rtr.fk_reviewer), false) AS review_by_responsible_reviewer,
    ( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.pk = tr.fk_intended_reviewer)) AS responsible_reviewer,
    COALESCE((tr.fk_intended_reviewer = ( SELECT staff.pk
           FROM dem.staff
          WHERE (staff.db_user = "current_user"()))), false) AS you_are_responsible,
        CASE
            WHEN (( SELECT 1
               FROM dem.staff
              WHERE (staff.db_user = tr.modified_by)) IS NULL) THEN (('<'::text || (tr.modified_by)::text) || '>'::text)
            ELSE ( SELECT staff.short_alias
               FROM dem.staff
              WHERE (staff.db_user = tr.modified_by))
        END AS modified_by,
    tr.val_grouping,
    tr.source_data,
    tr.modified_when,
    tr.row_version,
    tr.pk_item,
    tr.fk_encounter AS pk_encounter,
    tr.fk_episode AS pk_episode,
    tr.fk_type AS pk_test_type,
    tr.fk_intended_reviewer AS pk_intended_reviewer,
    tr.fk_request AS pk_request,
    tr.xmin AS xmin_test_result,
    c_vtt.pk_test_org,
    c_vtt.pk_meta_test_type,
    epi.fk_health_issue AS pk_health_issue,
    rtr.fk_reviewer AS pk_last_reviewer
   FROM ((((clin.test_result tr
     LEFT JOIN clin.encounter cenc ON ((tr.fk_encounter = cenc.pk)))
     LEFT JOIN clin.episode epi ON ((tr.fk_episode = epi.pk)))
     LEFT JOIN clin.reviewed_test_results rtr ON ((tr.pk = rtr.fk_reviewed_row)))
     LEFT JOIN clin.health_issue chi ON ((epi.fk_health_issue = chi.pk))),
    clin.v_test_types c_vtt
  WHERE (tr.fk_type = c_vtt.pk_test_type);


ALTER TABLE clin.v_test_results OWNER TO "gm-dbo";

--
-- Name: VIEW v_test_results; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_test_results IS 'denormalized view over test_results joined with (possibly unified) test
	 type and patient/episode/encounter keys';


--
-- Name: v_test_results_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_test_results_journal AS
 SELECT c_vtr.pk_patient,
    c_vtr.modified_when,
    c_vtr.clin_when,
    c_vtr.modified_by,
    c_vtr.soap_cat,
    COALESCE(((((((((((((((((((((((((((c_vtr.unified_name || ' ('::text) || c_vtr.unified_abbrev) || COALESCE(((' [#'::text || c_vtr.unified_loinc) || ']'::text), ''::text)) || '): '::text) || c_vtr.unified_val) || ' '::text) || COALESCE(c_vtr.val_unit, ''::text)) || ' '::text) || COALESCE((('('::text || c_vtr.abnormality_indicator) || ')'::text), ''::text)) || '
'::text) || public._('Range: '::text)) || COALESCE((c_vtr.unified_target_min)::text, ''::text)) || ' - '::text) || COALESCE((c_vtr.unified_target_max)::text, ''::text)) || ' / '::text) || COALESCE(c_vtr.unified_target_range, ''::text)) || COALESCE(((' ('::text || c_vtr.norm_ref_group) || ')'::text), ''::text)) || '
'::text) || COALESCE(((public._('Assessment: '::text) || c_vtr.comment) || '
'::text), ''::text)) || COALESCE(((public._('Context: '::text) || c_vtr.note_test_org) || '
'::text), ''::text)) || COALESCE(((public._('Status: '::text) || c_vtr.status) || '
'::text), ''::text)) || COALESCE(((public._('Grouping: '::text) || c_vtr.val_grouping) || '
'::text), ''::text)) || COALESCE((((((((public._('Review by '::text) || c_vtr.last_reviewer) || ' @ '::text) || to_char(c_vtr.last_reviewed, 'YYYY-MM-DD HH24:MI'::text)) || ': '::text) ||
        CASE
            WHEN c_vtr.is_technically_abnormal THEN (public._('abnormal'::text) || ', '::text)
            ELSE ''::text
        END) ||
        CASE
            WHEN c_vtr.is_clinically_relevant THEN (public._('relevant'::text) || ' '::text)
            ELSE ''::text
        END) || COALESCE((('('::text || c_vtr.review_comment) || ')
'::text), '
'::text)), ''::text)) || public._('Responsible clinician: '::text)) || c_vtr.responsible_reviewer) || COALESCE((((public._('Source data:'::text) || '
'::text) || c_vtr.source_data) || '
'::text), ''::text)), 'faulty clin.v_test_results_journal definition'::text) AS narrative,
    c_vtr.pk_encounter,
    c_vtr.pk_episode,
    c_vtr.pk_health_issue,
    c_vtr.pk_test_result AS src_pk,
    'clin.test_result'::text AS src_table,
    c_vtr.row_version,
    c_vtr.health_issue,
    c_hi.laterality AS issue_laterality,
    c_hi.is_active AS issue_active,
    c_hi.clinically_relevant AS issue_clinically_relevant,
    c_hi.is_confidential AS issue_confidential,
    c_vtr.episode,
    c_epi.is_open AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM ((((clin.v_test_results c_vtr
     JOIN clin.encounter c_enc ON ((c_vtr.pk_encounter = c_enc.pk)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
     JOIN clin.episode c_epi ON ((c_vtr.pk_episode = c_epi.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_epi.fk_health_issue = c_hi.pk)));


ALTER TABLE clin.v_test_results_journal OWNER TO "gm-dbo";

--
-- Name: VIEW v_test_results_journal; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_test_results_journal IS 'formatting of v_test_results for inclusion in v_emr_journal';


--
-- Name: vaccination; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.vaccination (
    pk integer NOT NULL,
    fk_provider integer,
    fk_vaccine integer NOT NULL,
    site text,
    batch_no text NOT NULL,
    reaction text,
    CONSTRAINT vaccination_sane_narrative CHECK ((gm.is_null_or_non_empty_string(narrative) IS TRUE)),
    CONSTRAINT vaccination_sane_reaction CHECK ((gm.is_null_or_non_empty_string(reaction) IS TRUE)),
    CONSTRAINT vaccination_sane_site CHECK ((gm.is_null_or_non_empty_string(site) IS TRUE))
)
INHERITS (clin.clin_root_item);


ALTER TABLE clin.vaccination OWNER TO "gm-dbo";

--
-- Name: TABLE vaccination; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.vaccination IS 'holds vaccinations actually given';


--
-- Name: COLUMN vaccination.narrative; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.vaccination.narrative IS 'Used to record a comment on this vaccination.';


--
-- Name: COLUMN vaccination.fk_provider; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.vaccination.fk_provider IS 'Who administered this vaccination.';


--
-- Name: COLUMN vaccination.site; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.vaccination.site IS 'The site of injection used in this vaccination.';


--
-- Name: COLUMN vaccination.batch_no; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.vaccination.batch_no IS 'The batch/lot number of the vaccine given.';


--
-- Name: COLUMN vaccination.reaction; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.vaccination.reaction IS 'Used to record reactions to this vaccination.';


--
-- Name: vaccine; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.vaccine (
    pk integer NOT NULL,
    id_route integer,
    is_live boolean NOT NULL,
    min_age interval,
    max_age interval,
    comment text,
    fk_drug_product integer NOT NULL,
    CONSTRAINT vaccine_sane_max_age CHECK (((max_age IS NULL) OR (max_age < '150 years'::interval))),
    CONSTRAINT vaccine_sane_min_age CHECK (((min_age IS NULL) OR (((max_age IS NULL) AND (min_age < '150 years'::interval)) OR ((max_age IS NOT NULL) AND (min_age <= max_age)))))
)
INHERITS (audit.audit_fields);


ALTER TABLE ref.vaccine OWNER TO "gm-dbo";

--
-- Name: TABLE vaccine; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.vaccine IS 'definition of a vaccine as available on the market';


--
-- Name: COLUMN vaccine.id_route; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.vaccine.id_route IS 'route this vaccine is given';


--
-- Name: COLUMN vaccine.is_live; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.vaccine.is_live IS 'whether this is a live vaccine';


--
-- Name: COLUMN vaccine.min_age; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.vaccine.min_age IS 'minimum age this vaccine is licensed for according to the information by the manufacturer';


--
-- Name: COLUMN vaccine.max_age; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.vaccine.max_age IS 'maximum age this vaccine is licensed for according to the information
	 by the manufacturer, use "5555 years" to indicate "no maximum age"';


--
-- Name: COLUMN vaccine.fk_drug_product; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.vaccine.fk_drug_product IS 'The brand of this vaccine, can be a fake entry in ref.branded_drug.';


--
-- Name: v_vaccinations_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_vaccinations_journal AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_vacc.modified_when,
    c_vacc.clin_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_vacc.modified_by)), (('<'::text || (c_vacc.modified_by)::text) || '>'::text)) AS modified_by,
    c_vacc.soap_cat,
    ((((((((((public._('Vaccination'::text) || ': '::text) || r_dp.description) || ' '::text) || '['::text) || c_vacc.batch_no) || ']'::text) || COALESCE(((' ('::text || c_vacc.site) || ')'::text), ''::text)) || COALESCE(((('
'::text || public._('Reaction'::text)) || ': '::text) || c_vacc.reaction), ''::text)) || COALESCE(((('
'::text || public._('Comment'::text)) || ': '::text) || c_vacc.narrative), ''::text)) || COALESCE(((('
'::text || public._('Indications'::text)) || ': '::text) || array_to_string(( SELECT array_agg(public._((r_s.atc || '-target'::text))) AS array_agg
           FROM ((ref.lnk_dose2drug r_ld2d
             JOIN ref.dose r_d ON ((r_d.pk = r_ld2d.fk_dose)))
             JOIN ref.substance r_s ON ((r_d.fk_substance = r_s.pk)))
          WHERE (r_ld2d.fk_drug_product = r_dp.pk)), ' / '::text)), ''::text)) AS narrative,
    c_vacc.fk_encounter AS pk_encounter,
    c_vacc.fk_episode AS pk_episode,
    ( SELECT episode.fk_health_issue
           FROM clin.episode
          WHERE (episode.pk = c_vacc.fk_episode)) AS pk_health_issue,
    c_vacc.pk AS src_pk,
    'clin.vaccination'::text AS src_table,
    c_vacc.row_version,
    c_hi.description AS health_issue,
    c_hi.laterality AS issue_laterality,
    c_hi.is_active AS issue_active,
    c_hi.clinically_relevant AS issue_clinically_relevant,
    c_hi.is_confidential AS issue_confidential,
    c_epi.description AS episode,
    c_epi.is_open AS episode_open,
    c_enc.started AS encounter_started,
    c_enc.last_affirmed AS encounter_last_affirmed,
    c_ety.description AS encounter_type,
    public._(c_ety.description) AS encounter_l10n_type
   FROM ((((((clin.vaccination c_vacc
     JOIN clin.encounter c_enc ON ((c_enc.pk = c_vacc.fk_encounter)))
     JOIN clin.encounter_type c_ety ON ((c_enc.fk_type = c_ety.pk)))
     JOIN clin.episode c_epi ON ((c_vacc.fk_episode = c_epi.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_epi.fk_health_issue = c_hi.pk)))
     JOIN ref.vaccine r_vcine ON ((r_vcine.pk = c_vacc.fk_vaccine)))
     JOIN ref.drug_product r_dp ON ((r_vcine.fk_drug_product = r_dp.pk)));


ALTER TABLE clin.v_vaccinations_journal OWNER TO "gm-dbo";

--
-- Name: VIEW v_vaccinations_journal; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_vaccinations_journal IS 'Vaccination data denormalized for the EMR journal.';


--
-- Name: v_emr_journal; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_emr_journal AS
 SELECT v_pat_narrative_journal.pk_patient,
    v_pat_narrative_journal.modified_when,
    v_pat_narrative_journal.clin_when,
    v_pat_narrative_journal.modified_by,
    v_pat_narrative_journal.soap_cat,
    v_pat_narrative_journal.narrative,
    v_pat_narrative_journal.pk_encounter,
    v_pat_narrative_journal.pk_episode,
    v_pat_narrative_journal.pk_health_issue,
    v_pat_narrative_journal.src_pk,
    v_pat_narrative_journal.src_table,
    v_pat_narrative_journal.row_version,
    v_pat_narrative_journal.health_issue,
    v_pat_narrative_journal.issue_laterality,
    v_pat_narrative_journal.issue_active,
    v_pat_narrative_journal.issue_clinically_relevant,
    v_pat_narrative_journal.issue_confidential,
    v_pat_narrative_journal.episode,
    v_pat_narrative_journal.episode_open,
    v_pat_narrative_journal.encounter_started,
    v_pat_narrative_journal.encounter_last_affirmed,
    v_pat_narrative_journal.encounter_type,
    v_pat_narrative_journal.encounter_l10n_type
   FROM clin.v_pat_narrative_journal
UNION ALL
 SELECT v_health_issues_journal.pk_patient,
    v_health_issues_journal.modified_when,
    v_health_issues_journal.clin_when,
    v_health_issues_journal.modified_by,
    v_health_issues_journal.soap_cat,
    v_health_issues_journal.narrative,
    v_health_issues_journal.pk_encounter,
    v_health_issues_journal.pk_episode,
    v_health_issues_journal.pk_health_issue,
    v_health_issues_journal.src_pk,
    v_health_issues_journal.src_table,
    v_health_issues_journal.row_version,
    v_health_issues_journal.health_issue,
    v_health_issues_journal.issue_laterality,
    v_health_issues_journal.issue_active,
    v_health_issues_journal.issue_clinically_relevant,
    v_health_issues_journal.issue_confidential,
    v_health_issues_journal.episode,
    v_health_issues_journal.episode_open,
    v_health_issues_journal.encounter_started,
    v_health_issues_journal.encounter_last_affirmed,
    v_health_issues_journal.encounter_type,
    v_health_issues_journal.encounter_l10n_type
   FROM clin.v_health_issues_journal
UNION ALL
 SELECT v_pat_encounters_journal.pk_patient,
    v_pat_encounters_journal.modified_when,
    v_pat_encounters_journal.clin_when,
    v_pat_encounters_journal.modified_by,
    v_pat_encounters_journal.soap_cat,
    v_pat_encounters_journal.narrative,
    v_pat_encounters_journal.pk_encounter,
    v_pat_encounters_journal.pk_episode,
    v_pat_encounters_journal.pk_health_issue,
    v_pat_encounters_journal.src_pk,
    v_pat_encounters_journal.src_table,
    v_pat_encounters_journal.row_version,
    v_pat_encounters_journal.health_issue,
    v_pat_encounters_journal.issue_laterality,
    v_pat_encounters_journal.issue_active,
    v_pat_encounters_journal.issue_clinically_relevant,
    v_pat_encounters_journal.issue_confidential,
    v_pat_encounters_journal.episode,
    v_pat_encounters_journal.episode_open,
    v_pat_encounters_journal.encounter_started,
    v_pat_encounters_journal.encounter_last_affirmed,
    v_pat_encounters_journal.encounter_type,
    v_pat_encounters_journal.encounter_l10n_type
   FROM clin.v_pat_encounters_journal
UNION ALL
 SELECT v_pat_episodes_journal.pk_patient,
    v_pat_episodes_journal.modified_when,
    v_pat_episodes_journal.clin_when,
    v_pat_episodes_journal.modified_by,
    v_pat_episodes_journal.soap_cat,
    v_pat_episodes_journal.narrative,
    v_pat_episodes_journal.pk_encounter,
    v_pat_episodes_journal.pk_episode,
    v_pat_episodes_journal.pk_health_issue,
    v_pat_episodes_journal.src_pk,
    v_pat_episodes_journal.src_table,
    v_pat_episodes_journal.row_version,
    v_pat_episodes_journal.health_issue,
    v_pat_episodes_journal.issue_laterality,
    v_pat_episodes_journal.issue_active,
    v_pat_episodes_journal.issue_clinically_relevant,
    v_pat_episodes_journal.issue_confidential,
    v_pat_episodes_journal.episode,
    v_pat_episodes_journal.episode_open,
    v_pat_episodes_journal.encounter_started,
    v_pat_episodes_journal.encounter_last_affirmed,
    v_pat_episodes_journal.encounter_type,
    v_pat_episodes_journal.encounter_l10n_type
   FROM clin.v_pat_episodes_journal
UNION ALL
 SELECT v_family_history_journal.pk_patient,
    v_family_history_journal.modified_when,
    v_family_history_journal.clin_when,
    v_family_history_journal.modified_by,
    v_family_history_journal.soap_cat,
    v_family_history_journal.narrative,
    v_family_history_journal.pk_encounter,
    v_family_history_journal.pk_episode,
    v_family_history_journal.pk_health_issue,
    v_family_history_journal.src_pk,
    v_family_history_journal.src_table,
    v_family_history_journal.row_version,
    v_family_history_journal.health_issue,
    v_family_history_journal.issue_laterality,
    v_family_history_journal.issue_active,
    v_family_history_journal.issue_clinically_relevant,
    v_family_history_journal.issue_confidential,
    v_family_history_journal.episode,
    v_family_history_journal.episode_open,
    v_family_history_journal.encounter_started,
    v_family_history_journal.encounter_last_affirmed,
    v_family_history_journal.encounter_type,
    v_family_history_journal.encounter_l10n_type
   FROM clin.v_family_history_journal
UNION ALL
 SELECT v_pat_allergies_journal.pk_patient,
    v_pat_allergies_journal.modified_when,
    v_pat_allergies_journal.clin_when,
    v_pat_allergies_journal.modified_by,
    v_pat_allergies_journal.soap_cat,
    v_pat_allergies_journal.narrative,
    v_pat_allergies_journal.pk_encounter,
    v_pat_allergies_journal.pk_episode,
    v_pat_allergies_journal.pk_health_issue,
    v_pat_allergies_journal.src_pk,
    v_pat_allergies_journal.src_table,
    v_pat_allergies_journal.row_version,
    v_pat_allergies_journal.health_issue,
    v_pat_allergies_journal.issue_laterality,
    v_pat_allergies_journal.issue_active,
    v_pat_allergies_journal.issue_clinically_relevant,
    v_pat_allergies_journal.issue_confidential,
    v_pat_allergies_journal.episode,
    v_pat_allergies_journal.episode_open,
    v_pat_allergies_journal.encounter_started,
    v_pat_allergies_journal.encounter_last_affirmed,
    v_pat_allergies_journal.encounter_type,
    v_pat_allergies_journal.encounter_l10n_type
   FROM clin.v_pat_allergies_journal
UNION ALL
 SELECT v_pat_allergy_state_journal.pk_patient,
    v_pat_allergy_state_journal.modified_when,
    v_pat_allergy_state_journal.clin_when,
    v_pat_allergy_state_journal.modified_by,
    v_pat_allergy_state_journal.soap_cat,
    v_pat_allergy_state_journal.narrative,
    v_pat_allergy_state_journal.pk_encounter,
    v_pat_allergy_state_journal.pk_episode,
    v_pat_allergy_state_journal.pk_health_issue,
    v_pat_allergy_state_journal.src_pk,
    v_pat_allergy_state_journal.src_table,
    v_pat_allergy_state_journal.row_version,
    v_pat_allergy_state_journal.health_issue,
    v_pat_allergy_state_journal.issue_laterality,
    v_pat_allergy_state_journal.issue_active,
    v_pat_allergy_state_journal.issue_clinically_relevant,
    v_pat_allergy_state_journal.issue_confidential,
    v_pat_allergy_state_journal.episode,
    v_pat_allergy_state_journal.episode_open,
    v_pat_allergy_state_journal.encounter_started,
    v_pat_allergy_state_journal.encounter_last_affirmed,
    v_pat_allergy_state_journal.encounter_type,
    v_pat_allergy_state_journal.encounter_l10n_type
   FROM clin.v_pat_allergy_state_journal
UNION ALL
 SELECT v_test_results_journal.pk_patient,
    v_test_results_journal.modified_when,
    v_test_results_journal.clin_when,
    v_test_results_journal.modified_by,
    v_test_results_journal.soap_cat,
    v_test_results_journal.narrative,
    v_test_results_journal.pk_encounter,
    v_test_results_journal.pk_episode,
    v_test_results_journal.pk_health_issue,
    v_test_results_journal.src_pk,
    v_test_results_journal.src_table,
    v_test_results_journal.row_version,
    v_test_results_journal.health_issue,
    v_test_results_journal.issue_laterality,
    v_test_results_journal.issue_active,
    v_test_results_journal.issue_clinically_relevant,
    v_test_results_journal.issue_confidential,
    v_test_results_journal.episode,
    v_test_results_journal.episode_open,
    v_test_results_journal.encounter_started,
    v_test_results_journal.encounter_last_affirmed,
    v_test_results_journal.encounter_type,
    v_test_results_journal.encounter_l10n_type
   FROM clin.v_test_results_journal
UNION ALL
 SELECT v_hospital_stays_journal.pk_patient,
    v_hospital_stays_journal.modified_when,
    v_hospital_stays_journal.clin_when,
    v_hospital_stays_journal.modified_by,
    v_hospital_stays_journal.soap_cat,
    v_hospital_stays_journal.narrative,
    v_hospital_stays_journal.pk_encounter,
    v_hospital_stays_journal.pk_episode,
    v_hospital_stays_journal.pk_health_issue,
    v_hospital_stays_journal.src_pk,
    v_hospital_stays_journal.src_table,
    v_hospital_stays_journal.row_version,
    v_hospital_stays_journal.health_issue,
    v_hospital_stays_journal.issue_laterality,
    v_hospital_stays_journal.issue_active,
    v_hospital_stays_journal.issue_clinically_relevant,
    v_hospital_stays_journal.issue_confidential,
    v_hospital_stays_journal.episode,
    v_hospital_stays_journal.episode_open,
    v_hospital_stays_journal.encounter_started,
    v_hospital_stays_journal.encounter_last_affirmed,
    v_hospital_stays_journal.encounter_type,
    v_hospital_stays_journal.encounter_l10n_type
   FROM clin.v_hospital_stays_journal
UNION ALL
 SELECT v_doc_med_journal.pk_patient,
    v_doc_med_journal.modified_when,
    v_doc_med_journal.clin_when,
    v_doc_med_journal.modified_by,
    v_doc_med_journal.soap_cat,
    v_doc_med_journal.narrative,
    v_doc_med_journal.pk_encounter,
    v_doc_med_journal.pk_episode,
    v_doc_med_journal.pk_health_issue,
    v_doc_med_journal.src_pk,
    v_doc_med_journal.src_table,
    v_doc_med_journal.row_version,
    v_doc_med_journal.health_issue,
    v_doc_med_journal.issue_laterality,
    v_doc_med_journal.issue_active,
    v_doc_med_journal.issue_clinically_relevant,
    v_doc_med_journal.issue_confidential,
    v_doc_med_journal.episode,
    v_doc_med_journal.episode_open,
    v_doc_med_journal.encounter_started,
    v_doc_med_journal.encounter_last_affirmed,
    v_doc_med_journal.encounter_type,
    v_doc_med_journal.encounter_l10n_type
   FROM blobs.v_doc_med_journal
UNION ALL
 SELECT v_substance_intake_journal.pk_patient,
    v_substance_intake_journal.modified_when,
    v_substance_intake_journal.clin_when,
    v_substance_intake_journal.modified_by,
    v_substance_intake_journal.soap_cat,
    v_substance_intake_journal.narrative,
    v_substance_intake_journal.pk_encounter,
    v_substance_intake_journal.pk_episode,
    v_substance_intake_journal.pk_health_issue,
    v_substance_intake_journal.src_pk,
    v_substance_intake_journal.src_table,
    v_substance_intake_journal.row_version,
    v_substance_intake_journal.health_issue,
    v_substance_intake_journal.issue_laterality,
    v_substance_intake_journal.issue_active,
    v_substance_intake_journal.issue_clinically_relevant,
    v_substance_intake_journal.issue_confidential,
    v_substance_intake_journal.episode,
    v_substance_intake_journal.episode_open,
    v_substance_intake_journal.encounter_started,
    v_substance_intake_journal.encounter_last_affirmed,
    v_substance_intake_journal.encounter_type,
    v_substance_intake_journal.encounter_l10n_type
   FROM clin.v_substance_intake_journal
UNION ALL
 SELECT v_procedures_journal.pk_patient,
    v_procedures_journal.modified_when,
    v_procedures_journal.clin_when,
    v_procedures_journal.modified_by,
    v_procedures_journal.soap_cat,
    v_procedures_journal.narrative,
    v_procedures_journal.pk_encounter,
    v_procedures_journal.pk_episode,
    v_procedures_journal.pk_health_issue,
    v_procedures_journal.src_pk,
    v_procedures_journal.src_table,
    v_procedures_journal.row_version,
    v_procedures_journal.health_issue,
    v_procedures_journal.issue_laterality,
    v_procedures_journal.issue_active,
    v_procedures_journal.issue_clinically_relevant,
    v_procedures_journal.issue_confidential,
    v_procedures_journal.episode,
    v_procedures_journal.episode_open,
    v_procedures_journal.encounter_started,
    v_procedures_journal.encounter_last_affirmed,
    v_procedures_journal.encounter_type,
    v_procedures_journal.encounter_l10n_type
   FROM clin.v_procedures_journal
UNION ALL
 SELECT v_vaccinations_journal.pk_patient,
    v_vaccinations_journal.modified_when,
    v_vaccinations_journal.clin_when,
    v_vaccinations_journal.modified_by,
    v_vaccinations_journal.soap_cat,
    v_vaccinations_journal.narrative,
    v_vaccinations_journal.pk_encounter,
    v_vaccinations_journal.pk_episode,
    v_vaccinations_journal.pk_health_issue,
    v_vaccinations_journal.src_pk,
    v_vaccinations_journal.src_table,
    v_vaccinations_journal.row_version,
    v_vaccinations_journal.health_issue,
    v_vaccinations_journal.issue_laterality,
    v_vaccinations_journal.issue_active,
    v_vaccinations_journal.issue_clinically_relevant,
    v_vaccinations_journal.issue_confidential,
    v_vaccinations_journal.episode,
    v_vaccinations_journal.episode_open,
    v_vaccinations_journal.encounter_started,
    v_vaccinations_journal.encounter_last_affirmed,
    v_vaccinations_journal.encounter_type,
    v_vaccinations_journal.encounter_l10n_type
   FROM clin.v_vaccinations_journal
UNION ALL
 SELECT v_suppressed_hints_journal.pk_patient,
    v_suppressed_hints_journal.modified_when,
    v_suppressed_hints_journal.clin_when,
    v_suppressed_hints_journal.modified_by,
    v_suppressed_hints_journal.soap_cat,
    v_suppressed_hints_journal.narrative,
    v_suppressed_hints_journal.fk_encounter AS pk_encounter,
    v_suppressed_hints_journal.pk_episode,
    v_suppressed_hints_journal.pk_health_issue,
    v_suppressed_hints_journal.src_pk,
    v_suppressed_hints_journal.src_table,
    v_suppressed_hints_journal.row_version,
    v_suppressed_hints_journal.health_issue,
    v_suppressed_hints_journal.issue_laterality,
    v_suppressed_hints_journal.issue_active,
    v_suppressed_hints_journal.issue_clinically_relevant,
    v_suppressed_hints_journal.issue_confidential,
    v_suppressed_hints_journal.episode,
    v_suppressed_hints_journal.episode_open,
    v_suppressed_hints_journal.encounter_started,
    v_suppressed_hints_journal.encounter_last_affirmed,
    v_suppressed_hints_journal.encounter_type,
    v_suppressed_hints_journal.encounter_l10n_type
   FROM clin.v_suppressed_hints_journal
UNION ALL
 SELECT v_external_care_journal.pk_patient,
    v_external_care_journal.modified_when,
    v_external_care_journal.clin_when,
    v_external_care_journal.modified_by,
    v_external_care_journal.soap_cat,
    v_external_care_journal.narrative,
    v_external_care_journal.pk_encounter,
    v_external_care_journal.pk_episode,
    v_external_care_journal.pk_health_issue,
    v_external_care_journal.src_pk,
    v_external_care_journal.src_table,
    v_external_care_journal.row_version,
    v_external_care_journal.health_issue,
    v_external_care_journal.issue_laterality,
    v_external_care_journal.issue_active,
    v_external_care_journal.issue_clinically_relevant,
    v_external_care_journal.issue_confidential,
    v_external_care_journal.episode,
    v_external_care_journal.episode_open,
    v_external_care_journal.encounter_started,
    v_external_care_journal.encounter_last_affirmed,
    v_external_care_journal.encounter_type,
    v_external_care_journal.encounter_l10n_type
   FROM clin.v_external_care_journal
UNION ALL
 SELECT v_edc_journal.pk_patient,
    v_edc_journal.modified_when,
    v_edc_journal.clin_when,
    v_edc_journal.modified_by,
    v_edc_journal.soap_cat,
    v_edc_journal.narrative,
    v_edc_journal.pk_encounter,
    v_edc_journal.pk_episode,
    v_edc_journal.pk_health_issue,
    v_edc_journal.src_pk,
    v_edc_journal.src_table,
    v_edc_journal.row_version,
    v_edc_journal.health_issue,
    v_edc_journal.issue_laterality,
    v_edc_journal.issue_active,
    v_edc_journal.issue_clinically_relevant,
    v_edc_journal.issue_confidential,
    v_edc_journal.episode,
    v_edc_journal.episode_open,
    v_edc_journal.encounter_started,
    v_edc_journal.encounter_last_affirmed,
    v_edc_journal.encounter_type,
    v_edc_journal.encounter_l10n_type
   FROM clin.v_edc_journal
UNION ALL
 SELECT v_reminders_journal.pk_patient,
    v_reminders_journal.modified_when,
    v_reminders_journal.clin_when,
    v_reminders_journal.modified_by,
    v_reminders_journal.soap_cat,
    v_reminders_journal.narrative,
    v_reminders_journal.pk_encounter,
    v_reminders_journal.pk_episode,
    v_reminders_journal.pk_health_issue,
    v_reminders_journal.src_pk,
    v_reminders_journal.src_table,
    v_reminders_journal.row_version,
    v_reminders_journal.health_issue,
    v_reminders_journal.issue_laterality,
    v_reminders_journal.issue_active,
    v_reminders_journal.issue_clinically_relevant,
    v_reminders_journal.issue_confidential,
    v_reminders_journal.episode,
    v_reminders_journal.episode_open,
    v_reminders_journal.encounter_started,
    v_reminders_journal.encounter_last_affirmed,
    v_reminders_journal.encounter_type,
    v_reminders_journal.encounter_l10n_type
   FROM clin.v_reminders_journal;


ALTER TABLE clin.v_emr_journal OWNER TO "gm-dbo";

--
-- Name: VIEW v_emr_journal; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_emr_journal IS 'Clinical patient data formatted into one string per
	 clinical entity even if it constains several user-
	 visible fields. Mainly useful for display as a simple
	 EMR journal.';


--
-- Name: _view_emr_journal_without_suppressed_hints; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin._view_emr_journal_without_suppressed_hints AS
 SELECT v_emr_journal.pk_patient,
    v_emr_journal.modified_when,
    v_emr_journal.clin_when,
    v_emr_journal.modified_by,
    v_emr_journal.soap_cat,
    v_emr_journal.narrative,
    v_emr_journal.pk_encounter,
    v_emr_journal.pk_episode,
    v_emr_journal.pk_health_issue,
    v_emr_journal.src_pk,
    v_emr_journal.src_table,
    v_emr_journal.row_version,
    v_emr_journal.health_issue,
    v_emr_journal.issue_laterality,
    v_emr_journal.issue_active,
    v_emr_journal.issue_clinically_relevant,
    v_emr_journal.issue_confidential,
    v_emr_journal.episode,
    v_emr_journal.episode_open,
    v_emr_journal.encounter_started,
    v_emr_journal.encounter_last_affirmed,
    v_emr_journal.encounter_type,
    v_emr_journal.encounter_l10n_type
   FROM clin.v_emr_journal
  WHERE (v_emr_journal.src_table <> 'clin.suppressed_hint'::text);


ALTER TABLE clin._view_emr_journal_without_suppressed_hints OWNER TO "gm-dbo";

--
-- Name: allergy_id_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.allergy_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.allergy_id_seq OWNER TO "gm-dbo";

--
-- Name: allergy_id_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.allergy_id_seq OWNED BY clin.allergy.pk;


--
-- Name: allergy_state_id_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.allergy_state_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.allergy_state_id_seq OWNER TO "gm-dbo";

--
-- Name: allergy_state_id_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.allergy_state_id_seq OWNED BY clin.allergy_state.pk;


--
-- Name: clin_aux_note; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.clin_aux_note (
    pk integer NOT NULL
)
INHERITS (clin.clin_root_item);


ALTER TABLE clin.clin_aux_note OWNER TO "gm-dbo";

--
-- Name: TABLE clin_aux_note; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.clin_aux_note IS 'Other tables link to this if they need more free text fields.';


--
-- Name: clin_aux_note_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.clin_aux_note_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.clin_aux_note_pk_seq OWNER TO "gm-dbo";

--
-- Name: clin_aux_note_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.clin_aux_note_pk_seq OWNED BY clin.clin_aux_note.pk;


--
-- Name: clin_diag; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.clin_diag (
    pk integer NOT NULL,
    fk_narrative integer NOT NULL,
    laterality character(1) DEFAULT NULL::bpchar,
    is_chronic boolean DEFAULT false NOT NULL,
    is_active boolean DEFAULT true NOT NULL,
    is_definite boolean DEFAULT false NOT NULL,
    clinically_relevant boolean DEFAULT true NOT NULL,
    CONSTRAINT clin_diag_laterality_check CHECK (((laterality = ANY (ARRAY['l'::bpchar, 'r'::bpchar, 'b'::bpchar, '?'::bpchar])) OR (laterality IS NULL))),
    CONSTRAINT if_active_then_relevant CHECK (((is_active = false) OR ((is_active = true) AND (clinically_relevant = true))))
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.clin_diag OWNER TO "gm-dbo";

--
-- Name: TABLE clin_diag; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.clin_diag IS 'stores additional detail on those clin.clin_narrative
	 rows where soap_cat=a that are true diagnoses,
	 true diagnoses DO have a code from one of the coding systems';


--
-- Name: COLUMN clin_diag.is_chronic; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.clin_diag.is_chronic IS 'whether this diagnosis is chronic, eg. no complete
	 cure is to be expected, regardless of whether it is
	 *active* right now (think of active/non-active phases
	 of Multiple Sclerosis which is sure chronic)';


--
-- Name: COLUMN clin_diag.is_active; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.clin_diag.is_active IS 'whether diagnosis is currently active or dormant';


--
-- Name: COLUMN clin_diag.clinically_relevant; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.clin_diag.clinically_relevant IS 'whether this diagnosis is considered clinically
	 relevant, eg. significant;
	 currently active diagnoses are considered to
	 always be relevant, while inactive ones may
	 or may not be';


--
-- Name: clin_diag_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.clin_diag_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.clin_diag_pk_seq OWNER TO "gm-dbo";

--
-- Name: clin_diag_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.clin_diag_pk_seq OWNED BY clin.clin_diag.pk;


--
-- Name: clin_hx_family_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.clin_hx_family_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.clin_hx_family_pk_seq OWNER TO "gm-dbo";

--
-- Name: clin_hx_family_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.clin_hx_family_pk_seq OWNED BY clin.family_history.pk;


--
-- Name: clin_item_type; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.clin_item_type (
    pk integer NOT NULL,
    type text DEFAULT 'history'::text NOT NULL,
    code text DEFAULT 'Hx'::text NOT NULL
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.clin_item_type OWNER TO "gm-dbo";

--
-- Name: TABLE clin_item_type; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.clin_item_type IS 'stores arbitrary types for tagging clinical items';


--
-- Name: COLUMN clin_item_type.type; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.clin_item_type.type IS 'the full name of the item type such as "family history"';


--
-- Name: COLUMN clin_item_type.code; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.clin_item_type.code IS 'shorthand for the type, eg "FHx"';


--
-- Name: clin_item_type_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.clin_item_type_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.clin_item_type_pk_seq OWNER TO "gm-dbo";

--
-- Name: clin_item_type_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.clin_item_type_pk_seq OWNED BY clin.clin_item_type.pk;


--
-- Name: clin_narrative_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.clin_narrative_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.clin_narrative_pk_seq OWNER TO "gm-dbo";

--
-- Name: clin_narrative_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.clin_narrative_pk_seq OWNED BY clin.clin_narrative.pk;


--
-- Name: clin_root_item_pk_item_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.clin_root_item_pk_item_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.clin_root_item_pk_item_seq OWNER TO "gm-dbo";

--
-- Name: clin_root_item_pk_item_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.clin_root_item_pk_item_seq OWNED BY clin.clin_root_item.pk_item;


--
-- Name: encounter_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.encounter_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.encounter_pk_seq OWNER TO "gm-dbo";

--
-- Name: encounter_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.encounter_pk_seq OWNED BY clin.encounter.pk;


--
-- Name: encounter_type_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.encounter_type_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.encounter_type_pk_seq OWNER TO "gm-dbo";

--
-- Name: encounter_type_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.encounter_type_pk_seq OWNED BY clin.encounter_type.pk;


--
-- Name: episode_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.episode_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.episode_pk_seq OWNER TO "gm-dbo";

--
-- Name: episode_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.episode_pk_seq OWNED BY clin.episode.pk;


--
-- Name: export_item; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.export_item (
    pk integer NOT NULL,
    fk_identity integer NOT NULL,
    created_by name DEFAULT "current_user"() NOT NULL,
    created_when timestamp with time zone DEFAULT statement_timestamp() NOT NULL,
    designation text,
    description text,
    fk_doc_obj integer,
    data bytea,
    filename text,
    CONSTRAINT clin_export_item_fk_obj_or_data CHECK ((((data IS NULL) AND (fk_doc_obj IS NOT NULL)) OR ((data IS NOT NULL) AND (fk_doc_obj IS NULL)))),
    CONSTRAINT clin_export_item_fk_obj_or_filename CHECK ((((filename IS NULL) AND (fk_doc_obj IS NOT NULL)) OR ((filename IS NOT NULL) AND (fk_doc_obj IS NULL)))),
    CONSTRAINT clin_export_item_sane_by CHECK ((length((created_by)::text) > 0)),
    CONSTRAINT clin_export_item_sane_data CHECK (((data IS NULL) OR (length(data) > 0))),
    CONSTRAINT clin_export_item_sane_description CHECK ((gm.is_null_or_blank_string(description) IS FALSE)),
    CONSTRAINT clin_export_item_sane_designation CHECK ((gm.is_null_or_non_empty_string(designation) IS TRUE)),
    CONSTRAINT clin_export_item_sane_filename CHECK ((gm.is_null_or_non_empty_string(filename) IS TRUE))
);


ALTER TABLE clin.export_item OWNER TO "gm-dbo";

--
-- Name: TABLE export_item; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.export_item IS 'A table to hold binary data for patients intended for export as print/mail/fax/removable media/...';


--
-- Name: COLUMN export_item.fk_identity; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.export_item.fk_identity IS 'the patient this item pertains to, DELETE does not cascade because we may have wanted to export data before deleting a patient ...';


--
-- Name: COLUMN export_item.created_by; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.export_item.created_by IS 'who put this item here';


--
-- Name: COLUMN export_item.created_when; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.export_item.created_when IS 'when was this item put here';


--
-- Name: COLUMN export_item.designation; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.export_item.designation IS 'the intended use for this item if any, say "print" for printing';


--
-- Name: COLUMN export_item.description; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.export_item.description IS 'a unique-per-patient description of the item';


--
-- Name: COLUMN export_item.fk_doc_obj; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.export_item.fk_doc_obj IS 'points to a document object';


--
-- Name: COLUMN export_item.data; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.export_item.data IS 'binary data representing the actual export item (unless fk_doc_obj points to a document object)';


--
-- Name: COLUMN export_item.filename; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.export_item.filename IS 'a filename, possibly from an import, if applicable, mainly used to please non-mime pseudo operating systems';


--
-- Name: export_item_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.export_item_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.export_item_pk_seq OWNER TO "gm-dbo";

--
-- Name: export_item_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.export_item_pk_seq OWNED BY clin.export_item.pk;


--
-- Name: external_care_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.external_care_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.external_care_pk_seq OWNER TO "gm-dbo";

--
-- Name: external_care_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.external_care_pk_seq OWNED BY clin.external_care.pk;


--
-- Name: fhx_relation_type_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.fhx_relation_type_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.fhx_relation_type_pk_seq OWNER TO "gm-dbo";

--
-- Name: fhx_relation_type_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.fhx_relation_type_pk_seq OWNED BY clin.fhx_relation_type.pk;


--
-- Name: form_data; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.form_data (
    pk integer NOT NULL,
    fk_instance integer NOT NULL,
    fk_form_field integer NOT NULL,
    value text NOT NULL
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.form_data OWNER TO "gm-dbo";

--
-- Name: TABLE form_data; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.form_data IS 'holds the values used in form instances, for
	 later re-use/validation';


--
-- Name: COLUMN form_data.fk_instance; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.form_data.fk_instance IS 'the form instance this value was used in';


--
-- Name: COLUMN form_data.fk_form_field; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.form_data.fk_form_field IS 'points to the definition of the field in the form
	 which in turn defines the place holder in the
	 template to replace with <value>';


--
-- Name: COLUMN form_data.value; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.form_data.value IS 'the value to replace the place holder with';


--
-- Name: form_data_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.form_data_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.form_data_pk_seq OWNER TO "gm-dbo";

--
-- Name: form_data_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.form_data_pk_seq OWNED BY clin.form_data.pk;


--
-- Name: form_instances; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.form_instances (
    pk integer NOT NULL,
    fk_form_def integer NOT NULL,
    form_name text NOT NULL,
    CONSTRAINT form_is_plan CHECK ((soap_cat = 'p'::text))
)
INHERITS (clin.clin_root_item);


ALTER TABLE clin.form_instances OWNER TO "gm-dbo";

--
-- Name: TABLE form_instances; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.form_instances IS 'instances of forms, like a log of all processed forms';


--
-- Name: COLUMN form_instances.narrative; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.form_instances.narrative IS 'can be used as a status field, eg. "printed", "faxed" etc.';


--
-- Name: COLUMN form_instances.fk_form_def; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.form_instances.fk_form_def IS 'points to the definition of this instance,
	 this FK will fail once we start separating services,
	 make it into a x_db_fk then';


--
-- Name: COLUMN form_instances.form_name; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.form_instances.form_name IS 'a string uniquely identifying the form template,
	 necessary for the audit trail';


--
-- Name: form_instances_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.form_instances_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.form_instances_pk_seq OWNER TO "gm-dbo";

--
-- Name: form_instances_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.form_instances_pk_seq OWNED BY clin.form_instances.pk;


--
-- Name: health_issue_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.health_issue_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.health_issue_pk_seq OWNER TO "gm-dbo";

--
-- Name: health_issue_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.health_issue_pk_seq OWNED BY clin.health_issue.pk;


--
-- Name: hospital_stay_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.hospital_stay_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.hospital_stay_pk_seq OWNER TO "gm-dbo";

--
-- Name: hospital_stay_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.hospital_stay_pk_seq OWNED BY clin.hospital_stay.pk;


--
-- Name: incoming_data_unmatchable; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.incoming_data_unmatchable (
    pk integer NOT NULL,
    fk_patient_candidates integer[],
    request_id text,
    firstnames text,
    lastnames text,
    dob date,
    postcode text,
    other_info text,
    type text,
    data bytea NOT NULL,
    gender text,
    requestor text,
    external_data_id text,
    fk_identity_disambiguated integer
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.incoming_data_unmatchable OWNER TO "gm-dbo";

--
-- Name: TABLE incoming_data_unmatchable; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.incoming_data_unmatchable IS 'this table holds test results that could not be matched
	 to any patient, it is intended to prevent overflow of
	 incoming_data_unmatched with unmatchable data';


--
-- Name: incoming_data_unmatchable_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.incoming_data_unmatchable_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.incoming_data_unmatchable_pk_seq OWNER TO "gm-dbo";

--
-- Name: incoming_data_unmatchable_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.incoming_data_unmatchable_pk_seq OWNED BY clin.incoming_data_unmatchable.pk;


--
-- Name: incoming_data_unmatched; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.incoming_data_unmatched (
    pk integer NOT NULL,
    fk_patient_candidates integer[],
    request_id text,
    firstnames text,
    lastnames text,
    dob date,
    postcode text,
    other_info text,
    type text,
    data bytea NOT NULL,
    gender text,
    requestor text,
    external_data_id text,
    fk_identity_disambiguated integer,
    comment text,
    fk_provider_disambiguated integer,
    CONSTRAINT unmatched_data_sane_comment CHECK ((gm.is_null_or_non_empty_string(comment) IS TRUE))
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.incoming_data_unmatched OWNER TO "gm-dbo";

--
-- Name: TABLE incoming_data_unmatched; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.incoming_data_unmatched IS 'this table holds incoming data (lab results, documents)
	 that could not be matched to one single patient automatically,
	 it is intended to facilitate manual matching,
	 - use "modified_when" for import time';


--
-- Name: COLUMN incoming_data_unmatched.fk_patient_candidates; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.incoming_data_unmatched.fk_patient_candidates IS 'a matching algorithm can be applied to produce
	 a list of likely candidate patients, the question
	 remains whether this should not be done at runtime';


--
-- Name: COLUMN incoming_data_unmatched.request_id; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.incoming_data_unmatched.request_id IS 'request ID as found in <data>';


--
-- Name: COLUMN incoming_data_unmatched.firstnames; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.incoming_data_unmatched.firstnames IS 'first names as found in <data>';


--
-- Name: COLUMN incoming_data_unmatched.lastnames; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.incoming_data_unmatched.lastnames IS 'last names as found in <data>';


--
-- Name: COLUMN incoming_data_unmatched.dob; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.incoming_data_unmatched.dob IS 'date of birth as found in <data>';


--
-- Name: COLUMN incoming_data_unmatched.postcode; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.incoming_data_unmatched.postcode IS 'postcode as found in <data>';


--
-- Name: COLUMN incoming_data_unmatched.other_info; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.incoming_data_unmatched.other_info IS 'other identifying information as found in <data>';


--
-- Name: COLUMN incoming_data_unmatched.type; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.incoming_data_unmatched.type IS 'the type of <data>, eg HL7, LDT, ...,
	 useful for selecting an importer';


--
-- Name: COLUMN incoming_data_unmatched.data; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.incoming_data_unmatched.data IS 'the raw data';


--
-- Name: COLUMN incoming_data_unmatched.gender; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.incoming_data_unmatched.gender IS 'Gender of patient in source data if available.';


--
-- Name: COLUMN incoming_data_unmatched.requestor; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.incoming_data_unmatched.requestor IS 'Requestor of data (e.g. who ordered test results) if available in source data.';


--
-- Name: COLUMN incoming_data_unmatched.external_data_id; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.incoming_data_unmatched.external_data_id IS 'ID of content of .data in external system (e.g. importer) where appropriate';


--
-- Name: COLUMN incoming_data_unmatched.fk_identity_disambiguated; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.incoming_data_unmatched.fk_identity_disambiguated IS 'ID of patient the data is judged to really belong to.';


--
-- Name: COLUMN incoming_data_unmatched.comment; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.incoming_data_unmatched.comment IS 'a free text comment on this row, eg. why is it here';


--
-- Name: COLUMN incoming_data_unmatched.fk_provider_disambiguated; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.incoming_data_unmatched.fk_provider_disambiguated IS 'The provider the data is relevant to.';


--
-- Name: incoming_data_unmatched_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.incoming_data_unmatched_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.incoming_data_unmatched_pk_seq OWNER TO "gm-dbo";

--
-- Name: incoming_data_unmatched_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.incoming_data_unmatched_pk_seq OWNED BY clin.incoming_data_unmatched.pk;


--
-- Name: lab_request; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.lab_request (
    pk integer NOT NULL,
    fk_test_org integer,
    request_id text NOT NULL,
    fk_requestor integer,
    lab_request_id text,
    lab_rxd_when timestamp with time zone,
    results_reported_when timestamp with time zone,
    request_status text NOT NULL,
    is_pending boolean DEFAULT true NOT NULL,
    diagnostic_service_section text,
    ordered_service text,
    note_test_org text,
    CONSTRAINT clin_lab_req_sane_test_org_note CHECK ((gm.is_null_or_non_empty_string(note_test_org) IS TRUE)),
    CONSTRAINT lab_request_request_id_check CHECK ((btrim(request_id) <> ''::text)),
    CONSTRAINT lab_request_request_status_check CHECK ((request_status = ANY (ARRAY['pending'::text, 'preliminary'::text, 'partial'::text, 'final'::text])))
)
INHERITS (clin.clin_root_item);


ALTER TABLE clin.lab_request OWNER TO "gm-dbo";

--
-- Name: TABLE lab_request; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.lab_request IS 'test request metadata';


--
-- Name: COLUMN lab_request.clin_when; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lab_request.clin_when IS 'the time the sample for this request was taken
	 LDT: 8432:8433
	 HL7: OBR.quantity_timing';


--
-- Name: COLUMN lab_request.narrative; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lab_request.narrative IS 'free text comment on request';


--
-- Name: COLUMN lab_request.request_id; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lab_request.request_id IS 'ID this request had when sent to the lab
	 LDT: 8310
	 HL7: OBR.filler_order_number';


--
-- Name: COLUMN lab_request.fk_requestor; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lab_request.fk_requestor IS 'who requested the test - really needed ?';


--
-- Name: COLUMN lab_request.lab_request_id; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lab_request.lab_request_id IS 'ID this request had internally at the lab
	 LDT: 8311';


--
-- Name: COLUMN lab_request.lab_rxd_when; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lab_request.lab_rxd_when IS 'when did the lab receive the request+sample
	 LDT: 8301
	 HL7: OBR.requested_date_time';


--
-- Name: COLUMN lab_request.results_reported_when; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lab_request.results_reported_when IS 'when was the report on the result generated,
	LDT: 8302
	HL7: OBR.results_report_status_change';


--
-- Name: COLUMN lab_request.request_status; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lab_request.request_status IS 'pending, final, preliminary, partial
	 LDT: 8401';


--
-- Name: COLUMN lab_request.is_pending; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lab_request.is_pending IS 'true if any (even partial) results are still pending';


--
-- Name: COLUMN lab_request.diagnostic_service_section; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lab_request.diagnostic_service_section IS 'The (section of) the diagnostic service which performed the test.
- HL7 2.3: OBR:24 Diagnostic Service Section ID
- somewhat redundant with fk_test_org, which, however,
  points to more normalized data';


--
-- Name: COLUMN lab_request.ordered_service; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lab_request.ordered_service IS 'The (battery of) test(s)/service(s) ordered.
- HL7 2.3: OBR:4 Universal Service ID';


--
-- Name: COLUMN lab_request.note_test_org; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lab_request.note_test_org IS 'A comment on this lab request by the performing organization (lab).';


--
-- Name: lab_request_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.lab_request_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.lab_request_pk_seq OWNER TO "gm-dbo";

--
-- Name: lab_request_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.lab_request_pk_seq OWNED BY clin.lab_request.pk;


--
-- Name: lnk_code2aoe_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.lnk_code2aoe_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.lnk_code2aoe_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_code2aoe_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.lnk_code2aoe_pk_seq OWNED BY clin.lnk_code2aoe.pk;


--
-- Name: lnk_code2episode_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.lnk_code2episode_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.lnk_code2episode_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_code2episode_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.lnk_code2episode_pk_seq OWNED BY clin.lnk_code2episode.pk;


--
-- Name: lnk_code2fhx_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.lnk_code2fhx_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.lnk_code2fhx_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_code2fhx_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.lnk_code2fhx_pk_seq OWNED BY clin.lnk_code2fhx.pk;


--
-- Name: lnk_code2h_issue_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.lnk_code2h_issue_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.lnk_code2h_issue_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_code2h_issue_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.lnk_code2h_issue_pk_seq OWNED BY clin.lnk_code2h_issue.pk;


--
-- Name: lnk_code2item_root_pk_lnk_code2item_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.lnk_code2item_root_pk_lnk_code2item_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.lnk_code2item_root_pk_lnk_code2item_seq OWNER TO "gm-dbo";

--
-- Name: lnk_code2item_root_pk_lnk_code2item_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.lnk_code2item_root_pk_lnk_code2item_seq OWNED BY clin.lnk_code2item_root.pk_lnk_code2item;


--
-- Name: lnk_code2narrative; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.lnk_code2narrative (
    pk integer NOT NULL
)
INHERITS (clin.lnk_code2item_root);
ALTER TABLE ONLY clin.lnk_code2narrative ALTER COLUMN fk_generic_code SET NOT NULL;


ALTER TABLE clin.lnk_code2narrative OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_code2narrative; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.lnk_code2narrative IS 'Links codes to SOAP narrative.';


--
-- Name: COLUMN lnk_code2narrative.fk_generic_code; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2narrative.fk_generic_code IS 'Custom foreign key to ref.coding_system_root.';


--
-- Name: COLUMN lnk_code2narrative.fk_item; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2narrative.fk_item IS 'Foreign key to clin.clin_narrative';


--
-- Name: lnk_code2narrative_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.lnk_code2narrative_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.lnk_code2narrative_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_code2narrative_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.lnk_code2narrative_pk_seq OWNED BY clin.lnk_code2narrative.pk;


--
-- Name: lnk_code2procedure_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.lnk_code2procedure_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.lnk_code2procedure_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_code2procedure_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.lnk_code2procedure_pk_seq OWNED BY clin.lnk_code2procedure.pk;


--
-- Name: lnk_code2rfe_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.lnk_code2rfe_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.lnk_code2rfe_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_code2rfe_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.lnk_code2rfe_pk_seq OWNED BY clin.lnk_code2rfe.pk;


--
-- Name: lnk_code2tst_pnl; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.lnk_code2tst_pnl (
    pk integer NOT NULL
)
INHERITS (clin.lnk_code2item_root);
ALTER TABLE ONLY clin.lnk_code2tst_pnl ALTER COLUMN fk_generic_code SET NOT NULL;


ALTER TABLE clin.lnk_code2tst_pnl OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_code2tst_pnl; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.lnk_code2tst_pnl IS 'Links codes to test panels.';


--
-- Name: COLUMN lnk_code2tst_pnl.fk_generic_code; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2tst_pnl.fk_generic_code IS 'Custom foreign key to ref.coding_system_root.';


--
-- Name: COLUMN lnk_code2tst_pnl.fk_item; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_code2tst_pnl.fk_item IS 'Foreign key to clin.test_panel';


--
-- Name: lnk_code2tst_pnl_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.lnk_code2tst_pnl_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.lnk_code2tst_pnl_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_code2tst_pnl_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.lnk_code2tst_pnl_pk_seq OWNED BY clin.lnk_code2tst_pnl.pk;


--
-- Name: lnk_constraint2vacc_course; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.lnk_constraint2vacc_course (
    pk integer NOT NULL,
    fk_vaccination_course integer NOT NULL,
    fk_constraint integer NOT NULL
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.lnk_constraint2vacc_course OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_constraint2vacc_course; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.lnk_constraint2vacc_course IS 'links constraints to courses';


--
-- Name: lnk_constraint2vacc_course_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.lnk_constraint2vacc_course_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.lnk_constraint2vacc_course_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_constraint2vacc_course_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.lnk_constraint2vacc_course_pk_seq OWNED BY clin.lnk_constraint2vacc_course.pk;


--
-- Name: lnk_loinc2test_panel_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.lnk_loinc2test_panel_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.lnk_loinc2test_panel_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_loinc2test_panel_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.lnk_loinc2test_panel_pk_seq OWNED BY clin.lnk_loinc2test_panel.pk;


--
-- Name: lnk_pat2vaccination_course; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.lnk_pat2vaccination_course (
    pk integer NOT NULL,
    fk_patient integer NOT NULL,
    fk_course integer NOT NULL
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.lnk_pat2vaccination_course OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_pat2vaccination_course; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.lnk_pat2vaccination_course IS 'links patients to vaccination courses they are actually on,
	 this allows for per-patient selection of courses to be
	 followed, eg. children at different ages may be on different
	 vaccination courses or some people are on a course due
	 to a trip abroad while most others are not';


--
-- Name: lnk_pat2vaccination_course_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.lnk_pat2vaccination_course_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.lnk_pat2vaccination_course_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_pat2vaccination_course_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.lnk_pat2vaccination_course_pk_seq OWNED BY clin.lnk_pat2vaccination_course.pk;


--
-- Name: lnk_substance2episode; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.lnk_substance2episode (
    pk integer NOT NULL,
    fk_episode integer,
    fk_substance integer
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.lnk_substance2episode OWNER TO "gm-dbo";

--
-- Name: lnk_substance2episode_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.lnk_substance2episode_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.lnk_substance2episode_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_substance2episode_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.lnk_substance2episode_pk_seq OWNED BY clin.lnk_substance2episode.pk;


--
-- Name: lnk_tst2norm; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.lnk_tst2norm (
    id integer NOT NULL,
    id_test integer NOT NULL,
    id_norm integer NOT NULL
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.lnk_tst2norm OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_tst2norm; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.lnk_tst2norm IS 'links test result evaluation norms to tests';


--
-- Name: COLUMN lnk_tst2norm.id_test; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_tst2norm.id_test IS 'which test does the linked norm apply to';


--
-- Name: COLUMN lnk_tst2norm.id_norm; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_tst2norm.id_norm IS 'the norm to apply to the linked test';


--
-- Name: lnk_tst2norm_id_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.lnk_tst2norm_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.lnk_tst2norm_id_seq OWNER TO "gm-dbo";

--
-- Name: lnk_tst2norm_id_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.lnk_tst2norm_id_seq OWNED BY clin.lnk_tst2norm.id;


--
-- Name: lnk_type2item; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.lnk_type2item (
    pk integer NOT NULL,
    fk_type integer NOT NULL,
    fk_item integer NOT NULL
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.lnk_type2item OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_type2item; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.lnk_type2item IS 'allow to link many-to-many between clin.clin_root_item and clin.clin_item_type';


--
-- Name: COLUMN lnk_type2item.fk_item; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.lnk_type2item.fk_item IS 'the item this type is linked to,
	 since PostgreSQL apparently cannot reference a value
	 inserted from a child table (?) we must simulate
	 referential integrity checks with a custom trigger,
	 this, however, does not deal with update/delete
	 cascading :-(';


--
-- Name: lnk_type2item_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.lnk_type2item_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.lnk_type2item_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_type2item_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.lnk_type2item_pk_seq OWNED BY clin.lnk_type2item.pk;


--
-- Name: lnk_vaccination_course2schedule; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.lnk_vaccination_course2schedule (
    pk integer NOT NULL,
    fk_course integer NOT NULL,
    fk_schedule integer NOT NULL
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.lnk_vaccination_course2schedule OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_vaccination_course2schedule; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.lnk_vaccination_course2schedule IS 'this table links vaccination courses for a single epitope
	 into schedules defined and recommended by a vaccination
	 council or similar entity';


--
-- Name: lnk_vaccination_course2schedule_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.lnk_vaccination_course2schedule_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.lnk_vaccination_course2schedule_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_vaccination_course2schedule_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.lnk_vaccination_course2schedule_pk_seq OWNED BY clin.lnk_vaccination_course2schedule.pk;


--
-- Name: patient_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.patient_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.patient_pk_seq OWNER TO "gm-dbo";

--
-- Name: patient_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.patient_pk_seq OWNED BY clin.patient.pk;


--
-- Name: procedure_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.procedure_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.procedure_pk_seq OWNER TO "gm-dbo";

--
-- Name: procedure_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.procedure_pk_seq OWNED BY clin.procedure.pk;


--
-- Name: review_root_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.review_root_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.review_root_pk_seq OWNER TO "gm-dbo";

--
-- Name: review_root_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.review_root_pk_seq OWNED BY clin.review_root.pk;


--
-- Name: soap_cat_ranks; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.soap_cat_ranks (
    pk integer NOT NULL,
    rank integer NOT NULL,
    soap_cat character(1),
    CONSTRAINT clin_soap_cat_ranks_sane_cats CHECK (((soap_cat IS NULL) OR (soap_cat = ANY (ARRAY['s'::bpchar, 'o'::bpchar, 'a'::bpchar, 'p'::bpchar, 'u'::bpchar])))),
    CONSTRAINT clin_soap_cat_ranks_sane_ranks CHECK ((rank = ANY (ARRAY[1, 2, 3, 4, 5, 6])))
);


ALTER TABLE clin.soap_cat_ranks OWNER TO "gm-dbo";

--
-- Name: soap_cat_ranks_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.soap_cat_ranks_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.soap_cat_ranks_pk_seq OWNER TO "gm-dbo";

--
-- Name: soap_cat_ranks_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.soap_cat_ranks_pk_seq OWNED BY clin.soap_cat_ranks.pk;


--
-- Name: substance_intake_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.substance_intake_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.substance_intake_pk_seq OWNER TO "gm-dbo";

--
-- Name: substance_intake_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.substance_intake_pk_seq OWNED BY clin.substance_intake.pk;


--
-- Name: suppressed_hint_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.suppressed_hint_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.suppressed_hint_pk_seq OWNER TO "gm-dbo";

--
-- Name: suppressed_hint_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.suppressed_hint_pk_seq OWNED BY clin.suppressed_hint.pk;


--
-- Name: test_org_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.test_org_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.test_org_pk_seq OWNER TO "gm-dbo";

--
-- Name: test_org_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.test_org_pk_seq OWNED BY clin.test_org.pk;


--
-- Name: test_panel_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.test_panel_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.test_panel_pk_seq OWNER TO "gm-dbo";

--
-- Name: test_panel_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.test_panel_pk_seq OWNED BY clin.test_panel.pk;


--
-- Name: test_result_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.test_result_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.test_result_pk_seq OWNER TO "gm-dbo";

--
-- Name: test_result_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.test_result_pk_seq OWNED BY clin.test_result.pk;


--
-- Name: test_type_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.test_type_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.test_type_pk_seq OWNER TO "gm-dbo";

--
-- Name: test_type_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.test_type_pk_seq OWNED BY clin.test_type.pk;


--
-- Name: test_type_unified_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.test_type_unified_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.test_type_unified_pk_seq OWNER TO "gm-dbo";

--
-- Name: test_type_unified_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.test_type_unified_pk_seq OWNED BY clin.meta_test_type.pk;


--
-- Name: v_candidate_diagnoses; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_candidate_diagnoses AS
 SELECT ( SELECT c_enc.fk_patient
           FROM clin.encounter c_enc
          WHERE (c_enc.pk = c_hi.fk_encounter)) AS pk_patient,
    (c_hi.description || COALESCE(((' ('::text || (c_hi.laterality)::text) || ')'::text), ''::text)) AS diagnosis,
    c_hi.is_confidential AS explicitely_confidential,
    c_hi.diagnostic_certainty_classification,
    'clin.health_issue'::text AS source
   FROM clin.health_issue c_hi
UNION ALL
 SELECT ( SELECT c_enc.fk_patient
           FROM clin.encounter c_enc
          WHERE (c_enc.pk = c_epi.fk_encounter)) AS pk_patient,
    c_epi.description AS diagnosis,
    COALESCE(( SELECT c_hi.is_confidential
           FROM clin.health_issue c_hi
          WHERE (c_hi.pk = c_epi.fk_health_issue)), false) AS explicitely_confidential,
    c_epi.diagnostic_certainty_classification,
    'clin.episode'::text AS source
   FROM clin.episode c_epi
  WHERE (c_epi.is_open IS TRUE)
UNION ALL
 SELECT c_enc.fk_patient AS pk_patient,
    c_enc.assessment_of_encounter AS diagnosis,
    false AS explicitely_confidential,
    NULL::text AS diagnostic_certainty_classification,
    'clin.encounter'::text AS source
   FROM clin.encounter c_enc
  WHERE ((c_enc.assessment_of_encounter IS NOT NULL) AND (c_enc.pk IN ( SELECT c_cri.fk_encounter
           FROM clin.clin_root_item c_cri
          WHERE (c_cri.fk_episode IN ( SELECT c_epi.pk
                   FROM clin.episode c_epi
                  WHERE (c_epi.is_open IS TRUE))))))
UNION ALL
 SELECT ( SELECT c_enc.fk_patient
           FROM clin.encounter c_enc
          WHERE (c_enc.pk = c_cn.fk_encounter)) AS pk_patient,
    c_cn.narrative AS diagnosis,
    false AS explicitely_confidential,
    NULL::text AS diagnostic_certainty_classification,
    'clin.clin_narrative'::text AS source
   FROM clin.clin_narrative c_cn
  WHERE ((c_cn.soap_cat = 'a'::text) AND (c_cn.fk_episode IN ( SELECT c_epi.pk
           FROM clin.episode c_epi
          WHERE (c_epi.is_open IS TRUE))));


ALTER TABLE clin.v_candidate_diagnoses OWNER TO "gm-dbo";

--
-- Name: VIEW v_candidate_diagnoses; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_candidate_diagnoses IS 'Candidates for diagnoses.';


--
-- Name: marital_status; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.marital_status (
    pk integer NOT NULL,
    name text NOT NULL
);


ALTER TABLE dem.marital_status OWNER TO "gm-dbo";

--
-- Name: v_all_persons; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_all_persons AS
 SELECT d_i.pk AS pk_identity,
    d_i.title,
    d_n.firstnames,
    d_n.preferred,
    d_n.lastnames,
    d_i.gender,
    public._(d_i.gender) AS l10n_gender,
    d_i.dob AS dob_only,
    (date_trunc('day'::text, d_i.dob) + (COALESCE(d_i.tob, (d_i.dob)::time without time zone))::interval) AS dob,
    d_i.tob,
    d_i.deceased,
    COALESCE(d_ms.name, 'unknown'::text) AS marital_status,
    public._(COALESCE(d_ms.name, 'unknown'::text)) AS l10n_marital_status,
    d_i.emergency_contact,
    d_i.comment,
    d_i.deleted AS is_deleted,
    d_i.fk_marital_status AS pk_marital_status,
    d_n.id AS pk_active_name,
    d_i.fk_emergency_contact AS pk_emergency_contact,
    d_i.fk_primary_provider AS pk_primary_provider,
    d_i.xmin AS xmin_identity,
    d_i.dob_is_estimated
   FROM ((dem.identity d_i
     JOIN dem.names d_n ON (((d_n.id_identity = d_i.pk) AND (d_n.active IS TRUE))))
     LEFT JOIN dem.marital_status d_ms ON ((d_i.fk_marital_status = d_ms.pk)));


ALTER TABLE dem.v_all_persons OWNER TO "gm-dbo";

--
-- Name: VIEW v_all_persons; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_all_persons IS 'This view denormalizes persons with their active name.';


--
-- Name: v_export_items; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_export_items AS
 SELECT inner_export_items.pk_export_item,
    inner_export_items.pk_identity,
    inner_export_items.created_by,
    inner_export_items.created_when,
    inner_export_items.designation,
    inner_export_items.description,
    inner_export_items.pk_doc_obj,
    inner_export_items.md5_sum,
    inner_export_items.size,
    inner_export_items.filename,
    inner_export_items.pk_identity_raw,
    inner_export_items.xmin_export_item,
    (inner_export_items.pk_identity IS DISTINCT FROM inner_export_items.pk_identity_raw) AS pk_identity_raw_needs_update,
    d_vp.title,
    d_vp.firstnames,
    d_vp.lastnames,
    d_vp.preferred,
    d_vp.gender,
    d_vp.dob
   FROM (( SELECT c_ei.pk AS pk_export_item,
                CASE
                    WHEN (c_ei.fk_doc_obj IS NULL) THEN c_ei.fk_identity
                    ELSE ( SELECT encounter.fk_patient
                       FROM clin.encounter
                      WHERE (encounter.pk = ( SELECT doc_med.fk_encounter
                               FROM blobs.doc_med
                              WHERE (doc_med.pk = ( SELECT doc_obj.fk_doc
                                       FROM blobs.doc_obj
                                      WHERE (doc_obj.pk = c_ei.fk_doc_obj))))))
                END AS pk_identity,
            COALESCE(( SELECT staff.short_alias
                   FROM dem.staff
                  WHERE (staff.db_user = c_ei.created_by)), (c_ei.created_by)::text) AS created_by,
            c_ei.created_when,
            c_ei.designation,
            c_ei.description,
            c_ei.fk_doc_obj AS pk_doc_obj,
            md5(COALESCE(c_ei.data, COALESCE(( SELECT b_do.data
                   FROM blobs.doc_obj b_do
                  WHERE (b_do.pk = c_ei.fk_doc_obj)), '\x'::bytea))) AS md5_sum,
            octet_length(COALESCE(c_ei.data, '\x'::bytea)) AS size,
            COALESCE(c_ei.filename, ( SELECT b_do.filename
                   FROM blobs.doc_obj b_do
                  WHERE (b_do.pk = c_ei.fk_doc_obj))) AS filename,
            c_ei.fk_identity AS pk_identity_raw,
            c_ei.xmin AS xmin_export_item
           FROM clin.export_item c_ei) inner_export_items
     JOIN dem.v_all_persons d_vp ON ((d_vp.pk_identity = inner_export_items.pk_identity)));


ALTER TABLE clin.v_export_items OWNER TO "gm-dbo";

--
-- Name: v_external_care; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_external_care AS
 SELECT c_ec.pk AS pk_external_care,
    ( SELECT encounter.fk_patient
           FROM clin.encounter
          WHERE (encounter.pk = c_ec.fk_encounter)) AS pk_identity,
    COALESCE(c_ec.issue, c_hi.description) AS issue,
    c_ec.provider,
    d_ou.description AS unit,
    d_o.description AS organization,
    c_ec.comment,
    c_ec.inactive,
    c_ec.fk_health_issue AS pk_health_issue,
    c_ec.fk_org_unit AS pk_org_unit,
    c_ec.fk_encounter AS pk_encounter,
    c_ec.xmin AS xmin_external_care,
    c_ec.modified_when,
    c_ec.modified_by,
    c_ec.row_version
   FROM (((clin.external_care c_ec
     LEFT JOIN clin.health_issue c_hi ON ((c_hi.pk = c_ec.fk_health_issue)))
     LEFT JOIN dem.org_unit d_ou ON ((c_ec.fk_org_unit = d_ou.pk)))
     LEFT JOIN dem.org d_o ON ((d_ou.fk_org = d_o.pk)));


ALTER TABLE clin.v_external_care OWNER TO "gm-dbo";

--
-- Name: v_family_history; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_family_history AS
 SELECT c_fh.pk AS pk_family_history,
    cenc.fk_patient AS pk_patient,
    c_fh.soap_cat,
    c_fhrt.description AS relation,
    public._(c_fhrt.description) AS l10n_relation,
    c_fh.narrative AS condition,
    c_fh.age_noted,
    c_fh.age_of_death,
    c_fh.contributed_to_death,
    c_fh.comment,
    cep.description AS episode,
    c_fh.clin_when AS when_known_to_patient,
    c_fh.name_relative,
    c_fh.dob_relative,
    c_fhrt.is_genetic AS is_genetic_relative,
    c_fh.fk_encounter AS pk_encounter,
    c_fh.fk_episode AS pk_episode,
    cep.fk_health_issue AS pk_health_issue,
    c_fhrt.pk AS pk_fhx_relation_type,
    c_fh.modified_when,
    COALESCE(( SELECT array_agg(c_lc2fhx.fk_generic_code) AS array_agg
           FROM clin.lnk_code2fhx c_lc2fhx
          WHERE (c_lc2fhx.fk_item = c_fh.pk)), ARRAY[]::integer[]) AS pk_generic_codes,
    c_fh.xmin AS xmin_family_history
   FROM (((clin.family_history c_fh
     JOIN clin.encounter cenc ON ((c_fh.fk_encounter = cenc.pk)))
     JOIN clin.episode cep ON ((c_fh.fk_episode = cep.pk)))
     LEFT JOIN clin.fhx_relation_type c_fhrt ON ((c_fh.fk_relation_type = c_fhrt.pk)));


ALTER TABLE clin.v_family_history OWNER TO "gm-dbo";

--
-- Name: VIEW v_family_history; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_family_history IS 'family history denormalized';


--
-- Name: v_health_issues; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_health_issues AS
 SELECT ( SELECT encounter.fk_patient
           FROM clin.encounter
          WHERE (encounter.pk = c_hi.fk_encounter)) AS pk_patient,
    c_hi.pk AS pk_health_issue,
    c_hi.description,
    c_hi.summary,
    c_hi.laterality,
    c_hi.age_noted,
    c_hi.is_active,
    c_hi.clinically_relevant,
    c_hi.is_confidential,
    c_hi.is_cause_of_death,
    c_hi.fk_encounter AS pk_encounter,
    c_hi.modified_when,
    c_hi.modified_by,
    c_hi.row_version,
    c_hi."grouping",
    c_hi.diagnostic_certainty_classification,
    (EXISTS ( SELECT 1
           FROM clin.episode c_ep
          WHERE ((c_ep.fk_health_issue = c_hi.pk) AND (c_ep.is_open IS TRUE))
         LIMIT 1)) AS has_open_episode,
    COALESCE(( SELECT array_agg(c_lc2h.fk_generic_code) AS array_agg
           FROM clin.lnk_code2h_issue c_lc2h
          WHERE (c_lc2h.fk_item = c_hi.pk)), ARRAY[]::integer[]) AS pk_generic_codes,
    c_hi.xmin AS xmin_health_issue
   FROM clin.health_issue c_hi;


ALTER TABLE clin.v_health_issues OWNER TO "gm-dbo";

--
-- Name: v_hospital_stays; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_hospital_stays AS
 SELECT c_hs.pk AS pk_hospital_stay,
    ( SELECT encounter.fk_patient
           FROM clin.encounter
          WHERE (encounter.pk = c_hs.fk_encounter)) AS pk_patient,
    d_o.description AS hospital,
    d_ou.description AS ward,
    c_hs.narrative AS comment,
    c_hs.clin_when AS admission,
    c_hs.discharge,
    c_hs.soap_cat,
    c_e.description AS episode,
    c_hi.description AS health_issue,
    c_hs.fk_encounter AS pk_encounter,
    c_hs.fk_episode AS pk_episode,
    c_hi.pk AS pk_health_issue,
    c_hs.fk_org_unit AS pk_org_unit,
    d_o.pk AS pk_org,
    COALESCE(( SELECT array_agg(b_dm.pk) AS array_agg
           FROM blobs.doc_med b_dm
          WHERE (b_dm.fk_hospital_stay = c_hs.pk)), ARRAY[]::integer[]) AS pk_documents,
    c_hs.modified_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_hs.modified_by)), (('<'::text || (c_hs.modified_by)::text) || '>'::text)) AS modified_by,
    c_hs.row_version,
    c_hs.xmin AS xmin_hospital_stay
   FROM ((((clin.hospital_stay c_hs
     LEFT JOIN clin.episode c_e ON ((c_e.pk = c_hs.fk_episode)))
     LEFT JOIN clin.health_issue c_hi ON ((c_hi.pk = c_e.fk_health_issue)))
     LEFT JOIN dem.org_unit d_ou ON ((d_ou.pk = c_hs.fk_org_unit)))
     LEFT JOIN dem.org d_o ON ((d_o.pk = d_ou.fk_org)));


ALTER TABLE clin.v_hospital_stays OWNER TO "gm-dbo";

--
-- Name: v_incoming_data_unmatched; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_incoming_data_unmatched AS
 SELECT c_idu.pk AS pk_incoming_data_unmatched,
    c_idu.fk_patient_candidates AS pk_patient_candidates,
    c_idu.firstnames,
    c_idu.lastnames,
    c_idu.dob,
    c_idu.gender,
    c_idu.postcode,
    c_idu.other_info,
    c_idu.request_id,
    c_idu.requestor,
    c_idu.external_data_id,
    c_idu.comment,
    c_idu.fk_identity_disambiguated AS pk_identity_disambiguated,
    c_idu.fk_provider_disambiguated AS pk_provider_disambiguated,
    c_idu.type AS data_type,
    md5(c_idu.data) AS md5_sum,
    octet_length(c_idu.data) AS data_size,
    c_idu.xmin AS xmin_incoming_data_unmatched
   FROM clin.incoming_data_unmatched c_idu;


ALTER TABLE clin.v_incoming_data_unmatched OWNER TO "gm-dbo";

--
-- Name: VIEW v_incoming_data_unmatched; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_incoming_data_unmatched IS 'Shows incoming data but w/o the data field.';


--
-- Name: v_linked_codes; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_linked_codes AS
 SELECT c_lc2ir.fk_item AS pk_item,
    (c_lc2ir.tableoid)::regclass AS item_table,
    (r_csr.code || COALESCE(c_lc2ir.code_modifier, ''::text)) AS code,
    r_csr.code AS base_code,
    c_lc2ir.code_modifier,
    r_csr.term,
    r_ds.name_long,
    r_ds.name_short,
    r_ds.version,
    r_ds.lang,
    (r_csr.tableoid)::regclass AS code_table,
    r_csr.pk_coding_system AS pk_generic_code,
    r_csr.fk_data_source AS pk_data_source,
    c_lc2ir.pk_lnk_code2item
   FROM ((clin.lnk_code2item_root c_lc2ir
     JOIN ref.coding_system_root r_csr ON ((r_csr.pk_coding_system = c_lc2ir.fk_generic_code)))
     JOIN ref.data_source r_ds ON ((r_ds.pk = r_csr.fk_data_source)));


ALTER TABLE clin.v_linked_codes OWNER TO "gm-dbo";

--
-- Name: VIEW v_linked_codes; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_linked_codes IS 'Denormalized codes linked to EMR structures.';


--
-- Name: v_most_recent_encounters; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_most_recent_encounters AS
 SELECT ce1.pk AS pk_encounter,
    ce1.fk_patient AS pk_patient,
    ce1.reason_for_encounter,
    ce1.assessment_of_encounter,
    et.description AS type,
    public._(et.description) AS l10n_type,
    ce1.started,
    ce1.last_affirmed,
    ce1.fk_type AS pk_type,
    ce1.fk_location AS pk_location
   FROM clin.encounter ce1,
    clin.encounter_type et
  WHERE ((ce1.fk_type = et.pk) AND (ce1.started = ( SELECT max(ce2.started) AS max
           FROM clin.encounter ce2
          WHERE (ce2.last_affirmed = ( SELECT max(ce3.last_affirmed) AS max
                   FROM clin.encounter ce3
                  WHERE (ce3.fk_patient = ce1.fk_patient)))
         LIMIT 1)));


ALTER TABLE clin.v_most_recent_encounters OWNER TO "gm-dbo";

--
-- Name: VIEW v_most_recent_encounters; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_most_recent_encounters IS 'Lists the most recent encounters per patient. Logic of "most recent" 
	is: for a patient: 
	 1) select encounters with latest "last_affirmed",
	 2) from those select encounters with latest "started"
	 3) limit those to 1 if there are duplicates (same start and end of encounter!)';


--
-- Name: v_narrative; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_narrative AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_n.clin_when AS date,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_n.modified_by)), (('<'::text || (c_n.modified_by)::text) || '>'::text)) AS modified_by,
    c_n.soap_cat,
    c_n.narrative,
    c_epi.description AS episode,
    c_hi.description AS health_issue,
    c_n.pk_item,
    c_n.pk AS pk_narrative,
    c_epi.fk_health_issue AS pk_health_issue,
    c_n.fk_episode AS pk_episode,
    c_n.fk_encounter AS pk_encounter,
    c_n.xmin AS xmin_clin_narrative,
    c_n.modified_when,
    c_n.row_version,
    c_n.pk_audit,
    c_n.modified_by AS modified_by_raw,
    COALESCE(( SELECT array_agg(c_lc2n.fk_generic_code) AS array_agg
           FROM clin.lnk_code2narrative c_lc2n
          WHERE (c_lc2n.fk_item = c_n.pk)), ARRAY[]::integer[]) AS pk_generic_codes
   FROM (((clin.clin_narrative c_n
     LEFT JOIN clin.encounter c_enc ON ((c_n.fk_encounter = c_enc.pk)))
     LEFT JOIN clin.episode c_epi ON ((c_n.fk_episode = c_epi.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_epi.fk_health_issue = c_hi.pk)));


ALTER TABLE clin.v_narrative OWNER TO "gm-dbo";

--
-- Name: VIEW v_narrative; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_narrative IS 'patient narrative with denormalized context added';


--
-- Name: v_pat_allergies; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_pat_allergies AS
 SELECT a.pk AS pk_allergy,
    ( SELECT encounter.fk_patient
           FROM clin.encounter
          WHERE (encounter.pk = a.fk_encounter)) AS pk_patient,
    a.soap_cat,
        CASE
            WHEN (COALESCE(btrim(a.allergene), ''::text) = ''::text) THEN a.substance
            ELSE a.allergene
        END AS descriptor,
    a.allergene,
    a.substance,
    a.substance_code,
    a.generics,
    a.generic_specific,
    a.atc_code,
    at.value AS type,
    public._(at.value) AS l10n_type,
    a.definite,
    a.narrative AS reaction,
    a.fk_type AS pk_type,
    a.pk_item,
    a.clin_when AS date,
    ( SELECT episode.fk_health_issue
           FROM clin.episode
          WHERE (episode.pk = a.fk_episode)) AS pk_health_issue,
    a.fk_episode AS pk_episode,
    a.fk_encounter AS pk_encounter,
    a.modified_when,
    a.modified_by,
    a.xmin AS xmin_allergy
   FROM clin.allergy a,
    clin._enum_allergy_type at
  WHERE (at.pk = a.fk_type);


ALTER TABLE clin.v_pat_allergies OWNER TO "gm-dbo";

--
-- Name: VIEW v_pat_allergies; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_pat_allergies IS 'denormalizes clin.allergy';


--
-- Name: v_pat_allergy_state; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_pat_allergy_state AS
 SELECT ( SELECT encounter.fk_patient
           FROM clin.encounter
          WHERE (encounter.pk = a.fk_encounter)) AS pk_patient,
    a.modified_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = a.modified_by)), (('<'::text || (a.modified_by)::text) || '>'::text)) AS modified_by,
    a.last_confirmed,
    a.has_allergy,
    a.comment,
    a.fk_encounter AS pk_encounter,
    a.pk AS pk_allergy_state,
    a.xmin AS xmin_allergy_state
   FROM clin.allergy_state a;


ALTER TABLE clin.v_pat_allergy_state OWNER TO "gm-dbo";

--
-- Name: v_pat_encounters; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_pat_encounters AS
 SELECT c_enc.pk AS pk_encounter,
    c_enc.fk_patient AS pk_patient,
    c_enc.started,
    c_et.description AS type,
    public._(c_et.description) AS l10n_type,
    c_enc.reason_for_encounter,
    c_enc.assessment_of_encounter,
    c_enc.last_affirmed,
    c_enc.source_time_zone,
    ( SELECT timezone(( SELECT c_enc1.source_time_zone
                   FROM clin.encounter c_enc1
                  WHERE (c_enc1.pk = c_enc.pk)), c_enc.started) AS timezone) AS started_original_tz,
    ( SELECT timezone(( SELECT c_enc1.source_time_zone
                   FROM clin.encounter c_enc1
                  WHERE (c_enc1.pk = c_enc.pk)), c_enc.last_affirmed) AS timezone) AS last_affirmed_original_tz,
    COALESCE(d_ou.description, '?'::text) AS praxis_branch,
    COALESCE(d_o.description, '?'::text) AS praxis,
    c_enc.fk_location AS pk_org_unit,
    d_ou.fk_org AS pk_org,
    d_ou.fk_category AS pk_unit_type,
    d_o.fk_category AS pk_org_type,
    c_enc.fk_type AS pk_type,
    COALESCE(( SELECT array_agg(c_lc2r.fk_generic_code) AS array_agg
           FROM clin.lnk_code2rfe c_lc2r
          WHERE (c_lc2r.fk_item = c_enc.pk)), ARRAY[]::integer[]) AS pk_generic_codes_rfe,
    COALESCE(( SELECT array_agg(c_lc2a.fk_generic_code) AS array_agg
           FROM clin.lnk_code2aoe c_lc2a
          WHERE (c_lc2a.fk_item = c_enc.pk)), ARRAY[]::integer[]) AS pk_generic_codes_aoe,
    c_enc.xmin AS xmin_encounter,
    c_enc.row_version,
    c_enc.pk_audit,
    c_enc.modified_when,
    c_enc.modified_by AS modified_by_raw,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_enc.modified_by)), (('<'::text || (c_enc.modified_by)::text) || '>'::text)) AS modified_by
   FROM (((clin.encounter c_enc
     LEFT JOIN clin.encounter_type c_et ON ((c_enc.fk_type = c_et.pk)))
     LEFT JOIN dem.org_unit d_ou ON ((c_enc.fk_location = d_ou.pk)))
     LEFT JOIN dem.org d_o ON ((d_ou.fk_org = d_o.pk)));


ALTER TABLE clin.v_pat_encounters OWNER TO "gm-dbo";

--
-- Name: VIEW v_pat_encounters; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_pat_encounters IS 'Details on encounters.';


--
-- Name: v_pat_episodes; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_pat_episodes AS
 SELECT cenc.fk_patient AS pk_patient,
    cep.description,
    cep.summary,
    cep.is_open AS episode_open,
    NULL::text AS health_issue,
    NULL::boolean AS issue_active,
    NULL::boolean AS issue_clinically_relevant,
    ( SELECT min(cle.started) AS min
           FROM clin.encounter cle
          WHERE (cle.pk = cep.fk_encounter)
         LIMIT 1) AS started_first,
    ( SELECT max(cle.started) AS max
           FROM clin.encounter cle
          WHERE (cle.pk = cep.fk_encounter)
         LIMIT 1) AS started_last,
    ( SELECT max(cle.last_affirmed) AS max
           FROM clin.encounter cle
          WHERE (cle.pk = cep.fk_encounter)
         LIMIT 1) AS last_affirmed,
    cep.pk AS pk_episode,
    cep.fk_encounter AS pk_encounter,
    NULL::integer AS pk_health_issue,
    cep.modified_when AS episode_modified_when,
    cep.modified_by AS episode_modified_by,
    cep.diagnostic_certainty_classification,
    NULL::text AS diagnostic_certainty_classification_issue,
    COALESCE(( SELECT array_agg(c_lc2e.fk_generic_code) AS array_agg
           FROM clin.lnk_code2episode c_lc2e
          WHERE (c_lc2e.fk_item = cep.pk)), ARRAY[]::integer[]) AS pk_generic_codes,
    cep.xmin AS xmin_episode
   FROM (clin.episode cep
     JOIN clin.encounter cenc ON ((cep.fk_encounter = cenc.pk)))
  WHERE (cep.fk_health_issue IS NULL)
UNION ALL
 SELECT cenc.fk_patient AS pk_patient,
    cep.description,
    cep.summary,
    cep.is_open AS episode_open,
    chi.description AS health_issue,
    chi.is_active AS issue_active,
    chi.clinically_relevant AS issue_clinically_relevant,
    ( SELECT min(cle.started) AS min
           FROM clin.encounter cle
          WHERE (cle.pk = cep.fk_encounter)
         LIMIT 1) AS started_first,
    ( SELECT max(cle.started) AS max
           FROM clin.encounter cle
          WHERE (cle.pk = cep.fk_encounter)
         LIMIT 1) AS started_last,
    ( SELECT max(cle.last_affirmed) AS max
           FROM clin.encounter cle
          WHERE (cle.pk = cep.fk_encounter)
         LIMIT 1) AS last_affirmed,
    cep.pk AS pk_episode,
    cep.fk_encounter AS pk_encounter,
    cep.fk_health_issue AS pk_health_issue,
    cep.modified_when AS episode_modified_when,
    cep.modified_by AS episode_modified_by,
    cep.diagnostic_certainty_classification,
    chi.diagnostic_certainty_classification AS diagnostic_certainty_classification_issue,
    COALESCE(( SELECT array_agg(c_lc2e.fk_generic_code) AS array_agg
           FROM clin.lnk_code2episode c_lc2e
          WHERE (c_lc2e.fk_item = cep.pk)), ARRAY[]::integer[]) AS pk_generic_codes,
    cep.xmin AS xmin_episode
   FROM ((clin.episode cep
     JOIN clin.encounter cenc ON ((cep.fk_encounter = cenc.pk)))
     JOIN clin.health_issue chi ON ((cep.fk_health_issue = chi.pk)));


ALTER TABLE clin.v_pat_episodes OWNER TO "gm-dbo";

--
-- Name: v_pat_items; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_pat_items AS
 SELECT cri.modified_when,
    cri.modified_by,
    cri.clin_when,
        CASE cri.row_version
            WHEN 0 THEN false
            ELSE true
        END AS is_modified,
    cenc.fk_patient AS pk_patient,
    cri.pk_item,
    cri.fk_encounter AS pk_encounter,
    cri.fk_episode AS pk_episode,
    cepi.fk_health_issue AS pk_health_issue,
    cri.soap_cat,
    cri.narrative,
    (((pgn.nspname)::text || '.'::text) || (pgc.relname)::text) AS src_table
   FROM clin.clin_root_item cri,
    clin.encounter cenc,
    clin.episode cepi,
    (pg_class pgc
     LEFT JOIN pg_namespace pgn ON ((pgc.relnamespace = pgn.oid)))
  WHERE ((cri.fk_encounter = cenc.pk) AND (cri.fk_episode = cepi.pk) AND (cri.tableoid = pgc.oid));


ALTER TABLE clin.v_pat_items OWNER TO "gm-dbo";

--
-- Name: v_pat_vaccs4indication; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_pat_vaccs4indication AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_shot.pk AS pk_vaccination,
    c_shot.clin_when AS date_given,
    r_dp.description AS vaccine,
    public._((r_s.atc || '-target'::text), 'en'::text) AS indication,
        CASE
            WHEN (public._((r_s.atc || '-target'::text)) = (r_s.atc || '-target'::text)) THEN public._((r_s.atc || '-target'::text), 'en'::text)
            ELSE public._((r_s.atc || '-target'::text))
        END AS l10n_indication,
    c_shot.site,
    c_shot.batch_no,
    c_shot.reaction,
    c_shot.narrative AS comment,
    c_shot.soap_cat,
    c_shot.modified_when,
    c_shot.modified_by,
    c_shot.row_version,
    c_shot.fk_vaccine AS pk_vaccine,
    r_s.atc AS atc_indication,
    c_shot.fk_provider AS pk_provider,
    c_shot.fk_encounter AS pk_encounter,
    c_shot.fk_episode AS pk_episode,
    c_shot.xmin AS xmin_vaccination
   FROM ((((((clin.vaccination c_shot
     JOIN clin.encounter c_enc ON ((c_enc.pk = c_shot.fk_encounter)))
     JOIN ref.vaccine r_v ON ((r_v.pk = c_shot.fk_vaccine)))
     JOIN ref.drug_product r_dp ON ((r_dp.pk = r_v.fk_drug_product)))
     JOIN ref.lnk_dose2drug r_ld2d ON ((r_ld2d.fk_drug_product = r_dp.pk)))
     JOIN ref.dose r_d ON ((r_d.pk = r_ld2d.fk_dose)))
     JOIN ref.substance r_s ON ((r_s.pk = r_d.fk_substance)));


ALTER TABLE clin.v_pat_vaccs4indication OWNER TO "gm-dbo";

--
-- Name: VIEW v_pat_vaccs4indication; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_pat_vaccs4indication IS 'Lists all vaccinations for each indication for patients';


--
-- Name: v_pat_last_vacc4indication; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_pat_last_vacc4indication AS
 SELECT c_vpv4i.pk_patient,
    c_vpv4i.pk_vaccination,
    c_vpv4i.date_given,
    c_vpv4i.vaccine,
    c_vpv4i.indication,
    c_vpv4i.l10n_indication,
    c_vpv4i.site,
    c_vpv4i.batch_no,
    c_vpv4i.reaction,
    c_vpv4i.comment,
    c_vpv4i.soap_cat,
    c_vpv4i.modified_when,
    c_vpv4i.modified_by,
    c_vpv4i.row_version,
    c_vpv4i.pk_vaccine,
    c_vpv4i.atc_indication,
    c_vpv4i.pk_provider,
    c_vpv4i.pk_encounter,
    c_vpv4i.pk_episode,
    c_vpv4i.xmin_vaccination,
    shots_per_ind.no_of_shots
   FROM (clin.v_pat_vaccs4indication c_vpv4i
     JOIN ( SELECT count(1) AS no_of_shots,
            v_pat_vaccs4indication.pk_patient,
            v_pat_vaccs4indication.atc_indication
           FROM clin.v_pat_vaccs4indication
          GROUP BY v_pat_vaccs4indication.pk_patient, v_pat_vaccs4indication.atc_indication) shots_per_ind ON (((c_vpv4i.pk_patient = shots_per_ind.pk_patient) AND (c_vpv4i.atc_indication = shots_per_ind.atc_indication))))
  WHERE (c_vpv4i.date_given = ( SELECT max(c_vpv4i_2.date_given) AS max
           FROM clin.v_pat_vaccs4indication c_vpv4i_2
          WHERE ((c_vpv4i.pk_patient = c_vpv4i_2.pk_patient) AND (c_vpv4i.atc_indication = c_vpv4i_2.atc_indication))));


ALTER TABLE clin.v_pat_last_vacc4indication OWNER TO "gm-dbo";

--
-- Name: VIEW v_pat_last_vacc4indication; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_pat_last_vacc4indication IS 'Lists *latest* vaccinations with total count per indication.';


--
-- Name: v_potential_problem_list; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_potential_problem_list AS
 SELECT ( SELECT encounter.fk_patient
           FROM clin.encounter
          WHERE (encounter.pk = cep.fk_encounter)) AS pk_patient,
    cep.description AS problem,
    cep.summary,
    'episode'::text AS type,
    public._('episode'::text) AS l10n_type,
    false AS problem_active,
    false AS clinically_relevant,
    cep.pk AS pk_episode,
    cep.fk_health_issue AS pk_health_issue,
    cep.diagnostic_certainty_classification,
    cep.fk_encounter AS pk_encounter,
    cep.modified_when
   FROM clin.episode cep
  WHERE (cep.is_open IS FALSE)
UNION
 SELECT ( SELECT encounter.fk_patient
           FROM clin.encounter
          WHERE (encounter.pk = chi.fk_encounter)) AS pk_patient,
    chi.description AS problem,
    chi.summary,
    'issue'::text AS type,
    public._('health issue'::text) AS l10n_type,
    chi.is_active AS problem_active,
    false AS clinically_relevant,
    NULL::integer AS pk_episode,
    chi.pk AS pk_health_issue,
    chi.diagnostic_certainty_classification,
    chi.fk_encounter AS pk_encounter,
    chi.modified_when
   FROM clin.health_issue chi
  WHERE (chi.clinically_relevant IS FALSE);


ALTER TABLE clin.v_potential_problem_list OWNER TO "gm-dbo";

--
-- Name: v_problem_list; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_problem_list AS
 SELECT ( SELECT encounter.fk_patient
           FROM clin.encounter
          WHERE (encounter.pk = cep.fk_encounter)) AS pk_patient,
    cep.description AS problem,
    cep.summary,
    'episode'::text AS type,
    public._('episode'::text) AS l10n_type,
    true AS problem_active,
    true AS clinically_relevant,
    cep.pk AS pk_episode,
    cep.fk_health_issue AS pk_health_issue,
    cep.diagnostic_certainty_classification,
    cep.fk_encounter AS pk_encounter,
    cep.modified_when
   FROM clin.episode cep
  WHERE (cep.is_open IS TRUE)
UNION
 SELECT ( SELECT encounter.fk_patient
           FROM clin.encounter
          WHERE (encounter.pk = chi.fk_encounter)) AS pk_patient,
    chi.description AS problem,
    chi.summary,
    'issue'::text AS type,
    public._('health issue'::text) AS l10n_type,
    chi.is_active AS problem_active,
    true AS clinically_relevant,
    NULL::integer AS pk_episode,
    chi.pk AS pk_health_issue,
    chi.diagnostic_certainty_classification,
    chi.fk_encounter AS pk_encounter,
    chi.modified_when
   FROM clin.health_issue chi
  WHERE (chi.clinically_relevant IS TRUE);


ALTER TABLE clin.v_problem_list OWNER TO "gm-dbo";

--
-- Name: v_procedures_at_hospital; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_procedures_at_hospital AS
 SELECT c_pr.pk AS pk_procedure,
    c_enc.fk_patient AS pk_patient,
    c_pr.soap_cat,
    c_pr.clin_when,
    c_pr.clin_end,
    c_pr.is_ongoing,
    c_pr.narrative AS performed_procedure,
    c_pr.comment,
    c_vhs.ward AS unit,
    c_vhs.hospital AS organization,
    c_ep.description AS episode,
    c_hi.description AS health_issue,
    c_pr.modified_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_pr.modified_by)), (('<'::text || (c_pr.modified_by)::text) || '>'::text)) AS modified_by,
    c_pr.row_version,
    c_pr.fk_encounter AS pk_encounter,
    c_pr.fk_episode AS pk_episode,
    c_pr.fk_hospital_stay AS pk_hospital_stay,
    c_ep.fk_health_issue AS pk_health_issue,
    c_pr.fk_doc AS pk_doc,
    c_vhs.pk_org,
    c_vhs.pk_org_unit,
    COALESCE(( SELECT array_agg(c_lc2p.fk_generic_code) AS array_agg
           FROM clin.lnk_code2procedure c_lc2p
          WHERE (c_lc2p.fk_item = c_pr.pk)), ARRAY[]::integer[]) AS pk_generic_codes,
    c_pr.xmin AS xmin_procedure
   FROM ((((clin.procedure c_pr
     JOIN clin.encounter c_enc ON ((c_pr.fk_encounter = c_enc.pk)))
     JOIN clin.episode c_ep ON ((c_pr.fk_episode = c_ep.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_ep.fk_health_issue = c_hi.pk)))
     LEFT JOIN clin.v_hospital_stays c_vhs ON ((c_pr.fk_hospital_stay = c_vhs.pk_hospital_stay)))
  WHERE (c_pr.fk_hospital_stay IS NOT NULL);


ALTER TABLE clin.v_procedures_at_hospital OWNER TO "gm-dbo";

--
-- Name: v_procedures_not_at_hospital; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_procedures_not_at_hospital AS
 SELECT c_pr.pk AS pk_procedure,
    c_enc.fk_patient AS pk_patient,
    c_pr.soap_cat,
    c_pr.clin_when,
    c_pr.clin_end,
    c_pr.is_ongoing,
    c_pr.narrative AS performed_procedure,
    c_pr.comment,
    d_ou.description AS unit,
    d_o.description AS organization,
    c_ep.description AS episode,
    c_hi.description AS health_issue,
    c_pr.modified_when,
    COALESCE(( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.db_user = c_pr.modified_by)), (('<'::text || (c_pr.modified_by)::text) || '>'::text)) AS modified_by,
    c_pr.row_version,
    c_pr.fk_encounter AS pk_encounter,
    c_pr.fk_episode AS pk_episode,
    c_pr.fk_hospital_stay AS pk_hospital_stay,
    c_ep.fk_health_issue AS pk_health_issue,
    c_pr.fk_doc AS pk_doc,
    d_o.pk AS pk_org,
    d_ou.pk AS pk_org_unit,
    COALESCE(( SELECT array_agg(c_lc2p.fk_generic_code) AS array_agg
           FROM clin.lnk_code2procedure c_lc2p
          WHERE (c_lc2p.fk_item = c_pr.pk)), ARRAY[]::integer[]) AS pk_generic_codes,
    c_pr.xmin AS xmin_procedure
   FROM (((((clin.procedure c_pr
     JOIN clin.encounter c_enc ON ((c_pr.fk_encounter = c_enc.pk)))
     JOIN clin.episode c_ep ON ((c_pr.fk_episode = c_ep.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_ep.fk_health_issue = c_hi.pk)))
     LEFT JOIN dem.org_unit d_ou ON ((d_ou.pk = c_pr.fk_org_unit)))
     LEFT JOIN dem.org d_o ON ((d_o.pk = d_ou.fk_org)))
  WHERE (c_pr.fk_hospital_stay IS NULL);


ALTER TABLE clin.v_procedures_not_at_hospital OWNER TO "gm-dbo";

--
-- Name: v_procedures; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_procedures AS
 SELECT v_procedures_at_hospital.pk_procedure,
    v_procedures_at_hospital.pk_patient,
    v_procedures_at_hospital.soap_cat,
    v_procedures_at_hospital.clin_when,
    v_procedures_at_hospital.clin_end,
    v_procedures_at_hospital.is_ongoing,
    v_procedures_at_hospital.performed_procedure,
    v_procedures_at_hospital.comment,
    v_procedures_at_hospital.unit,
    v_procedures_at_hospital.organization,
    v_procedures_at_hospital.episode,
    v_procedures_at_hospital.health_issue,
    v_procedures_at_hospital.modified_when,
    v_procedures_at_hospital.modified_by,
    v_procedures_at_hospital.row_version,
    v_procedures_at_hospital.pk_encounter,
    v_procedures_at_hospital.pk_episode,
    v_procedures_at_hospital.pk_hospital_stay,
    v_procedures_at_hospital.pk_health_issue,
    v_procedures_at_hospital.pk_doc,
    v_procedures_at_hospital.pk_org,
    v_procedures_at_hospital.pk_org_unit,
    v_procedures_at_hospital.pk_generic_codes,
    v_procedures_at_hospital.xmin_procedure
   FROM clin.v_procedures_at_hospital
UNION ALL
 SELECT v_procedures_not_at_hospital.pk_procedure,
    v_procedures_not_at_hospital.pk_patient,
    v_procedures_not_at_hospital.soap_cat,
    v_procedures_not_at_hospital.clin_when,
    v_procedures_not_at_hospital.clin_end,
    v_procedures_not_at_hospital.is_ongoing,
    v_procedures_not_at_hospital.performed_procedure,
    v_procedures_not_at_hospital.comment,
    v_procedures_not_at_hospital.unit,
    v_procedures_not_at_hospital.organization,
    v_procedures_not_at_hospital.episode,
    v_procedures_not_at_hospital.health_issue,
    v_procedures_not_at_hospital.modified_when,
    v_procedures_not_at_hospital.modified_by,
    v_procedures_not_at_hospital.row_version,
    v_procedures_not_at_hospital.pk_encounter,
    v_procedures_not_at_hospital.pk_episode,
    v_procedures_not_at_hospital.pk_hospital_stay,
    v_procedures_not_at_hospital.pk_health_issue,
    v_procedures_not_at_hospital.pk_doc,
    v_procedures_not_at_hospital.pk_org,
    v_procedures_not_at_hospital.pk_org_unit,
    v_procedures_not_at_hospital.pk_generic_codes,
    v_procedures_not_at_hospital.xmin_procedure
   FROM clin.v_procedures_not_at_hospital;


ALTER TABLE clin.v_procedures OWNER TO "gm-dbo";

--
-- Name: v_reviewed_items; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_reviewed_items AS
 SELECT ( SELECT pg_class.relnamespace
           FROM pg_class
          WHERE (pg_class.oid = rr.tableoid)) AS src_schema,
    ( SELECT pg_class.relname
           FROM pg_class
          WHERE (pg_class.oid = rr.tableoid)) AS src_table,
    rr.fk_reviewed_row AS pk_reviewed_row,
    rr.is_technically_abnormal,
    rr.clinically_relevant,
    ( SELECT staff.short_alias
           FROM dem.staff
          WHERE (staff.pk = rr.fk_reviewer)) AS reviewer,
    rr.comment,
    rr.pk AS pk_review_root,
    rr.fk_reviewer AS pk_reviewer
   FROM clin.review_root rr;


ALTER TABLE clin.v_reviewed_items OWNER TO "gm-dbo";

--
-- Name: VIEW v_reviewed_items; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_reviewed_items IS 'denormalization of parent table of reviewed items';


--
-- Name: v_subst_intake4narr_search; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_subst_intake4narr_search AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_si.soap_cat,
    ((((COALESCE(c_si.narrative, ''::text) || COALESCE((' / '::text || c_si.comment_on_start), ''::text)) || COALESCE((' / '::text || c_si.schedule), ''::text)) || COALESCE((' / '::text || c_si.aim), ''::text)) || COALESCE((' / '::text || c_si.discontinue_reason), ''::text)) AS narrative,
    c_si.fk_encounter AS pk_encounter,
    c_si.fk_episode AS pk_episode,
    c_epi.fk_health_issue AS pk_health_issue,
    c_si.pk AS src_pk,
    'clin.substance_intake'::text AS src_table
   FROM ((clin.substance_intake c_si
     JOIN clin.encounter c_enc ON ((c_si.fk_encounter = c_enc.pk)))
     JOIN clin.episode c_epi ON ((c_si.fk_episode = c_epi.pk)));


ALTER TABLE clin.v_subst_intake4narr_search OWNER TO "gm-dbo";

--
-- Name: lnk_loinc2substance; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.lnk_loinc2substance (
    pk integer NOT NULL,
    fk_substance integer NOT NULL,
    loinc text,
    max_age interval,
    comment text,
    CONSTRAINT ref_ll2s_sane_comment CHECK ((gm.is_null_or_non_empty_string(comment) IS TRUE)),
    CONSTRAINT ref_ll2s_sane_loinc CHECK ((gm.is_null_or_blank_string(loinc) IS FALSE))
)
INHERITS (audit.audit_fields);


ALTER TABLE ref.lnk_loinc2substance OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_loinc2substance; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.lnk_loinc2substance IS 'Links LOINC codes to substances (for monitoring).';


--
-- Name: COLUMN lnk_loinc2substance.fk_substance; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.lnk_loinc2substance.fk_substance IS 'FK linking the substance';


--
-- Name: COLUMN lnk_loinc2substance.loinc; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.lnk_loinc2substance.loinc IS 'LOINC to monitor for substance';


--
-- Name: COLUMN lnk_loinc2substance.max_age; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.lnk_loinc2substance.max_age IS 'maximum recommended age of value of monitored LOINC in a patient,
set this to something like "999 years" if it needs to be monitored just once,
NULL = unspecified';


--
-- Name: COLUMN lnk_loinc2substance.comment; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.lnk_loinc2substance.comment IS 'a comment on this monitoring advice';


--
-- Name: v_substance_intakes; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_substance_intakes AS
 SELECT c_si.pk AS pk_substance_intake,
    c_enc.fk_patient AS pk_patient,
    c_si.soap_cat,
    r_dp.description AS product,
    r_dp.preparation,
    public._(r_dp.preparation) AS l10n_preparation,
    r_s.description AS substance,
    r_d.amount,
    r_d.unit,
    r_d.dose_unit,
    r_s.atc AS atc_substance,
    r_dp.atc_code AS atc_drug,
    r_dp.external_code AS external_code_product,
    r_dp.external_code_type AS external_code_type_product,
    ARRAY( SELECT row_to_json(loinc_row.*) AS row_to_json
           FROM ( SELECT r_ll2s.loinc,
                    r_ll2s.comment,
                    date_part('epoch'::text, r_ll2s.max_age) AS max_age_in_secs,
                    (r_ll2s.max_age)::text AS max_age_str
                   FROM ref.lnk_loinc2substance r_ll2s
                  WHERE (r_ll2s.fk_substance = r_s.pk)) loinc_row) AS loincs,
        CASE
            WHEN (c_si.comment_on_start = '?'::text) THEN NULL::timestamp with time zone
            ELSE c_si.clin_when
        END AS started,
    c_si.comment_on_start,
        CASE
            WHEN (c_si.comment_on_start = '?'::text) THEN true
            ELSE false
        END AS start_is_unknown,
        CASE
            WHEN (c_si.comment_on_start IS NULL) THEN false
            ELSE true
        END AS start_is_approximate,
    c_si.intake_is_approved_of,
    c_si.harmful_use_type,
    c_enc.started AS last_checked_when,
    c_si.schedule,
    c_si.duration,
    c_si.discontinued,
    c_si.discontinue_reason,
    c_si.is_long_term,
    c_si.aim,
    r_s.intake_instructions,
    c_epi.description AS episode,
    c_hi.description AS health_issue,
    c_si.narrative AS notes,
    r_dp.is_fake AS is_fake_product,
        CASE
            WHEN (c_si.discontinued IS NULL) THEN true
            ELSE false
        END AS is_currently_active,
        CASE
            WHEN (c_si.discontinued IS NOT NULL) THEN true
            WHEN (c_si.clin_when IS NULL) THEN
            CASE
                WHEN (c_si.is_long_term IS TRUE) THEN false
                ELSE NULL::boolean
            END
            WHEN ((c_si.clin_when > now()) IS TRUE) THEN true
            WHEN (((c_si.clin_when + c_si.duration) < now()) IS TRUE) THEN true
            WHEN (((c_si.clin_when + c_si.duration) > now()) IS TRUE) THEN false
            ELSE NULL::boolean
        END AS seems_inactive,
    r_ld2d.fk_drug_product AS pk_drug_product,
    r_dp.fk_data_source AS pk_data_source,
    r_ld2d.fk_dose AS pk_dose,
    r_ld2d.pk AS pk_drug_component,
    r_d.fk_substance AS pk_substance,
    c_si.fk_encounter AS pk_encounter,
    c_si.fk_episode AS pk_episode,
    c_epi.fk_health_issue AS pk_health_issue,
    c_si.modified_when,
    c_si.modified_by,
    c_si.row_version,
    c_si.xmin AS xmin_substance_intake
   FROM (((((((clin.substance_intake c_si
     LEFT JOIN clin.encounter c_enc ON ((c_si.fk_encounter = c_enc.pk)))
     LEFT JOIN clin.episode c_epi ON ((c_si.fk_episode = c_epi.pk)))
     LEFT JOIN clin.health_issue c_hi ON ((c_hi.pk = c_epi.fk_health_issue)))
     JOIN ref.lnk_dose2drug r_ld2d ON ((c_si.fk_drug_component = r_ld2d.pk)))
     JOIN ref.drug_product r_dp ON ((r_ld2d.fk_drug_product = r_dp.pk)))
     JOIN ref.dose r_d ON ((r_ld2d.fk_dose = r_d.pk)))
     JOIN ref.substance r_s ON ((r_d.fk_substance = r_s.pk)));


ALTER TABLE clin.v_substance_intakes OWNER TO "gm-dbo";

--
-- Name: v_suppressed_hints; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_suppressed_hints AS
 SELECT ( SELECT encounter.fk_patient
           FROM clin.encounter
          WHERE (encounter.pk = c_sh.fk_encounter)) AS pk_identity,
    c_sh.pk AS pk_suppressed_hint,
    c_sh.fk_hint AS pk_hint,
    r_vah.title,
    r_vah.hint,
    r_vah.recommendation,
    r_vah.url,
    r_vah.is_active,
    r_vah.source,
    r_vah.query,
    r_vah.lang,
    c_sh.rationale,
    r_vah.popup_type,
    r_vah.highlight_as_priority,
    c_sh.md5_sum AS md5_suppressed,
    r_vah.md5_sum AS md5_hint,
    c_sh.suppressed_by,
    c_sh.suppressed_when,
    c_sh.fk_encounter AS pk_encounter
   FROM (clin.suppressed_hint c_sh
     JOIN ref.v_auto_hints r_vah ON ((c_sh.fk_hint = r_vah.pk_auto_hint)));


ALTER TABLE clin.v_suppressed_hints OWNER TO "gm-dbo";

--
-- Name: v_test_orgs; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_test_orgs AS
 SELECT c_to.pk AS pk_test_org,
    d_o.description AS organization,
    d_ou.description AS unit,
    c_to.comment,
    c_to.contact AS test_org_contact,
    c_to.fk_adm_contact AS pk_adm_contact,
    c_to.fk_med_contact AS pk_med_contact,
    d_o.pk AS pk_org,
    d_o.fk_category AS category_org,
    d_ou.pk AS pk_org_unit,
    d_ou.fk_category AS category_unit,
    d_ou.fk_address AS pk_address_unit,
    c_to.xmin AS xmin_test_org
   FROM ((clin.test_org c_to
     LEFT JOIN dem.org_unit d_ou ON ((c_to.fk_org_unit = d_ou.pk)))
     LEFT JOIN dem.org d_o ON ((d_ou.fk_org = d_o.pk)));


ALTER TABLE clin.v_test_orgs OWNER TO "gm-dbo";

--
-- Name: v_test_panels; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_test_panels AS
 SELECT c_tp.pk AS pk_test_panel,
    c_tp.description,
    c_tp.comment,
    c_tp.modified_when,
    c_tp.modified_by,
    COALESCE(( SELECT array_agg(c_ll2tp.loinc) AS array_agg
           FROM clin.lnk_loinc2test_panel c_ll2tp
          WHERE (c_ll2tp.fk_test_panel = c_tp.pk)), ARRAY[]::text[]) AS loincs,
    ARRAY( SELECT row_to_json(test_type_row.*) AS row_to_json
           FROM ( SELECT c_ll2tp.loinc,
                    c_tt.pk AS pk_test_type,
                    c_tt.fk_meta_test_type AS pk_meta_test_type
                   FROM (clin.lnk_loinc2test_panel c_ll2tp
                     JOIN clin.test_type c_tt ON ((c_ll2tp.loinc = c_tt.loinc)))
                  WHERE (c_ll2tp.fk_test_panel = c_tp.pk)) test_type_row) AS test_types,
    COALESCE(( SELECT array_agg(c_lc2tp.fk_generic_code) AS array_agg
           FROM clin.lnk_code2tst_pnl c_lc2tp
          WHERE (c_lc2tp.fk_item = c_tp.pk)), ARRAY[]::integer[]) AS pk_generic_codes,
    c_tp.row_version,
    c_tp.xmin AS xmin_test_panel
   FROM clin.test_panel c_tp;


ALTER TABLE clin.v_test_panels OWNER TO "gm-dbo";

--
-- Name: vaccination_course; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.vaccination_course (
    pk integer NOT NULL,
    fk_recommended_by integer,
    fk_indication integer NOT NULL,
    is_active boolean DEFAULT true NOT NULL,
    comment text
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.vaccination_course OWNER TO "gm-dbo";

--
-- Name: TABLE vaccination_course; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.vaccination_course IS 'holds vaccination courses defined at a techno-medical level for
	 a single indication and will in many cases represent a part of
	 a "recommended multi-epitope schedule",
	 note that one organization can indeed recommend several courses
	 for one and the same indication - which then only differ in their
	 constraints, PostgreSQL does not currently offer the best tools
	 to enforce such constraints';


--
-- Name: COLUMN vaccination_course.fk_recommended_by; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.vaccination_course.fk_recommended_by IS 'the source/organization which defined this course, can be used to
	 differentiate several locale-dependant courses for the same indication
	 and yet tell them apart';


--
-- Name: COLUMN vaccination_course.fk_indication; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.vaccination_course.fk_indication IS 'vaccination indication this course is targeted at';


--
-- Name: COLUMN vaccination_course.is_active; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.vaccination_course.is_active IS 'whether this course is active or not,
	 if False: do not newly *start* patients on this course';


--
-- Name: COLUMN vaccination_course.comment; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.vaccination_course.comment IS 'a free-text comment on this vaccination course';


--
-- Name: vaccination_schedule; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.vaccination_schedule (
    pk integer NOT NULL,
    name text NOT NULL,
    comment text
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.vaccination_schedule OWNER TO "gm-dbo";

--
-- Name: TABLE vaccination_schedule; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.vaccination_schedule IS 'This table holds schedules as recommended by some authority
	 such as a Vaccination Council. There will be numerous schedules
	 depending on locale, constraints, age group etc. These schedules
	 may be single or multi-epitope depending on their definition.
	 A schedule acts as a convenient handle aggregating possibly several
	 vaccination courses under a common name.';


--
-- Name: COLUMN vaccination_schedule.name; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.vaccination_schedule.name IS 'name of the schedule as defined by some authority';


--
-- Name: v_vaccination_courses_in_schedule; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_vaccination_courses_in_schedule AS
 SELECT cvs.name AS vaccination_schedule,
    cvc.is_active,
    cvc.fk_recommended_by AS pk_recommended_by,
    cvc.comment AS comment_course,
    cvs.comment AS comment_schedule,
    cvc.pk AS pk_vaccination_course,
    cvc.fk_indication AS pk_indication,
    cvs.pk AS pk_vaccination_schedule
   FROM clin.vaccination_course cvc,
    clin.vaccination_schedule cvs,
    clin.lnk_vaccination_course2schedule clvc2s
  WHERE ((clvc2s.fk_course = cvc.pk) AND (clvc2s.fk_schedule = cvs.pk));


ALTER TABLE clin.v_vaccination_courses_in_schedule OWNER TO "gm-dbo";

--
-- Name: v_vaccinations; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_vaccinations AS
 SELECT c_enc.fk_patient AS pk_patient,
    c_shot.pk AS pk_vaccination,
    c_shot.clin_when AS date_given,
    (now() - c_shot.clin_when) AS interval_since_given,
    r_dp.description AS vaccine,
    ARRAY( SELECT row_to_json(indication_row.*) AS row_to_json
           FROM ( SELECT public._((r_s.atc || '-target'::text), 'en'::text) AS indication,
                        CASE
                            WHEN (public._((r_s.atc || '-target'::text)) = (r_s.atc || '-target'::text)) THEN public._((r_s.atc || '-target'::text), 'en'::text)
                            ELSE public._((r_s.atc || '-target'::text))
                        END AS l10n_indication,
                    r_s.atc AS atc_indication
                   FROM ((ref.lnk_dose2drug r_ld2d
                     JOIN ref.dose r_d ON ((r_d.pk = r_ld2d.fk_dose)))
                     JOIN ref.substance r_s ON ((r_d.fk_substance = r_s.pk)))
                  WHERE (r_ld2d.fk_drug_product = r_dp.pk)) indication_row) AS indications,
    c_shot.site,
    c_shot.batch_no,
    c_shot.reaction,
    c_shot.narrative AS comment,
    c_shot.soap_cat,
    c_shot.modified_when,
    c_shot.modified_by,
    c_shot.row_version,
    c_shot.fk_vaccine AS pk_vaccine,
    c_shot.fk_provider AS pk_provider,
    c_shot.fk_encounter AS pk_encounter,
    c_shot.fk_episode AS pk_episode,
    c_shot.xmin AS xmin_vaccination
   FROM (((clin.vaccination c_shot
     JOIN clin.encounter c_enc ON ((c_enc.pk = c_shot.fk_encounter)))
     JOIN ref.vaccine r_v ON ((r_v.pk = c_shot.fk_vaccine)))
     JOIN ref.drug_product r_dp ON ((r_v.fk_drug_product = r_dp.pk)));


ALTER TABLE clin.v_vaccinations OWNER TO "gm-dbo";

--
-- Name: VIEW v_vaccinations; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON VIEW clin.v_vaccinations IS 'Lists vaccinations for patients';


--
-- Name: waiting_list; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.waiting_list (
    pk integer NOT NULL,
    fk_patient integer NOT NULL,
    registered timestamp with time zone DEFAULT now() NOT NULL,
    urgency integer DEFAULT 0 NOT NULL,
    list_position integer NOT NULL,
    comment text,
    area text,
    CONSTRAINT non_empty_area CHECK ((btrim(area) <> ''::text)),
    CONSTRAINT waiting_list_list_position_check CHECK ((list_position > 0))
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.waiting_list OWNER TO "gm-dbo";

--
-- Name: TABLE waiting_list; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.waiting_list IS 'aggregates all the patients currently waiting for an encounter';


--
-- Name: COLUMN waiting_list.fk_patient; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.waiting_list.fk_patient IS 'the waiting patient';


--
-- Name: COLUMN waiting_list.registered; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.waiting_list.registered IS 'when did the patient arrive (enter the waiting list, that is)';


--
-- Name: COLUMN waiting_list.urgency; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.waiting_list.urgency IS 'relative urgency, used by practices as they see fit,
	   0 - "standard" urgency
	 < 0 - less urgent
	 > 0 - more urgent';


--
-- Name: COLUMN waiting_list.list_position; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.waiting_list.list_position IS 'the currently assigned position of
	 this patient on the waiting list';


--
-- Name: COLUMN waiting_list.comment; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.waiting_list.comment IS 'a free comment regarding this entry,
	 NOT THE RFE !';


--
-- Name: COLUMN waiting_list.area; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.waiting_list.area IS 'an arbitrary value by which filtering waiting patients into zones becomes possible';


--
-- Name: v_waiting_list; Type: VIEW; Schema: clin; Owner: gm-dbo
--

CREATE VIEW clin.v_waiting_list AS
 SELECT c_wl.list_position,
    c_wl.area AS waiting_zone,
    c_wl.urgency,
    d_i.title,
    d_n.firstnames,
    d_n.lastnames,
    d_n.preferred AS preferred_name,
    d_i.dob,
    d_i.gender,
    public._(d_i.gender) AS l10n_gender,
    d_i.comment AS comment_identity,
    c_wl.registered,
    ( SELECT (now() - c_wl.registered)) AS waiting_time,
    ( SELECT to_char(age(now(), c_wl.registered), 'DDD HH24:MI'::text) AS to_char) AS waiting_time_formatted,
    c_wl.comment,
    d_i.pk AS pk_identity,
    d_n.id AS pk_name,
    c_wl.pk AS pk_waiting_list
   FROM clin.waiting_list c_wl,
    dem.identity d_i,
    dem.names d_n
  WHERE ((c_wl.fk_patient = d_i.pk) AND (c_wl.fk_patient = d_n.id_identity) AND (d_i.deceased IS NULL) AND (d_n.active IS TRUE));


ALTER TABLE clin.v_waiting_list OWNER TO "gm-dbo";

--
-- Name: vaccination_course_constraint; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.vaccination_course_constraint (
    pk integer NOT NULL,
    description text NOT NULL
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.vaccination_course_constraint OWNER TO "gm-dbo";

--
-- Name: TABLE vaccination_course_constraint; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.vaccination_course_constraint IS 'holds constraints which apply to a vaccination course';


--
-- Name: COLUMN vaccination_course_constraint.description; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.vaccination_course_constraint.description IS 'description/label/name of the constraint';


--
-- Name: vaccination_course_constraint_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.vaccination_course_constraint_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.vaccination_course_constraint_pk_seq OWNER TO "gm-dbo";

--
-- Name: vaccination_course_constraint_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.vaccination_course_constraint_pk_seq OWNED BY clin.vaccination_course_constraint.pk;


--
-- Name: vaccination_course_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.vaccination_course_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.vaccination_course_pk_seq OWNER TO "gm-dbo";

--
-- Name: vaccination_course_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.vaccination_course_pk_seq OWNED BY clin.vaccination_course.pk;


--
-- Name: vaccination_definition; Type: TABLE; Schema: clin; Owner: gm-dbo
--

CREATE TABLE clin.vaccination_definition (
    id integer NOT NULL,
    fk_course integer NOT NULL,
    is_booster boolean DEFAULT false NOT NULL,
    seq_no integer,
    min_age_due interval NOT NULL,
    max_age_due interval DEFAULT '01:32:35'::interval NOT NULL,
    min_interval interval,
    comment text,
    CONSTRAINT numbered_shot_xor_booster CHECK ((((is_booster IS TRUE) AND (seq_no IS NULL)) OR ((is_booster IS FALSE) AND (seq_no > 0)))),
    CONSTRAINT sensible_min_interval CHECK ((((min_interval IS NULL) AND (seq_no = 1)) OR ((min_interval IS NOT NULL) AND (min_interval > '00:00:00'::interval) AND (is_booster IS TRUE)) OR ((min_interval IS NOT NULL) AND (min_interval > '00:00:00'::interval) AND (seq_no > 1)))),
    CONSTRAINT vaccination_definition_check CHECK ((((max_age_due >= min_age_due) AND (max_age_due <= '150 years'::interval)) OR (max_age_due = '01:32:35'::interval))),
    CONSTRAINT vaccination_definition_min_age_due_check CHECK (((min_age_due >= '00:00:01'::interval) AND (min_age_due <= '150 years'::interval)))
)
INHERITS (audit.audit_fields);


ALTER TABLE clin.vaccination_definition OWNER TO "gm-dbo";

--
-- Name: TABLE vaccination_definition; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON TABLE clin.vaccination_definition IS 'defines a given vaccination event for a particular course';


--
-- Name: COLUMN vaccination_definition.fk_course; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.vaccination_definition.fk_course IS 'course to which this event belongs';


--
-- Name: COLUMN vaccination_definition.is_booster; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.vaccination_definition.is_booster IS 'does this definition represent a booster,
	 also set for quasi-booster courses such as
	 Influenza';


--
-- Name: COLUMN vaccination_definition.seq_no; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.vaccination_definition.seq_no IS 'sequence number for this vaccination event
	 within a particular course,
	 NULL if (is_booster == true)';


--
-- Name: COLUMN vaccination_definition.min_age_due; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.vaccination_definition.min_age_due IS 'minimum age at which this shot is due';


--
-- Name: COLUMN vaccination_definition.max_age_due; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.vaccination_definition.max_age_due IS 'maximum age at which this shot is due,
	 if max_age_due = "5555 years": no maximum age';


--
-- Name: COLUMN vaccination_definition.min_interval; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON COLUMN clin.vaccination_definition.min_interval IS 'if (is_booster == true):
		recommended interval for boostering
	 id (is_booster == false):
	 	minimum interval after previous vaccination,
		NULL if seq_no == 1';


--
-- Name: vaccination_definition_id_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.vaccination_definition_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.vaccination_definition_id_seq OWNER TO "gm-dbo";

--
-- Name: vaccination_definition_id_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.vaccination_definition_id_seq OWNED BY clin.vaccination_definition.id;


--
-- Name: vaccination_id_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.vaccination_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.vaccination_id_seq OWNER TO "gm-dbo";

--
-- Name: vaccination_id_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.vaccination_id_seq OWNED BY clin.vaccination.pk;


--
-- Name: vaccination_schedule_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.vaccination_schedule_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.vaccination_schedule_pk_seq OWNER TO "gm-dbo";

--
-- Name: vaccination_schedule_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.vaccination_schedule_pk_seq OWNED BY clin.vaccination_schedule.pk;


--
-- Name: waiting_list_pk_seq; Type: SEQUENCE; Schema: clin; Owner: gm-dbo
--

CREATE SEQUENCE clin.waiting_list_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE clin.waiting_list_pk_seq OWNER TO "gm-dbo";

--
-- Name: waiting_list_pk_seq; Type: SEQUENCE OWNED BY; Schema: clin; Owner: gm-dbo
--

ALTER SEQUENCE clin.waiting_list_pk_seq OWNED BY clin.waiting_list.pk;


--
-- Name: beh_fall_typ; Type: TABLE; Schema: de_de; Owner: gm-dbo
--

CREATE TABLE de_de.beh_fall_typ (
    pk integer NOT NULL,
    code text NOT NULL,
    kurzform text NOT NULL,
    name text NOT NULL
)
INHERITS (audit.audit_fields);


ALTER TABLE de_de.beh_fall_typ OWNER TO "gm-dbo";

--
-- Name: TABLE beh_fall_typ; Type: COMMENT; Schema: de_de; Owner: gm-dbo
--

COMMENT ON TABLE de_de.beh_fall_typ IS 'Art des Behandlungsfalls (MuVo/Impfung/...)';


--
-- Name: beh_fall_typ_pk_seq; Type: SEQUENCE; Schema: de_de; Owner: gm-dbo
--

CREATE SEQUENCE de_de.beh_fall_typ_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE de_de.beh_fall_typ_pk_seq OWNER TO "gm-dbo";

--
-- Name: beh_fall_typ_pk_seq; Type: SEQUENCE OWNED BY; Schema: de_de; Owner: gm-dbo
--

ALTER SEQUENCE de_de.beh_fall_typ_pk_seq OWNED BY de_de.beh_fall_typ.pk;


--
-- Name: kvk; Type: TABLE; Schema: de_de; Owner: gm-dbo
--

CREATE TABLE de_de.kvk (
    pk integer NOT NULL,
    fk_patient integer NOT NULL,
    kk_name character varying(28) NOT NULL,
    kk_nummer character(7) NOT NULL,
    kvk_nummer character(5),
    mitgliedsnummer character varying(12) NOT NULL,
    mitgliedsstatus character varying(4) NOT NULL,
    zusatzstatus character varying(3),
    titel character varying(15),
    vorname character varying(28),
    namenszuatz character varying(15),
    familienname character varying(28) NOT NULL,
    geburtsdatum character(8) NOT NULL,
    strasse character varying(28),
    landescode character varying(3),
    plz character varying(7) NOT NULL,
    ort character varying(23) NOT NULL,
    gueltigkeit character(4),
    crc character(1) NOT NULL,
    is_valid_address boolean DEFAULT true,
    valid_since timestamp with time zone NOT NULL,
    presented timestamp with time zone[] NOT NULL,
    invalidated timestamp with time zone
);


ALTER TABLE de_de.kvk OWNER TO "gm-dbo";

--
-- Name: TABLE kvk; Type: COMMENT; Schema: de_de; Owner: gm-dbo
--

COMMENT ON TABLE de_de.kvk IS 'Speichert die Daten einer bestimmten KVK. Wir trennen die KVK-Daten von
	 den Daten ueber Person, Wohnort, Kassenzugehoerigkeit, Mitgliedsstatus und
	 Abrechnungsfaellen. Diese Daten werden jedoch a) als Vorgaben fuer die
	 eigentlichen Personendaten und b) als gueltig fuer abrechnungstechnische
	 Belange angesehen.';


--
-- Name: COLUMN kvk.invalidated; Type: COMMENT; Schema: de_de; Owner: gm-dbo
--

COMMENT ON COLUMN de_de.kvk.invalidated IS 'Kann durchaus vor Ende von "Gueltigkeit" liegen. Zeitpunkt des
	 Austritts aus der Krankenkasse. Beim Setzen dieses Feldes muss
	 auch die Zuzahlungsbefreiung auf NULL gesetzt werden.';


--
-- Name: kvk_pk_seq; Type: SEQUENCE; Schema: de_de; Owner: gm-dbo
--

CREATE SEQUENCE de_de.kvk_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE de_de.kvk_pk_seq OWNER TO "gm-dbo";

--
-- Name: kvk_pk_seq; Type: SEQUENCE OWNED BY; Schema: de_de; Owner: gm-dbo
--

ALTER SEQUENCE de_de.kvk_pk_seq OWNED BY de_de.kvk.pk;


--
-- Name: lab_test_gnr; Type: TABLE; Schema: de_de; Owner: gm-dbo
--

CREATE TABLE de_de.lab_test_gnr (
    id integer NOT NULL,
    id_test integer NOT NULL
)
INHERITS (audit.audit_fields);


ALTER TABLE de_de.lab_test_gnr OWNER TO "gm-dbo";

--
-- Name: TABLE lab_test_gnr; Type: COMMENT; Schema: de_de; Owner: gm-dbo
--

COMMENT ON TABLE de_de.lab_test_gnr IS 'specific for Germany, GNR = GebuehrenordnungsNummeR = billing
	 item, build index before lab import and drop afterwards, check
	 against this table when importing, build table during import';


--
-- Name: COLUMN lab_test_gnr.id_test; Type: COMMENT; Schema: de_de; Owner: gm-dbo
--

COMMENT ON COLUMN de_de.lab_test_gnr.id_test IS 'link to test in our practice';


--
-- Name: lab_test_gnr_id_seq; Type: SEQUENCE; Schema: de_de; Owner: gm-dbo
--

CREATE SEQUENCE de_de.lab_test_gnr_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE de_de.lab_test_gnr_id_seq OWNER TO "gm-dbo";

--
-- Name: lab_test_gnr_id_seq; Type: SEQUENCE OWNED BY; Schema: de_de; Owner: gm-dbo
--

ALTER SEQUENCE de_de.lab_test_gnr_id_seq OWNED BY de_de.lab_test_gnr.id;


--
-- Name: payment_method; Type: TABLE; Schema: de_de; Owner: gm-dbo
--

CREATE TABLE de_de.payment_method (
    pk integer NOT NULL,
    description text NOT NULL
);


ALTER TABLE de_de.payment_method OWNER TO "gm-dbo";

--
-- Name: payment_method_pk_seq; Type: SEQUENCE; Schema: de_de; Owner: gm-dbo
--

CREATE SEQUENCE de_de.payment_method_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE de_de.payment_method_pk_seq OWNER TO "gm-dbo";

--
-- Name: payment_method_pk_seq; Type: SEQUENCE OWNED BY; Schema: de_de; Owner: gm-dbo
--

ALTER SEQUENCE de_de.payment_method_pk_seq OWNED BY de_de.payment_method.pk;


--
-- Name: prax_geb_paid; Type: TABLE; Schema: de_de; Owner: gm-dbo
--

CREATE TABLE de_de.prax_geb_paid (
    pk integer NOT NULL,
    fk_fall integer NOT NULL,
    paid_amount numeric DEFAULT 0 NOT NULL,
    paid_when date DEFAULT ('now'::text)::date NOT NULL,
    paid_with integer NOT NULL
)
INHERITS (audit.audit_fields);


ALTER TABLE de_de.prax_geb_paid OWNER TO "gm-dbo";

--
-- Name: prax_geb_paid_pk_seq; Type: SEQUENCE; Schema: de_de; Owner: gm-dbo
--

CREATE SEQUENCE de_de.prax_geb_paid_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE de_de.prax_geb_paid_pk_seq OWNER TO "gm-dbo";

--
-- Name: prax_geb_paid_pk_seq; Type: SEQUENCE OWNED BY; Schema: de_de; Owner: gm-dbo
--

ALTER SEQUENCE de_de.prax_geb_paid_pk_seq OWNED BY de_de.prax_geb_paid.pk;


--
-- Name: zuzahlungsbefreiung; Type: TABLE; Schema: de_de; Owner: gm-dbo
--

CREATE TABLE de_de.zuzahlungsbefreiung (
    id integer NOT NULL,
    id_patient integer,
    medikamente date,
    heilmittel date,
    hilfsmittel date,
    presented timestamp with time zone DEFAULT now() NOT NULL
);


ALTER TABLE de_de.zuzahlungsbefreiung OWNER TO "gm-dbo";

--
-- Name: zuzahlungsbefreiung_id_seq; Type: SEQUENCE; Schema: de_de; Owner: gm-dbo
--

CREATE SEQUENCE de_de.zuzahlungsbefreiung_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE de_de.zuzahlungsbefreiung_id_seq OWNER TO "gm-dbo";

--
-- Name: zuzahlungsbefreiung_id_seq; Type: SEQUENCE OWNED BY; Schema: de_de; Owner: gm-dbo
--

ALTER SEQUENCE de_de.zuzahlungsbefreiung_id_seq OWNED BY de_de.zuzahlungsbefreiung.id;


--
-- Name: address; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.address (
    id integer NOT NULL,
    id_street integer NOT NULL,
    aux_street text,
    number text NOT NULL,
    subunit text,
    addendum text,
    lat_lon point
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.address OWNER TO "gm-dbo";

--
-- Name: TABLE address; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.address IS 'an address aka a location, void of attached meaning such as type of address';


--
-- Name: COLUMN address.id_street; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.address.id_street IS 'the street this address is at from
	 whence the urb is to be found, it
	 thus indirectly references dem.urb(id)';


--
-- Name: COLUMN address.aux_street; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.address.aux_street IS 'additional street-level information which
	 formatters would usually put on lines directly
	 below the street line of an address, such as
	 postal box directions in CA';


--
-- Name: COLUMN address.number; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.address.number IS 'number of the house';


--
-- Name: COLUMN address.subunit; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.address.subunit IS 'directions *below* the unit (eg.number) level,
	 such as appartment number, room number, level,
	 entrance or even verbal directions';


--
-- Name: COLUMN address.addendum; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.address.addendum IS 'any additional information that
	 did not fit anywhere else';


--
-- Name: COLUMN address.lat_lon; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.address.lat_lon IS 'the exact location of this address in latitude-longtitude';


--
-- Name: address_id_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.address_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.address_id_seq OWNER TO "gm-dbo";

--
-- Name: address_id_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.address_id_seq OWNED BY dem.address.id;


--
-- Name: address_type; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.address_type (
    id integer NOT NULL,
    name text NOT NULL
);


ALTER TABLE dem.address_type OWNER TO "gm-dbo";

--
-- Name: address_type_id_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.address_type_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.address_type_id_seq OWNER TO "gm-dbo";

--
-- Name: address_type_id_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.address_type_id_seq OWNED BY dem.address_type.id;


--
-- Name: country; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.country (
    id integer NOT NULL,
    code character(2) NOT NULL,
    name text NOT NULL,
    deprecated date,
    CONSTRAINT no_linebreaks CHECK ((("position"(((COALESCE(code, ''::bpchar))::text || COALESCE(name, ''::text)), ''::text) = 0) AND ("position"(((COALESCE(code, ''::bpchar))::text || COALESCE(name, ''::text)), '
'::text) = 0) AND ("position"(((COALESCE(code, ''::bpchar))::text || COALESCE(name, ''::text)), '
'::text) = 0) AND ("position"(((COALESCE(code, ''::bpchar))::text || COALESCE(name, ''::text)), ''::text) = 0)))
);


ALTER TABLE dem.country OWNER TO "gm-dbo";

--
-- Name: TABLE country; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.country IS 'countries coded per ISO 3166-1';


--
-- Name: COLUMN country.code; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.country.code IS 'international two character country code as per ISO 3166-1';


--
-- Name: COLUMN country.deprecated; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.country.deprecated IS 'date when this country ceased officially to exist (if applicable)';


--
-- Name: country_id_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.country_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.country_id_seq OWNER TO "gm-dbo";

--
-- Name: country_id_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.country_id_seq OWNED BY dem.country.id;


--
-- Name: enum_comm_types; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.enum_comm_types (
    pk integer NOT NULL,
    description text NOT NULL
);


ALTER TABLE dem.enum_comm_types OWNER TO "gm-dbo";

--
-- Name: enum_comm_types_id_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.enum_comm_types_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.enum_comm_types_id_seq OWNER TO "gm-dbo";

--
-- Name: enum_comm_types_id_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.enum_comm_types_id_seq OWNED BY dem.enum_comm_types.pk;


--
-- Name: enum_ext_id_types; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.enum_ext_id_types (
    pk integer NOT NULL,
    name text,
    issuer text
);


ALTER TABLE dem.enum_ext_id_types OWNER TO "gm-dbo";

--
-- Name: TABLE enum_ext_id_types; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.enum_ext_id_types IS 'a list of all bureaucratic IDs/serial numbers/3rd party primary keys, etc.';


--
-- Name: COLUMN enum_ext_id_types.issuer; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.enum_ext_id_types.issuer IS 'the authority/system issuing the number';


--
-- Name: enum_ext_id_types_pk_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.enum_ext_id_types_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.enum_ext_id_types_pk_seq OWNER TO "gm-dbo";

--
-- Name: enum_ext_id_types_pk_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.enum_ext_id_types_pk_seq OWNED BY dem.enum_ext_id_types.pk;


--
-- Name: gender_label; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.gender_label (
    pk integer NOT NULL,
    tag text NOT NULL,
    label text NOT NULL,
    sort_weight integer NOT NULL,
    comment text NOT NULL,
    CONSTRAINT gender_label_tag_check CHECK ((tag = ANY (ARRAY['m'::text, 'f'::text, 'h'::text, 'tm'::text, 'tf'::text])))
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.gender_label OWNER TO "gm-dbo";

--
-- Name: TABLE gender_label; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.gender_label IS 'This table stores the genders known to GNUmed.
	 FIXME: cross-check with CDA:administrative-gender-code';


--
-- Name: gender_label_pk_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.gender_label_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.gender_label_pk_seq OWNER TO "gm-dbo";

--
-- Name: gender_label_pk_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.gender_label_pk_seq OWNED BY dem.gender_label.pk;


--
-- Name: identity_pk_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.identity_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.identity_pk_seq OWNER TO "gm-dbo";

--
-- Name: identity_pk_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.identity_pk_seq OWNED BY dem.identity.pk;


--
-- Name: identity_tag; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.identity_tag (
    pk integer NOT NULL,
    fk_identity integer NOT NULL,
    fk_tag integer NOT NULL,
    comment text,
    CONSTRAINT dem_identity_tag_sane_comment CHECK ((gm.is_null_or_non_empty_string(comment) IS TRUE))
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.identity_tag OWNER TO "gm-dbo";

--
-- Name: TABLE identity_tag; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.identity_tag IS 'tags attached to this identity';


--
-- Name: identity_tag_pk_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.identity_tag_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.identity_tag_pk_seq OWNER TO "gm-dbo";

--
-- Name: identity_tag_pk_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.identity_tag_pk_seq OWNED BY dem.identity_tag.pk;


--
-- Name: inbox_item_category_pk_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.inbox_item_category_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.inbox_item_category_pk_seq OWNER TO "gm-dbo";

--
-- Name: inbox_item_category_pk_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.inbox_item_category_pk_seq OWNED BY dem.inbox_item_category.pk;


--
-- Name: inbox_item_type_pk_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.inbox_item_type_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.inbox_item_type_pk_seq OWNER TO "gm-dbo";

--
-- Name: inbox_item_type_pk_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.inbox_item_type_pk_seq OWNED BY dem.inbox_item_type.pk;


--
-- Name: lnk_identity2comm; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.lnk_identity2comm (
    pk integer NOT NULL,
    fk_identity integer NOT NULL,
    fk_address integer,
    url text NOT NULL,
    fk_type integer NOT NULL,
    is_confidential boolean DEFAULT false NOT NULL,
    comment text,
    CONSTRAINT d_l_i2comm_sane_comment CHECK ((gm.is_null_or_non_empty_string(comment) IS TRUE)),
    CONSTRAINT lnk_identity2comm_url_check CHECK ((btrim(url) <> ''::text))
);


ALTER TABLE dem.lnk_identity2comm OWNER TO "gm-dbo";

--
-- Name: COLUMN lnk_identity2comm.comment; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.lnk_identity2comm.comment IS 'a comment on this communications channel';


--
-- Name: lnk_identity2comm_id_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.lnk_identity2comm_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.lnk_identity2comm_id_seq OWNER TO "gm-dbo";

--
-- Name: lnk_identity2comm_id_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.lnk_identity2comm_id_seq OWNED BY dem.lnk_identity2comm.pk;


--
-- Name: lnk_identity2ext_id; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.lnk_identity2ext_id (
    id integer NOT NULL,
    id_identity integer NOT NULL,
    external_id text NOT NULL,
    fk_origin integer NOT NULL,
    comment text
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.lnk_identity2ext_id OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_identity2ext_id; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.lnk_identity2ext_id IS 'link external IDs to GnuMed identities';


--
-- Name: COLUMN lnk_identity2ext_id.external_id; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.lnk_identity2ext_id.external_id IS 'textual representation of external ID which
	 may be Social Security Number, patient ID of
	 another EMR system, you-name-it';


--
-- Name: COLUMN lnk_identity2ext_id.fk_origin; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.lnk_identity2ext_id.fk_origin IS 'originating system';


--
-- Name: lnk_identity2ext_id_id_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.lnk_identity2ext_id_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.lnk_identity2ext_id_id_seq OWNER TO "gm-dbo";

--
-- Name: lnk_identity2ext_id_id_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.lnk_identity2ext_id_id_seq OWNED BY dem.lnk_identity2ext_id.id;


--
-- Name: lnk_job2person; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.lnk_job2person (
    pk integer NOT NULL,
    fk_identity integer NOT NULL,
    fk_occupation integer NOT NULL,
    activities text
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.lnk_job2person OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_job2person; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.lnk_job2person IS 'linking (possibly several) jobs to a person';


--
-- Name: COLUMN lnk_job2person.activities; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.lnk_job2person.activities IS 'describes activities the person is usually
	 carrying out when working at this job';


--
-- Name: lnk_job2person_id_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.lnk_job2person_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.lnk_job2person_id_seq OWNER TO "gm-dbo";

--
-- Name: lnk_job2person_id_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.lnk_job2person_id_seq OWNED BY dem.lnk_job2person.pk;


--
-- Name: lnk_org_unit2comm; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.lnk_org_unit2comm (
    pk integer NOT NULL,
    fk_org_unit integer NOT NULL,
    url text,
    fk_type integer NOT NULL,
    is_confidential boolean DEFAULT false NOT NULL,
    comment text,
    CONSTRAINT dem_lnk_unit2comm_sane_comment CHECK ((gm.is_null_or_non_empty_string(comment) IS TRUE)),
    CONSTRAINT lnk_org_unit2comm_sane_url CHECK ((gm.is_null_or_blank_string(url) IS FALSE))
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.lnk_org_unit2comm OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_org_unit2comm; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.lnk_org_unit2comm IS 'Comm channels per org unit.';


--
-- Name: COLUMN lnk_org_unit2comm.comment; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.lnk_org_unit2comm.comment IS 'a comment on this comm channel';


--
-- Name: lnk_org_unit2comm_pk_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.lnk_org_unit2comm_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.lnk_org_unit2comm_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_org_unit2comm_pk_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.lnk_org_unit2comm_pk_seq OWNED BY dem.lnk_org_unit2comm.pk;


--
-- Name: lnk_org_unit2ext_id; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.lnk_org_unit2ext_id (
    pk integer NOT NULL,
    fk_org_unit integer NOT NULL,
    external_id text,
    fk_type integer NOT NULL,
    comment text,
    CONSTRAINT lnk_org_unit2ext_id_sane_comment CHECK ((gm.is_null_or_non_empty_string(comment) IS TRUE)),
    CONSTRAINT lnk_org_unit2ext_id_sane_id CHECK ((gm.is_null_or_blank_string(external_id) IS FALSE))
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.lnk_org_unit2ext_id OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_org_unit2ext_id; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.lnk_org_unit2ext_id IS 'External IDs per org unit.';


--
-- Name: lnk_org_unit2ext_id_pk_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.lnk_org_unit2ext_id_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.lnk_org_unit2ext_id_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_org_unit2ext_id_pk_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.lnk_org_unit2ext_id_pk_seq OWNED BY dem.lnk_org_unit2ext_id.pk;


--
-- Name: lnk_person_org_address; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.lnk_person_org_address (
    id integer NOT NULL,
    id_identity integer,
    id_address integer,
    id_type integer DEFAULT 1,
    address_source text,
    id_org integer
);


ALTER TABLE dem.lnk_person_org_address OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_person_org_address; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.lnk_person_org_address IS 'a many-to-many pivot table describing the relationship
	 between an organisation, a person, their work address and
	 their occupation at that location.
	 For patients id_org is NULL';


--
-- Name: COLUMN lnk_person_org_address.id_identity; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.lnk_person_org_address.id_identity IS 'identity to which the address belongs';


--
-- Name: COLUMN lnk_person_org_address.id_address; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.lnk_person_org_address.id_address IS 'address belonging to this identity (the branch of the organisation)';


--
-- Name: COLUMN lnk_person_org_address.id_type; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.lnk_person_org_address.id_type IS 'type of this address (like home, work, parents, holidays ...)';


--
-- Name: lnk_person2address; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.lnk_person2address AS
 SELECT lnk_person_org_address.id_identity,
    lnk_person_org_address.id_address,
    lnk_person_org_address.id_type
   FROM dem.lnk_person_org_address;


ALTER TABLE dem.lnk_person2address OWNER TO "gm-dbo";

--
-- Name: lnk_person2relative; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.lnk_person2relative (
    id integer NOT NULL,
    id_identity integer NOT NULL,
    id_relative integer NOT NULL,
    id_relation_type integer NOT NULL,
    started date,
    ended date
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.lnk_person2relative OWNER TO "gm-dbo";

--
-- Name: TABLE lnk_person2relative; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.lnk_person2relative IS 'biological and social relationships between an identity and other identities';


--
-- Name: COLUMN lnk_person2relative.id_identity; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.lnk_person2relative.id_identity IS 'primary identity to whom the relationship applies';


--
-- Name: COLUMN lnk_person2relative.id_relative; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.lnk_person2relative.id_relative IS 'referred-to identity of this relationship (e.g. "child"
	 if id_identity points to the father and id_relation_type
	 points to "parent")';


--
-- Name: COLUMN lnk_person2relative.started; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.lnk_person2relative.started IS 'date when this relationship began';


--
-- Name: COLUMN lnk_person2relative.ended; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.lnk_person2relative.ended IS 'date when this relationship ended, biological
	 relationships do not end !';


--
-- Name: lnk_person2relative_id_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.lnk_person2relative_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.lnk_person2relative_id_seq OWNER TO "gm-dbo";

--
-- Name: lnk_person2relative_id_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.lnk_person2relative_id_seq OWNED BY dem.lnk_person2relative.id;


--
-- Name: lnk_person_org_address_id_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.lnk_person_org_address_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.lnk_person_org_address_id_seq OWNER TO "gm-dbo";

--
-- Name: lnk_person_org_address_id_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.lnk_person_org_address_id_seq OWNED BY dem.lnk_person_org_address.id;


--
-- Name: marital_status_pk_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.marital_status_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.marital_status_pk_seq OWNER TO "gm-dbo";

--
-- Name: marital_status_pk_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.marital_status_pk_seq OWNED BY dem.marital_status.pk;


--
-- Name: name_gender_map; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.name_gender_map (
    id integer NOT NULL,
    name text NOT NULL,
    gender character(1),
    CONSTRAINT name_gender_map_gender_check CHECK ((gender = ANY (ARRAY['m'::bpchar, 'f'::bpchar])))
);


ALTER TABLE dem.name_gender_map OWNER TO "gm-dbo";

--
-- Name: TABLE name_gender_map; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.name_gender_map IS 'maps (first) names to their most frequently locally assigned gender,
	 this table is updated nightly by a cron script,
	 names whose gender distribution is between 70/30 and 30/70 are
	 ignored for ambiguity reasons,
	 names with "ambigous" gender are also ignored';


--
-- Name: name_gender_map_id_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.name_gender_map_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.name_gender_map_id_seq OWNER TO "gm-dbo";

--
-- Name: name_gender_map_id_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.name_gender_map_id_seq OWNED BY dem.name_gender_map.id;


--
-- Name: names_id_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.names_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.names_id_seq OWNER TO "gm-dbo";

--
-- Name: names_id_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.names_id_seq OWNED BY dem.names.id;


--
-- Name: occupation; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.occupation (
    id integer NOT NULL,
    name text NOT NULL,
    CONSTRAINT occupation_name_check CHECK ((btrim(name) <> ''::text))
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.occupation OWNER TO "gm-dbo";

--
-- Name: TABLE occupation; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.occupation IS 'collects occupation names';


--
-- Name: occupation_id_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.occupation_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.occupation_id_seq OWNER TO "gm-dbo";

--
-- Name: occupation_id_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.occupation_id_seq OWNED BY dem.occupation.id;


--
-- Name: org_category; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.org_category (
    pk integer NOT NULL,
    description text NOT NULL
);


ALTER TABLE dem.org_category OWNER TO "gm-dbo";

--
-- Name: org_category_id_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.org_category_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.org_category_id_seq OWNER TO "gm-dbo";

--
-- Name: org_category_id_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.org_category_id_seq OWNED BY dem.org_category.pk;


--
-- Name: org_pk_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.org_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.org_pk_seq OWNER TO "gm-dbo";

--
-- Name: org_pk_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.org_pk_seq OWNED BY dem.org.pk;


--
-- Name: org_unit_pk_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.org_unit_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.org_unit_pk_seq OWNER TO "gm-dbo";

--
-- Name: org_unit_pk_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.org_unit_pk_seq OWNED BY dem.org_unit.pk;


--
-- Name: praxis_branch; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.praxis_branch (
    pk integer NOT NULL,
    fk_org_unit integer NOT NULL
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.praxis_branch OWNER TO "gm-dbo";

--
-- Name: TABLE praxis_branch; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.praxis_branch IS 'Defines one branch of a praxis (which itself is a dem.org)';


--
-- Name: praxis_branch_pk_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.praxis_branch_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.praxis_branch_pk_seq OWNER TO "gm-dbo";

--
-- Name: praxis_branch_pk_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.praxis_branch_pk_seq OWNED BY dem.praxis_branch.pk;


--
-- Name: provider_inbox_pk_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.provider_inbox_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.provider_inbox_pk_seq OWNER TO "gm-dbo";

--
-- Name: provider_inbox_pk_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.provider_inbox_pk_seq OWNED BY dem.message_inbox.pk;


--
-- Name: region; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.region (
    pk integer NOT NULL,
    code text NOT NULL,
    country character(2) NOT NULL,
    name text NOT NULL,
    CONSTRAINT no_linebreaks CHECK ((("position"(((COALESCE(code, ''::text) || (COALESCE(country, ''::bpchar))::text) || COALESCE(name, ''::text)), ''::text) = 0) AND ("position"(((COALESCE(code, ''::text) || (COALESCE(country, ''::bpchar))::text) || COALESCE(name, ''::text)), '
'::text) = 0) AND ("position"(((COALESCE(code, ''::text) || (COALESCE(country, ''::bpchar))::text) || COALESCE(name, ''::text)), '
'::text) = 0) AND ("position"(((COALESCE(code, ''::text) || (COALESCE(country, ''::bpchar))::text) || COALESCE(name, ''::text)), ''::text) = 0)))
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.region OWNER TO "gm-dbo";

--
-- Name: TABLE region; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.region IS 'region codes (country specific);
	 Richard agreed we should require pre-existence,
	 allow user to mail details for adding a state to developers';


--
-- Name: COLUMN region.code; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.region.code IS 'region code';


--
-- Name: COLUMN region.country; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.region.country IS '2 character ISO 3166-1 country code';


--
-- Name: relation_types; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.relation_types (
    id integer NOT NULL,
    inverse integer,
    biological boolean NOT NULL,
    biol_verified boolean DEFAULT false,
    description text
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.relation_types OWNER TO "gm-dbo";

--
-- Name: TABLE relation_types; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.relation_types IS 'types of biological/social relationships between identities';


--
-- Name: COLUMN relation_types.biological; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.relation_types.biological IS 'true if relationship is biological (proven or
	 reasonable assumption), else false';


--
-- Name: COLUMN relation_types.biol_verified; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.relation_types.biol_verified IS 'ONLY true if there is genetic proof for this relationship';


--
-- Name: COLUMN relation_types.description; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.relation_types.description IS 'plain text description of relationship';


--
-- Name: relation_types_id_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.relation_types_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.relation_types_id_seq OWNER TO "gm-dbo";

--
-- Name: relation_types_id_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.relation_types_id_seq OWNED BY dem.relation_types.id;


--
-- Name: staff_pk_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.staff_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.staff_pk_seq OWNER TO "gm-dbo";

--
-- Name: staff_pk_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.staff_pk_seq OWNED BY dem.staff.pk;


--
-- Name: state_id_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.state_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.state_id_seq OWNER TO "gm-dbo";

--
-- Name: state_id_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.state_id_seq OWNED BY dem.region.pk;


--
-- Name: street; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.street (
    id integer NOT NULL,
    id_urb integer NOT NULL,
    name text NOT NULL,
    postcode text,
    suburb text,
    lat_lon point,
    CONSTRAINT no_linebreaks CHECK ((("position"(((COALESCE(postcode, ''::text) || COALESCE(suburb, ''::text)) || COALESCE(name, ''::text)), ''::text) = 0) AND ("position"(((COALESCE(postcode, ''::text) || COALESCE(suburb, ''::text)) || COALESCE(name, ''::text)), '
'::text) = 0) AND ("position"(((COALESCE(postcode, ''::text) || COALESCE(suburb, ''::text)) || COALESCE(name, ''::text)), '
'::text) = 0) AND ("position"(((COALESCE(postcode, ''::text) || COALESCE(suburb, ''::text)) || COALESCE(name, ''::text)), ''::text) = 0)))
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.street OWNER TO "gm-dbo";

--
-- Name: TABLE street; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.street IS 'street names, specific for distinct "urbs"';


--
-- Name: COLUMN street.id_urb; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.street.id_urb IS 'reference to information postcode, city, country and region';


--
-- Name: COLUMN street.name; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.street.name IS 'name of this street';


--
-- Name: COLUMN street.postcode; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.street.postcode IS 'postcode for systems (such as UK Royal Mail) which specify the street';


--
-- Name: COLUMN street.suburb; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.street.suburb IS 'the suburb this street is in (if any)';


--
-- Name: COLUMN street.lat_lon; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.street.lat_lon IS 'the approximate location of the street, as lat/long co-ordinates';


--
-- Name: street_id_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.street_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.street_id_seq OWNER TO "gm-dbo";

--
-- Name: street_id_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.street_id_seq OWNED BY dem.street.id;


--
-- Name: urb; Type: TABLE; Schema: dem; Owner: gm-dbo
--

CREATE TABLE dem.urb (
    id integer NOT NULL,
    fk_region integer NOT NULL,
    postcode text NOT NULL,
    lat_lon point,
    name text NOT NULL,
    CONSTRAINT no_linebreaks CHECK ((("position"((COALESCE(postcode, ''::text) || COALESCE(name, ''::text)), ''::text) = 0) AND ("position"((COALESCE(postcode, ''::text) || COALESCE(name, ''::text)), '
'::text) = 0) AND ("position"((COALESCE(postcode, ''::text) || COALESCE(name, ''::text)), '
'::text) = 0) AND ("position"((COALESCE(postcode, ''::text) || COALESCE(name, ''::text)), ''::text) = 0)))
)
INHERITS (audit.audit_fields);


ALTER TABLE dem.urb OWNER TO "gm-dbo";

--
-- Name: TABLE urb; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON TABLE dem.urb IS 'cities, towns, dwellings ..., eg. "official" places of residence';


--
-- Name: COLUMN urb.fk_region; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.urb.fk_region IS 'reference to information about country and region';


--
-- Name: COLUMN urb.postcode; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.urb.postcode IS 'default postcode for urb.name,
	 useful for all the smaller urbs that only have one postcode,
	 also useful as a default when adding new streets to an urb';


--
-- Name: COLUMN urb.lat_lon; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.urb.lat_lon IS 'the location of the urb, as lat/long co-ordinates. Ideally this would be NOT NULL';


--
-- Name: COLUMN urb.name; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON COLUMN dem.urb.name IS 'the name of the city/town/dwelling';


--
-- Name: urb_id_seq; Type: SEQUENCE; Schema: dem; Owner: gm-dbo
--

CREATE SEQUENCE dem.urb_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE dem.urb_id_seq OWNER TO "gm-dbo";

--
-- Name: urb_id_seq; Type: SEQUENCE OWNED BY; Schema: dem; Owner: gm-dbo
--

ALTER SEQUENCE dem.urb_id_seq OWNED BY dem.urb.id;


--
-- Name: v_active_persons; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_active_persons AS
 SELECT d_vp.pk_identity,
    d_vp.title,
    d_vp.firstnames,
    d_vp.preferred,
    d_vp.lastnames,
    d_vp.gender,
    d_vp.l10n_gender,
    d_vp.dob_only,
    d_vp.dob,
    d_vp.tob,
    d_vp.deceased,
    d_vp.marital_status,
    d_vp.l10n_marital_status,
    d_vp.emergency_contact,
    d_vp.comment,
    d_vp.is_deleted,
    d_vp.pk_marital_status,
    d_vp.pk_active_name,
    d_vp.pk_emergency_contact,
    d_vp.pk_primary_provider,
    d_vp.xmin_identity,
    d_vp.dob_is_estimated
   FROM dem.v_all_persons d_vp
  WHERE (d_vp.is_deleted IS FALSE);


ALTER TABLE dem.v_active_persons OWNER TO "gm-dbo";

--
-- Name: VIEW v_active_persons; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_active_persons IS 'This view denormalizes non-deleted persons with their active name.';


--
-- Name: v_address; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_address AS
 SELECT d_adr.id AS pk_address,
    d_str.name AS street,
    COALESCE(d_str.postcode, d_u.postcode) AS postcode,
    d_adr.aux_street AS notes_street,
    d_adr.number,
    d_adr.subunit,
    d_adr.addendum AS notes_subunit,
    d_adr.lat_lon AS lat_lon_address,
    d_str.postcode AS postcode_street,
    d_str.lat_lon AS lat_lon_street,
    d_str.suburb,
    d_u.name AS urb,
    d_u.postcode AS postcode_urb,
    d_u.lat_lon AS lat_lon_urb,
    d_r.code AS code_region,
    d_r.name AS region,
    public._(d_r.name) AS l10n_region,
    d_r.country AS code_country,
    d_c.name AS country,
    public._(d_c.name) AS l10n_country,
    d_c.deprecated AS country_deprecated,
    d_adr.id_street AS pk_street,
    d_u.id AS pk_urb,
    d_r.pk AS pk_region,
    d_adr.xmin AS xmin_address
   FROM ((((dem.address d_adr
     LEFT JOIN dem.street d_str ON ((d_adr.id_street = d_str.id)))
     LEFT JOIN dem.urb d_u ON ((d_str.id_urb = d_u.id)))
     LEFT JOIN dem.region d_r ON ((d_u.fk_region = d_r.pk)))
     LEFT JOIN dem.country d_c ON ((d_c.code = d_r.country)));


ALTER TABLE dem.v_address OWNER TO "gm-dbo";

--
-- Name: VIEW v_address; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_address IS 'fully denormalizes data about addresses as entities in themselves';


--
-- Name: v_basic_address; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_basic_address AS
 SELECT d_adr.id,
    d_r.country AS country_code,
    d_r.code AS region_code,
    d_r.name AS region,
    d_c.name AS country,
    COALESCE(d_str.postcode, d_u.postcode) AS postcode,
    d_u.name AS urb,
    d_adr.number,
    d_str.name AS street,
    d_adr.addendum,
    COALESCE(d_adr.lat_lon, d_str.lat_lon, d_u.lat_lon) AS lat_lon
   FROM dem.address d_adr,
    dem.region d_r,
    dem.country d_c,
    dem.urb d_u,
    dem.street d_str
  WHERE ((d_r.country = d_c.code) AND (d_adr.id_street = d_str.id) AND (d_str.id_urb = d_u.id) AND (d_u.fk_region = d_r.pk));


ALTER TABLE dem.v_basic_address OWNER TO "gm-dbo";

--
-- Name: v_deleted_persons; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_deleted_persons AS
 SELECT d_vp.pk_identity,
    d_vp.title,
    d_vp.firstnames,
    d_vp.preferred,
    d_vp.lastnames,
    d_vp.gender,
    d_vp.l10n_gender,
    d_vp.dob_only,
    d_vp.dob,
    d_vp.tob,
    d_vp.deceased,
    d_vp.marital_status,
    d_vp.l10n_marital_status,
    d_vp.emergency_contact,
    d_vp.comment,
    d_vp.is_deleted,
    d_vp.pk_marital_status,
    d_vp.pk_active_name,
    d_vp.pk_emergency_contact,
    d_vp.pk_primary_provider,
    d_vp.xmin_identity,
    d_vp.dob_is_estimated
   FROM dem.v_all_persons d_vp
  WHERE (d_vp.is_deleted IS TRUE);


ALTER TABLE dem.v_deleted_persons OWNER TO "gm-dbo";

--
-- Name: VIEW v_deleted_persons; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_deleted_persons IS 'This view denormalizes "deleted" persons with their active name.';


--
-- Name: v_external_ids4identity; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_external_ids4identity AS
 SELECT li2ei.id_identity AS pk_identity,
    li2ei.id AS pk_id,
    eit.name,
    li2ei.external_id AS value,
    eit.issuer,
    li2ei.comment,
    li2ei.fk_origin AS pk_type
   FROM dem.lnk_identity2ext_id li2ei,
    dem.enum_ext_id_types eit
  WHERE (li2ei.fk_origin = eit.pk);


ALTER TABLE dem.v_external_ids4identity OWNER TO "gm-dbo";

--
-- Name: v_external_ids4org_unit; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_external_ids4org_unit AS
 SELECT d_lou2ei.fk_org_unit AS pk_org_unit,
    d_lou2ei.pk AS pk_id,
    d_eit.name,
    d_lou2ei.external_id AS value,
    d_eit.issuer,
    d_lou2ei.comment,
    d_lou2ei.fk_type AS pk_type
   FROM (dem.lnk_org_unit2ext_id d_lou2ei
     JOIN dem.enum_ext_id_types d_eit ON ((d_lou2ei.fk_type = d_eit.pk)));


ALTER TABLE dem.v_external_ids4org_unit OWNER TO "gm-dbo";

--
-- Name: v_gender_labels; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_gender_labels AS
 SELECT gl.tag,
    public._(gl.tag) AS l10n_tag,
    gl.label,
    public._(gl.label) AS l10n_label,
    gl.comment,
    gl.sort_weight,
    gl.pk AS pk_gender_label
   FROM dem.gender_label gl;


ALTER TABLE dem.v_gender_labels OWNER TO "gm-dbo";

--
-- Name: tag_image; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.tag_image (
    pk integer NOT NULL,
    description text,
    filename text,
    image bytea NOT NULL,
    CONSTRAINT ref_tag_image_sane_desc CHECK ((gm.is_null_or_blank_string(description) IS FALSE)),
    CONSTRAINT ref_tag_image_sane_filename CHECK ((gm.is_null_or_non_empty_string(filename) IS TRUE))
)
INHERITS (audit.audit_fields);


ALTER TABLE ref.tag_image OWNER TO "gm-dbo";

--
-- Name: TABLE tag_image; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.tag_image IS 'Text+image tags that can be applied to a person for characterization.';


--
-- Name: COLUMN tag_image.description; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.tag_image.description IS 'A textual description of the meaning of the tag. Keep this reasonably short.';


--
-- Name: COLUMN tag_image.filename; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.tag_image.filename IS 'An example filename, mainly for preserving the file suffix. Set during import, suffix used during export.';


--
-- Name: COLUMN tag_image.image; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.tag_image.image IS 'An image showing the meaning of the tag.';


--
-- Name: v_identity_tags; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_identity_tags AS
 SELECT dit.fk_identity AS pk_identity,
    rti.description,
    public._(rti.description) AS l10n_description,
    dit.comment,
    rti.filename,
    octet_length(COALESCE(rti.image, '\x'::bytea)) AS image_size,
    dit.pk AS pk_identity_tag,
    rti.pk AS pk_tag_image,
    dit.xmin AS xmin_identity_tag
   FROM (dem.identity_tag dit
     LEFT JOIN ref.tag_image rti ON ((dit.fk_tag = rti.pk)));


ALTER TABLE dem.v_identity_tags OWNER TO "gm-dbo";

--
-- Name: v_message_inbox; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_message_inbox AS
 SELECT all_msgs.received_when,
    all_msgs.modified_by,
    all_msgs.provider,
    all_msgs.importance,
    all_msgs.category,
    all_msgs.l10n_category,
    all_msgs.type,
    all_msgs.l10n_type,
    all_msgs.comment,
    all_msgs.pk_context,
    all_msgs.data,
    all_msgs.pk_inbox_message,
    all_msgs.pk_staff,
    all_msgs.pk_category,
    all_msgs.pk_type,
    all_msgs.pk_patient,
    all_msgs.is_virtual,
    all_msgs.due_date,
    all_msgs.expiry_date,
    all_msgs.is_overdue,
    all_msgs.is_expired,
    all_msgs.interval_due,
    all_msgs.xmin_message_inbox,
    d_n.lastnames,
    d_n.firstnames,
    d_n.preferred AS preferred_name,
    d_n.comment AS comment_name,
    d_i.gender,
    public._(d_i.gender) AS l10n_gender,
    (date_trunc('day'::text, d_i.dob) + (COALESCE(d_i.tob, (d_i.dob)::time without time zone))::interval) AS dob,
    d_i.deceased,
    d_i.title,
    d_i.comment AS comment_identity
   FROM ((( SELECT mi.modified_when AS received_when,
            COALESCE(( SELECT staff.short_alias
                   FROM dem.staff
                  WHERE (staff.db_user = mi.modified_by)), (('<'::text || (mi.modified_by)::text) || '>'::text)) AS modified_by,
            ( SELECT staff.short_alias
                   FROM dem.staff
                  WHERE (staff.pk = mi.fk_staff)) AS provider,
            mi.importance,
            vit.category,
            vit.l10n_category,
            vit.type,
            vit.l10n_type,
            mi.comment,
            mi.ufk_context AS pk_context,
            mi.data,
            mi.pk AS pk_inbox_message,
            mi.fk_staff AS pk_staff,
            vit.pk_category,
            mi.fk_inbox_item_type AS pk_type,
            mi.fk_patient AS pk_patient,
            false AS is_virtual,
            mi.due_date,
            mi.expiry_date,
                CASE
                    WHEN (mi.due_date IS NULL) THEN false
                    WHEN (mi.due_date > now()) THEN false
                    WHEN (mi.expiry_date IS NULL) THEN true
                    WHEN (mi.expiry_date < now()) THEN false
                    ELSE true
                END AS is_overdue,
                CASE
                    WHEN (mi.expiry_date IS NULL) THEN false
                    WHEN (mi.expiry_date > now()) THEN false
                    ELSE true
                END AS is_expired,
                CASE
                    WHEN (mi.due_date IS NULL) THEN NULL::interval
                    WHEN (mi.due_date > now()) THEN ((mi.due_date)::timestamp with time zone - now())
                    ELSE (now() - (mi.due_date)::timestamp with time zone)
                END AS interval_due,
            gm.xid2int(mi.xmin) AS xmin_message_inbox
           FROM dem.message_inbox mi,
            dem.v_inbox_item_type vit
          WHERE (mi.fk_inbox_item_type = vit.pk_type)
        UNION ALL
         SELECT v_unreviewed_docs_inbox.received_when,
            v_unreviewed_docs_inbox.modified_by,
            v_unreviewed_docs_inbox.provider,
            v_unreviewed_docs_inbox.importance,
            v_unreviewed_docs_inbox.category,
            v_unreviewed_docs_inbox.l10n_category,
            v_unreviewed_docs_inbox.type,
            v_unreviewed_docs_inbox.l10n_type,
            v_unreviewed_docs_inbox.comment,
            v_unreviewed_docs_inbox.pk_context,
            v_unreviewed_docs_inbox.data,
            v_unreviewed_docs_inbox.pk_inbox_message,
            v_unreviewed_docs_inbox.pk_staff,
            v_unreviewed_docs_inbox.pk_category,
            v_unreviewed_docs_inbox.pk_type,
            v_unreviewed_docs_inbox.pk_patient,
            v_unreviewed_docs_inbox.is_virtual,
            v_unreviewed_docs_inbox.due_date,
            v_unreviewed_docs_inbox.expiry_date,
            v_unreviewed_docs_inbox.is_overdue,
            v_unreviewed_docs_inbox.is_expired,
            v_unreviewed_docs_inbox.interval_due,
            v_unreviewed_docs_inbox.xmin_message_inbox
           FROM blobs.v_unreviewed_docs_inbox
        UNION ALL (
                 SELECT now() AS received_when,
                    vtr.modified_by,
                    ( SELECT staff.short_alias
                           FROM dem.staff
                          WHERE (staff.pk = vtr.pk_intended_reviewer)) AS provider,
                    1 AS importance,
                    'clinical'::text AS category,
                    public._('clinical'::text) AS l10n_category,
                    'review results'::text AS type,
                    public._('review results'::text) AS l10n_type,
                    ( SELECT (((((public._('unreviewed (abnormal) results for patient'::text) || ' ['::text) || dn.lastnames) || ', '::text) || dn.firstnames) || ']'::text)
                           FROM dem.names dn
                          WHERE ((dn.id_identity = vtr.pk_patient) AND (dn.active IS TRUE))) AS comment,
                    NULL::integer[] AS pk_context,
                    NULL::text AS data,
                    NULL::integer AS pk_inbox_message,
                    vtr.pk_intended_reviewer AS pk_staff,
                    ( SELECT v_inbox_item_type.pk_category
                           FROM dem.v_inbox_item_type
                          WHERE (v_inbox_item_type.type = 'review results'::text)) AS pk_category,
                    ( SELECT v_inbox_item_type.pk_type
                           FROM dem.v_inbox_item_type
                          WHERE (v_inbox_item_type.type = 'review results'::text)) AS pk_type,
                    vtr.pk_patient,
                    true AS is_virtual,
                    (now() - '01:00:00'::interval) AS due_date,
                    NULL::timestamp with time zone AS expiry_date,
                    true AS is_overdue,
                    false AS is_expired,
                    '01:00:00'::interval AS interval_due,
                    NULL::integer AS xmin_message_inbox
                   FROM clin.v_test_results vtr
                  WHERE ((vtr.reviewed IS FALSE) AND ((vtr.is_technically_abnormal IS TRUE) OR ((vtr.is_technically_abnormal IS NULL) AND (vtr.abnormality_indicator IS NOT NULL))))
                UNION
                 SELECT now() AS received_when,
                    vtr.modified_by,
                    ( SELECT staff.short_alias
                           FROM dem.staff
                          WHERE (staff.pk = vtr.pk_intended_reviewer)) AS provider,
                    0 AS importance,
                    'clinical'::text AS category,
                    public._('clinical'::text) AS l10n_category,
                    'review results'::text AS type,
                    public._('review results'::text) AS l10n_type,
                    ( SELECT (((((public._('unreviewed (normal) results for patient'::text) || ' ['::text) || dn.lastnames) || ', '::text) || dn.firstnames) || ']'::text)
                           FROM dem.names dn
                          WHERE ((dn.id_identity = vtr.pk_patient) AND (dn.active IS TRUE))) AS comment,
                    NULL::integer[] AS pk_context,
                    NULL::text AS data,
                    NULL::integer AS pk_inbox_message,
                    vtr.pk_intended_reviewer AS pk_staff,
                    ( SELECT v_inbox_item_type.pk_category
                           FROM dem.v_inbox_item_type
                          WHERE (v_inbox_item_type.type = 'review results'::text)) AS pk_category,
                    ( SELECT v_inbox_item_type.pk_type
                           FROM dem.v_inbox_item_type
                          WHERE (v_inbox_item_type.type = 'review results'::text)) AS pk_type,
                    vtr.pk_patient,
                    true AS is_virtual,
                    (now() - '01:00:00'::interval) AS due_date,
                    NULL::timestamp with time zone AS expiry_date,
                    true AS is_overdue,
                    false AS is_expired,
                    '01:00:00'::interval AS interval_due,
                    NULL::integer AS xmin_message_inbox
                   FROM clin.v_test_results vtr
                  WHERE ((vtr.reviewed IS FALSE) AND ((vtr.is_technically_abnormal IS FALSE) OR ((vtr.is_technically_abnormal IS NULL) AND (vtr.abnormality_indicator IS NULL))))
        )) all_msgs
     LEFT JOIN dem.identity d_i ON ((all_msgs.pk_patient = d_i.pk)))
     LEFT JOIN dem.names d_n ON ((d_i.pk = d_n.id_identity)))
  WHERE (d_n.active IS DISTINCT FROM false);


ALTER TABLE dem.v_message_inbox OWNER TO "gm-dbo";

--
-- Name: VIEW v_message_inbox; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_message_inbox IS 'Denormalized messages for the providers and/or patients.
Using UNION makes sure we get the right level of uniqueness.';


--
-- Name: v_org_unit_comms; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_org_unit_comms AS
 SELECT d_lo2c.fk_org_unit AS pk_org_unit,
    ect.description AS comm_type,
    public._(ect.description) AS l10n_comm_type,
    d_lo2c.url,
    d_lo2c.comment,
    d_lo2c.is_confidential,
    d_lo2c.pk AS pk_lnk_org_unit2comm,
    d_lo2c.fk_type AS pk_type,
    d_lo2c.xmin AS xmin_lnk_org_unit2comm
   FROM (dem.lnk_org_unit2comm d_lo2c
     JOIN dem.enum_comm_types ect ON ((d_lo2c.fk_type = ect.pk)));


ALTER TABLE dem.v_org_unit_comms OWNER TO "gm-dbo";

--
-- Name: VIEW v_org_unit_comms; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_org_unit_comms IS 'denormalizes org units to communication channels';


--
-- Name: v_org_units; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_org_units AS
 SELECT d_ou.pk AS pk_org_unit,
    d_o.description AS organization,
    d_ou.description AS unit,
    d_oc_o.description AS organization_category,
    public._(d_oc_o.description) AS l10n_organization_category,
    d_oc_u.description AS unit_category,
    public._(d_oc_u.description) AS l10n_unit_category,
    (EXISTS ( SELECT 1
           FROM dem.praxis_branch d_pb
          WHERE (d_pb.fk_org_unit = d_ou.pk))) AS is_praxis_branch,
    d_o.pk AS pk_org,
    d_o.fk_category AS pk_category_org,
    d_ou.fk_category AS pk_category_unit,
    d_ou.fk_address AS pk_address,
    d_ou.xmin AS xmin_org_unit
   FROM (((dem.org_unit d_ou
     JOIN dem.org d_o ON ((d_o.pk = d_ou.fk_org)))
     LEFT JOIN dem.org_category d_oc_u ON ((d_ou.fk_category = d_oc_u.pk)))
     LEFT JOIN dem.org_category d_oc_o ON ((d_o.fk_category = d_oc_o.pk)));


ALTER TABLE dem.v_org_units OWNER TO "gm-dbo";

--
-- Name: v_org_units_no_praxis_check; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_org_units_no_praxis_check AS
 SELECT d_ou.pk AS pk_org_unit,
    d_o.description AS organization,
    d_ou.description AS unit,
    d_oc_o.description AS organization_category,
    public._(d_oc_o.description) AS l10n_organization_category,
    d_oc_u.description AS unit_category,
    public._(d_oc_u.description) AS l10n_unit_category,
    d_o.pk AS pk_org,
    d_o.fk_category AS pk_category_org,
    d_ou.fk_category AS pk_category_unit,
    d_ou.fk_address AS pk_address,
    d_ou.xmin AS xmin_org_unit
   FROM (((dem.org_unit d_ou
     JOIN dem.org d_o ON ((d_o.pk = d_ou.fk_org)))
     LEFT JOIN dem.org_category d_oc_u ON ((d_ou.fk_category = d_oc_u.pk)))
     LEFT JOIN dem.org_category d_oc_o ON ((d_o.fk_category = d_oc_o.pk)));


ALTER TABLE dem.v_org_units_no_praxis_check OWNER TO "gm-dbo";

--
-- Name: v_orgs; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_orgs AS
 SELECT d_o.pk AS pk_org,
    d_o.description AS organization,
    d_oc.description AS category,
    public._(d_oc.description) AS l10n_category,
    (EXISTS ( SELECT 1
           FROM dem.praxis_branch d_pb
          WHERE (d_pb.fk_org_unit IN ( SELECT d_ou.pk
                   FROM dem.org_unit d_ou
                  WHERE (d_ou.fk_org = d_o.pk))))) AS is_praxis,
    d_o.fk_category AS pk_category_org,
    d_o.xmin AS xmin_org
   FROM (dem.org d_o
     LEFT JOIN dem.org_category d_oc ON ((d_o.fk_category = d_oc.pk)));


ALTER TABLE dem.v_orgs OWNER TO "gm-dbo";

--
-- Name: v_pat_addresses; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_pat_addresses AS
 SELECT d_vp.pk_identity,
    d_va.pk_address,
    d_at.name AS address_type,
    public._(d_at.name) AS l10n_address_type,
    d_vp.title,
    d_vp.firstnames,
    d_vp.lastnames,
    d_vp.dob,
    d_vp.gender,
    d_vp.l10n_gender,
    d_vp.preferred,
    d_va.street,
    d_va.postcode,
    d_va.notes_street,
    d_va.number,
    d_va.subunit,
    d_va.notes_subunit,
    d_va.lat_lon_address,
    d_va.postcode_street,
    d_va.lat_lon_street,
    d_va.suburb,
    d_va.urb,
    d_va.postcode_urb,
    d_va.lat_lon_urb,
    d_va.code_region,
    d_va.region,
    d_va.l10n_region,
    d_va.code_country,
    d_va.country,
    d_va.l10n_country,
    d_va.country_deprecated,
    d_va.pk_street,
    d_va.pk_urb,
    d_va.pk_region,
    d_lpoa.id AS pk_lnk_person_org_address,
    d_lpoa.id_type AS pk_address_type,
    d_lpoa.xmin AS xmin_lnk_person_org_address
   FROM (((dem.lnk_person_org_address d_lpoa
     JOIN dem.v_address d_va ON ((d_lpoa.id_address = d_va.pk_address)))
     JOIN dem.address_type d_at ON ((d_lpoa.id_type = d_at.id)))
     JOIN dem.v_all_persons d_vp ON ((d_lpoa.id_identity = d_vp.pk_identity)));


ALTER TABLE dem.v_pat_addresses OWNER TO "gm-dbo";

--
-- Name: VIEW v_pat_addresses; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_pat_addresses IS 'denormalized addresses per person';


--
-- Name: v_person_comms; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_person_comms AS
 SELECT li2c.fk_identity AS pk_identity,
    ect.description AS comm_type,
    public._(ect.description) AS l10n_comm_type,
    li2c.url,
    li2c.is_confidential,
    li2c.comment,
    li2c.pk AS pk_lnk_identity2comm,
    li2c.fk_address AS pk_address,
    li2c.fk_type AS pk_type,
    li2c.xmin AS xmin_lnk_identity2comm
   FROM dem.lnk_identity2comm li2c,
    dem.enum_comm_types ect
  WHERE (li2c.fk_type = ect.pk);


ALTER TABLE dem.v_person_comms OWNER TO "gm-dbo";

--
-- Name: VIEW v_person_comms; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_person_comms IS 'denormalizes persons to communications channels';


--
-- Name: v_person_jobs; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_person_jobs AS
 SELECT lj2p.fk_identity AS pk_identity,
    o.name AS occupation,
    public._(o.name) AS l10n_occupation,
    lj2p.activities,
    lj2p.modified_when,
    lj2p.fk_occupation AS pk_occupation,
    lj2p.pk AS pk_lnk_job2person,
    lj2p.xmin AS xmin_lnk_job2person
   FROM (dem.lnk_job2person lj2p
     JOIN dem.occupation o ON ((lj2p.fk_occupation = o.id)));


ALTER TABLE dem.v_person_jobs OWNER TO "gm-dbo";

--
-- Name: VIEW v_person_jobs; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_person_jobs IS 'denormalizes the jobs a person has';


--
-- Name: v_person_names; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_person_names AS
 SELECT d_i.pk AS pk_identity,
    d_n.active AS active_name,
    d_i.title,
    d_n.firstnames,
    d_n.lastnames,
    d_n.preferred,
    d_n.comment,
    d_i.comment AS comment_identity,
    d_i.gender,
    d_i.dob,
    d_i.tob,
    d_i.deceased AS dod,
    d_i.deleted AS identity_deleted,
    (d_i.deceased IS NOT NULL) AS deceased,
    d_n.id AS pk_name,
    d_n.xmin AS xmin_name
   FROM (dem.names d_n
     JOIN dem.identity d_i ON ((d_n.id_identity = d_i.pk)))
  WHERE (d_i.pk = d_n.id_identity);


ALTER TABLE dem.v_person_names OWNER TO "gm-dbo";

--
-- Name: v_persons; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_persons AS
 SELECT i.pk AS pk_identity,
    i.title,
    n.firstnames,
    n.preferred,
    n.lastnames,
    i.gender,
    public._(i.gender) AS l10n_gender,
    i.dob AS dob_only,
    (date_trunc('day'::text, i.dob) + (COALESCE(i.tob, (i.dob)::time without time zone))::interval) AS dob,
    i.tob,
    i.deceased,
        CASE
            WHEN (i.fk_marital_status IS NULL) THEN 'unknown'::text
            ELSE ( SELECT ms.name
               FROM dem.marital_status ms,
                dem.identity i1
              WHERE ((ms.pk = i.fk_marital_status) AND (i1.pk = i.pk)))
        END AS marital_status,
        CASE
            WHEN (i.fk_marital_status IS NULL) THEN public._('unknown'::text)
            ELSE ( SELECT public._(ms1.name) AS _
               FROM dem.marital_status ms1,
                dem.identity i1
              WHERE ((ms1.pk = i.fk_marital_status) AND (i1.pk = i.pk)))
        END AS l10n_marital_status,
    i.emergency_contact,
    i.comment,
    i.deleted AS is_deleted,
    i.fk_marital_status AS pk_marital_status,
    n.id AS pk_active_name,
    i.fk_emergency_contact AS pk_emergency_contact,
    i.fk_primary_provider AS pk_primary_provider,
    i.xmin AS xmin_identity,
    i.dob_is_estimated
   FROM dem.identity i,
    dem.names n
  WHERE ((n.active IS TRUE) AND (n.id_identity = i.pk));


ALTER TABLE dem.v_persons OWNER TO "gm-dbo";

--
-- Name: VIEW v_persons; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_persons IS 'This view denormalizes persons with their active name.';


--
-- Name: v_praxis_branches; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_praxis_branches AS
 SELECT branches_w_orgs.pk_praxis_branch,
    branches_w_orgs.branch,
    branches_w_orgs.pk_org_unit,
    branches_w_orgs.pk_category_unit,
    branches_w_orgs.pk_address,
    branches_w_orgs.pk_org,
    branches_w_orgs.xmin_praxis_branch,
    branches_w_orgs.xmin_org_unit,
    branches_w_orgs.praxis,
    branches_w_orgs.pk_category_org,
    d_ocat.description AS organization_category,
    public._(d_ocat.description) AS l10n_organization_category,
    d_ucat.description AS unit_category,
    public._(d_ucat.description) AS l10n_unit_category
   FROM ((( SELECT branches_w_units.pk_praxis_branch,
            branches_w_units.branch,
            branches_w_units.pk_org_unit,
            branches_w_units.pk_category_unit,
            branches_w_units.pk_address,
            branches_w_units.pk_org,
            branches_w_units.xmin_praxis_branch,
            branches_w_units.xmin_org_unit,
            d_o.description AS praxis,
            d_o.fk_category AS pk_category_org
           FROM (( SELECT d_pb.pk AS pk_praxis_branch,
                    d_ou.description AS branch,
                    d_pb.fk_org_unit AS pk_org_unit,
                    d_ou.fk_category AS pk_category_unit,
                    d_ou.fk_address AS pk_address,
                    d_ou.fk_org AS pk_org,
                    d_pb.xmin AS xmin_praxis_branch,
                    d_ou.xmin AS xmin_org_unit
                   FROM (dem.praxis_branch d_pb
                     JOIN dem.org_unit d_ou ON ((d_pb.fk_org_unit = d_ou.pk)))) branches_w_units
             JOIN dem.org d_o ON ((d_o.pk = branches_w_units.pk_org)))) branches_w_orgs
     LEFT JOIN dem.org_category d_ucat ON ((branches_w_orgs.pk_category_unit = d_ucat.pk)))
     LEFT JOIN dem.org_category d_ocat ON ((branches_w_orgs.pk_category_org = d_ocat.pk)));


ALTER TABLE dem.v_praxis_branches OWNER TO "gm-dbo";

--
-- Name: VIEW v_praxis_branches; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_praxis_branches IS 'Denormalized praxis branches with their praxis.';


--
-- Name: v_region; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_region AS
 SELECT d_r.pk AS pk_region,
    d_r.code AS code_region,
    d_r.name AS region,
    public._(d_r.name) AS l10n_region,
    d_r.country AS code_country,
    c.name AS country,
    public._(c.name) AS l10n_country,
    c.deprecated AS country_deprecated,
    d_r.xmin AS xmin_region
   FROM (dem.region d_r
     LEFT JOIN dem.country c ON ((d_r.country = c.code)));


ALTER TABLE dem.v_region OWNER TO "gm-dbo";

--
-- Name: VIEW v_region; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_region IS 'denormalizes region information';


--
-- Name: v_staff; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_staff AS
 SELECT d_vp.pk_identity,
    d_s.pk AS pk_staff,
    d_vp.title,
    d_vp.firstnames,
    d_vp.lastnames,
    d_s.short_alias,
        CASE
            WHEN ( SELECT (EXISTS ( SELECT 1
                       FROM pg_group
                      WHERE ((pg_group.groname = 'gm-doctors'::name) AND (( SELECT pg_user.usesysid
                               FROM pg_user
                              WHERE (pg_user.usename = d_s.db_user)) = ANY (pg_group.grolist))))) AS "exists") THEN 'full clinical access'::text
            WHEN ( SELECT (EXISTS ( SELECT 1
                       FROM pg_group
                      WHERE ((pg_group.groname = 'gm-nurses'::name) AND (( SELECT pg_user.usesysid
                               FROM pg_user
                              WHERE (pg_user.usename = d_s.db_user)) = ANY (pg_group.grolist))))) AS "exists") THEN 'limited clinical access'::text
            WHEN ( SELECT (EXISTS ( SELECT 1
                       FROM pg_group
                      WHERE ((pg_group.groname = 'gm-staff'::name) AND (( SELECT pg_user.usesysid
                               FROM pg_user
                              WHERE (pg_user.usename = d_s.db_user)) = ANY (pg_group.grolist))))) AS "exists") THEN 'non-clinical access'::text
            WHEN ( SELECT (EXISTS ( SELECT 1
                       FROM pg_group
                      WHERE ((pg_group.groname = 'gm-public'::name) AND (( SELECT pg_user.usesysid
                               FROM pg_user
                              WHERE (pg_user.usename = d_s.db_user)) = ANY (pg_group.grolist))))) AS "exists") THEN 'public access'::text
            ELSE NULL::text
        END AS role,
    d_vp.dob,
    d_vp.gender,
    d_s.db_user,
    d_s.comment,
    d_s.is_active,
    d_vp.is_deleted AS person_is_deleted,
    ( SELECT (( SELECT (EXISTS ( SELECT 1
                           FROM pg_group
                          WHERE ((( SELECT pg_user.usesysid
                                   FROM pg_user
                                  WHERE (pg_user.usename = d_s.db_user)) = ANY (pg_group.grolist)) AND (pg_group.groname = current_database())))) AS "exists") AND ( SELECT (EXISTS ( SELECT 1
                           FROM pg_group
                          WHERE ((( SELECT pg_user.usesysid
                                   FROM pg_user
                                  WHERE (pg_user.usename = d_s.db_user)) = ANY (pg_group.grolist)) AND (pg_group.groname = 'gm-logins'::name)))) AS "exists"))) AS can_login,
    d_s.xmin AS xmin_staff
   FROM (dem.staff d_s
     JOIN dem.v_all_persons d_vp ON ((d_s.fk_identity = d_vp.pk_identity)));


ALTER TABLE dem.v_staff OWNER TO "gm-dbo";

--
-- Name: VIEW v_staff; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_staff IS 'Denormalized staff data.';


--
-- Name: v_urb; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_urb AS
 SELECT d_u.id AS pk_urb,
    d_u.name AS urb,
    d_u.postcode AS postcode_urb,
    d_u.lat_lon AS lat_lon_urb,
    d_vr.code_region,
    d_vr.region,
    d_vr.l10n_region,
    d_vr.code_country,
    d_vr.country,
    d_vr.l10n_country,
    d_vr.country_deprecated,
    d_u.fk_region AS pk_region,
    d_u.xmin AS xmin_urb
   FROM (dem.urb d_u
     LEFT JOIN dem.v_region d_vr ON ((d_vr.pk_region = d_u.fk_region)));


ALTER TABLE dem.v_urb OWNER TO "gm-dbo";

--
-- Name: VIEW v_urb; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_urb IS 'denormalizes urb data';


--
-- Name: v_street; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_street AS
 SELECT d_st.id AS pk_street,
    d_st.name AS street,
    COALESCE(d_st.postcode, d_vu.postcode_urb) AS postcode,
    d_st.postcode AS postcode_street,
    d_st.lat_lon AS lat_lon_street,
    d_st.suburb,
    d_vu.urb,
    d_vu.postcode_urb,
    d_vu.lat_lon_urb,
    d_vu.code_region,
    d_vu.region,
    d_vu.l10n_region,
    d_vu.code_country,
    d_vu.country,
    d_vu.l10n_country,
    d_vu.country_deprecated,
    d_st.id_urb AS pk_urb,
    d_vu.pk_region,
    d_st.xmin AS xmin_street
   FROM (dem.street d_st
     LEFT JOIN dem.v_urb d_vu ON ((d_st.id_urb = d_vu.pk_urb)));


ALTER TABLE dem.v_street OWNER TO "gm-dbo";

--
-- Name: VIEW v_street; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_street IS 'denormalizes street data';


--
-- Name: v_zip2street; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_zip2street AS
 SELECT COALESCE(d_str.postcode, d_u.postcode) AS postcode,
    d_str.name AS street,
    d_str.suburb,
    d_r.name AS region,
    d_r.code AS code_region,
    d_u.name AS urb,
    d_c.name AS country,
    public._(d_c.name) AS l10n_country,
    d_r.country AS code_country
   FROM dem.street d_str,
    dem.urb d_u,
    dem.region d_r,
    dem.country d_c
  WHERE ((d_str.postcode IS NOT NULL) AND (d_str.id_urb = d_u.id) AND (d_u.fk_region = d_r.pk) AND (d_r.country = d_c.code));


ALTER TABLE dem.v_zip2street OWNER TO "gm-dbo";

--
-- Name: VIEW v_zip2street; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_zip2street IS 'list known data for streets that have a zip code';


--
-- Name: v_uniq_zipped_urbs; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_uniq_zipped_urbs AS
 SELECT d_u.postcode,
    d_u.name,
    d_r.name AS region,
    d_r.code AS code_region,
    d_c.name AS country,
    public._(d_c.name) AS l10n_country,
    d_r.country AS code_country
   FROM dem.urb d_u,
    dem.region d_r,
    dem.country d_c
  WHERE ((d_u.postcode IS NOT NULL) AND (NOT (EXISTS ( SELECT 1
           FROM dem.v_zip2street d_vz2str
          WHERE ((d_vz2str.postcode = d_u.postcode) AND (d_vz2str.urb = d_u.name))))) AND (d_u.fk_region = d_r.pk) AND (d_r.country = d_c.code));


ALTER TABLE dem.v_uniq_zipped_urbs OWNER TO "gm-dbo";

--
-- Name: VIEW v_uniq_zipped_urbs; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_uniq_zipped_urbs IS 'convenience view that selects urbs which:
	 - have a zip code
	 - are not referenced in table "street" with that zip code';


--
-- Name: v_zip2data; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_zip2data AS
 SELECT d_vz2s.postcode AS zip,
    d_vz2s.street,
    d_vz2s.suburb,
    d_vz2s.urb,
    d_vz2s.region,
    d_vz2s.code_region,
    d_vz2s.country,
    d_vz2s.l10n_country,
    d_vz2s.code_country
   FROM dem.v_zip2street d_vz2s
UNION
 SELECT d_vuzu.postcode AS zip,
    NULL::text AS street,
    NULL::text AS suburb,
    d_vuzu.name AS urb,
    d_vuzu.region,
    d_vuzu.code_region,
    d_vuzu.country,
    d_vuzu.l10n_country,
    d_vuzu.code_country
   FROM dem.v_uniq_zipped_urbs d_vuzu;


ALTER TABLE dem.v_zip2data OWNER TO "gm-dbo";

--
-- Name: VIEW v_zip2data; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_zip2data IS 'aggregates nearly all known data per zip code';


--
-- Name: v_zip2urb; Type: VIEW; Schema: dem; Owner: gm-dbo
--

CREATE VIEW dem.v_zip2urb AS
 SELECT d_u.postcode,
    d_u.name AS urb,
    d_r.name AS region,
    d_r.code AS code_region,
    public._(d_c.name) AS country,
    d_r.country AS code_country
   FROM dem.urb d_u,
    dem.region d_r,
    dem.country d_c
  WHERE ((d_u.postcode IS NOT NULL) AND (d_u.fk_region = d_r.pk) AND (d_r.country = d_c.code));


ALTER TABLE dem.v_zip2urb OWNER TO "gm-dbo";

--
-- Name: VIEW v_zip2urb; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON VIEW dem.v_zip2urb IS 'list known data for urbs that have a zip code';


--
-- Name: access_log_pk_seq; Type: SEQUENCE; Schema: gm; Owner: gm-dbo
--

CREATE SEQUENCE gm.access_log_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE gm.access_log_pk_seq OWNER TO "gm-dbo";

--
-- Name: access_log_pk_seq; Type: SEQUENCE OWNED BY; Schema: gm; Owner: gm-dbo
--

ALTER SEQUENCE gm.access_log_pk_seq OWNED BY gm.access_log.pk;


--
-- Name: schema_revision; Type: TABLE; Schema: gm; Owner: gm-dbo
--

CREATE TABLE gm.schema_revision (
    pk integer NOT NULL,
    filename text NOT NULL,
    version text NOT NULL,
    imported timestamp with time zone DEFAULT now() NOT NULL
);


ALTER TABLE gm.schema_revision OWNER TO "gm-dbo";

--
-- Name: TABLE schema_revision; Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON TABLE gm.schema_revision IS 'this table holds the revisions of all SQL scripts ever
	 inserted into this database, the values are preferably
	 provided by CVS tags in the scripts themselves, see above
	 for a convenient way to do that';


--
-- Name: COLUMN schema_revision.filename; Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON COLUMN gm.schema_revision.filename IS 'the name of the script, handled most easily by CVS via "RCSfile"';


--
-- Name: COLUMN schema_revision.version; Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON COLUMN gm.schema_revision.version IS 'the version of the script, handled most easily by CVS via "Revision"';


--
-- Name: COLUMN schema_revision.imported; Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON COLUMN gm.schema_revision.imported IS 'when this script was imported, mainly for debugging';


--
-- Name: gm_schema_revision_pk_seq; Type: SEQUENCE; Schema: gm; Owner: gm-dbo
--

CREATE SEQUENCE gm.gm_schema_revision_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE gm.gm_schema_revision_pk_seq OWNER TO "gm-dbo";

--
-- Name: gm_schema_revision_pk_seq; Type: SEQUENCE OWNED BY; Schema: gm; Owner: gm-dbo
--

ALTER SEQUENCE gm.gm_schema_revision_pk_seq OWNED BY gm.schema_revision.pk;


--
-- Name: notifying_tables; Type: TABLE; Schema: gm; Owner: gm-dbo
--

CREATE TABLE gm.notifying_tables (
    pk integer NOT NULL,
    schema_name name DEFAULT 'public'::name NOT NULL,
    table_name name NOT NULL
);


ALTER TABLE gm.notifying_tables OWNER TO "gm-dbo";

--
-- Name: TABLE notifying_tables; Type: COMMENT; Schema: gm; Owner: gm-dbo
--

COMMENT ON TABLE gm.notifying_tables IS 'All tables that want to send standard notifications
	 must be recorded in this table. Notification triggers
	 will be generated automatically for all tables recorded
	 here.';


--
-- Name: notifying_tables_pk_seq; Type: SEQUENCE; Schema: gm; Owner: gm-dbo
--

CREATE SEQUENCE gm.notifying_tables_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE gm.notifying_tables_pk_seq OWNER TO "gm-dbo";

--
-- Name: notifying_tables_pk_seq; Type: SEQUENCE OWNED BY; Schema: gm; Owner: gm-dbo
--

ALTER SEQUENCE gm.notifying_tables_pk_seq OWNED BY gm.notifying_tables.pk;


--
-- Name: curr_lang; Type: TABLE; Schema: i18n; Owner: gm-dbo
--

CREATE TABLE i18n.curr_lang (
    pk integer NOT NULL,
    db_user name DEFAULT "current_user"() NOT NULL,
    lang text NOT NULL,
    CONSTRAINT user_must_exist CHECK ((gm.user_exists(db_user) IS TRUE))
);


ALTER TABLE i18n.curr_lang OWNER TO "gm-dbo";

--
-- Name: TABLE curr_lang; Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON TABLE i18n.curr_lang IS 'holds the currently selected per-user default
	 language for fixed strings in the database';


--
-- Name: COLUMN curr_lang.db_user; Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON COLUMN i18n.curr_lang.db_user IS 'The database account this language setting applies to.';


--
-- Name: curr_lang_pk_seq; Type: SEQUENCE; Schema: i18n; Owner: gm-dbo
--

CREATE SEQUENCE i18n.curr_lang_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE i18n.curr_lang_pk_seq OWNER TO "gm-dbo";

--
-- Name: curr_lang_pk_seq; Type: SEQUENCE OWNED BY; Schema: i18n; Owner: gm-dbo
--

ALTER SEQUENCE i18n.curr_lang_pk_seq OWNED BY i18n.curr_lang.pk;


--
-- Name: keys; Type: TABLE; Schema: i18n; Owner: gm-dbo
--

CREATE TABLE i18n.keys (
    pk integer NOT NULL,
    orig text NOT NULL
);


ALTER TABLE i18n.keys OWNER TO "gm-dbo";

--
-- Name: TABLE keys; Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON TABLE i18n.keys IS 'this table holds all the original strings that need
	 translation so give this to your language teams,
	 the function i18n.i18n() will take care to enter relevant
	 strings into this table, the table table does NOT
	 play any role in runtime translation activity';


--
-- Name: keys_pk_seq; Type: SEQUENCE; Schema: i18n; Owner: gm-dbo
--

CREATE SEQUENCE i18n.keys_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE i18n.keys_pk_seq OWNER TO "gm-dbo";

--
-- Name: keys_pk_seq; Type: SEQUENCE OWNED BY; Schema: i18n; Owner: gm-dbo
--

ALTER SEQUENCE i18n.keys_pk_seq OWNED BY i18n.keys.pk;


--
-- Name: translations; Type: TABLE; Schema: i18n; Owner: gm-dbo
--

CREATE TABLE i18n.translations (
    pk integer NOT NULL,
    lang text NOT NULL,
    orig text NOT NULL,
    trans text NOT NULL,
    CONSTRAINT i18n_translations_sane_trans CHECK ((trans <> orig))
);


ALTER TABLE i18n.translations OWNER TO "gm-dbo";

--
-- Name: TABLE translations; Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON TABLE i18n.translations IS 'this table holds all the translated strings';


--
-- Name: COLUMN translations.lang; Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON COLUMN i18n.translations.lang IS 'the language (corresponding to i18n.curr_lang for
	 a given user) that this translation belongs to';


--
-- Name: COLUMN translations.orig; Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON COLUMN i18n.translations.orig IS 'the original, untranslated string, used as the search key.';


--
-- Name: COLUMN translations.trans; Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON COLUMN i18n.translations.trans IS 'the translation of <orig> into <lang>';


--
-- Name: translations_pk_seq; Type: SEQUENCE; Schema: i18n; Owner: gm-dbo
--

CREATE SEQUENCE i18n.translations_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE i18n.translations_pk_seq OWNER TO "gm-dbo";

--
-- Name: translations_pk_seq; Type: SEQUENCE OWNED BY; Schema: i18n; Owner: gm-dbo
--

ALTER SEQUENCE i18n.translations_pk_seq OWNED BY i18n.translations.pk;


--
-- Name: v_missing_translations; Type: VIEW; Schema: i18n; Owner: gm-dbo
--

CREATE VIEW i18n.v_missing_translations AS
 SELECT i_cl.lang,
    i_k.orig,
    public._(i_k.orig, 'en'::text) AS english
   FROM ( SELECT DISTINCT ON (curr_lang.lang) curr_lang.lang
           FROM i18n.curr_lang) i_cl,
    i18n.keys i_k
  WHERE (NOT (i_k.orig IN ( SELECT i_t.orig
           FROM i18n.translations i_t
          WHERE (i_t.lang = i_cl.lang))));


ALTER TABLE i18n.v_missing_translations OWNER TO "gm-dbo";

--
-- Name: VIEW v_missing_translations; Type: COMMENT; Schema: i18n; Owner: gm-dbo
--

COMMENT ON VIEW i18n.v_missing_translations IS 'lists per language which strings are lacking a translation';


--
-- Name: basic_unit; Type: TABLE; Schema: public; Owner: gm-dbo
--

CREATE TABLE public.basic_unit (
    pk integer NOT NULL,
    name_short text NOT NULL,
    name_long text
);


ALTER TABLE public.basic_unit OWNER TO "gm-dbo";

--
-- Name: TABLE basic_unit; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON TABLE public.basic_unit IS 'basic units are SI units, units derived from them and the Unity';


--
-- Name: basic_unit_pk_seq; Type: SEQUENCE; Schema: public; Owner: gm-dbo
--

CREATE SEQUENCE public.basic_unit_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.basic_unit_pk_seq OWNER TO "gm-dbo";

--
-- Name: basic_unit_pk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: gm-dbo
--

ALTER SEQUENCE public.basic_unit_pk_seq OWNED BY public.basic_unit.pk;


--
-- Name: form_field_types; Type: TABLE; Schema: public; Owner: gm-dbo
--

CREATE TABLE public.form_field_types (
    name text,
    pk integer NOT NULL
);


ALTER TABLE public.form_field_types OWNER TO "gm-dbo";

--
-- Name: form_field_types_pk_seq; Type: SEQUENCE; Schema: public; Owner: gm-dbo
--

CREATE SEQUENCE public.form_field_types_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.form_field_types_pk_seq OWNER TO "gm-dbo";

--
-- Name: form_field_types_pk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: gm-dbo
--

ALTER SEQUENCE public.form_field_types_pk_seq OWNED BY public.form_field_types.pk;


--
-- Name: form_fields; Type: TABLE; Schema: public; Owner: gm-dbo
--

CREATE TABLE public.form_fields (
    pk integer NOT NULL,
    fk_form integer NOT NULL,
    long_name text NOT NULL,
    template_placeholder text NOT NULL,
    help text,
    fk_type integer NOT NULL,
    param text,
    display_order integer
);


ALTER TABLE public.form_fields OWNER TO "gm-dbo";

--
-- Name: TABLE form_fields; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON TABLE public.form_fields IS 'List of fields for a particular form';


--
-- Name: COLUMN form_fields.long_name; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.form_fields.long_name IS 'The full name of the form field as presented to the user';


--
-- Name: COLUMN form_fields.template_placeholder; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.form_fields.template_placeholder IS 'The name of the field as exposed to the form template.
	 In other words, the placeholder in form_defs.template where
	 the value entered into this field ist to be substituted.
	 Must be a valid identifier in the form template''s
	 script language (viz. Python)';


--
-- Name: COLUMN form_fields.help; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.form_fields.help IS 'longer help text';


--
-- Name: COLUMN form_fields.fk_type; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.form_fields.fk_type IS 'the field type';


--
-- Name: COLUMN form_fields.param; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.form_fields.param IS 'a parameter for the field''s behaviour, meaning is type-dependent';


--
-- Name: COLUMN form_fields.display_order; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.form_fields.display_order IS 'used to *suggest* display order, but client may ignore';


--
-- Name: form_fields_pk_seq; Type: SEQUENCE; Schema: public; Owner: gm-dbo
--

CREATE SEQUENCE public.form_fields_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.form_fields_pk_seq OWNER TO "gm-dbo";

--
-- Name: form_fields_pk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: gm-dbo
--

ALTER SEQUENCE public.form_fields_pk_seq OWNED BY public.form_fields.pk;


--
-- Name: form_job_queue; Type: TABLE; Schema: public; Owner: gm-dbo
--

CREATE TABLE public.form_job_queue (
    pk integer NOT NULL,
    fk_form_instance integer NOT NULL,
    form bytea NOT NULL,
    fk_job_target integer NOT NULL,
    submitted_when timestamp with time zone DEFAULT now() NOT NULL,
    fk_submitted_by integer NOT NULL,
    submitted_from text NOT NULL,
    status text DEFAULT 'submitted'::text NOT NULL
);


ALTER TABLE public.form_job_queue OWNER TO "gm-dbo";

--
-- Name: TABLE form_job_queue; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON TABLE public.form_job_queue IS 'Queue table for rendered form instances. Note that
	 the rows in this table will get deleted after processing.
	 This is NOT an archive of form jobs.';


--
-- Name: COLUMN form_job_queue.fk_form_instance; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.form_job_queue.fk_form_instance IS 'points to the unrendered source instance of the form,
	 useful for recalling submitted jobs for changing';


--
-- Name: COLUMN form_job_queue.form; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.form_job_queue.form IS 'the rendered form, IOW binary data such as a PDF file';


--
-- Name: COLUMN form_job_queue.fk_job_target; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.form_job_queue.fk_job_target IS 'points to the job target';


--
-- Name: COLUMN form_job_queue.submitted_when; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.form_job_queue.submitted_when IS 'when was this form job submitted';


--
-- Name: COLUMN form_job_queue.fk_submitted_by; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.form_job_queue.fk_submitted_by IS 'who of the staff submitted this form job';


--
-- Name: COLUMN form_job_queue.submitted_from; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.form_job_queue.submitted_from IS 'the workplace this form job was submitted from';


--
-- Name: COLUMN form_job_queue.status; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.form_job_queue.status IS 'status of the form job:
	 - submitted: ready for processing
	 - in progress: being processed
	 - removable: fit for removal (either cancelled, timed out or done)
	 - halted: do not process';


--
-- Name: form_job_queue_pk_seq; Type: SEQUENCE; Schema: public; Owner: gm-dbo
--

CREATE SEQUENCE public.form_job_queue_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.form_job_queue_pk_seq OWNER TO "gm-dbo";

--
-- Name: form_job_queue_pk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: gm-dbo
--

ALTER SEQUENCE public.form_job_queue_pk_seq OWNED BY public.form_job_queue.pk;


--
-- Name: form_job_targets; Type: TABLE; Schema: public; Owner: gm-dbo
--

CREATE TABLE public.form_job_targets (
    pk integer NOT NULL,
    target text NOT NULL
);


ALTER TABLE public.form_job_targets OWNER TO "gm-dbo";

--
-- Name: TABLE form_job_targets; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON TABLE public.form_job_targets IS 'the form job targets (eg. printers, faxes, smtp servers) in
	 whatever granularity is needed locally, can be used for load
	 balancing/round robin servicing busy queues';


--
-- Name: form_job_targets_pk_seq; Type: SEQUENCE; Schema: public; Owner: gm-dbo
--

CREATE SEQUENCE public.form_job_targets_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.form_job_targets_pk_seq OWNER TO "gm-dbo";

--
-- Name: form_job_targets_pk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: gm-dbo
--

ALTER SEQUENCE public.form_job_targets_pk_seq OWNED BY public.form_job_targets.pk;


--
-- Name: form_print_defs; Type: TABLE; Schema: public; Owner: gm-dbo
--

CREATE TABLE public.form_print_defs (
    pk integer NOT NULL,
    fk_form integer NOT NULL,
    fk_papersize integer NOT NULL,
    offset_top integer DEFAULT 0 NOT NULL,
    offset_left integer DEFAULT 0 NOT NULL,
    pages integer DEFAULT 1 NOT NULL,
    printer text NOT NULL,
    tray text NOT NULL,
    manual_feed boolean DEFAULT false NOT NULL,
    papertype text NOT NULL,
    eject_direction character(1) NOT NULL,
    orientation character(1) NOT NULL
);


ALTER TABLE public.form_print_defs OWNER TO "gm-dbo";

--
-- Name: COLUMN form_print_defs.offset_top; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.form_print_defs.offset_top IS 'in mm - and yes, they do change even within one
	 type of form, but we do not want to change the
	 offset for all the fields in that case';


--
-- Name: COLUMN form_print_defs.papertype; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.form_print_defs.papertype IS 'type of paper such as "watermarked rose",
	 mainly for user interaction on manual_feed==true';


--
-- Name: form_print_defs_pk_seq; Type: SEQUENCE; Schema: public; Owner: gm-dbo
--

CREATE SEQUENCE public.form_print_defs_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.form_print_defs_pk_seq OWNER TO "gm-dbo";

--
-- Name: form_print_defs_pk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: gm-dbo
--

ALTER SEQUENCE public.form_print_defs_pk_seq OWNED BY public.form_print_defs.pk;


--
-- Name: gm_client_db_match; Type: TABLE; Schema: public; Owner: gm-dbo
--

CREATE TABLE public.gm_client_db_match (
    pk integer NOT NULL,
    client_type text NOT NULL,
    client_version text NOT NULL,
    db_identity_hash text NOT NULL
);


ALTER TABLE public.gm_client_db_match OWNER TO "gm-dbo";

--
-- Name: TABLE gm_client_db_match; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON TABLE public.gm_client_db_match IS 'allows lookup of whether a given client version
	 can work with a particular database revision';


--
-- Name: COLUMN gm_client_db_match.client_type; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.gm_client_db_match.client_type IS 'the type of client this row refers to';


--
-- Name: COLUMN gm_client_db_match.client_version; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.gm_client_db_match.client_version IS 'the version of the client this row refers to';


--
-- Name: COLUMN gm_client_db_match.db_identity_hash; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.gm_client_db_match.db_identity_hash IS 'the identity_hash of a database revision that
	 the client version can work with';


--
-- Name: gm_client_db_match_pk_seq; Type: SEQUENCE; Schema: public; Owner: gm-dbo
--

CREATE SEQUENCE public.gm_client_db_match_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.gm_client_db_match_pk_seq OWNER TO "gm-dbo";

--
-- Name: gm_client_db_match_pk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: gm-dbo
--

ALTER SEQUENCE public.gm_client_db_match_pk_seq OWNED BY public.gm_client_db_match.pk;


--
-- Name: housekeeping_todo; Type: TABLE; Schema: public; Owner: gm-dbo
--

CREATE TABLE public.housekeeping_todo (
    pk integer NOT NULL,
    reported_when timestamp with time zone DEFAULT now() NOT NULL,
    reported_by text DEFAULT "current_user"() NOT NULL,
    reported_to text DEFAULT 'admin'::text NOT NULL,
    problem text NOT NULL,
    solution text,
    context text,
    category text NOT NULL,
    cookie text,
    CONSTRAINT housekeeping_todo_reported_to_check CHECK ((reported_to = ANY (ARRAY['user'::text, 'admin'::text])))
);


ALTER TABLE public.housekeeping_todo OWNER TO "gm-dbo";

--
-- Name: TABLE housekeeping_todo; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON TABLE public.housekeeping_todo IS 'this table stores items that originate in headless processes
	 running in the background but need to be brought to the
	 attention of someone, say, errors that an integrity checker
	 may find';


--
-- Name: COLUMN housekeeping_todo.reported_by; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.housekeeping_todo.reported_by IS 'who or what reported this condition, may be a user or software';


--
-- Name: COLUMN housekeeping_todo.reported_to; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.housekeeping_todo.reported_to IS 'who is this condition reported to, user or admin,
	 used for filtering';


--
-- Name: COLUMN housekeeping_todo.problem; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.housekeeping_todo.problem IS 'a description of the reported condition';


--
-- Name: COLUMN housekeeping_todo.solution; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.housekeeping_todo.solution IS 'a proposed solution to the problem';


--
-- Name: COLUMN housekeeping_todo.context; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.housekeeping_todo.context IS 'specific context for this condition that would
	 make the problem field unnecessary complex and bulky';


--
-- Name: COLUMN housekeeping_todo.category; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.housekeeping_todo.category IS 'a category for the condition, this is used
	 for filtering, too';


--
-- Name: COLUMN housekeeping_todo.cookie; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.housekeeping_todo.cookie IS 'stores arbitrary information related to the condition,
	 mostly used for semantic duplicates detection, eg.
	 do not report on a single problem more than once in
	 subsequent runs of, say, an import script';


--
-- Name: housekeeping_todo_pk_seq; Type: SEQUENCE; Schema: public; Owner: gm-dbo
--

CREATE SEQUENCE public.housekeeping_todo_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.housekeeping_todo_pk_seq OWNER TO "gm-dbo";

--
-- Name: housekeeping_todo_pk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: gm-dbo
--

ALTER SEQUENCE public.housekeeping_todo_pk_seq OWNED BY public.housekeeping_todo.pk;


--
-- Name: test_norm; Type: TABLE; Schema: public; Owner: gm-dbo
--

CREATE TABLE public.test_norm (
    pk integer NOT NULL,
    fk_ref_src integer NOT NULL,
    data text NOT NULL,
    comment text
);


ALTER TABLE public.test_norm OWNER TO "gm-dbo";

--
-- Name: TABLE test_norm; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON TABLE public.test_norm IS 'each row defines one set of measurement reference data';


--
-- Name: COLUMN test_norm.fk_ref_src; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.test_norm.fk_ref_src IS 'source this reference data set was taken from';


--
-- Name: COLUMN test_norm.data; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.test_norm.data IS 'the actual reference data in some format,
	 say, XML or like in a *.conf file';


--
-- Name: test_norm_pk_seq; Type: SEQUENCE; Schema: public; Owner: gm-dbo
--

CREATE SEQUENCE public.test_norm_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.test_norm_pk_seq OWNER TO "gm-dbo";

--
-- Name: test_norm_pk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: gm-dbo
--

ALTER SEQUENCE public.test_norm_pk_seq OWNED BY public.test_norm.pk;


--
-- Name: unit; Type: TABLE; Schema: public; Owner: gm-dbo
--

CREATE TABLE public.unit (
    pk integer NOT NULL,
    fk_basic_unit integer,
    name_short text NOT NULL,
    name_long text,
    factor double precision DEFAULT 1.0 NOT NULL,
    shift double precision DEFAULT 0.0 NOT NULL
);


ALTER TABLE public.unit OWNER TO "gm-dbo";

--
-- Name: TABLE unit; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON TABLE public.unit IS 'units as used in real life';


--
-- Name: COLUMN unit.fk_basic_unit; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.unit.fk_basic_unit IS 'what is the SI-Standard unit for this, e.g. for the unit mg it is kg';


--
-- Name: COLUMN unit.factor; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.unit.factor IS 'what factor the value with this unit has to be multiplied with to get values in the basic_unit';


--
-- Name: COLUMN unit.shift; Type: COMMENT; Schema: public; Owner: gm-dbo
--

COMMENT ON COLUMN public.unit.shift IS 'what has to be added (after multiplying by factor) to a value with this unit to get values in the basic_unit';


--
-- Name: unit_pk_seq; Type: SEQUENCE; Schema: public; Owner: gm-dbo
--

CREATE SEQUENCE public.unit_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.unit_pk_seq OWNER TO "gm-dbo";

--
-- Name: unit_pk_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: gm-dbo
--

ALTER SEQUENCE public.unit_pk_seq OWNED BY public.unit.pk;


--
-- Name: atc; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.atc (
    pk integer NOT NULL,
    administration_route text
)
INHERITS (ref.coding_system_root);


ALTER TABLE ref.atc OWNER TO "gm-dbo";

--
-- Name: TABLE atc; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.atc IS 'holds ATC data';


--
-- Name: COLUMN atc.code; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.atc.code IS 'holds the ATC code';


--
-- Name: COLUMN atc.term; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.atc.term IS 'the name of the drug component';


--
-- Name: COLUMN atc.comment; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.atc.comment IS 'a comment on this ATC';


--
-- Name: COLUMN atc.administration_route; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.atc.administration_route IS 'by what route this drug is to be given';


--
-- Name: atc_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.atc_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.atc_pk_seq OWNER TO "gm-dbo";

--
-- Name: atc_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.atc_pk_seq OWNED BY ref.atc.pk;


--
-- Name: atc_staging; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.atc_staging (
    atc text,
    name text,
    ddd text,
    unit text,
    adro text,
    comment text
);


ALTER TABLE ref.atc_staging OWNER TO "gm-dbo";

--
-- Name: TABLE atc_staging; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.atc_staging IS 'used for importing ATC data';


--
-- Name: auto_hint_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.auto_hint_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.auto_hint_pk_seq OWNER TO "gm-dbo";

--
-- Name: auto_hint_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.auto_hint_pk_seq OWNED BY ref.auto_hint.pk;


--
-- Name: billable_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.billable_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.billable_pk_seq OWNER TO "gm-dbo";

--
-- Name: billable_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.billable_pk_seq OWNED BY ref.billable.pk;


--
-- Name: coda; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.coda (
    pk integer NOT NULL,
    icd10_text text,
    CONSTRAINT chk_ref_coda_sane_icd10_text CHECK ((gm.is_null_or_blank_string(icd10_text) IS FALSE))
)
INHERITS (ref.coding_system_root);


ALTER TABLE ref.coda OWNER TO "gm-dbo";

--
-- Name: TABLE coda; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.coda IS 'Holds CodA/CodZ codes.';


--
-- Name: COLUMN coda.term; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.coda.term IS 'The Reason-For-Encounter like meaning of the code.';


--
-- Name: COLUMN coda.icd10_text; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.coda.icd10_text IS 'The text of the corresponding ICD-10 code.';


--
-- Name: coda_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.coda_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.coda_pk_seq OWNER TO "gm-dbo";

--
-- Name: coda_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.coda_pk_seq OWNED BY ref.coda.pk;


--
-- Name: code_thesaurus_root; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.code_thesaurus_root (
    pk_thesaurus integer NOT NULL,
    fk_code integer NOT NULL,
    synonym text,
    CONSTRAINT ref_code_thes_root_sane_synonym CHECK ((gm.is_null_or_blank_string(synonym) IS FALSE))
);


ALTER TABLE ref.code_thesaurus_root OWNER TO "gm-dbo";

--
-- Name: TABLE code_thesaurus_root; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.code_thesaurus_root IS 'Synonyms for coded terms.';


--
-- Name: code_thesaurus_root_pk_thesaurus_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.code_thesaurus_root_pk_thesaurus_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.code_thesaurus_root_pk_thesaurus_seq OWNER TO "gm-dbo";

--
-- Name: code_thesaurus_root_pk_thesaurus_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.code_thesaurus_root_pk_thesaurus_seq OWNED BY ref.code_thesaurus_root.pk_thesaurus;


--
-- Name: coding_system_root_pk_coding_system_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.coding_system_root_pk_coding_system_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.coding_system_root_pk_coding_system_seq OWNER TO "gm-dbo";

--
-- Name: coding_system_root_pk_coding_system_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.coding_system_root_pk_coding_system_seq OWNED BY ref.coding_system_root.pk_coding_system;


--
-- Name: data_source_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.data_source_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.data_source_pk_seq OWNER TO "gm-dbo";

--
-- Name: data_source_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.data_source_pk_seq OWNED BY ref.data_source.pk;


--
-- Name: document_type_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.document_type_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.document_type_pk_seq OWNER TO "gm-dbo";

--
-- Name: document_type_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.document_type_pk_seq OWNED BY ref.document_type.pk;


--
-- Name: dose_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.dose_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.dose_pk_seq OWNER TO "gm-dbo";

--
-- Name: dose_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.dose_pk_seq OWNED BY ref.dose.pk;


--
-- Name: form_types; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.form_types (
    name text NOT NULL,
    pk integer NOT NULL
);


ALTER TABLE ref.form_types OWNER TO "gm-dbo";

--
-- Name: TABLE form_types; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.form_types IS 'types of forms which are available, generally by purpose
	 (radiology, pathology, sick leave, Therapiebericht etc.)';


--
-- Name: form_types_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.form_types_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.form_types_pk_seq OWNER TO "gm-dbo";

--
-- Name: form_types_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.form_types_pk_seq OWNED BY ref.form_types.pk;


--
-- Name: icd10; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.icd10 (
    pk integer NOT NULL,
    star_code text,
    aux_code text,
    CONSTRAINT chk_ref_icd10_sane_aux_code CHECK ((gm.is_null_or_non_empty_string(aux_code) IS TRUE)),
    CONSTRAINT chk_ref_icd10_sane_star_code CHECK ((gm.is_null_or_non_empty_string(star_code) IS TRUE))
)
INHERITS (ref.coding_system_root);


ALTER TABLE ref.icd10 OWNER TO "gm-dbo";

--
-- Name: TABLE icd10; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.icd10 IS 'Holds ICD-10 codes.';


--
-- Name: COLUMN icd10.star_code; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.icd10.star_code IS 'The star code which needs to be combined with the primary code to define the term.';


--
-- Name: COLUMN icd10.aux_code; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.icd10.aux_code IS 'The auxiliary code which needs to be combined with the primary code to define the term.';


--
-- Name: icd10_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.icd10_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.icd10_pk_seq OWNER TO "gm-dbo";

--
-- Name: icd10_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.icd10_pk_seq OWNED BY ref.icd10.pk;


--
-- Name: icd9; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.icd9 (
    pk integer NOT NULL
)
INHERITS (ref.coding_system_root);


ALTER TABLE ref.icd9 OWNER TO "gm-dbo";

--
-- Name: TABLE icd9; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.icd9 IS 'Holds ICD-9 codes.';


--
-- Name: icd9_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.icd9_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.icd9_pk_seq OWNER TO "gm-dbo";

--
-- Name: icd9_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.icd9_pk_seq OWNED BY ref.icd9.pk;


--
-- Name: icpc; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.icpc (
    pk integer NOT NULL,
    code_extension text,
    short_description text,
    icd10 text[],
    criteria text,
    inclusions text,
    exclusions text[],
    see_also text[],
    fk_component smallint NOT NULL,
    fk_chapter character(1) NOT NULL,
    CONSTRAINT ref_icpc_sane_code_ext CHECK ((gm.is_null_or_non_empty_string(code_extension) IS TRUE)),
    CONSTRAINT ref_icpc_sane_criteria CHECK ((gm.is_null_or_non_empty_string(criteria) IS TRUE)),
    CONSTRAINT ref_icpc_sane_exclusions CHECK (((exclusions IS NULL) OR (array_length(exclusions, 1) > 0))),
    CONSTRAINT ref_icpc_sane_icd10 CHECK (((icd10 IS NULL) OR (array_length(icd10, 1) > 0))),
    CONSTRAINT ref_icpc_sane_inclusions CHECK ((gm.is_null_or_non_empty_string(inclusions) IS TRUE)),
    CONSTRAINT ref_icpc_sane_see_also CHECK (((see_also IS NULL) OR (array_length(see_also, 1) > 0))),
    CONSTRAINT ref_icpc_sane_term CHECK ((gm.is_null_or_blank_string(term) IS FALSE))
)
INHERITS (ref.coding_system_root);


ALTER TABLE ref.icpc OWNER TO "gm-dbo";

--
-- Name: TABLE icpc; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.icpc IS 'This table holds ICPC2 codes along with local extensions.';


--
-- Name: COLUMN icpc.code_extension; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.icpc.code_extension IS 'An extension to the bare code as defined in, say, the Netherlands or Australia.';


--
-- Name: COLUMN icpc.short_description; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.icpc.short_description IS 'A shorter term for this item';


--
-- Name: COLUMN icpc.icd10; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.icpc.icd10 IS 'Array of corresponding ICD-10 codes.';


--
-- Name: COLUMN icpc.criteria; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.icpc.criteria IS 'Criteria to guide in selection of the appropriate code.';


--
-- Name: COLUMN icpc.inclusions; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.icpc.inclusions IS 'Items included under this code.';


--
-- Name: COLUMN icpc.exclusions; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.icpc.exclusions IS 'Items NOT included under this code because there is another code for them.';


--
-- Name: COLUMN icpc.see_also; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.icpc.see_also IS 'See also under these items.';


--
-- Name: icpc_chapter; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.icpc_chapter (
    pk integer NOT NULL,
    chapter character(1) NOT NULL,
    description text,
    CONSTRAINT ref_icpc_chapter_sane_desc CHECK ((gm.is_null_or_blank_string(description) IS FALSE))
);


ALTER TABLE ref.icpc_chapter OWNER TO "gm-dbo";

--
-- Name: TABLE icpc_chapter; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.icpc_chapter IS 'The chapters of the ICPC.';


--
-- Name: icpc_chapter_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.icpc_chapter_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.icpc_chapter_pk_seq OWNER TO "gm-dbo";

--
-- Name: icpc_chapter_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.icpc_chapter_pk_seq OWNED BY ref.icpc_chapter.pk;


--
-- Name: icpc_component; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.icpc_component (
    pk integer NOT NULL,
    component smallint NOT NULL,
    description text,
    typical_soap_cat text[],
    CONSTRAINT ref_icpc_component_sane_desc CHECK ((gm.is_null_or_blank_string(description) IS FALSE))
);


ALTER TABLE ref.icpc_component OWNER TO "gm-dbo";

--
-- Name: TABLE icpc_component; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.icpc_component IS 'The Components of the ICPC chapters.';


--
-- Name: COLUMN icpc_component.typical_soap_cat; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.icpc_component.typical_soap_cat IS 'An array of SOAP categories which codes from this component are typically used for.';


--
-- Name: icpc_component_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.icpc_component_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.icpc_component_pk_seq OWNER TO "gm-dbo";

--
-- Name: icpc_component_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.icpc_component_pk_seq OWNED BY ref.icpc_component.pk;


--
-- Name: icpc_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.icpc_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.icpc_pk_seq OWNER TO "gm-dbo";

--
-- Name: icpc_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.icpc_pk_seq OWNED BY ref.icpc.pk;


--
-- Name: icpc_thesaurus; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.icpc_thesaurus (
    pk integer NOT NULL,
    CONSTRAINT ref_icpc_thes_sane_synonym CHECK ((gm.is_null_or_blank_string(synonym) IS FALSE))
)
INHERITS (ref.code_thesaurus_root);


ALTER TABLE ref.icpc_thesaurus OWNER TO "gm-dbo";

--
-- Name: TABLE icpc_thesaurus; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.icpc_thesaurus IS 'Synonyms for ICPC terms.';


--
-- Name: icpc_thesaurus_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.icpc_thesaurus_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.icpc_thesaurus_pk_seq OWNER TO "gm-dbo";

--
-- Name: icpc_thesaurus_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.icpc_thesaurus_pk_seq OWNED BY ref.icpc_thesaurus.pk;


--
-- Name: keyword_expansion; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.keyword_expansion (
    pk integer NOT NULL,
    fk_staff integer,
    keyword text NOT NULL,
    textual_data text,
    owner text DEFAULT "current_user"() NOT NULL,
    encrypted boolean DEFAULT false NOT NULL,
    binary_data bytea,
    CONSTRAINT keyword_expansion_keyword_check CHECK ((btrim(keyword) <> ''::text)),
    CONSTRAINT ref_kwd_exp_binary_xor_textual CHECK ((((binary_data IS NULL) AND (textual_data IS NOT NULL)) OR ((binary_data IS NOT NULL) AND (textual_data IS NULL)))),
    CONSTRAINT ref_kwd_exp_sane_data CHECK (((binary_data IS NULL) OR (octet_length(binary_data) > 0))),
    CONSTRAINT ref_kwd_exp_sane_keyword CHECK ((gm.is_null_or_blank_string(keyword) IS FALSE)),
    CONSTRAINT ref_kwd_exp_sane_text CHECK ((gm.is_null_or_non_empty_string(textual_data) IS TRUE))
);


ALTER TABLE ref.keyword_expansion OWNER TO "gm-dbo";

--
-- Name: TABLE keyword_expansion; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.keyword_expansion IS 'Arbitrary binary or textual snippets of data. Used as text macros or document "ribbons".';


--
-- Name: COLUMN keyword_expansion.fk_staff; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.keyword_expansion.fk_staff IS 'The provider this expansion applies to.
If NULL: applies to all providers.';


--
-- Name: COLUMN keyword_expansion.keyword; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.keyword_expansion.keyword IS 'A keyword by which to uniquely identify this snippet. Can only exist once per provider.';


--
-- Name: COLUMN keyword_expansion.textual_data; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.keyword_expansion.textual_data IS 'This holds the text of non-binary snippets.';


--
-- Name: COLUMN keyword_expansion.owner; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.keyword_expansion.owner IS 'Who "owns" this text expansion.';


--
-- Name: COLUMN keyword_expansion.encrypted; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.keyword_expansion.encrypted IS 'If true the snippet is encrypted with GnuPG.';


--
-- Name: COLUMN keyword_expansion.binary_data; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.keyword_expansion.binary_data IS 'This holds the binary data of non-textual snippets';


--
-- Name: keyword_expansion_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.keyword_expansion_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.keyword_expansion_pk_seq OWNER TO "gm-dbo";

--
-- Name: keyword_expansion_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.keyword_expansion_pk_seq OWNED BY ref.keyword_expansion.pk;


--
-- Name: lnk_dose2drug_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.lnk_dose2drug_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.lnk_dose2drug_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_dose2drug_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.lnk_dose2drug_pk_seq OWNED BY ref.lnk_dose2drug.pk;


--
-- Name: lnk_loinc2substance_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.lnk_loinc2substance_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.lnk_loinc2substance_pk_seq OWNER TO "gm-dbo";

--
-- Name: lnk_loinc2substance_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.lnk_loinc2substance_pk_seq OWNED BY ref.lnk_loinc2substance.pk;


--
-- Name: loinc; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.loinc (
    pk integer NOT NULL,
    component text,
    property text,
    time_aspect text,
    system text,
    scale_type text,
    method_type text,
    related_names_1_old text,
    grouping_class text,
    loinc_internal_source text,
    dt_last_change text,
    change_type text,
    answer_list text,
    code_status text,
    maps_to text,
    scope text,
    normal_range text,
    ipcc_units text,
    reference text,
    exact_component_synonym text,
    molar_mass text,
    grouping_class_type smallint,
    formula text,
    species text,
    example_answers text,
    acs_synonyms text,
    base_name text,
    final text,
    naa_ccr_id text,
    code_table text,
    is_set_root boolean,
    panel_elements text,
    survey_question_text text,
    survey_question_source text,
    units_required text,
    submitted_units text,
    related_names_2 text,
    short_name text,
    order_obs text,
    cdisc_common_tests text,
    hl7_field_subfield_id text,
    external_copyright_notice text,
    example_units text,
    inpc_percentage text,
    long_common_name text
)
INHERITS (ref.coding_system_root);


ALTER TABLE ref.loinc OWNER TO "gm-dbo";

--
-- Name: TABLE loinc; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.loinc IS 'holds LOINC codes';


--
-- Name: COLUMN loinc.code; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.loinc.code IS 'holds LOINC_NUM';


--
-- Name: COLUMN loinc.term; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.loinc.term IS 'holds either long_common_name or a ":".join of .component to .method_type';


--
-- Name: COLUMN loinc.fk_data_source; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.loinc.fk_data_source IS 'points to a particular data source which in turn holds the version';


--
-- Name: loinc_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.loinc_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.loinc_pk_seq OWNER TO "gm-dbo";

--
-- Name: loinc_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.loinc_pk_seq OWNED BY ref.loinc.pk;


--
-- Name: ops; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.ops (
    pk integer NOT NULL,
    second_code text,
    requires_laterality boolean
)
INHERITS (ref.coding_system_root);


ALTER TABLE ref.ops OWNER TO "gm-dbo";

--
-- Name: TABLE ops; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.ops IS 'Holds OPS (German ICPM-CM) codes.';


--
-- Name: ops_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.ops_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.ops_pk_seq OWNER TO "gm-dbo";

--
-- Name: ops_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.ops_pk_seq OWNED BY ref.ops.pk;


--
-- Name: other_code; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.other_code (
    pk integer NOT NULL
)
INHERITS (ref.coding_system_root);


ALTER TABLE ref.other_code OWNER TO "gm-dbo";

--
-- Name: TABLE other_code; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.other_code IS 'Holds codes from "other" coding systems for which no specific tables exist just yet.';


--
-- Name: other_code_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.other_code_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.other_code_pk_seq OWNER TO "gm-dbo";

--
-- Name: other_code_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.other_code_pk_seq OWNED BY ref.other_code.pk;


--
-- Name: papersizes; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.papersizes (
    pk integer NOT NULL,
    name text NOT NULL,
    size point NOT NULL
);


ALTER TABLE ref.papersizes OWNER TO "gm-dbo";

--
-- Name: COLUMN papersizes.size; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.papersizes.size IS '(cm, cm)';


--
-- Name: papersizes_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.papersizes_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.papersizes_pk_seq OWNER TO "gm-dbo";

--
-- Name: papersizes_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.papersizes_pk_seq OWNED BY ref.papersizes.pk;


--
-- Name: paperwork_templates; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.paperwork_templates (
    pk integer NOT NULL,
    fk_template_type integer NOT NULL,
    instance_type text,
    name_short text NOT NULL,
    name_long text NOT NULL,
    external_version text NOT NULL,
    gnumed_revision double precision,
    engine text DEFAULT 'O'::text NOT NULL,
    in_use boolean DEFAULT true NOT NULL,
    filename text,
    data bytea,
    edit_after_substitution boolean DEFAULT true NOT NULL,
    CONSTRAINT ref_templates_engine_range CHECK ((engine = ANY (ARRAY['T'::text, 'L'::text, 'H'::text, 'O'::text, 'I'::text, 'G'::text, 'P'::text, 'A'::text, 'X'::text, 'S'::text])))
)
INHERITS (audit.audit_fields);


ALTER TABLE ref.paperwork_templates OWNER TO "gm-dbo";

--
-- Name: TABLE paperwork_templates; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.paperwork_templates IS 'form and letter template definitions';


--
-- Name: COLUMN paperwork_templates.instance_type; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.paperwork_templates.instance_type IS 'default document type to store documents generated from
	 this form under, note that this may generate rows in
	 blobs.doc_type if set to a non-existant document type';


--
-- Name: COLUMN paperwork_templates.name_short; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.paperwork_templates.name_short IS 'a short name for use in a GUI or some such';


--
-- Name: COLUMN paperwork_templates.name_long; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.paperwork_templates.name_long IS 'a long name unambigously describing the form';


--
-- Name: COLUMN paperwork_templates.gnumed_revision; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.paperwork_templates.gnumed_revision IS 'GnuMed internal form def version, may
	 occur if we rolled out a faulty form def';


--
-- Name: COLUMN paperwork_templates.engine; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.paperwork_templates.engine IS 'the business layer forms engine used to process this form,
	currently:
	- T: plain text (generic postprocessing)
	- L: LaTeX
	- H: HTML
	- O: OpenOffice
	- I: image editor (visual progress notes)
	- G: gnuplot scripts (test results graphing)
	- P: PDF form (FDF based)
	- A: AbiWord
	- X: Xe(La)TeX
	- S: XSLT';


--
-- Name: COLUMN paperwork_templates.in_use; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.paperwork_templates.in_use IS 'whether this template is currently actively
	 used in a given practice';


--
-- Name: COLUMN paperwork_templates.filename; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.paperwork_templates.filename IS 'the filename from when the template data was imported if applicable,
	 used by some engines (such as OOo) to differentiate what to do
	 with certain files, such as *.ott vs. *.ods, GNUmed uses it
	 to derive a file extension when exporting the template data';


--
-- Name: COLUMN paperwork_templates.data; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.paperwork_templates.data IS 'the template complete with placeholders in
	 the format accepted by the engine defined in
	 ref.paperwork_templates.engine';


--
-- Name: COLUMN paperwork_templates.edit_after_substitution; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON COLUMN ref.paperwork_templates.edit_after_substitution IS 'Whether to offer last-minute, manual, generic editing inbetween placeholder substitution and final output generation.';


--
-- Name: paperwork_templates_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.paperwork_templates_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.paperwork_templates_pk_seq OWNER TO "gm-dbo";

--
-- Name: paperwork_templates_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.paperwork_templates_pk_seq OWNED BY ref.paperwork_templates.pk;


--
-- Name: substance_brand_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.substance_brand_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.substance_brand_pk_seq OWNER TO "gm-dbo";

--
-- Name: substance_brand_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.substance_brand_pk_seq OWNED BY ref.drug_product.pk;


--
-- Name: substance_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.substance_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.substance_pk_seq OWNER TO "gm-dbo";

--
-- Name: substance_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.substance_pk_seq OWNED BY ref.substance.pk;


--
-- Name: tag_image_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.tag_image_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.tag_image_pk_seq OWNER TO "gm-dbo";

--
-- Name: tag_image_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.tag_image_pk_seq OWNED BY ref.tag_image.pk;


--
-- Name: v_atc; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_atc AS
 SELECT a.pk AS pk_atc,
    a.code AS atc,
    a.term,
    a.administration_route,
    a.comment,
    (octet_length(a.code) < 7) AS is_group_code,
    (octet_length(a.code) - (octet_length(a.code) / 3)) AS atc_level,
    rds.name_long,
    rds.name_short,
    rds.version,
    rds.lang,
    a.pk_coding_system,
    a.fk_data_source AS pk_data_source
   FROM (ref.atc a
     JOIN ref.data_source rds ON ((rds.pk = a.fk_data_source)));


ALTER TABLE ref.v_atc OWNER TO "gm-dbo";

--
-- Name: v_billables; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_billables AS
 SELECT r_b.pk AS pk_billable,
    r_b.code AS billable_code,
    r_b.term AS billable_description,
    r_b.amount AS raw_amount,
    (r_b.amount + (r_b.amount * r_b.vat_multiplier)) AS amount_with_vat,
    r_b.currency,
    r_b.comment,
    r_b.vat_multiplier,
    r_b.active,
    r_b.discountable,
    r_ds.name_long AS catalog_long,
    r_ds.name_short AS catalog_short,
    r_ds.version AS catalog_version,
    r_ds.lang AS catalog_language,
    r_b.fk_data_source AS pk_data_source,
    r_b.pk_coding_system AS pk_coding_system_root,
    r_b.xmin AS xmin_billable
   FROM (ref.billable r_b
     LEFT JOIN ref.data_source r_ds ON ((r_b.fk_data_source = r_ds.pk)));


ALTER TABLE ref.v_billables OWNER TO "gm-dbo";

--
-- Name: v_coded_terms; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_coded_terms AS
 SELECT r_csr.code,
    r_csr.term,
    r_ds.name_short AS coding_system,
    r_ds.name_long AS coding_system_long,
    r_ds.version,
    r_ds.lang,
    r_csr.pk_coding_system AS pk_generic_code
   FROM (ref.coding_system_root r_csr
     JOIN ref.data_source r_ds ON ((r_csr.fk_data_source = r_ds.pk)))
UNION
 SELECT ri.code,
    r_it.synonym AS term,
    r_ds.name_short AS coding_system,
    r_ds.name_long AS coding_system_long,
    r_ds.version,
    r_ds.lang,
    r_it.fk_code AS pk_generic_code
   FROM ((ref.icpc_thesaurus r_it
     LEFT JOIN ref.icpc ri ON ((r_it.fk_code = ri.pk_coding_system)))
     LEFT JOIN ref.data_source r_ds ON ((ri.fk_data_source = r_ds.pk)));


ALTER TABLE ref.v_coded_terms OWNER TO "gm-dbo";

--
-- Name: VIEW v_coded_terms; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON VIEW ref.v_coded_terms IS 'This view aggregates all official (reference) terms, including "official" synonyms, for which a corresponding code is known to the system.';


--
-- Name: v_substances; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_substances AS
 SELECT r_s.pk AS pk_substance,
    r_s.description AS substance,
    r_s.intake_instructions,
    r_s.atc,
    ARRAY( SELECT row_to_json(loinc_row.*) AS row_to_json
           FROM ( SELECT r_ll2s.loinc,
                    r_ll2s.comment,
                    date_part('epoch'::text, r_ll2s.max_age) AS max_age_in_secs,
                    (r_ll2s.max_age)::text AS max_age_str
                   FROM ref.lnk_loinc2substance r_ll2s
                  WHERE (r_ll2s.fk_substance = r_s.pk)) loinc_row) AS loincs,
    r_s.xmin AS xmin_substance
   FROM ref.substance r_s;


ALTER TABLE ref.v_substances OWNER TO "gm-dbo";

--
-- Name: v_substance_doses; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_substance_doses AS
 SELECT r_d.pk AS pk_dose,
    r_vs.substance,
    r_d.amount,
    r_d.unit,
    r_d.dose_unit,
    r_vs.intake_instructions,
    r_vs.atc AS atc_substance,
    r_vs.loincs,
    r_vs.pk_substance,
    r_d.xmin AS xmin_dose
   FROM (ref.dose r_d
     JOIN ref.v_substances r_vs ON ((r_d.fk_substance = r_vs.pk_substance)));


ALTER TABLE ref.v_substance_doses OWNER TO "gm-dbo";

--
-- Name: v_drug_components; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_drug_components AS
 SELECT r_ld2d.pk AS pk_component,
    r_dp.description AS product,
    r_vsd.substance,
    r_vsd.amount,
    r_vsd.unit,
    r_vsd.dose_unit,
    r_dp.preparation,
    public._(r_dp.preparation) AS l10n_preparation,
    r_vsd.intake_instructions,
    r_vsd.loincs,
    r_vsd.atc_substance,
    r_dp.atc_code AS atc_drug,
    r_dp.external_code,
    r_dp.external_code_type,
    r_dp.is_fake AS is_fake_product,
    (EXISTS ( SELECT 1
           FROM clin.substance_intake c_si
          WHERE (c_si.fk_drug_component = r_ld2d.pk)
         LIMIT 1)) AS is_in_use,
    r_dp.pk AS pk_drug_product,
    r_vsd.pk_dose,
    r_vsd.pk_substance,
    r_dp.fk_data_source AS pk_data_source,
    r_ld2d.xmin AS xmin_lnk_dose2drug
   FROM ((ref.lnk_dose2drug r_ld2d
     JOIN ref.drug_product r_dp ON ((r_ld2d.fk_drug_product = r_dp.pk)))
     JOIN ref.v_substance_doses r_vsd ON ((r_ld2d.fk_dose = r_vsd.pk_dose)));


ALTER TABLE ref.v_drug_components OWNER TO "gm-dbo";

--
-- Name: v_drug_products; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_drug_products AS
 SELECT r_dp.pk AS pk_drug_product,
    r_dp.description AS product,
    r_dp.preparation,
    public._(r_dp.preparation) AS l10n_preparation,
    r_dp.atc_code AS atc,
    r_dp.external_code,
    r_dp.external_code_type,
    r_dp.is_fake AS is_fake_product,
    (EXISTS ( SELECT 1
           FROM ref.vaccine c_v
          WHERE (c_v.fk_drug_product = r_dp.pk))) AS is_vaccine,
    ARRAY( SELECT row_to_json(component_row.*) AS row_to_json
           FROM ( SELECT r_vsd.substance,
                    r_vsd.amount,
                    r_vsd.unit,
                    r_vsd.dose_unit,
                    r_vsd.intake_instructions,
                    r_vsd.loincs,
                    r_vsd.atc_substance,
                    r_ld2d.pk AS pk_component,
                    r_vsd.pk_dose,
                    r_vsd.pk_substance
                   FROM (ref.lnk_dose2drug r_ld2d
                     JOIN ref.v_substance_doses r_vsd ON ((r_ld2d.fk_dose = r_vsd.pk_dose)))
                  WHERE (r_ld2d.fk_drug_product = r_dp.pk)) component_row) AS components,
    r_dp.fk_data_source AS pk_data_source,
    r_dp.xmin AS xmin_drug_product
   FROM ref.drug_product r_dp;


ALTER TABLE ref.v_drug_products OWNER TO "gm-dbo";

--
-- Name: v_generic_codes; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_generic_codes AS
 SELECT r_csr.pk_coding_system AS pk_generic_code,
    r_csr.code,
    r_csr.term,
    r_ds.name_long,
    r_ds.name_short,
    r_ds.version,
    r_ds.lang,
    (r_csr.tableoid)::regclass AS code_table,
    r_csr.fk_data_source AS pk_data_source
   FROM (ref.coding_system_root r_csr
     JOIN ref.data_source r_ds ON ((r_ds.pk = r_csr.fk_data_source)));


ALTER TABLE ref.v_generic_codes OWNER TO "gm-dbo";

--
-- Name: VIEW v_generic_codes; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON VIEW ref.v_generic_codes IS 'Denormalized generic codes.';


--
-- Name: v_icpc; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_icpc AS
 SELECT ri.code,
    ri.code_extension,
    (ri.code || COALESCE(ri.code_extension, ''::text)) AS extended_code,
    ri.term,
    ri.short_description,
    ri.fk_chapter AS code_chapter,
    rich.description AS chapter,
    public._(rich.description) AS l10n_chapter,
    ri.fk_component AS code_component,
    rico.description AS component,
    public._(rico.description) AS l10n_component,
    rico.typical_soap_cat,
    ri.icd10,
    ri.criteria,
    ri.inclusions,
    ri.exclusions,
    ri.see_also,
    ri.comment,
    rds.name_short,
    rds.name_long,
    rds.version,
    rds.lang,
    ri.pk AS pk_icpc,
    ri.fk_data_source AS pk_data_source
   FROM (((ref.icpc ri
     JOIN ref.data_source rds ON ((ri.fk_data_source = rds.pk)))
     JOIN ref.icpc_chapter rich ON ((ri.fk_chapter = rich.chapter)))
     JOIN ref.icpc_component rico ON ((ri.fk_component = rico.component)));


ALTER TABLE ref.v_icpc OWNER TO "gm-dbo";

--
-- Name: VIEW v_icpc; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON VIEW ref.v_icpc IS 'View over denormalized ICPC2 data.';


--
-- Name: v_icpc_thesaurus; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_icpc_thesaurus AS
 SELECT rit.pk AS pk_icpc_thesaurus,
    ri.code,
    ri.term,
    rit.synonym,
    rit.pk_thesaurus,
    rit.fk_code AS pk_coding_system,
    ri.pk AS pk_icpc
   FROM (ref.icpc_thesaurus rit
     JOIN ref.icpc ri ON ((rit.fk_code = ri.pk_coding_system)));


ALTER TABLE ref.v_icpc_thesaurus OWNER TO "gm-dbo";

--
-- Name: VIEW v_icpc_thesaurus; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON VIEW ref.v_icpc_thesaurus IS 'View over denormalized ICPC2 thesaurus.';


--
-- Name: vacc_route; Type: TABLE; Schema: ref; Owner: gm-dbo
--

CREATE TABLE ref.vacc_route (
    id integer NOT NULL,
    abbreviation text NOT NULL,
    description text NOT NULL
)
INHERITS (audit.audit_fields);


ALTER TABLE ref.vacc_route OWNER TO "gm-dbo";

--
-- Name: TABLE vacc_route; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON TABLE ref.vacc_route IS 'definition of route via which vaccine is given,
	 currently i.m. and p.o. only but may include
	 "via genetically engineered food" etc in the
	 future';


--
-- Name: v_indications4vaccine; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_indications4vaccine AS
 SELECT r_v.pk AS pk_vaccine,
    r_dp.description AS vaccine,
    r_dp.preparation,
    public._(r_dp.preparation) AS l10n_preparation,
    r_dp.atc_code,
    r_dp.is_fake AS is_fake_vaccine,
    r_vr.abbreviation AS route_abbreviation,
    r_vr.description AS route_description,
    r_v.is_live,
    r_v.min_age,
    r_v.max_age,
    r_v.comment,
    public._((r_s.atc || '-target'::text), 'en'::text) AS indication,
        CASE
            WHEN (public._((r_s.atc || '-target'::text)) = (r_s.atc || '-target'::text)) THEN public._((r_s.atc || '-target'::text), 'en'::text)
            ELSE public._((r_s.atc || '-target'::text))
        END AS l10n_indication,
    r_dp.external_code,
    r_dp.external_code_type,
    ARRAY( SELECT row_to_json(indication_row.*) AS row_to_json
           FROM ( SELECT public._((r_s_1.atc || '-target'::text), 'en'::text) AS indication,
                        CASE
                            WHEN (public._((r_s_1.atc || '-target'::text)) = (r_s_1.atc || '-target'::text)) THEN public._((r_s_1.atc || '-target'::text), 'en'::text)
                            ELSE public._((r_s_1.atc || '-target'::text))
                        END AS l10n_indication,
                    r_s_1.atc AS atc_indication
                   FROM ((ref.lnk_dose2drug r_ld2d_1
                     JOIN ref.dose r_d_1 ON ((r_d_1.pk = r_ld2d_1.fk_dose)))
                     JOIN ref.substance r_s_1 ON ((r_d_1.fk_substance = r_s_1.pk)))
                  WHERE (r_ld2d_1.fk_drug_product = r_dp.pk)) indication_row) AS indications,
    r_v.id_route AS pk_route,
    r_v.fk_drug_product AS pk_drug_product,
    r_dp.fk_data_source AS pk_data_source,
    r_s.atc AS atc_indication,
    r_v.xmin AS xmin_vaccine
   FROM (((((ref.vaccine r_v
     LEFT JOIN ref.vacc_route r_vr ON ((r_vr.id = r_v.id_route)))
     JOIN ref.drug_product r_dp ON ((r_dp.pk = r_v.fk_drug_product)))
     JOIN ref.lnk_dose2drug r_ld2d ON ((r_ld2d.fk_drug_product = r_dp.pk)))
     JOIN ref.dose r_d ON ((r_d.pk = r_ld2d.fk_dose)))
     JOIN ref.substance r_s ON ((r_d.fk_substance = r_s.pk)));


ALTER TABLE ref.v_indications4vaccine OWNER TO "gm-dbo";

--
-- Name: VIEW v_indications4vaccine; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON VIEW ref.v_indications4vaccine IS 'Denormalizes indications per vaccine.';


--
-- Name: v_keyword_expansions; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_keyword_expansions AS
 SELECT r_ke.pk AS pk_expansion,
    r_ke.fk_staff AS pk_staff,
    r_ke.keyword,
    r_ke.textual_data AS expansion,
    r_ke.encrypted AS is_encrypted,
    (r_ke.binary_data IS NULL) AS is_textual,
    octet_length(r_ke.binary_data) AS data_size,
    (r_ke.fk_staff IS NULL) AS public_expansion,
    (r_ke.fk_staff IS NOT NULL) AS private_expansion,
    r_ke.owner,
    r_ke.xmin AS xmin_expansion
   FROM ref.keyword_expansion r_ke;


ALTER TABLE ref.v_keyword_expansions OWNER TO "gm-dbo";

--
-- Name: VIEW v_keyword_expansions; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON VIEW ref.v_keyword_expansions IS 'Just a slightly more convenient view over expansions.';


--
-- Name: v_lnk_loincs2substances; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_lnk_loincs2substances AS
 SELECT r_ll2s.pk AS pk_lnk_loinc2substance,
    r_s.description AS substance,
    r_ll2s.loinc,
    r_ll2s.max_age,
    r_ll2s.comment,
    r_s.atc,
    r_s.pk AS pk_substance,
    r_ll2s.xmin AS xmin_lnk_loinc2substance
   FROM (ref.substance r_s
     JOIN ref.lnk_loinc2substance r_ll2s ON ((r_ll2s.fk_substance = r_s.pk)));


ALTER TABLE ref.v_lnk_loincs2substances OWNER TO "gm-dbo";

--
-- Name: v_paperwork_templates; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_paperwork_templates AS
 SELECT r_pt.pk AS pk_paperwork_template,
    r_pt.name_short,
    r_pt.name_long,
    r_pt.external_version,
    r_pt.gnumed_revision,
    ( SELECT r_ft.name
           FROM ref.form_types r_ft
          WHERE (r_ft.pk = r_pt.fk_template_type)) AS template_type,
    ( SELECT public._(r_ft.name) AS _
           FROM ref.form_types r_ft
          WHERE (r_ft.pk = r_pt.fk_template_type)) AS l10n_template_type,
    COALESCE(r_pt.instance_type, ( SELECT r_ft.name
           FROM ref.form_types r_ft
          WHERE (r_ft.pk = r_pt.fk_template_type))) AS instance_type,
    COALESCE(public._(r_pt.instance_type), ( SELECT public._(r_ft.name) AS _
           FROM ref.form_types r_ft
          WHERE (r_ft.pk = r_pt.fk_template_type))) AS l10n_instance_type,
    r_pt.engine,
    r_pt.in_use,
    r_pt.edit_after_substitution,
    r_pt.filename,
        CASE
            WHEN (r_pt.data IS NOT NULL) THEN true
            ELSE false
        END AS has_template_data,
    r_pt.modified_when AS last_modified,
    COALESCE(( SELECT d_s.short_alias
           FROM dem.staff d_s
          WHERE (d_s.db_user = r_pt.modified_by)), (('<'::text || (r_pt.modified_by)::text) || '>'::text)) AS modified_by,
    r_pt.fk_template_type AS pk_template_type,
    r_pt.xmin AS xmin_paperwork_template
   FROM ref.paperwork_templates r_pt;


ALTER TABLE ref.v_paperwork_templates OWNER TO "gm-dbo";

--
-- Name: v_tag_images_no_data; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_tag_images_no_data AS
 SELECT rti.pk AS pk_tag_image,
    rti.description,
    public._(rti.description) AS l10n_description,
    rti.filename,
    octet_length(COALESCE(rti.image, '\x'::bytea)) AS size,
    (EXISTS ( SELECT 1
           FROM dem.identity_tag dit
          WHERE (dit.fk_tag = rti.pk)
         LIMIT 1)) AS is_in_use,
    rti.xmin AS xmin_tag_image
   FROM ref.tag_image rti;


ALTER TABLE ref.v_tag_images_no_data OWNER TO "gm-dbo";

--
-- Name: v_vaccines; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_vaccines AS
 SELECT r_v.pk AS pk_vaccine,
    r_dp.description AS vaccine,
    r_dp.preparation,
    public._(r_dp.preparation) AS l10n_preparation,
    r_dp.atc_code,
    r_dp.is_fake AS is_fake_vaccine,
    r_vr.abbreviation AS route_abbreviation,
    r_vr.description AS route_description,
    r_v.is_live,
    r_v.min_age,
    r_v.max_age,
    r_v.comment,
    ARRAY( SELECT row_to_json(indication_row.*) AS row_to_json
           FROM ( SELECT public._((r_s.atc || '-target'::text), 'en'::text) AS indication,
                        CASE
                            WHEN (public._((r_s.atc || '-target'::text)) = (r_s.atc || '-target'::text)) THEN public._((r_s.atc || '-target'::text), 'en'::text)
                            ELSE public._((r_s.atc || '-target'::text))
                        END AS l10n_indication,
                    r_s.atc AS atc_indication
                   FROM ((ref.lnk_dose2drug r_ld2d
                     JOIN ref.dose r_d ON ((r_d.pk = r_ld2d.fk_dose)))
                     JOIN ref.substance r_s ON ((r_d.fk_substance = r_s.pk)))
                  WHERE (r_ld2d.fk_drug_product = r_dp.pk)) indication_row) AS indications,
    r_dp.external_code,
    r_dp.external_code_type,
    r_v.id_route AS pk_route,
    r_v.fk_drug_product AS pk_drug_product,
    r_dp.fk_data_source AS pk_data_source,
    r_v.xmin AS xmin_vaccine
   FROM ((ref.vaccine r_v
     JOIN ref.drug_product r_dp ON ((r_v.fk_drug_product = r_dp.pk)))
     LEFT JOIN ref.vacc_route r_vr ON ((r_v.id_route = r_vr.id)));


ALTER TABLE ref.v_vaccines OWNER TO "gm-dbo";

--
-- Name: VIEW v_vaccines; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON VIEW ref.v_vaccines IS 'A list of vaccines.';


--
-- Name: v_your_keyword_expansions; Type: VIEW; Schema: ref; Owner: gm-dbo
--

CREATE VIEW ref.v_your_keyword_expansions AS
 SELECT DISTINCT ON (union_result.keyword) union_result.pk_expansion,
    union_result.pk_staff,
    union_result.keyword,
    union_result.expansion,
    union_result.is_encrypted,
    union_result.is_textual,
    union_result.data_size,
    union_result.public_expansion,
    union_result.private_expansion,
    union_result.owner,
    union_result.xmin_expansion
   FROM ( SELECT r_ke.pk AS pk_expansion,
            r_ke.fk_staff AS pk_staff,
            r_ke.keyword,
            r_ke.textual_data AS expansion,
            r_ke.encrypted AS is_encrypted,
            (r_ke.binary_data IS NULL) AS is_textual,
            octet_length(r_ke.binary_data) AS data_size,
            false AS public_expansion,
            true AS private_expansion,
            r_ke.owner,
            r_ke.xmin AS xmin_expansion
           FROM ref.keyword_expansion r_ke
          WHERE (r_ke.fk_staff = ( SELECT staff.pk
                   FROM dem.staff
                  WHERE (staff.db_user = "current_user"())))
        UNION ALL
         SELECT r_ke.pk AS pk_expansion,
            r_ke.fk_staff AS pk_staff,
            r_ke.keyword,
            r_ke.textual_data AS expansion,
            r_ke.encrypted AS is_encrypted,
            (r_ke.binary_data IS NULL) AS is_textual,
            octet_length(r_ke.binary_data) AS data_size,
            true AS public_expansion,
            false AS private_expansion,
            r_ke.owner,
            r_ke.xmin AS xmin_expansion
           FROM ref.keyword_expansion r_ke
          WHERE (r_ke.fk_staff IS NULL)
  ORDER BY 9 DESC) union_result;


ALTER TABLE ref.v_your_keyword_expansions OWNER TO "gm-dbo";

--
-- Name: VIEW v_your_keyword_expansions; Type: COMMENT; Schema: ref; Owner: gm-dbo
--

COMMENT ON VIEW ref.v_your_keyword_expansions IS 'View over the text expansions relevant to the current user:
a private expansion set up for the current user overrides a
public expansion of the same keyword.';


--
-- Name: vacc_route_id_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.vacc_route_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.vacc_route_id_seq OWNER TO "gm-dbo";

--
-- Name: vacc_route_id_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.vacc_route_id_seq OWNED BY ref.vacc_route.id;


--
-- Name: vaccine_pk_seq; Type: SEQUENCE; Schema: ref; Owner: gm-dbo
--

CREATE SEQUENCE ref.vaccine_pk_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE ref.vaccine_pk_seq OWNER TO "gm-dbo";

--
-- Name: vaccine_pk_seq; Type: SEQUENCE OWNED BY; Schema: ref; Owner: gm-dbo
--

ALTER SEQUENCE ref.vaccine_pk_seq OWNED BY ref.vaccine.pk;


--
-- Name: lab_request; Type: TABLE; Schema: staging; Owner: gm-dbo
--

CREATE TABLE staging.lab_request (
    pk_audit integer DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass) NOT NULL,
    row_version integer DEFAULT 0 NOT NULL,
    modified_when timestamp with time zone DEFAULT now() NOT NULL,
    modified_by name DEFAULT "current_user"() NOT NULL,
    pk_item integer DEFAULT nextval('clin.clin_root_item_pk_item_seq'::regclass) NOT NULL,
    clin_when timestamp with time zone DEFAULT now() NOT NULL,
    fk_episode integer NOT NULL,
    narrative text,
    soap_cat text DEFAULT 'p'::text,
    pk integer DEFAULT nextval('clin.lab_request_pk_seq'::regclass) NOT NULL,
    fk_test_org integer NOT NULL,
    request_id text NOT NULL,
    fk_requestor integer,
    lab_request_id text,
    lab_rxd_when timestamp with time zone,
    results_reported_when timestamp with time zone,
    request_status text NOT NULL,
    is_pending boolean DEFAULT true NOT NULL,
    diagnostic_service_section text,
    ordered_service text,
    fk_incoming_data_unmatched integer NOT NULL,
    CONSTRAINT clin_root_item_soap_cat_check CHECK (((soap_cat IS NULL) OR (lower(soap_cat) = ANY (ARRAY['s'::text, 'o'::text, 'a'::text, 'p'::text])))),
    CONSTRAINT lab_request_request_id_check CHECK ((btrim(request_id) <> ''::text)),
    CONSTRAINT lab_request_request_status_check CHECK ((request_status = ANY (ARRAY['pending'::text, 'preliminary'::text, 'partial'::text, 'final'::text]))),
    CONSTRAINT staging_request_sane_request_id CHECK ((gm.is_null_or_blank_string(request_id) IS FALSE)),
    CONSTRAINT staging_request_sane_status CHECK ((request_status = ANY (ARRAY['pending'::text, 'preliminary'::text, 'partial'::text, 'final'::text])))
);


ALTER TABLE staging.lab_request OWNER TO "gm-dbo";

--
-- Name: TABLE lab_request; Type: COMMENT; Schema: staging; Owner: gm-dbo
--

COMMENT ON TABLE staging.lab_request IS 'Used to stage lab requests (from hl7 files, currently).';


--
-- Name: lnk_vacc_ind2subst_dose; Type: TABLE; Schema: staging; Owner: gm-dbo
--

CREATE UNLOGGED TABLE staging.lnk_vacc_ind2subst_dose (
    fk_indication integer NOT NULL,
    fk_dose integer NOT NULL,
    is_live boolean DEFAULT false NOT NULL
);


ALTER TABLE staging.lnk_vacc_ind2subst_dose OWNER TO "gm-dbo";

--
-- Name: loinc_staging; Type: TABLE; Schema: staging; Owner: gm-dbo
--

CREATE TABLE staging.loinc_staging (
    loinc_num text,
    component text,
    property text,
    time_aspect text,
    system text,
    scale_type text,
    method_type text,
    related_names_1_old text,
    class text,
    source text,
    dt_last_change text,
    change_type text,
    comments text,
    answer_list text,
    status text,
    map_to text,
    scope text,
    normal_range text,
    ipcc_units text,
    reference text,
    exact_component_synonym text,
    molar_mass text,
    class_type text,
    formula text,
    species text,
    example_answers text,
    acs_synonyms text,
    base_name text,
    final text,
    naa_ccr_id text,
    code_table text,
    is_set_root text,
    panel_elements text,
    survey_question_text text,
    survey_question_source text,
    units_required text,
    submitted_units text,
    related_names_2 text,
    short_name text,
    order_obs text,
    cdisc_common_tests text,
    hl7_field_subfield_id text,
    external_copyright_notice text,
    example_units text,
    inpc_percentage text,
    long_common_name text
);


ALTER TABLE staging.loinc_staging OWNER TO "gm-dbo";

--
-- Name: TABLE loinc_staging; Type: COMMENT; Schema: staging; Owner: gm-dbo
--

COMMENT ON TABLE staging.loinc_staging IS 'used for importing LOINC data, columns correspond 1:1 with the LOINC CSV file fields';


--
-- Name: test_result; Type: TABLE; Schema: staging; Owner: gm-dbo
--

CREATE TABLE staging.test_result (
    pk_audit integer DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass) NOT NULL,
    row_version integer DEFAULT 0 NOT NULL,
    modified_when timestamp with time zone DEFAULT now() NOT NULL,
    modified_by name DEFAULT "current_user"() NOT NULL,
    pk_item integer DEFAULT nextval('clin.clin_root_item_pk_item_seq'::regclass) NOT NULL,
    clin_when timestamp with time zone DEFAULT now() NOT NULL,
    fk_episode integer NOT NULL,
    narrative text,
    soap_cat text DEFAULT 'p'::text,
    pk integer DEFAULT nextval('clin.test_result_pk_seq'::regclass) NOT NULL,
    fk_type integer NOT NULL,
    val_num numeric,
    val_alpha text,
    val_unit text,
    val_normal_min numeric,
    val_normal_max numeric,
    val_normal_range text,
    val_target_min numeric,
    val_target_max numeric,
    val_target_range text,
    abnormality_indicator text,
    norm_ref_group text,
    note_test_org text,
    material text,
    material_detail text,
    fk_intended_reviewer integer NOT NULL,
    fk_request integer NOT NULL,
    orig_intended_reviewer text,
    CONSTRAINT clin_root_item_soap_cat_check CHECK (((soap_cat IS NULL) OR (lower(soap_cat) = ANY (ARRAY['s'::text, 'o'::text, 'a'::text, 'p'::text])))),
    CONSTRAINT numval_needs_unit CHECK ((((val_num IS NOT NULL) AND (btrim(COALESCE(val_unit, ''::text)) <> ''::text)) OR (val_num IS NULL))),
    CONSTRAINT staging_numval_needs_unit CHECK ((((val_num IS NOT NULL) AND (btrim(COALESCE(val_unit, ''::text)) <> ''::text)) OR (val_num IS NULL))),
    CONSTRAINT staging_sane_value CHECK (((val_num IS NOT NULL) OR (val_alpha IS NOT NULL) OR ((val_num IS NULL) AND (val_alpha <> ''::text) AND (val_alpha IS NOT NULL)))),
    CONSTRAINT test_result_check CHECK (((val_num IS NOT NULL) OR (val_alpha IS NOT NULL) OR ((val_num IS NULL) AND (val_alpha <> ''::text) AND (val_alpha IS NOT NULL))))
);


ALTER TABLE staging.test_result OWNER TO "gm-dbo";

--
-- Name: TABLE test_result; Type: COMMENT; Schema: staging; Owner: gm-dbo
--

COMMENT ON TABLE staging.test_result IS 'Used to stage test results (from hl7 files, currently).';


--
-- Name: referral pk_audit; Type: DEFAULT; Schema: au; Owner: gm-dbo
--

ALTER TABLE ONLY au.referral ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: referral row_version; Type: DEFAULT; Schema: au; Owner: gm-dbo
--

ALTER TABLE ONLY au.referral ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: referral modified_when; Type: DEFAULT; Schema: au; Owner: gm-dbo
--

ALTER TABLE ONLY au.referral ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: referral modified_by; Type: DEFAULT; Schema: au; Owner: gm-dbo
--

ALTER TABLE ONLY au.referral ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: referral pk_item; Type: DEFAULT; Schema: au; Owner: gm-dbo
--

ALTER TABLE ONLY au.referral ALTER COLUMN pk_item SET DEFAULT nextval('clin.clin_root_item_pk_item_seq'::regclass);


--
-- Name: referral clin_when; Type: DEFAULT; Schema: au; Owner: gm-dbo
--

ALTER TABLE ONLY au.referral ALTER COLUMN clin_when SET DEFAULT now();


--
-- Name: referral id; Type: DEFAULT; Schema: au; Owner: gm-dbo
--

ALTER TABLE ONLY au.referral ALTER COLUMN id SET DEFAULT nextval('au.referral_id_seq'::regclass);


--
-- Name: audit_fields pk_audit; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.audit_fields ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: audit_trail pk_audit; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.audit_trail ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass);


--
-- Name: audited_tables id; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.audited_tables ALTER COLUMN id SET DEFAULT nextval('audit.audited_tables_id_seq'::regclass);


--
-- Name: log_access_log orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_access_log ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_access_log audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_access_log ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_access_log audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_access_log ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_address orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_address ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_address audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_address ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_address audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_address ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_allergy orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_allergy ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_allergy audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_allergy ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_allergy audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_allergy ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_allergy_state orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_allergy_state ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_allergy_state audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_allergy_state ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_allergy_state audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_allergy_state ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_auto_hint orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_auto_hint ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_auto_hint audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_auto_hint ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_auto_hint audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_auto_hint ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_beh_fall_typ orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_beh_fall_typ ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_beh_fall_typ audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_beh_fall_typ ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_beh_fall_typ audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_beh_fall_typ ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_bill orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_bill ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_bill audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_bill ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_bill audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_bill ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_bill_item orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_bill_item ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_bill_item audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_bill_item ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_bill_item audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_bill_item ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_billable pk_audit; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_billable ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass);


--
-- Name: log_billable orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_billable ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_billable audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_billable ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_billable audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_billable ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_clin_aux_note orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_clin_aux_note ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_clin_aux_note audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_clin_aux_note ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_clin_aux_note audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_clin_aux_note ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_clin_diag orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_clin_diag ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_clin_diag audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_clin_diag ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_clin_diag audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_clin_diag ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_clin_item_type orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_clin_item_type ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_clin_item_type audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_clin_item_type ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_clin_item_type audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_clin_item_type ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_clin_narrative orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_clin_narrative ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_clin_narrative audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_clin_narrative ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_clin_narrative audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_clin_narrative ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_consumable_substance orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_consumable_substance ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_consumable_substance audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_consumable_substance ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_consumable_substance audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_consumable_substance ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_consumed_substance orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_consumed_substance ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_consumed_substance audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_consumed_substance ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_consumed_substance audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_consumed_substance ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_data_source orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_data_source ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_data_source audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_data_source ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_data_source audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_data_source ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_doc_desc orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_doc_desc ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_doc_desc audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_doc_desc ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_doc_desc audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_doc_desc ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_doc_med orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_doc_med ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_doc_med audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_doc_med ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_doc_med audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_doc_med ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_dose pk_audit; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_dose ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass);


--
-- Name: log_dose orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_dose ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_dose audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_dose ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_dose audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_dose ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_drug_product orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_drug_product ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_drug_product audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_drug_product ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_drug_product audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_drug_product ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_encounter orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_encounter ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_encounter audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_encounter ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_encounter audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_encounter ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_episode orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_episode ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_episode audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_episode ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_episode audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_episode ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_external_care orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_external_care ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_external_care audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_external_care ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_external_care audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_external_care ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_family_history orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_family_history ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_family_history audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_family_history ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_family_history audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_family_history ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_fhx_relation_type orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_fhx_relation_type ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_fhx_relation_type audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_fhx_relation_type ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_fhx_relation_type audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_fhx_relation_type ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_form_data orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_form_data ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_form_data audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_form_data ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_form_data audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_form_data ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_form_instances orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_form_instances ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_form_instances audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_form_instances ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_form_instances audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_form_instances ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_gender_label orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_gender_label ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_gender_label audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_gender_label ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_gender_label audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_gender_label ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_health_issue orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_health_issue ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_health_issue audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_health_issue ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_health_issue audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_health_issue ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_hospital_stay orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_hospital_stay ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_hospital_stay audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_hospital_stay ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_hospital_stay audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_hospital_stay ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_hx_family_item orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_hx_family_item ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_hx_family_item audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_hx_family_item ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_hx_family_item audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_hx_family_item ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_identity orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_identity ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_identity audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_identity ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_identity audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_identity ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_identity_tag orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_identity_tag ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_identity_tag audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_identity_tag ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_identity_tag audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_identity_tag ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_inbox_item_category orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_inbox_item_category ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_inbox_item_category audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_inbox_item_category ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_inbox_item_category audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_inbox_item_category ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_inbox_item_type orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_inbox_item_type ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_inbox_item_type audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_inbox_item_type ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_inbox_item_type audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_inbox_item_type ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_incoming_data_unmatchable orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_incoming_data_unmatchable ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_incoming_data_unmatchable audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_incoming_data_unmatchable ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_incoming_data_unmatchable audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_incoming_data_unmatchable ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_incoming_data_unmatched orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_incoming_data_unmatched ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_incoming_data_unmatched audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_incoming_data_unmatched ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_incoming_data_unmatched audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_incoming_data_unmatched ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lab_request orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lab_request ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lab_request audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lab_request ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lab_request audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lab_request ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lab_test_gnr orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lab_test_gnr ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lab_test_gnr audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lab_test_gnr ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lab_test_gnr audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lab_test_gnr ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_code2aoe orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2aoe ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_code2aoe audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2aoe ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_code2aoe audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2aoe ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_code2episode orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2episode ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_code2episode audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2episode ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_code2episode audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2episode ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_code2fhx orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2fhx ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_code2fhx audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2fhx ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_code2fhx audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2fhx ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_code2h_issue orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2h_issue ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_code2h_issue audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2h_issue ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_code2h_issue audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2h_issue ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_code2narrative orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2narrative ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_code2narrative audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2narrative ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_code2narrative audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2narrative ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_code2procedure orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2procedure ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_code2procedure audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2procedure ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_code2procedure audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2procedure ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_code2rfe orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2rfe ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_code2rfe audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2rfe ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_code2rfe audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2rfe ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_code2tst_pnl orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2tst_pnl ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_code2tst_pnl audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2tst_pnl ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_code2tst_pnl audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_code2tst_pnl ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_constraint2vacc_course orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_constraint2vacc_course ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_constraint2vacc_course audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_constraint2vacc_course ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_constraint2vacc_course audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_constraint2vacc_course ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_dose2drug pk_audit; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_dose2drug ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass);


--
-- Name: log_lnk_dose2drug orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_dose2drug ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_dose2drug audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_dose2drug ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_dose2drug audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_dose2drug ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_identity2ext_id orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_identity2ext_id ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_identity2ext_id audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_identity2ext_id ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_identity2ext_id audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_identity2ext_id ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_identity2primary_doc pk_audit; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_identity2primary_doc ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass);


--
-- Name: log_lnk_identity2primary_doc orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_identity2primary_doc ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_identity2primary_doc audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_identity2primary_doc ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_identity2primary_doc audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_identity2primary_doc ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_job2person orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_job2person ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_job2person audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_job2person ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_job2person audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_job2person ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_loinc2substance pk_audit; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_loinc2substance ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass);


--
-- Name: log_lnk_loinc2substance orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_loinc2substance ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_loinc2substance audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_loinc2substance ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_loinc2substance audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_loinc2substance ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_loinc2test_panel pk_audit; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_loinc2test_panel ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass);


--
-- Name: log_lnk_loinc2test_panel orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_loinc2test_panel ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_loinc2test_panel audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_loinc2test_panel ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_loinc2test_panel audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_loinc2test_panel ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_org_unit2comm orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_org_unit2comm ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_org_unit2comm audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_org_unit2comm ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_org_unit2comm audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_org_unit2comm ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_org_unit2ext_id orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_org_unit2ext_id ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_org_unit2ext_id audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_org_unit2ext_id ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_org_unit2ext_id audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_org_unit2ext_id ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_pat2vaccination_course orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_pat2vaccination_course ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_pat2vaccination_course audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_pat2vaccination_course ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_pat2vaccination_course audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_pat2vaccination_course ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_person2relative orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_person2relative ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_person2relative audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_person2relative ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_person2relative audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_person2relative ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_substance2brand orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_substance2brand ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_substance2brand audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_substance2brand ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_substance2brand audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_substance2brand ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_tst2norm orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_tst2norm ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_tst2norm audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_tst2norm ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_tst2norm audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_tst2norm ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_type2item orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_type2item ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_type2item audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_type2item ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_type2item audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_type2item ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_vaccination_course2schedule orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_vaccination_course2schedule ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_vaccination_course2schedule audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_vaccination_course2schedule ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_vaccination_course2schedule audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_vaccination_course2schedule ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_lnk_vaccine2inds orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_vaccine2inds ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_lnk_vaccine2inds audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_vaccine2inds ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_lnk_vaccine2inds audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_lnk_vaccine2inds ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_message_inbox orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_message_inbox ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_message_inbox audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_message_inbox ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_message_inbox audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_message_inbox ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_occupation orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_occupation ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_occupation audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_occupation ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_occupation audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_occupation ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_operation orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_operation ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_operation audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_operation ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_operation audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_operation ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_org orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_org ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_org audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_org ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_org audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_org ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_org_unit orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_org_unit ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_org_unit audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_org_unit ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_org_unit audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_org_unit ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_paperwork_templates orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_paperwork_templates ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_paperwork_templates audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_paperwork_templates ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_paperwork_templates audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_paperwork_templates ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_patient orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_patient ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_patient audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_patient ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_patient audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_patient ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_prax_geb_paid orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_prax_geb_paid ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_prax_geb_paid audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_prax_geb_paid ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_prax_geb_paid audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_prax_geb_paid ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_praxis_branch orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_praxis_branch ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_praxis_branch audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_praxis_branch ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_praxis_branch audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_praxis_branch ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_procedure orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_procedure ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_procedure audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_procedure ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_procedure audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_procedure ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_referral orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_referral ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_referral audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_referral ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_referral audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_referral ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_region orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_region ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_region audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_region ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_region audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_region ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_relation_types orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_relation_types ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_relation_types audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_relation_types ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_relation_types audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_relation_types ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_report_query orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_report_query ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_report_query audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_report_query ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_report_query audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_report_query ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_staff orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_staff ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_staff audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_staff ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_staff audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_staff ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_street orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_street ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_street audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_street ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_street audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_street ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_substance pk_audit; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_substance ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_trail_pk_audit_seq'::regclass);


--
-- Name: log_substance orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_substance ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_substance audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_substance ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_substance audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_substance ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_substance_in_brand orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_substance_in_brand ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_substance_in_brand audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_substance_in_brand ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_substance_in_brand audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_substance_in_brand ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_substance_intake orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_substance_intake ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_substance_intake audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_substance_intake ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_substance_intake audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_substance_intake ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_suppressed_hint orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_suppressed_hint ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_suppressed_hint audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_suppressed_hint ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_suppressed_hint audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_suppressed_hint ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_tag_image orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_tag_image ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_tag_image audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_tag_image ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_tag_image audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_tag_image ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_test_org orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_test_org ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_test_org audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_test_org ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_test_org audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_test_org ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_test_panel orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_test_panel ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_test_panel audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_test_panel ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_test_panel audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_test_panel ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_test_result orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_test_result ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_test_result audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_test_result ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_test_result audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_test_result ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_test_type orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_test_type ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_test_type audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_test_type ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_test_type audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_test_type ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_urb orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_urb ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_urb audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_urb ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_urb audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_urb ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_vacc_indication orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vacc_indication ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_vacc_indication audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vacc_indication ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_vacc_indication audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vacc_indication ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_vacc_route orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vacc_route ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_vacc_route audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vacc_route ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_vacc_route audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vacc_route ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_vaccination orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccination ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_vaccination audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccination ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_vaccination audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccination ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_vaccination_course orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccination_course ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_vaccination_course audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccination_course ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_vaccination_course audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccination_course ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_vaccination_course_constraint orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccination_course_constraint ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_vaccination_course_constraint audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccination_course_constraint ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_vaccination_course_constraint audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccination_course_constraint ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_vaccination_definition orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccination_definition ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_vaccination_definition audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccination_definition ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_vaccination_definition audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccination_definition ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_vaccination_schedule orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccination_schedule ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_vaccination_schedule audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccination_schedule ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_vaccination_schedule audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccination_schedule ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_vaccine orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccine ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_vaccine audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccine ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_vaccine audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccine ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_vaccine_batches orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccine_batches ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_vaccine_batches audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccine_batches ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_vaccine_batches audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_vaccine_batches ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_waiting_list orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_waiting_list ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_waiting_list audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_waiting_list ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_waiting_list audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_waiting_list ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: log_xlnk_identity orig_version; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_xlnk_identity ALTER COLUMN orig_version SET DEFAULT 0;


--
-- Name: log_xlnk_identity audit_when; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_xlnk_identity ALTER COLUMN audit_when SET DEFAULT now();


--
-- Name: log_xlnk_identity audit_by; Type: DEFAULT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.log_xlnk_identity ALTER COLUMN audit_by SET DEFAULT "current_user"();


--
-- Name: bill pk_audit; Type: DEFAULT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: bill row_version; Type: DEFAULT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: bill modified_when; Type: DEFAULT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: bill modified_by; Type: DEFAULT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: bill pk; Type: DEFAULT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill ALTER COLUMN pk SET DEFAULT nextval('bill.bill_pk_seq'::regclass);


--
-- Name: bill_item pk_audit; Type: DEFAULT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill_item ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: bill_item row_version; Type: DEFAULT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill_item ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: bill_item modified_when; Type: DEFAULT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill_item ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: bill_item modified_by; Type: DEFAULT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill_item ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: bill_item pk; Type: DEFAULT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill_item ALTER COLUMN pk SET DEFAULT nextval('bill.bill_item_pk_seq'::regclass);


--
-- Name: lnk_enc_type2billable pk; Type: DEFAULT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.lnk_enc_type2billable ALTER COLUMN pk SET DEFAULT nextval('bill.lnk_enc_type2billable_pk_seq'::regclass);


--
-- Name: doc_desc pk_audit; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_desc ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: doc_desc row_version; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_desc ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: doc_desc modified_when; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_desc ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: doc_desc modified_by; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_desc ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: doc_desc pk; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_desc ALTER COLUMN pk SET DEFAULT nextval('blobs.doc_desc_pk_seq'::regclass);


--
-- Name: doc_med pk_audit; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_med ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: doc_med row_version; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_med ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: doc_med modified_when; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_med ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: doc_med modified_by; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_med ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: doc_med pk; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_med ALTER COLUMN pk SET DEFAULT nextval('blobs.doc_med_pk_seq'::regclass);


--
-- Name: doc_obj pk; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_obj ALTER COLUMN pk SET DEFAULT nextval('blobs.doc_obj_pk_seq'::regclass);


--
-- Name: doc_type pk; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_type ALTER COLUMN pk SET DEFAULT nextval('blobs.doc_type_pk_seq'::regclass);


--
-- Name: lnk_doc_med2episode pk_audit; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.lnk_doc_med2episode ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_doc_med2episode row_version; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.lnk_doc_med2episode ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_doc_med2episode modified_when; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.lnk_doc_med2episode ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_doc_med2episode modified_by; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.lnk_doc_med2episode ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_doc_med2episode pk; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.lnk_doc_med2episode ALTER COLUMN pk SET DEFAULT nextval('blobs.lnk_doc_med2episode_pk_seq'::regclass);


--
-- Name: reviewed_doc_objs pk_audit; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.reviewed_doc_objs ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: reviewed_doc_objs row_version; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.reviewed_doc_objs ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: reviewed_doc_objs modified_when; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.reviewed_doc_objs ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: reviewed_doc_objs modified_by; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.reviewed_doc_objs ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: reviewed_doc_objs pk; Type: DEFAULT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.reviewed_doc_objs ALTER COLUMN pk SET DEFAULT nextval('clin.review_root_pk_seq'::regclass);


--
-- Name: cfg_data pk; Type: DEFAULT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_data ALTER COLUMN pk SET DEFAULT nextval('cfg.cfg_data_pk_seq'::regclass);


--
-- Name: cfg_item pk; Type: DEFAULT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_item ALTER COLUMN pk SET DEFAULT nextval('cfg.cfg_item_pk_seq'::regclass);


--
-- Name: cfg_numeric pk; Type: DEFAULT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_numeric ALTER COLUMN pk SET DEFAULT nextval('cfg.cfg_numeric_pk_seq'::regclass);


--
-- Name: cfg_str_array pk; Type: DEFAULT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_str_array ALTER COLUMN pk SET DEFAULT nextval('cfg.cfg_str_array_pk_seq'::regclass);


--
-- Name: cfg_string pk; Type: DEFAULT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_string ALTER COLUMN pk SET DEFAULT nextval('cfg.cfg_string_pk_seq'::regclass);


--
-- Name: cfg_template pk; Type: DEFAULT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_template ALTER COLUMN pk SET DEFAULT nextval('cfg.cfg_template_pk_seq'::regclass);


--
-- Name: config id; Type: DEFAULT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.config ALTER COLUMN id SET DEFAULT nextval('cfg.config_id_seq'::regclass);


--
-- Name: report_query pk_audit; Type: DEFAULT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.report_query ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: report_query row_version; Type: DEFAULT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.report_query ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: report_query modified_when; Type: DEFAULT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.report_query ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: report_query modified_by; Type: DEFAULT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.report_query ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: report_query pk; Type: DEFAULT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.report_query ALTER COLUMN pk SET DEFAULT nextval('cfg.report_query_pk_seq'::regclass);


--
-- Name: _enum_allergy_type pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin._enum_allergy_type ALTER COLUMN pk SET DEFAULT nextval('clin._enum_allergy_type_id_seq'::regclass);


--
-- Name: allergy pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: allergy row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: allergy modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: allergy modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: allergy pk_item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy ALTER COLUMN pk_item SET DEFAULT nextval('clin.clin_root_item_pk_item_seq'::regclass);


--
-- Name: allergy clin_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy ALTER COLUMN clin_when SET DEFAULT now();


--
-- Name: allergy soap_cat; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy ALTER COLUMN soap_cat SET DEFAULT 'o'::text;


--
-- Name: allergy pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy ALTER COLUMN pk SET DEFAULT nextval('clin.allergy_id_seq'::regclass);


--
-- Name: allergy_state pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy_state ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: allergy_state row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy_state ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: allergy_state modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy_state ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: allergy_state modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy_state ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: allergy_state pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy_state ALTER COLUMN pk SET DEFAULT nextval('clin.allergy_state_id_seq'::regclass);


--
-- Name: clin_aux_note pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_aux_note ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: clin_aux_note row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_aux_note ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: clin_aux_note modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_aux_note ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: clin_aux_note modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_aux_note ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: clin_aux_note pk_item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_aux_note ALTER COLUMN pk_item SET DEFAULT nextval('clin.clin_root_item_pk_item_seq'::regclass);


--
-- Name: clin_aux_note clin_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_aux_note ALTER COLUMN clin_when SET DEFAULT now();


--
-- Name: clin_aux_note pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_aux_note ALTER COLUMN pk SET DEFAULT nextval('clin.clin_aux_note_pk_seq'::regclass);


--
-- Name: clin_diag pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_diag ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: clin_diag row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_diag ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: clin_diag modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_diag ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: clin_diag modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_diag ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: clin_diag pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_diag ALTER COLUMN pk SET DEFAULT nextval('clin.clin_diag_pk_seq'::regclass);


--
-- Name: clin_item_type pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_item_type ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: clin_item_type row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_item_type ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: clin_item_type modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_item_type ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: clin_item_type modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_item_type ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: clin_item_type pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_item_type ALTER COLUMN pk SET DEFAULT nextval('clin.clin_item_type_pk_seq'::regclass);


--
-- Name: clin_narrative pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_narrative ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: clin_narrative row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_narrative ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: clin_narrative modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_narrative ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: clin_narrative modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_narrative ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: clin_narrative pk_item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_narrative ALTER COLUMN pk_item SET DEFAULT nextval('clin.clin_root_item_pk_item_seq'::regclass);


--
-- Name: clin_narrative clin_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_narrative ALTER COLUMN clin_when SET DEFAULT now();


--
-- Name: clin_narrative pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_narrative ALTER COLUMN pk SET DEFAULT nextval('clin.clin_narrative_pk_seq'::regclass);


--
-- Name: clin_root_item pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_root_item ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: clin_root_item row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_root_item ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: clin_root_item modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_root_item ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: clin_root_item modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_root_item ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: clin_root_item pk_item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_root_item ALTER COLUMN pk_item SET DEFAULT nextval('clin.clin_root_item_pk_item_seq'::regclass);


--
-- Name: encounter pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.encounter ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: encounter row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.encounter ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: encounter modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.encounter ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: encounter modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.encounter ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: encounter pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.encounter ALTER COLUMN pk SET DEFAULT nextval('clin.encounter_pk_seq'::regclass);


--
-- Name: encounter_type pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.encounter_type ALTER COLUMN pk SET DEFAULT nextval('clin.encounter_type_pk_seq'::regclass);


--
-- Name: episode pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.episode ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: episode row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.episode ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: episode modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.episode ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: episode modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.episode ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: episode pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.episode ALTER COLUMN pk SET DEFAULT nextval('clin.episode_pk_seq'::regclass);


--
-- Name: export_item pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.export_item ALTER COLUMN pk SET DEFAULT nextval('clin.export_item_pk_seq'::regclass);


--
-- Name: external_care pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.external_care ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: external_care row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.external_care ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: external_care modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.external_care ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: external_care modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.external_care ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: external_care pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.external_care ALTER COLUMN pk SET DEFAULT nextval('clin.external_care_pk_seq'::regclass);


--
-- Name: family_history pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.family_history ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: family_history row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.family_history ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: family_history modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.family_history ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: family_history modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.family_history ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: family_history pk_item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.family_history ALTER COLUMN pk_item SET DEFAULT nextval('clin.clin_root_item_pk_item_seq'::regclass);


--
-- Name: family_history clin_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.family_history ALTER COLUMN clin_when SET DEFAULT now();


--
-- Name: family_history pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.family_history ALTER COLUMN pk SET DEFAULT nextval('clin.clin_hx_family_pk_seq'::regclass);


--
-- Name: fhx_relation_type pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.fhx_relation_type ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: fhx_relation_type row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.fhx_relation_type ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: fhx_relation_type modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.fhx_relation_type ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: fhx_relation_type modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.fhx_relation_type ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: fhx_relation_type pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.fhx_relation_type ALTER COLUMN pk SET DEFAULT nextval('clin.fhx_relation_type_pk_seq'::regclass);


--
-- Name: form_data pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_data ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: form_data row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_data ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: form_data modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_data ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: form_data modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_data ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: form_data pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_data ALTER COLUMN pk SET DEFAULT nextval('clin.form_data_pk_seq'::regclass);


--
-- Name: form_instances pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_instances ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: form_instances row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_instances ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: form_instances modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_instances ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: form_instances modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_instances ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: form_instances pk_item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_instances ALTER COLUMN pk_item SET DEFAULT nextval('clin.clin_root_item_pk_item_seq'::regclass);


--
-- Name: form_instances clin_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_instances ALTER COLUMN clin_when SET DEFAULT now();


--
-- Name: form_instances pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_instances ALTER COLUMN pk SET DEFAULT nextval('clin.form_instances_pk_seq'::regclass);


--
-- Name: health_issue pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.health_issue ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: health_issue row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.health_issue ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: health_issue modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.health_issue ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: health_issue modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.health_issue ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: health_issue pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.health_issue ALTER COLUMN pk SET DEFAULT nextval('clin.health_issue_pk_seq'::regclass);


--
-- Name: hospital_stay pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.hospital_stay ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: hospital_stay row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.hospital_stay ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: hospital_stay modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.hospital_stay ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: hospital_stay modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.hospital_stay ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: hospital_stay pk_item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.hospital_stay ALTER COLUMN pk_item SET DEFAULT nextval('clin.clin_root_item_pk_item_seq'::regclass);


--
-- Name: hospital_stay clin_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.hospital_stay ALTER COLUMN clin_when SET DEFAULT now();


--
-- Name: hospital_stay pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.hospital_stay ALTER COLUMN pk SET DEFAULT nextval('clin.hospital_stay_pk_seq'::regclass);


--
-- Name: incoming_data_unmatchable pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.incoming_data_unmatchable ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: incoming_data_unmatchable row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.incoming_data_unmatchable ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: incoming_data_unmatchable modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.incoming_data_unmatchable ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: incoming_data_unmatchable modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.incoming_data_unmatchable ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: incoming_data_unmatchable pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.incoming_data_unmatchable ALTER COLUMN pk SET DEFAULT nextval('clin.incoming_data_unmatchable_pk_seq'::regclass);


--
-- Name: incoming_data_unmatched pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.incoming_data_unmatched ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: incoming_data_unmatched row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.incoming_data_unmatched ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: incoming_data_unmatched modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.incoming_data_unmatched ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: incoming_data_unmatched modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.incoming_data_unmatched ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: incoming_data_unmatched pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.incoming_data_unmatched ALTER COLUMN pk SET DEFAULT nextval('clin.incoming_data_unmatched_pk_seq'::regclass);


--
-- Name: lab_request pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lab_request ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lab_request row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lab_request ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lab_request modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lab_request ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lab_request modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lab_request ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lab_request pk_item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lab_request ALTER COLUMN pk_item SET DEFAULT nextval('clin.clin_root_item_pk_item_seq'::regclass);


--
-- Name: lab_request clin_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lab_request ALTER COLUMN clin_when SET DEFAULT now();


--
-- Name: lab_request soap_cat; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lab_request ALTER COLUMN soap_cat SET DEFAULT 'p'::text;


--
-- Name: lab_request pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lab_request ALTER COLUMN pk SET DEFAULT nextval('clin.lab_request_pk_seq'::regclass);


--
-- Name: lnk_code2aoe pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2aoe ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_code2aoe row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2aoe ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_code2aoe modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2aoe ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_code2aoe modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2aoe ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_code2aoe pk_lnk_code2item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2aoe ALTER COLUMN pk_lnk_code2item SET DEFAULT nextval('clin.lnk_code2item_root_pk_lnk_code2item_seq'::regclass);


--
-- Name: lnk_code2aoe pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2aoe ALTER COLUMN pk SET DEFAULT nextval('clin.lnk_code2aoe_pk_seq'::regclass);


--
-- Name: lnk_code2episode pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2episode ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_code2episode row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2episode ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_code2episode modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2episode ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_code2episode modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2episode ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_code2episode pk_lnk_code2item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2episode ALTER COLUMN pk_lnk_code2item SET DEFAULT nextval('clin.lnk_code2item_root_pk_lnk_code2item_seq'::regclass);


--
-- Name: lnk_code2episode pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2episode ALTER COLUMN pk SET DEFAULT nextval('clin.lnk_code2episode_pk_seq'::regclass);


--
-- Name: lnk_code2fhx pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2fhx ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_code2fhx row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2fhx ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_code2fhx modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2fhx ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_code2fhx modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2fhx ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_code2fhx pk_lnk_code2item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2fhx ALTER COLUMN pk_lnk_code2item SET DEFAULT nextval('clin.lnk_code2item_root_pk_lnk_code2item_seq'::regclass);


--
-- Name: lnk_code2fhx pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2fhx ALTER COLUMN pk SET DEFAULT nextval('clin.lnk_code2fhx_pk_seq'::regclass);


--
-- Name: lnk_code2h_issue pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2h_issue ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_code2h_issue row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2h_issue ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_code2h_issue modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2h_issue ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_code2h_issue modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2h_issue ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_code2h_issue pk_lnk_code2item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2h_issue ALTER COLUMN pk_lnk_code2item SET DEFAULT nextval('clin.lnk_code2item_root_pk_lnk_code2item_seq'::regclass);


--
-- Name: lnk_code2h_issue pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2h_issue ALTER COLUMN pk SET DEFAULT nextval('clin.lnk_code2h_issue_pk_seq'::regclass);


--
-- Name: lnk_code2item_root pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2item_root ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_code2item_root row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2item_root ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_code2item_root modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2item_root ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_code2item_root modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2item_root ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_code2item_root pk_lnk_code2item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2item_root ALTER COLUMN pk_lnk_code2item SET DEFAULT nextval('clin.lnk_code2item_root_pk_lnk_code2item_seq'::regclass);


--
-- Name: lnk_code2narrative pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2narrative ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_code2narrative row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2narrative ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_code2narrative modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2narrative ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_code2narrative modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2narrative ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_code2narrative pk_lnk_code2item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2narrative ALTER COLUMN pk_lnk_code2item SET DEFAULT nextval('clin.lnk_code2item_root_pk_lnk_code2item_seq'::regclass);


--
-- Name: lnk_code2narrative pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2narrative ALTER COLUMN pk SET DEFAULT nextval('clin.lnk_code2narrative_pk_seq'::regclass);


--
-- Name: lnk_code2procedure pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2procedure ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_code2procedure row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2procedure ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_code2procedure modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2procedure ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_code2procedure modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2procedure ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_code2procedure pk_lnk_code2item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2procedure ALTER COLUMN pk_lnk_code2item SET DEFAULT nextval('clin.lnk_code2item_root_pk_lnk_code2item_seq'::regclass);


--
-- Name: lnk_code2procedure pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2procedure ALTER COLUMN pk SET DEFAULT nextval('clin.lnk_code2procedure_pk_seq'::regclass);


--
-- Name: lnk_code2rfe pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2rfe ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_code2rfe row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2rfe ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_code2rfe modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2rfe ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_code2rfe modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2rfe ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_code2rfe pk_lnk_code2item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2rfe ALTER COLUMN pk_lnk_code2item SET DEFAULT nextval('clin.lnk_code2item_root_pk_lnk_code2item_seq'::regclass);


--
-- Name: lnk_code2rfe pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2rfe ALTER COLUMN pk SET DEFAULT nextval('clin.lnk_code2rfe_pk_seq'::regclass);


--
-- Name: lnk_code2tst_pnl pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2tst_pnl ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_code2tst_pnl row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2tst_pnl ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_code2tst_pnl modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2tst_pnl ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_code2tst_pnl modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2tst_pnl ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_code2tst_pnl pk_lnk_code2item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2tst_pnl ALTER COLUMN pk_lnk_code2item SET DEFAULT nextval('clin.lnk_code2item_root_pk_lnk_code2item_seq'::regclass);


--
-- Name: lnk_code2tst_pnl pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2tst_pnl ALTER COLUMN pk SET DEFAULT nextval('clin.lnk_code2tst_pnl_pk_seq'::regclass);


--
-- Name: lnk_constraint2vacc_course pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_constraint2vacc_course ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_constraint2vacc_course row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_constraint2vacc_course ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_constraint2vacc_course modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_constraint2vacc_course ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_constraint2vacc_course modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_constraint2vacc_course ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_constraint2vacc_course pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_constraint2vacc_course ALTER COLUMN pk SET DEFAULT nextval('clin.lnk_constraint2vacc_course_pk_seq'::regclass);


--
-- Name: lnk_loinc2test_panel pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_loinc2test_panel ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_loinc2test_panel row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_loinc2test_panel ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_loinc2test_panel modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_loinc2test_panel ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_loinc2test_panel modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_loinc2test_panel ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_loinc2test_panel pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_loinc2test_panel ALTER COLUMN pk SET DEFAULT nextval('clin.lnk_loinc2test_panel_pk_seq'::regclass);


--
-- Name: lnk_pat2vaccination_course pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_pat2vaccination_course ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_pat2vaccination_course row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_pat2vaccination_course ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_pat2vaccination_course modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_pat2vaccination_course ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_pat2vaccination_course modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_pat2vaccination_course ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_pat2vaccination_course pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_pat2vaccination_course ALTER COLUMN pk SET DEFAULT nextval('clin.lnk_pat2vaccination_course_pk_seq'::regclass);


--
-- Name: lnk_substance2episode pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_substance2episode ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_substance2episode row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_substance2episode ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_substance2episode modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_substance2episode ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_substance2episode modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_substance2episode ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_substance2episode pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_substance2episode ALTER COLUMN pk SET DEFAULT nextval('clin.lnk_substance2episode_pk_seq'::regclass);


--
-- Name: lnk_tst2norm pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_tst2norm ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_tst2norm row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_tst2norm ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_tst2norm modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_tst2norm ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_tst2norm modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_tst2norm ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_tst2norm id; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_tst2norm ALTER COLUMN id SET DEFAULT nextval('clin.lnk_tst2norm_id_seq'::regclass);


--
-- Name: lnk_type2item pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_type2item ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_type2item row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_type2item ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_type2item modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_type2item ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_type2item modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_type2item ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_type2item pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_type2item ALTER COLUMN pk SET DEFAULT nextval('clin.lnk_type2item_pk_seq'::regclass);


--
-- Name: lnk_vaccination_course2schedule pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_vaccination_course2schedule ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_vaccination_course2schedule row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_vaccination_course2schedule ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_vaccination_course2schedule modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_vaccination_course2schedule ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_vaccination_course2schedule modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_vaccination_course2schedule ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_vaccination_course2schedule pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_vaccination_course2schedule ALTER COLUMN pk SET DEFAULT nextval('clin.lnk_vaccination_course2schedule_pk_seq'::regclass);


--
-- Name: meta_test_type pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.meta_test_type ALTER COLUMN pk SET DEFAULT nextval('clin.test_type_unified_pk_seq'::regclass);


--
-- Name: patient pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.patient ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: patient row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.patient ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: patient modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.patient ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: patient modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.patient ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: patient pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.patient ALTER COLUMN pk SET DEFAULT nextval('clin.patient_pk_seq'::regclass);


--
-- Name: procedure pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.procedure ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: procedure row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.procedure ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: procedure modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.procedure ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: procedure modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.procedure ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: procedure pk_item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.procedure ALTER COLUMN pk_item SET DEFAULT nextval('clin.clin_root_item_pk_item_seq'::regclass);


--
-- Name: procedure clin_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.procedure ALTER COLUMN clin_when SET DEFAULT now();


--
-- Name: procedure soap_cat; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.procedure ALTER COLUMN soap_cat SET DEFAULT 'p'::text;


--
-- Name: procedure pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.procedure ALTER COLUMN pk SET DEFAULT nextval('clin.procedure_pk_seq'::regclass);


--
-- Name: review_root pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.review_root ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: review_root row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.review_root ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: review_root modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.review_root ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: review_root modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.review_root ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: review_root pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.review_root ALTER COLUMN pk SET DEFAULT nextval('clin.review_root_pk_seq'::regclass);


--
-- Name: reviewed_test_results pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.reviewed_test_results ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: reviewed_test_results row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.reviewed_test_results ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: reviewed_test_results modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.reviewed_test_results ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: reviewed_test_results modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.reviewed_test_results ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: reviewed_test_results pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.reviewed_test_results ALTER COLUMN pk SET DEFAULT nextval('clin.review_root_pk_seq'::regclass);


--
-- Name: reviewed_test_results fk_reviewer; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.reviewed_test_results ALTER COLUMN fk_reviewer SET DEFAULT clin.f_fk_reviewer_default();


--
-- Name: soap_cat_ranks pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.soap_cat_ranks ALTER COLUMN pk SET DEFAULT nextval('clin.soap_cat_ranks_pk_seq'::regclass);


--
-- Name: substance_intake pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.substance_intake ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: substance_intake row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.substance_intake ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: substance_intake modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.substance_intake ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: substance_intake modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.substance_intake ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: substance_intake pk_item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.substance_intake ALTER COLUMN pk_item SET DEFAULT nextval('clin.clin_root_item_pk_item_seq'::regclass);


--
-- Name: substance_intake clin_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.substance_intake ALTER COLUMN clin_when SET DEFAULT now();


--
-- Name: substance_intake soap_cat; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.substance_intake ALTER COLUMN soap_cat SET DEFAULT 'p'::text;


--
-- Name: substance_intake pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.substance_intake ALTER COLUMN pk SET DEFAULT nextval('clin.substance_intake_pk_seq'::regclass);


--
-- Name: suppressed_hint pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.suppressed_hint ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: suppressed_hint row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.suppressed_hint ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: suppressed_hint modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.suppressed_hint ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: suppressed_hint modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.suppressed_hint ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: suppressed_hint pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.suppressed_hint ALTER COLUMN pk SET DEFAULT nextval('clin.suppressed_hint_pk_seq'::regclass);


--
-- Name: test_org pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_org ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: test_org row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_org ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: test_org modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_org ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: test_org modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_org ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: test_org pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_org ALTER COLUMN pk SET DEFAULT nextval('clin.test_org_pk_seq'::regclass);


--
-- Name: test_panel pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_panel ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: test_panel row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_panel ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: test_panel modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_panel ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: test_panel modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_panel ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: test_panel pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_panel ALTER COLUMN pk SET DEFAULT nextval('clin.test_panel_pk_seq'::regclass);


--
-- Name: test_result pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_result ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: test_result row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_result ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: test_result modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_result ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: test_result modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_result ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: test_result pk_item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_result ALTER COLUMN pk_item SET DEFAULT nextval('clin.clin_root_item_pk_item_seq'::regclass);


--
-- Name: test_result clin_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_result ALTER COLUMN clin_when SET DEFAULT now();


--
-- Name: test_result soap_cat; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_result ALTER COLUMN soap_cat SET DEFAULT 'o'::text;


--
-- Name: test_result pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_result ALTER COLUMN pk SET DEFAULT nextval('clin.test_result_pk_seq'::regclass);


--
-- Name: test_type pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_type ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: test_type row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_type ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: test_type modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_type ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: test_type modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_type ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: test_type pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_type ALTER COLUMN pk SET DEFAULT nextval('clin.test_type_pk_seq'::regclass);


--
-- Name: vaccination pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: vaccination row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: vaccination modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: vaccination modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: vaccination pk_item; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination ALTER COLUMN pk_item SET DEFAULT nextval('clin.clin_root_item_pk_item_seq'::regclass);


--
-- Name: vaccination clin_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination ALTER COLUMN clin_when SET DEFAULT now();


--
-- Name: vaccination soap_cat; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination ALTER COLUMN soap_cat SET DEFAULT 'p'::text;


--
-- Name: vaccination pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination ALTER COLUMN pk SET DEFAULT nextval('clin.vaccination_id_seq'::regclass);


--
-- Name: vaccination_course pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_course ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: vaccination_course row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_course ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: vaccination_course modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_course ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: vaccination_course modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_course ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: vaccination_course pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_course ALTER COLUMN pk SET DEFAULT nextval('clin.vaccination_course_pk_seq'::regclass);


--
-- Name: vaccination_course_constraint pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_course_constraint ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: vaccination_course_constraint row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_course_constraint ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: vaccination_course_constraint modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_course_constraint ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: vaccination_course_constraint modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_course_constraint ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: vaccination_course_constraint pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_course_constraint ALTER COLUMN pk SET DEFAULT nextval('clin.vaccination_course_constraint_pk_seq'::regclass);


--
-- Name: vaccination_definition pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_definition ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: vaccination_definition row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_definition ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: vaccination_definition modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_definition ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: vaccination_definition modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_definition ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: vaccination_definition id; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_definition ALTER COLUMN id SET DEFAULT nextval('clin.vaccination_definition_id_seq'::regclass);


--
-- Name: vaccination_schedule pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_schedule ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: vaccination_schedule row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_schedule ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: vaccination_schedule modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_schedule ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: vaccination_schedule modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_schedule ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: vaccination_schedule pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_schedule ALTER COLUMN pk SET DEFAULT nextval('clin.vaccination_schedule_pk_seq'::regclass);


--
-- Name: waiting_list pk_audit; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.waiting_list ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: waiting_list row_version; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.waiting_list ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: waiting_list modified_when; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.waiting_list ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: waiting_list modified_by; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.waiting_list ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: waiting_list pk; Type: DEFAULT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.waiting_list ALTER COLUMN pk SET DEFAULT nextval('clin.waiting_list_pk_seq'::regclass);


--
-- Name: beh_fall_typ pk_audit; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.beh_fall_typ ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: beh_fall_typ row_version; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.beh_fall_typ ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: beh_fall_typ modified_when; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.beh_fall_typ ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: beh_fall_typ modified_by; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.beh_fall_typ ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: beh_fall_typ pk; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.beh_fall_typ ALTER COLUMN pk SET DEFAULT nextval('de_de.beh_fall_typ_pk_seq'::regclass);


--
-- Name: kvk pk; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.kvk ALTER COLUMN pk SET DEFAULT nextval('de_de.kvk_pk_seq'::regclass);


--
-- Name: lab_test_gnr pk_audit; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.lab_test_gnr ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lab_test_gnr row_version; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.lab_test_gnr ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lab_test_gnr modified_when; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.lab_test_gnr ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lab_test_gnr modified_by; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.lab_test_gnr ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lab_test_gnr id; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.lab_test_gnr ALTER COLUMN id SET DEFAULT nextval('de_de.lab_test_gnr_id_seq'::regclass);


--
-- Name: payment_method pk; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.payment_method ALTER COLUMN pk SET DEFAULT nextval('de_de.payment_method_pk_seq'::regclass);


--
-- Name: prax_geb_paid pk_audit; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.prax_geb_paid ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: prax_geb_paid row_version; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.prax_geb_paid ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: prax_geb_paid modified_when; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.prax_geb_paid ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: prax_geb_paid modified_by; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.prax_geb_paid ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: prax_geb_paid pk; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.prax_geb_paid ALTER COLUMN pk SET DEFAULT nextval('de_de.prax_geb_paid_pk_seq'::regclass);


--
-- Name: zuzahlungsbefreiung id; Type: DEFAULT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.zuzahlungsbefreiung ALTER COLUMN id SET DEFAULT nextval('de_de.zuzahlungsbefreiung_id_seq'::regclass);


--
-- Name: address pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.address ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: address row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.address ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: address modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.address ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: address modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.address ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: address id; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.address ALTER COLUMN id SET DEFAULT nextval('dem.address_id_seq'::regclass);


--
-- Name: address_type id; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.address_type ALTER COLUMN id SET DEFAULT nextval('dem.address_type_id_seq'::regclass);


--
-- Name: country id; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.country ALTER COLUMN id SET DEFAULT nextval('dem.country_id_seq'::regclass);


--
-- Name: enum_comm_types pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.enum_comm_types ALTER COLUMN pk SET DEFAULT nextval('dem.enum_comm_types_id_seq'::regclass);


--
-- Name: enum_ext_id_types pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.enum_ext_id_types ALTER COLUMN pk SET DEFAULT nextval('dem.enum_ext_id_types_pk_seq'::regclass);


--
-- Name: gender_label pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.gender_label ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: gender_label row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.gender_label ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: gender_label modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.gender_label ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: gender_label modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.gender_label ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: gender_label pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.gender_label ALTER COLUMN pk SET DEFAULT nextval('dem.gender_label_pk_seq'::regclass);


--
-- Name: identity pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: identity row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: identity modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: identity modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: identity pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity ALTER COLUMN pk SET DEFAULT nextval('dem.identity_pk_seq'::regclass);


--
-- Name: identity_tag pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity_tag ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: identity_tag row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity_tag ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: identity_tag modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity_tag ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: identity_tag modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity_tag ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: identity_tag pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity_tag ALTER COLUMN pk SET DEFAULT nextval('dem.identity_tag_pk_seq'::regclass);


--
-- Name: inbox_item_category pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.inbox_item_category ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: inbox_item_category row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.inbox_item_category ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: inbox_item_category modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.inbox_item_category ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: inbox_item_category modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.inbox_item_category ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: inbox_item_category pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.inbox_item_category ALTER COLUMN pk SET DEFAULT nextval('dem.inbox_item_category_pk_seq'::regclass);


--
-- Name: inbox_item_type pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.inbox_item_type ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: inbox_item_type row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.inbox_item_type ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: inbox_item_type modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.inbox_item_type ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: inbox_item_type modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.inbox_item_type ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: inbox_item_type pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.inbox_item_type ALTER COLUMN pk SET DEFAULT nextval('dem.inbox_item_type_pk_seq'::regclass);


--
-- Name: lnk_identity2comm pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_identity2comm ALTER COLUMN pk SET DEFAULT nextval('dem.lnk_identity2comm_id_seq'::regclass);


--
-- Name: lnk_identity2ext_id pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_identity2ext_id ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_identity2ext_id row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_identity2ext_id ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_identity2ext_id modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_identity2ext_id ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_identity2ext_id modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_identity2ext_id ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_identity2ext_id id; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_identity2ext_id ALTER COLUMN id SET DEFAULT nextval('dem.lnk_identity2ext_id_id_seq'::regclass);


--
-- Name: lnk_job2person pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_job2person ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_job2person row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_job2person ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_job2person modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_job2person ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_job2person modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_job2person ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_job2person pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_job2person ALTER COLUMN pk SET DEFAULT nextval('dem.lnk_job2person_id_seq'::regclass);


--
-- Name: lnk_org_unit2comm pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2comm ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_org_unit2comm row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2comm ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_org_unit2comm modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2comm ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_org_unit2comm modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2comm ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_org_unit2comm pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2comm ALTER COLUMN pk SET DEFAULT nextval('dem.lnk_org_unit2comm_pk_seq'::regclass);


--
-- Name: lnk_org_unit2ext_id pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2ext_id ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_org_unit2ext_id row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2ext_id ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_org_unit2ext_id modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2ext_id ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_org_unit2ext_id modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2ext_id ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_org_unit2ext_id pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2ext_id ALTER COLUMN pk SET DEFAULT nextval('dem.lnk_org_unit2ext_id_pk_seq'::regclass);


--
-- Name: lnk_person2relative pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_person2relative ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_person2relative row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_person2relative ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_person2relative modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_person2relative ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_person2relative modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_person2relative ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_person2relative id; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_person2relative ALTER COLUMN id SET DEFAULT nextval('dem.lnk_person2relative_id_seq'::regclass);


--
-- Name: lnk_person_org_address id; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_person_org_address ALTER COLUMN id SET DEFAULT nextval('dem.lnk_person_org_address_id_seq'::regclass);


--
-- Name: marital_status pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.marital_status ALTER COLUMN pk SET DEFAULT nextval('dem.marital_status_pk_seq'::regclass);


--
-- Name: message_inbox pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.message_inbox ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: message_inbox row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.message_inbox ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: message_inbox modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.message_inbox ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: message_inbox modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.message_inbox ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: message_inbox pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.message_inbox ALTER COLUMN pk SET DEFAULT nextval('dem.provider_inbox_pk_seq'::regclass);


--
-- Name: name_gender_map id; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.name_gender_map ALTER COLUMN id SET DEFAULT nextval('dem.name_gender_map_id_seq'::regclass);


--
-- Name: names id; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.names ALTER COLUMN id SET DEFAULT nextval('dem.names_id_seq'::regclass);


--
-- Name: occupation pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.occupation ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: occupation row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.occupation ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: occupation modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.occupation ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: occupation modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.occupation ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: occupation id; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.occupation ALTER COLUMN id SET DEFAULT nextval('dem.occupation_id_seq'::regclass);


--
-- Name: org pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: org row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: org modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: org modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: org pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org ALTER COLUMN pk SET DEFAULT nextval('dem.org_pk_seq'::regclass);


--
-- Name: org_category pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org_category ALTER COLUMN pk SET DEFAULT nextval('dem.org_category_id_seq'::regclass);


--
-- Name: org_unit pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org_unit ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: org_unit row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org_unit ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: org_unit modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org_unit ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: org_unit modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org_unit ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: org_unit pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org_unit ALTER COLUMN pk SET DEFAULT nextval('dem.org_unit_pk_seq'::regclass);


--
-- Name: praxis_branch pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.praxis_branch ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: praxis_branch row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.praxis_branch ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: praxis_branch modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.praxis_branch ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: praxis_branch modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.praxis_branch ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: praxis_branch pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.praxis_branch ALTER COLUMN pk SET DEFAULT nextval('dem.praxis_branch_pk_seq'::regclass);


--
-- Name: region pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.region ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: region row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.region ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: region modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.region ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: region modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.region ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: region pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.region ALTER COLUMN pk SET DEFAULT nextval('dem.state_id_seq'::regclass);


--
-- Name: relation_types pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.relation_types ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: relation_types row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.relation_types ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: relation_types modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.relation_types ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: relation_types modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.relation_types ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: relation_types id; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.relation_types ALTER COLUMN id SET DEFAULT nextval('dem.relation_types_id_seq'::regclass);


--
-- Name: staff pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.staff ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: staff row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.staff ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: staff modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.staff ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: staff modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.staff ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: staff pk; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.staff ALTER COLUMN pk SET DEFAULT nextval('dem.staff_pk_seq'::regclass);


--
-- Name: street pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.street ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: street row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.street ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: street modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.street ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: street modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.street ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: street id; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.street ALTER COLUMN id SET DEFAULT nextval('dem.street_id_seq'::regclass);


--
-- Name: urb pk_audit; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.urb ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: urb row_version; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.urb ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: urb modified_when; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.urb ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: urb modified_by; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.urb ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: urb id; Type: DEFAULT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.urb ALTER COLUMN id SET DEFAULT nextval('dem.urb_id_seq'::regclass);


--
-- Name: access_log pk_audit; Type: DEFAULT; Schema: gm; Owner: gm-dbo
--

ALTER TABLE ONLY gm.access_log ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: access_log row_version; Type: DEFAULT; Schema: gm; Owner: gm-dbo
--

ALTER TABLE ONLY gm.access_log ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: access_log modified_when; Type: DEFAULT; Schema: gm; Owner: gm-dbo
--

ALTER TABLE ONLY gm.access_log ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: access_log modified_by; Type: DEFAULT; Schema: gm; Owner: gm-dbo
--

ALTER TABLE ONLY gm.access_log ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: access_log pk; Type: DEFAULT; Schema: gm; Owner: gm-dbo
--

ALTER TABLE ONLY gm.access_log ALTER COLUMN pk SET DEFAULT nextval('gm.access_log_pk_seq'::regclass);


--
-- Name: notifying_tables pk; Type: DEFAULT; Schema: gm; Owner: gm-dbo
--

ALTER TABLE ONLY gm.notifying_tables ALTER COLUMN pk SET DEFAULT nextval('gm.notifying_tables_pk_seq'::regclass);


--
-- Name: schema_revision pk; Type: DEFAULT; Schema: gm; Owner: gm-dbo
--

ALTER TABLE ONLY gm.schema_revision ALTER COLUMN pk SET DEFAULT nextval('gm.gm_schema_revision_pk_seq'::regclass);


--
-- Name: curr_lang pk; Type: DEFAULT; Schema: i18n; Owner: gm-dbo
--

ALTER TABLE ONLY i18n.curr_lang ALTER COLUMN pk SET DEFAULT nextval('i18n.curr_lang_pk_seq'::regclass);


--
-- Name: keys pk; Type: DEFAULT; Schema: i18n; Owner: gm-dbo
--

ALTER TABLE ONLY i18n.keys ALTER COLUMN pk SET DEFAULT nextval('i18n.keys_pk_seq'::regclass);


--
-- Name: translations pk; Type: DEFAULT; Schema: i18n; Owner: gm-dbo
--

ALTER TABLE ONLY i18n.translations ALTER COLUMN pk SET DEFAULT nextval('i18n.translations_pk_seq'::regclass);


--
-- Name: basic_unit pk; Type: DEFAULT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.basic_unit ALTER COLUMN pk SET DEFAULT nextval('public.basic_unit_pk_seq'::regclass);


--
-- Name: form_field_types pk; Type: DEFAULT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_field_types ALTER COLUMN pk SET DEFAULT nextval('public.form_field_types_pk_seq'::regclass);


--
-- Name: form_fields pk; Type: DEFAULT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_fields ALTER COLUMN pk SET DEFAULT nextval('public.form_fields_pk_seq'::regclass);


--
-- Name: form_job_queue pk; Type: DEFAULT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_job_queue ALTER COLUMN pk SET DEFAULT nextval('public.form_job_queue_pk_seq'::regclass);


--
-- Name: form_job_targets pk; Type: DEFAULT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_job_targets ALTER COLUMN pk SET DEFAULT nextval('public.form_job_targets_pk_seq'::regclass);


--
-- Name: form_print_defs pk; Type: DEFAULT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_print_defs ALTER COLUMN pk SET DEFAULT nextval('public.form_print_defs_pk_seq'::regclass);


--
-- Name: gm_client_db_match pk; Type: DEFAULT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.gm_client_db_match ALTER COLUMN pk SET DEFAULT nextval('public.gm_client_db_match_pk_seq'::regclass);


--
-- Name: housekeeping_todo pk; Type: DEFAULT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.housekeeping_todo ALTER COLUMN pk SET DEFAULT nextval('public.housekeeping_todo_pk_seq'::regclass);


--
-- Name: test_norm pk; Type: DEFAULT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.test_norm ALTER COLUMN pk SET DEFAULT nextval('public.test_norm_pk_seq'::regclass);


--
-- Name: unit pk; Type: DEFAULT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.unit ALTER COLUMN pk SET DEFAULT nextval('public.unit_pk_seq'::regclass);


--
-- Name: atc pk_coding_system; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.atc ALTER COLUMN pk_coding_system SET DEFAULT nextval('ref.coding_system_root_pk_coding_system_seq'::regclass);


--
-- Name: atc pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.atc ALTER COLUMN pk SET DEFAULT nextval('ref.atc_pk_seq'::regclass);


--
-- Name: auto_hint pk_audit; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.auto_hint ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: auto_hint row_version; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.auto_hint ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: auto_hint modified_when; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.auto_hint ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: auto_hint modified_by; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.auto_hint ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: auto_hint pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.auto_hint ALTER COLUMN pk SET DEFAULT nextval('ref.auto_hint_pk_seq'::regclass);


--
-- Name: billable pk_coding_system; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.billable ALTER COLUMN pk_coding_system SET DEFAULT nextval('ref.coding_system_root_pk_coding_system_seq'::regclass);


--
-- Name: billable pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.billable ALTER COLUMN pk SET DEFAULT nextval('ref.billable_pk_seq'::regclass);


--
-- Name: coda pk_coding_system; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.coda ALTER COLUMN pk_coding_system SET DEFAULT nextval('ref.coding_system_root_pk_coding_system_seq'::regclass);


--
-- Name: coda pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.coda ALTER COLUMN pk SET DEFAULT nextval('ref.coda_pk_seq'::regclass);


--
-- Name: code_thesaurus_root pk_thesaurus; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.code_thesaurus_root ALTER COLUMN pk_thesaurus SET DEFAULT nextval('ref.code_thesaurus_root_pk_thesaurus_seq'::regclass);


--
-- Name: coding_system_root pk_coding_system; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.coding_system_root ALTER COLUMN pk_coding_system SET DEFAULT nextval('ref.coding_system_root_pk_coding_system_seq'::regclass);


--
-- Name: data_source pk_audit; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.data_source ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: data_source row_version; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.data_source ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: data_source modified_when; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.data_source ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: data_source modified_by; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.data_source ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: data_source pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.data_source ALTER COLUMN pk SET DEFAULT nextval('ref.data_source_pk_seq'::regclass);


--
-- Name: document_type pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.document_type ALTER COLUMN pk SET DEFAULT nextval('ref.document_type_pk_seq'::regclass);


--
-- Name: dose pk_audit; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.dose ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: dose row_version; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.dose ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: dose modified_when; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.dose ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: dose modified_by; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.dose ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: dose pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.dose ALTER COLUMN pk SET DEFAULT nextval('ref.dose_pk_seq'::regclass);


--
-- Name: drug_product pk_audit; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.drug_product ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: drug_product row_version; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.drug_product ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: drug_product modified_when; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.drug_product ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: drug_product modified_by; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.drug_product ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: drug_product pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.drug_product ALTER COLUMN pk SET DEFAULT nextval('ref.substance_brand_pk_seq'::regclass);


--
-- Name: form_types pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.form_types ALTER COLUMN pk SET DEFAULT nextval('ref.form_types_pk_seq'::regclass);


--
-- Name: icd10 pk_coding_system; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icd10 ALTER COLUMN pk_coding_system SET DEFAULT nextval('ref.coding_system_root_pk_coding_system_seq'::regclass);


--
-- Name: icd10 pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icd10 ALTER COLUMN pk SET DEFAULT nextval('ref.icd10_pk_seq'::regclass);


--
-- Name: icd9 pk_coding_system; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icd9 ALTER COLUMN pk_coding_system SET DEFAULT nextval('ref.coding_system_root_pk_coding_system_seq'::regclass);


--
-- Name: icd9 pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icd9 ALTER COLUMN pk SET DEFAULT nextval('ref.icd9_pk_seq'::regclass);


--
-- Name: icpc pk_coding_system; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc ALTER COLUMN pk_coding_system SET DEFAULT nextval('ref.coding_system_root_pk_coding_system_seq'::regclass);


--
-- Name: icpc pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc ALTER COLUMN pk SET DEFAULT nextval('ref.icpc_pk_seq'::regclass);


--
-- Name: icpc_chapter pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc_chapter ALTER COLUMN pk SET DEFAULT nextval('ref.icpc_chapter_pk_seq'::regclass);


--
-- Name: icpc_component pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc_component ALTER COLUMN pk SET DEFAULT nextval('ref.icpc_component_pk_seq'::regclass);


--
-- Name: icpc_thesaurus pk_thesaurus; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc_thesaurus ALTER COLUMN pk_thesaurus SET DEFAULT nextval('ref.code_thesaurus_root_pk_thesaurus_seq'::regclass);


--
-- Name: icpc_thesaurus pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc_thesaurus ALTER COLUMN pk SET DEFAULT nextval('ref.icpc_thesaurus_pk_seq'::regclass);


--
-- Name: keyword_expansion pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.keyword_expansion ALTER COLUMN pk SET DEFAULT nextval('ref.keyword_expansion_pk_seq'::regclass);


--
-- Name: lnk_dose2drug pk_audit; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.lnk_dose2drug ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_dose2drug row_version; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.lnk_dose2drug ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_dose2drug modified_when; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.lnk_dose2drug ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_dose2drug modified_by; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.lnk_dose2drug ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_dose2drug pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.lnk_dose2drug ALTER COLUMN pk SET DEFAULT nextval('ref.lnk_dose2drug_pk_seq'::regclass);


--
-- Name: lnk_loinc2substance pk_audit; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.lnk_loinc2substance ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: lnk_loinc2substance row_version; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.lnk_loinc2substance ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: lnk_loinc2substance modified_when; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.lnk_loinc2substance ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: lnk_loinc2substance modified_by; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.lnk_loinc2substance ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: lnk_loinc2substance pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.lnk_loinc2substance ALTER COLUMN pk SET DEFAULT nextval('ref.lnk_loinc2substance_pk_seq'::regclass);


--
-- Name: loinc pk_coding_system; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.loinc ALTER COLUMN pk_coding_system SET DEFAULT nextval('ref.coding_system_root_pk_coding_system_seq'::regclass);


--
-- Name: loinc pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.loinc ALTER COLUMN pk SET DEFAULT nextval('ref.loinc_pk_seq'::regclass);


--
-- Name: ops pk_coding_system; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.ops ALTER COLUMN pk_coding_system SET DEFAULT nextval('ref.coding_system_root_pk_coding_system_seq'::regclass);


--
-- Name: ops pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.ops ALTER COLUMN pk SET DEFAULT nextval('ref.ops_pk_seq'::regclass);


--
-- Name: other_code pk_coding_system; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.other_code ALTER COLUMN pk_coding_system SET DEFAULT nextval('ref.coding_system_root_pk_coding_system_seq'::regclass);


--
-- Name: other_code pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.other_code ALTER COLUMN pk SET DEFAULT nextval('ref.other_code_pk_seq'::regclass);


--
-- Name: papersizes pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.papersizes ALTER COLUMN pk SET DEFAULT nextval('ref.papersizes_pk_seq'::regclass);


--
-- Name: paperwork_templates pk_audit; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.paperwork_templates ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: paperwork_templates row_version; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.paperwork_templates ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: paperwork_templates modified_when; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.paperwork_templates ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: paperwork_templates modified_by; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.paperwork_templates ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: paperwork_templates pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.paperwork_templates ALTER COLUMN pk SET DEFAULT nextval('ref.paperwork_templates_pk_seq'::regclass);


--
-- Name: substance pk_audit; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.substance ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: substance row_version; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.substance ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: substance modified_when; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.substance ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: substance modified_by; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.substance ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: substance pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.substance ALTER COLUMN pk SET DEFAULT nextval('ref.substance_pk_seq'::regclass);


--
-- Name: tag_image pk_audit; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.tag_image ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: tag_image row_version; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.tag_image ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: tag_image modified_when; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.tag_image ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: tag_image modified_by; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.tag_image ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: tag_image pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.tag_image ALTER COLUMN pk SET DEFAULT nextval('ref.tag_image_pk_seq'::regclass);


--
-- Name: vacc_route pk_audit; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.vacc_route ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: vacc_route row_version; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.vacc_route ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: vacc_route modified_when; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.vacc_route ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: vacc_route modified_by; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.vacc_route ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: vacc_route id; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.vacc_route ALTER COLUMN id SET DEFAULT nextval('ref.vacc_route_id_seq'::regclass);


--
-- Name: vaccine pk_audit; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.vaccine ALTER COLUMN pk_audit SET DEFAULT nextval('audit.audit_fields_pk_audit_seq'::regclass);


--
-- Name: vaccine row_version; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.vaccine ALTER COLUMN row_version SET DEFAULT 0;


--
-- Name: vaccine modified_when; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.vaccine ALTER COLUMN modified_when SET DEFAULT now();


--
-- Name: vaccine modified_by; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.vaccine ALTER COLUMN modified_by SET DEFAULT "current_user"();


--
-- Name: vaccine pk; Type: DEFAULT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.vaccine ALTER COLUMN pk SET DEFAULT nextval('ref.vaccine_pk_seq'::regclass);


--
-- Name: referral referral_pkey; Type: CONSTRAINT; Schema: au; Owner: gm-dbo
--

ALTER TABLE ONLY au.referral
    ADD CONSTRAINT referral_pkey PRIMARY KEY (id);


--
-- Name: audit_fields audit_fields_pkey; Type: CONSTRAINT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.audit_fields
    ADD CONSTRAINT audit_fields_pkey PRIMARY KEY (pk_audit);


--
-- Name: audit_trail audit_trail_pkey; Type: CONSTRAINT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.audit_trail
    ADD CONSTRAINT audit_trail_pkey PRIMARY KEY (pk_audit);


--
-- Name: audited_tables audited_tables_pkey; Type: CONSTRAINT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.audited_tables
    ADD CONSTRAINT audited_tables_pkey PRIMARY KEY (id);


--
-- Name: audited_tables audited_tables_schema_key; Type: CONSTRAINT; Schema: audit; Owner: gm-dbo
--

ALTER TABLE ONLY audit.audited_tables
    ADD CONSTRAINT audited_tables_schema_key UNIQUE (schema, table_name);


--
-- Name: bill bill_bill_uniq_invoice_id; Type: CONSTRAINT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill
    ADD CONSTRAINT bill_bill_uniq_invoice_id UNIQUE (invoice_id);


--
-- Name: bill_item bill_item_pkey; Type: CONSTRAINT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill_item
    ADD CONSTRAINT bill_item_pkey PRIMARY KEY (pk);


--
-- Name: bill bill_pkey; Type: CONSTRAINT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill
    ADD CONSTRAINT bill_pkey PRIMARY KEY (pk);


--
-- Name: lnk_enc_type2billable lnk_enc_type2billable_pkey; Type: CONSTRAINT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.lnk_enc_type2billable
    ADD CONSTRAINT lnk_enc_type2billable_pkey PRIMARY KEY (pk);


--
-- Name: doc_desc doc_desc_doc_id_key; Type: CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_desc
    ADD CONSTRAINT doc_desc_doc_id_key UNIQUE (fk_doc, text);


--
-- Name: doc_desc doc_desc_pkey; Type: CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_desc
    ADD CONSTRAINT doc_desc_pkey PRIMARY KEY (pk);


--
-- Name: doc_med doc_med_pkey; Type: CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_med
    ADD CONSTRAINT doc_med_pkey PRIMARY KEY (pk);


--
-- Name: doc_obj doc_obj_pkey; Type: CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_obj
    ADD CONSTRAINT doc_obj_pkey PRIMARY KEY (pk);


--
-- Name: doc_type doc_type_name_key; Type: CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_type
    ADD CONSTRAINT doc_type_name_key UNIQUE (name);


--
-- Name: doc_type doc_type_pkey; Type: CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_type
    ADD CONSTRAINT doc_type_pkey PRIMARY KEY (pk);


--
-- Name: lnk_doc_med2episode lnk_doc_med2episode_fk_episode_key; Type: CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.lnk_doc_med2episode
    ADD CONSTRAINT lnk_doc_med2episode_fk_episode_key UNIQUE (fk_episode, fk_doc_med);


--
-- Name: lnk_doc_med2episode lnk_doc_med2episode_pkey; Type: CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.lnk_doc_med2episode
    ADD CONSTRAINT lnk_doc_med2episode_pkey PRIMARY KEY (pk);


--
-- Name: reviewed_doc_objs reviewed_doc_objs_fk_reviewed_row_key; Type: CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.reviewed_doc_objs
    ADD CONSTRAINT reviewed_doc_objs_fk_reviewed_row_key UNIQUE (fk_reviewed_row, fk_reviewer);


--
-- Name: reviewed_doc_objs reviewed_doc_objs_pkey; Type: CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.reviewed_doc_objs
    ADD CONSTRAINT reviewed_doc_objs_pkey PRIMARY KEY (pk);


--
-- Name: cfg_data cfg_data_pkey; Type: CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_data
    ADD CONSTRAINT cfg_data_pkey PRIMARY KEY (pk);


--
-- Name: cfg_item cfg_item_fk_template_key; Type: CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_item
    ADD CONSTRAINT cfg_item_fk_template_key UNIQUE (fk_template, owner, workplace, cookie);


--
-- Name: cfg_item cfg_item_pkey; Type: CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_item
    ADD CONSTRAINT cfg_item_pkey PRIMARY KEY (pk);


--
-- Name: cfg_numeric cfg_numeric_pkey; Type: CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_numeric
    ADD CONSTRAINT cfg_numeric_pkey PRIMARY KEY (pk);


--
-- Name: cfg_str_array cfg_str_array_pkey; Type: CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_str_array
    ADD CONSTRAINT cfg_str_array_pkey PRIMARY KEY (pk);


--
-- Name: cfg_string cfg_string_pkey; Type: CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_string
    ADD CONSTRAINT cfg_string_pkey PRIMARY KEY (pk);


--
-- Name: cfg_template cfg_template_pkey; Type: CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_template
    ADD CONSTRAINT cfg_template_pkey PRIMARY KEY (pk);


--
-- Name: cfg_type_enum cfg_type_enum_name_key; Type: CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_type_enum
    ADD CONSTRAINT cfg_type_enum_name_key UNIQUE (name);


--
-- Name: config config_pkey; Type: CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.config
    ADD CONSTRAINT config_pkey PRIMARY KEY (id);


--
-- Name: db_logon_banner db_logon_banner_singularizer_key; Type: CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.db_logon_banner
    ADD CONSTRAINT db_logon_banner_singularizer_key UNIQUE (singularizer);


--
-- Name: report_query report_query_label_key; Type: CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.report_query
    ADD CONSTRAINT report_query_label_key UNIQUE (label);


--
-- Name: report_query report_query_pkey; Type: CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.report_query
    ADD CONSTRAINT report_query_pkey PRIMARY KEY (pk);


--
-- Name: _enum_allergy_type _enum_allergy_type_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin._enum_allergy_type
    ADD CONSTRAINT _enum_allergy_type_pkey PRIMARY KEY (pk);


--
-- Name: _enum_allergy_type _enum_allergy_type_value_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin._enum_allergy_type
    ADD CONSTRAINT _enum_allergy_type_value_key UNIQUE (value);


--
-- Name: allergy allergy_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy
    ADD CONSTRAINT allergy_pkey PRIMARY KEY (pk);


--
-- Name: allergy_state allergy_state_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy_state
    ADD CONSTRAINT allergy_state_pkey PRIMARY KEY (pk);


--
-- Name: fhx_relation_type c_fhx_rel_type_uniq; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.fhx_relation_type
    ADD CONSTRAINT c_fhx_rel_type_uniq UNIQUE (description, is_genetic);


--
-- Name: clin_aux_note clin_aux_note_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_aux_note
    ADD CONSTRAINT clin_aux_note_pkey PRIMARY KEY (pk);


--
-- Name: clin_diag clin_diag_fk_narrative_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_diag
    ADD CONSTRAINT clin_diag_fk_narrative_key UNIQUE (fk_narrative);


--
-- Name: clin_diag clin_diag_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_diag
    ADD CONSTRAINT clin_diag_pkey PRIMARY KEY (pk);


--
-- Name: export_item clin_export_item_uniq_desc_per_pat; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.export_item
    ADD CONSTRAINT clin_export_item_uniq_desc_per_pat UNIQUE (fk_identity, description);


--
-- Name: export_item clin_export_item_uniq_fk_obj; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.export_item
    ADD CONSTRAINT clin_export_item_uniq_fk_obj UNIQUE (fk_doc_obj);


--
-- Name: external_care clin_ext_care_uniq_fk_issue_per_unit; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.external_care
    ADD CONSTRAINT clin_ext_care_uniq_fk_issue_per_unit UNIQUE (fk_health_issue, fk_org_unit);


--
-- Name: family_history clin_hx_family_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.family_history
    ADD CONSTRAINT clin_hx_family_pkey PRIMARY KEY (pk);


--
-- Name: clin_item_type clin_item_type_code_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_item_type
    ADD CONSTRAINT clin_item_type_code_key UNIQUE (code);


--
-- Name: clin_item_type clin_item_type_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_item_type
    ADD CONSTRAINT clin_item_type_pkey PRIMARY KEY (pk);


--
-- Name: clin_item_type clin_item_type_type_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_item_type
    ADD CONSTRAINT clin_item_type_type_key UNIQUE (type);


--
-- Name: lnk_code2aoe clin_lc2aoe_code_uniq_per_item; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2aoe
    ADD CONSTRAINT clin_lc2aoe_code_uniq_per_item UNIQUE (fk_generic_code, fk_item);


--
-- Name: lnk_code2episode clin_lc2epi_code_uniq_per_item; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2episode
    ADD CONSTRAINT clin_lc2epi_code_uniq_per_item UNIQUE (fk_generic_code, fk_item);


--
-- Name: lnk_code2fhx clin_lc2fhx_code_uniq_per_item; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2fhx
    ADD CONSTRAINT clin_lc2fhx_code_uniq_per_item UNIQUE (fk_generic_code, fk_item);


--
-- Name: lnk_code2h_issue clin_lc2h_issue_code_uniq_per_item; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2h_issue
    ADD CONSTRAINT clin_lc2h_issue_code_uniq_per_item UNIQUE (fk_generic_code, fk_item);


--
-- Name: lnk_code2narrative clin_lc2narr_code_uniq_per_item; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2narrative
    ADD CONSTRAINT clin_lc2narr_code_uniq_per_item UNIQUE (fk_generic_code, fk_item);


--
-- Name: lnk_code2procedure clin_lc2proc_code_uniq_per_item; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2procedure
    ADD CONSTRAINT clin_lc2proc_code_uniq_per_item UNIQUE (fk_generic_code, fk_item);


--
-- Name: lnk_code2rfe clin_lc2rfe_code_uniq_per_item; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2rfe
    ADD CONSTRAINT clin_lc2rfe_code_uniq_per_item UNIQUE (fk_generic_code, fk_item);


--
-- Name: lnk_code2tst_pnl clin_lc2tst_pnl_code_uniq_per_item; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2tst_pnl
    ADD CONSTRAINT clin_lc2tst_pnl_code_uniq_per_item UNIQUE (fk_generic_code, fk_item);


--
-- Name: clin_narrative clin_narrative_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_narrative
    ADD CONSTRAINT clin_narrative_pkey PRIMARY KEY (pk);


--
-- Name: patient clin_patient_uniq_fk_identity; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.patient
    ADD CONSTRAINT clin_patient_uniq_fk_identity UNIQUE (fk_identity);


--
-- Name: clin_root_item clin_root_item_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_root_item
    ADD CONSTRAINT clin_root_item_pkey PRIMARY KEY (pk_item);


--
-- Name: test_type clin_test_type_uniq_abbrev_per_org; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_type
    ADD CONSTRAINT clin_test_type_uniq_abbrev_per_org UNIQUE (fk_test_org, abbrev);


--
-- Name: test_type clin_test_type_uniq_name_per_org; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_type
    ADD CONSTRAINT clin_test_type_uniq_name_per_org UNIQUE (fk_test_org, name);


--
-- Name: encounter encounter_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.encounter
    ADD CONSTRAINT encounter_pkey PRIMARY KEY (pk);


--
-- Name: encounter_type encounter_type_description_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.encounter_type
    ADD CONSTRAINT encounter_type_description_key UNIQUE (description);


--
-- Name: encounter_type encounter_type_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.encounter_type
    ADD CONSTRAINT encounter_type_pkey PRIMARY KEY (pk);


--
-- Name: episode episode_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.episode
    ADD CONSTRAINT episode_pkey PRIMARY KEY (pk);


--
-- Name: export_item export_item_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.export_item
    ADD CONSTRAINT export_item_pkey PRIMARY KEY (pk);


--
-- Name: external_care external_care_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.external_care
    ADD CONSTRAINT external_care_pkey PRIMARY KEY (pk);


--
-- Name: fhx_relation_type fhx_relation_type_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.fhx_relation_type
    ADD CONSTRAINT fhx_relation_type_pkey PRIMARY KEY (pk);


--
-- Name: form_data form_data_fk_instance_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_data
    ADD CONSTRAINT form_data_fk_instance_key UNIQUE (fk_instance, fk_form_field);


--
-- Name: form_data form_data_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_data
    ADD CONSTRAINT form_data_pkey PRIMARY KEY (pk);


--
-- Name: form_instances form_instances_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_instances
    ADD CONSTRAINT form_instances_pkey PRIMARY KEY (pk);


--
-- Name: health_issue health_issue_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.health_issue
    ADD CONSTRAINT health_issue_pkey PRIMARY KEY (pk);


--
-- Name: hospital_stay hospital_stay_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.hospital_stay
    ADD CONSTRAINT hospital_stay_pkey PRIMARY KEY (pk);


--
-- Name: incoming_data_unmatchable incoming_data_unmatchable_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.incoming_data_unmatchable
    ADD CONSTRAINT incoming_data_unmatchable_pkey PRIMARY KEY (pk);


--
-- Name: incoming_data_unmatched incoming_data_unmatched_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.incoming_data_unmatched
    ADD CONSTRAINT incoming_data_unmatched_pkey PRIMARY KEY (pk);


--
-- Name: lab_request lab_request_fk_test_org_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lab_request
    ADD CONSTRAINT lab_request_fk_test_org_key UNIQUE (fk_test_org, request_id);


--
-- Name: lab_request lab_request_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lab_request
    ADD CONSTRAINT lab_request_pkey PRIMARY KEY (pk);


--
-- Name: lnk_code2aoe lnk_code2aoe_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2aoe
    ADD CONSTRAINT lnk_code2aoe_pkey PRIMARY KEY (pk);


--
-- Name: lnk_code2episode lnk_code2episode_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2episode
    ADD CONSTRAINT lnk_code2episode_pkey PRIMARY KEY (pk);


--
-- Name: lnk_code2fhx lnk_code2fhx_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2fhx
    ADD CONSTRAINT lnk_code2fhx_pkey PRIMARY KEY (pk);


--
-- Name: lnk_code2h_issue lnk_code2h_issue_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2h_issue
    ADD CONSTRAINT lnk_code2h_issue_pkey PRIMARY KEY (pk);


--
-- Name: lnk_code2item_root lnk_code2item_root_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2item_root
    ADD CONSTRAINT lnk_code2item_root_pkey PRIMARY KEY (pk_lnk_code2item);


--
-- Name: lnk_code2narrative lnk_code2narrative_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2narrative
    ADD CONSTRAINT lnk_code2narrative_pkey PRIMARY KEY (pk);


--
-- Name: lnk_code2procedure lnk_code2procedure_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2procedure
    ADD CONSTRAINT lnk_code2procedure_pkey PRIMARY KEY (pk);


--
-- Name: lnk_code2rfe lnk_code2rfe_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2rfe
    ADD CONSTRAINT lnk_code2rfe_pkey PRIMARY KEY (pk);


--
-- Name: lnk_code2tst_pnl lnk_code2tst_pnl_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2tst_pnl
    ADD CONSTRAINT lnk_code2tst_pnl_pkey PRIMARY KEY (pk);


--
-- Name: lnk_constraint2vacc_course lnk_constraint2vacc_course_fk_vaccination_course_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_constraint2vacc_course
    ADD CONSTRAINT lnk_constraint2vacc_course_fk_vaccination_course_key UNIQUE (fk_vaccination_course, fk_constraint);


--
-- Name: lnk_constraint2vacc_course lnk_constraint2vacc_course_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_constraint2vacc_course
    ADD CONSTRAINT lnk_constraint2vacc_course_pkey PRIMARY KEY (pk);


--
-- Name: lnk_loinc2test_panel lnk_loinc2test_panel_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_loinc2test_panel
    ADD CONSTRAINT lnk_loinc2test_panel_pkey PRIMARY KEY (pk);


--
-- Name: lnk_pat2vaccination_course lnk_pat2vaccination_course_fk_patient_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_pat2vaccination_course
    ADD CONSTRAINT lnk_pat2vaccination_course_fk_patient_key UNIQUE (fk_patient, fk_course);


--
-- Name: lnk_pat2vaccination_course lnk_pat2vaccination_course_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_pat2vaccination_course
    ADD CONSTRAINT lnk_pat2vaccination_course_pkey PRIMARY KEY (pk);


--
-- Name: lnk_substance2episode lnk_substance2episode_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_substance2episode
    ADD CONSTRAINT lnk_substance2episode_pkey PRIMARY KEY (pk);


--
-- Name: lnk_tst2norm lnk_tst2norm_id_test_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_tst2norm
    ADD CONSTRAINT lnk_tst2norm_id_test_key UNIQUE (id_test, id_norm);


--
-- Name: lnk_tst2norm lnk_tst2norm_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_tst2norm
    ADD CONSTRAINT lnk_tst2norm_pkey PRIMARY KEY (id);


--
-- Name: lnk_type2item lnk_type2item_fk_type_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_type2item
    ADD CONSTRAINT lnk_type2item_fk_type_key UNIQUE (fk_type, fk_item);


--
-- Name: lnk_type2item lnk_type2item_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_type2item
    ADD CONSTRAINT lnk_type2item_pkey PRIMARY KEY (pk);


--
-- Name: lnk_vaccination_course2schedule lnk_vaccination_course2schedule_fk_course_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_vaccination_course2schedule
    ADD CONSTRAINT lnk_vaccination_course2schedule_fk_course_key UNIQUE (fk_course);


--
-- Name: lnk_vaccination_course2schedule lnk_vaccination_course2schedule_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_vaccination_course2schedule
    ADD CONSTRAINT lnk_vaccination_course2schedule_pkey PRIMARY KEY (pk);


--
-- Name: patient patient_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.patient
    ADD CONSTRAINT patient_pkey PRIMARY KEY (pk);


--
-- Name: procedure procedure_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.procedure
    ADD CONSTRAINT procedure_pkey PRIMARY KEY (pk);


--
-- Name: review_root review_root_fk_reviewed_row_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.review_root
    ADD CONSTRAINT review_root_fk_reviewed_row_key UNIQUE (fk_reviewed_row, fk_reviewer);


--
-- Name: review_root review_root_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.review_root
    ADD CONSTRAINT review_root_pkey PRIMARY KEY (pk);


--
-- Name: reviewed_test_results reviewed_test_results_fk_reviewed_row_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.reviewed_test_results
    ADD CONSTRAINT reviewed_test_results_fk_reviewed_row_key UNIQUE (fk_reviewed_row, fk_reviewer);


--
-- Name: reviewed_test_results reviewed_test_results_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.reviewed_test_results
    ADD CONSTRAINT reviewed_test_results_pkey PRIMARY KEY (pk);


--
-- Name: soap_cat_ranks soap_cat_ranks_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.soap_cat_ranks
    ADD CONSTRAINT soap_cat_ranks_pkey PRIMARY KEY (pk);


--
-- Name: substance_intake substance_intake_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.substance_intake
    ADD CONSTRAINT substance_intake_pkey PRIMARY KEY (pk);


--
-- Name: suppressed_hint suppressed_hint_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.suppressed_hint
    ADD CONSTRAINT suppressed_hint_pkey PRIMARY KEY (pk);


--
-- Name: test_org test_org_fk_org_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_org
    ADD CONSTRAINT test_org_fk_org_key UNIQUE (fk_org_unit);


--
-- Name: test_org test_org_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_org
    ADD CONSTRAINT test_org_pkey PRIMARY KEY (pk);


--
-- Name: test_panel test_panel_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_panel
    ADD CONSTRAINT test_panel_pkey PRIMARY KEY (pk);


--
-- Name: test_result test_result_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_result
    ADD CONSTRAINT test_result_pkey PRIMARY KEY (pk);


--
-- Name: test_type test_type_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_type
    ADD CONSTRAINT test_type_pkey PRIMARY KEY (pk);


--
-- Name: meta_test_type test_type_unified_code_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.meta_test_type
    ADD CONSTRAINT test_type_unified_code_key UNIQUE (abbrev, name);


--
-- Name: meta_test_type test_type_unified_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.meta_test_type
    ADD CONSTRAINT test_type_unified_pkey PRIMARY KEY (pk);


--
-- Name: reviewed_test_results unique_review_per_row; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.reviewed_test_results
    ADD CONSTRAINT unique_review_per_row UNIQUE (fk_reviewed_row);


--
-- Name: vaccination_course_constraint vaccination_course_constraint_description_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_course_constraint
    ADD CONSTRAINT vaccination_course_constraint_description_key UNIQUE (description);


--
-- Name: vaccination_course_constraint vaccination_course_constraint_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_course_constraint
    ADD CONSTRAINT vaccination_course_constraint_pkey PRIMARY KEY (pk);


--
-- Name: vaccination_course vaccination_course_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_course
    ADD CONSTRAINT vaccination_course_pkey PRIMARY KEY (pk);


--
-- Name: vaccination_definition vaccination_definition_fk_course_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_definition
    ADD CONSTRAINT vaccination_definition_fk_course_key UNIQUE (fk_course, seq_no);


--
-- Name: vaccination_definition vaccination_definition_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_definition
    ADD CONSTRAINT vaccination_definition_pkey PRIMARY KEY (id);


--
-- Name: vaccination vaccination_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination
    ADD CONSTRAINT vaccination_pkey PRIMARY KEY (pk);


--
-- Name: vaccination_schedule vaccination_schedule_name_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_schedule
    ADD CONSTRAINT vaccination_schedule_name_key UNIQUE (name);


--
-- Name: vaccination_schedule vaccination_schedule_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_schedule
    ADD CONSTRAINT vaccination_schedule_pkey PRIMARY KEY (pk);


--
-- Name: waiting_list waiting_list_list_position_key; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.waiting_list
    ADD CONSTRAINT waiting_list_list_position_key UNIQUE (list_position);


--
-- Name: waiting_list waiting_list_pkey; Type: CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.waiting_list
    ADD CONSTRAINT waiting_list_pkey PRIMARY KEY (pk);


--
-- Name: beh_fall_typ beh_fall_typ_code_key; Type: CONSTRAINT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.beh_fall_typ
    ADD CONSTRAINT beh_fall_typ_code_key UNIQUE (code);


--
-- Name: beh_fall_typ beh_fall_typ_kurzform_key; Type: CONSTRAINT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.beh_fall_typ
    ADD CONSTRAINT beh_fall_typ_kurzform_key UNIQUE (kurzform);


--
-- Name: beh_fall_typ beh_fall_typ_name_key; Type: CONSTRAINT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.beh_fall_typ
    ADD CONSTRAINT beh_fall_typ_name_key UNIQUE (name);


--
-- Name: beh_fall_typ beh_fall_typ_pkey; Type: CONSTRAINT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.beh_fall_typ
    ADD CONSTRAINT beh_fall_typ_pkey PRIMARY KEY (pk);


--
-- Name: kvk kvk_pkey; Type: CONSTRAINT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.kvk
    ADD CONSTRAINT kvk_pkey PRIMARY KEY (pk);


--
-- Name: lab_test_gnr lab_test_gnr_pkey; Type: CONSTRAINT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.lab_test_gnr
    ADD CONSTRAINT lab_test_gnr_pkey PRIMARY KEY (id);


--
-- Name: payment_method payment_method_description_key; Type: CONSTRAINT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.payment_method
    ADD CONSTRAINT payment_method_description_key UNIQUE (description);


--
-- Name: payment_method payment_method_pkey; Type: CONSTRAINT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.payment_method
    ADD CONSTRAINT payment_method_pkey PRIMARY KEY (pk);


--
-- Name: prax_geb_paid prax_geb_paid_pkey; Type: CONSTRAINT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.prax_geb_paid
    ADD CONSTRAINT prax_geb_paid_pkey PRIMARY KEY (pk);


--
-- Name: zuzahlungsbefreiung zuzahlungsbefreiung_pkey; Type: CONSTRAINT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.zuzahlungsbefreiung
    ADD CONSTRAINT zuzahlungsbefreiung_pkey PRIMARY KEY (id);


--
-- Name: address address_id_street_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.address
    ADD CONSTRAINT address_id_street_key UNIQUE (id_street, aux_street, number, subunit, addendum);


--
-- Name: address address_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.address
    ADD CONSTRAINT address_pkey PRIMARY KEY (id);


--
-- Name: address_type address_type_name_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.address_type
    ADD CONSTRAINT address_type_name_key UNIQUE (name);


--
-- Name: address_type address_type_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.address_type
    ADD CONSTRAINT address_type_pkey PRIMARY KEY (id);


--
-- Name: country country_code_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.country
    ADD CONSTRAINT country_code_key UNIQUE (code);


--
-- Name: country country_name_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.country
    ADD CONSTRAINT country_name_key UNIQUE (name);


--
-- Name: country country_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.country
    ADD CONSTRAINT country_pkey PRIMARY KEY (id);


--
-- Name: identity_tag dem_identity_tag_uniq_tag; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity_tag
    ADD CONSTRAINT dem_identity_tag_uniq_tag UNIQUE (fk_identity, fk_tag);


--
-- Name: org dem_org_uniq_desc; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org
    ADD CONSTRAINT dem_org_uniq_desc UNIQUE (description);


--
-- Name: praxis_branch dem_praxis_branch_uniq_fk_org_unit; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.praxis_branch
    ADD CONSTRAINT dem_praxis_branch_uniq_fk_org_unit UNIQUE (fk_org_unit);


--
-- Name: enum_comm_types enum_comm_types_description_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.enum_comm_types
    ADD CONSTRAINT enum_comm_types_description_key UNIQUE (description);


--
-- Name: enum_comm_types enum_comm_types_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.enum_comm_types
    ADD CONSTRAINT enum_comm_types_pkey PRIMARY KEY (pk);


--
-- Name: enum_ext_id_types enum_ext_id_types_name_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.enum_ext_id_types
    ADD CONSTRAINT enum_ext_id_types_name_key UNIQUE (name, issuer);


--
-- Name: enum_ext_id_types enum_ext_id_types_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.enum_ext_id_types
    ADD CONSTRAINT enum_ext_id_types_pkey PRIMARY KEY (pk);


--
-- Name: gender_label gender_label_label_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.gender_label
    ADD CONSTRAINT gender_label_label_key UNIQUE (label);


--
-- Name: gender_label gender_label_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.gender_label
    ADD CONSTRAINT gender_label_pkey PRIMARY KEY (pk);


--
-- Name: gender_label gender_label_tag_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.gender_label
    ADD CONSTRAINT gender_label_tag_key UNIQUE (tag);


--
-- Name: identity identity_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity
    ADD CONSTRAINT identity_pkey PRIMARY KEY (pk);


--
-- Name: identity_tag identity_tag_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity_tag
    ADD CONSTRAINT identity_tag_pkey PRIMARY KEY (pk);


--
-- Name: inbox_item_category inbox_item_category_description_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.inbox_item_category
    ADD CONSTRAINT inbox_item_category_description_key UNIQUE (description);


--
-- Name: inbox_item_category inbox_item_category_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.inbox_item_category
    ADD CONSTRAINT inbox_item_category_pkey PRIMARY KEY (pk);


--
-- Name: inbox_item_type inbox_item_type_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.inbox_item_type
    ADD CONSTRAINT inbox_item_type_pkey PRIMARY KEY (pk);


--
-- Name: inbox_item_type inbox_item_type_uniq_desc_cat; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.inbox_item_type
    ADD CONSTRAINT inbox_item_type_uniq_desc_cat UNIQUE (description, fk_inbox_item_category);


--
-- Name: lnk_identity2comm lnk_identity2comm_id_identity_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_identity2comm
    ADD CONSTRAINT lnk_identity2comm_id_identity_key UNIQUE (fk_identity, url);


--
-- Name: lnk_identity2comm lnk_identity2comm_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_identity2comm
    ADD CONSTRAINT lnk_identity2comm_pkey PRIMARY KEY (pk);


--
-- Name: lnk_identity2ext_id lnk_identity2ext_id_id_identity_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_identity2ext_id
    ADD CONSTRAINT lnk_identity2ext_id_id_identity_key UNIQUE (id_identity, external_id, fk_origin);


--
-- Name: lnk_identity2ext_id lnk_identity2ext_id_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_identity2ext_id
    ADD CONSTRAINT lnk_identity2ext_id_pkey PRIMARY KEY (id);


--
-- Name: lnk_job2person lnk_job2person_id_identity_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_job2person
    ADD CONSTRAINT lnk_job2person_id_identity_key UNIQUE (fk_identity, fk_occupation);


--
-- Name: lnk_job2person lnk_job2person_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_job2person
    ADD CONSTRAINT lnk_job2person_pkey PRIMARY KEY (pk);


--
-- Name: lnk_org_unit2comm lnk_org_unit2comm_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2comm
    ADD CONSTRAINT lnk_org_unit2comm_pkey PRIMARY KEY (pk);


--
-- Name: lnk_org_unit2comm lnk_org_unit2comm_uniq_url; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2comm
    ADD CONSTRAINT lnk_org_unit2comm_uniq_url UNIQUE (fk_org_unit, url, fk_type);


--
-- Name: lnk_org_unit2ext_id lnk_org_unit2ext_id_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2ext_id
    ADD CONSTRAINT lnk_org_unit2ext_id_pkey PRIMARY KEY (pk);


--
-- Name: lnk_org_unit2ext_id lnk_org_unit2ext_id_uniq_id; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2ext_id
    ADD CONSTRAINT lnk_org_unit2ext_id_uniq_id UNIQUE (fk_org_unit, external_id, fk_type);


--
-- Name: lnk_person2relative lnk_person2relative_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_person2relative
    ADD CONSTRAINT lnk_person2relative_pkey PRIMARY KEY (id);


--
-- Name: lnk_person_org_address lnk_person_org_address_id_identity_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_person_org_address
    ADD CONSTRAINT lnk_person_org_address_id_identity_key UNIQUE (id_identity, id_address);


--
-- Name: lnk_person_org_address lnk_person_org_address_id_org_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_person_org_address
    ADD CONSTRAINT lnk_person_org_address_id_org_key UNIQUE (id_org, id_address);


--
-- Name: lnk_person_org_address lnk_person_org_address_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_person_org_address
    ADD CONSTRAINT lnk_person_org_address_pkey PRIMARY KEY (id);


--
-- Name: marital_status marital_status_name_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.marital_status
    ADD CONSTRAINT marital_status_name_key UNIQUE (name);


--
-- Name: marital_status marital_status_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.marital_status
    ADD CONSTRAINT marital_status_pkey PRIMARY KEY (pk);


--
-- Name: name_gender_map name_gender_map_name_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.name_gender_map
    ADD CONSTRAINT name_gender_map_name_key UNIQUE (name);


--
-- Name: name_gender_map name_gender_map_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.name_gender_map
    ADD CONSTRAINT name_gender_map_pkey PRIMARY KEY (id);


--
-- Name: names names_id_identity_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.names
    ADD CONSTRAINT names_id_identity_key UNIQUE (id_identity, lastnames, firstnames);


--
-- Name: names names_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.names
    ADD CONSTRAINT names_pkey PRIMARY KEY (id);


--
-- Name: occupation occupation_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.occupation
    ADD CONSTRAINT occupation_pkey PRIMARY KEY (id);


--
-- Name: org_category org_category_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org_category
    ADD CONSTRAINT org_category_pkey PRIMARY KEY (pk);


--
-- Name: org org_pkey1; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org
    ADD CONSTRAINT org_pkey1 PRIMARY KEY (pk);


--
-- Name: org_unit org_unit_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org_unit
    ADD CONSTRAINT org_unit_pkey PRIMARY KEY (pk);


--
-- Name: org_unit org_unit_uniq_per_org; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org_unit
    ADD CONSTRAINT org_unit_uniq_per_org UNIQUE (fk_org, description);


--
-- Name: praxis_branch praxis_branch_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.praxis_branch
    ADD CONSTRAINT praxis_branch_pkey PRIMARY KEY (pk);


--
-- Name: message_inbox provider_inbox_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.message_inbox
    ADD CONSTRAINT provider_inbox_pkey PRIMARY KEY (pk);


--
-- Name: relation_types relation_types_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.relation_types
    ADD CONSTRAINT relation_types_pkey PRIMARY KEY (id);


--
-- Name: staff staff_db_user_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.staff
    ADD CONSTRAINT staff_db_user_key UNIQUE (db_user);


--
-- Name: staff staff_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.staff
    ADD CONSTRAINT staff_pkey PRIMARY KEY (pk);


--
-- Name: staff staff_short_alias_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.staff
    ADD CONSTRAINT staff_short_alias_key UNIQUE (short_alias);


--
-- Name: region state_code_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.region
    ADD CONSTRAINT state_code_key UNIQUE (code, country);


--
-- Name: region state_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.region
    ADD CONSTRAINT state_pkey PRIMARY KEY (pk);


--
-- Name: street street_id_urb_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.street
    ADD CONSTRAINT street_id_urb_key UNIQUE (id_urb, name, postcode);


--
-- Name: street street_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.street
    ADD CONSTRAINT street_pkey PRIMARY KEY (id);


--
-- Name: urb urb_id_state_key; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.urb
    ADD CONSTRAINT urb_id_state_key UNIQUE (fk_region, postcode, name);


--
-- Name: urb urb_pkey; Type: CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.urb
    ADD CONSTRAINT urb_pkey PRIMARY KEY (id);


--
-- Name: access_log access_log_pkey; Type: CONSTRAINT; Schema: gm; Owner: gm-dbo
--

ALTER TABLE ONLY gm.access_log
    ADD CONSTRAINT access_log_pkey PRIMARY KEY (pk);


--
-- Name: schema_revision gm_schema_revision_filename_key; Type: CONSTRAINT; Schema: gm; Owner: gm-dbo
--

ALTER TABLE ONLY gm.schema_revision
    ADD CONSTRAINT gm_schema_revision_filename_key UNIQUE (filename, version);


--
-- Name: schema_revision gm_schema_revision_pkey; Type: CONSTRAINT; Schema: gm; Owner: gm-dbo
--

ALTER TABLE ONLY gm.schema_revision
    ADD CONSTRAINT gm_schema_revision_pkey PRIMARY KEY (pk);


--
-- Name: notifying_tables notifying_tables_pkey; Type: CONSTRAINT; Schema: gm; Owner: gm-dbo
--

ALTER TABLE ONLY gm.notifying_tables
    ADD CONSTRAINT notifying_tables_pkey PRIMARY KEY (pk);


--
-- Name: curr_lang curr_lang_pkey; Type: CONSTRAINT; Schema: i18n; Owner: gm-dbo
--

ALTER TABLE ONLY i18n.curr_lang
    ADD CONSTRAINT curr_lang_pkey PRIMARY KEY (pk);


--
-- Name: curr_lang curr_lang_user_key; Type: CONSTRAINT; Schema: i18n; Owner: gm-dbo
--

ALTER TABLE ONLY i18n.curr_lang
    ADD CONSTRAINT curr_lang_user_key UNIQUE (db_user);


--
-- Name: keys keys_orig_key; Type: CONSTRAINT; Schema: i18n; Owner: gm-dbo
--

ALTER TABLE ONLY i18n.keys
    ADD CONSTRAINT keys_orig_key UNIQUE (orig);


--
-- Name: keys keys_pkey; Type: CONSTRAINT; Schema: i18n; Owner: gm-dbo
--

ALTER TABLE ONLY i18n.keys
    ADD CONSTRAINT keys_pkey PRIMARY KEY (pk);


--
-- Name: translations translations_lang_key; Type: CONSTRAINT; Schema: i18n; Owner: gm-dbo
--

ALTER TABLE ONLY i18n.translations
    ADD CONSTRAINT translations_lang_key UNIQUE (lang, orig);


--
-- Name: translations translations_pkey; Type: CONSTRAINT; Schema: i18n; Owner: gm-dbo
--

ALTER TABLE ONLY i18n.translations
    ADD CONSTRAINT translations_pkey PRIMARY KEY (pk);


--
-- Name: basic_unit basic_unit_name_long_key; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.basic_unit
    ADD CONSTRAINT basic_unit_name_long_key UNIQUE (name_long);


--
-- Name: basic_unit basic_unit_name_short_key; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.basic_unit
    ADD CONSTRAINT basic_unit_name_short_key UNIQUE (name_short);


--
-- Name: basic_unit basic_unit_pkey; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.basic_unit
    ADD CONSTRAINT basic_unit_pkey PRIMARY KEY (pk);


--
-- Name: form_field_types form_field_types_name_key; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_field_types
    ADD CONSTRAINT form_field_types_name_key UNIQUE (name);


--
-- Name: form_field_types form_field_types_pkey; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_field_types
    ADD CONSTRAINT form_field_types_pkey PRIMARY KEY (pk);


--
-- Name: form_fields form_fields_fk_form_key; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_fields
    ADD CONSTRAINT form_fields_fk_form_key UNIQUE (fk_form, long_name);


--
-- Name: form_fields form_fields_fk_form_key1; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_fields
    ADD CONSTRAINT form_fields_fk_form_key1 UNIQUE (fk_form, template_placeholder);


--
-- Name: form_fields form_fields_pkey; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_fields
    ADD CONSTRAINT form_fields_pkey PRIMARY KEY (pk);


--
-- Name: form_job_queue form_job_queue_pkey; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_job_queue
    ADD CONSTRAINT form_job_queue_pkey PRIMARY KEY (pk);


--
-- Name: form_job_targets form_job_targets_pkey; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_job_targets
    ADD CONSTRAINT form_job_targets_pkey PRIMARY KEY (pk);


--
-- Name: form_job_targets form_job_targets_target_key; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_job_targets
    ADD CONSTRAINT form_job_targets_target_key UNIQUE (target);


--
-- Name: form_print_defs form_print_defs_fk_form_key; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_print_defs
    ADD CONSTRAINT form_print_defs_fk_form_key UNIQUE (fk_form);


--
-- Name: form_print_defs form_print_defs_pkey; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_print_defs
    ADD CONSTRAINT form_print_defs_pkey PRIMARY KEY (pk);


--
-- Name: gm_client_db_match gm_client_db_match_client_version_key; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.gm_client_db_match
    ADD CONSTRAINT gm_client_db_match_client_version_key UNIQUE (client_version, client_type, db_identity_hash);


--
-- Name: gm_client_db_match gm_client_db_match_pkey; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.gm_client_db_match
    ADD CONSTRAINT gm_client_db_match_pkey PRIMARY KEY (pk);


--
-- Name: housekeeping_todo housekeeping_todo_pkey; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.housekeeping_todo
    ADD CONSTRAINT housekeeping_todo_pkey PRIMARY KEY (pk);


--
-- Name: test_norm test_norm_fk_ref_src_key; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.test_norm
    ADD CONSTRAINT test_norm_fk_ref_src_key UNIQUE (fk_ref_src, data);


--
-- Name: test_norm test_norm_pkey; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.test_norm
    ADD CONSTRAINT test_norm_pkey PRIMARY KEY (pk);


--
-- Name: unit unit_pkey; Type: CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.unit
    ADD CONSTRAINT unit_pkey PRIMARY KEY (pk);


--
-- Name: atc atc_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.atc
    ADD CONSTRAINT atc_pkey PRIMARY KEY (pk);


--
-- Name: auto_hint auto_hint_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.auto_hint
    ADD CONSTRAINT auto_hint_pkey PRIMARY KEY (pk);


--
-- Name: billable billable_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.billable
    ADD CONSTRAINT billable_pkey PRIMARY KEY (pk);


--
-- Name: vaccine clin_vaccine_uniq_brand; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.vaccine
    ADD CONSTRAINT clin_vaccine_uniq_brand UNIQUE (fk_drug_product);


--
-- Name: coda coda_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.coda
    ADD CONSTRAINT coda_pkey PRIMARY KEY (pk);


--
-- Name: code_thesaurus_root code_thesaurus_root_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.code_thesaurus_root
    ADD CONSTRAINT code_thesaurus_root_pkey PRIMARY KEY (pk_thesaurus);


--
-- Name: coding_system_root coding_system_root_fk_data_source_key; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.coding_system_root
    ADD CONSTRAINT coding_system_root_fk_data_source_key UNIQUE (fk_data_source, code);


--
-- Name: coding_system_root coding_system_root_fk_data_source_key1; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.coding_system_root
    ADD CONSTRAINT coding_system_root_fk_data_source_key1 UNIQUE (fk_data_source, term);


--
-- Name: coding_system_root coding_system_root_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.coding_system_root
    ADD CONSTRAINT coding_system_root_pkey PRIMARY KEY (pk_coding_system);


--
-- Name: data_source data_source_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.data_source
    ADD CONSTRAINT data_source_pkey PRIMARY KEY (pk);


--
-- Name: data_source data_source_version_key; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.data_source
    ADD CONSTRAINT data_source_version_key UNIQUE (version, name_long);


--
-- Name: data_source data_source_version_key1; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.data_source
    ADD CONSTRAINT data_source_version_key1 UNIQUE (version, name_short);


--
-- Name: document_type document_type_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.document_type
    ADD CONSTRAINT document_type_pkey PRIMARY KEY (pk);


--
-- Name: dose dose_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.dose
    ADD CONSTRAINT dose_pkey PRIMARY KEY (pk);


--
-- Name: form_types form_types_name_key; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.form_types
    ADD CONSTRAINT form_types_name_key UNIQUE (name);


--
-- Name: form_types form_types_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.form_types
    ADD CONSTRAINT form_types_pkey PRIMARY KEY (pk);


--
-- Name: icd10 icd10_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icd10
    ADD CONSTRAINT icd10_pkey PRIMARY KEY (pk);


--
-- Name: icd9 icd9_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icd9
    ADD CONSTRAINT icd9_pkey PRIMARY KEY (pk);


--
-- Name: icpc_chapter icpc_chapter_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc_chapter
    ADD CONSTRAINT icpc_chapter_pkey PRIMARY KEY (pk);


--
-- Name: icpc_component icpc_component_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc_component
    ADD CONSTRAINT icpc_component_pkey PRIMARY KEY (pk);


--
-- Name: icpc icpc_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc
    ADD CONSTRAINT icpc_pkey PRIMARY KEY (pk);


--
-- Name: icpc_thesaurus icpc_thesaurus_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc_thesaurus
    ADD CONSTRAINT icpc_thesaurus_pkey PRIMARY KEY (pk);


--
-- Name: keyword_expansion keyword_expansion_fk_staff_key; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.keyword_expansion
    ADD CONSTRAINT keyword_expansion_fk_staff_key UNIQUE (fk_staff, keyword);


--
-- Name: keyword_expansion keyword_expansion_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.keyword_expansion
    ADD CONSTRAINT keyword_expansion_pkey PRIMARY KEY (pk);


--
-- Name: lnk_dose2drug lnk_dose2drug_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.lnk_dose2drug
    ADD CONSTRAINT lnk_dose2drug_pkey PRIMARY KEY (pk);


--
-- Name: lnk_loinc2substance lnk_loinc2substance_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.lnk_loinc2substance
    ADD CONSTRAINT lnk_loinc2substance_pkey PRIMARY KEY (pk);


--
-- Name: loinc loinc_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.loinc
    ADD CONSTRAINT loinc_pkey PRIMARY KEY (pk);


--
-- Name: ops ops_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.ops
    ADD CONSTRAINT ops_pkey PRIMARY KEY (pk);


--
-- Name: other_code other_code_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.other_code
    ADD CONSTRAINT other_code_pkey PRIMARY KEY (pk);


--
-- Name: papersizes papersizes_name_key; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.papersizes
    ADD CONSTRAINT papersizes_name_key UNIQUE (name);


--
-- Name: papersizes papersizes_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.papersizes
    ADD CONSTRAINT papersizes_pkey PRIMARY KEY (pk);


--
-- Name: paperwork_templates paperwork_templates_gnumed_revision_key; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.paperwork_templates
    ADD CONSTRAINT paperwork_templates_gnumed_revision_key UNIQUE (gnumed_revision, external_version, name_long);


--
-- Name: paperwork_templates paperwork_templates_name_long_key; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.paperwork_templates
    ADD CONSTRAINT paperwork_templates_name_long_key UNIQUE (name_long, name_short);


--
-- Name: paperwork_templates paperwork_templates_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.paperwork_templates
    ADD CONSTRAINT paperwork_templates_pkey PRIMARY KEY (pk);


--
-- Name: auto_hint ref_auto_hint_uniq_query; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.auto_hint
    ADD CONSTRAINT ref_auto_hint_uniq_query UNIQUE (query);


--
-- Name: auto_hint ref_auto_hint_uniq_title; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.auto_hint
    ADD CONSTRAINT ref_auto_hint_uniq_title UNIQUE (title);


--
-- Name: icpc_chapter ref_icpc_chapter_unique_desc; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc_chapter
    ADD CONSTRAINT ref_icpc_chapter_unique_desc UNIQUE (description);


--
-- Name: icpc_component ref_icpc_component_unique_desc; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc_component
    ADD CONSTRAINT ref_icpc_component_unique_desc UNIQUE (description);


--
-- Name: icpc_chapter ref_icpc_unique_chapter; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc_chapter
    ADD CONSTRAINT ref_icpc_unique_chapter UNIQUE (chapter);


--
-- Name: icpc ref_icpc_unique_code_ext; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc
    ADD CONSTRAINT ref_icpc_unique_code_ext UNIQUE (code, code_extension);


--
-- Name: icpc_component ref_icpc_unique_component; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc_component
    ADD CONSTRAINT ref_icpc_unique_component UNIQUE (component);


--
-- Name: tag_image ref_tag_image_uniq_desc; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.tag_image
    ADD CONSTRAINT ref_tag_image_uniq_desc UNIQUE (description);


--
-- Name: drug_product substance_brand_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.drug_product
    ADD CONSTRAINT substance_brand_pkey PRIMARY KEY (pk);


--
-- Name: substance substance_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.substance
    ADD CONSTRAINT substance_pkey PRIMARY KEY (pk);


--
-- Name: tag_image tag_image_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.tag_image
    ADD CONSTRAINT tag_image_pkey PRIMARY KEY (pk);


--
-- Name: vacc_route vacc_route_abbreviation_key; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.vacc_route
    ADD CONSTRAINT vacc_route_abbreviation_key UNIQUE (abbreviation);


--
-- Name: vacc_route vacc_route_description_key; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.vacc_route
    ADD CONSTRAINT vacc_route_description_key UNIQUE (description);


--
-- Name: vacc_route vacc_route_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.vacc_route
    ADD CONSTRAINT vacc_route_pkey PRIMARY KEY (id);


--
-- Name: vaccine vaccine_pkey; Type: CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.vaccine
    ADD CONSTRAINT vaccine_pkey PRIMARY KEY (pk);


--
-- Name: lab_request lab_request_fk_test_org_key; Type: CONSTRAINT; Schema: staging; Owner: gm-dbo
--

ALTER TABLE ONLY staging.lab_request
    ADD CONSTRAINT lab_request_fk_test_org_key UNIQUE (fk_test_org, request_id);


--
-- Name: lab_request lab_request_pkey; Type: CONSTRAINT; Schema: staging; Owner: gm-dbo
--

ALTER TABLE ONLY staging.lab_request
    ADD CONSTRAINT lab_request_pkey PRIMARY KEY (pk);


--
-- Name: lnk_vacc_ind2subst_dose lnk_vacc_ind2subst_dose_fk_indication_fk_dose_key; Type: CONSTRAINT; Schema: staging; Owner: gm-dbo
--

ALTER TABLE ONLY staging.lnk_vacc_ind2subst_dose
    ADD CONSTRAINT lnk_vacc_ind2subst_dose_fk_indication_fk_dose_key UNIQUE (fk_indication, fk_dose);


--
-- Name: lnk_vacc_ind2subst_dose lnk_vacc_ind2subst_dose_fk_indication_is_live_key; Type: CONSTRAINT; Schema: staging; Owner: gm-dbo
--

ALTER TABLE ONLY staging.lnk_vacc_ind2subst_dose
    ADD CONSTRAINT lnk_vacc_ind2subst_dose_fk_indication_is_live_key UNIQUE (fk_indication, is_live);


--
-- Name: test_result test_result_pkey; Type: CONSTRAINT; Schema: staging; Owner: gm-dbo
--

ALTER TABLE ONLY staging.test_result
    ADD CONSTRAINT test_result_pkey PRIMARY KEY (pk);


--
-- Name: idx_au_referral_fk_encounter; Type: INDEX; Schema: au; Owner: gm-dbo
--

CREATE INDEX idx_au_referral_fk_encounter ON au.referral USING btree (fk_encounter);


--
-- Name: idx_au_referral_fk_episode; Type: INDEX; Schema: au; Owner: gm-dbo
--

CREATE INDEX idx_au_referral_fk_episode ON au.referral USING btree (fk_episode);


--
-- Name: idx_bill_bill_item_fk_bill; Type: INDEX; Schema: bill; Owner: gm-dbo
--

CREATE INDEX idx_bill_bill_item_fk_bill ON bill.bill_item USING btree (fk_bill);


--
-- Name: idx_bill_bill_item_fk_billable; Type: INDEX; Schema: bill; Owner: gm-dbo
--

CREATE INDEX idx_bill_bill_item_fk_billable ON bill.bill_item USING btree (fk_billable);


--
-- Name: idx_lnk_enc_type2billable_fk_billable; Type: INDEX; Schema: bill; Owner: gm-dbo
--

CREATE INDEX idx_lnk_enc_type2billable_fk_billable ON bill.lnk_enc_type2billable USING btree (fk_billable);


--
-- Name: idx_lnk_enc_type2billable_fk_encounter_type; Type: INDEX; Schema: bill; Owner: gm-dbo
--

CREATE INDEX idx_lnk_enc_type2billable_fk_encounter_type ON bill.lnk_enc_type2billable USING btree (fk_encounter_type);


--
-- Name: idx_doc_desc_fk_doc; Type: INDEX; Schema: blobs; Owner: gm-dbo
--

CREATE INDEX idx_doc_desc_fk_doc ON blobs.doc_desc USING btree (fk_doc);


--
-- Name: idx_doc_med_fk_encounter; Type: INDEX; Schema: blobs; Owner: gm-dbo
--

CREATE INDEX idx_doc_med_fk_encounter ON blobs.doc_med USING btree (fk_encounter);


--
-- Name: idx_doc_med_fk_episode; Type: INDEX; Schema: blobs; Owner: gm-dbo
--

CREATE INDEX idx_doc_med_fk_episode ON blobs.doc_med USING btree (fk_episode);


--
-- Name: idx_doc_med_fk_hospital_stay; Type: INDEX; Schema: blobs; Owner: gm-dbo
--

CREATE INDEX idx_doc_med_fk_hospital_stay ON blobs.doc_med USING btree (fk_hospital_stay);


--
-- Name: idx_doc_med_fk_org_unit; Type: INDEX; Schema: blobs; Owner: gm-dbo
--

CREATE INDEX idx_doc_med_fk_org_unit ON blobs.doc_med USING btree (fk_org_unit);


--
-- Name: idx_doc_med_fk_type; Type: INDEX; Schema: blobs; Owner: gm-dbo
--

CREATE INDEX idx_doc_med_fk_type ON blobs.doc_med USING btree (fk_type);


--
-- Name: idx_doc_obj_fk_doc; Type: INDEX; Schema: blobs; Owner: gm-dbo
--

CREATE INDEX idx_doc_obj_fk_doc ON blobs.doc_obj USING btree (fk_doc);


--
-- Name: idx_doc_obj_fk_intended_reviewer; Type: INDEX; Schema: blobs; Owner: gm-dbo
--

CREATE INDEX idx_doc_obj_fk_intended_reviewer ON blobs.doc_obj USING btree (fk_intended_reviewer);


--
-- Name: idx_rev_doc_objs_fk_reviewed_row; Type: INDEX; Schema: blobs; Owner: gm-dbo
--

CREATE INDEX idx_rev_doc_objs_fk_reviewed_row ON blobs.reviewed_doc_objs USING btree (fk_reviewed_row);


--
-- Name: idx_rev_doc_objs_fk_reviewer; Type: INDEX; Schema: blobs; Owner: gm-dbo
--

CREATE INDEX idx_rev_doc_objs_fk_reviewer ON blobs.reviewed_doc_objs USING btree (fk_reviewer);


--
-- Name: idx_c_lc2aoe_fk_item; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_c_lc2aoe_fk_item ON clin.lnk_code2aoe USING btree (fk_item);


--
-- Name: idx_c_lc2epi_fk_item; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_c_lc2epi_fk_item ON clin.lnk_code2episode USING btree (fk_item);


--
-- Name: idx_c_lc2fhx_fk_item; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_c_lc2fhx_fk_item ON clin.lnk_code2fhx USING btree (fk_item);


--
-- Name: idx_c_lc2iss_fk_item; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_c_lc2iss_fk_item ON clin.lnk_code2h_issue USING btree (fk_item);


--
-- Name: idx_c_lc2narr_fk_item; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_c_lc2narr_fk_item ON clin.lnk_code2narrative USING btree (fk_item);


--
-- Name: idx_c_lc2proc_fk_item; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_c_lc2proc_fk_item ON clin.lnk_code2procedure USING btree (fk_item);


--
-- Name: idx_c_lc2rfe_fk_item; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_c_lc2rfe_fk_item ON clin.lnk_code2rfe USING btree (fk_item);


--
-- Name: idx_c_lc2tp_fk_item; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_c_lc2tp_fk_item ON clin.lnk_code2tst_pnl USING btree (fk_item);


--
-- Name: idx_c_subst_int_fk_drug_comp; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_c_subst_int_fk_drug_comp ON clin.substance_intake USING btree (fk_drug_component);


--
-- Name: idx_clin_allergy_fk_encounter; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_allergy_fk_encounter ON clin.allergy USING btree (fk_encounter);


--
-- Name: idx_clin_allergy_fk_episode; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_allergy_fk_episode ON clin.allergy USING btree (fk_episode);


--
-- Name: idx_clin_clin_aux_note_fk_encounter; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_clin_aux_note_fk_encounter ON clin.clin_aux_note USING btree (fk_encounter);


--
-- Name: idx_clin_clin_aux_note_fk_episode; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_clin_aux_note_fk_episode ON clin.clin_aux_note USING btree (fk_episode);


--
-- Name: idx_clin_clin_narrative_fk_encounter; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_clin_narrative_fk_encounter ON clin.clin_narrative USING btree (fk_encounter);


--
-- Name: idx_clin_clin_narrative_fk_episode; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_clin_narrative_fk_episode ON clin.clin_narrative USING btree (fk_episode);


--
-- Name: idx_clin_encounter_fk_location; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_encounter_fk_location ON clin.encounter USING btree (fk_location);


--
-- Name: idx_clin_family_history_fk_encounter; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_family_history_fk_encounter ON clin.family_history USING btree (fk_encounter);


--
-- Name: idx_clin_family_history_fk_episode; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_family_history_fk_episode ON clin.family_history USING btree (fk_episode);


--
-- Name: idx_clin_form_instances_fk_encounter; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_form_instances_fk_encounter ON clin.form_instances USING btree (fk_encounter);


--
-- Name: idx_clin_form_instances_fk_episode; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_form_instances_fk_episode ON clin.form_instances USING btree (fk_episode);


--
-- Name: idx_clin_hospital_stay_fk_encounter; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_hospital_stay_fk_encounter ON clin.hospital_stay USING btree (fk_encounter);


--
-- Name: idx_clin_hospital_stay_fk_episode; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_hospital_stay_fk_episode ON clin.hospital_stay USING btree (fk_episode);


--
-- Name: idx_clin_lab_request_fk_encounter; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_lab_request_fk_encounter ON clin.lab_request USING btree (fk_encounter);


--
-- Name: idx_clin_lab_request_fk_episode; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_lab_request_fk_episode ON clin.lab_request USING btree (fk_episode);


--
-- Name: idx_clin_procedure_fk_encounter; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_procedure_fk_encounter ON clin.procedure USING btree (fk_encounter);


--
-- Name: idx_clin_procedure_fk_episode; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_procedure_fk_episode ON clin.procedure USING btree (fk_episode);


--
-- Name: idx_clin_substance_intake_fk_encounter; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_substance_intake_fk_encounter ON clin.substance_intake USING btree (fk_encounter);


--
-- Name: idx_clin_substance_intake_fk_episode; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_substance_intake_fk_episode ON clin.substance_intake USING btree (fk_episode);


--
-- Name: idx_clin_test_result_fk_encounter; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_test_result_fk_encounter ON clin.test_result USING btree (fk_encounter);


--
-- Name: idx_clin_test_result_fk_episode; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_test_result_fk_episode ON clin.test_result USING btree (fk_episode);


--
-- Name: idx_clin_vaccination_clin_when; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_vaccination_clin_when ON clin.vaccination USING btree (clin_when);


--
-- Name: idx_clin_vaccination_fk_encounter; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_vaccination_fk_encounter ON clin.vaccination USING btree (fk_encounter);


--
-- Name: idx_clin_vaccination_fk_episode; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_vaccination_fk_episode ON clin.vaccination USING btree (fk_episode);


--
-- Name: idx_clin_vaccination_fk_provider; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_vaccination_fk_provider ON clin.vaccination USING btree (fk_provider);


--
-- Name: idx_clin_vaccination_fk_vaccine; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_clin_vaccination_fk_vaccine ON clin.vaccination USING btree (fk_vaccine);


--
-- Name: idx_clnarr_unique; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_clnarr_unique ON clin.clin_narrative USING btree (fk_encounter, fk_episode, soap_cat, modified_by, md5(narrative));


--
-- Name: idx_cri_encounter; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_cri_encounter ON clin.clin_root_item USING btree (fk_encounter);


--
-- Name: idx_cri_episode; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_cri_episode ON clin.clin_root_item USING btree (fk_episode);


--
-- Name: idx_encounter_affirmed; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_encounter_affirmed ON clin.encounter USING btree (last_affirmed);


--
-- Name: idx_encounter_modified_by; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_encounter_modified_by ON clin.encounter USING btree (modified_by);


--
-- Name: idx_encounter_started; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_encounter_started ON clin.encounter USING btree (started);


--
-- Name: idx_episode_fk_encounter; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_episode_fk_encounter ON clin.episode USING btree (fk_encounter);


--
-- Name: idx_episode_issue; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_episode_issue ON clin.episode USING btree (fk_health_issue);


--
-- Name: idx_episode_modified_by; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_episode_modified_by ON clin.episode USING btree (modified_by);


--
-- Name: idx_episode_with_issue; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_episode_with_issue ON clin.episode USING btree (fk_health_issue) WHERE (fk_health_issue IS NOT NULL);


--
-- Name: INDEX idx_episode_with_issue; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON INDEX clin.idx_episode_with_issue IS 'index episodes with associated health issue by their issue';


--
-- Name: idx_episode_without_issue; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_episode_without_issue ON clin.episode USING btree (fk_health_issue) WHERE (fk_health_issue IS NULL);


--
-- Name: INDEX idx_episode_without_issue; Type: COMMENT; Schema: clin; Owner: gm-dbo
--

COMMENT ON INDEX clin.idx_episode_without_issue IS 'index episodes without associated health issue';


--
-- Name: idx_external_care_fk_encounter; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_external_care_fk_encounter ON clin.external_care USING btree (fk_encounter);


--
-- Name: idx_external_care_fk_health_issue; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_external_care_fk_health_issue ON clin.external_care USING btree (fk_health_issue);


--
-- Name: idx_external_care_fk_org_unit; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_external_care_fk_org_unit ON clin.external_care USING btree (fk_org_unit);


--
-- Name: idx_health_issue_modified_by; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_health_issue_modified_by ON clin.health_issue USING btree (modified_by);


--
-- Name: idx_ll2tp_uniq_l_per_p; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ll2tp_uniq_l_per_p ON clin.lnk_loinc2test_panel USING btree (fk_test_panel, loinc);


--
-- Name: idx_narrative_modified_by; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_narrative_modified_by ON clin.clin_narrative USING btree (modified_by);


--
-- Name: idx_narrative_soap_cat; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_narrative_soap_cat ON clin.clin_narrative USING btree (soap_cat) WHERE (soap_cat = ANY (ARRAY['s'::text, 'o'::text, 'a'::text, 'p'::text, 'u'::text]));


--
-- Name: idx_pat_per_encounter; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_pat_per_encounter ON clin.encounter USING btree (fk_patient);


--
-- Name: idx_rtr_fk_reviewer; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_rtr_fk_reviewer ON clin.reviewed_test_results USING btree (fk_reviewer);


--
-- Name: idx_suppressed_hint_fk_encounter; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_suppressed_hint_fk_encounter ON clin.suppressed_hint USING btree (fk_encounter);


--
-- Name: idx_suppressed_hint_fk_hint; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_suppressed_hint_fk_hint ON clin.suppressed_hint USING btree (fk_hint);


--
-- Name: idx_test_result_fk_type; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_test_result_fk_type ON clin.test_result USING btree (fk_type);


--
-- Name: idx_test_result_status; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_test_result_status ON clin.test_result USING btree (status);


--
-- Name: idx_test_result_unit; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_test_result_unit ON clin.test_result USING btree (val_unit);


--
-- Name: idx_test_type_fk_meta_test_type; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_test_type_fk_meta_test_type ON clin.test_type USING btree (fk_meta_test_type);


--
-- Name: idx_test_type_fk_test_org; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_test_type_fk_test_org ON clin.test_type USING btree (fk_test_org);


--
-- Name: idx_test_type_loinc; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE INDEX idx_test_type_loinc ON clin.test_type USING btree (loinc) WHERE (loinc IS NOT NULL);


--
-- Name: idx_uniq_open_epi_per_issue; Type: INDEX; Schema: clin; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_uniq_open_epi_per_issue ON clin.episode USING btree (is_open, fk_health_issue) WHERE ((fk_health_issue IS NOT NULL) AND is_open);


--
-- Name: idx_dem_address_id_street; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_address_id_street ON dem.address USING btree (id_street);


--
-- Name: idx_dem_identity_fk_emergency_contact; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_identity_fk_emergency_contact ON dem.identity USING btree (fk_emergency_contact);


--
-- Name: idx_dem_identity_fk_marital_status; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_identity_fk_marital_status ON dem.identity USING btree (fk_marital_status);


--
-- Name: idx_dem_identity_fk_primary_provider; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_identity_fk_primary_provider ON dem.identity USING btree (fk_primary_provider);


--
-- Name: idx_dem_names_active_names; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_names_active_names ON dem.names USING btree (id_identity, active) WHERE (active IS TRUE);


--
-- Name: idx_dem_names_firstnames; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_names_firstnames ON dem.names USING btree (firstnames);


--
-- Name: idx_dem_names_firstnames_lower; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_names_firstnames_lower ON dem.names USING btree (lower(firstnames));


--
-- Name: idx_dem_names_firstnames_trgm; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_names_firstnames_trgm ON dem.names USING gin (firstnames pgtrgm.gin_trgm_ops);


--
-- Name: idx_dem_names_id_identity; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_names_id_identity ON dem.names USING btree (id_identity);


--
-- Name: idx_dem_names_lastnames; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_names_lastnames ON dem.names USING btree (lastnames);


--
-- Name: idx_dem_names_lastnames_lower; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_names_lastnames_lower ON dem.names USING btree (lower(lastnames));


--
-- Name: idx_dem_names_lastnames_trgm; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_names_lastnames_trgm ON dem.names USING gin (lastnames pgtrgm.gin_trgm_ops);


--
-- Name: idx_dem_org_category_description; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_dem_org_category_description ON dem.org_category USING btree (lower(description));


--
-- Name: idx_dem_org_fk_category; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_org_fk_category ON dem.org USING btree (fk_category);


--
-- Name: idx_dem_org_unit_fk_address; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_org_unit_fk_address ON dem.org_unit USING btree (fk_address);


--
-- Name: idx_dem_org_unit_fk_category; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_org_unit_fk_category ON dem.org_unit USING btree (fk_category);


--
-- Name: idx_dem_state_code_country; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_dem_state_code_country ON dem.region USING btree (lower(code), country);


--
-- Name: idx_dem_state_country_code; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_state_country_code ON dem.region USING btree (country);


--
-- Name: idx_dem_street_id_urb; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_street_id_urb ON dem.street USING btree (id_urb);


--
-- Name: idx_dem_street_id_urb_name_postcode; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_dem_street_id_urb_name_postcode ON dem.street USING btree (id_urb, lower(name), lower(postcode));


--
-- Name: idx_dem_urb_id_state; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_dem_urb_id_state ON dem.urb USING btree (fk_region);


--
-- Name: idx_dem_urb_id_state_postcode_name; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_dem_urb_id_state_postcode_name ON dem.urb USING btree (fk_region, lower(postcode), lower(name));


--
-- Name: idx_identity_dob_ymd; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_identity_dob_ymd ON dem.identity USING btree (dem.date_trunc_utc('day'::text, dob));


--
-- Name: INDEX idx_identity_dob_ymd; Type: COMMENT; Schema: dem; Owner: gm-dbo
--

COMMENT ON INDEX dem.idx_identity_dob_ymd IS 'When searching for patients per DOB this will usually
	 happen with no more precision than "day". Need to
	 normalize to UTC zone, however.';


--
-- Name: idx_lnk_pers2rel; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_lnk_pers2rel ON dem.lnk_person2relative USING btree (id_identity, id_relation_type);


--
-- Name: idx_msg_inbox_fk_patient; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_msg_inbox_fk_patient ON dem.message_inbox USING btree (fk_patient);


--
-- Name: idx_msg_inbox_fk_staff; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_msg_inbox_fk_staff ON dem.message_inbox USING btree (fk_staff);


--
-- Name: idx_names_last_first; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_names_last_first ON dem.names USING btree (lastnames, firstnames);


--
-- Name: idx_state_names; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_state_names ON dem.region USING btree (name);


--
-- Name: idx_street_names; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_street_names ON dem.street USING btree (name);


--
-- Name: idx_street_zips; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_street_zips ON dem.street USING btree (postcode);


--
-- Name: idx_uniq_act_name; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_uniq_act_name ON dem.names USING btree (id_identity) WHERE (active = true);


--
-- Name: idx_urb_names; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_urb_names ON dem.urb USING btree (name);


--
-- Name: idx_urb_zips; Type: INDEX; Schema: dem; Owner: gm-dbo
--

CREATE INDEX idx_urb_zips ON dem.urb USING btree (postcode);


--
-- Name: idx_orig; Type: INDEX; Schema: i18n; Owner: gm-dbo
--

CREATE INDEX idx_orig ON i18n.translations USING btree (orig);


--
-- Name: idx_branded_drug_uniq_brand_w_code; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_branded_drug_uniq_brand_w_code ON ref.drug_product USING btree (description, preparation, external_code, external_code_type) WHERE (external_code IS NOT NULL);


--
-- Name: idx_c_vaccine_id_route; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_c_vaccine_id_route ON ref.vaccine USING btree (id_route);


--
-- Name: idx_dose_uniq_row; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_dose_uniq_row ON ref.dose USING btree (fk_substance, amount, unit, dose_unit);


--
-- Name: idx_drug_data_source; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_drug_data_source ON ref.drug_product USING btree (fk_data_source);


--
-- Name: idx_drug_description; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_drug_description ON ref.drug_product USING btree (description);


--
-- Name: idx_drug_ext_code; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_drug_ext_code ON ref.drug_product USING btree (external_code);


--
-- Name: idx_drug_product_uniq_product_no_code; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_drug_product_uniq_product_no_code ON ref.drug_product USING btree (description, preparation, is_fake) WHERE (external_code IS NULL);


--
-- Name: idx_ld2d_dose_uniq_per_drug_product; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ld2d_dose_uniq_per_drug_product ON ref.lnk_dose2drug USING btree (fk_dose, fk_drug_product);


--
-- Name: idx_ll2s_uniq_l_per_s; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ll2s_uniq_l_per_s ON ref.lnk_loinc2substance USING btree (fk_substance, loinc);


--
-- Name: idx_ref_atc_code_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_atc_code_unique_per_system ON ref.atc USING btree (fk_data_source, lower(code));


--
-- Name: idx_ref_atc_fk_data_src; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_ref_atc_fk_data_src ON ref.atc USING btree (fk_data_source);


--
-- Name: idx_ref_atc_term_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_atc_term_unique_per_system ON ref.atc USING btree (fk_data_source, lower(code), lower(term));


--
-- Name: idx_ref_billable_code_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_billable_code_unique_per_system ON ref.billable USING btree (fk_data_source, lower(code));


--
-- Name: idx_ref_billable_fk_data_src; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_ref_billable_fk_data_src ON ref.billable USING btree (fk_data_source);


--
-- Name: idx_ref_billable_term_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_billable_term_unique_per_system ON ref.billable USING btree (fk_data_source, lower(code), lower(term));


--
-- Name: idx_ref_coda_code_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_coda_code_unique_per_system ON ref.coda USING btree (fk_data_source, lower(code));


--
-- Name: idx_ref_coda_fk_data_src; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_ref_coda_fk_data_src ON ref.coda USING btree (fk_data_source);


--
-- Name: idx_ref_coda_term_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_coda_term_unique_per_system ON ref.coda USING btree (fk_data_source, lower(code), lower(term));


--
-- Name: idx_ref_data_source_lang; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_ref_data_source_lang ON ref.data_source USING btree (lang);


--
-- Name: idx_ref_icd10_code_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_icd10_code_unique_per_system ON ref.icd10 USING btree (fk_data_source, lower(code));


--
-- Name: idx_ref_icd10_fk_data_src; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_ref_icd10_fk_data_src ON ref.icd10 USING btree (fk_data_source);


--
-- Name: idx_ref_icd10_term_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_icd10_term_unique_per_system ON ref.icd10 USING btree (fk_data_source, lower(code), lower(term));


--
-- Name: idx_ref_icd9_code_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_icd9_code_unique_per_system ON ref.icd9 USING btree (fk_data_source, lower(code));


--
-- Name: idx_ref_icd9_fk_data_src; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_ref_icd9_fk_data_src ON ref.icd9 USING btree (fk_data_source);


--
-- Name: idx_ref_icd9_term_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_icd9_term_unique_per_system ON ref.icd9 USING btree (fk_data_source, lower(code), lower(term));


--
-- Name: idx_ref_icpc_chapter; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_ref_icpc_chapter ON ref.icpc USING btree (fk_chapter);


--
-- Name: idx_ref_icpc_code; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_ref_icpc_code ON ref.icpc USING btree (code);


--
-- Name: idx_ref_icpc_code_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_icpc_code_unique_per_system ON ref.icpc USING btree (fk_data_source, lower(code));


--
-- Name: idx_ref_icpc_component; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_ref_icpc_component ON ref.icpc USING btree (fk_component);


--
-- Name: idx_ref_icpc_fk_data_src; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_ref_icpc_fk_data_src ON ref.icpc USING btree (fk_data_source);


--
-- Name: idx_ref_icpc_pk_coding_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_icpc_pk_coding_system ON ref.icpc USING btree (pk_coding_system);


--
-- Name: idx_ref_icpc_term; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_ref_icpc_term ON ref.icpc USING btree (term);


--
-- Name: idx_ref_icpc_term_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_icpc_term_unique_per_system ON ref.icpc USING btree (fk_data_source, lower(code), lower(term));


--
-- Name: idx_ref_loinc_code_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_loinc_code_unique_per_system ON ref.loinc USING btree (fk_data_source, lower(code));


--
-- Name: idx_ref_loinc_fk_data_src; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_ref_loinc_fk_data_src ON ref.loinc USING btree (fk_data_source);


--
-- Name: idx_ref_loinc_term_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_loinc_term_unique_per_system ON ref.loinc USING btree (fk_data_source, lower(code), lower(term));


--
-- Name: idx_ref_ops_code_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_ops_code_unique_per_system ON ref.ops USING btree (fk_data_source, lower(code));


--
-- Name: idx_ref_ops_fk_data_src; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_ref_ops_fk_data_src ON ref.ops USING btree (fk_data_source);


--
-- Name: idx_ref_ops_term_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_ops_term_unique_per_system ON ref.ops USING btree (fk_data_source, lower(code), lower(term));


--
-- Name: idx_ref_other_code_code_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_other_code_code_unique_per_system ON ref.other_code USING btree (fk_data_source, lower(code));


--
-- Name: idx_ref_other_code_fk_data_src; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_ref_other_code_fk_data_src ON ref.other_code USING btree (fk_data_source);


--
-- Name: idx_ref_other_code_term_unique_per_system; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_ref_other_code_term_unique_per_system ON ref.other_code USING btree (fk_data_source, lower(code), lower(term));


--
-- Name: idx_substance_atc; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE INDEX idx_substance_atc ON ref.substance USING btree (atc);


--
-- Name: idx_substance_desc; Type: INDEX; Schema: ref; Owner: gm-dbo
--

CREATE UNIQUE INDEX idx_substance_desc ON ref.substance USING btree (description);


--
-- Name: lab_request_fk_episode_key; Type: INDEX; Schema: staging; Owner: gm-dbo
--

CREATE INDEX lab_request_fk_episode_key ON staging.lab_request USING btree (fk_episode);


--
-- Name: test_result_fk_episode_key; Type: INDEX; Schema: staging; Owner: gm-dbo
--

CREATE INDEX test_result_fk_episode_key ON staging.test_result USING btree (fk_episode);


--
-- Name: test_result_fk_type_key; Type: INDEX; Schema: staging; Owner: gm-dbo
--

CREATE INDEX test_result_fk_type_key ON staging.test_result USING btree (fk_type);


--
-- Name: audit_fields audit_fields_no_del; Type: RULE; Schema: audit; Owner: gm-dbo
--

CREATE RULE audit_fields_no_del AS
    ON DELETE TO audit.audit_fields DO INSTEAD NOTHING;


--
-- Name: audit_fields audit_fields_no_ins; Type: RULE; Schema: audit; Owner: gm-dbo
--

CREATE RULE audit_fields_no_ins AS
    ON INSERT TO audit.audit_fields DO INSTEAD NOTHING;


--
-- Name: audit_fields audit_fields_no_upd; Type: RULE; Schema: audit; Owner: gm-dbo
--

CREATE RULE audit_fields_no_upd AS
    ON UPDATE TO audit.audit_fields DO INSTEAD NOTHING;


--
-- Name: audit_trail audit_trail_no_del; Type: RULE; Schema: audit; Owner: gm-dbo
--

CREATE RULE audit_trail_no_del AS
    ON DELETE TO audit.audit_trail DO INSTEAD NOTHING;


--
-- Name: audit_trail audit_trail_no_ins; Type: RULE; Schema: audit; Owner: gm-dbo
--

CREATE RULE audit_trail_no_ins AS
    ON INSERT TO audit.audit_trail DO INSTEAD NOTHING;


--
-- Name: audit_trail audit_trail_no_upd; Type: RULE; Schema: audit; Owner: gm-dbo
--

CREATE RULE audit_trail_no_upd AS
    ON UPDATE TO audit.audit_trail DO INSTEAD NOTHING;


--
-- Name: clin_root_item clin_ritem_no_del; Type: RULE; Schema: clin; Owner: gm-dbo
--

CREATE RULE clin_ritem_no_del AS
    ON DELETE TO clin.clin_root_item DO INSTEAD  SELECT clin.f_protect_clin_root_item() AS f_protect_clin_root_item;


--
-- Name: clin_root_item clin_ritem_no_ins; Type: RULE; Schema: clin; Owner: gm-dbo
--

CREATE RULE clin_ritem_no_ins AS
    ON INSERT TO clin.clin_root_item DO INSTEAD  SELECT clin.f_protect_clin_root_item() AS f_protect_clin_root_item;


--
-- Name: identity r_del_identity; Type: RULE; Schema: dem; Owner: gm-dbo
--

CREATE RULE r_del_identity AS
    ON DELETE TO dem.identity DO INSTEAD  UPDATE dem.identity SET deleted = true
  WHERE (identity.pk = old.pk);


--
-- Name: referral tr_sanity_check_enc_epi_ins_upd; Type: TRIGGER; Schema: au; Owner: gm-dbo
--

CREATE TRIGGER tr_sanity_check_enc_epi_ins_upd BEFORE INSERT OR UPDATE ON au.referral FOR EACH ROW WHEN ((new.fk_episode IS NOT NULL)) EXECUTE FUNCTION clin.trf_sanity_check_enc_epi_ins_upd('fk_encounter', 'fk_episode');


--
-- Name: referral zt_del_referral; Type: TRIGGER; Schema: au; Owner: gm-dbo
--

CREATE TRIGGER zt_del_referral BEFORE DELETE ON au.referral FOR EACH ROW EXECUTE FUNCTION audit.ft_del_referral();


--
-- Name: referral zt_ins_referral; Type: TRIGGER; Schema: au; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_referral BEFORE INSERT ON au.referral FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_referral();


--
-- Name: referral zt_upd_referral; Type: TRIGGER; Schema: au; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_referral BEFORE UPDATE ON au.referral FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_referral();


--
-- Name: bill_item tr_prevent_empty_bills; Type: TRIGGER; Schema: bill; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER tr_prevent_empty_bills AFTER DELETE OR UPDATE ON bill.bill_item DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION bill.trf_prevent_empty_bills();


--
-- Name: bill tr_prevent_mislinked_bills; Type: TRIGGER; Schema: bill; Owner: gm-dbo
--

CREATE TRIGGER tr_prevent_mislinked_bills BEFORE INSERT OR UPDATE ON bill.bill FOR EACH ROW EXECUTE FUNCTION bill.trf_prevent_mislinked_bills();


--
-- Name: bill zt_del_bill; Type: TRIGGER; Schema: bill; Owner: gm-dbo
--

CREATE TRIGGER zt_del_bill BEFORE DELETE ON bill.bill FOR EACH ROW EXECUTE FUNCTION audit.ft_del_bill();


--
-- Name: bill_item zt_del_bill_item; Type: TRIGGER; Schema: bill; Owner: gm-dbo
--

CREATE TRIGGER zt_del_bill_item BEFORE DELETE ON bill.bill_item FOR EACH ROW EXECUTE FUNCTION audit.ft_del_bill_item();


--
-- Name: bill zt_ins_bill; Type: TRIGGER; Schema: bill; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_bill BEFORE INSERT ON bill.bill FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_bill();


--
-- Name: bill_item zt_ins_bill_item; Type: TRIGGER; Schema: bill; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_bill_item BEFORE INSERT ON bill.bill_item FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_bill_item();


--
-- Name: bill zt_upd_bill; Type: TRIGGER; Schema: bill; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_bill BEFORE UPDATE ON bill.bill FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_bill();


--
-- Name: bill_item zt_upd_bill_item; Type: TRIGGER; Schema: bill; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_bill_item BEFORE UPDATE ON bill.bill_item FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_bill_item();


--
-- Name: bill zzz_tr_announce_bill_bill_del; Type: TRIGGER; Schema: bill; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_bill_bill_del AFTER DELETE ON bill.bill DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=bill.bill::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: bill zzz_tr_announce_bill_bill_ins_upd; Type: TRIGGER; Schema: bill; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_bill_bill_ins_upd AFTER INSERT OR UPDATE ON bill.bill DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=bill.bill::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: bill_item zzz_tr_announce_bill_bill_item_del; Type: TRIGGER; Schema: bill; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_bill_bill_item_del AFTER DELETE ON bill.bill_item DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=bill.bill_item::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: bill_item zzz_tr_announce_bill_bill_item_ins_upd; Type: TRIGGER; Schema: bill; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_bill_bill_item_ins_upd AFTER INSERT OR UPDATE ON bill.bill_item DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=bill.bill_item::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: lnk_doc_med2episode tr_do_not_duplicate_primary_episode_in_link_table; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE TRIGGER tr_do_not_duplicate_primary_episode_in_link_table BEFORE INSERT OR UPDATE ON blobs.lnk_doc_med2episode FOR EACH ROW EXECUTE FUNCTION blobs.trf_do_not_duplicate_primary_episode_in_link_table();


--
-- Name: doc_obj tr_mark_unreviewed_on_doc_obj_update; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE TRIGGER tr_mark_unreviewed_on_doc_obj_update AFTER UPDATE ON blobs.doc_obj FOR EACH ROW EXECUTE FUNCTION blobs.trf_mark_unreviewed_on_doc_obj_update();


--
-- Name: doc_med tr_remove_primary_episode_from_link_table; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE TRIGGER tr_remove_primary_episode_from_link_table AFTER INSERT OR UPDATE ON blobs.doc_med FOR EACH ROW EXECUTE FUNCTION blobs.trf_remove_primary_episode_from_link_table();


--
-- Name: doc_med tr_sanity_check_enc_epi_ins_upd; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE TRIGGER tr_sanity_check_enc_epi_ins_upd BEFORE INSERT OR UPDATE ON blobs.doc_med FOR EACH ROW WHEN ((new.fk_episode IS NOT NULL)) EXECUTE FUNCTION clin.trf_sanity_check_enc_epi_ins_upd('fk_encounter', 'fk_episode');


--
-- Name: doc_obj tr_set_default_intended_reviewer; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE TRIGGER tr_set_default_intended_reviewer BEFORE INSERT OR UPDATE ON blobs.doc_obj FOR EACH ROW EXECUTE FUNCTION blobs.trf_set_intended_reviewer();


--
-- Name: doc_obj tr_verify_page_number; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE TRIGGER tr_verify_page_number BEFORE INSERT OR UPDATE ON blobs.doc_obj FOR EACH ROW EXECUTE FUNCTION blobs.trf_verify_page_number();


--
-- Name: doc_desc zt_del_doc_desc; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE TRIGGER zt_del_doc_desc BEFORE DELETE ON blobs.doc_desc FOR EACH ROW EXECUTE FUNCTION audit.ft_del_doc_desc();


--
-- Name: doc_med zt_del_doc_med; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE TRIGGER zt_del_doc_med BEFORE DELETE ON blobs.doc_med FOR EACH ROW EXECUTE FUNCTION audit.ft_del_doc_med();


--
-- Name: doc_desc zt_ins_doc_desc; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_doc_desc BEFORE INSERT ON blobs.doc_desc FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_doc_desc();


--
-- Name: doc_med zt_ins_doc_med; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_doc_med BEFORE INSERT ON blobs.doc_med FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_doc_med();


--
-- Name: doc_desc zt_upd_doc_desc; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_doc_desc BEFORE UPDATE ON blobs.doc_desc FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_doc_desc();


--
-- Name: doc_med zt_upd_doc_med; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_doc_med BEFORE UPDATE ON blobs.doc_med FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_doc_med();


--
-- Name: doc_med zzz_tr_announce_blobs_doc_med_del; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_blobs_doc_med_del AFTER DELETE ON blobs.doc_med DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=blobs.doc_med::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: doc_med zzz_tr_announce_blobs_doc_med_ins_upd; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_blobs_doc_med_ins_upd AFTER INSERT OR UPDATE ON blobs.doc_med DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=blobs.doc_med::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: doc_obj zzz_tr_announce_blobs_doc_obj_del; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_blobs_doc_obj_del AFTER DELETE ON blobs.doc_obj DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=blobs.doc_obj::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: doc_obj zzz_tr_announce_blobs_doc_obj_ins_upd; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_blobs_doc_obj_ins_upd AFTER INSERT OR UPDATE ON blobs.doc_obj DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=blobs.doc_obj::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: doc_type zzz_tr_announce_blobs_doc_type_del; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_blobs_doc_type_del AFTER DELETE ON blobs.doc_type DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=blobs.doc_type::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: doc_type zzz_tr_announce_blobs_doc_type_ins_upd; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_blobs_doc_type_ins_upd AFTER INSERT OR UPDATE ON blobs.doc_type DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=blobs.doc_type::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: reviewed_doc_objs zzz_tr_announce_blobs_reviewed_doc_objs_del; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_blobs_reviewed_doc_objs_del AFTER DELETE ON blobs.reviewed_doc_objs DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=blobs.reviewed_doc_objs::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: reviewed_doc_objs zzz_tr_announce_blobs_reviewed_doc_objs_ins_upd; Type: TRIGGER; Schema: blobs; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_blobs_reviewed_doc_objs_ins_upd AFTER INSERT OR UPDATE ON blobs.reviewed_doc_objs DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=blobs.reviewed_doc_objs::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: report_query zt_del_report_query; Type: TRIGGER; Schema: cfg; Owner: gm-dbo
--

CREATE TRIGGER zt_del_report_query BEFORE DELETE ON cfg.report_query FOR EACH ROW EXECUTE FUNCTION audit.ft_del_report_query();


--
-- Name: report_query zt_ins_report_query; Type: TRIGGER; Schema: cfg; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_report_query BEFORE INSERT ON cfg.report_query FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_report_query();


--
-- Name: report_query zt_upd_report_query; Type: TRIGGER; Schema: cfg; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_report_query BEFORE UPDATE ON cfg.report_query FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_report_query();


--
-- Name: episode tr_activate_issue_on_opening_episode; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_activate_issue_on_opening_episode AFTER INSERT OR UPDATE ON clin.episode FOR EACH ROW WHEN (((new.fk_health_issue IS NOT NULL) AND (new.is_open IS TRUE))) EXECUTE FUNCTION clin.trf_activate_issue_on_opening_episode();


--
-- Name: external_care tr_clin_ext_care_uniq_issue_per_enc_and_unit_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER tr_clin_ext_care_uniq_issue_per_enc_and_unit_ins_upd AFTER INSERT OR UPDATE ON clin.external_care DEFERRABLE INITIALLY DEFERRED FOR EACH ROW WHEN ((new.fk_health_issue IS NULL)) EXECUTE FUNCTION clin.trf_check_ext_care_uniq_issue_per_enc_and_unit_ins_upd();


--
-- Name: vaccination_definition tr_del_booster_must_have_base_immunity; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_del_booster_must_have_base_immunity AFTER DELETE ON clin.vaccination_definition FOR EACH ROW EXECUTE FUNCTION clin.f_del_booster_must_have_base_immunity();


--
-- Name: substance_intake tr_del_intake_document_deleted; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_del_intake_document_deleted BEFORE DELETE ON clin.substance_intake FOR EACH ROW EXECUTE FUNCTION clin.trf_del_intake_document_deleted();


--
-- Name: substance_intake tr_del_intake_must_unlink_all_drug_components; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER tr_del_intake_must_unlink_all_drug_components AFTER DELETE ON clin.substance_intake DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION clin.trf_del_intake_must_unlink_all_drug_components();


--
-- Name: allergy_state tr_ensure_one_allergy_state_per_patient; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_ensure_one_allergy_state_per_patient BEFORE INSERT OR UPDATE ON clin.allergy_state FOR EACH ROW EXECUTE FUNCTION clin.trf_ensure_one_allergy_state_per_patient();


--
-- Name: vaccination_definition tr_ins_booster_must_have_base_immunity; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_ins_booster_must_have_base_immunity BEFORE INSERT ON clin.vaccination_definition FOR EACH ROW EXECUTE FUNCTION clin.f_ins_booster_must_have_base_immunity();


--
-- Name: lnk_code2aoe tr_ins_lc2sth_fk_generic_code; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_ins_lc2sth_fk_generic_code BEFORE INSERT ON clin.lnk_code2aoe FOR EACH ROW EXECUTE FUNCTION clin.trf_ins_lc2sth_fk_generic_code();


--
-- Name: lnk_code2episode tr_ins_lc2sth_fk_generic_code; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_ins_lc2sth_fk_generic_code BEFORE INSERT ON clin.lnk_code2episode FOR EACH ROW EXECUTE FUNCTION clin.trf_ins_lc2sth_fk_generic_code();


--
-- Name: lnk_code2fhx tr_ins_lc2sth_fk_generic_code; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_ins_lc2sth_fk_generic_code BEFORE INSERT ON clin.lnk_code2fhx FOR EACH ROW EXECUTE FUNCTION clin.trf_ins_lc2sth_fk_generic_code();


--
-- Name: lnk_code2h_issue tr_ins_lc2sth_fk_generic_code; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_ins_lc2sth_fk_generic_code BEFORE INSERT ON clin.lnk_code2h_issue FOR EACH ROW EXECUTE FUNCTION clin.trf_ins_lc2sth_fk_generic_code();


--
-- Name: lnk_code2narrative tr_ins_lc2sth_fk_generic_code; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_ins_lc2sth_fk_generic_code BEFORE INSERT ON clin.lnk_code2narrative FOR EACH ROW EXECUTE FUNCTION clin.trf_ins_lc2sth_fk_generic_code();


--
-- Name: lnk_code2procedure tr_ins_lc2sth_fk_generic_code; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_ins_lc2sth_fk_generic_code BEFORE INSERT ON clin.lnk_code2procedure FOR EACH ROW EXECUTE FUNCTION clin.trf_ins_lc2sth_fk_generic_code();


--
-- Name: lnk_code2rfe tr_ins_lc2sth_fk_generic_code; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_ins_lc2sth_fk_generic_code BEFORE INSERT ON clin.lnk_code2rfe FOR EACH ROW EXECUTE FUNCTION clin.trf_ins_lc2sth_fk_generic_code();


--
-- Name: lnk_code2tst_pnl tr_ins_lc2tp_fk_generic_code; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_ins_lc2tp_fk_generic_code BEFORE INSERT ON clin.lnk_code2tst_pnl FOR EACH ROW EXECUTE FUNCTION clin.trf_ins_lc2sth_fk_generic_code();


--
-- Name: export_item tr_ins_upd_export_item_normalize_fk_identity; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_ins_upd_export_item_normalize_fk_identity BEFORE INSERT OR UPDATE ON clin.export_item FOR EACH ROW WHEN ((new.fk_doc_obj IS NOT NULL)) EXECUTE FUNCTION clin.trf_ins_upd_export_item_normalize_fk_identity();


--
-- Name: substance_intake tr_insert_intake_links_all_drug_components; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_insert_intake_links_all_drug_components AFTER INSERT ON clin.substance_intake FOR EACH ROW EXECUTE FUNCTION clin.trf_insert_intake_links_all_drug_components();


--
-- Name: substance_intake tr_insert_intake_prevent_duplicate_component_links; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_insert_intake_prevent_duplicate_component_links BEFORE INSERT ON clin.substance_intake FOR EACH ROW EXECUTE FUNCTION clin.trf_ins_intake_prevent_duplicate_component_links();


--
-- Name: test_result tr_invalidate_review_on_result_change; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_invalidate_review_on_result_change AFTER UPDATE ON clin.test_result FOR EACH ROW EXECUTE FUNCTION clin.trf_invalidate_review_on_result_change();


--
-- Name: procedure tr_normalize_proc_is_ongoing; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_normalize_proc_is_ongoing BEFORE INSERT OR UPDATE ON clin.procedure FOR EACH ROW WHEN ((new.clin_end IS NOT NULL)) EXECUTE FUNCTION clin.trf_normalize_proc_is_ongoing();


--
-- Name: reviewed_test_results tr_notify_reviewer_of_review_change; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_notify_reviewer_of_review_change BEFORE UPDATE ON clin.reviewed_test_results FOR EACH ROW EXECUTE FUNCTION clin.trf_notify_reviewer_of_review_change();


--
-- Name: lnk_type2item tr_rfi_type2item; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_rfi_type2item AFTER INSERT OR UPDATE ON clin.lnk_type2item FOR EACH ROW EXECUTE FUNCTION public.f_rfi_type2item();


--
-- Name: allergy tr_sanity_check_enc_epi_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_sanity_check_enc_epi_ins_upd BEFORE INSERT OR UPDATE ON clin.allergy FOR EACH ROW WHEN ((new.fk_episode IS NOT NULL)) EXECUTE FUNCTION clin.trf_sanity_check_enc_epi_ins_upd('fk_encounter', 'fk_episode');


--
-- Name: clin_aux_note tr_sanity_check_enc_epi_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_sanity_check_enc_epi_ins_upd BEFORE INSERT OR UPDATE ON clin.clin_aux_note FOR EACH ROW WHEN ((new.fk_episode IS NOT NULL)) EXECUTE FUNCTION clin.trf_sanity_check_enc_epi_ins_upd('fk_encounter', 'fk_episode');


--
-- Name: clin_narrative tr_sanity_check_enc_epi_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_sanity_check_enc_epi_ins_upd BEFORE INSERT OR UPDATE ON clin.clin_narrative FOR EACH ROW WHEN ((new.fk_episode IS NOT NULL)) EXECUTE FUNCTION clin.trf_sanity_check_enc_epi_ins_upd('fk_encounter', 'fk_episode');


--
-- Name: clin_root_item tr_sanity_check_enc_epi_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_sanity_check_enc_epi_ins_upd BEFORE INSERT OR UPDATE ON clin.clin_root_item FOR EACH ROW WHEN ((new.fk_episode IS NOT NULL)) EXECUTE FUNCTION clin.trf_sanity_check_enc_epi_ins_upd('fk_encounter', 'fk_episode');


--
-- Name: family_history tr_sanity_check_enc_epi_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_sanity_check_enc_epi_ins_upd BEFORE INSERT OR UPDATE ON clin.family_history FOR EACH ROW WHEN ((new.fk_episode IS NOT NULL)) EXECUTE FUNCTION clin.trf_sanity_check_enc_epi_ins_upd('fk_encounter', 'fk_episode');


--
-- Name: form_instances tr_sanity_check_enc_epi_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_sanity_check_enc_epi_ins_upd BEFORE INSERT OR UPDATE ON clin.form_instances FOR EACH ROW WHEN ((new.fk_episode IS NOT NULL)) EXECUTE FUNCTION clin.trf_sanity_check_enc_epi_ins_upd('fk_encounter', 'fk_episode');


--
-- Name: hospital_stay tr_sanity_check_enc_epi_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_sanity_check_enc_epi_ins_upd BEFORE INSERT OR UPDATE ON clin.hospital_stay FOR EACH ROW WHEN ((new.fk_episode IS NOT NULL)) EXECUTE FUNCTION clin.trf_sanity_check_enc_epi_ins_upd('fk_encounter', 'fk_episode');


--
-- Name: lab_request tr_sanity_check_enc_epi_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_sanity_check_enc_epi_ins_upd BEFORE INSERT OR UPDATE ON clin.lab_request FOR EACH ROW WHEN ((new.fk_episode IS NOT NULL)) EXECUTE FUNCTION clin.trf_sanity_check_enc_epi_ins_upd('fk_encounter', 'fk_episode');


--
-- Name: procedure tr_sanity_check_enc_epi_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_sanity_check_enc_epi_ins_upd BEFORE INSERT OR UPDATE ON clin.procedure FOR EACH ROW WHEN ((new.fk_episode IS NOT NULL)) EXECUTE FUNCTION clin.trf_sanity_check_enc_epi_ins_upd('fk_encounter', 'fk_episode');


--
-- Name: substance_intake tr_sanity_check_enc_epi_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_sanity_check_enc_epi_ins_upd BEFORE INSERT OR UPDATE ON clin.substance_intake FOR EACH ROW WHEN ((new.fk_episode IS NOT NULL)) EXECUTE FUNCTION clin.trf_sanity_check_enc_epi_ins_upd('fk_encounter', 'fk_episode');


--
-- Name: test_result tr_sanity_check_enc_epi_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_sanity_check_enc_epi_ins_upd BEFORE INSERT OR UPDATE ON clin.test_result FOR EACH ROW WHEN ((new.fk_episode IS NOT NULL)) EXECUTE FUNCTION clin.trf_sanity_check_enc_epi_ins_upd('fk_encounter', 'fk_episode');


--
-- Name: vaccination tr_sanity_check_enc_epi_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_sanity_check_enc_epi_ins_upd BEFORE INSERT OR UPDATE ON clin.vaccination FOR EACH ROW WHEN ((new.fk_episode IS NOT NULL)) EXECUTE FUNCTION clin.trf_sanity_check_enc_epi_ins_upd('fk_encounter', 'fk_episode');


--
-- Name: external_care tr_sanity_check_enc_issue_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER tr_sanity_check_enc_issue_ins_upd AFTER INSERT OR UPDATE ON clin.external_care DEFERRABLE INITIALLY DEFERRED FOR EACH ROW WHEN ((new.fk_health_issue IS NOT NULL)) EXECUTE FUNCTION clin.trf_sanity_check_enc_issue_ins_upd();


--
-- Name: episode tr_sanity_check_enc_vs_issue_on_epi; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_sanity_check_enc_vs_issue_on_epi BEFORE INSERT OR UPDATE ON clin.episode FOR EACH ROW EXECUTE FUNCTION clin.trf_sanity_check_enc_vs_issue_on_epi();


--
-- Name: procedure tr_sanity_check_procedure_episode; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_sanity_check_procedure_episode BEFORE INSERT OR UPDATE ON clin.procedure FOR EACH ROW EXECUTE FUNCTION clin.trf_sanity_check_procedure_episode();


--
-- Name: suppressed_hint tr_sanity_check_uniq_hint_per_pat_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER tr_sanity_check_uniq_hint_per_pat_ins_upd AFTER INSERT OR UPDATE ON clin.suppressed_hint DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION clin.trf_sanity_check_uniq_hint_per_pat_ins_upd();


--
-- Name: encounter tr_set_encounter_timezone; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_set_encounter_timezone BEFORE INSERT OR UPDATE ON clin.encounter FOR EACH ROW EXECUTE FUNCTION public.f_set_encounter_timezone();


--
-- Name: allergy tr_sync_allergic_state_on_allergies_modified; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_sync_allergic_state_on_allergies_modified AFTER INSERT OR DELETE ON clin.allergy FOR EACH ROW EXECUTE FUNCTION clin.trf_sync_allergic_state_on_allergies_modified();


--
-- Name: substance_intake tr_undiscontinue_unsets_reason; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_undiscontinue_unsets_reason BEFORE INSERT OR UPDATE ON clin.substance_intake FOR EACH ROW EXECUTE FUNCTION clin.trf_undiscontinue_unsets_reason();


--
-- Name: lnk_vaccination_course2schedule tr_unique_indication_in_schedule; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_unique_indication_in_schedule BEFORE INSERT OR UPDATE ON clin.lnk_vaccination_course2schedule FOR EACH ROW EXECUTE FUNCTION clin.trf_unique_indication_in_schedule();


--
-- Name: vaccination_definition tr_upd_booster_must_have_base_immunity; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_upd_booster_must_have_base_immunity AFTER UPDATE ON clin.vaccination_definition FOR EACH ROW EXECUTE FUNCTION clin.f_upd_booster_must_have_base_immunity();


--
-- Name: substance_intake tr_upd_intake_must_link_all_drug_components; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER tr_upd_intake_must_link_all_drug_components AFTER UPDATE ON clin.substance_intake DEFERRABLE INITIALLY DEFERRED FOR EACH ROW WHEN ((new.fk_drug_component IS DISTINCT FROM old.fk_drug_component)) EXECUTE FUNCTION clin.trf_upd_intake_must_link_all_drug_components();


--
-- Name: substance_intake tr_upd_intake_updates_all_drug_components; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER tr_upd_intake_updates_all_drug_components AFTER UPDATE ON clin.substance_intake DEFERRABLE INITIALLY DEFERRED FOR EACH ROW WHEN ((pg_trigger_depth() = 0)) EXECUTE FUNCTION clin.trf_upd_intake_updates_all_drug_components();


--
-- Name: lnk_code2aoe tr_upd_lc2sth_fk_generic_code; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_upd_lc2sth_fk_generic_code BEFORE UPDATE ON clin.lnk_code2aoe FOR EACH ROW EXECUTE FUNCTION clin.trf_upd_lc2sth_fk_generic_code();


--
-- Name: lnk_code2episode tr_upd_lc2sth_fk_generic_code; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_upd_lc2sth_fk_generic_code BEFORE UPDATE ON clin.lnk_code2episode FOR EACH ROW EXECUTE FUNCTION clin.trf_upd_lc2sth_fk_generic_code();


--
-- Name: lnk_code2fhx tr_upd_lc2sth_fk_generic_code; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_upd_lc2sth_fk_generic_code BEFORE UPDATE ON clin.lnk_code2fhx FOR EACH ROW EXECUTE FUNCTION clin.trf_upd_lc2sth_fk_generic_code();


--
-- Name: lnk_code2h_issue tr_upd_lc2sth_fk_generic_code; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_upd_lc2sth_fk_generic_code BEFORE UPDATE ON clin.lnk_code2h_issue FOR EACH ROW EXECUTE FUNCTION clin.trf_upd_lc2sth_fk_generic_code();


--
-- Name: lnk_code2narrative tr_upd_lc2sth_fk_generic_code; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_upd_lc2sth_fk_generic_code BEFORE UPDATE ON clin.lnk_code2narrative FOR EACH ROW EXECUTE FUNCTION clin.trf_upd_lc2sth_fk_generic_code();


--
-- Name: lnk_code2procedure tr_upd_lc2sth_fk_generic_code; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_upd_lc2sth_fk_generic_code BEFORE UPDATE ON clin.lnk_code2procedure FOR EACH ROW EXECUTE FUNCTION clin.trf_upd_lc2sth_fk_generic_code();


--
-- Name: lnk_code2rfe tr_upd_lc2sth_fk_generic_code; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_upd_lc2sth_fk_generic_code BEFORE UPDATE ON clin.lnk_code2rfe FOR EACH ROW EXECUTE FUNCTION clin.trf_upd_lc2sth_fk_generic_code();


--
-- Name: lnk_code2tst_pnl tr_upd_lc2tp_fk_generic_code; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_upd_lc2tp_fk_generic_code BEFORE UPDATE ON clin.lnk_code2tst_pnl FOR EACH ROW EXECUTE FUNCTION clin.trf_upd_lc2sth_fk_generic_code();


--
-- Name: substance_intake tr_update_intake_prevent_duplicate_component_links; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER tr_update_intake_prevent_duplicate_component_links AFTER UPDATE ON clin.substance_intake FOR EACH ROW WHEN ((new.fk_drug_component IS DISTINCT FROM old.fk_drug_component)) EXECUTE FUNCTION clin.trf_upd_intake_prevent_duplicate_component_links();


--
-- Name: allergy zt_del_allergy; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_allergy BEFORE DELETE ON clin.allergy FOR EACH ROW EXECUTE FUNCTION audit.ft_del_allergy();


--
-- Name: allergy_state zt_del_allergy_state; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_allergy_state BEFORE DELETE ON clin.allergy_state FOR EACH ROW EXECUTE FUNCTION audit.ft_del_allergy_state();


--
-- Name: clin_aux_note zt_del_clin_aux_note; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_clin_aux_note BEFORE DELETE ON clin.clin_aux_note FOR EACH ROW EXECUTE FUNCTION audit.ft_del_clin_aux_note();


--
-- Name: clin_diag zt_del_clin_diag; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_clin_diag BEFORE DELETE ON clin.clin_diag FOR EACH ROW EXECUTE FUNCTION audit.ft_del_clin_diag();


--
-- Name: clin_item_type zt_del_clin_item_type; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_clin_item_type BEFORE DELETE ON clin.clin_item_type FOR EACH ROW EXECUTE FUNCTION audit.ft_del_clin_item_type();


--
-- Name: clin_narrative zt_del_clin_narrative; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_clin_narrative BEFORE DELETE ON clin.clin_narrative FOR EACH ROW EXECUTE FUNCTION audit.ft_del_clin_narrative();


--
-- Name: encounter zt_del_encounter; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_encounter BEFORE DELETE ON clin.encounter FOR EACH ROW EXECUTE FUNCTION audit.ft_del_encounter();


--
-- Name: episode zt_del_episode; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_episode BEFORE DELETE ON clin.episode FOR EACH ROW EXECUTE FUNCTION audit.ft_del_episode();


--
-- Name: external_care zt_del_external_care; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_external_care BEFORE DELETE ON clin.external_care FOR EACH ROW EXECUTE FUNCTION audit.ft_del_external_care();


--
-- Name: family_history zt_del_family_history; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_family_history BEFORE DELETE ON clin.family_history FOR EACH ROW EXECUTE FUNCTION audit.ft_del_family_history();


--
-- Name: fhx_relation_type zt_del_fhx_relation_type; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_fhx_relation_type BEFORE DELETE ON clin.fhx_relation_type FOR EACH ROW EXECUTE FUNCTION audit.ft_del_fhx_relation_type();


--
-- Name: form_data zt_del_form_data; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_form_data BEFORE DELETE ON clin.form_data FOR EACH ROW EXECUTE FUNCTION audit.ft_del_form_data();


--
-- Name: form_instances zt_del_form_instances; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_form_instances BEFORE DELETE ON clin.form_instances FOR EACH ROW EXECUTE FUNCTION audit.ft_del_form_instances();


--
-- Name: health_issue zt_del_health_issue; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_health_issue BEFORE DELETE ON clin.health_issue FOR EACH ROW EXECUTE FUNCTION audit.ft_del_health_issue();


--
-- Name: hospital_stay zt_del_hospital_stay; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_hospital_stay BEFORE DELETE ON clin.hospital_stay FOR EACH ROW EXECUTE FUNCTION audit.ft_del_hospital_stay();


--
-- Name: incoming_data_unmatchable zt_del_incoming_data_unmatchable; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_incoming_data_unmatchable BEFORE DELETE ON clin.incoming_data_unmatchable FOR EACH ROW EXECUTE FUNCTION audit.ft_del_incoming_data_unmatchable();


--
-- Name: incoming_data_unmatched zt_del_incoming_data_unmatched; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_incoming_data_unmatched BEFORE DELETE ON clin.incoming_data_unmatched FOR EACH ROW EXECUTE FUNCTION audit.ft_del_incoming_data_unmatched();


--
-- Name: lab_request zt_del_lab_request; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lab_request BEFORE DELETE ON clin.lab_request FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lab_request();


--
-- Name: lnk_code2aoe zt_del_lnk_code2aoe; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_code2aoe BEFORE DELETE ON clin.lnk_code2aoe FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_code2aoe();


--
-- Name: lnk_code2episode zt_del_lnk_code2episode; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_code2episode BEFORE DELETE ON clin.lnk_code2episode FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_code2episode();


--
-- Name: lnk_code2fhx zt_del_lnk_code2fhx; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_code2fhx BEFORE DELETE ON clin.lnk_code2fhx FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_code2fhx();


--
-- Name: lnk_code2h_issue zt_del_lnk_code2h_issue; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_code2h_issue BEFORE DELETE ON clin.lnk_code2h_issue FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_code2h_issue();


--
-- Name: lnk_code2narrative zt_del_lnk_code2narrative; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_code2narrative BEFORE DELETE ON clin.lnk_code2narrative FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_code2narrative();


--
-- Name: lnk_code2procedure zt_del_lnk_code2procedure; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_code2procedure BEFORE DELETE ON clin.lnk_code2procedure FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_code2procedure();


--
-- Name: lnk_code2rfe zt_del_lnk_code2rfe; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_code2rfe BEFORE DELETE ON clin.lnk_code2rfe FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_code2rfe();


--
-- Name: lnk_code2tst_pnl zt_del_lnk_code2tst_pnl; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_code2tst_pnl BEFORE DELETE ON clin.lnk_code2tst_pnl FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_code2tst_pnl();


--
-- Name: lnk_constraint2vacc_course zt_del_lnk_constraint2vacc_course; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_constraint2vacc_course BEFORE DELETE ON clin.lnk_constraint2vacc_course FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_constraint2vacc_course();


--
-- Name: lnk_loinc2test_panel zt_del_lnk_loinc2test_panel; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_loinc2test_panel BEFORE DELETE ON clin.lnk_loinc2test_panel FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_loinc2test_panel();


--
-- Name: lnk_pat2vaccination_course zt_del_lnk_pat2vaccination_course; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_pat2vaccination_course BEFORE DELETE ON clin.lnk_pat2vaccination_course FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_pat2vaccination_course();


--
-- Name: lnk_tst2norm zt_del_lnk_tst2norm; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_tst2norm BEFORE DELETE ON clin.lnk_tst2norm FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_tst2norm();


--
-- Name: lnk_type2item zt_del_lnk_type2item; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_type2item BEFORE DELETE ON clin.lnk_type2item FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_type2item();


--
-- Name: lnk_vaccination_course2schedule zt_del_lnk_vaccination_course2schedule; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_vaccination_course2schedule BEFORE DELETE ON clin.lnk_vaccination_course2schedule FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_vaccination_course2schedule();


--
-- Name: patient zt_del_patient; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_patient BEFORE DELETE ON clin.patient FOR EACH ROW EXECUTE FUNCTION audit.ft_del_patient();


--
-- Name: procedure zt_del_procedure; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_procedure BEFORE DELETE ON clin.procedure FOR EACH ROW EXECUTE FUNCTION audit.ft_del_procedure();


--
-- Name: substance_intake zt_del_substance_intake; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_substance_intake BEFORE DELETE ON clin.substance_intake FOR EACH ROW EXECUTE FUNCTION audit.ft_del_substance_intake();


--
-- Name: suppressed_hint zt_del_suppressed_hint; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_suppressed_hint BEFORE DELETE ON clin.suppressed_hint FOR EACH ROW EXECUTE FUNCTION audit.ft_del_suppressed_hint();


--
-- Name: test_org zt_del_test_org; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_test_org BEFORE DELETE ON clin.test_org FOR EACH ROW EXECUTE FUNCTION audit.ft_del_test_org();


--
-- Name: test_panel zt_del_test_panel; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_test_panel BEFORE DELETE ON clin.test_panel FOR EACH ROW EXECUTE FUNCTION audit.ft_del_test_panel();


--
-- Name: test_result zt_del_test_result; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_test_result BEFORE DELETE ON clin.test_result FOR EACH ROW EXECUTE FUNCTION audit.ft_del_test_result();


--
-- Name: test_type zt_del_test_type; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_test_type BEFORE DELETE ON clin.test_type FOR EACH ROW EXECUTE FUNCTION audit.ft_del_test_type();


--
-- Name: vaccination zt_del_vaccination; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_vaccination BEFORE DELETE ON clin.vaccination FOR EACH ROW EXECUTE FUNCTION audit.ft_del_vaccination();


--
-- Name: vaccination_course zt_del_vaccination_course; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_vaccination_course BEFORE DELETE ON clin.vaccination_course FOR EACH ROW EXECUTE FUNCTION audit.ft_del_vaccination_course();


--
-- Name: vaccination_course_constraint zt_del_vaccination_course_constraint; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_vaccination_course_constraint BEFORE DELETE ON clin.vaccination_course_constraint FOR EACH ROW EXECUTE FUNCTION audit.ft_del_vaccination_course_constraint();


--
-- Name: vaccination_definition zt_del_vaccination_definition; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_vaccination_definition BEFORE DELETE ON clin.vaccination_definition FOR EACH ROW EXECUTE FUNCTION audit.ft_del_vaccination_definition();


--
-- Name: vaccination_schedule zt_del_vaccination_schedule; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_vaccination_schedule BEFORE DELETE ON clin.vaccination_schedule FOR EACH ROW EXECUTE FUNCTION audit.ft_del_vaccination_schedule();


--
-- Name: waiting_list zt_del_waiting_list; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_del_waiting_list BEFORE DELETE ON clin.waiting_list FOR EACH ROW EXECUTE FUNCTION audit.ft_del_waiting_list();


--
-- Name: allergy zt_ins_allergy; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_allergy BEFORE INSERT ON clin.allergy FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_allergy();


--
-- Name: allergy_state zt_ins_allergy_state; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_allergy_state BEFORE INSERT ON clin.allergy_state FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_allergy_state();


--
-- Name: clin_aux_note zt_ins_clin_aux_note; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_clin_aux_note BEFORE INSERT ON clin.clin_aux_note FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_clin_aux_note();


--
-- Name: clin_diag zt_ins_clin_diag; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_clin_diag BEFORE INSERT ON clin.clin_diag FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_clin_diag();


--
-- Name: clin_item_type zt_ins_clin_item_type; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_clin_item_type BEFORE INSERT ON clin.clin_item_type FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_clin_item_type();


--
-- Name: clin_narrative zt_ins_clin_narrative; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_clin_narrative BEFORE INSERT ON clin.clin_narrative FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_clin_narrative();


--
-- Name: encounter zt_ins_encounter; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_encounter BEFORE INSERT ON clin.encounter FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_encounter();


--
-- Name: episode zt_ins_episode; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_episode BEFORE INSERT ON clin.episode FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_episode();


--
-- Name: external_care zt_ins_external_care; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_external_care BEFORE INSERT ON clin.external_care FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_external_care();


--
-- Name: family_history zt_ins_family_history; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_family_history BEFORE INSERT ON clin.family_history FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_family_history();


--
-- Name: fhx_relation_type zt_ins_fhx_relation_type; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_fhx_relation_type BEFORE INSERT ON clin.fhx_relation_type FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_fhx_relation_type();


--
-- Name: form_data zt_ins_form_data; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_form_data BEFORE INSERT ON clin.form_data FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_form_data();


--
-- Name: form_instances zt_ins_form_instances; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_form_instances BEFORE INSERT ON clin.form_instances FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_form_instances();


--
-- Name: health_issue zt_ins_health_issue; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_health_issue BEFORE INSERT ON clin.health_issue FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_health_issue();


--
-- Name: hospital_stay zt_ins_hospital_stay; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_hospital_stay BEFORE INSERT ON clin.hospital_stay FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_hospital_stay();


--
-- Name: incoming_data_unmatchable zt_ins_incoming_data_unmatchable; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_incoming_data_unmatchable BEFORE INSERT ON clin.incoming_data_unmatchable FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_incoming_data_unmatchable();


--
-- Name: incoming_data_unmatched zt_ins_incoming_data_unmatched; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_incoming_data_unmatched BEFORE INSERT ON clin.incoming_data_unmatched FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_incoming_data_unmatched();


--
-- Name: lab_request zt_ins_lab_request; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lab_request BEFORE INSERT ON clin.lab_request FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lab_request();


--
-- Name: lnk_code2aoe zt_ins_lnk_code2aoe; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_code2aoe BEFORE INSERT ON clin.lnk_code2aoe FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_code2aoe();


--
-- Name: lnk_code2episode zt_ins_lnk_code2episode; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_code2episode BEFORE INSERT ON clin.lnk_code2episode FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_code2episode();


--
-- Name: lnk_code2fhx zt_ins_lnk_code2fhx; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_code2fhx BEFORE INSERT ON clin.lnk_code2fhx FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_code2fhx();


--
-- Name: lnk_code2h_issue zt_ins_lnk_code2h_issue; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_code2h_issue BEFORE INSERT ON clin.lnk_code2h_issue FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_code2h_issue();


--
-- Name: lnk_code2narrative zt_ins_lnk_code2narrative; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_code2narrative BEFORE INSERT ON clin.lnk_code2narrative FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_code2narrative();


--
-- Name: lnk_code2procedure zt_ins_lnk_code2procedure; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_code2procedure BEFORE INSERT ON clin.lnk_code2procedure FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_code2procedure();


--
-- Name: lnk_code2rfe zt_ins_lnk_code2rfe; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_code2rfe BEFORE INSERT ON clin.lnk_code2rfe FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_code2rfe();


--
-- Name: lnk_code2tst_pnl zt_ins_lnk_code2tst_pnl; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_code2tst_pnl BEFORE INSERT ON clin.lnk_code2tst_pnl FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_code2tst_pnl();


--
-- Name: lnk_constraint2vacc_course zt_ins_lnk_constraint2vacc_course; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_constraint2vacc_course BEFORE INSERT ON clin.lnk_constraint2vacc_course FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_constraint2vacc_course();


--
-- Name: lnk_loinc2test_panel zt_ins_lnk_loinc2test_panel; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_loinc2test_panel BEFORE INSERT ON clin.lnk_loinc2test_panel FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_loinc2test_panel();


--
-- Name: lnk_pat2vaccination_course zt_ins_lnk_pat2vaccination_course; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_pat2vaccination_course BEFORE INSERT ON clin.lnk_pat2vaccination_course FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_pat2vaccination_course();


--
-- Name: lnk_tst2norm zt_ins_lnk_tst2norm; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_tst2norm BEFORE INSERT ON clin.lnk_tst2norm FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_tst2norm();


--
-- Name: lnk_type2item zt_ins_lnk_type2item; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_type2item BEFORE INSERT ON clin.lnk_type2item FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_type2item();


--
-- Name: lnk_vaccination_course2schedule zt_ins_lnk_vaccination_course2schedule; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_vaccination_course2schedule BEFORE INSERT ON clin.lnk_vaccination_course2schedule FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_vaccination_course2schedule();


--
-- Name: patient zt_ins_patient; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_patient BEFORE INSERT ON clin.patient FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_patient();


--
-- Name: procedure zt_ins_procedure; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_procedure BEFORE INSERT ON clin.procedure FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_procedure();


--
-- Name: substance_intake zt_ins_substance_intake; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_substance_intake BEFORE INSERT ON clin.substance_intake FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_substance_intake();


--
-- Name: suppressed_hint zt_ins_suppressed_hint; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_suppressed_hint BEFORE INSERT ON clin.suppressed_hint FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_suppressed_hint();


--
-- Name: test_org zt_ins_test_org; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_test_org BEFORE INSERT ON clin.test_org FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_test_org();


--
-- Name: test_panel zt_ins_test_panel; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_test_panel BEFORE INSERT ON clin.test_panel FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_test_panel();


--
-- Name: test_result zt_ins_test_result; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_test_result BEFORE INSERT ON clin.test_result FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_test_result();


--
-- Name: test_type zt_ins_test_type; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_test_type BEFORE INSERT ON clin.test_type FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_test_type();


--
-- Name: vaccination zt_ins_vaccination; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_vaccination BEFORE INSERT ON clin.vaccination FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_vaccination();


--
-- Name: vaccination_course zt_ins_vaccination_course; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_vaccination_course BEFORE INSERT ON clin.vaccination_course FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_vaccination_course();


--
-- Name: vaccination_course_constraint zt_ins_vaccination_course_constraint; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_vaccination_course_constraint BEFORE INSERT ON clin.vaccination_course_constraint FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_vaccination_course_constraint();


--
-- Name: vaccination_definition zt_ins_vaccination_definition; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_vaccination_definition BEFORE INSERT ON clin.vaccination_definition FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_vaccination_definition();


--
-- Name: vaccination_schedule zt_ins_vaccination_schedule; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_vaccination_schedule BEFORE INSERT ON clin.vaccination_schedule FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_vaccination_schedule();


--
-- Name: waiting_list zt_ins_waiting_list; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_waiting_list BEFORE INSERT ON clin.waiting_list FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_waiting_list();


--
-- Name: allergy zt_upd_allergy; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_allergy BEFORE UPDATE ON clin.allergy FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_allergy();


--
-- Name: allergy_state zt_upd_allergy_state; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_allergy_state BEFORE UPDATE ON clin.allergy_state FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_allergy_state();


--
-- Name: clin_aux_note zt_upd_clin_aux_note; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_clin_aux_note BEFORE UPDATE ON clin.clin_aux_note FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_clin_aux_note();


--
-- Name: clin_diag zt_upd_clin_diag; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_clin_diag BEFORE UPDATE ON clin.clin_diag FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_clin_diag();


--
-- Name: clin_item_type zt_upd_clin_item_type; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_clin_item_type BEFORE UPDATE ON clin.clin_item_type FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_clin_item_type();


--
-- Name: clin_narrative zt_upd_clin_narrative; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_clin_narrative BEFORE UPDATE ON clin.clin_narrative FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_clin_narrative();


--
-- Name: encounter zt_upd_encounter; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_encounter BEFORE UPDATE ON clin.encounter FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_encounter();


--
-- Name: episode zt_upd_episode; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_episode BEFORE UPDATE ON clin.episode FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_episode();


--
-- Name: external_care zt_upd_external_care; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_external_care BEFORE UPDATE ON clin.external_care FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_external_care();


--
-- Name: family_history zt_upd_family_history; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_family_history BEFORE UPDATE ON clin.family_history FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_family_history();


--
-- Name: fhx_relation_type zt_upd_fhx_relation_type; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_fhx_relation_type BEFORE UPDATE ON clin.fhx_relation_type FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_fhx_relation_type();


--
-- Name: form_data zt_upd_form_data; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_form_data BEFORE UPDATE ON clin.form_data FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_form_data();


--
-- Name: form_instances zt_upd_form_instances; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_form_instances BEFORE UPDATE ON clin.form_instances FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_form_instances();


--
-- Name: health_issue zt_upd_health_issue; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_health_issue BEFORE UPDATE ON clin.health_issue FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_health_issue();


--
-- Name: hospital_stay zt_upd_hospital_stay; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_hospital_stay BEFORE UPDATE ON clin.hospital_stay FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_hospital_stay();


--
-- Name: incoming_data_unmatchable zt_upd_incoming_data_unmatchable; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_incoming_data_unmatchable BEFORE UPDATE ON clin.incoming_data_unmatchable FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_incoming_data_unmatchable();


--
-- Name: incoming_data_unmatched zt_upd_incoming_data_unmatched; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_incoming_data_unmatched BEFORE UPDATE ON clin.incoming_data_unmatched FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_incoming_data_unmatched();


--
-- Name: lab_request zt_upd_lab_request; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lab_request BEFORE UPDATE ON clin.lab_request FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lab_request();


--
-- Name: lnk_code2aoe zt_upd_lnk_code2aoe; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_code2aoe BEFORE UPDATE ON clin.lnk_code2aoe FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_code2aoe();


--
-- Name: lnk_code2episode zt_upd_lnk_code2episode; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_code2episode BEFORE UPDATE ON clin.lnk_code2episode FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_code2episode();


--
-- Name: lnk_code2fhx zt_upd_lnk_code2fhx; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_code2fhx BEFORE UPDATE ON clin.lnk_code2fhx FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_code2fhx();


--
-- Name: lnk_code2h_issue zt_upd_lnk_code2h_issue; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_code2h_issue BEFORE UPDATE ON clin.lnk_code2h_issue FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_code2h_issue();


--
-- Name: lnk_code2narrative zt_upd_lnk_code2narrative; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_code2narrative BEFORE UPDATE ON clin.lnk_code2narrative FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_code2narrative();


--
-- Name: lnk_code2procedure zt_upd_lnk_code2procedure; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_code2procedure BEFORE UPDATE ON clin.lnk_code2procedure FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_code2procedure();


--
-- Name: lnk_code2rfe zt_upd_lnk_code2rfe; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_code2rfe BEFORE UPDATE ON clin.lnk_code2rfe FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_code2rfe();


--
-- Name: lnk_code2tst_pnl zt_upd_lnk_code2tst_pnl; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_code2tst_pnl BEFORE UPDATE ON clin.lnk_code2tst_pnl FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_code2tst_pnl();


--
-- Name: lnk_constraint2vacc_course zt_upd_lnk_constraint2vacc_course; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_constraint2vacc_course BEFORE UPDATE ON clin.lnk_constraint2vacc_course FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_constraint2vacc_course();


--
-- Name: lnk_loinc2test_panel zt_upd_lnk_loinc2test_panel; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_loinc2test_panel BEFORE UPDATE ON clin.lnk_loinc2test_panel FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_loinc2test_panel();


--
-- Name: lnk_pat2vaccination_course zt_upd_lnk_pat2vaccination_course; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_pat2vaccination_course BEFORE UPDATE ON clin.lnk_pat2vaccination_course FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_pat2vaccination_course();


--
-- Name: lnk_tst2norm zt_upd_lnk_tst2norm; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_tst2norm BEFORE UPDATE ON clin.lnk_tst2norm FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_tst2norm();


--
-- Name: lnk_type2item zt_upd_lnk_type2item; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_type2item BEFORE UPDATE ON clin.lnk_type2item FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_type2item();


--
-- Name: lnk_vaccination_course2schedule zt_upd_lnk_vaccination_course2schedule; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_vaccination_course2schedule BEFORE UPDATE ON clin.lnk_vaccination_course2schedule FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_vaccination_course2schedule();


--
-- Name: patient zt_upd_patient; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_patient BEFORE UPDATE ON clin.patient FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_patient();


--
-- Name: procedure zt_upd_procedure; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_procedure BEFORE UPDATE ON clin.procedure FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_procedure();


--
-- Name: substance_intake zt_upd_substance_intake; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_substance_intake BEFORE UPDATE ON clin.substance_intake FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_substance_intake();


--
-- Name: suppressed_hint zt_upd_suppressed_hint; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_suppressed_hint BEFORE UPDATE ON clin.suppressed_hint FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_suppressed_hint();


--
-- Name: test_org zt_upd_test_org; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_test_org BEFORE UPDATE ON clin.test_org FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_test_org();


--
-- Name: test_panel zt_upd_test_panel; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_test_panel BEFORE UPDATE ON clin.test_panel FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_test_panel();


--
-- Name: test_result zt_upd_test_result; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_test_result BEFORE UPDATE ON clin.test_result FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_test_result();


--
-- Name: test_type zt_upd_test_type; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_test_type BEFORE UPDATE ON clin.test_type FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_test_type();


--
-- Name: vaccination zt_upd_vaccination; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_vaccination BEFORE UPDATE ON clin.vaccination FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_vaccination();


--
-- Name: vaccination_course zt_upd_vaccination_course; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_vaccination_course BEFORE UPDATE ON clin.vaccination_course FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_vaccination_course();


--
-- Name: vaccination_course_constraint zt_upd_vaccination_course_constraint; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_vaccination_course_constraint BEFORE UPDATE ON clin.vaccination_course_constraint FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_vaccination_course_constraint();


--
-- Name: vaccination_definition zt_upd_vaccination_definition; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_vaccination_definition BEFORE UPDATE ON clin.vaccination_definition FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_vaccination_definition();


--
-- Name: vaccination_schedule zt_upd_vaccination_schedule; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_vaccination_schedule BEFORE UPDATE ON clin.vaccination_schedule FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_vaccination_schedule();


--
-- Name: waiting_list zt_upd_waiting_list; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_waiting_list BEFORE UPDATE ON clin.waiting_list FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_waiting_list();


--
-- Name: allergy zzz_tr_announce_clin_allergy_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_allergy_del AFTER DELETE ON clin.allergy DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.allergy::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: allergy zzz_tr_announce_clin_allergy_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_allergy_ins_upd AFTER INSERT OR UPDATE ON clin.allergy DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.allergy::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: allergy_state zzz_tr_announce_clin_allergy_state_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_allergy_state_del AFTER DELETE ON clin.allergy_state DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.allergy_state::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: allergy_state zzz_tr_announce_clin_allergy_state_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_allergy_state_ins_upd AFTER INSERT OR UPDATE ON clin.allergy_state DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.allergy_state::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: clin_narrative zzz_tr_announce_clin_clin_narrative_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_clin_narrative_del AFTER DELETE ON clin.clin_narrative DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.clin_narrative::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: clin_narrative zzz_tr_announce_clin_clin_narrative_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_clin_narrative_ins_upd AFTER INSERT OR UPDATE ON clin.clin_narrative DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.clin_narrative::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: clin_root_item zzz_tr_announce_clin_clin_root_item_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_clin_root_item_del AFTER DELETE ON clin.clin_root_item DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.clin_root_item::PK name=pk_item', 'select $1.pk_item', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: clin_root_item zzz_tr_announce_clin_clin_root_item_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_clin_root_item_ins_upd AFTER INSERT OR UPDATE ON clin.clin_root_item DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.clin_root_item::PK name=pk_item', 'select $1.pk_item', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: encounter zzz_tr_announce_clin_encounter_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_encounter_del AFTER DELETE ON clin.encounter DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.encounter::PK name=pk', 'select $1.pk', 'select $1.fk_patient');


--
-- Name: encounter zzz_tr_announce_clin_encounter_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_encounter_ins_upd AFTER INSERT OR UPDATE ON clin.encounter DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.encounter::PK name=pk', 'select $1.pk', 'select $1.fk_patient');


--
-- Name: episode zzz_tr_announce_clin_episode_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_episode_del AFTER DELETE ON clin.episode DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.episode::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: episode zzz_tr_announce_clin_episode_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_episode_ins_upd AFTER INSERT OR UPDATE ON clin.episode DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.episode::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: export_item zzz_tr_announce_clin_export_item_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_export_item_del AFTER DELETE ON clin.export_item DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.export_item::PK name=pk', 'select $1.pk', 'select $1.fk_identity');


--
-- Name: export_item zzz_tr_announce_clin_export_item_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_export_item_ins_upd AFTER INSERT OR UPDATE ON clin.export_item DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.export_item::PK name=pk', 'select $1.pk', 'select $1.fk_identity');


--
-- Name: external_care zzz_tr_announce_clin_external_care_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_external_care_del AFTER DELETE ON clin.external_care DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.external_care::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: external_care zzz_tr_announce_clin_external_care_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_external_care_ins_upd AFTER INSERT OR UPDATE ON clin.external_care DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.external_care::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: family_history zzz_tr_announce_clin_family_history_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_family_history_del AFTER DELETE ON clin.family_history DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.family_history::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: family_history zzz_tr_announce_clin_family_history_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_family_history_ins_upd AFTER INSERT OR UPDATE ON clin.family_history DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.family_history::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: health_issue zzz_tr_announce_clin_health_issue_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_health_issue_del AFTER DELETE ON clin.health_issue DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.health_issue::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: health_issue zzz_tr_announce_clin_health_issue_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_health_issue_ins_upd AFTER INSERT OR UPDATE ON clin.health_issue DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.health_issue::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: hospital_stay zzz_tr_announce_clin_hospital_stay_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_hospital_stay_del AFTER DELETE ON clin.hospital_stay DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.hospital_stay::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: hospital_stay zzz_tr_announce_clin_hospital_stay_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_hospital_stay_ins_upd AFTER INSERT OR UPDATE ON clin.hospital_stay DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.hospital_stay::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: lnk_code2aoe zzz_tr_announce_clin_lnk_code2aoe_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_code2aoe_del AFTER DELETE ON clin.lnk_code2aoe DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.lnk_code2aoe::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_code2aoe zzz_tr_announce_clin_lnk_code2aoe_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_code2aoe_ins_upd AFTER INSERT OR UPDATE ON clin.lnk_code2aoe DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.lnk_code2aoe::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_code2episode zzz_tr_announce_clin_lnk_code2episode_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_code2episode_del AFTER DELETE ON clin.lnk_code2episode DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.lnk_code2episode::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_code2episode zzz_tr_announce_clin_lnk_code2episode_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_code2episode_ins_upd AFTER INSERT OR UPDATE ON clin.lnk_code2episode DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.lnk_code2episode::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_code2fhx zzz_tr_announce_clin_lnk_code2fhx_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_code2fhx_del AFTER DELETE ON clin.lnk_code2fhx DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.lnk_code2fhx::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_code2fhx zzz_tr_announce_clin_lnk_code2fhx_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_code2fhx_ins_upd AFTER INSERT OR UPDATE ON clin.lnk_code2fhx DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.lnk_code2fhx::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_code2h_issue zzz_tr_announce_clin_lnk_code2h_issue_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_code2h_issue_del AFTER DELETE ON clin.lnk_code2h_issue DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.lnk_code2h_issue::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_code2h_issue zzz_tr_announce_clin_lnk_code2h_issue_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_code2h_issue_ins_upd AFTER INSERT OR UPDATE ON clin.lnk_code2h_issue DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.lnk_code2h_issue::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_code2narrative zzz_tr_announce_clin_lnk_code2narrative_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_code2narrative_del AFTER DELETE ON clin.lnk_code2narrative DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.lnk_code2narrative::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_code2narrative zzz_tr_announce_clin_lnk_code2narrative_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_code2narrative_ins_upd AFTER INSERT OR UPDATE ON clin.lnk_code2narrative DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.lnk_code2narrative::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_code2procedure zzz_tr_announce_clin_lnk_code2procedure_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_code2procedure_del AFTER DELETE ON clin.lnk_code2procedure DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.lnk_code2procedure::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_code2procedure zzz_tr_announce_clin_lnk_code2procedure_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_code2procedure_ins_upd AFTER INSERT OR UPDATE ON clin.lnk_code2procedure DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.lnk_code2procedure::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_code2rfe zzz_tr_announce_clin_lnk_code2rfe_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_code2rfe_del AFTER DELETE ON clin.lnk_code2rfe DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.lnk_code2rfe::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_code2rfe zzz_tr_announce_clin_lnk_code2rfe_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_code2rfe_ins_upd AFTER INSERT OR UPDATE ON clin.lnk_code2rfe DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.lnk_code2rfe::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_code2tst_pnl zzz_tr_announce_clin_lnk_code2tst_pnl_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_code2tst_pnl_del AFTER DELETE ON clin.lnk_code2tst_pnl DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.lnk_code2tst_pnl::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_code2tst_pnl zzz_tr_announce_clin_lnk_code2tst_pnl_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_code2tst_pnl_ins_upd AFTER INSERT OR UPDATE ON clin.lnk_code2tst_pnl DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.lnk_code2tst_pnl::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_loinc2test_panel zzz_tr_announce_clin_lnk_loinc2test_panel_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_loinc2test_panel_del AFTER DELETE ON clin.lnk_loinc2test_panel DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.lnk_loinc2test_panel::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_loinc2test_panel zzz_tr_announce_clin_lnk_loinc2test_panel_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_lnk_loinc2test_panel_ins_upd AFTER INSERT OR UPDATE ON clin.lnk_loinc2test_panel DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.lnk_loinc2test_panel::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: patient zzz_tr_announce_clin_patient_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_patient_del AFTER DELETE ON clin.patient DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.patient::PK name=pk', 'select $1.pk', 'select $1.fk_identity');


--
-- Name: patient zzz_tr_announce_clin_patient_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_patient_ins_upd AFTER INSERT OR UPDATE ON clin.patient DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.patient::PK name=pk', 'select $1.pk', 'select $1.fk_identity');


--
-- Name: procedure zzz_tr_announce_clin_procedure_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_procedure_del AFTER DELETE ON clin.procedure DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.procedure::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: procedure zzz_tr_announce_clin_procedure_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_procedure_ins_upd AFTER INSERT OR UPDATE ON clin.procedure DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.procedure::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: reviewed_test_results zzz_tr_announce_clin_reviewed_test_results_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_reviewed_test_results_del AFTER DELETE ON clin.reviewed_test_results DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.reviewed_test_results::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: reviewed_test_results zzz_tr_announce_clin_reviewed_test_results_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_reviewed_test_results_ins_upd AFTER INSERT OR UPDATE ON clin.reviewed_test_results DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.reviewed_test_results::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: substance_intake zzz_tr_announce_clin_substance_intake_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_substance_intake_del AFTER DELETE ON clin.substance_intake DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.substance_intake::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: substance_intake zzz_tr_announce_clin_substance_intake_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_substance_intake_ins_upd AFTER INSERT OR UPDATE ON clin.substance_intake DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.substance_intake::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: suppressed_hint zzz_tr_announce_clin_suppressed_hint_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_suppressed_hint_del AFTER DELETE ON clin.suppressed_hint DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.suppressed_hint::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: suppressed_hint zzz_tr_announce_clin_suppressed_hint_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_suppressed_hint_ins_upd AFTER INSERT OR UPDATE ON clin.suppressed_hint DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.suppressed_hint::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: test_panel zzz_tr_announce_clin_test_panel_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_test_panel_del AFTER DELETE ON clin.test_panel DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.test_panel::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: test_panel zzz_tr_announce_clin_test_panel_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_test_panel_ins_upd AFTER INSERT OR UPDATE ON clin.test_panel DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.test_panel::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: test_result zzz_tr_announce_clin_test_result_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_test_result_del AFTER DELETE ON clin.test_result DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.test_result::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: test_result zzz_tr_announce_clin_test_result_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_test_result_ins_upd AFTER INSERT OR UPDATE ON clin.test_result DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.test_result::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: vaccination zzz_tr_announce_clin_vaccination_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_vaccination_del AFTER DELETE ON clin.vaccination DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.vaccination::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: vaccination zzz_tr_announce_clin_vaccination_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_vaccination_ins_upd AFTER INSERT OR UPDATE ON clin.vaccination DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.vaccination::PK name=pk', 'select $1.pk', 'select fk_patient from clin.encounter where pk = $1.fk_encounter limit 1');


--
-- Name: waiting_list zzz_tr_announce_clin_waiting_list_del; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_waiting_list_del AFTER DELETE ON clin.waiting_list DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=clin.waiting_list::PK name=pk', 'select $1.pk', 'select $1.fk_patient');


--
-- Name: waiting_list zzz_tr_announce_clin_waiting_list_ins_upd; Type: TRIGGER; Schema: clin; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_clin_waiting_list_ins_upd AFTER INSERT OR UPDATE ON clin.waiting_list DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=clin.waiting_list::PK name=pk', 'select $1.pk', 'select $1.fk_patient');


--
-- Name: beh_fall_typ zt_del_beh_fall_typ; Type: TRIGGER; Schema: de_de; Owner: gm-dbo
--

CREATE TRIGGER zt_del_beh_fall_typ BEFORE DELETE ON de_de.beh_fall_typ FOR EACH ROW EXECUTE FUNCTION audit.ft_del_beh_fall_typ();


--
-- Name: lab_test_gnr zt_del_lab_test_gnr; Type: TRIGGER; Schema: de_de; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lab_test_gnr BEFORE DELETE ON de_de.lab_test_gnr FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lab_test_gnr();


--
-- Name: prax_geb_paid zt_del_prax_geb_paid; Type: TRIGGER; Schema: de_de; Owner: gm-dbo
--

CREATE TRIGGER zt_del_prax_geb_paid BEFORE DELETE ON de_de.prax_geb_paid FOR EACH ROW EXECUTE FUNCTION audit.ft_del_prax_geb_paid();


--
-- Name: beh_fall_typ zt_ins_beh_fall_typ; Type: TRIGGER; Schema: de_de; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_beh_fall_typ BEFORE INSERT ON de_de.beh_fall_typ FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_beh_fall_typ();


--
-- Name: lab_test_gnr zt_ins_lab_test_gnr; Type: TRIGGER; Schema: de_de; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lab_test_gnr BEFORE INSERT ON de_de.lab_test_gnr FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lab_test_gnr();


--
-- Name: prax_geb_paid zt_ins_prax_geb_paid; Type: TRIGGER; Schema: de_de; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_prax_geb_paid BEFORE INSERT ON de_de.prax_geb_paid FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_prax_geb_paid();


--
-- Name: beh_fall_typ zt_upd_beh_fall_typ; Type: TRIGGER; Schema: de_de; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_beh_fall_typ BEFORE UPDATE ON de_de.beh_fall_typ FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_beh_fall_typ();


--
-- Name: lab_test_gnr zt_upd_lab_test_gnr; Type: TRIGGER; Schema: de_de; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lab_test_gnr BEFORE UPDATE ON de_de.lab_test_gnr FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lab_test_gnr();


--
-- Name: prax_geb_paid zt_upd_prax_geb_paid; Type: TRIGGER; Schema: de_de; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_prax_geb_paid BEFORE UPDATE ON de_de.prax_geb_paid FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_prax_geb_paid();


--
-- Name: names tr_d_n_assert_unique_named_identity; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER tr_d_n_assert_unique_named_identity AFTER INSERT OR UPDATE ON dem.names DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION dem.assert_unique_named_identity();


--
-- Name: identity tr_ins_d_i_assert_unique_named_identity; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER tr_ins_d_i_assert_unique_named_identity AFTER INSERT ON dem.identity DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION dem.assert_unique_named_identity();


--
-- Name: identity tr_normalize_time_in_dob; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER tr_normalize_time_in_dob BEFORE INSERT OR UPDATE ON dem.identity FOR EACH ROW EXECUTE FUNCTION dem.trf_normalize_time_in_dob();


--
-- Name: identity tr_null_empty_title; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER tr_null_empty_title BEFORE INSERT OR UPDATE ON dem.identity FOR EACH ROW EXECUTE FUNCTION dem.trf_null_empty_title();


--
-- Name: staff tr_prevent_deletion_of_in_use_staff; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER tr_prevent_deletion_of_in_use_staff BEFORE DELETE ON dem.staff FOR EACH ROW EXECUTE FUNCTION dem.trf_prevent_deletion_of_in_use_staff();


--
-- Name: praxis_branch tr_prevent_multiple_praxi; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER tr_prevent_multiple_praxi BEFORE INSERT OR UPDATE ON dem.praxis_branch FOR EACH ROW EXECUTE FUNCTION dem.trf_prevent_multiple_praxi();


--
-- Name: names tr_protect_active_name_of_person; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER tr_protect_active_name_of_person AFTER DELETE OR UPDATE ON dem.names DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION dem.trf_protect_active_name_of_person();


--
-- Name: identity tr_upd_d_i_assert_unique_named_identity; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER tr_upd_d_i_assert_unique_named_identity AFTER UPDATE ON dem.identity DEFERRABLE INITIALLY DEFERRED FOR EACH ROW WHEN ((new.comment IS DISTINCT FROM old.comment)) EXECUTE FUNCTION dem.assert_unique_named_identity();


--
-- Name: address zt_del_address; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_address BEFORE DELETE ON dem.address FOR EACH ROW EXECUTE FUNCTION audit.ft_del_address();


--
-- Name: gender_label zt_del_gender_label; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_gender_label BEFORE DELETE ON dem.gender_label FOR EACH ROW EXECUTE FUNCTION audit.ft_del_gender_label();


--
-- Name: identity zt_del_identity; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_identity BEFORE DELETE ON dem.identity FOR EACH ROW EXECUTE FUNCTION audit.ft_del_identity();


--
-- Name: identity_tag zt_del_identity_tag; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_identity_tag BEFORE DELETE ON dem.identity_tag FOR EACH ROW EXECUTE FUNCTION audit.ft_del_identity_tag();


--
-- Name: inbox_item_category zt_del_inbox_item_category; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_inbox_item_category BEFORE DELETE ON dem.inbox_item_category FOR EACH ROW EXECUTE FUNCTION audit.ft_del_inbox_item_category();


--
-- Name: inbox_item_type zt_del_inbox_item_type; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_inbox_item_type BEFORE DELETE ON dem.inbox_item_type FOR EACH ROW EXECUTE FUNCTION audit.ft_del_inbox_item_type();


--
-- Name: lnk_identity2ext_id zt_del_lnk_identity2ext_id; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_identity2ext_id BEFORE DELETE ON dem.lnk_identity2ext_id FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_identity2ext_id();


--
-- Name: lnk_job2person zt_del_lnk_job2person; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_job2person BEFORE DELETE ON dem.lnk_job2person FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_job2person();


--
-- Name: lnk_org_unit2comm zt_del_lnk_org_unit2comm; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_org_unit2comm BEFORE DELETE ON dem.lnk_org_unit2comm FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_org_unit2comm();


--
-- Name: lnk_org_unit2ext_id zt_del_lnk_org_unit2ext_id; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_org_unit2ext_id BEFORE DELETE ON dem.lnk_org_unit2ext_id FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_org_unit2ext_id();


--
-- Name: lnk_person2relative zt_del_lnk_person2relative; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_person2relative BEFORE DELETE ON dem.lnk_person2relative FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_person2relative();


--
-- Name: message_inbox zt_del_message_inbox; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_message_inbox BEFORE DELETE ON dem.message_inbox FOR EACH ROW EXECUTE FUNCTION audit.ft_del_message_inbox();


--
-- Name: occupation zt_del_occupation; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_occupation BEFORE DELETE ON dem.occupation FOR EACH ROW EXECUTE FUNCTION audit.ft_del_occupation();


--
-- Name: org zt_del_org; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_org BEFORE DELETE ON dem.org FOR EACH ROW EXECUTE FUNCTION audit.ft_del_org();


--
-- Name: org_unit zt_del_org_unit; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_org_unit BEFORE DELETE ON dem.org_unit FOR EACH ROW EXECUTE FUNCTION audit.ft_del_org_unit();


--
-- Name: praxis_branch zt_del_praxis_branch; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_praxis_branch BEFORE DELETE ON dem.praxis_branch FOR EACH ROW EXECUTE FUNCTION audit.ft_del_praxis_branch();


--
-- Name: region zt_del_region; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_region BEFORE DELETE ON dem.region FOR EACH ROW EXECUTE FUNCTION audit.ft_del_region();


--
-- Name: relation_types zt_del_relation_types; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_relation_types BEFORE DELETE ON dem.relation_types FOR EACH ROW EXECUTE FUNCTION audit.ft_del_relation_types();


--
-- Name: staff zt_del_staff; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_staff BEFORE DELETE ON dem.staff FOR EACH ROW EXECUTE FUNCTION audit.ft_del_staff();


--
-- Name: street zt_del_street; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_street BEFORE DELETE ON dem.street FOR EACH ROW EXECUTE FUNCTION audit.ft_del_street();


--
-- Name: urb zt_del_urb; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_del_urb BEFORE DELETE ON dem.urb FOR EACH ROW EXECUTE FUNCTION audit.ft_del_urb();


--
-- Name: address zt_ins_address; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_address BEFORE INSERT ON dem.address FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_address();


--
-- Name: gender_label zt_ins_gender_label; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_gender_label BEFORE INSERT ON dem.gender_label FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_gender_label();


--
-- Name: identity zt_ins_identity; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_identity BEFORE INSERT ON dem.identity FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_identity();


--
-- Name: identity_tag zt_ins_identity_tag; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_identity_tag BEFORE INSERT ON dem.identity_tag FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_identity_tag();


--
-- Name: inbox_item_category zt_ins_inbox_item_category; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_inbox_item_category BEFORE INSERT ON dem.inbox_item_category FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_inbox_item_category();


--
-- Name: inbox_item_type zt_ins_inbox_item_type; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_inbox_item_type BEFORE INSERT ON dem.inbox_item_type FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_inbox_item_type();


--
-- Name: lnk_identity2ext_id zt_ins_lnk_identity2ext_id; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_identity2ext_id BEFORE INSERT ON dem.lnk_identity2ext_id FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_identity2ext_id();


--
-- Name: lnk_job2person zt_ins_lnk_job2person; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_job2person BEFORE INSERT ON dem.lnk_job2person FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_job2person();


--
-- Name: lnk_org_unit2comm zt_ins_lnk_org_unit2comm; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_org_unit2comm BEFORE INSERT ON dem.lnk_org_unit2comm FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_org_unit2comm();


--
-- Name: lnk_org_unit2ext_id zt_ins_lnk_org_unit2ext_id; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_org_unit2ext_id BEFORE INSERT ON dem.lnk_org_unit2ext_id FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_org_unit2ext_id();


--
-- Name: lnk_person2relative zt_ins_lnk_person2relative; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_person2relative BEFORE INSERT ON dem.lnk_person2relative FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_person2relative();


--
-- Name: message_inbox zt_ins_message_inbox; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_message_inbox BEFORE INSERT ON dem.message_inbox FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_message_inbox();


--
-- Name: occupation zt_ins_occupation; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_occupation BEFORE INSERT ON dem.occupation FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_occupation();


--
-- Name: org zt_ins_org; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_org BEFORE INSERT ON dem.org FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_org();


--
-- Name: org_unit zt_ins_org_unit; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_org_unit BEFORE INSERT ON dem.org_unit FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_org_unit();


--
-- Name: praxis_branch zt_ins_praxis_branch; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_praxis_branch BEFORE INSERT ON dem.praxis_branch FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_praxis_branch();


--
-- Name: region zt_ins_region; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_region BEFORE INSERT ON dem.region FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_region();


--
-- Name: relation_types zt_ins_relation_types; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_relation_types BEFORE INSERT ON dem.relation_types FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_relation_types();


--
-- Name: staff zt_ins_staff; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_staff BEFORE INSERT ON dem.staff FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_staff();


--
-- Name: street zt_ins_street; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_street BEFORE INSERT ON dem.street FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_street();


--
-- Name: urb zt_ins_urb; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_urb BEFORE INSERT ON dem.urb FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_urb();


--
-- Name: address zt_upd_address; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_address BEFORE UPDATE ON dem.address FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_address();


--
-- Name: gender_label zt_upd_gender_label; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_gender_label BEFORE UPDATE ON dem.gender_label FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_gender_label();


--
-- Name: identity zt_upd_identity; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_identity BEFORE UPDATE ON dem.identity FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_identity();


--
-- Name: identity_tag zt_upd_identity_tag; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_identity_tag BEFORE UPDATE ON dem.identity_tag FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_identity_tag();


--
-- Name: inbox_item_category zt_upd_inbox_item_category; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_inbox_item_category BEFORE UPDATE ON dem.inbox_item_category FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_inbox_item_category();


--
-- Name: inbox_item_type zt_upd_inbox_item_type; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_inbox_item_type BEFORE UPDATE ON dem.inbox_item_type FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_inbox_item_type();


--
-- Name: lnk_identity2ext_id zt_upd_lnk_identity2ext_id; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_identity2ext_id BEFORE UPDATE ON dem.lnk_identity2ext_id FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_identity2ext_id();


--
-- Name: lnk_job2person zt_upd_lnk_job2person; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_job2person BEFORE UPDATE ON dem.lnk_job2person FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_job2person();


--
-- Name: lnk_org_unit2comm zt_upd_lnk_org_unit2comm; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_org_unit2comm BEFORE UPDATE ON dem.lnk_org_unit2comm FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_org_unit2comm();


--
-- Name: lnk_org_unit2ext_id zt_upd_lnk_org_unit2ext_id; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_org_unit2ext_id BEFORE UPDATE ON dem.lnk_org_unit2ext_id FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_org_unit2ext_id();


--
-- Name: lnk_person2relative zt_upd_lnk_person2relative; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_person2relative BEFORE UPDATE ON dem.lnk_person2relative FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_person2relative();


--
-- Name: message_inbox zt_upd_message_inbox; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_message_inbox BEFORE UPDATE ON dem.message_inbox FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_message_inbox();


--
-- Name: occupation zt_upd_occupation; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_occupation BEFORE UPDATE ON dem.occupation FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_occupation();


--
-- Name: org zt_upd_org; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_org BEFORE UPDATE ON dem.org FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_org();


--
-- Name: org_unit zt_upd_org_unit; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_org_unit BEFORE UPDATE ON dem.org_unit FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_org_unit();


--
-- Name: praxis_branch zt_upd_praxis_branch; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_praxis_branch BEFORE UPDATE ON dem.praxis_branch FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_praxis_branch();


--
-- Name: region zt_upd_region; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_region BEFORE UPDATE ON dem.region FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_region();


--
-- Name: relation_types zt_upd_relation_types; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_relation_types BEFORE UPDATE ON dem.relation_types FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_relation_types();


--
-- Name: staff zt_upd_staff; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_staff BEFORE UPDATE ON dem.staff FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_staff();


--
-- Name: street zt_upd_street; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_street BEFORE UPDATE ON dem.street FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_street();


--
-- Name: urb zt_upd_urb; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_urb BEFORE UPDATE ON dem.urb FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_urb();


--
-- Name: identity zzz_tr_announce_dem_identity_del; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_identity_del AFTER DELETE ON dem.identity DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=dem.identity::PK name=pk', 'select $1.pk', 'select $1.pk');


--
-- Name: identity zzz_tr_announce_dem_identity_ins_upd; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_identity_ins_upd AFTER INSERT OR UPDATE ON dem.identity DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=dem.identity::PK name=pk', 'select $1.pk', 'select $1.pk');


--
-- Name: identity_tag zzz_tr_announce_dem_identity_tag_del; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_identity_tag_del AFTER DELETE ON dem.identity_tag DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=dem.identity_tag::PK name=pk', 'select $1.pk', 'select $1.fk_identity');


--
-- Name: identity_tag zzz_tr_announce_dem_identity_tag_ins_upd; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_identity_tag_ins_upd AFTER INSERT OR UPDATE ON dem.identity_tag DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=dem.identity_tag::PK name=pk', 'select $1.pk', 'select $1.fk_identity');


--
-- Name: lnk_identity2comm zzz_tr_announce_dem_lnk_identity2comm_del; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_lnk_identity2comm_del AFTER DELETE ON dem.lnk_identity2comm DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=dem.lnk_identity2comm::PK name=pk', 'select $1.pk', 'select $1.fk_identity');


--
-- Name: lnk_identity2comm zzz_tr_announce_dem_lnk_identity2comm_ins_upd; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_lnk_identity2comm_ins_upd AFTER INSERT OR UPDATE ON dem.lnk_identity2comm DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=dem.lnk_identity2comm::PK name=pk', 'select $1.pk', 'select $1.fk_identity');


--
-- Name: lnk_identity2ext_id zzz_tr_announce_dem_lnk_identity2ext_id_del; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_lnk_identity2ext_id_del AFTER DELETE ON dem.lnk_identity2ext_id DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=dem.lnk_identity2ext_id::PK name=id', 'select $1.id', 'select $1.id_identity');


--
-- Name: lnk_identity2ext_id zzz_tr_announce_dem_lnk_identity2ext_id_ins_upd; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_lnk_identity2ext_id_ins_upd AFTER INSERT OR UPDATE ON dem.lnk_identity2ext_id DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=dem.lnk_identity2ext_id::PK name=id', 'select $1.id', 'select $1.id_identity');


--
-- Name: lnk_job2person zzz_tr_announce_dem_lnk_job2person_del; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_lnk_job2person_del AFTER DELETE ON dem.lnk_job2person DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=dem.lnk_job2person::PK name=pk', 'select $1.pk', 'select $1.fk_identity');


--
-- Name: lnk_job2person zzz_tr_announce_dem_lnk_job2person_ins_upd; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_lnk_job2person_ins_upd AFTER INSERT OR UPDATE ON dem.lnk_job2person DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=dem.lnk_job2person::PK name=pk', 'select $1.pk', 'select $1.fk_identity');


--
-- Name: lnk_org_unit2comm zzz_tr_announce_dem_lnk_org_unit2comm_del; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_lnk_org_unit2comm_del AFTER DELETE ON dem.lnk_org_unit2comm DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=dem.lnk_org_unit2comm::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_org_unit2comm zzz_tr_announce_dem_lnk_org_unit2comm_ins_upd; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_lnk_org_unit2comm_ins_upd AFTER INSERT OR UPDATE ON dem.lnk_org_unit2comm DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=dem.lnk_org_unit2comm::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: message_inbox zzz_tr_announce_dem_message_inbox_del; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_message_inbox_del AFTER DELETE ON dem.message_inbox DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=dem.message_inbox::PK name=pk', 'select $1.pk', 'select $1.fk_patient');


--
-- Name: message_inbox zzz_tr_announce_dem_message_inbox_ins_upd; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_message_inbox_ins_upd AFTER INSERT OR UPDATE ON dem.message_inbox DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=dem.message_inbox::PK name=pk', 'select $1.pk', 'select $1.fk_patient');


--
-- Name: names zzz_tr_announce_dem_names_del; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_names_del AFTER DELETE ON dem.names DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=dem.names::PK name=id', 'select $1.id', 'select $1.id_identity');


--
-- Name: names zzz_tr_announce_dem_names_ins_upd; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_names_ins_upd AFTER INSERT OR UPDATE ON dem.names DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=dem.names::PK name=id', 'select $1.id', 'select $1.id_identity');


--
-- Name: org zzz_tr_announce_dem_org_del; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_org_del AFTER DELETE ON dem.org DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=dem.org::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: org zzz_tr_announce_dem_org_ins_upd; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_org_ins_upd AFTER INSERT OR UPDATE ON dem.org DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=dem.org::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: org_unit zzz_tr_announce_dem_org_unit_del; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_org_unit_del AFTER DELETE ON dem.org_unit DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=dem.org_unit::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: org_unit zzz_tr_announce_dem_org_unit_ins_upd; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_org_unit_ins_upd AFTER INSERT OR UPDATE ON dem.org_unit DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=dem.org_unit::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: praxis_branch zzz_tr_announce_dem_praxis_branch_del; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_praxis_branch_del AFTER DELETE ON dem.praxis_branch DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=dem.praxis_branch::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: praxis_branch zzz_tr_announce_dem_praxis_branch_ins_upd; Type: TRIGGER; Schema: dem; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_dem_praxis_branch_ins_upd AFTER INSERT OR UPDATE ON dem.praxis_branch DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=dem.praxis_branch::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: access_log zt_del_access_log; Type: TRIGGER; Schema: gm; Owner: gm-dbo
--

CREATE TRIGGER zt_del_access_log BEFORE DELETE ON gm.access_log FOR EACH ROW EXECUTE FUNCTION audit.ft_del_access_log();


--
-- Name: access_log zt_ins_access_log; Type: TRIGGER; Schema: gm; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_access_log BEFORE INSERT ON gm.access_log FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_access_log();


--
-- Name: access_log zt_upd_access_log; Type: TRIGGER; Schema: gm; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_access_log BEFORE UPDATE ON gm.access_log FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_access_log();


--
-- Name: drug_product tr_assert_product_has_components; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER tr_assert_product_has_components AFTER INSERT OR UPDATE ON ref.drug_product DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION ref.trf_assert_product_has_components();


--
-- Name: lnk_dose2drug tr_del_assert_product_keeps_components; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER tr_del_assert_product_keeps_components AFTER DELETE ON ref.lnk_dose2drug DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION ref.trf_assert_product_keeps_components();


--
-- Name: atc tr_del_ref_code_tbl_check_backlink; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER tr_del_ref_code_tbl_check_backlink BEFORE UPDATE ON ref.atc FOR EACH ROW EXECUTE FUNCTION ref.trf_del_ref_code_tbl_check_backlink();


--
-- Name: coda tr_del_ref_code_tbl_check_backlink; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER tr_del_ref_code_tbl_check_backlink BEFORE UPDATE ON ref.coda FOR EACH ROW EXECUTE FUNCTION ref.trf_del_ref_code_tbl_check_backlink();


--
-- Name: icd10 tr_del_ref_code_tbl_check_backlink; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER tr_del_ref_code_tbl_check_backlink BEFORE UPDATE ON ref.icd10 FOR EACH ROW EXECUTE FUNCTION ref.trf_del_ref_code_tbl_check_backlink();


--
-- Name: icd9 tr_del_ref_code_tbl_check_backlink; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER tr_del_ref_code_tbl_check_backlink BEFORE UPDATE ON ref.icd9 FOR EACH ROW EXECUTE FUNCTION ref.trf_del_ref_code_tbl_check_backlink();


--
-- Name: icpc tr_del_ref_code_tbl_check_backlink; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER tr_del_ref_code_tbl_check_backlink BEFORE UPDATE ON ref.icpc FOR EACH ROW EXECUTE FUNCTION ref.trf_del_ref_code_tbl_check_backlink();


--
-- Name: loinc tr_del_ref_code_tbl_check_backlink; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER tr_del_ref_code_tbl_check_backlink BEFORE UPDATE ON ref.loinc FOR EACH ROW EXECUTE FUNCTION ref.trf_del_ref_code_tbl_check_backlink();


--
-- Name: ops tr_del_ref_code_tbl_check_backlink; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER tr_del_ref_code_tbl_check_backlink BEFORE UPDATE ON ref.ops FOR EACH ROW EXECUTE FUNCTION ref.trf_del_ref_code_tbl_check_backlink();


--
-- Name: other_code tr_del_ref_code_tbl_check_backlink; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER tr_del_ref_code_tbl_check_backlink BEFORE UPDATE ON ref.other_code FOR EACH ROW EXECUTE FUNCTION ref.trf_del_ref_code_tbl_check_backlink();


--
-- Name: lnk_dose2drug tr_ins_upd_assert_dose_unit_across_drug_components; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER tr_ins_upd_assert_dose_unit_across_drug_components AFTER INSERT OR UPDATE ON ref.lnk_dose2drug DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION ref.trf_ins_upd_assert_dose_unit_across_drug_components();


--
-- Name: paperwork_templates tr_protect_template_data; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER tr_protect_template_data BEFORE UPDATE ON ref.paperwork_templates FOR EACH ROW EXECUTE FUNCTION ref.trf_protect_template_data();


--
-- Name: dose tr_upd_assert_dose_unit_in_multi_component_drugs; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER tr_upd_assert_dose_unit_in_multi_component_drugs AFTER UPDATE ON ref.dose DEFERRABLE INITIALLY DEFERRED FOR EACH ROW WHEN ((new.dose_unit IS DISTINCT FROM old.dose_unit)) EXECUTE FUNCTION ref.trf_upd_assert_dose_unit_in_multi_component_drugs();


--
-- Name: lnk_dose2drug tr_upd_assert_product_keeps_components; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER tr_upd_assert_product_keeps_components AFTER UPDATE ON ref.lnk_dose2drug DEFERRABLE INITIALLY DEFERRED FOR EACH ROW WHEN ((new.fk_drug_product IS DISTINCT FROM old.fk_drug_product)) EXECUTE FUNCTION ref.trf_assert_product_keeps_components();


--
-- Name: atc tr_upd_ref_code_tbl_check_backlink; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER tr_upd_ref_code_tbl_check_backlink BEFORE UPDATE ON ref.atc FOR EACH ROW EXECUTE FUNCTION ref.trf_upd_ref_code_tbl_check_backlink();


--
-- Name: coda tr_upd_ref_code_tbl_check_backlink; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER tr_upd_ref_code_tbl_check_backlink BEFORE UPDATE ON ref.coda FOR EACH ROW EXECUTE FUNCTION ref.trf_upd_ref_code_tbl_check_backlink();


--
-- Name: icd10 tr_upd_ref_code_tbl_check_backlink; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER tr_upd_ref_code_tbl_check_backlink BEFORE UPDATE ON ref.icd10 FOR EACH ROW EXECUTE FUNCTION ref.trf_upd_ref_code_tbl_check_backlink();


--
-- Name: icd9 tr_upd_ref_code_tbl_check_backlink; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER tr_upd_ref_code_tbl_check_backlink BEFORE UPDATE ON ref.icd9 FOR EACH ROW EXECUTE FUNCTION ref.trf_upd_ref_code_tbl_check_backlink();


--
-- Name: icpc tr_upd_ref_code_tbl_check_backlink; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER tr_upd_ref_code_tbl_check_backlink BEFORE UPDATE ON ref.icpc FOR EACH ROW EXECUTE FUNCTION ref.trf_upd_ref_code_tbl_check_backlink();


--
-- Name: loinc tr_upd_ref_code_tbl_check_backlink; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER tr_upd_ref_code_tbl_check_backlink BEFORE UPDATE ON ref.loinc FOR EACH ROW EXECUTE FUNCTION ref.trf_upd_ref_code_tbl_check_backlink();


--
-- Name: ops tr_upd_ref_code_tbl_check_backlink; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER tr_upd_ref_code_tbl_check_backlink BEFORE UPDATE ON ref.ops FOR EACH ROW EXECUTE FUNCTION ref.trf_upd_ref_code_tbl_check_backlink();


--
-- Name: other_code tr_upd_ref_code_tbl_check_backlink; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER tr_upd_ref_code_tbl_check_backlink BEFORE UPDATE ON ref.other_code FOR EACH ROW EXECUTE FUNCTION ref.trf_upd_ref_code_tbl_check_backlink();


--
-- Name: auto_hint zt_del_auto_hint; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_del_auto_hint BEFORE DELETE ON ref.auto_hint FOR EACH ROW EXECUTE FUNCTION audit.ft_del_auto_hint();


--
-- Name: data_source zt_del_data_source; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_del_data_source BEFORE DELETE ON ref.data_source FOR EACH ROW EXECUTE FUNCTION audit.ft_del_data_source();


--
-- Name: dose zt_del_dose; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_del_dose BEFORE DELETE ON ref.dose FOR EACH ROW EXECUTE FUNCTION audit.ft_del_dose();


--
-- Name: drug_product zt_del_drug_product; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_del_drug_product BEFORE DELETE ON ref.drug_product FOR EACH ROW EXECUTE FUNCTION audit.ft_del_drug_product();


--
-- Name: lnk_dose2drug zt_del_lnk_dose2drug; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_dose2drug BEFORE DELETE ON ref.lnk_dose2drug FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_dose2drug();


--
-- Name: lnk_loinc2substance zt_del_lnk_loinc2substance; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_del_lnk_loinc2substance BEFORE DELETE ON ref.lnk_loinc2substance FOR EACH ROW EXECUTE FUNCTION audit.ft_del_lnk_loinc2substance();


--
-- Name: paperwork_templates zt_del_paperwork_templates; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_del_paperwork_templates BEFORE DELETE ON ref.paperwork_templates FOR EACH ROW EXECUTE FUNCTION audit.ft_del_paperwork_templates();


--
-- Name: substance zt_del_substance; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_del_substance BEFORE DELETE ON ref.substance FOR EACH ROW EXECUTE FUNCTION audit.ft_del_substance();


--
-- Name: tag_image zt_del_tag_image; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_del_tag_image BEFORE DELETE ON ref.tag_image FOR EACH ROW EXECUTE FUNCTION audit.ft_del_tag_image();


--
-- Name: vacc_route zt_del_vacc_route; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_del_vacc_route BEFORE DELETE ON ref.vacc_route FOR EACH ROW EXECUTE FUNCTION audit.ft_del_vacc_route();


--
-- Name: vaccine zt_del_vaccine; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_del_vaccine BEFORE DELETE ON ref.vaccine FOR EACH ROW EXECUTE FUNCTION audit.ft_del_vaccine();


--
-- Name: auto_hint zt_ins_auto_hint; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_auto_hint BEFORE INSERT ON ref.auto_hint FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_auto_hint();


--
-- Name: data_source zt_ins_data_source; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_data_source BEFORE INSERT ON ref.data_source FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_data_source();


--
-- Name: dose zt_ins_dose; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_dose BEFORE INSERT ON ref.dose FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_dose();


--
-- Name: drug_product zt_ins_drug_product; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_drug_product BEFORE INSERT ON ref.drug_product FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_drug_product();


--
-- Name: lnk_dose2drug zt_ins_lnk_dose2drug; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_dose2drug BEFORE INSERT ON ref.lnk_dose2drug FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_dose2drug();


--
-- Name: lnk_loinc2substance zt_ins_lnk_loinc2substance; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_lnk_loinc2substance BEFORE INSERT ON ref.lnk_loinc2substance FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_lnk_loinc2substance();


--
-- Name: paperwork_templates zt_ins_paperwork_templates; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_paperwork_templates BEFORE INSERT ON ref.paperwork_templates FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_paperwork_templates();


--
-- Name: substance zt_ins_substance; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_substance BEFORE INSERT ON ref.substance FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_substance();


--
-- Name: tag_image zt_ins_tag_image; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_tag_image BEFORE INSERT ON ref.tag_image FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_tag_image();


--
-- Name: vacc_route zt_ins_vacc_route; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_vacc_route BEFORE INSERT ON ref.vacc_route FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_vacc_route();


--
-- Name: vaccine zt_ins_vaccine; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_ins_vaccine BEFORE INSERT ON ref.vaccine FOR EACH ROW EXECUTE FUNCTION audit.ft_ins_vaccine();


--
-- Name: auto_hint zt_upd_auto_hint; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_auto_hint BEFORE UPDATE ON ref.auto_hint FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_auto_hint();


--
-- Name: data_source zt_upd_data_source; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_data_source BEFORE UPDATE ON ref.data_source FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_data_source();


--
-- Name: dose zt_upd_dose; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_dose BEFORE UPDATE ON ref.dose FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_dose();


--
-- Name: drug_product zt_upd_drug_product; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_drug_product BEFORE UPDATE ON ref.drug_product FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_drug_product();


--
-- Name: lnk_dose2drug zt_upd_lnk_dose2drug; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_dose2drug BEFORE UPDATE ON ref.lnk_dose2drug FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_dose2drug();


--
-- Name: lnk_loinc2substance zt_upd_lnk_loinc2substance; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_lnk_loinc2substance BEFORE UPDATE ON ref.lnk_loinc2substance FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_lnk_loinc2substance();


--
-- Name: paperwork_templates zt_upd_paperwork_templates; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_paperwork_templates BEFORE UPDATE ON ref.paperwork_templates FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_paperwork_templates();


--
-- Name: substance zt_upd_substance; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_substance BEFORE UPDATE ON ref.substance FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_substance();


--
-- Name: tag_image zt_upd_tag_image; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_tag_image BEFORE UPDATE ON ref.tag_image FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_tag_image();


--
-- Name: vacc_route zt_upd_vacc_route; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_vacc_route BEFORE UPDATE ON ref.vacc_route FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_vacc_route();


--
-- Name: vaccine zt_upd_vaccine; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE TRIGGER zt_upd_vaccine BEFORE UPDATE ON ref.vaccine FOR EACH ROW EXECUTE FUNCTION audit.ft_upd_vaccine();


--
-- Name: auto_hint zzz_tr_announce_ref_auto_hint_del; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_ref_auto_hint_del AFTER DELETE ON ref.auto_hint DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=ref.auto_hint::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: auto_hint zzz_tr_announce_ref_auto_hint_ins_upd; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_ref_auto_hint_ins_upd AFTER INSERT OR UPDATE ON ref.auto_hint DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=ref.auto_hint::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: billable zzz_tr_announce_ref_billable_del; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_ref_billable_del AFTER DELETE ON ref.billable DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=ref.billable::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: billable zzz_tr_announce_ref_billable_ins_upd; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_ref_billable_ins_upd AFTER INSERT OR UPDATE ON ref.billable DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=ref.billable::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: dose zzz_tr_announce_ref_dose_del; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_ref_dose_del AFTER DELETE ON ref.dose DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=ref.dose::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: dose zzz_tr_announce_ref_dose_ins_upd; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_ref_dose_ins_upd AFTER INSERT OR UPDATE ON ref.dose DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=ref.dose::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: drug_product zzz_tr_announce_ref_drug_product_del; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_ref_drug_product_del AFTER DELETE ON ref.drug_product DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=ref.drug_product::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: drug_product zzz_tr_announce_ref_drug_product_ins_upd; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_ref_drug_product_ins_upd AFTER INSERT OR UPDATE ON ref.drug_product DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=ref.drug_product::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_dose2drug zzz_tr_announce_ref_lnk_dose2drug_del; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_ref_lnk_dose2drug_del AFTER DELETE ON ref.lnk_dose2drug DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=ref.lnk_dose2drug::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_dose2drug zzz_tr_announce_ref_lnk_dose2drug_ins_upd; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_ref_lnk_dose2drug_ins_upd AFTER INSERT OR UPDATE ON ref.lnk_dose2drug DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=ref.lnk_dose2drug::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_loinc2substance zzz_tr_announce_ref_lnk_loinc2substance_del; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_ref_lnk_loinc2substance_del AFTER DELETE ON ref.lnk_loinc2substance DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=ref.lnk_loinc2substance::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: lnk_loinc2substance zzz_tr_announce_ref_lnk_loinc2substance_ins_upd; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_ref_lnk_loinc2substance_ins_upd AFTER INSERT OR UPDATE ON ref.lnk_loinc2substance DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=ref.lnk_loinc2substance::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: substance zzz_tr_announce_ref_substance_del; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_ref_substance_del AFTER DELETE ON ref.substance DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=ref.substance::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: substance zzz_tr_announce_ref_substance_ins_upd; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_ref_substance_ins_upd AFTER INSERT OR UPDATE ON ref.substance DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=ref.substance::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: tag_image zzz_tr_announce_ref_tag_image_del; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_ref_tag_image_del AFTER DELETE ON ref.tag_image DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_del('operation=DELETE::table=ref.tag_image::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: tag_image zzz_tr_announce_ref_tag_image_ins_upd; Type: TRIGGER; Schema: ref; Owner: gm-dbo
--

CREATE CONSTRAINT TRIGGER zzz_tr_announce_ref_tag_image_ins_upd AFTER INSERT OR UPDATE ON ref.tag_image DEFERRABLE INITIALLY DEFERRED FOR EACH ROW EXECUTE FUNCTION gm.trf_announce_table_ins_upd('table=ref.tag_image::PK name=pk', 'select $1.pk', '<NULL>');


--
-- Name: referral referral_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: au; Owner: gm-dbo
--

ALTER TABLE ONLY au.referral
    ADD CONSTRAINT referral_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: referral referral_fk_episode_fkey; Type: FK CONSTRAINT; Schema: au; Owner: gm-dbo
--

ALTER TABLE ONLY au.referral
    ADD CONSTRAINT referral_fk_episode_fkey FOREIGN KEY (fk_episode) REFERENCES clin.episode(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: referral referral_fk_form_fkey; Type: FK CONSTRAINT; Schema: au; Owner: gm-dbo
--

ALTER TABLE ONLY au.referral
    ADD CONSTRAINT referral_fk_form_fkey FOREIGN KEY (fk_form) REFERENCES clin.form_instances(pk);


--
-- Name: referral referral_fk_referee_fkey; Type: FK CONSTRAINT; Schema: au; Owner: gm-dbo
--

ALTER TABLE ONLY au.referral
    ADD CONSTRAINT referral_fk_referee_fkey FOREIGN KEY (fk_referee) REFERENCES dem.identity(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: bill bill_fk_doc_fkey; Type: FK CONSTRAINT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill
    ADD CONSTRAINT bill_fk_doc_fkey FOREIGN KEY (fk_doc) REFERENCES blobs.doc_med(pk) ON UPDATE CASCADE ON DELETE SET NULL;


--
-- Name: bill bill_fk_receiver_address_fkey; Type: FK CONSTRAINT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill
    ADD CONSTRAINT bill_fk_receiver_address_fkey FOREIGN KEY (fk_receiver_address) REFERENCES dem.lnk_person_org_address(id) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: bill bill_fk_receiver_identity_fkey; Type: FK CONSTRAINT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill
    ADD CONSTRAINT bill_fk_receiver_identity_fkey FOREIGN KEY (fk_receiver_identity) REFERENCES dem.identity(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: bill_item bill_item_fk_billable_fkey; Type: FK CONSTRAINT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill_item
    ADD CONSTRAINT bill_item_fk_billable_fkey FOREIGN KEY (fk_billable) REFERENCES ref.billable(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: bill_item bill_item_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill_item
    ADD CONSTRAINT bill_item_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: bill_item bill_item_fk_provider_fkey; Type: FK CONSTRAINT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill_item
    ADD CONSTRAINT bill_item_fk_provider_fkey FOREIGN KEY (fk_provider) REFERENCES dem.staff(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: bill_item fk_bill_item_fk_bill; Type: FK CONSTRAINT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.bill_item
    ADD CONSTRAINT fk_bill_item_fk_bill FOREIGN KEY (fk_bill) REFERENCES bill.bill(pk) ON UPDATE CASCADE ON DELETE SET NULL DEFERRABLE INITIALLY DEFERRED;


--
-- Name: lnk_enc_type2billable lnk_enc_type2billable_fk_billable_fkey; Type: FK CONSTRAINT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.lnk_enc_type2billable
    ADD CONSTRAINT lnk_enc_type2billable_fk_billable_fkey FOREIGN KEY (fk_billable) REFERENCES ref.billable(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: lnk_enc_type2billable lnk_enc_type2billable_fk_encounter_type_fkey; Type: FK CONSTRAINT; Schema: bill; Owner: gm-dbo
--

ALTER TABLE ONLY bill.lnk_enc_type2billable
    ADD CONSTRAINT lnk_enc_type2billable_fk_encounter_type_fkey FOREIGN KEY (fk_encounter_type) REFERENCES clin.encounter_type(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: doc_desc doc_desc_doc_id_fkey; Type: FK CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_desc
    ADD CONSTRAINT doc_desc_doc_id_fkey FOREIGN KEY (fk_doc) REFERENCES blobs.doc_med(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: doc_med doc_med_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_med
    ADD CONSTRAINT doc_med_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: doc_med doc_med_fk_episode_fkey; Type: FK CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_med
    ADD CONSTRAINT doc_med_fk_episode_fkey FOREIGN KEY (fk_episode) REFERENCES clin.episode(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: doc_med doc_med_type_fkey; Type: FK CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_med
    ADD CONSTRAINT doc_med_type_fkey FOREIGN KEY (fk_type) REFERENCES blobs.doc_type(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: doc_obj doc_obj_fk_doc_fkey; Type: FK CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_obj
    ADD CONSTRAINT doc_obj_fk_doc_fkey FOREIGN KEY (fk_doc) REFERENCES blobs.doc_med(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: doc_obj doc_obj_fk_intended_reviewer_fkey; Type: FK CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_obj
    ADD CONSTRAINT doc_obj_fk_intended_reviewer_fkey FOREIGN KEY (fk_intended_reviewer) REFERENCES dem.staff(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: doc_med fk_blobs_doc_med_dem_org_unit_pk; Type: FK CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.doc_med
    ADD CONSTRAINT fk_blobs_doc_med_dem_org_unit_pk FOREIGN KEY (fk_org_unit) REFERENCES dem.org_unit(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lnk_doc_med2episode lnk_doc_med2episode_fk_doc_med_fkey; Type: FK CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.lnk_doc_med2episode
    ADD CONSTRAINT lnk_doc_med2episode_fk_doc_med_fkey FOREIGN KEY (fk_doc_med) REFERENCES blobs.doc_med(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lnk_doc_med2episode lnk_doc_med2episode_fk_episode_fkey; Type: FK CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.lnk_doc_med2episode
    ADD CONSTRAINT lnk_doc_med2episode_fk_episode_fkey FOREIGN KEY (fk_episode) REFERENCES clin.episode(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: reviewed_doc_objs reviewed_doc_objs_fk_reviewed_row_fkey; Type: FK CONSTRAINT; Schema: blobs; Owner: gm-dbo
--

ALTER TABLE ONLY blobs.reviewed_doc_objs
    ADD CONSTRAINT reviewed_doc_objs_fk_reviewed_row_fkey FOREIGN KEY (fk_reviewed_row) REFERENCES blobs.doc_obj(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cfg_data cfg_data_fk_item_fkey; Type: FK CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_data
    ADD CONSTRAINT cfg_data_fk_item_fkey FOREIGN KEY (fk_item) REFERENCES cfg.cfg_item(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cfg_item cfg_item_fk_template_fkey; Type: FK CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_item
    ADD CONSTRAINT cfg_item_fk_template_fkey FOREIGN KEY (fk_template) REFERENCES cfg.cfg_template(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cfg_numeric cfg_numeric_fk_item_fkey; Type: FK CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_numeric
    ADD CONSTRAINT cfg_numeric_fk_item_fkey FOREIGN KEY (fk_item) REFERENCES cfg.cfg_item(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cfg_str_array cfg_str_array_fk_item_fkey; Type: FK CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_str_array
    ADD CONSTRAINT cfg_str_array_fk_item_fkey FOREIGN KEY (fk_item) REFERENCES cfg.cfg_item(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cfg_string cfg_string_fk_item_fkey; Type: FK CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_string
    ADD CONSTRAINT cfg_string_fk_item_fkey FOREIGN KEY (fk_item) REFERENCES cfg.cfg_item(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cfg_template cfg_template_type_fkey; Type: FK CONSTRAINT; Schema: cfg; Owner: gm-dbo
--

ALTER TABLE ONLY cfg.cfg_template
    ADD CONSTRAINT cfg_template_type_fkey FOREIGN KEY (type) REFERENCES cfg.cfg_type_enum(name);


--
-- Name: allergy allergy_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy
    ADD CONSTRAINT allergy_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: allergy allergy_fk_episode_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy
    ADD CONSTRAINT allergy_fk_episode_fkey FOREIGN KEY (fk_episode) REFERENCES clin.episode(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: allergy allergy_id_type_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy
    ADD CONSTRAINT allergy_id_type_fkey FOREIGN KEY (fk_type) REFERENCES clin._enum_allergy_type(pk);


--
-- Name: allergy_state allergy_state_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.allergy_state
    ADD CONSTRAINT allergy_state_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk);


--
-- Name: clin_aux_note clin_aux_note_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_aux_note
    ADD CONSTRAINT clin_aux_note_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: clin_aux_note clin_aux_note_fk_episode_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_aux_note
    ADD CONSTRAINT clin_aux_note_fk_episode_fkey FOREIGN KEY (fk_episode) REFERENCES clin.episode(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: clin_diag clin_diag_fk_narrative_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_diag
    ADD CONSTRAINT clin_diag_fk_narrative_fkey FOREIGN KEY (fk_narrative) REFERENCES clin.clin_narrative(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: family_history clin_hx_family_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.family_history
    ADD CONSTRAINT clin_hx_family_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: family_history clin_hx_family_fk_episode_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.family_history
    ADD CONSTRAINT clin_hx_family_fk_episode_fkey FOREIGN KEY (fk_episode) REFERENCES clin.episode(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lnk_loinc2test_panel clin_ll2tp_fk_test_panel; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_loinc2test_panel
    ADD CONSTRAINT clin_ll2tp_fk_test_panel FOREIGN KEY (fk_test_panel) REFERENCES clin.test_panel(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: clin_narrative clin_narrative_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_narrative
    ADD CONSTRAINT clin_narrative_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: clin_narrative clin_narrative_fk_episode_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_narrative
    ADD CONSTRAINT clin_narrative_fk_episode_fkey FOREIGN KEY (fk_episode) REFERENCES clin.episode(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: clin_root_item clin_root_item_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_root_item
    ADD CONSTRAINT clin_root_item_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: clin_root_item clin_root_item_fk_episode_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.clin_root_item
    ADD CONSTRAINT clin_root_item_fk_episode_fkey FOREIGN KEY (fk_episode) REFERENCES clin.episode(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: substance_intake clin_substance_intake_fk_drug_component; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.substance_intake
    ADD CONSTRAINT clin_substance_intake_fk_drug_component FOREIGN KEY (fk_drug_component) REFERENCES ref.lnk_dose2drug(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: encounter encounter_fk_location_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.encounter
    ADD CONSTRAINT encounter_fk_location_fkey FOREIGN KEY (fk_location) REFERENCES dem.org_unit(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: encounter encounter_fk_type_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.encounter
    ADD CONSTRAINT encounter_fk_type_fkey FOREIGN KEY (fk_type) REFERENCES clin.encounter_type(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: episode episode_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.episode
    ADD CONSTRAINT episode_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: episode episode_fk_health_issue_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.episode
    ADD CONSTRAINT episode_fk_health_issue_fkey FOREIGN KEY (fk_health_issue) REFERENCES clin.health_issue(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: family_history family_history_fk_relation_type_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.family_history
    ADD CONSTRAINT family_history_fk_relation_type_fkey FOREIGN KEY (fk_relation_type) REFERENCES clin.fhx_relation_type(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: encounter fk_clin_encounter_fk_patient; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.encounter
    ADD CONSTRAINT fk_clin_encounter_fk_patient FOREIGN KEY (fk_patient) REFERENCES clin.patient(fk_identity) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: export_item fk_clin_export_item_fk_doc_obj; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.export_item
    ADD CONSTRAINT fk_clin_export_item_fk_doc_obj FOREIGN KEY (fk_doc_obj) REFERENCES blobs.doc_obj(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: export_item fk_clin_export_item_fk_identity; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.export_item
    ADD CONSTRAINT fk_clin_export_item_fk_identity FOREIGN KEY (fk_identity) REFERENCES clin.patient(fk_identity) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: external_care fk_clin_ext_care_fk_health_issue; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.external_care
    ADD CONSTRAINT fk_clin_ext_care_fk_health_issue FOREIGN KEY (fk_health_issue) REFERENCES clin.health_issue(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: external_care fk_clin_ext_care_fk_org_unit; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.external_care
    ADD CONSTRAINT fk_clin_ext_care_fk_org_unit FOREIGN KEY (fk_org_unit) REFERENCES dem.org_unit(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: external_care fk_clin_external_care_fk_encounter; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.external_care
    ADD CONSTRAINT fk_clin_external_care_fk_encounter FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: patient fk_clin_patient_fk_identity; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.patient
    ADD CONSTRAINT fk_clin_patient_fk_identity FOREIGN KEY (fk_identity) REFERENCES dem.identity(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: suppressed_hint fk_clin_suppressed_hint_fk_encounter; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.suppressed_hint
    ADD CONSTRAINT fk_clin_suppressed_hint_fk_encounter FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: suppressed_hint fk_clin_suppressed_hint_fk_hint; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.suppressed_hint
    ADD CONSTRAINT fk_clin_suppressed_hint_fk_hint FOREIGN KEY (fk_hint) REFERENCES ref.auto_hint(pk) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- Name: incoming_data_unmatched fk_incoming_data_unmatched_fk_identity_disambiguated; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.incoming_data_unmatched
    ADD CONSTRAINT fk_incoming_data_unmatched_fk_identity_disambiguated FOREIGN KEY (fk_identity_disambiguated) REFERENCES clin.patient(fk_identity) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lnk_pat2vaccination_course fk_lnk_pat2vaccination_course_fk_patient; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_pat2vaccination_course
    ADD CONSTRAINT fk_lnk_pat2vaccination_course_fk_patient FOREIGN KEY (fk_patient) REFERENCES clin.patient(fk_identity) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: form_data form_data_fk_form_field_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_data
    ADD CONSTRAINT form_data_fk_form_field_fkey FOREIGN KEY (fk_form_field) REFERENCES public.form_fields(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: form_data form_data_fk_instance_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_data
    ADD CONSTRAINT form_data_fk_instance_fkey FOREIGN KEY (fk_instance) REFERENCES clin.form_instances(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: form_instances form_instances_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_instances
    ADD CONSTRAINT form_instances_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: form_instances form_instances_fk_episode_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_instances
    ADD CONSTRAINT form_instances_fk_episode_fkey FOREIGN KEY (fk_episode) REFERENCES clin.episode(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: form_instances form_instances_fk_form_def_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.form_instances
    ADD CONSTRAINT form_instances_fk_form_def_fkey FOREIGN KEY (fk_form_def) REFERENCES ref.paperwork_templates(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: health_issue health_issue_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.health_issue
    ADD CONSTRAINT health_issue_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: hospital_stay hospital_stay_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.hospital_stay
    ADD CONSTRAINT hospital_stay_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: hospital_stay hospital_stay_fk_episode_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.hospital_stay
    ADD CONSTRAINT hospital_stay_fk_episode_fkey FOREIGN KEY (fk_episode) REFERENCES clin.episode(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: hospital_stay hospital_stay_fk_org_unit_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.hospital_stay
    ADD CONSTRAINT hospital_stay_fk_org_unit_fkey FOREIGN KEY (fk_org_unit) REFERENCES dem.org_unit(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: incoming_data_unmatched incoming_data_unmatched_fk_provider_disambiguated_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.incoming_data_unmatched
    ADD CONSTRAINT incoming_data_unmatched_fk_provider_disambiguated_fkey FOREIGN KEY (fk_provider_disambiguated) REFERENCES dem.staff(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lab_request lab_request_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lab_request
    ADD CONSTRAINT lab_request_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lab_request lab_request_fk_episode_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lab_request
    ADD CONSTRAINT lab_request_fk_episode_fkey FOREIGN KEY (fk_episode) REFERENCES clin.episode(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lab_request lab_request_fk_requestor_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lab_request
    ADD CONSTRAINT lab_request_fk_requestor_fkey FOREIGN KEY (fk_requestor) REFERENCES dem.identity(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lab_request lab_request_fk_test_org_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lab_request
    ADD CONSTRAINT lab_request_fk_test_org_fkey FOREIGN KEY (fk_test_org) REFERENCES clin.test_org(pk);


--
-- Name: lnk_code2aoe lnk_code2aoe_fk_item_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2aoe
    ADD CONSTRAINT lnk_code2aoe_fk_item_fkey FOREIGN KEY (fk_item) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: lnk_code2episode lnk_code2episode_fk_item_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2episode
    ADD CONSTRAINT lnk_code2episode_fk_item_fkey FOREIGN KEY (fk_item) REFERENCES clin.episode(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: lnk_code2fhx lnk_code2fhx_fk_item_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2fhx
    ADD CONSTRAINT lnk_code2fhx_fk_item_fkey FOREIGN KEY (fk_item) REFERENCES clin.family_history(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: lnk_code2h_issue lnk_code2h_issue_fk_item_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2h_issue
    ADD CONSTRAINT lnk_code2h_issue_fk_item_fkey FOREIGN KEY (fk_item) REFERENCES clin.health_issue(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: lnk_code2narrative lnk_code2narrative_fk_item_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2narrative
    ADD CONSTRAINT lnk_code2narrative_fk_item_fkey FOREIGN KEY (fk_item) REFERENCES clin.clin_narrative(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: lnk_code2procedure lnk_code2procedure_fk_item_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2procedure
    ADD CONSTRAINT lnk_code2procedure_fk_item_fkey FOREIGN KEY (fk_item) REFERENCES clin.procedure(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: lnk_code2rfe lnk_code2rfe_fk_item_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2rfe
    ADD CONSTRAINT lnk_code2rfe_fk_item_fkey FOREIGN KEY (fk_item) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: lnk_code2tst_pnl lnk_code2tst_pnl_fk_item_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_code2tst_pnl
    ADD CONSTRAINT lnk_code2tst_pnl_fk_item_fkey FOREIGN KEY (fk_item) REFERENCES clin.test_panel(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: lnk_constraint2vacc_course lnk_constraint2vacc_course_fk_constraint_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_constraint2vacc_course
    ADD CONSTRAINT lnk_constraint2vacc_course_fk_constraint_fkey FOREIGN KEY (fk_constraint) REFERENCES clin.vaccination_course_constraint(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: lnk_constraint2vacc_course lnk_constraint2vacc_course_fk_vaccination_course_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_constraint2vacc_course
    ADD CONSTRAINT lnk_constraint2vacc_course_fk_vaccination_course_fkey FOREIGN KEY (fk_vaccination_course) REFERENCES clin.vaccination_course(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: lnk_pat2vaccination_course lnk_pat2vaccination_course_fk_course_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_pat2vaccination_course
    ADD CONSTRAINT lnk_pat2vaccination_course_fk_course_fkey FOREIGN KEY (fk_course) REFERENCES clin.vaccination_course(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lnk_substance2episode lnk_substance2episode_fk_episode_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_substance2episode
    ADD CONSTRAINT lnk_substance2episode_fk_episode_fkey FOREIGN KEY (fk_episode) REFERENCES clin.episode(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lnk_substance2episode lnk_substance2episode_fk_substance_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_substance2episode
    ADD CONSTRAINT lnk_substance2episode_fk_substance_fkey FOREIGN KEY (fk_substance) REFERENCES clin.substance_intake(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lnk_tst2norm lnk_tst2norm_id_test_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_tst2norm
    ADD CONSTRAINT lnk_tst2norm_id_test_fkey FOREIGN KEY (id_test) REFERENCES clin.test_type(pk);


--
-- Name: lnk_type2item lnk_type2item_fk_type_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_type2item
    ADD CONSTRAINT lnk_type2item_fk_type_fkey FOREIGN KEY (fk_type) REFERENCES clin.clin_item_type(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: lnk_vaccination_course2schedule lnk_vaccination_course2schedule_fk_course_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_vaccination_course2schedule
    ADD CONSTRAINT lnk_vaccination_course2schedule_fk_course_fkey FOREIGN KEY (fk_course) REFERENCES clin.vaccination_course(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lnk_vaccination_course2schedule lnk_vaccination_course2schedule_fk_schedule_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.lnk_vaccination_course2schedule
    ADD CONSTRAINT lnk_vaccination_course2schedule_fk_schedule_fkey FOREIGN KEY (fk_schedule) REFERENCES clin.vaccination_schedule(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: procedure procedure_fk_doc_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.procedure
    ADD CONSTRAINT procedure_fk_doc_fkey FOREIGN KEY (fk_doc) REFERENCES blobs.doc_med(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: procedure procedure_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.procedure
    ADD CONSTRAINT procedure_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: procedure procedure_fk_episode_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.procedure
    ADD CONSTRAINT procedure_fk_episode_fkey FOREIGN KEY (fk_episode) REFERENCES clin.episode(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: procedure procedure_fk_hospital_stay_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.procedure
    ADD CONSTRAINT procedure_fk_hospital_stay_fkey FOREIGN KEY (fk_hospital_stay) REFERENCES clin.hospital_stay(pk);


--
-- Name: procedure procedure_fk_org_unit_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.procedure
    ADD CONSTRAINT procedure_fk_org_unit_fkey FOREIGN KEY (fk_org_unit) REFERENCES dem.org_unit(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: review_root review_root_fk_reviewer_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.review_root
    ADD CONSTRAINT review_root_fk_reviewer_fkey FOREIGN KEY (fk_reviewer) REFERENCES dem.staff(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: reviewed_test_results reviewed_test_results_fk_reviewed_row_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.reviewed_test_results
    ADD CONSTRAINT reviewed_test_results_fk_reviewed_row_fkey FOREIGN KEY (fk_reviewed_row) REFERENCES clin.test_result(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: reviewed_test_results reviewed_test_results_fk_reviewer_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.reviewed_test_results
    ADD CONSTRAINT reviewed_test_results_fk_reviewer_fkey FOREIGN KEY (fk_reviewer) REFERENCES dem.staff(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: substance_intake substance_intake_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.substance_intake
    ADD CONSTRAINT substance_intake_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: substance_intake substance_intake_fk_episode_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.substance_intake
    ADD CONSTRAINT substance_intake_fk_episode_fkey FOREIGN KEY (fk_episode) REFERENCES clin.episode(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: test_org test_org_fk_adm_contact_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_org
    ADD CONSTRAINT test_org_fk_adm_contact_fkey FOREIGN KEY (fk_adm_contact) REFERENCES dem.identity(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: test_org test_org_fk_med_contact_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_org
    ADD CONSTRAINT test_org_fk_med_contact_fkey FOREIGN KEY (fk_med_contact) REFERENCES dem.identity(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: test_org test_org_fk_org_unit_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_org
    ADD CONSTRAINT test_org_fk_org_unit_fkey FOREIGN KEY (fk_org_unit) REFERENCES dem.org_unit(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: test_result test_result_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_result
    ADD CONSTRAINT test_result_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: test_result test_result_fk_episode_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_result
    ADD CONSTRAINT test_result_fk_episode_fkey FOREIGN KEY (fk_episode) REFERENCES clin.episode(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: test_result test_result_fk_intended_reviewer_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_result
    ADD CONSTRAINT test_result_fk_intended_reviewer_fkey FOREIGN KEY (fk_intended_reviewer) REFERENCES dem.staff(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: test_result test_result_fk_request_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_result
    ADD CONSTRAINT test_result_fk_request_fkey FOREIGN KEY (fk_request) REFERENCES clin.lab_request(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: test_result test_result_fk_type_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_result
    ADD CONSTRAINT test_result_fk_type_fkey FOREIGN KEY (fk_type) REFERENCES clin.test_type(pk);


--
-- Name: test_type test_type_fk_meta_test_type_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_type
    ADD CONSTRAINT test_type_fk_meta_test_type_fkey FOREIGN KEY (fk_meta_test_type) REFERENCES clin.meta_test_type(pk);


--
-- Name: test_type test_type_fk_test_org_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.test_type
    ADD CONSTRAINT test_type_fk_test_org_fkey FOREIGN KEY (fk_test_org) REFERENCES clin.test_org(pk);


--
-- Name: vaccination_definition vaccination_definition_fk_course_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination_definition
    ADD CONSTRAINT vaccination_definition_fk_course_fkey FOREIGN KEY (fk_course) REFERENCES clin.vaccination_course(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: vaccination vaccination_fk_encounter_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination
    ADD CONSTRAINT vaccination_fk_encounter_fkey FOREIGN KEY (fk_encounter) REFERENCES clin.encounter(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: vaccination vaccination_fk_episode_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination
    ADD CONSTRAINT vaccination_fk_episode_fkey FOREIGN KEY (fk_episode) REFERENCES clin.episode(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: vaccination vaccination_fk_provider_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination
    ADD CONSTRAINT vaccination_fk_provider_fkey FOREIGN KEY (fk_provider) REFERENCES dem.staff(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: vaccination vaccination_fk_vaccine_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.vaccination
    ADD CONSTRAINT vaccination_fk_vaccine_fkey FOREIGN KEY (fk_vaccine) REFERENCES ref.vaccine(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: waiting_list waiting_list_fk_patient_fkey; Type: FK CONSTRAINT; Schema: clin; Owner: gm-dbo
--

ALTER TABLE ONLY clin.waiting_list
    ADD CONSTRAINT waiting_list_fk_patient_fkey FOREIGN KEY (fk_patient) REFERENCES dem.identity(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: kvk kvk_fk_patient_fkey; Type: FK CONSTRAINT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.kvk
    ADD CONSTRAINT kvk_fk_patient_fkey FOREIGN KEY (fk_patient) REFERENCES dem.identity(pk);


--
-- Name: lab_test_gnr lab_test_gnr_id_test_fkey; Type: FK CONSTRAINT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.lab_test_gnr
    ADD CONSTRAINT lab_test_gnr_id_test_fkey FOREIGN KEY (id_test) REFERENCES clin.test_type(pk);


--
-- Name: prax_geb_paid prax_geb_paid_paid_with_fkey; Type: FK CONSTRAINT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.prax_geb_paid
    ADD CONSTRAINT prax_geb_paid_paid_with_fkey FOREIGN KEY (paid_with) REFERENCES de_de.payment_method(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: zuzahlungsbefreiung zuzahlungsbefreiung_id_patient_fkey; Type: FK CONSTRAINT; Schema: de_de; Owner: gm-dbo
--

ALTER TABLE ONLY de_de.zuzahlungsbefreiung
    ADD CONSTRAINT zuzahlungsbefreiung_id_patient_fkey FOREIGN KEY (id_patient) REFERENCES dem.identity(pk);


--
-- Name: address address_id_street_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.address
    ADD CONSTRAINT address_id_street_fkey FOREIGN KEY (id_street) REFERENCES dem.street(id) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: urb fk_dem_urb_dem_region_pk; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.urb
    ADD CONSTRAINT fk_dem_urb_dem_region_pk FOREIGN KEY (fk_region) REFERENCES dem.region(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: identity identity_fk_emergency_contact_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity
    ADD CONSTRAINT identity_fk_emergency_contact_fkey FOREIGN KEY (fk_emergency_contact) REFERENCES dem.identity(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: identity identity_fk_marital_status_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity
    ADD CONSTRAINT identity_fk_marital_status_fkey FOREIGN KEY (fk_marital_status) REFERENCES dem.marital_status(pk);


--
-- Name: identity identity_fk_primary_provider_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity
    ADD CONSTRAINT identity_fk_primary_provider_fkey FOREIGN KEY (fk_primary_provider) REFERENCES dem.staff(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: identity identity_gender_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity
    ADD CONSTRAINT identity_gender_fkey FOREIGN KEY (gender) REFERENCES dem.gender_label(tag) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: identity_tag identity_tag_fk_identity_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity_tag
    ADD CONSTRAINT identity_tag_fk_identity_fkey FOREIGN KEY (fk_identity) REFERENCES dem.identity(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: identity_tag identity_tag_fk_tag_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.identity_tag
    ADD CONSTRAINT identity_tag_fk_tag_fkey FOREIGN KEY (fk_tag) REFERENCES ref.tag_image(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: inbox_item_type inbox_item_type_fk_inbox_item_category_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.inbox_item_type
    ADD CONSTRAINT inbox_item_type_fk_inbox_item_category_fkey FOREIGN KEY (fk_inbox_item_category) REFERENCES dem.inbox_item_category(pk);


--
-- Name: lnk_identity2comm lnk_identity2comm_id_address_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_identity2comm
    ADD CONSTRAINT lnk_identity2comm_id_address_fkey FOREIGN KEY (fk_address) REFERENCES dem.address(id) ON UPDATE SET NULL ON DELETE SET NULL;


--
-- Name: lnk_identity2comm lnk_identity2comm_id_identity_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_identity2comm
    ADD CONSTRAINT lnk_identity2comm_id_identity_fkey FOREIGN KEY (fk_identity) REFERENCES dem.identity(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: lnk_identity2comm lnk_identity2comm_id_type_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_identity2comm
    ADD CONSTRAINT lnk_identity2comm_id_type_fkey FOREIGN KEY (fk_type) REFERENCES dem.enum_comm_types(pk);


--
-- Name: lnk_identity2ext_id lnk_identity2ext_id_fk_origin_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_identity2ext_id
    ADD CONSTRAINT lnk_identity2ext_id_fk_origin_fkey FOREIGN KEY (fk_origin) REFERENCES dem.enum_ext_id_types(pk);


--
-- Name: lnk_identity2ext_id lnk_identity2ext_id_id_identity_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_identity2ext_id
    ADD CONSTRAINT lnk_identity2ext_id_id_identity_fkey FOREIGN KEY (id_identity) REFERENCES dem.identity(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: lnk_job2person lnk_job2person_fk_identity_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_job2person
    ADD CONSTRAINT lnk_job2person_fk_identity_fkey FOREIGN KEY (fk_identity) REFERENCES dem.identity(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: lnk_job2person lnk_job2person_fk_occupation_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_job2person
    ADD CONSTRAINT lnk_job2person_fk_occupation_fkey FOREIGN KEY (fk_occupation) REFERENCES dem.occupation(id) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lnk_org_unit2comm lnk_org_unit2comm_fk_org_unit_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2comm
    ADD CONSTRAINT lnk_org_unit2comm_fk_org_unit_fkey FOREIGN KEY (fk_org_unit) REFERENCES dem.org_unit(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lnk_org_unit2comm lnk_org_unit2comm_fk_type_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2comm
    ADD CONSTRAINT lnk_org_unit2comm_fk_type_fkey FOREIGN KEY (fk_type) REFERENCES dem.enum_comm_types(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lnk_org_unit2ext_id lnk_org_unit2ext_id_fk_org_unit_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2ext_id
    ADD CONSTRAINT lnk_org_unit2ext_id_fk_org_unit_fkey FOREIGN KEY (fk_org_unit) REFERENCES dem.org_unit(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lnk_org_unit2ext_id lnk_org_unit2ext_id_fk_type_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_org_unit2ext_id
    ADD CONSTRAINT lnk_org_unit2ext_id_fk_type_fkey FOREIGN KEY (fk_type) REFERENCES dem.enum_ext_id_types(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lnk_person2relative lnk_person2relative_id_identity_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_person2relative
    ADD CONSTRAINT lnk_person2relative_id_identity_fkey FOREIGN KEY (id_identity) REFERENCES dem.identity(pk);


--
-- Name: lnk_person2relative lnk_person2relative_id_relation_type_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_person2relative
    ADD CONSTRAINT lnk_person2relative_id_relation_type_fkey FOREIGN KEY (id_relation_type) REFERENCES dem.relation_types(id);


--
-- Name: lnk_person2relative lnk_person2relative_id_relative_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_person2relative
    ADD CONSTRAINT lnk_person2relative_id_relative_fkey FOREIGN KEY (id_relative) REFERENCES dem.identity(pk);


--
-- Name: lnk_person_org_address lnk_person_org_address_id_address_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_person_org_address
    ADD CONSTRAINT lnk_person_org_address_id_address_fkey FOREIGN KEY (id_address) REFERENCES dem.address(id);


--
-- Name: lnk_person_org_address lnk_person_org_address_id_identity_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_person_org_address
    ADD CONSTRAINT lnk_person_org_address_id_identity_fkey FOREIGN KEY (id_identity) REFERENCES dem.identity(pk);


--
-- Name: lnk_person_org_address lnk_person_org_address_id_type_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.lnk_person_org_address
    ADD CONSTRAINT lnk_person_org_address_id_type_fkey FOREIGN KEY (id_type) REFERENCES dem.address_type(id);


--
-- Name: message_inbox message_inbox_fk_patient_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.message_inbox
    ADD CONSTRAINT message_inbox_fk_patient_fkey FOREIGN KEY (fk_patient) REFERENCES dem.identity(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: names names_id_identity_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.names
    ADD CONSTRAINT names_id_identity_fkey FOREIGN KEY (id_identity) REFERENCES dem.identity(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: org org_fk_category_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org
    ADD CONSTRAINT org_fk_category_fkey FOREIGN KEY (fk_category) REFERENCES dem.org_category(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: org org_fk_data_source_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org
    ADD CONSTRAINT org_fk_data_source_fkey FOREIGN KEY (fk_data_source) REFERENCES ref.data_source(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: org_unit org_unit_fk_address_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org_unit
    ADD CONSTRAINT org_unit_fk_address_fkey FOREIGN KEY (fk_address) REFERENCES dem.address(id) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: org_unit org_unit_fk_category_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org_unit
    ADD CONSTRAINT org_unit_fk_category_fkey FOREIGN KEY (fk_category) REFERENCES dem.org_category(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: org_unit org_unit_fk_org_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.org_unit
    ADD CONSTRAINT org_unit_fk_org_fkey FOREIGN KEY (fk_org) REFERENCES dem.org(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: message_inbox provider_inbox_fk_inbox_item_type_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.message_inbox
    ADD CONSTRAINT provider_inbox_fk_inbox_item_type_fkey FOREIGN KEY (fk_inbox_item_type) REFERENCES dem.inbox_item_type(pk);


--
-- Name: message_inbox provider_inbox_fk_staff_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.message_inbox
    ADD CONSTRAINT provider_inbox_fk_staff_fkey FOREIGN KEY (fk_staff) REFERENCES dem.staff(pk);


--
-- Name: relation_types relation_types_inverse_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.relation_types
    ADD CONSTRAINT relation_types_inverse_fkey FOREIGN KEY (inverse) REFERENCES dem.relation_types(id);


--
-- Name: staff staff_fk_identity_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.staff
    ADD CONSTRAINT staff_fk_identity_fkey FOREIGN KEY (fk_identity) REFERENCES dem.identity(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: region state_country_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.region
    ADD CONSTRAINT state_country_fkey FOREIGN KEY (country) REFERENCES dem.country(code);


--
-- Name: street street_id_urb_fkey; Type: FK CONSTRAINT; Schema: dem; Owner: gm-dbo
--

ALTER TABLE ONLY dem.street
    ADD CONSTRAINT street_id_urb_fkey FOREIGN KEY (id_urb) REFERENCES dem.urb(id) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: form_fields form_fields_fk_form_fkey; Type: FK CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_fields
    ADD CONSTRAINT form_fields_fk_form_fkey FOREIGN KEY (fk_form) REFERENCES ref.paperwork_templates(pk);


--
-- Name: form_fields form_fields_fk_type_fkey; Type: FK CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_fields
    ADD CONSTRAINT form_fields_fk_type_fkey FOREIGN KEY (fk_type) REFERENCES public.form_field_types(pk);


--
-- Name: form_job_queue form_job_queue_fk_form_instance_fkey; Type: FK CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_job_queue
    ADD CONSTRAINT form_job_queue_fk_form_instance_fkey FOREIGN KEY (fk_form_instance) REFERENCES clin.form_instances(pk);


--
-- Name: form_job_queue form_job_queue_fk_job_target_fkey; Type: FK CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_job_queue
    ADD CONSTRAINT form_job_queue_fk_job_target_fkey FOREIGN KEY (fk_job_target) REFERENCES public.form_job_targets(pk);


--
-- Name: form_print_defs form_print_defs_fk_papersize_fkey; Type: FK CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.form_print_defs
    ADD CONSTRAINT form_print_defs_fk_papersize_fkey FOREIGN KEY (fk_papersize) REFERENCES ref.papersizes(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: unit unit_fk_basic_unit_fkey; Type: FK CONSTRAINT; Schema: public; Owner: gm-dbo
--

ALTER TABLE ONLY public.unit
    ADD CONSTRAINT unit_fk_basic_unit_fkey FOREIGN KEY (fk_basic_unit) REFERENCES public.basic_unit(pk);


--
-- Name: atc atc_fk_data_source_fkey; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.atc
    ADD CONSTRAINT atc_fk_data_source_fkey FOREIGN KEY (fk_data_source) REFERENCES ref.data_source(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: billable billable_fk_data_source_fkey; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.billable
    ADD CONSTRAINT billable_fk_data_source_fkey FOREIGN KEY (fk_data_source) REFERENCES ref.data_source(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: drug_product branded_drug_fk_data_source_fkey; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.drug_product
    ADD CONSTRAINT branded_drug_fk_data_source_fkey FOREIGN KEY (fk_data_source) REFERENCES ref.data_source(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: coda coda_fk_data_source_fkey; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.coda
    ADD CONSTRAINT coda_fk_data_source_fkey FOREIGN KEY (fk_data_source) REFERENCES ref.data_source(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: coding_system_root coding_system_root_fk_data_source_fkey; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.coding_system_root
    ADD CONSTRAINT coding_system_root_fk_data_source_fkey FOREIGN KEY (fk_data_source) REFERENCES ref.data_source(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: icd10 icd10_fk_data_source_fkey; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icd10
    ADD CONSTRAINT icd10_fk_data_source_fkey FOREIGN KEY (fk_data_source) REFERENCES ref.data_source(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: icd9 icd9_fk_data_source_fkey; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icd9
    ADD CONSTRAINT icd9_fk_data_source_fkey FOREIGN KEY (fk_data_source) REFERENCES ref.data_source(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: icpc icpc_fk_chapter_fkey; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc
    ADD CONSTRAINT icpc_fk_chapter_fkey FOREIGN KEY (fk_chapter) REFERENCES ref.icpc_chapter(chapter) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: icpc icpc_fk_component_fkey; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc
    ADD CONSTRAINT icpc_fk_component_fkey FOREIGN KEY (fk_component) REFERENCES ref.icpc_component(component) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: icpc icpc_fk_data_source_fkey; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc
    ADD CONSTRAINT icpc_fk_data_source_fkey FOREIGN KEY (fk_data_source) REFERENCES ref.data_source(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: icpc_thesaurus icpc_thesaurus_fk_code_fkey; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.icpc_thesaurus
    ADD CONSTRAINT icpc_thesaurus_fk_code_fkey FOREIGN KEY (fk_code) REFERENCES ref.icpc(pk_coding_system) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: keyword_expansion keyword_expansion_fk_staff_fkey; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.keyword_expansion
    ADD CONSTRAINT keyword_expansion_fk_staff_fkey FOREIGN KEY (fk_staff) REFERENCES dem.staff(pk);


--
-- Name: loinc loinc_fk_data_source_fkey; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.loinc
    ADD CONSTRAINT loinc_fk_data_source_fkey FOREIGN KEY (fk_data_source) REFERENCES ref.data_source(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: ops ops_fk_data_source_fkey; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.ops
    ADD CONSTRAINT ops_fk_data_source_fkey FOREIGN KEY (fk_data_source) REFERENCES ref.data_source(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: other_code other_code_fk_data_source_fkey; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.other_code
    ADD CONSTRAINT other_code_fk_data_source_fkey FOREIGN KEY (fk_data_source) REFERENCES ref.data_source(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: paperwork_templates paperwork_templates_fk_template_type_fkey; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.paperwork_templates
    ADD CONSTRAINT paperwork_templates_fk_template_type_fkey FOREIGN KEY (fk_template_type) REFERENCES ref.form_types(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: dose ref_dose_fk_substance; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.dose
    ADD CONSTRAINT ref_dose_fk_substance FOREIGN KEY (fk_substance) REFERENCES ref.substance(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lnk_dose2drug ref_ld2d_fk_dose; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.lnk_dose2drug
    ADD CONSTRAINT ref_ld2d_fk_dose FOREIGN KEY (fk_dose) REFERENCES ref.dose(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lnk_dose2drug ref_ld2d_fk_drug_product; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.lnk_dose2drug
    ADD CONSTRAINT ref_ld2d_fk_drug_product FOREIGN KEY (fk_drug_product) REFERENCES ref.drug_product(pk) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: lnk_loinc2substance ref_ll2s_fk_substance; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.lnk_loinc2substance
    ADD CONSTRAINT ref_ll2s_fk_substance FOREIGN KEY (fk_substance) REFERENCES ref.substance(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: vaccine ref_vaccine_fk_drug_product; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.vaccine
    ADD CONSTRAINT ref_vaccine_fk_drug_product FOREIGN KEY (fk_drug_product) REFERENCES ref.drug_product(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: vaccine vaccine_id_route_fkey; Type: FK CONSTRAINT; Schema: ref; Owner: gm-dbo
--

ALTER TABLE ONLY ref.vaccine
    ADD CONSTRAINT vaccine_id_route_fkey FOREIGN KEY (id_route) REFERENCES ref.vacc_route(id);


--
-- Name: lab_request lab_request_fk_test_org_fkey; Type: FK CONSTRAINT; Schema: staging; Owner: gm-dbo
--

ALTER TABLE ONLY staging.lab_request
    ADD CONSTRAINT lab_request_fk_test_org_fkey FOREIGN KEY (fk_test_org) REFERENCES clin.test_org(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: lnk_vacc_ind2subst_dose lnk_vacc_ind2subst_dose_fk_dose_fkey; Type: FK CONSTRAINT; Schema: staging; Owner: gm-dbo
--

ALTER TABLE ONLY staging.lnk_vacc_ind2subst_dose
    ADD CONSTRAINT lnk_vacc_ind2subst_dose_fk_dose_fkey FOREIGN KEY (fk_dose) REFERENCES ref.dose(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: test_result test_result_fk_request_fkey; Type: FK CONSTRAINT; Schema: staging; Owner: gm-dbo
--

ALTER TABLE ONLY staging.test_result
    ADD CONSTRAINT test_result_fk_request_fkey FOREIGN KEY (fk_request) REFERENCES staging.lab_request(pk) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: SCHEMA au; Type: ACL; Schema: -; Owner: gm-dbo
--

GRANT USAGE ON SCHEMA au TO "gm-doctors";


--
-- Name: SCHEMA audit; Type: ACL; Schema: -; Owner: gm-dbo
--

GRANT USAGE ON SCHEMA audit TO "gm-doctors";


--
-- Name: SCHEMA bill; Type: ACL; Schema: -; Owner: gm-dbo
--

GRANT USAGE ON SCHEMA bill TO "gm-doctors";


--
-- Name: SCHEMA blobs; Type: ACL; Schema: -; Owner: gm-dbo
--

GRANT USAGE ON SCHEMA blobs TO "gm-doctors";
GRANT USAGE ON SCHEMA blobs TO "gm-staff";


--
-- Name: SCHEMA cfg; Type: ACL; Schema: -; Owner: gm-dbo
--

GRANT USAGE ON SCHEMA cfg TO "gm-doctors";
GRANT USAGE ON SCHEMA cfg TO "gm-staff";


--
-- Name: SCHEMA clin; Type: ACL; Schema: -; Owner: gm-dbo
--

GRANT USAGE ON SCHEMA clin TO "gm-doctors";
GRANT USAGE ON SCHEMA clin TO "gm-staff";


--
-- Name: SCHEMA de_de; Type: ACL; Schema: -; Owner: gm-dbo
--

GRANT USAGE ON SCHEMA de_de TO "gm-doctors";


--
-- Name: SCHEMA dem; Type: ACL; Schema: -; Owner: gm-dbo
--

GRANT USAGE ON SCHEMA dem TO "gm-doctors";
GRANT USAGE ON SCHEMA dem TO "gm-staff";


--
-- Name: SCHEMA gm; Type: ACL; Schema: -; Owner: gm-dbo
--

GRANT USAGE ON SCHEMA gm TO "gm-doctors";
GRANT USAGE ON SCHEMA gm TO "gm-staff";


--
-- Name: SCHEMA i18n; Type: ACL; Schema: -; Owner: gm-dbo
--

GRANT USAGE ON SCHEMA i18n TO "gm-public";


--
-- Name: SCHEMA pgtrgm; Type: ACL; Schema: -; Owner: postgres
--

GRANT USAGE ON SCHEMA pgtrgm TO "gm-dbo";


--
-- Name: SCHEMA ref; Type: ACL; Schema: -; Owner: gm-dbo
--

GRANT USAGE ON SCHEMA ref TO "gm-doctors";
GRANT USAGE ON SCHEMA ref TO "gm-staff";


--
-- Name: SCHEMA staging; Type: ACL; Schema: -; Owner: gm-dbo
--

GRANT USAGE ON SCHEMA staging TO "gm-doctors";


--
-- Name: FUNCTION get_dob(integer); Type: ACL; Schema: clin; Owner: gm-dbo
--

REVOKE ALL ON FUNCTION clin.get_dob(integer) FROM PUBLIC;
GRANT ALL ON FUNCTION clin.get_dob(integer) TO "gm-public";


--
-- Name: FUNCTION get_dod(integer); Type: ACL; Schema: clin; Owner: gm-dbo
--

REVOKE ALL ON FUNCTION clin.get_dod(integer) FROM PUBLIC;
GRANT ALL ON FUNCTION clin.get_dod(integer) TO "gm-public";


--
-- Name: FUNCTION is_null_or_non_empty_string(text); Type: ACL; Schema: gm; Owner: gm-dbo
--

GRANT ALL ON FUNCTION gm.is_null_or_non_empty_string(text) TO "gm-public";


--
-- Name: TABLE audit_fields; Type: ACL; Schema: audit; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE audit.audit_fields TO "gm-doctors";


--
-- Name: TABLE auto_hint; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.auto_hint TO "gm-public";


--
-- Name: TABLE v_auto_hints; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_auto_hints TO "gm-staff";


--
-- Name: FUNCTION remove_old_empty_encounters(integer); Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT ALL ON FUNCTION clin.remove_old_empty_encounters(integer) TO "gm-staff";


--
-- Name: FUNCTION remove_old_empty_encounters(integer, interval); Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT ALL ON FUNCTION clin.remove_old_empty_encounters(integer, interval) TO "gm-staff";


--
-- Name: FUNCTION add_user_to_permission_group(name, name); Type: ACL; Schema: gm; Owner: gm-dbo
--

REVOKE ALL ON FUNCTION gm.add_user_to_permission_group(name, name) FROM PUBLIC;


--
-- Name: FUNCTION create_user(name, text); Type: ACL; Schema: gm; Owner: gm-dbo
--

REVOKE ALL ON FUNCTION gm.create_user(name, text) FROM PUBLIC;


--
-- Name: FUNCTION disable_user(name); Type: ACL; Schema: gm; Owner: gm-dbo
--

REVOKE ALL ON FUNCTION gm.disable_user(name) FROM PUBLIC;


--
-- Name: FUNCTION drop_user(name); Type: ACL; Schema: gm; Owner: gm-dbo
--

REVOKE ALL ON FUNCTION gm.drop_user(name) FROM PUBLIC;


--
-- Name: FUNCTION get_users(); Type: ACL; Schema: gm; Owner: gm-dbo
--

REVOKE ALL ON FUNCTION gm.get_users() FROM PUBLIC;


--
-- Name: FUNCTION get_users(name); Type: ACL; Schema: gm; Owner: gm-dbo
--

REVOKE ALL ON FUNCTION gm.get_users(name) FROM PUBLIC;


--
-- Name: FUNCTION log_access2emr(text); Type: ACL; Schema: gm; Owner: gm-dbo
--

GRANT ALL ON FUNCTION gm.log_access2emr(text) TO "gm-public";
GRANT ALL ON FUNCTION gm.log_access2emr(text) TO "gm-staff";


--
-- Name: FUNCTION log_other_access(text); Type: ACL; Schema: gm; Owner: gm-dbo
--

GRANT ALL ON FUNCTION gm.log_other_access(text) TO "gm-public";


--
-- Name: FUNCTION nullify_empty_string(text); Type: ACL; Schema: gm; Owner: gm-dbo
--

GRANT ALL ON FUNCTION gm.nullify_empty_string(text) TO "gm-public";


--
-- Name: FUNCTION transfer_users(text); Type: ACL; Schema: gm; Owner: gm-dbo
--

REVOKE ALL ON FUNCTION gm.transfer_users(text) FROM PUBLIC;


--
-- Name: FUNCTION transfer_users(text, text); Type: ACL; Schema: gm; Owner: gm-dbo
--

REVOKE ALL ON FUNCTION gm.transfer_users(text, text) FROM PUBLIC;


--
-- Name: TABLE clin_root_item; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.clin_root_item TO "gm-doctors";


--
-- Name: TABLE referral; Type: ACL; Schema: au; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE au.referral TO "gm-doctors";


--
-- Name: SEQUENCE audit_fields_pk_audit_seq; Type: ACL; Schema: audit; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE audit.audit_fields_pk_audit_seq TO "gm-doctors";
GRANT USAGE ON SEQUENCE audit.audit_fields_pk_audit_seq TO "gm-staff";


--
-- Name: TABLE audit_trail; Type: ACL; Schema: audit; Owner: gm-dbo
--

GRANT SELECT ON TABLE audit.audit_trail TO "gm-doctors";


--
-- Name: SEQUENCE audit_trail_pk_audit_seq; Type: ACL; Schema: audit; Owner: gm-dbo
--

GRANT SELECT ON SEQUENCE audit.audit_trail_pk_audit_seq TO "gm-doctors";


--
-- Name: COLUMN log_bill.invoice_id; Type: ACL; Schema: audit; Owner: gm-dbo
--

GRANT SELECT(invoice_id) ON TABLE audit.log_bill TO "gm-doctors";


--
-- Name: TABLE log_clin_narrative; Type: ACL; Schema: audit; Owner: gm-dbo
--

GRANT SELECT ON TABLE audit.log_clin_narrative TO "gm-doctors";


--
-- Name: TABLE log_consumed_substance; Type: ACL; Schema: audit; Owner: gm-dbo
--

GRANT SELECT ON TABLE audit.log_consumed_substance TO "gm-doctors";


--
-- Name: TABLE log_encounter; Type: ACL; Schema: audit; Owner: gm-dbo
--

GRANT SELECT ON TABLE audit.log_encounter TO "gm-doctors";


--
-- Name: TABLE log_episode; Type: ACL; Schema: audit; Owner: gm-dbo
--

GRANT SELECT ON TABLE audit.log_episode TO "gm-doctors";


--
-- Name: TABLE log_health_issue; Type: ACL; Schema: audit; Owner: gm-dbo
--

GRANT SELECT ON TABLE audit.log_health_issue TO "gm-doctors";


--
-- Name: TABLE staff; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.staff TO "gm-doctors";
GRANT SELECT ON TABLE dem.staff TO "gm-staff";


--
-- Name: TABLE access_log; Type: ACL; Schema: gm; Owner: gm-dbo
--

GRANT INSERT ON TABLE gm.access_log TO "gm-public";


--
-- Name: TABLE v_audit_trail; Type: ACL; Schema: audit; Owner: gm-dbo
--

GRANT SELECT ON TABLE audit.v_audit_trail TO "gm-doctors";


--
-- Name: TABLE bill; Type: ACL; Schema: bill; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE bill.bill TO "gm-doctors";
GRANT SELECT ON TABLE bill.bill TO "gm-public";


--
-- Name: TABLE bill_item; Type: ACL; Schema: bill; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE bill.bill_item TO "gm-doctors";
GRANT SELECT ON TABLE bill.bill_item TO "gm-public";


--
-- Name: SEQUENCE bill_item_pk_seq; Type: ACL; Schema: bill; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE bill.bill_item_pk_seq TO "gm-doctors";
GRANT USAGE ON SEQUENCE bill.bill_item_pk_seq TO "gm-public";


--
-- Name: SEQUENCE bill_pk_seq; Type: ACL; Schema: bill; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE bill.bill_pk_seq TO "gm-public";


--
-- Name: TABLE lnk_enc_type2billable; Type: ACL; Schema: bill; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE bill.lnk_enc_type2billable TO "gm-doctors";
GRANT SELECT ON TABLE bill.lnk_enc_type2billable TO "gm-public";


--
-- Name: SEQUENCE lnk_enc_type2billable_pk_seq; Type: ACL; Schema: bill; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE bill.lnk_enc_type2billable_pk_seq TO "gm-public";


--
-- Name: TABLE encounter; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.encounter TO "gm-doctors";
GRANT SELECT,UPDATE ON TABLE clin.encounter TO "gm-staff";


--
-- Name: COLUMN encounter.fk_patient; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT INSERT(fk_patient) ON TABLE clin.encounter TO "gm-staff";


--
-- Name: COLUMN encounter.fk_type; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT INSERT(fk_type) ON TABLE clin.encounter TO "gm-staff";


--
-- Name: COLUMN encounter.fk_location; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT INSERT(fk_location) ON TABLE clin.encounter TO "gm-staff";


--
-- Name: TABLE coding_system_root; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE ref.coding_system_root TO "gm-doctors";


--
-- Name: TABLE billable; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.billable TO "gm-public";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE ref.billable TO "gm-doctors";


--
-- Name: TABLE data_source; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE ref.data_source TO "gm-doctors";


--
-- Name: TABLE v_bill_items; Type: ACL; Schema: bill; Owner: gm-dbo
--

GRANT SELECT ON TABLE bill.v_bill_items TO "gm-doctors";


--
-- Name: TABLE v_bills; Type: ACL; Schema: bill; Owner: gm-dbo
--

GRANT SELECT ON TABLE bill.v_bills TO "gm-doctors";


--
-- Name: TABLE doc_desc; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE blobs.doc_desc TO "gm-doctors";


--
-- Name: SEQUENCE doc_desc_pk_seq; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE blobs.doc_desc_pk_seq TO "gm-doctors";


--
-- Name: TABLE doc_med; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT,INSERT,UPDATE ON TABLE blobs.doc_med TO "gm-doctors";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE blobs.doc_med TO "gm-staff";


--
-- Name: SEQUENCE doc_med_pk_seq; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE blobs.doc_med_pk_seq TO "gm-doctors";


--
-- Name: TABLE doc_obj; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE blobs.doc_obj TO "gm-doctors";
GRANT SELECT ON TABLE blobs.doc_obj TO "gm-staff";


--
-- Name: SEQUENCE doc_obj_pk_seq; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE blobs.doc_obj_pk_seq TO "gm-doctors";


--
-- Name: TABLE doc_type; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT INSERT,DELETE,UPDATE ON TABLE blobs.doc_type TO "gm-doctors";
GRANT SELECT ON TABLE blobs.doc_type TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE blobs.doc_type TO "gm-staff";


--
-- Name: SEQUENCE doc_type_pk_seq; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE blobs.doc_type_pk_seq TO "gm-doctors";


--
-- Name: TABLE lnk_doc_med2episode; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE blobs.lnk_doc_med2episode TO "gm-doctors";


--
-- Name: TABLE review_root; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.review_root TO "gm-doctors";


--
-- Name: TABLE reviewed_doc_objs; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE blobs.reviewed_doc_objs TO "gm-doctors";


--
-- Name: TABLE episode; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.episode TO "gm-doctors";


--
-- Name: TABLE health_issue; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.health_issue TO "gm-doctors";


--
-- Name: TABLE org; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.org TO "gm-doctors";


--
-- Name: TABLE org_unit; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.org_unit TO "gm-doctors";


--
-- Name: TABLE v_doc_med; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT ON TABLE blobs.v_doc_med TO "gm-doctors";


--
-- Name: TABLE v_doc_desc; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT ON TABLE blobs.v_doc_desc TO "gm-doctors";


--
-- Name: TABLE encounter_type; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.encounter_type TO "gm-doctors";
GRANT SELECT ON TABLE clin.encounter_type TO "gm-staff";


--
-- Name: TABLE v_doc_med_journal; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT ON TABLE blobs.v_doc_med_journal TO "gm-doctors";


--
-- Name: TABLE document_type; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE ref.document_type TO "gm-doctors";


--
-- Name: TABLE v_doc_type; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT ON TABLE blobs.v_doc_type TO "gm-public";


--
-- Name: TABLE v_obj4doc_no_data; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT ON TABLE blobs.v_obj4doc_no_data TO "gm-doctors";


--
-- Name: TABLE v_latest_mugshot; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT ON TABLE blobs.v_latest_mugshot TO "gm-doctors";


--
-- Name: TABLE v_reviewed_doc_objects; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT ON TABLE blobs.v_reviewed_doc_objects TO "gm-doctors";


--
-- Name: TABLE v_unreviewed_docs; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT ON TABLE blobs.v_unreviewed_docs TO "gm-staff";


--
-- Name: TABLE v_unreviewed_docs_summary; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT ON TABLE blobs.v_unreviewed_docs_summary TO "gm-staff";


--
-- Name: TABLE inbox_item_category; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.inbox_item_category TO "gm-public";


--
-- Name: TABLE inbox_item_type; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.inbox_item_type TO "gm-doctors";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.inbox_item_type TO "gm-public";


--
-- Name: TABLE names; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.names TO "gm-doctors";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.names TO "gm-staff";


--
-- Name: TABLE v_inbox_item_type; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_inbox_item_type TO "gm-public";


--
-- Name: TABLE v_unreviewed_docs_inbox; Type: ACL; Schema: blobs; Owner: gm-dbo
--

GRANT SELECT ON TABLE blobs.v_unreviewed_docs_inbox TO "gm-staff";


--
-- Name: TABLE cfg_data; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT ON TABLE cfg.cfg_data TO "gm-public";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE cfg.cfg_data TO "gm-doctors";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE cfg.cfg_data TO "gm-staff";


--
-- Name: TABLE cfg_item; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT ON TABLE cfg.cfg_item TO "gm-public";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE cfg.cfg_item TO "gm-doctors";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE cfg.cfg_item TO "gm-staff";


--
-- Name: SEQUENCE cfg_item_pk_seq; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE cfg.cfg_item_pk_seq TO "gm-doctors";
GRANT USAGE ON SEQUENCE cfg.cfg_item_pk_seq TO "gm-staff";


--
-- Name: TABLE cfg_numeric; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT ON TABLE cfg.cfg_numeric TO "gm-public";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE cfg.cfg_numeric TO "gm-doctors";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE cfg.cfg_numeric TO "gm-staff";


--
-- Name: SEQUENCE cfg_numeric_pk_seq; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE cfg.cfg_numeric_pk_seq TO "gm-public";


--
-- Name: TABLE cfg_str_array; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT ON TABLE cfg.cfg_str_array TO "gm-public";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE cfg.cfg_str_array TO "gm-doctors";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE cfg.cfg_str_array TO "gm-staff";


--
-- Name: SEQUENCE cfg_str_array_pk_seq; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE cfg.cfg_str_array_pk_seq TO "gm-public";


--
-- Name: TABLE cfg_string; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT ON TABLE cfg.cfg_string TO "gm-public";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE cfg.cfg_string TO "gm-doctors";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE cfg.cfg_string TO "gm-staff";


--
-- Name: SEQUENCE cfg_string_pk_seq; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE cfg.cfg_string_pk_seq TO "gm-public";


--
-- Name: TABLE cfg_template; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT ON TABLE cfg.cfg_template TO "gm-public";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE cfg.cfg_template TO "gm-doctors";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE cfg.cfg_template TO "gm-staff";


--
-- Name: SEQUENCE cfg_template_pk_seq; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE cfg.cfg_template_pk_seq TO "gm-doctors";
GRANT USAGE ON SEQUENCE cfg.cfg_template_pk_seq TO "gm-staff";


--
-- Name: TABLE cfg_type_enum; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT ON TABLE cfg.cfg_type_enum TO "gm-public";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE cfg.cfg_type_enum TO "gm-doctors";
GRANT SELECT ON TABLE cfg.cfg_type_enum TO "gm-staff";


--
-- Name: TABLE config; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT ON TABLE cfg.config TO "gm-public";


--
-- Name: TABLE db_logon_banner; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT ON TABLE cfg.db_logon_banner TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE cfg.db_logon_banner TO "gm-doctors";


--
-- Name: TABLE report_query; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE cfg.report_query TO "gm-doctors";


--
-- Name: SEQUENCE report_query_pk_seq; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE cfg.report_query_pk_seq TO "gm-doctors";


--
-- Name: TABLE v_cfg_options; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT ON TABLE cfg.v_cfg_options TO "gm-public";


--
-- Name: TABLE v_cfg_opts_data; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT ON TABLE cfg.v_cfg_opts_data TO "gm-public";


--
-- Name: TABLE v_cfg_opts_numeric; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT ON TABLE cfg.v_cfg_opts_numeric TO "gm-public";


--
-- Name: TABLE v_cfg_opts_str_array; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT ON TABLE cfg.v_cfg_opts_str_array TO "gm-public";


--
-- Name: TABLE v_cfg_opts_string; Type: ACL; Schema: cfg; Owner: gm-dbo
--

GRANT SELECT ON TABLE cfg.v_cfg_opts_string TO "gm-public";


--
-- Name: TABLE _enum_allergy_type; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin._enum_allergy_type TO "gm-doctors";


--
-- Name: SEQUENCE _enum_allergy_type_id_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin._enum_allergy_type_id_seq TO "gm-doctors";


--
-- Name: TABLE allergy; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.allergy TO "gm-doctors";


--
-- Name: TABLE allergy_state; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.allergy_state TO "gm-doctors";
GRANT SELECT ON TABLE clin.allergy_state TO "gm-staff";


--
-- Name: COLUMN allergy_state.has_allergy; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT INSERT(has_allergy) ON TABLE clin.allergy_state TO "gm-staff";


--
-- Name: COLUMN allergy_state.fk_encounter; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT INSERT(fk_encounter) ON TABLE clin.allergy_state TO "gm-staff";


--
-- Name: TABLE clin_narrative; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.clin_narrative TO "gm-doctors";


--
-- Name: TABLE external_care; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.external_care TO "gm-doctors";


--
-- Name: TABLE family_history; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.family_history TO "gm-doctors";


--
-- Name: TABLE fhx_relation_type; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.fhx_relation_type TO "gm-doctors";


--
-- Name: TABLE hospital_stay; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.hospital_stay TO "gm-doctors";


--
-- Name: TABLE lnk_code2item_root; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.lnk_code2item_root TO "gm-public";


--
-- Name: TABLE lnk_code2aoe; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.lnk_code2aoe TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE clin.lnk_code2aoe TO "gm-doctors";


--
-- Name: TABLE lnk_code2episode; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.lnk_code2episode TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE clin.lnk_code2episode TO "gm-doctors";


--
-- Name: TABLE lnk_code2fhx; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.lnk_code2fhx TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE clin.lnk_code2fhx TO "gm-doctors";


--
-- Name: TABLE lnk_code2h_issue; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.lnk_code2h_issue TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE clin.lnk_code2h_issue TO "gm-doctors";


--
-- Name: TABLE lnk_code2procedure; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.lnk_code2procedure TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE clin.lnk_code2procedure TO "gm-doctors";


--
-- Name: TABLE lnk_code2rfe; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.lnk_code2rfe TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE clin.lnk_code2rfe TO "gm-doctors";


--
-- Name: TABLE lnk_loinc2test_panel; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.lnk_loinc2test_panel TO "gm-public";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.lnk_loinc2test_panel TO "gm-doctors";


--
-- Name: TABLE meta_test_type; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.meta_test_type TO "gm-doctors";


--
-- Name: TABLE patient; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.patient TO "gm-doctors";


--
-- Name: TABLE procedure; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.procedure TO "gm-doctors";


--
-- Name: TABLE reviewed_test_results; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,UPDATE ON TABLE clin.reviewed_test_results TO "gm-doctors";


--
-- Name: TABLE substance_intake; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.substance_intake TO "gm-doctors";


--
-- Name: TABLE suppressed_hint; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.suppressed_hint TO "gm-staff";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.suppressed_hint TO "gm-doctors";


--
-- Name: TABLE test_org; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.test_org TO "gm-doctors";


--
-- Name: TABLE test_panel; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.test_panel TO "gm-public";


--
-- Name: TABLE test_result; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.test_result TO "gm-doctors";


--
-- Name: TABLE test_type; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.test_type TO "gm-doctors";


--
-- Name: TABLE v_edc_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_edc_journal TO "gm-doctors";


--
-- Name: TABLE v_external_care_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_external_care_journal TO "gm-doctors";


--
-- Name: TABLE v_family_history_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_family_history_journal TO "gm-doctors";


--
-- Name: TABLE identity; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,UPDATE ON TABLE dem.identity TO "gm-doctors";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.identity TO "gm-staff";


--
-- Name: TABLE v_health_issues_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_health_issues_journal TO "gm-doctors";


--
-- Name: TABLE v_hospital_stays_journal_multi_day_adm; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_hospital_stays_journal_multi_day_adm TO "gm-doctors";


--
-- Name: TABLE v_hospital_stays_journal_multi_day_dis; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_hospital_stays_journal_multi_day_dis TO "gm-doctors";


--
-- Name: TABLE v_hospital_stays_journal_no_discharge; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_hospital_stays_journal_no_discharge TO "gm-doctors";


--
-- Name: TABLE v_hospital_stays_journal_one_day; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_hospital_stays_journal_one_day TO "gm-doctors";


--
-- Name: TABLE v_hospital_stays_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_hospital_stays_journal TO "gm-doctors";


--
-- Name: TABLE v_pat_allergies_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_pat_allergies_journal TO "gm-doctors";


--
-- Name: TABLE v_pat_allergy_state_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_pat_allergy_state_journal TO "gm-doctors";


--
-- Name: TABLE v_pat_encounters_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_pat_encounters_journal TO "gm-doctors";


--
-- Name: TABLE v_pat_episodes_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_pat_episodes_journal TO "gm-doctors";


--
-- Name: TABLE v_pat_narrative_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_pat_narrative_journal TO "gm-doctors";


--
-- Name: TABLE v_procedures_at_hospital_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_procedures_at_hospital_journal TO "gm-doctors";


--
-- Name: TABLE v_procedures_not_at_hospital_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_procedures_not_at_hospital_journal TO "gm-doctors";


--
-- Name: TABLE v_procedures_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_procedures_journal TO "gm-doctors";


--
-- Name: TABLE message_inbox; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.message_inbox TO "gm-doctors";


--
-- Name: TABLE v_reminders_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_reminders_journal TO "gm-doctors";


--
-- Name: TABLE dose; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.dose TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE ref.dose TO "gm-doctors";


--
-- Name: TABLE drug_product; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE ref.drug_product TO "gm-doctors";


--
-- Name: TABLE lnk_dose2drug; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.lnk_dose2drug TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE ref.lnk_dose2drug TO "gm-doctors";


--
-- Name: TABLE substance; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.substance TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE ref.substance TO "gm-doctors";


--
-- Name: TABLE v_substance_intake_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_substance_intake_journal TO "gm-doctors";


--
-- Name: TABLE v_suppressed_hints_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_suppressed_hints_journal TO "gm-doctors";


--
-- Name: TABLE v_test_types4test_panel; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_test_types4test_panel TO "gm-public";


--
-- Name: TABLE v_test_types; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_test_types TO "gm-doctors";


--
-- Name: TABLE v_test_results; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_test_results TO "gm-doctors";


--
-- Name: TABLE v_test_results_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_test_results_journal TO "gm-doctors";


--
-- Name: TABLE vaccination; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.vaccination TO "gm-doctors";


--
-- Name: TABLE vaccine; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE ref.vaccine TO "gm-doctors";


--
-- Name: TABLE v_vaccinations_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_vaccinations_journal TO "gm-doctors";


--
-- Name: TABLE v_emr_journal; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_emr_journal TO "gm-doctors";


--
-- Name: TABLE _view_emr_journal_without_suppressed_hints; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin._view_emr_journal_without_suppressed_hints TO "gm-staff";


--
-- Name: SEQUENCE allergy_id_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.allergy_id_seq TO "gm-doctors";


--
-- Name: SEQUENCE allergy_state_id_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.allergy_state_id_seq TO "gm-doctors";
GRANT USAGE ON SEQUENCE clin.allergy_state_id_seq TO "gm-public";


--
-- Name: TABLE clin_aux_note; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.clin_aux_note TO "gm-doctors";


--
-- Name: SEQUENCE clin_aux_note_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.clin_aux_note_pk_seq TO "gm-doctors";


--
-- Name: TABLE clin_diag; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.clin_diag TO "gm-doctors";


--
-- Name: SEQUENCE clin_diag_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.clin_diag_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE clin_hx_family_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT ALL ON SEQUENCE clin.clin_hx_family_pk_seq TO "gm-doctors";


--
-- Name: TABLE clin_item_type; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.clin_item_type TO "gm-doctors";


--
-- Name: SEQUENCE clin_item_type_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.clin_item_type_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE clin_narrative_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.clin_narrative_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE clin_root_item_pk_item_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.clin_root_item_pk_item_seq TO "gm-doctors";


--
-- Name: SEQUENCE encounter_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.encounter_pk_seq TO "gm-doctors";
GRANT USAGE ON SEQUENCE clin.encounter_pk_seq TO "gm-staff";


--
-- Name: SEQUENCE encounter_type_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.encounter_type_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE episode_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.episode_pk_seq TO "gm-doctors";


--
-- Name: TABLE export_item; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.export_item TO "gm-staff";


--
-- Name: SEQUENCE export_item_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE clin.export_item_pk_seq TO "gm-staff";


--
-- Name: SEQUENCE external_care_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE clin.external_care_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE fhx_relation_type_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE clin.fhx_relation_type_pk_seq TO "gm-doctors";


--
-- Name: TABLE form_data; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.form_data TO "gm-doctors";


--
-- Name: SEQUENCE form_data_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.form_data_pk_seq TO "gm-doctors";


--
-- Name: TABLE form_instances; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.form_instances TO "gm-doctors";


--
-- Name: SEQUENCE form_instances_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.form_instances_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE health_issue_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.health_issue_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE hospital_stay_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT ALL ON SEQUENCE clin.hospital_stay_pk_seq TO "gm-doctors";


--
-- Name: TABLE incoming_data_unmatchable; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.incoming_data_unmatchable TO "gm-doctors";


--
-- Name: SEQUENCE incoming_data_unmatchable_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT ALL ON SEQUENCE clin.incoming_data_unmatchable_pk_seq TO "gm-doctors";


--
-- Name: TABLE incoming_data_unmatched; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.incoming_data_unmatched TO "gm-doctors";


--
-- Name: SEQUENCE incoming_data_unmatched_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.incoming_data_unmatched_pk_seq TO "gm-doctors";


--
-- Name: TABLE lab_request; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.lab_request TO "gm-doctors";


--
-- Name: SEQUENCE lab_request_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.lab_request_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE lnk_code2aoe_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE clin.lnk_code2aoe_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE lnk_code2episode_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE clin.lnk_code2episode_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE lnk_code2fhx_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE clin.lnk_code2fhx_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE lnk_code2h_issue_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE clin.lnk_code2h_issue_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE lnk_code2item_root_pk_lnk_code2item_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE clin.lnk_code2item_root_pk_lnk_code2item_seq TO "gm-public";


--
-- Name: TABLE lnk_code2narrative; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.lnk_code2narrative TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE clin.lnk_code2narrative TO "gm-doctors";


--
-- Name: SEQUENCE lnk_code2narrative_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE clin.lnk_code2narrative_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE lnk_code2procedure_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE clin.lnk_code2procedure_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE lnk_code2rfe_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE clin.lnk_code2rfe_pk_seq TO "gm-doctors";


--
-- Name: TABLE lnk_code2tst_pnl; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.lnk_code2tst_pnl TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE clin.lnk_code2tst_pnl TO "gm-doctors";


--
-- Name: SEQUENCE lnk_code2tst_pnl_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE clin.lnk_code2tst_pnl_pk_seq TO "gm-doctors";


--
-- Name: TABLE lnk_constraint2vacc_course; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.lnk_constraint2vacc_course TO "gm-doctors";


--
-- Name: SEQUENCE lnk_constraint2vacc_course_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.lnk_constraint2vacc_course_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE lnk_loinc2test_panel_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE clin.lnk_loinc2test_panel_pk_seq TO "gm-doctors";


--
-- Name: TABLE lnk_pat2vaccination_course; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.lnk_pat2vaccination_course TO "gm-doctors";


--
-- Name: SEQUENCE lnk_pat2vaccination_course_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.lnk_pat2vaccination_course_pk_seq TO "gm-doctors";


--
-- Name: TABLE lnk_substance2episode; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.lnk_substance2episode TO "gm-doctors";


--
-- Name: SEQUENCE lnk_substance2episode_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT ALL ON SEQUENCE clin.lnk_substance2episode_pk_seq TO "gm-doctors";


--
-- Name: TABLE lnk_tst2norm; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.lnk_tst2norm TO "gm-doctors";


--
-- Name: SEQUENCE lnk_tst2norm_id_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.lnk_tst2norm_id_seq TO "gm-doctors";


--
-- Name: TABLE lnk_type2item; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.lnk_type2item TO "gm-doctors";


--
-- Name: SEQUENCE lnk_type2item_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.lnk_type2item_pk_seq TO "gm-doctors";


--
-- Name: TABLE lnk_vaccination_course2schedule; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.lnk_vaccination_course2schedule TO "gm-doctors";


--
-- Name: SEQUENCE lnk_vaccination_course2schedule_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.lnk_vaccination_course2schedule_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE patient_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE clin.patient_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE procedure_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT ALL ON SEQUENCE clin.procedure_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE review_root_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.review_root_pk_seq TO "gm-doctors";


--
-- Name: TABLE soap_cat_ranks; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.soap_cat_ranks TO "gm-doctors";


--
-- Name: SEQUENCE substance_intake_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.substance_intake_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE suppressed_hint_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE clin.suppressed_hint_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE test_org_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.test_org_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE test_panel_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE clin.test_panel_pk_seq TO "gm-public";


--
-- Name: SEQUENCE test_result_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.test_result_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE test_type_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.test_type_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE test_type_unified_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.test_type_unified_pk_seq TO "gm-doctors";


--
-- Name: TABLE v_candidate_diagnoses; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_candidate_diagnoses TO "gm-doctors";


--
-- Name: TABLE marital_status; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.marital_status TO "gm-doctors";


--
-- Name: TABLE v_all_persons; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_all_persons TO "gm-public";


--
-- Name: TABLE v_export_items; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_export_items TO "gm-staff";


--
-- Name: TABLE v_external_care; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_external_care TO "gm-doctors";


--
-- Name: TABLE v_family_history; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_family_history TO "gm-doctors";


--
-- Name: TABLE v_health_issues; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_health_issues TO "gm-doctors";


--
-- Name: TABLE v_hospital_stays; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_hospital_stays TO "gm-doctors";


--
-- Name: TABLE v_incoming_data_unmatched; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_incoming_data_unmatched TO "gm-doctors";


--
-- Name: TABLE v_linked_codes; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_linked_codes TO "gm-public";


--
-- Name: TABLE v_most_recent_encounters; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_most_recent_encounters TO "gm-doctors";


--
-- Name: COLUMN v_most_recent_encounters.pk_encounter; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT(pk_encounter) ON TABLE clin.v_most_recent_encounters TO "gm-staff";


--
-- Name: COLUMN v_most_recent_encounters.pk_patient; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT(pk_patient) ON TABLE clin.v_most_recent_encounters TO "gm-staff";


--
-- Name: COLUMN v_most_recent_encounters.last_affirmed; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT(last_affirmed) ON TABLE clin.v_most_recent_encounters TO "gm-staff";


--
-- Name: TABLE v_narrative; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_narrative TO "gm-doctors";


--
-- Name: TABLE v_pat_allergies; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_pat_allergies TO "gm-doctors";
GRANT SELECT ON TABLE clin.v_pat_allergies TO "gm-staff";


--
-- Name: TABLE v_pat_allergy_state; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_pat_allergy_state TO "gm-doctors";
GRANT SELECT ON TABLE clin.v_pat_allergy_state TO "gm-staff";


--
-- Name: TABLE v_pat_encounters; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_pat_encounters TO "gm-doctors";


--
-- Name: TABLE v_pat_episodes; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_pat_episodes TO "gm-doctors";


--
-- Name: TABLE v_pat_items; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_pat_items TO "gm-doctors";


--
-- Name: TABLE v_pat_vaccs4indication; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_pat_vaccs4indication TO "gm-doctors";


--
-- Name: TABLE v_pat_last_vacc4indication; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_pat_last_vacc4indication TO "gm-doctors";


--
-- Name: TABLE v_potential_problem_list; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_potential_problem_list TO "gm-doctors";


--
-- Name: TABLE v_problem_list; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_problem_list TO "gm-doctors";


--
-- Name: TABLE v_procedures_at_hospital; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_procedures_at_hospital TO "gm-doctors";


--
-- Name: TABLE v_procedures_not_at_hospital; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_procedures_not_at_hospital TO "gm-doctors";


--
-- Name: TABLE v_procedures; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_procedures TO "gm-doctors";


--
-- Name: TABLE v_reviewed_items; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_reviewed_items TO "gm-doctors";


--
-- Name: TABLE v_subst_intake4narr_search; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_subst_intake4narr_search TO "gm-doctors";


--
-- Name: TABLE lnk_loinc2substance; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.lnk_loinc2substance TO "gm-public";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE ref.lnk_loinc2substance TO "gm-doctors";


--
-- Name: TABLE v_substance_intakes; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_substance_intakes TO "gm-doctors";


--
-- Name: TABLE v_suppressed_hints; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_suppressed_hints TO "gm-doctors";


--
-- Name: TABLE v_test_orgs; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_test_orgs TO "gm-public";


--
-- Name: TABLE v_test_panels; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_test_panels TO "gm-doctors";


--
-- Name: TABLE vaccination_course; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.vaccination_course TO "gm-doctors";


--
-- Name: TABLE vaccination_schedule; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.vaccination_schedule TO "gm-doctors";


--
-- Name: TABLE v_vaccination_courses_in_schedule; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_vaccination_courses_in_schedule TO "gm-doctors";


--
-- Name: TABLE v_vaccinations; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_vaccinations TO "gm-doctors";


--
-- Name: TABLE waiting_list; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.waiting_list TO "gm-doctors";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.waiting_list TO "gm-staff";


--
-- Name: TABLE v_waiting_list; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT ON TABLE clin.v_waiting_list TO "gm-public";


--
-- Name: TABLE vaccination_course_constraint; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.vaccination_course_constraint TO "gm-doctors";


--
-- Name: SEQUENCE vaccination_course_constraint_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.vaccination_course_constraint_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE vaccination_course_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.vaccination_course_pk_seq TO "gm-doctors";


--
-- Name: TABLE vaccination_definition; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE clin.vaccination_definition TO "gm-doctors";


--
-- Name: SEQUENCE vaccination_definition_id_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.vaccination_definition_id_seq TO "gm-doctors";


--
-- Name: SEQUENCE vaccination_id_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.vaccination_id_seq TO "gm-doctors";


--
-- Name: SEQUENCE vaccination_schedule_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.vaccination_schedule_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE waiting_list_pk_seq; Type: ACL; Schema: clin; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE clin.waiting_list_pk_seq TO "gm-doctors";
GRANT USAGE ON SEQUENCE clin.waiting_list_pk_seq TO "gm-public";


--
-- Name: TABLE address; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT INSERT,DELETE,UPDATE ON TABLE dem.address TO "gm-doctors";
GRANT SELECT ON TABLE dem.address TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE dem.address TO "gm-staff";


--
-- Name: SEQUENCE address_id_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE dem.address_id_seq TO "gm-public";


--
-- Name: TABLE address_type; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT INSERT,DELETE,UPDATE ON TABLE dem.address_type TO "gm-doctors";
GRANT SELECT ON TABLE dem.address_type TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE dem.address_type TO "gm-staff";


--
-- Name: SEQUENCE address_type_id_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE dem.address_type_id_seq TO "gm-public";


--
-- Name: TABLE country; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT INSERT,DELETE,UPDATE ON TABLE dem.country TO "gm-doctors";
GRANT SELECT ON TABLE dem.country TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE dem.country TO "gm-staff";


--
-- Name: SEQUENCE country_id_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE dem.country_id_seq TO "gm-public";


--
-- Name: TABLE enum_comm_types; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.enum_comm_types TO "gm-doctors";
GRANT SELECT ON TABLE dem.enum_comm_types TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE dem.enum_comm_types TO "gm-staff";


--
-- Name: SEQUENCE enum_comm_types_id_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE dem.enum_comm_types_id_seq TO "gm-public";


--
-- Name: TABLE enum_ext_id_types; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.enum_ext_id_types TO "gm-doctors";
GRANT SELECT ON TABLE dem.enum_ext_id_types TO "gm-staff";


--
-- Name: SEQUENCE enum_ext_id_types_pk_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE dem.enum_ext_id_types_pk_seq TO "gm-doctors";


--
-- Name: TABLE gender_label; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.gender_label TO "gm-doctors";


--
-- Name: SEQUENCE gender_label_pk_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE dem.gender_label_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE identity_pk_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE dem.identity_pk_seq TO "gm-doctors";
GRANT USAGE ON SEQUENCE dem.identity_pk_seq TO "gm-staff";


--
-- Name: TABLE identity_tag; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.identity_tag TO "gm-doctors";


--
-- Name: SEQUENCE identity_tag_pk_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE dem.identity_tag_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE inbox_item_category_pk_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,USAGE ON SEQUENCE dem.inbox_item_category_pk_seq TO "gm-public";


--
-- Name: SEQUENCE inbox_item_type_pk_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE dem.inbox_item_type_pk_seq TO "gm-doctors";
GRANT SELECT,USAGE ON SEQUENCE dem.inbox_item_type_pk_seq TO "gm-public";


--
-- Name: TABLE lnk_identity2comm; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.lnk_identity2comm TO "gm-doctors";
GRANT SELECT ON TABLE dem.lnk_identity2comm TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE dem.lnk_identity2comm TO "gm-staff";


--
-- Name: SEQUENCE lnk_identity2comm_id_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE dem.lnk_identity2comm_id_seq TO "gm-doctors";
GRANT USAGE ON SEQUENCE dem.lnk_identity2comm_id_seq TO "gm-public";


--
-- Name: TABLE lnk_identity2ext_id; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.lnk_identity2ext_id TO "gm-doctors";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.lnk_identity2ext_id TO "gm-staff";


--
-- Name: SEQUENCE lnk_identity2ext_id_id_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE dem.lnk_identity2ext_id_id_seq TO "gm-doctors";
GRANT USAGE ON SEQUENCE dem.lnk_identity2ext_id_id_seq TO "gm-public";


--
-- Name: TABLE lnk_job2person; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.lnk_job2person TO "gm-doctors";


--
-- Name: SEQUENCE lnk_job2person_id_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE dem.lnk_job2person_id_seq TO "gm-doctors";


--
-- Name: TABLE lnk_org_unit2comm; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.lnk_org_unit2comm TO "gm-public";


--
-- Name: SEQUENCE lnk_org_unit2comm_pk_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE dem.lnk_org_unit2comm_pk_seq TO "gm-doctors";
GRANT USAGE ON SEQUENCE dem.lnk_org_unit2comm_pk_seq TO "gm-staff";


--
-- Name: TABLE lnk_org_unit2ext_id; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.lnk_org_unit2ext_id TO "gm-public";


--
-- Name: SEQUENCE lnk_org_unit2ext_id_pk_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE dem.lnk_org_unit2ext_id_pk_seq TO "gm-staff";


--
-- Name: TABLE lnk_person_org_address; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.lnk_person_org_address TO "gm-doctors";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.lnk_person_org_address TO "gm-staff";


--
-- Name: TABLE lnk_person2address; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.lnk_person2address TO "gm-doctors";


--
-- Name: TABLE lnk_person2relative; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.lnk_person2relative TO "gm-doctors";


--
-- Name: SEQUENCE lnk_person2relative_id_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE dem.lnk_person2relative_id_seq TO "gm-doctors";


--
-- Name: SEQUENCE lnk_person_org_address_id_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE dem.lnk_person_org_address_id_seq TO "gm-doctors";
GRANT USAGE ON SEQUENCE dem.lnk_person_org_address_id_seq TO "gm-staff";


--
-- Name: TABLE name_gender_map; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.name_gender_map TO "gm-public";


--
-- Name: SEQUENCE names_id_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE dem.names_id_seq TO "gm-doctors";
GRANT USAGE ON SEQUENCE dem.names_id_seq TO "gm-staff";


--
-- Name: TABLE occupation; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.occupation TO "gm-doctors";


--
-- Name: SEQUENCE occupation_id_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE dem.occupation_id_seq TO "gm-doctors";


--
-- Name: TABLE org_category; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.org_category TO "gm-doctors";


--
-- Name: SEQUENCE org_category_id_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE dem.org_category_id_seq TO "gm-doctors";


--
-- Name: SEQUENCE org_pk_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE dem.org_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE org_unit_pk_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE dem.org_unit_pk_seq TO "gm-doctors";


--
-- Name: TABLE praxis_branch; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.praxis_branch TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE dem.praxis_branch TO "gm-doctors";


--
-- Name: SEQUENCE praxis_branch_pk_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE dem.praxis_branch_pk_seq TO "gm-public";


--
-- Name: SEQUENCE provider_inbox_pk_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE dem.provider_inbox_pk_seq TO "gm-doctors";


--
-- Name: TABLE region; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT INSERT,DELETE,UPDATE ON TABLE dem.region TO "gm-doctors";
GRANT SELECT ON TABLE dem.region TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE dem.region TO "gm-staff";


--
-- Name: TABLE relation_types; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE dem.relation_types TO "gm-doctors";


--
-- Name: SEQUENCE state_id_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE dem.state_id_seq TO "gm-public";


--
-- Name: TABLE street; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT INSERT,DELETE,UPDATE ON TABLE dem.street TO "gm-doctors";
GRANT SELECT ON TABLE dem.street TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE dem.street TO "gm-staff";


--
-- Name: SEQUENCE street_id_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE dem.street_id_seq TO "gm-public";


--
-- Name: TABLE urb; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT INSERT,DELETE,UPDATE ON TABLE dem.urb TO "gm-doctors";
GRANT SELECT ON TABLE dem.urb TO "gm-public";
GRANT INSERT,DELETE,UPDATE ON TABLE dem.urb TO "gm-staff";


--
-- Name: SEQUENCE urb_id_seq; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE dem.urb_id_seq TO "gm-public";


--
-- Name: TABLE v_active_persons; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_active_persons TO "gm-public";


--
-- Name: TABLE v_address; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_address TO "gm-doctors";
GRANT SELECT ON TABLE dem.v_address TO "gm-public";


--
-- Name: TABLE v_basic_address; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_basic_address TO "gm-public";


--
-- Name: TABLE v_deleted_persons; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_deleted_persons TO "gm-doctors";


--
-- Name: TABLE v_external_ids4identity; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_external_ids4identity TO "gm-doctors";
GRANT SELECT ON TABLE dem.v_external_ids4identity TO "gm-staff";


--
-- Name: TABLE v_external_ids4org_unit; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_external_ids4org_unit TO "gm-staff";


--
-- Name: TABLE v_gender_labels; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_gender_labels TO "gm-doctors";
GRANT SELECT ON TABLE dem.v_gender_labels TO "gm-staff";


--
-- Name: TABLE tag_image; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE ref.tag_image TO "gm-doctors";
GRANT SELECT ON TABLE ref.tag_image TO "gm-staff";


--
-- Name: TABLE v_identity_tags; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_identity_tags TO "gm-doctors";
GRANT SELECT ON TABLE dem.v_identity_tags TO "gm-staff";


--
-- Name: TABLE v_message_inbox; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_message_inbox TO "gm-doctors";


--
-- Name: TABLE v_org_unit_comms; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_org_unit_comms TO "gm-doctors";
GRANT SELECT ON TABLE dem.v_org_unit_comms TO "gm-staff";


--
-- Name: TABLE v_org_units; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_org_units TO "gm-public";


--
-- Name: TABLE v_org_units_no_praxis_check; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_org_units_no_praxis_check TO "gm-public";


--
-- Name: TABLE v_orgs; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_orgs TO "gm-public";


--
-- Name: TABLE v_pat_addresses; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_pat_addresses TO "gm-doctors";


--
-- Name: TABLE v_person_comms; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_person_comms TO "gm-doctors";
GRANT SELECT ON TABLE dem.v_person_comms TO "gm-staff";


--
-- Name: TABLE v_person_jobs; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_person_jobs TO "gm-doctors";


--
-- Name: TABLE v_person_names; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_person_names TO "gm-public";


--
-- Name: TABLE v_persons; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_persons TO "gm-public";


--
-- Name: TABLE v_praxis_branches; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_praxis_branches TO "gm-public";


--
-- Name: TABLE v_region; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_region TO "gm-doctors";
GRANT SELECT ON TABLE dem.v_region TO "gm-public";


--
-- Name: TABLE v_staff; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_staff TO "gm-public";


--
-- Name: TABLE v_urb; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_urb TO "gm-doctors";
GRANT SELECT ON TABLE dem.v_urb TO "gm-public";


--
-- Name: TABLE v_street; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_street TO "gm-doctors";
GRANT SELECT ON TABLE dem.v_street TO "gm-public";


--
-- Name: TABLE v_zip2street; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_zip2street TO "gm-public";


--
-- Name: TABLE v_uniq_zipped_urbs; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_uniq_zipped_urbs TO "gm-doctors";
GRANT SELECT ON TABLE dem.v_uniq_zipped_urbs TO "gm-public";


--
-- Name: TABLE v_zip2data; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_zip2data TO "gm-public";


--
-- Name: TABLE v_zip2urb; Type: ACL; Schema: dem; Owner: gm-dbo
--

GRANT SELECT ON TABLE dem.v_zip2urb TO "gm-public";


--
-- Name: SEQUENCE access_log_pk_seq; Type: ACL; Schema: gm; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE gm.access_log_pk_seq TO "gm-public";


--
-- Name: TABLE schema_revision; Type: ACL; Schema: gm; Owner: gm-dbo
--

GRANT SELECT ON TABLE gm.schema_revision TO "gm-public";


--
-- Name: TABLE notifying_tables; Type: ACL; Schema: gm; Owner: gm-dbo
--

GRANT SELECT ON TABLE gm.notifying_tables TO "gm-doctors";
GRANT SELECT ON TABLE gm.notifying_tables TO "gm-staff";


--
-- Name: TABLE curr_lang; Type: ACL; Schema: i18n; Owner: gm-dbo
--

GRANT SELECT ON TABLE i18n.curr_lang TO "gm-public";


--
-- Name: TABLE keys; Type: ACL; Schema: i18n; Owner: gm-dbo
--

GRANT SELECT ON TABLE i18n.keys TO "gm-public";


--
-- Name: TABLE translations; Type: ACL; Schema: i18n; Owner: gm-dbo
--

GRANT SELECT ON TABLE i18n.translations TO "gm-public";


--
-- Name: TABLE v_missing_translations; Type: ACL; Schema: i18n; Owner: gm-dbo
--

GRANT SELECT ON TABLE i18n.v_missing_translations TO "gm-public";


--
-- Name: TABLE basic_unit; Type: ACL; Schema: public; Owner: gm-dbo
--

GRANT SELECT ON TABLE public.basic_unit TO "gm-public";


--
-- Name: TABLE form_job_queue; Type: ACL; Schema: public; Owner: gm-dbo
--

GRANT SELECT ON TABLE public.form_job_queue TO "gm-public";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE public.form_job_queue TO "gm-doctors";


--
-- Name: SEQUENCE form_job_queue_pk_seq; Type: ACL; Schema: public; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE public.form_job_queue_pk_seq TO "gm-doctors";


--
-- Name: TABLE form_job_targets; Type: ACL; Schema: public; Owner: gm-dbo
--

GRANT SELECT ON TABLE public.form_job_targets TO "gm-public";


--
-- Name: TABLE form_print_defs; Type: ACL; Schema: public; Owner: gm-dbo
--

GRANT SELECT ON TABLE public.form_print_defs TO "gm-public";


--
-- Name: TABLE gm_client_db_match; Type: ACL; Schema: public; Owner: gm-dbo
--

GRANT SELECT ON TABLE public.gm_client_db_match TO "gm-public";


--
-- Name: TABLE housekeeping_todo; Type: ACL; Schema: public; Owner: gm-dbo
--

GRANT SELECT,INSERT ON TABLE public.housekeeping_todo TO "gm-public";
GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE public.housekeeping_todo TO "gm-doctors";


--
-- Name: SEQUENCE housekeeping_todo_pk_seq; Type: ACL; Schema: public; Owner: gm-dbo
--

GRANT SELECT ON SEQUENCE public.housekeeping_todo_pk_seq TO "gm-public";
GRANT SELECT,UPDATE ON SEQUENCE public.housekeeping_todo_pk_seq TO "gm-doctors";


--
-- Name: TABLE test_norm; Type: ACL; Schema: public; Owner: gm-dbo
--

GRANT SELECT ON TABLE public.test_norm TO "gm-public";


--
-- Name: TABLE unit; Type: ACL; Schema: public; Owner: gm-dbo
--

GRANT SELECT ON TABLE public.unit TO "gm-public";


--
-- Name: TABLE atc; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.atc TO "gm-doctors";


--
-- Name: TABLE atc_staging; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE ref.atc_staging TO "gm-doctors";


--
-- Name: SEQUENCE billable_pk_seq; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE ref.billable_pk_seq TO "gm-public";


--
-- Name: TABLE coda; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.coda TO "gm-public";


--
-- Name: TABLE code_thesaurus_root; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE ref.code_thesaurus_root TO "gm-doctors";


--
-- Name: SEQUENCE coding_system_root_pk_coding_system_seq; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE ref.coding_system_root_pk_coding_system_seq TO "gm-doctors";


--
-- Name: SEQUENCE data_source_pk_seq; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE ref.data_source_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE dose_pk_seq; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE ref.dose_pk_seq TO "gm-public";


--
-- Name: TABLE form_types; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE ref.form_types TO "gm-doctors";


--
-- Name: SEQUENCE form_types_pk_seq; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE ref.form_types_pk_seq TO "gm-doctors";


--
-- Name: TABLE icd10; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.icd10 TO "gm-public";


--
-- Name: TABLE icd9; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.icd9 TO "gm-public";


--
-- Name: TABLE icpc; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE ref.icpc TO "gm-doctors";


--
-- Name: TABLE icpc_chapter; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.icpc_chapter TO "gm-doctors";


--
-- Name: TABLE icpc_component; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.icpc_component TO "gm-doctors";


--
-- Name: TABLE icpc_thesaurus; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE ref.icpc_thesaurus TO "gm-doctors";


--
-- Name: TABLE keyword_expansion; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE ref.keyword_expansion TO "gm-doctors";


--
-- Name: SEQUENCE keyword_expansion_pk_seq; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE ref.keyword_expansion_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE lnk_dose2drug_pk_seq; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE ref.lnk_dose2drug_pk_seq TO "gm-public";


--
-- Name: SEQUENCE lnk_loinc2substance_pk_seq; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE ref.lnk_loinc2substance_pk_seq TO "gm-doctors";


--
-- Name: TABLE loinc; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE ref.loinc TO "gm-doctors";


--
-- Name: SEQUENCE loinc_pk_seq; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE ref.loinc_pk_seq TO "gm-doctors";


--
-- Name: TABLE ops; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.ops TO "gm-public";


--
-- Name: TABLE other_code; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.other_code TO "gm-public";


--
-- Name: TABLE papersizes; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.papersizes TO "gm-public";


--
-- Name: TABLE paperwork_templates; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE ref.paperwork_templates TO "gm-doctors";


--
-- Name: SEQUENCE paperwork_templates_pk_seq; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE ref.paperwork_templates_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE substance_brand_pk_seq; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE ref.substance_brand_pk_seq TO "gm-doctors";


--
-- Name: SEQUENCE substance_pk_seq; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT USAGE ON SEQUENCE ref.substance_pk_seq TO "gm-public";


--
-- Name: SEQUENCE tag_image_pk_seq; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE ref.tag_image_pk_seq TO "gm-doctors";


--
-- Name: TABLE v_atc; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_atc TO "gm-public";


--
-- Name: TABLE v_billables; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_billables TO "gm-public";


--
-- Name: TABLE v_coded_terms; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_coded_terms TO "gm-public";


--
-- Name: TABLE v_substances; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_substances TO "gm-public";


--
-- Name: TABLE v_substance_doses; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_substance_doses TO "gm-public";


--
-- Name: TABLE v_drug_components; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_drug_components TO "gm-public";


--
-- Name: TABLE v_drug_products; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_drug_products TO "gm-doctors";


--
-- Name: TABLE v_generic_codes; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_generic_codes TO "gm-public";


--
-- Name: TABLE v_icpc; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_icpc TO "gm-doctors";


--
-- Name: TABLE v_icpc_thesaurus; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_icpc_thesaurus TO "gm-doctors";


--
-- Name: TABLE vacc_route; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.vacc_route TO "gm-public";


--
-- Name: TABLE v_indications4vaccine; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_indications4vaccine TO "gm-public";


--
-- Name: TABLE v_keyword_expansions; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_keyword_expansions TO "gm-doctors";


--
-- Name: TABLE v_lnk_loincs2substances; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_lnk_loincs2substances TO "gm-public";


--
-- Name: TABLE v_paperwork_templates; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_paperwork_templates TO "gm-doctors";


--
-- Name: TABLE v_tag_images_no_data; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_tag_images_no_data TO "gm-doctors";
GRANT SELECT ON TABLE ref.v_tag_images_no_data TO "gm-public";


--
-- Name: TABLE v_vaccines; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_vaccines TO "gm-public";


--
-- Name: TABLE v_your_keyword_expansions; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT ON TABLE ref.v_your_keyword_expansions TO "gm-doctors";


--
-- Name: SEQUENCE vaccine_pk_seq; Type: ACL; Schema: ref; Owner: gm-dbo
--

GRANT SELECT,UPDATE ON SEQUENCE ref.vaccine_pk_seq TO "gm-doctors";


--
-- Name: TABLE lab_request; Type: ACL; Schema: staging; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE staging.lab_request TO "gm-doctors";


--
-- Name: TABLE test_result; Type: ACL; Schema: staging; Owner: gm-dbo
--

GRANT SELECT,INSERT,DELETE,UPDATE ON TABLE staging.test_result TO "gm-doctors";


--
-- PostgreSQL database dump complete
--

